package com.jetbrains.rdserver.terminal

import com.intellij.openapi.project.Project
import com.jediterm.terminal.TtyConnector
import com.pty4j.PtyProcess
import org.jetbrains.plugins.terminal.AbstractTerminalRunner
import org.jetbrains.plugins.terminal.DefaultTerminalRunnerFactory
import org.jetbrains.plugins.terminal.LocalTerminalDirectRunner

class BackendTerminalRunnerFactory : DefaultTerminalRunnerFactory() {
  override fun create(project: Project): AbstractTerminalRunner<*> {
    return object : LocalTerminalDirectRunner(project) {
      override fun createTtyConnector(process: PtyProcess): TtyConnector {
        return BackendTtyConnector(project, super.createTtyConnector(process))
      }
    }
  }
}

