package com.jetbrains.cwm.unattended.common

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.ui.Messages
import com.intellij.openapi.project.DumbAware
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.util.reactive.adviseNotNull

class ConnectToRemoteControlSocketInternalAction : AnAction("Connect to remote control socket (internal)"), DumbAware {
  override fun actionPerformed(e: AnActionEvent) {
    val port = Messages.showInputDialog(e.project, "Enter control socket port", "Connect to remote control socket (internal)", null)

    if (port.isNullOrEmpty()) return;

    val connection = UnattendedHostControlConnection(null, port.toInt())
    connection.controlModel.view(Lifetime.Eternal) { modelLt, model ->
      model.session.adviseNotNull(modelLt) {
        UnattendedHostProjectListDialog(modelLt, it).show()
      }
    }
  }
}