package com.jetbrains.cwm.unattended.ssh

import com.intellij.ssh.RemoteFileObject
import java.io.InputStream
import java.io.OutputStream

class RemoteFileObjectFacade(private val delegate: RemoteFileObject) {
  fun exists(): Boolean =
    delegate.exists()

  fun list(): List<RemoteFileObjectFacade> =
    delegate.list().map { RemoteFileObjectFacade(it) }

  fun isDir(): Boolean =
    delegate.isDir()

  fun isSymbolicLink(): Boolean =
    delegate.isSymbolicLink()

  fun mkdir() =
    delegate.mkdir()

  fun rm(): Boolean =
    delegate.rm()

  fun child(name: String): RemoteFileObjectFacade =
    RemoteFileObjectFacade(delegate.child(name))

  fun inputStream(): InputStream =
    delegate.inputStream()

  fun size(): Long =
    delegate.size()

  fun path(): String =
    delegate.path()

  fun name(): String =
    delegate.name()

  val permissions: Int
    get() = delegate.permissions

  fun setPermissions(value: Int) =
    delegate.setPermissions(value)

  val UId: Int
    get() = delegate.UId

  fun outputStream(append: Boolean): OutputStream =
    delegate.outputStream(append)

  fun getGroupId(): Int =
    delegate.getGroupId()

  fun moveTo(newAbsolutePath: String) =
    delegate.moveTo(newAbsolutePath)

  fun getLastModifiedTime(): Long =
    delegate.getLastModifiedTime()

  fun setLastModifiedTime(value: Long) =
    delegate.setLastModifiedTime(value)

  fun canonicalPath(): String =
    delegate.canonicalPath()

  fun clearCachedData() =
    delegate.clearCachedData()
}