package com.jetbrains.cwm.unattended.ssh

import com.intellij.ssh.channels.SftpChannel
import java.io.File
import java.util.function.Predicate

class SftpChannelFacade(internal override val delegate: SftpChannel) : SshChannelFacade(delegate) {
  fun file(path: String): RemoteFileObjectFacade {
    return RemoteFileObjectFacade(delegate.file(path))
  }

  fun uploadFileOrDir(file: File,
                      remoteDir: String,
                      relativePath: String,
                      progressTracker: SftpProgressTrackerFacade?,
                      filesFilter: Predicate<File>?) = delegate.uploadFileOrDir(
    file,
    remoteDir,
    relativePath,
    progressTracker?.delegate,
    filesFilter
  )

  fun uploadFileOrDir(file: File, remoteDir: String, relativePath: String) = delegate.uploadFileOrDir(
    file,
    remoteDir,
    relativePath,
    null,
    null
  )


  fun downloadFileOrDir(remotePath: String, localPath: String) = delegate.downloadFileOrDir(remotePath, localPath)

  val home get() = delegate.home
}