package com.jetbrains.cwm.unattended.ssh

import com.intellij.ssh.SshSession

class SshSessionFacade(internal val delegate: SshSession) {
  val userName: String
    get() = delegate.userName

  val host: String
    get() = delegate.host

  val port: Int
    get() = delegate.port

  val isConnected: Boolean
    get() = delegate.isConnected

  fun addRemoteTunnel(remotePort: Int, host: String, localPort: Int) =
    delegate.addRemoteTunnel(remotePort, host, localPort)

  fun addRemoteTunnelWithRandomRemotePort(host: String, localPort: Int): Int =
    delegate.addRemoteTunnelWithRandomRemotePort(host, localPort)

  fun addLocalTunnel(localPort: Int, host: String, remotePort: Int) =
    delegate.addLocalTunnel(localPort, host, remotePort)

  fun addLocalTunnelWithRandomLocalPort(host: String, remotePort: Int): Int =
    delegate.addLocalTunnelWithRandomLocalPort(host, remotePort)

  fun getPortForwardingList(): List<String> =
    delegate.getPortForwardingList()

  fun removeLocalTunnel(port: Int) =
    delegate.removeLocalTunnel(port)

  fun removeRemoteTunnel(port: Int) =
    delegate.removeRemoteTunnel(port)

  fun disconnect() =
    delegate.disconnect()

  fun applyPortForwardings() =
    delegate.applyPortForwardings()
}