package com.jetbrains.cwm.unattended.common

import org.bouncycastle.crypto.generators.SCrypt
import java.security.SecureRandom

object UnattendedHostPasswordUtil {
  private val random = SecureRandom()

  fun hashPassword(password: ByteArray, salt: ByteArray): ByteArray {
    return SCrypt.generate(password, salt, 32768, 16, 1, 256)
  }

  fun hashPassword(password: String, salt: ByteArray): ByteArray {
    return hashPassword(password.toByteArray(Charsets.UTF_8), salt)
  }

  fun hashPasswordCreateSalt(password: ByteArray): Pair<ByteArray, ByteArray> {
    val salt = ByteArray(16)
    random.nextBytes(salt)
    return hashPassword(password, salt) to salt
  }

  fun hashPasswordCreateSalt(password: String): Pair<ByteArray, ByteArray> {
    return hashPasswordCreateSalt(password.toByteArray(Charsets.UTF_8))
  }
}