package com.jetbrains.cwm.unattended.common

import com.intellij.openapi.ui.DialogWrapper
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.codeWithMe.model.RemoteControlSession
import javax.swing.JComponent

class UnattendedHostProjectListDialog(outerLifetime: Lifetime, val session: RemoteControlSession) : DialogWrapper(false) {
  private val myLifetimeDef = outerLifetime.createNested()

  init {
    isModal = false
    title = "Select remote project to connect to"
    init()
  }

  override fun shouldCloseOnCross(): Boolean {
    return true
  }

  override fun dispose() {
    super.dispose()
    myLifetimeDef.terminate()
  }

  override fun createCenterPanel(): JComponent {
    return UnattendedHostProjectListPanel(myLifetimeDef, session)
  }
}