package com.jetbrains.rdserver.actions

import com.intellij.codeWithMe.ClientId
import com.intellij.execution.Executor
import com.intellij.execution.actions.RunContextAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.actionSystem.EmptyAction
import com.jetbrains.rdserver.permissions.PermissionManager
import com.jetbrains.rdserver.permissions.RunAccessLevel

abstract class AbstractRunDebugAction(executor : Executor)  : EmptyAction.MyDelegatingAction(RunContextAction(executor)) {
  override fun actionPerformed(e: AnActionEvent) {
    if (ClientId.isCurrentlyUnderLocalId) {
      super.actionPerformed(e)
      return
    }

    val project = e.project ?: return
    val currentRunAccess = PermissionManager.getInstance(project).getRunAccess(ClientId.current)
    if (currentRunAccess != RunAccessLevel.FullAccess)
      return

    super.actionPerformed(e)
  }
}