package com.jetbrains.rdserver.actions

import com.intellij.codeWithMe.ClientId
import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.IdeActions
import com.intellij.openapi.project.Project
import com.jetbrains.rd.ui.bindable.ActionFilterProvider
import com.jetbrains.rd.ui.bindable.ActionFilterResult
import com.jetbrains.rdserver.permissions.PermissionManager

class AccessActionFilterProvider : ActionFilterProvider {
  companion object {
    private val MODIFYING_ACTION_IDS = setOf(
      IdeActions.ACTION_RENAME,
      IdeActions.GROUP_GENERATE,
      "IntroduceVariable",
      "Generate",
      "Inline"
    )
  }

  override fun filterAction(action: AnAction, actionId: String, project: Project, id: ClientId): ActionFilterResult {
    if (actionId in MODIFYING_ACTION_IDS && !PermissionManager.getInstance(project).hasFileWriteAccess(id)) {
      return ActionFilterResult.FORBIDDEN
    } else {
      return ActionFilterResult.OK
    }
  }
}