package com.jetbrains.rdserver.actions

import com.intellij.openapi.actionSystem.ActionManager
import com.jetbrains.rdserver.CodeWithMePluginBundle
import com.jetbrains.rd.ide.model.*

class ActionExecutionResultHandler(private val requestId: Int) : TimestampUpgradeResultHandler {
  lateinit var response: RdResponse

  override fun handleFailure(actionId: String, failure: TimestampUpgradeResult.Failure) {
    val actionManager = ActionManager.getInstance()
    val description = actionManager.getAction(actionId)?.templatePresentation?.text ?: actionId
    val message = CodeWithMePluginBundle.message("message.failed.to", description, failure.message)
    response = RdFailureResponse(message, requestId)
  }

  override fun handleRetryRequest(actionId: String, request: TimestampUpgradeResult.RetryRequest) {
    val actionManager = ActionManager.getInstance()
    val action = actionManager.getAction(actionId)?.templatePresentation?.text ?: actionId
    val message = CodeWithMePluginBundle.message("message.failed.to", action, request.message)
    response = RdRetryResponse(message, requestId)
  }
}