package com.jetbrains.rdserver.actions

import com.intellij.openapi.project.Project
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.util.lifetime.SequentialLifetimes
import com.jetbrains.rdserver.RdServerPerClientComponents

@Suppress("NonDefaultConstructor")
class BackendActionGroupLifetimeHost(lifetime: Lifetime) {
  private val sequentialLifetimes = SequentialLifetimes(lifetime)

  val nextGroupLifetime: Lifetime
    get() = sequentialLifetimes.next()

  companion object {
    fun getInstance(project: Project) = RdServerPerClientComponents.getService(project, BackendActionGroupLifetimeHost::class.java)
  }
}
