package com.jetbrains.rdserver.actions

import com.intellij.openapi.extensions.ProjectExtensionPointName
import com.intellij.openapi.project.Project

/**
 * Checks timestamps that doesn't have corresponding data key
 */
abstract class BackendActionTimestampValidator(val project: Project) {
  companion object {
    val EP = ProjectExtensionPointName<BackendActionTimestampValidator>("com.intellij.rdserver.actionTimestampValidator")
  }

  abstract fun validate(actionId: String, requestSet: ActionTimestampSet, actualSet: ActionTimestampSet): TimestampUpgradeResult?
}


