package com.jetbrains.rdserver.actions

import com.intellij.openapi.actionSystem.ActionManager
import com.intellij.openapi.project.Project
import com.intellij.xdebugger.impl.actions.XDebuggerActionBase
import com.jetbrains.rdserver.actions.timestamps.DebuggerExecutionLineTimestamp

class BackendExecutionLineTimestampValidator(project: Project) : BackendActionTimestampValidator(project) {
  override fun validate(actionId: String, requestSet: ActionTimestampSet, actualSet: ActionTimestampSet): TimestampUpgradeResult? {
    if (ActionManager.getInstance().getAction(actionId) is XDebuggerActionBase) {
      return requestSet.getTimestamp(DebuggerExecutionLineTimestamp.NAME)?.upgrade(actualSet)
    }
    return null
  }
}