package com.jetbrains.rdserver.actions

import com.jetbrains.rdserver.ui.feelLuckUi.ModalDialogSilentOption

class ModalUIShowPolicy {
  companion object {
    private val dialogTitlesWithSkippedUISilentAccept = setOf("")
    private val dialogTitlesWithSkippedUISilentCancel = setOf("Add File to Git")
    private val dialogTitlesWithDefaultMessageBoxValues = setOf(
        "No Test Roots Found"
    )
    fun maySkipModalDialog(title:String): ModalDialogSilentOption {
      if( dialogTitlesWithSkippedUISilentAccept.contains(title))
        return ModalDialogSilentOption.Accept
      if( dialogTitlesWithSkippedUISilentCancel.contains(title))
        return ModalDialogSilentOption.Cancel
      return ModalDialogSilentOption.SilentForbidden
    }

    fun mayUseDefaultValueInMessageBox(title: String?): Boolean {
      return dialogTitlesWithDefaultMessageBoxValues.contains(title)
    }
  }
}