package com.jetbrains.rdserver.actions

import com.intellij.openapi.actionSystem.CommonDataKeys
import com.intellij.openapi.actionSystem.DataContext
import com.intellij.openapi.actionSystem.impl.SimpleDataContext
import com.intellij.openapi.editor.Editor
import com.intellij.openapi.fileEditor.impl.text.TextEditorPsiDataProvider
import com.intellij.openapi.project.Project
import com.intellij.openapi.project.processOpenedProjects
import com.intellij.refactoring.rename.PsiElementRenameHandler
import com.jetbrains.rdserver.editors.BackendEditorHost
import com.jetbrains.rd.ide.model.DefaultNameDataConstant
import com.jetbrains.rd.ide.model.RdDataConstant
import com.jetbrains.rd.ide.model.TextControlConstant

@Deprecated("Use ActionTimestampSet and new async actions")
fun convertDataContext(dataContext: List<RdDataConstant>): DataContext {
  val textControlId = dataContext.filterIsInstance<TextControlConstant>().firstOrNull()?.id
  if (textControlId != null) {
    processOpenedProjects { project ->
      val editor = BackendEditorHost.getInstance(project).tryGetOwnRemoteEditor(textControlId)
      if (editor != null) {
        return dataContextForEditor(project, editor, dataContext)
      }
    }
  }
  return SimpleDataContext.EMPTY_CONTEXT
}

@Deprecated("Use ActionTimestampSet and new async actions")
fun dataContextForEditor(project: Project,
                         editor: Editor,
                         dataContext: List<RdDataConstant> = emptyList()): DataContext {
  val textEditorDataProvider = TextEditorPsiDataProvider()
  val textEditorDataContext = DataContext { dataId -> textEditorDataProvider.getData(dataId, editor, editor.caretModel.currentCaret) }

  val map = mutableMapOf<String, Any>()
  map[CommonDataKeys.PROJECT.name] = project
  map[CommonDataKeys.EDITOR.name] = editor
  for (dataConstant in dataContext) {
    if (dataConstant is DefaultNameDataConstant) {
      map[PsiElementRenameHandler.DEFAULT_NAME.name] = dataConstant.name
    }
  }

  return SimpleDataContext.getSimpleContext(map, textEditorDataContext)
}
