package com.jetbrains.rdserver.codeInsight

import com.intellij.codeInsight.CodeInsightSettings
import com.intellij.codeInsight.CodeInsightSettings.*
import com.intellij.codeWithMe.ClientId
import com.jetbrains.rd.ide.model.MatchCase
import com.jetbrains.rd.util.reactive.valueOrDefault
import com.jetbrains.rdserver.BackendSettingsSynchronizer
import com.jetbrains.rdserver.RdServerPerClientComponents

class BackendCodeInsightSettings : CodeInsightSettings() {

  override fun getCompletionCaseSensitive(): Int {
    if (ClientId.isCurrentlyUnderLocalId)
      return super.getCompletionCaseSensitive()

    return RdServerPerClientComponents.getServiceInRandomProject(BackendSettingsSynchronizer::class.java)
      .settingsModel.matchCase.valueOrDefault(MatchCase.NONE).toBackendValue()
  }

  override fun setCompletionCaseSensitive(value: Int) {
    if (ClientId.isCurrentlyUnderLocalId)
      super.setCompletionCaseSensitive(value)
    else
      throw UnsupportedOperationException("setting smth from ClientId context")
  }
}

private fun MatchCase.toBackendValue(): Int {
  return when (this) {
    MatchCase.NONE -> NONE
    MatchCase.ALL -> ALL
    MatchCase.FIRST_LETTER -> FIRST_LETTER
  }
}
