package com.jetbrains.rdserver.codeInsight

import com.intellij.codeWithMe.ClientId
import com.intellij.openapi.editor.ex.EditorSettingsExternalizable
import com.jetbrains.rd.util.reactive.valueOrDefault
import com.jetbrains.rdserver.BackendSettingsSynchronizer
import com.jetbrains.rdserver.RdServerPerClientComponents

class BackendEditorSettingsExternalizable : EditorSettingsExternalizable() {
  override fun isCamelWords(): Boolean {
    if (ClientId.isCurrentlyUnderLocalId)
      return super.isCamelWords()

    return RdServerPerClientComponents.getServiceInRandomProject(BackendSettingsSynchronizer::class.java)
      .settingsModel.useCamelHumps.valueOrDefault(false)
  }

  override fun isMouseClickSelectionHonorsCamelWords(): Boolean {
    if (ClientId.isCurrentlyUnderLocalId)
      return super.isMouseClickSelectionHonorsCamelWords()

    return RdServerPerClientComponents.getServiceInRandomProject(BackendSettingsSynchronizer::class.java)
      .settingsModel.isMouseClickSelectionHonorsCamelWords.valueOrDefault(false)
  }

  override fun isIndentGuidesShown(): Boolean {
    if (ClientId.isCurrentlyUnderLocalId)
      return super.isIndentGuidesShown()

    return RdServerPerClientComponents.getServiceInRandomProject(BackendSettingsSynchronizer::class.java)
      .settingsModel.isIndentGuidesShown.valueOrDefault(false)
  }

  override fun getCustomSoftWrapIndent(): Int {
    if (ClientId.isCurrentlyUnderLocalId)
      return super.getCustomSoftWrapIndent()

    return RdServerPerClientComponents.getServiceInRandomProject(BackendSettingsSynchronizer::class.java)
      .settingsModel.customSoftWrapIndent.valueOrDefault(10)
  }
}