package com.jetbrains.rdserver.codeInsight.hint

import com.intellij.codeInsight.hint.ParameterInfoControllerBase
import com.intellij.codeInsight.hint.ParameterInfoControllerProvider
import com.intellij.lang.parameterInfo.ParameterInfoHandler
import com.intellij.openapi.editor.Editor
import com.intellij.openapi.project.Project
import com.intellij.psi.PsiElement
import com.jetbrains.rdserver.editors.isLocal

class BackendParameterInfoControllerProvider : ParameterInfoControllerProvider() {

  override fun doCreate(project: Project,
                      editor: Editor,
                      lbraceOffset: Int,
                      descriptors: Array<Any?>?,
                      highlighted: Any?,
                      parameterOwner: PsiElement?,
                      handler: ParameterInfoHandler<out PsiElement?, *>,
                      showHint: Boolean,
                      requestFocus: Boolean): ParameterInfoControllerBase? {
    if (!editor.isLocal()) {
      return BackendParameterInfoController(project, editor, lbraceOffset, descriptors, highlighted,
                                            parameterOwner, handler, showHint, requestFocus)
    }
    return null
  }

}