package com.intellij.ide.license;

import org.jetbrains.annotations.Nls;

public class AuthorizationRequiredException  extends LicenseCreationException{
  private final String myAuthUrl;

  public AuthorizationRequiredException(String serverMessage, String authUrl) {
    super(createAuthorizationPromptMessage(serverMessage, authUrl));
    myAuthUrl = authUrl;
  }

  @Nls
  public static String createAuthorizationPromptMessage(String serverMessage, String authUrl) {
    return LicenseBundle.message("message.fls.authorization.required", serverMessage != null? serverMessage + ". " : "", authUrl);
  }

  public String getAuthUrl() {
    return myAuthUrl;
  }
}
