package com.intellij.ide.license;

import com.intellij.openapi.util.NlsContexts;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class LicenseCreationException extends Exception {
  private final @NlsContexts.DetailedDescription String myDetails;

  public LicenseCreationException(@NlsContexts.DetailedDescription @NotNull String userMessage) {
    this(userMessage, null);
  }

  public LicenseCreationException(@NlsContexts.DetailedDescription @NotNull String userMessage, @Nullable @NlsContexts.DetailedDescription String details) {
    super(userMessage);
    myDetails = details;
  }

  @Nullable
  public @NlsContexts.DetailedDescription String getDetails() {//Technical details e.g. java.lang.Exception#getMessage()
    return myDetails;
  }

  @Override
  public synchronized Throwable fillInStackTrace() {
    return this;
  }
}
