package com.intellij.ide.license;

import com.intellij.ide.license.impl.EvaluationLicenseData;
import com.intellij.ide.license.impl.LicenseStore;
import com.intellij.ide.license.impl.ServerLicenseData;
import com.intellij.licensecommon.license.LicenseData;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;


public interface LicenseFactory {

  LicenseData createFromUser(String key, String userName);

  @Nullable
  EvaluationLicenseData findExistingEvaluationLicense();

  @NotNull
  EvaluationLicenseData createEvaluationLicense();

  boolean storeEvaluationLicense(EvaluationLicenseData license);

  ServerLicenseData createServerLicense(
    String ticketId, long prolongationPeriod, String serverUrl, String licensee, int licenseType, String confirmationStamp, String metadata
  );

  LicenseValidator getLicenseValidator();

  LicenseStore getLicenseStore();

  int getCurrentMajorVersion();

  @NotNull
  ProductDescriptor getProductDescriptor();

  /**
   * To be incremented whenever we want to renew ability to evaluate to those
   * who already evaluated previous versions (but haven't deleted config folder)
   * Note that EAP builds use build number as selector automatically.
   */
  String getCurrentEvaluationSelector();

  boolean isForceReleaseEvaluationSelector();    //should be false  for real eap builds.
}
