package com.intellij.ide.license;

import com.intellij.ide.license.impl.TargetSaveException;
import com.intellij.ide.license.ui.LicenseUrls;
import com.intellij.licensecommon.license.LicenseData;

import java.util.List;

public interface LicenseMessages {

  boolean askEnterKeyBecauseLicenseExpired(ProductDescriptor pd, boolean isPlugin, boolean isEvaluation);

  void showLicenseInvalidMessage(ProductDescriptor pd);

  void showSaveLicenseWarning(ProductDescriptor pd, TargetSaveException exception);

  boolean showWillExpireWarning(ProductDescriptor pd, final boolean isPlugin, long daysBeforeExpiration, final boolean evaluation);

  List<String> getUsageRestrictionsMessages(ProductDescriptor pd, LicenseData license);

  boolean showLicenseExpired(ProductDescriptor pd, boolean isPlugin);

  void showLicenseExpiredBeforeShutdownNotification(ProductDescriptor pd, boolean isPlugin, boolean isEval);

  String getPurchaseUrl(ProductDescriptor pd, boolean isPlugin);

  LicenseUrls getLicenseUrls();
}
