package com.intellij.ide.license;

import com.intellij.ide.license.impl.ValidationFailedException;
import com.intellij.licensecommon.license.LicenseData;
import org.jetbrains.annotations.Nullable;


public interface LicenseSource<T> {

  /**
   * @param userInput
   */
  void create(T userInput) throws LicenseCreationException;

  void validate() throws ValidationFailedException;

  void restore();

  void clear();

  @Nullable
  LicenseData getLicense();

  boolean needNetworkLicenseCheck();

  void scheduleRemoteValidation();
}
