package com.intellij.ide.license.common;

import com.intellij.ide.license.ProductDescriptor;
import com.intellij.ide.license.impl.LicenseFile;
import com.intellij.licensecommon.license.LicenseData;
import com.intellij.openapi.application.PathManager;
import org.jetbrains.annotations.Nullable;

import java.io.File;
import java.util.Date;

class PluginLicenseFile extends LicenseFile {

  private final Date myPluginReleaseDate;

  PluginLicenseFile(ProductDescriptor productDescriptor, Date pluginReleaseDate) {
    super(productDescriptor, PathManager.getConfigPath() + File.separator + "plugin_" + productDescriptor.getProductCode() + ".license");
    myPluginReleaseDate = pluginReleaseDate;
  }

  @Override
  @Nullable
  protected LicenseData parseKeyLicenseData(String text) {
    if (text.startsWith(JET_PROFILE_DATA_MARKER)) {
      return readJBALicense(text.substring(JET_PROFILE_DATA_MARKER.length()), myPluginReleaseDate);
    }
    if (text.startsWith(CERT_KEY_SIGNATURE)) {
      return readCertKeyLicense(text.substring(CERT_KEY_SIGNATURE.length()),myPluginReleaseDate);
    }
    return super.parseKeyLicenseData(text);
  }
}