package com.intellij.ide.license.common;

import com.intellij.ide.license.ProductDescriptor;
import com.intellij.ide.license.impl.LicenseFile;

import java.io.File;

public class StandardLicenseFile extends LicenseFile {

  public StandardLicenseFile(final ProductDescriptor productDescriptor, String writePath, String... readPaths) {
    super(productDescriptor, findFirstExistingFile(readPaths), writePath);
  }

  private static String findFirstExistingFile(String[] paths) {
    for(String path: paths) {
      if (new File(path).exists()) {
        return path;
      }
    }
    return paths[paths.length-1];
  }
}
