package com.intellij.ide.license.common;

import com.intellij.ide.license.ui.LicenseUrls;
import com.intellij.openapi.application.impl.ApplicationInfoImpl;
import org.jetbrains.annotations.NonNls;

import java.text.MessageFormat;

public class StandardLicenseUrls extends LicenseUrls {
  private static final MessageFormat FMT_PURCHASE_URL = new MessageFormat("https://www.jetbrains.com/{0}/buy/?fromIDE");
  private static final MessageFormat PLUGIN_FMT_PURCHASE_URL = new MessageFormat("{0}/purchase-link/{1}/?fromIDE");

  private final String purchaseURL;
  public StandardLicenseUrls(@NonNls String shortName) {
    purchaseURL = FMT_PURCHASE_URL.format(new Object[]{shortName});
  }

  @Override
  public String getPurchaseUrl() {
    return purchaseURL;
  }

  @Override
  public String getPluginPurchaseUrl(String productCode) {
    return PLUGIN_FMT_PURCHASE_URL.format(new Object[]{ApplicationInfoImpl.getShadowInstance().getPluginManagerUrl(), productCode});
  }
}

