package com.intellij.ide.license.idea;

import com.intellij.ide.license.LicenseFactory;
import com.intellij.ide.license.common.StandardEAPLicenseManager;
import com.intellij.ide.license.common.StandardLicenseUrls;
import com.intellij.ide.license.ui.LicenseMessagesImpl;
import com.intellij.openapi.application.impl.ApplicationInfoImpl;

/**
 * @author yole
 */
public class IdeaEAPLicenseManager extends StandardEAPLicenseManager {
  public IdeaEAPLicenseManager() {
    super(
      "IntelliJ IDEA",
      30,
      "http://eap.jetbrains.com/idea" + ApplicationInfoImpl.getShadowInstance().getMajorVersion(),
      new LicenseMessagesImpl(new StandardLicenseUrls("idea"))
    );
  }

  @Override
  public LicenseFactory createLicenseFactory() {
    return new IdeaLicenseFactory(this);
  }
}
