package com.intellij.ide.license.idea;

import com.intellij.ide.license.LicenseFactory;
import com.intellij.ide.license.LicenseMessages;
import com.intellij.ide.license.common.StandardLicenseUrls;
import com.intellij.ide.license.impl.GeneralLicenseManager;
import com.intellij.ide.license.ui.LicenseMessagesImpl;

/**
 * @author yole
 */
public class IdeaLicenseManager extends GeneralLicenseManager {
  private final LicenseMessagesImpl ourLicenseMessages = new LicenseMessagesImpl(new StandardLicenseUrls("idea"));

  public IdeaLicenseManager() {super();}

  @Override
  public LicenseFactory createLicenseFactory() {
    return new IdeaLicenseFactory(this);
  }

  @Override
  public LicenseMessages getMessages() {
    return ourLicenseMessages;
  }
}
