package com.intellij.ide.license.impl;


public class AuthRequiredException extends ValidationFailedException{
  private final String myAuthUrl;
  private final String myClientId;
  private final String myCodeExchangeUrl;

  public AuthRequiredException(String message, String authUrl, String clientId, String codeExchangeUrl) {
    super(message);
    myAuthUrl = authUrl;
    myClientId = clientId;
    myCodeExchangeUrl = codeExchangeUrl;
  }

  public String getAuthUrl() {
    return myAuthUrl;
  }

  public String getCodeExchangeUrl() {
    return myCodeExchangeUrl;
  }

  public String getClientId() {
    return myClientId;
  }
}
