package com.intellij.ide.license.impl;

import java.util.Date;

/**
 * @author Eugene Zhuravlev
 */
public interface CertKeyLicense {
  CertKey2 getCertKey();

  /**
   * @return self product code: the product code of the IDE where this code runs, not the product code encoded in the key.
   */
  String getProductCode();

  Date  getProductBuildDate();
  
  default String getLicensedTo() {
    final CertKey2 certKey = getCertKey();
    final Object licensee = certKey.eval(new GetLicenseeName());
    final Object assignee = certKey.eval(new GetAssigneeName());
    return assignee != null && !((String)assignee).isEmpty() ? licensee + " / " + assignee : (String)licensee;
  }
}
