package com.intellij.ide.license.impl;

import com.intellij.openapi.util.NlsSafe;
import org.jetbrains.annotations.NotNull;

import java.util.Date;

public class GetApplicableWarningMessage {
  @NotNull
  private final String myProductCode;
  @NotNull
  private final Date myProductBuildDate;
  @NotNull
  private final String myProductName;

  public GetApplicableWarningMessage(@NotNull String productCode, @NotNull Date productBuildDate, @NotNull String productName) {
    myProductCode = productCode;
    myProductBuildDate = productBuildDate;
    myProductName = productName;
  }

  @NotNull
  public Date getProductBuildDate() {
    return myProductBuildDate;
  }

  @NotNull
  public String getProductCode() {
    return myProductCode;
  }

  @NotNull
  public @NlsSafe String getProductName() {
    return myProductName;
  }
}
