package com.intellij.ide.license.impl;

import com.intellij.licensecommon.log.Logger;
import com.intellij.licensecommon.log.LoggerFactory;

/**
 */
public class IdeaLoggerFactory implements LoggerFactory {
  @Override
  public Logger getInstance(String name) {
    return new MyLogger(com.intellij.openapi.diagnostic.Logger.getInstance(name));
  }

  private static class MyLogger implements Logger {
    private final com.intellij.openapi.diagnostic.Logger myLogger;

    MyLogger(com.intellij.openapi.diagnostic.Logger logger) {
      myLogger = logger;
    }

    @Override
    public void info(String message) {
      myLogger.info(message);
    }

    @Override
    public boolean isDebugEnabled() {
      return myLogger.isDebugEnabled();
    }

    @Override
    public void debug(Throwable e) {
      myLogger.debug(e);
    }
  }
}
