package com.intellij.ide.license.impl;

import com.intellij.ide.license.LicenseManager;
import com.intellij.ide.license.LicenseMessages;
import com.intellij.ide.license.ui.HtmlHelp;
import com.jetbrains.license.util.VerificationFailedException;

/**
 * @author Eugene Zhuravlev
 */
public class IncorrectLSException extends VerificationFailedException {

  @Override
  public String getMessage() {
    final String msg = "The license server address is incorrect";
    final LicenseManager mgr = LicenseManager.getInstance();
    if (mgr != null) {
      final LicenseMessages messages = mgr.getMessages();
      final String url = messages != null ? messages.getPurchaseUrl(mgr.getLicenseFactory().getProductDescriptor(), false) : null;
      if (url != null) {
        return msg + ", please visit "+ HtmlHelp.makeUrl(url + "&incorrect-server", "this page") + " to learn more.";
      }
    }
    return msg;
  }

}
