/*
 * @author max
 */
package com.intellij.ide.license.impl;

import com.intellij.openapi.util.NlsContexts;
import com.jetbrains.ls.responses.EncodedAsset;
import com.jetbrains.ls.responses.License;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Date;

/**
 * The first JetProfile-based license introduced together with the JetProfile.
 * Currently is obsolete and replaced with X509 Certificate-based keys
 */
public class JetProfileLicenseData extends JBALicenseData {

  public JetProfileLicenseData(@NotNull String userId, String userLogin, @NotNull EncodedAsset asset, @NotNull License decodedLicense) {
    super(userId, userLogin, asset, decodedLicense);
  }

  @Override
  public Date getExpirationDate() {
    return getLicense().getExpirationDate();
  }

  @Override
  public int getMajorVersion() {
    return getLicense().getProductVersion();
  }

  @Override
  public String getUserName() {
    return getLicense().getLicensedTo();
  }

  @Override
  public boolean isExpired() {
    final Date expirationDate = getExpirationDate();
    return expirationDate != null && new Date().after(expirationDate);
  }

  @Override
  public boolean shouldDetectDuplicates() {
    return getLicense().isDetectDuplicates();
  }

  @Override
  @Nullable @NlsContexts.Label
  public String getRestrictionsText() {
    //noinspection HardCodedStringLiteral
    return getLicense().getLicenseRestrictions();
  }
}
