package com.intellij.ide.license.impl;

import com.intellij.notification.NotificationType;
import com.intellij.openapi.util.NlsContexts;

import java.util.Collection;

@SuppressWarnings("override")
public interface LicenseNotification {

  enum Type {
    ERR, WARN, INFO;
    
    public NotificationType toNotificationType() {
      switch(this) {
        case ERR: return NotificationType.ERROR;
        case WARN: return NotificationType.WARNING;
        case INFO: return NotificationType.INFORMATION;
        default: return NotificationType.INFORMATION;
      }
    }
  }

  interface Action{
    Action RENEW = new Action() {
      public String getText() {
        return "Renew License";
      }

      public String getLink() {
        return "https://account.jetbrains.com";
      }
    };
    Action FALLBACK_OPTIONS = new Action() {
      public String getText() {
        return "Fallback Options";
      }

      public String getLink() {
        return "https://sales.jetbrains.com/hc/en-gb/articles/207240845-What-is-perpetual-fallback-license-";
      }
    };

    String getText();
    
    String getLink();
  }

  Type getType();

  @NlsContexts.NotificationTitle String getTitle();
  
  @NlsContexts.NotificationContent String getMessage();

  Collection<Action> getActions();
}
