package com.intellij.ide.license.impl;

import com.intellij.openapi.application.ApplicationInfo;
import com.intellij.openapi.application.PermanentInstallationID;
import com.intellij.openapi.application.impl.ApplicationInfoImpl;
import com.intellij.openapi.util.BuildNumber;
import com.jetbrains.license.util.MachineIDProvider;

public class MachineIDProviderImpl extends MachineIDProvider{
  @Override
  public String get() {
    return PermanentInstallationID.get();
  }

  @Override
  public String getBuildNumber() {
    final ApplicationInfo appInfo = ApplicationInfoImpl.getShadowInstance();
    
    final StringBuilder bn = new StringBuilder();
    final String ver = appInfo.getFullVersion();
    if (ver != null) {
      bn.append(ver);
    }
    final BuildNumber build = appInfo.getBuild();
    if (build != null)  {
      bn.append(" Build ").append(build.asString());
    }
    return bn.length() > 0? bn.toString() : null;
  }
}
