package com.intellij.ide.license.impl;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

/**
 * @author Eugene Zhuravlev
 * Date: 04-Jul-18
 * @noinspection unchecked
 *
 * Expected key format: licenseId-licenseData-signatureBase64-certificatesBase64
 * Accepts one string argument, returns a string array with the argument splitted with delimiter "-"
 */
final class SplitCertKey implements InvocationHandler {
  public static final SplitCertKey INSTANCE = new SplitCertKey();

  private static final String DATA_LINE = "5¯\f(DHJKu008E×>4";

  private SplitCertKey() {
  }

  @Override
  public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
    final List result = new ArrayList();
    final StringBuilder buf = new StringBuilder();
    final int delim = Integer.parseInt(String.valueOf(DATA_LINE.charAt(DATA_LINE.length() - 1)) + DATA_LINE.charAt(0));
    final String input = args[0].toString();
    for (int i = 0; i< input.length(); i++) {
      final char _ch = input.charAt(i);
      if (_ch != delim) {
        buf.append(_ch);
      }
      else {
        if (buf.length() > 0) {
          result.add(buf.toString());
          buf.setLength(0); // reset buf
        }
      }
    }
    if (buf.length() > 0) {
      result.add(buf.toString());
    }
    return result.toArray();
  }
}
