package com.intellij.ide.license.impl;

import com.jetbrains.license.util.RSAEncoder;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.math.BigInteger;
import java.util.Random;

/**
 * @author Eugene Zhuravlev
 * Date: 12-Jul-18
 */
public class VerifyUltimate implements InvocationHandler {
  private final Object VERIFY_PRIVATE_MOD;
  private final Object VERIFY_PRIVATE_EXP;
  private final BigInteger ourSalt = new BigInteger(512, new Random(System.currentTimeMillis()));

  public VerifyUltimate() {
    try {
      final Class<? extends BigInteger> aClass = ourSalt.getClass();
      final Method xor = aClass.getMethod("xor", aClass);
      VERIFY_PRIVATE_MOD = xor.invoke(aClass.getConstructor(String.class, int.class).newInstance("ba3da866372947f737c0120610ae281f1085659726cbd2b1288ac7a2b95acef7392d4c848d4cab7767c2c972bdf4e4f73482ef23fb31bf6dda4cbcbf82924d97", 16), ourSalt);
      VERIFY_PRIVATE_EXP = xor.invoke(aClass.getConstructor(String.class, int.class).newInstance("395af9bc98ea4eae74ede2df194df92f2ff0550c0ab7a4a8487b0ce6313d25157905b0b480f3e13b86a06e69b120ee687bbca0b93f6c512241261862a5d76f89", 16), ourSalt);
    }
    catch (Throwable e) {
      throw new RuntimeException() {
        @Override
        public synchronized Throwable fillInStackTrace() {
          return this;
        }
      };
    }
  }

  @Override
  public Object invoke(Object proxy, Method method, Object[] args) {
    try {
      final Class<?> aClass = VERIFY_PRIVATE_EXP.getClass();
      final Method xor = aClass.getMethod("xor", aClass);
      final RSAEncoder encoder = RSAEncoder.class.getConstructor(BigInteger.class, BigInteger.class).newInstance(
        xor.invoke(VERIFY_PRIVATE_EXP, ourSalt),
        xor.invoke(VERIFY_PRIVATE_MOD, ourSalt)
      );
      return encoder.encode((byte[])aClass.getMethod("toByteArray").invoke(args[0]));
    }
    catch (Throwable ignored) {
    }
    return "0";
  }

}
