package com.intellij.ide.license.ui;

import com.intellij.ide.license.LicenseInfo;
import com.intellij.ide.license.LicenseSource;
import com.intellij.ide.license.ProductDescriptor;
import com.intellij.openapi.util.NlsContexts;
import org.jetbrains.annotations.Nls;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.Collection;

public interface LicenseEditingModel {
  @Nullable
  default ProductDescriptor getInitialProductToSelect() {
    return getPlatformProduct();
  }

  @Nullable
  default @NlsContexts.DetailedDescription String getInitialProblemDescription() {
    return null;
  }

  @Nullable
  ProductDescriptor getPlatformProduct();

  Collection<ProductDescriptor> getPluginProducts();

  LicenseInfo getLicenseInfo(ProductDescriptor pd);

  @NotNull
  Collection<LicenseSource<?>> getAvailableLicenseSources(ProductDescriptor pd);

  LicenseInfo activateLicense(ProductDescriptor pd, LicenseSource<?> source) throws Exception;

  @Nls String getDisplayName(ProductDescriptor pd);

  void forgetLicense(ProductDescriptor pd);

  void close(boolean forceExit);
}