package com.intellij.ide.misc;

import com.intellij.openapi.application.PathManager;
import org.jetbrains.annotations.NotNull;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * @author Eugene Zhuravlev
 */
public final class BlackListResource extends UpdatableResource<Collection<String>> {
  public BlackListResource(@NotNull Path storageRoot) {
    super(storageRoot.resolve("bl"));
  }

  @Override
  protected Collection<String> parseData(String data) throws IOException {
    List<String> result = new ArrayList<>();
    //noinspection IOResourceOpenedButNotSafelyClosed
    final BufferedReader reader = new BufferedReader(new StringReader(data));
    for (String line = reader.readLine(); line != null; line = reader.readLine()) {
      result.add(line.trim());
    }
    return result;
  }

  public static BlackListResource createDefault() {
    return new BlackListResource(PathManager.getCommonDataPath());
  }
}