package com.intellij.ide.misc;

import com.intellij.openapi.application.PathManager;
import org.jetbrains.annotations.NotNull;

import java.nio.file.Path;

/**
 * @author Eugene Zhuravlev
 */
public final class CrlResource extends UpdatableResource<String> {
  public CrlResource(@NotNull Path storageRoot) {
    super(storageRoot.resolve("crl"));
  }

  @Override
  protected String parseData(String data) {
    return data;
  }

  public static CrlResource createDefault() {
    return new CrlResource(PathManager.getCommonDataPath());
  }
}