package com.intellij.indexing.shared.download

import com.intellij.indexing.shared.message.SharedIndexesBundle
import com.intellij.openapi.components.service
import com.intellij.openapi.project.Project
import com.intellij.ui.layout.*

internal class SharedIndexesPauseIndexingConfigurable : SharedIndexSuggesterConfigurable {
  override val mode = SharedIndexConfigurableMode.Additional
  override fun isAvailableFor(project: Project) = true

  override fun buildSettingsPanel(project: Project, scope: SharedIndexesConfigurableScope, builder: RowBuilder) {
    builder.row {
      checkBox(
        text = SharedIndexesBundle.message("configuration.combobox.pauseIndexing"),
        getter = { service<SharedIndexDownloadConsentStore>().pauseIndexing },
        setter = { service<SharedIndexDownloadConsentStore>().pauseIndexing = it },
        comment = SharedIndexesBundle.message("configuration.combobox.pauseIndexing.comment")
      )
    }
  }
}