package com.intellij.indexing.shared.download

import com.intellij.openapi.application.ApplicationManager
import com.intellij.openapi.components.service
import com.intellij.openapi.roots.ModuleRootEvent
import com.intellij.openapi.roots.ModuleRootListener
import com.intellij.openapi.util.registry.Registry


private fun isEnabled() = !ApplicationManager.getApplication().isUnitTestMode &&
                          Registry.`is`("shared.indexes.download")

internal class SharedIndexProjectRootsRefresh : ModuleRootListener {
  override fun rootsChanged(event: ModuleRootEvent) {
    if (!isEnabled()) return
    if (event.isCausedByFileTypesChange) return

    service<SharedIndexDownloadService>().rescanNow(event.project)
  }
}
