package com.intellij.indexing.shared.java.maven

data class MavenPackageId(
  val groupId: String,
  val artifactId: String,
  val version: String
) {
  fun asString() = "$groupId:$artifactId:$version"
  override fun toString() = "MavenPackageId(${asString()})"
}

fun String.toMavenPackageId(): MavenPackageId? {
  val split = this.split(":")
  if (split.size != 3) return null
  val (group, artifact, version) = split
  return MavenPackageId(group, artifact, version)
}
