package com.intellij.indexing.shared.java.maven

import com.intellij.indexing.shared.download.*
import com.intellij.openapi.application.ApplicationManager
import com.intellij.openapi.util.registry.Registry

object MavenSharedIndexes {
  const val MAVEN_KIND = "mvn"

  val mavenFeedUrl
    get() = Registry.stringValue("shared.indexes.maven.download.url").trim('/')

  val decisionKey get() = IndexDownloadConsentDecisionKey(MAVEN_KIND, mavenFeedUrl)

  fun toSharedIndexId(pkg: MavenPackageId) = SharedIndexId(MAVEN_KIND, mavenFeedUrl, pkg.asString())

  fun isEnabled() = !ApplicationManager.getApplication().isUnitTestMode &&
                    Registry.`is`("shared.indexes.download") &&
                    Registry.`is`("shared.indexes.maven.download")
}
