package com.intellij.indexing.shared.message;

import com.intellij.DynamicBundle;
import org.jetbrains.annotations.Nls;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.PropertyKey;

public final class SharedIndexesBundle extends DynamicBundle {

  @NonNls
  private static final String BUNDLE = "messages.SharedIndexesBundle";
  private static final SharedIndexesBundle INSTANCE = new SharedIndexesBundle();

  private SharedIndexesBundle() {
    super(BUNDLE);
  }

  @NotNull
  public static @Nls String message(@NotNull @PropertyKey(resourceBundle = BUNDLE) String key, Object @NotNull ... params) {
    return INSTANCE.getMessage(key, params);
  }
}
