package com.intellij.indexing.shared.platform.api;

import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public enum IndexInfrastructureCapability implements Comparable<IndexInfrastructureCapability> {
  ARCHIVE_METADATA("archive-hashes"),
  GIT_METADATA("git-hashes"),
  TEST_CAPABILITY("test-metadata"),

  ;
  private final String myCapabilityName;

  IndexInfrastructureCapability(@NotNull String capabilityName) {
    myCapabilityName = capabilityName;
  }

  @NotNull
  public String getCapabilityName() {
    return myCapabilityName;
  }

  @Nullable
  public static IndexInfrastructureCapability find(@NotNull String capabilityName) {
    for (IndexInfrastructureCapability value : values()) {
      if (value.myCapabilityName.equalsIgnoreCase(capabilityName)) return value;
    }
    return null;
  }
}
