package com.intellij.indexing.shared.platform.impl

import com.intellij.indexing.shared.download.SharedIndexDownloadConsentStore
import com.intellij.indexing.shared.download.SharedIndexDownloadHistoryStore
import com.intellij.indexing.shared.download.SharedIndexDownloadService
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.application.PathManager
import com.intellij.openapi.components.service
import com.intellij.openapi.project.DumbAwareAction
import com.intellij.openapi.util.io.FileUtil
import com.intellij.util.indexing.FileBasedIndexSwitcher

private class ResetSharedIndexesAction : DumbAwareAction() {
  override fun actionPerformed(e: AnActionEvent) {
    val switcher = FileBasedIndexSwitcher()
    switcher.turnOff()
    FileUtil.delete(PathManager.getIndexRoot())
    service<SharedIndexDownloadHistoryStore>().reset()
    service<SharedIndexDownloadConsentStore>().reset()
    switcher.turnOn()

    service<SharedIndexDownloadService>().rescanNow(e.project)
  }
}
