package com.intellij.indexing.shared.platform.impl

import com.intellij.ide.caches.CachesInvalidator
import com.intellij.indexing.shared.download.SharedIndexDownloadConsentStore
import com.intellij.indexing.shared.message.SharedIndexesBundle
import com.intellij.openapi.components.service

class SharedIndexCachesDataInvalidator : CachesInvalidator() {
  override fun getDescription() = SharedIndexesBundle.message("checkbox.invalidateCaches.dropDownloadedIndexes")
  override fun optionalCheckboxDefaultValue() = true

  override fun invalidateCaches() {
    SharedIndexChunkConfiguration.getInstance().markOpenChunksAsExcluded(true)
  }
}

class SharedIndexCachesConsentsInvalidator : CachesInvalidator() {
  override fun optionalCheckboxDefaultValue(): Boolean = false

  override fun getDescription() = SharedIndexesBundle.message("checkbox.invalidateCaches.resetConsents")

  override fun invalidateCaches() {
    service<SharedIndexDownloadConsentStore>().reset()
  }
}
