package com.intellij.indexing.shared.space

import com.intellij.indexing.shared.download.SharedIndexConfigurableMode
import com.intellij.indexing.shared.download.SharedIndexSuggesterConfigurable
import com.intellij.indexing.shared.download.SharedIndexesConfigurableScope
import com.intellij.indexing.shared.message.SharedIndexesBundle
import com.intellij.openapi.project.Project
import com.intellij.space.vcs.SpaceProjectContext
import com.intellij.ui.layout.*

class SpareSharedIndexesConfig : SharedIndexSuggesterConfigurable {
  override val mode = SharedIndexConfigurableMode.CustomBuilt
  override fun isAvailableFor(project: Project) = true

  override fun buildSettingsPanel(project: Project, scope: SharedIndexesConfigurableScope, builder: RowBuilder) {
    scope.run {
      builder.titledRow(SharedIndexesBundle.message("configuration.section.space")) {
        val hasSpaceProject = SpaceProjectContext.getInstance(project).currentContext.isAssociatedWithSpaceRepository

        row {
          if (hasSpaceProject) {
            label("Space Project is associated")
          }
          else {
            label("No Space Project is associated")
          }
        }
      }
    }
  }
}
