package com.intellij.indexing.shared.util

import com.intellij.util.io.PersistentBTreeEnumerator
import com.intellij.util.io.PersistentEnumeratorBase
import it.unimi.dsi.fastutil.ints.Int2IntMap
import it.unimi.dsi.fastutil.ints.Int2IntOpenHashMap
import it.unimi.dsi.fastutil.ints.IntArrayList

fun <D> mergeEnumerator(baseEnumerator: PersistentBTreeEnumerator<D>,
                        toMerge: PersistentBTreeEnumerator<D>): Int2IntMap {
  val diff = Int2IntOpenHashMap()

  val idsToBeMerged = IntArrayList()
  toMerge.traverseAllRecords(object : PersistentEnumeratorBase.RecordsProcessor() {
    override fun process(record: Int): Boolean {
      idsToBeMerged.add(record)
      return true
    }
  })

  for (idToBeMerged in idsToBeMerged.iterator()) {
    val data = toMerge.valueOf(idToBeMerged)
    if (data == null) continue
    val newId = baseEnumerator.enumerate(data)
    if (idToBeMerged != newId) {
      diff[idToBeMerged] = newId
    }
  }

  return diff
}