package com.intellij.indexing.shared.util.zipFs;

import org.jetbrains.annotations.NotNull;

import java.io.IOException;
import java.nio.file.attribute.BasicFileAttributeView;
import java.nio.file.attribute.BasicFileAttributes;
import java.nio.file.attribute.FileTime;

final class UncompressedZipEntryFileAttributeView implements BasicFileAttributeView {
  private final @NotNull UncompressedZipPath path;

  UncompressedZipEntryFileAttributeView(@NotNull UncompressedZipPath path) {
    this.path = path;
  }

  @Override
  public String name() {
    return "basic";
  }

  @Override
  public BasicFileAttributes readAttributes() throws IOException {
    return new UncompressedZipEntryFileAttributes(path);
  }

  @Override
  public void setTimes(FileTime lastModifiedTime,
                       FileTime lastAccessTime,
                       FileTime createTime) {
    // do nothing
  }
}
