package com.intellij.licensecommon.license;

import org.jetbrains.annotations.NotNull;

public class LicenseBroadcastData {

  private final int myCode;
  @NotNull
  private final String myLicenseKeyId;
  @NotNull
  private final String myLicenseeName;
  @NotNull
  private final String myUserLogin;

  public LicenseBroadcastData(int code, @NotNull String licenseKeyId, @NotNull String licenseeName, @NotNull String userLogin) {
    myCode = code;
    myLicenseKeyId = licenseKeyId;
    myLicenseeName = licenseeName;
    myUserLogin = userLogin;
  }

  public int getCode() {
    return myCode;
  }

  @NotNull
  public String getLicenseKeyId() {
    return myLicenseKeyId;
  }

  @NotNull
  public String getLicenseeName() {
    return myLicenseeName;
  }

  @NotNull
  public String getUserLogin() {
    return myUserLogin;
  }

  @Override
  public String toString() {
    return "LicenseDescriptor{" +
           "myCode=" + myCode +
           ", myLicenseKeyId='" + myLicenseKeyId + '\'' +
           ", myLicenseeName='" + myLicenseeName + '\'' +
           ", myUserLogin='" + myUserLogin + '\'' +
           '}';
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;

    LicenseBroadcastData that = (LicenseBroadcastData)o;

    if (myCode != that.myCode) return false;
    if (!myLicenseKeyId.equals(that.myLicenseKeyId)) return false;
    if (!myLicenseeName.equals(that.myLicenseeName)) return false;
    if (!myUserLogin.equals(that.myUserLogin)) return false;

    return true;
  }

  @Override
  public int hashCode() {
    int result = myCode;
    result = 31 * result + myLicenseKeyId.hashCode();
    result = 31 * result + myLicenseeName.hashCode();
    result = 31 * result + myUserLogin.hashCode();
    return result;
  }
}
