package com.intellij.licensecommon.license;

import com.intellij.openapi.util.NlsContexts;
import org.jetbrains.annotations.Nullable;

import java.util.Date;

public interface LicenseData {

  String getKey();

  boolean isExpired();

  boolean isValid();

  @Nullable
  Date getExpirationDate();

  String getUserName();

  boolean isNonCommercial();

  boolean shouldDetectDuplicates();

  boolean isPersonal();

  boolean isYearAcademic();

  boolean isOpenSource();

  int getMajorVersion();

  Date getGenerationDate();

  @Nullable
  @NlsContexts.Label
  String getRestrictionsText();
}
