package com.intellij.licensecommon.license;

import com.intellij.licensecommon.util.InvalidLicenseKeyException;
import com.intellij.licensecommon.util.LicenseDecoder;
import com.intellij.licensecommon.util.LicenseInfo;

public class LicenseDataImpl extends LegacyKeyBasedLicenseData {
  public LicenseDataImpl(String key, String userName) {
    super(key, userName);
  }

  public static LicenseDataImpl create(String key, String userName) {
    return new LicenseDataImpl(key, userName);
  }

  @Override
  protected LicenseInfo decodeInternal() throws InvalidLicenseKeyException {
    return LicenseDecoder.decodeLicenseKey(getUserName(), getKey());
  }


}
