package com.intellij.licensecommon.net.impl;

import com.intellij.licensecommon.net.Network;
import com.intellij.licensecommon.net.NetworkSocket;
import com.intellij.licensecommon.net.Packet;
import com.intellij.licensecommon.net.SocketClosedException;

public class SocketListener implements Runnable {
  private final Network myNetwork;
  private final NetworkSocket mySocket;

  public SocketListener(Network network, NetworkSocket socket) {
    myNetwork = network;
    mySocket = socket;
  }

  @Override
  public void run() {
    while (true) {
      try {
        Packet packet = mySocket.receive();
        myNetwork.receive(packet);
      }
      catch (TimeoutOccurredException e) {
      }
      catch (SocketClosedException e) {
        return;
      }
      catch (Throwable ignored) {
        return;
      }
    }
  }
}
