// Copyright 2000-2020 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.intellij.space.vcs

import com.intellij.openapi.project.Project
import com.intellij.openapi.startup.StartupActivity
import com.intellij.space.components.SpaceWorkspaceComponent
import com.intellij.space.vcs.review.SpaceCodeReviewTabManager

open class SpacePostStartupActivity : StartupActivity.DumbAware {

  // init Space services
  override fun runActivity(project: Project) {
    SpaceWorkspaceComponent.getInstance() // auto-login to Space if possible
    SpaceProjectContext.getInstance(project) // map git remotes with Space repositories
    SpaceCodeReviewTabManager.getInstance(project) // manage "Space Code Reviews" toolwindow visibility
  }
}
