package com.jetbrains.rd.actions

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.extensions.ExtensionPointName
import com.intellij.openapi.project.Project
import com.jetbrains.rd.ide.model.ActionModel
import com.jetbrains.rd.ide.model.ActionRegistrationModel
import com.jetbrains.rd.ide.model.GroupModel

interface ActionProvider {
  companion object {
    val EP_NAME = ExtensionPointName.create<ActionProvider>("com.intellij.rd.actionProvider")
  }

  fun getAction(backendActionId: String, actionEvent: AnActionEvent?): AnAction?

  fun getAction(actionPresentation: ActionRegistrationModel, project: Project): AnAction? {
    val backendActionId = when(actionPresentation){
      is ActionModel -> actionPresentation.actionId
      is GroupModel -> actionPresentation.actionId
      else -> null
    }
    return backendActionId?.let { getAction(it, null) }
  }
}