package com.jetbrains.rd.actions

enum class GutterActionKind {
  LEFT_CLICK,
  MIDDLE_CLICK,
  RIGHT_CLICK,
}

data class GutterActionId(val kind: GutterActionKind, val gutterId: Long) {
  companion object {
    private const val GUTTER_PREFIX = "gutter"
    private const val SEPARATOR = ':'

    fun from(stringActionId: String): GutterActionId? {
      try {
        val tokens = stringActionId.split(SEPARATOR)
        if (tokens.size != 3 || tokens[0] != GUTTER_PREFIX) {
          return null
        }
        val kind = GutterActionKind.valueOf(tokens[1])
        val gutterId = tokens[2].toLong()
        return GutterActionId(kind, gutterId)
      } catch (_: Exception) {
        return null
      }
    }
  }

  fun toStringActionId(): String {
    return "$GUTTER_PREFIX$SEPARATOR$kind$SEPARATOR$gutterId"
  }
}
