// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.actions

import com.intellij.openapi.actionSystem.DataContext
import com.jetbrains.rd.ide.model.RdDataConstant

open class RdDataContextManager {
  companion object {

    fun createDataContextModel(dataContext: DataContext): List<RdDataConstant> {
      val list = mutableListOf<RdDataConstant>()
      RdDataConstantProvider.EP_NAME.extensions.flatMapTo(list) { provider ->
        provider.getDataConstants(dataContext)
      }
      return list
    }

  }
}