package com.jetbrains.rd.actions

import com.intellij.openapi.util.NlsContexts

data class TooltipActionId(@NlsContexts.Command val myActionText: String,
                           val tooltipId: Long) {
  companion object {
    private const val TOOLTIP_ACTION_PREFIX = "tooltipAction"
    private const val SEPARATOR = ':'

    fun from(stringActionId: String): TooltipActionId? {
      try {
        val tokens = stringActionId.split(SEPARATOR)
        if (tokens.size != 3 || tokens[0] != TOOLTIP_ACTION_PREFIX) {
          return null
        }
        val tooltipId = tokens[1].toLong()
        val actionText = tokens[2]

        return TooltipActionId(actionText, tooltipId)
      }
      catch (_: Exception) {
        return null
      }
    }
  }

  fun toActionId() = listOf(TOOLTIP_ACTION_PREFIX, tooltipId.toString(), myActionText).joinToString(SEPARATOR.toString())
}
