package com.jetbrains.rd.ide.completion

import com.intellij.openapi.editor.Editor
import com.jetbrains.rd.platform.util.userData
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.util.lifetime.onTermination

class CompletionSessionMarker

var Editor.completionSessionMarker: CompletionSessionMarker? by userData()

fun Editor.markCompletionSessionExecuting(lifetime: Lifetime) {
    this.completionSessionMarker = CompletionSessionMarker()
    lifetime.onTermination {
        completionSessionMarker = null
    }
}

val Editor.isCompletionSessionExecuting: Boolean get() = this.completionSessionMarker != null