// Copyright 2000-2020 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ide.document

import com.jetbrains.rd.ide.model.RdDocumentVersion

interface DocumentVersionHolder {
  val previousVersion: RdDocumentVersion
  val version: RdDocumentVersion
  fun incrementVersion(newIdeaModificationStamp: Long): Boolean
  fun resetVersion(v: RdDocumentVersion, ideaModificationStamp: Long)
}

val InitialDocVersion = RdDocumentVersion(-1)

fun RdDocumentVersion.increment(): RdDocumentVersion {
  val new = this.value + 1
  require(new >= 0)
  return RdDocumentVersion(new)
}

fun RdDocumentVersion.decrement(): RdDocumentVersion {
  require(this.value >= 0)
  return RdDocumentVersion(this.value - 1)
}