// Copyright 2000-2020 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ide.editor

import com.jetbrains.rd.ide.model.RdEditorVersion

class EditorVersionHolder(initialVersion: RdEditorVersion) {
  var version: RdEditorVersion = initialVersion
    private set

  fun incrementVersion(): RdEditorVersion {
    version = version.increment()
    return version
  }

  fun reset(v: RdEditorVersion) {
    version = v
  }
}

val InitialEditorVersion = RdEditorVersion(-1)

fun RdEditorVersion.increment(): RdEditorVersion {
  val newVersion = this.caretModelVersion + 1
  require(newVersion >= 0)
  return RdEditorVersion(newVersion)
}