// Copyright 2000-2020 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ide.editor.markup

import com.intellij.openapi.util.Key
import com.jetbrains.rd.ide.model.GutterMarkActionModel
import com.jetbrains.rd.ide.model.RdMarkupModel
import com.jetbrains.rd.ide.model.TooltipProviderModel

object GutterMarkProtocolExtensions {
  val GUTTER_MARK_ACTION_MODEL_KEY = Key<GutterMarkActionModel>("GUTTER_MARK_ACTION_MODEL_KEY")
  val GUTTER_MARK_TASK_ACTION_MODEL_KEY = Key<GutterMarkActionModel>("GUTTER_MARK_TASK_ACTION_MODEL_KEY")
  val GUTTER_MARK_TOOLTIPS_KEY = Key<TooltipProviderModel>("GUTTER_MARK_TOOLTIPS_KEY")
}

val RdMarkupModel.gutterMarkAction get() = getExtension(GutterMarkProtocolExtensions.GUTTER_MARK_ACTION_MODEL_KEY)
val RdMarkupModel.gutterMarkTaskAction get() = getExtension(GutterMarkProtocolExtensions.GUTTER_MARK_TASK_ACTION_MODEL_KEY)
val RdMarkupModel.gutterMarkTooltipProviderModel get() = getExtension(GutterMarkProtocolExtensions.GUTTER_MARK_TOOLTIPS_KEY)
