// Copyright 2000-2020 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ide.editor.markup

import com.intellij.openapi.util.Key
import com.jetbrains.rd.ide.model.MarkupModelExtension
import com.jetbrains.rd.ide.model.RdMarkupModel

fun <T : MarkupModelExtension> RdMarkupModel.getExtension(key: Key<T>): T {
  @Suppress("UNCHECKED_CAST")
  return extensions.firstOrNull { it.key == key.toString() } as T
}
