// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ide.toolWindows

import com.intellij.openapi.wm.ToolWindowAnchor
import com.jetbrains.ide.model.uiautomation.BePosition

fun ToolWindowAnchor.toModelAnchor(): BePosition {
  return when (this) {
    ToolWindowAnchor.TOP -> BePosition.TOP
    ToolWindowAnchor.BOTTOM -> BePosition.BOTTOM
    ToolWindowAnchor.LEFT -> BePosition.LEFT
    ToolWindowAnchor.RIGHT -> BePosition.RIGHT
    else -> BePosition.RIGHT
  }
}

fun BePosition.toIdeaAnchor() = when (this) {
  BePosition.TOP -> ToolWindowAnchor.TOP
  BePosition.BOTTOM -> ToolWindowAnchor.BOTTOM
  BePosition.LEFT -> ToolWindowAnchor.LEFT
  BePosition.RIGHT -> ToolWindowAnchor.RIGHT
  else -> ToolWindowAnchor.RIGHT
}
