// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.lang

import com.intellij.openapi.extensions.AbstractExtensionPointBean
import com.intellij.openapi.extensions.RequiredElement
import com.intellij.util.xmlb.annotations.Attribute
import org.jetbrains.annotations.NonNls

class ProtocolLanguageAssociationBean : AbstractExtensionPointBean() {
  /**
   * this must be set to the name of the language in the backend
   * e.g. <see cref="JetBrains.ReSharper.Psi.PsiLanguageType"/>
   */
  @Attribute("backendLanguage")
  @RequiredElement
  @NonNls
  var backendLanguage: String? = null

  /**
   * this must be set to the name of the language in the frontend
   * @see com.intellij.lang.Language.getID
   */
  @Attribute("frontendLanguage")
  @RequiredElement
  var frontendLanguage: String? = null

  /**
   * defines whether this backendLanguage <-> frontendLanguage binding should be returned in case of one to many relationship
   */
  @Attribute("default")
  var isDefault: Boolean = false
}