package com.jetbrains.rd.platform

import com.jetbrains.rd.ide.model.RdTextRange

data class Range(val start: Int, val end: Int) {
  companion object {
    val invalidRange = Range(-1, -1)
  }

  val isNormalized: Boolean get() = this.start <= this.end

  val isValid: Boolean get() = this != invalidRange

  fun shift(offset: Int) = Range(this.start + offset, this.end + offset)
}

fun Range.toModel() = RdTextRange(start, end)
fun RdTextRange.fromModel() = Range(startOffset, endOffset)