package com.jetbrains.rd.platform.codeWithMe

import com.intellij.util.containers.ContainerUtil
import java.util.concurrent.atomic.AtomicLong

class ThreadSafeIdHolder {
  private val idMap = ContainerUtil.createConcurrentWeakMap<Any, Long>()
  private var nextId = AtomicLong()
  
  fun getId(value: Any): Long {
    return idMap.getOrPut(value) { nextId.incrementAndGet() }
  }
}