package com.jetbrains.rd.platform.codeWithMe.completion

import com.intellij.codeInsight.lookup.LookupElement
import com.intellij.codeInsight.lookup.LookupElementDecorator
import com.jetbrains.rd.ide.completion.IProtocolLookupItem

fun tryGetProtocolItem(item: LookupElement?): IProtocolLookupItem? {
  if (item is IProtocolLookupItem) return item

  var decorator = item
  while (decorator is LookupElementDecorator<*>) {
    val delegate = decorator.delegate
    if (delegate is IProtocolLookupItem) return delegate

    decorator = delegate
  }

  return null
}

