package com.jetbrains.rd.platform.codeWithMe.control.icons

import com.intellij.ui.LayeredIcon
import com.jetbrains.rd.platform.codeWithMe.control.CWMDrawingData
import com.jetbrains.rd.platform.codeWithMe.control.backgroundColor
import com.jetbrains.codeWithMe.model.RdUserModel
import java.awt.Color
import java.awt.Font
import javax.swing.Icon
import javax.swing.SwingConstants

class CircleFactories {
  companion object {
    private fun createStringWithBackgroundIcon(icon: Icon, string: String,
                                               font: Font): Icon {
      val symbolIcon = TextIcon({icon.iconWidth}, {icon.iconHeight}, string, CWMDrawingData.avatarForeground, {font})

      return LayeredIcon(2).apply {
        setIcon(icon, 0, SwingConstants.CENTER)
        setIcon(symbolIcon, 1, SwingConstants.CENTER)
      }
    }

    fun createHoverIcon(color: Color = CWMDrawingData.avatarHover): Icon {
      return CircleHoverIcon(color)
    }

    private fun createUserCircleIcon(user: RdUserModel? = null): CircleIcon {
      return CircleIcon(user?.backgroundColor, 16, 0)
    }

    private fun createUserTabCircleIcon(user: RdUserModel? = null): CircleIcon {
      return createUserTabCircleIcon(
        user?.backgroundColor)
    }

    private fun createUserTabCircleIcon(color: Color?): CircleIcon {
      return CircleIcon(color, 12, 1)
    }

    fun createUsersTabIcon(user: RdUserModel): Icon {
      return createStringWithBackgroundIcon(
        createUserTabCircleIcon(user),
        user.name[0].toUpperCase().toString(), CWMDrawingData.tabIconFont)
    }

    fun createUsersIcon(user: RdUserModel): Icon {
      return createStringWithBackgroundIcon(
        createUserCircleIcon(user),
        user.name[0].toUpperCase().toString(), CWMDrawingData.iconFont)
    }
  }
}