package com.jetbrains.rd.platform.codeWithMe.control.icons

import com.intellij.util.ui.JBUI
import java.awt.*
import java.awt.geom.Rectangle2D
import javax.swing.Icon

class FollowedIcon(var color: Color? = null, private val unscaledWidth: Int = 16, private val unscaledHeight: Int = 24, val unscaledThickness: Int = 2) : Icon {
  private val count = 3

  private val thickness
    get() = JBUI.scale(unscaledThickness)
  private val gap
    get() = thickness

  override fun getIconWidth(): Int {
    return JBUI.scale(unscaledWidth)
  }

  override fun getIconHeight(): Int {
    return JBUI.scale(unscaledHeight)
  }

  override fun paintIcon(c: Component?, g: Graphics, x: Int, y: Int) {
    val g2d = g.create() as Graphics2D

    g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON)

    val lf = (iconWidth - (gap * (count - 1))).toFloat()/count
    val tf = thickness.toFloat()
    val yf = iconHeight - tf

    g2d.color = color ?: Color.GRAY

    for(i in 0 until count) {
      val xf = x.toFloat() + ((lf+gap)*i)

      val area = Rectangle2D.Float(xf, yf, lf, tf)
      g2d.fill(area)
    }

    g2d.dispose()
  }

}