package com.jetbrains.rd.platform.codeWithMe.control.icons

import com.intellij.util.ui.JBUI
import java.awt.*
import java.awt.geom.Rectangle2D
import javax.swing.Icon

class FullSyncIcon(var color: Color? = null, private val unscaledWidth: Int = 16, private val unscaledHeight: Int = 24, val unscaledThickness: Int = 2) : Icon {
  private val thickness
    get() = JBUI.scale(unscaledThickness)

  override fun getIconWidth(): Int {
    return JBUI.scale(unscaledWidth)
  }

  override fun getIconHeight(): Int {
    return JBUI.scale(unscaledHeight)
  }

  override fun paintIcon(c: Component?, g: Graphics, x: Int, y: Int) {
    val g2d = g.create() as Graphics2D

    g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON)

    val cf = iconWidth.toFloat()
    val tf = thickness.toFloat()
    val yf = iconHeight - tf

    g2d.color = color ?: Color.GRAY

    val area = Rectangle2D.Float(x.toFloat(), yf, cf, tf)
    g2d.fill(area)

    g2d.dispose()
  }


}