package com.jetbrains.rd.platform.codeWithMe.editors

import com.intellij.codeWithMe.ClientId
import com.intellij.openapi.components.service
import com.intellij.openapi.editor.Document
import com.intellij.openapi.editor.Editor
import com.intellij.openapi.project.Project
import com.jetbrains.rd.platform.codeWithMe.users.UserManager
import com.jetbrains.rd.platform.codeWithMe.users.clientId

open class CodeWithMeEditorService(private val project: Project) {
  companion object {
    fun getInstance(project: Project): CodeWithMeEditorService = project.service()
  }

  open fun serverNotify(document: Document, clientId: ClientId) {
    throw UnsupportedOperationException("invalid")
  }

  open fun getActiveClients(editor: Editor): List<ClientId> {
    throw UnsupportedOperationException("invalid")
  }

  fun isLeadEditor(editor : Editor): Boolean {
    val userManager = UserManager.getInstance(project)
    val lead = userManager.lead.value ?: return false

    return getActiveClients(editor).contains(lead.clientId)
  }
}
