package com.jetbrains.rd.platform.codeWithMe.editors

import com.intellij.openapi.components.service
import com.intellij.openapi.project.Project
import com.jetbrains.rd.ide.model.RdFileId
import java.lang.UnsupportedOperationException

open class GuestNavigationService {
  companion object {
    fun getInstance(project: Project): GuestNavigationService = project.service()
  }

  open fun navigateViaBackend(pathRelativeToBasePath: String, offset: Int = 0) {
    throw UnsupportedOperationException("should be used from thin clients only")
  }

  open fun navigateViaBackend(fileId: RdFileId, offset: Int = 0) {
    throw UnsupportedOperationException("should be used from thin clients only")
  }
}