@file:Suppress("UnnecessaryVariable")

package com.jetbrains.rd.platform.codeWithMe.network

import com.jetbrains.codeWithMe.lobby.StunTurnServer
import com.jetbrains.rd.platform.codeWithMe.network.quic.StunTurnUrl

object CwmStunUtil {
  fun filterSimpleStunServers(servers: List<StunTurnServer>): List<StunTurnUrl> {
    val simpleServers = servers
      .filter { it.password == null && it.username == null }
      .mapNotNull { StunTurnUrl.tryParse(it.uri) }
      .filter { it.protocol == StunTurnUrl.Protocol.STUN && (it.transport == StunTurnUrl.Transport.UDP || it.transport == null) }
    return simpleServers
  }
}