package com.jetbrains.rd.platform.codeWithMe.options

import com.intellij.openapi.editor.colors.TextAttributesKey
import com.intellij.openapi.fileTypes.PlainSyntaxHighlighter
import com.intellij.openapi.fileTypes.SyntaxHighlighter
import com.intellij.openapi.options.colors.AttributesDescriptor
import com.intellij.openapi.options.colors.ColorDescriptor
import com.intellij.openapi.options.colors.ColorSettingsPage
import com.intellij.psi.codeStyle.DisplayPriority
import com.intellij.psi.codeStyle.DisplayPrioritySortable
import com.jetbrains.rd.platform.codeWithMe.CodeWithMePlatformBundle
import com.jetbrains.rd.platform.codeWithMe.control.CodeWithMeColors
import javax.swing.Icon

class CodeWithMeColorsPage : ColorSettingsPage, DisplayPrioritySortable {
  override fun getDisplayName(): String {
    return CodeWithMePlatformBundle.message("product.name")
  }

  override fun getIcon(): Icon? {
    return null
  }

  infix fun String.to(key: TextAttributesKey) = AttributesDescriptor(this, key)

  override fun getAttributeDescriptors(): Array<AttributesDescriptor> {
    return arrayOf(
      CodeWithMePlatformBundle.message("color.settings.user1.marker") to CodeWithMeColors.USER_1_MARKER,
      CodeWithMePlatformBundle.message("color.settings.user2.marker") to CodeWithMeColors.USER_2_MARKER,
      CodeWithMePlatformBundle.message("color.settings.user3.marker") to CodeWithMeColors.USER_3_MARKER,
      CodeWithMePlatformBundle.message("color.settings.user4.marker") to CodeWithMeColors.USER_4_MARKER,
      CodeWithMePlatformBundle.message("color.settings.user5.marker") to CodeWithMeColors.USER_5_MARKER,
      CodeWithMePlatformBundle.message("color.settings.user6.marker") to CodeWithMeColors.USER_6_MARKER,

      CodeWithMePlatformBundle.message("color.settings.user1.selection") to CodeWithMeColors.USER_1_SELECTION,
      CodeWithMePlatformBundle.message("color.settings.user2.selection") to CodeWithMeColors.USER_2_SELECTION,
      CodeWithMePlatformBundle.message("color.settings.user3.selection") to CodeWithMeColors.USER_3_SELECTION,
      CodeWithMePlatformBundle.message("color.settings.user4.selection") to CodeWithMeColors.USER_4_SELECTION,
      CodeWithMePlatformBundle.message("color.settings.user5.selection") to CodeWithMeColors.USER_5_SELECTION,
      CodeWithMePlatformBundle.message("color.settings.user6.selection") to CodeWithMeColors.USER_6_SELECTION
    )
  }

  override fun getColorDescriptors(): Array<ColorDescriptor> {
    return ColorDescriptor.EMPTY_ARRAY
  }

  override fun getHighlighter(): SyntaxHighlighter {
    return PlainSyntaxHighlighter()
  }

  override fun getDemoText(): String {
    return " "
  }

  override fun getAdditionalHighlightingTagToDescriptorMap(): Map<String, TextAttributesKey>? {
    return null
  }

  override fun getPriority(): DisplayPriority {
    return DisplayPriority.COMMON_SETTINGS
  }
}