// Copyright 2000-2020 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.platform.codeWithMe.protocol

import java.util.concurrent.CompletableFuture

interface IPasswordAuthHandler {
  // serverside parts
  fun getPasswordRequestBytes(): ByteArray = byteArrayOf()
  fun checkPasswordFromClient(password: ByteArray): Boolean = false

  // clientside part
  fun askForPassword(challenge: ByteArray): CompletableFuture<ByteArray?> = CompletableFuture.completedFuture(null)
}