package com.jetbrains.rd.platform.codeWithMe.tabection

import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.util.ui.JBUI
import com.jetbrains.rd.platform.codeWithMe.control.CWMDrawingData
import com.jetbrains.rd.platform.codeWithMe.control.icons.TextIcon
import com.jetbrains.rd.platform.codeWithMe.toolbar.CodeWithMeUsersGroup

class CWMSeveralUsersAction(private val maxCirclesCount: Int, val maxBeforeCounter: Int, val maxTooltipCount: Int) : CWMCircleAction() {
  override fun actionPerformed(e: AnActionEvent) {
  }

  override fun update(e: AnActionEvent) {
    val list = getList(e)
    e.presentation.isEnabledAndVisible = if (list.isEmpty() || list.size <= maxCirclesCount) {
      false
    }
    else {
      val afterCircles = list.size - maxCirclesCount
      val iconText = if (afterCircles <= maxBeforeCounter) "+$afterCircles" else "$maxBeforeCounter+"

      val h = { JBUI.scale(13) }
      val severalIcons = TextIcon(h, h, iconText, null, {CWMDrawingData.tabIconFont})

      var string = ""
      list.filterIndexed { i, _ -> i < maxTooltipCount }.map { CodeWithMeUsersGroup.getName(it, escapeHtml = true) }.forEach {
        string += "<div>$it</div>"
      }

      val additionalText = if(list.size > maxTooltipCount) "<div>and ${list.size - maxTooltipCount} more...</div>" else ""

      e.presentation.icon = severalIcons
      e.presentation.text = "<html>${string}$additionalText</html>"
      true
    }
    super.update(e)
  }
}