package com.jetbrains.rd.platform.codeWithMe.tabection

import com.intellij.openapi.actionSystem.AnActionEvent
import com.jetbrains.rd.platform.codeWithMe.control.icons.CircleFactories
import com.jetbrains.rd.platform.codeWithMe.toolbar.CodeWithMeUsersGroup

class CWMSingleUserAction(val index: Int) : CWMCircleAction() {
  override fun actionPerformed(e: AnActionEvent) {
  }

  override fun update(e: AnActionEvent) {
    val list = getList(e)
    e.presentation.isEnabledAndVisible = if (list.isEmpty() || index >= list.size) {
      false
    }
    else {
      list.sortedWith(CodeWithMeUsersGroup.userComparator)
      val user = list[index]
      e.presentation.icon = CircleFactories.createUsersTabIcon(user)
      e.presentation.text = CodeWithMeUsersGroup.getName(user, escapeHtml = true)
      true
    }
    super.update(e)
  }
}