// Copyright 2000-2020 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.platform.codeWithMe.tabection

import com.intellij.openapi.actionSystem.ActionGroup
import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.project.DumbAware
import com.jetbrains.rd.platform.codeWithMe.control.CWMDrawingData

class CodeWithMeTabAction : ActionGroup(), DumbAware {
  private val maxCirclesCount = 2
  private val circles = mutableListOf<CWMCircleAction>()

  init {
    for (i in 0 until maxCirclesCount) {
      circles.add(CWMSingleUserAction(i))
    }
    circles.add(CWMSeveralUsersAction(maxCirclesCount, CWMDrawingData.MAX_BEFORE_COUNTER, CWMDrawingData.MAX_TOOLTIP_COUNT))
  }

  override fun getChildren(e: AnActionEvent?): Array<AnAction> {
    return circles.toTypedArray()
  }
}