package com.jetbrains.rd.platform.codeWithMe.telephony

import com.intellij.icons.AllIcons
import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.project.DumbAware
import com.jetbrains.rd.platform.codeWithMe.CodeWithMePlatformBundle

class EnableCameraAction: AnAction(), DumbAware {

  override fun actionPerformed(e: AnActionEvent) {
    val telephonySession = TelephonyManager.getInstance(e.project ?: return).getSession() ?: return
    telephonySession.toggleCamera()
  }

  override fun update(e: AnActionEvent) {
    val telephonySession = TelephonyManager.getInstance(e.project ?: return).getSession()
    if (telephonySession == null) {
      e.presentation.isEnabledAndVisible = false
      return
    }
    e.presentation.isEnabledAndVisible = true
    e.presentation.text = if (telephonySession.cameraEnabled.value)
      CodeWithMePlatformBundle.message("action.EnableCameraAction.disable.text")
    else
      CodeWithMePlatformBundle.message("action.EnableCameraAction.enable.text")
    e.presentation.icon = if (telephonySession.cameraEnabled.value) AllIcons.CodeWithMe.CwmCamOn else AllIcons.CodeWithMe.CwmCamOff
  }
}