package com.jetbrains.rd.platform.codeWithMe.telephony

import com.intellij.icons.AllIcons
import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.project.DumbAware

class EnableMicrophoneAction : AnAction(), DumbAware {
  override fun actionPerformed(e: AnActionEvent) {
    val telephonySession = e.project?.getService(TelephonyManager::class.java)?.getSession() ?: return
    telephonySession.toggleMicrophone()
  }

  override fun update(e: AnActionEvent) {
    val telephonySession = e.project?.getService(TelephonyManager::class.java)?.getSession()
    if (telephonySession == null) {
      e.presentation.isEnabledAndVisible = false
      return
    }
    e.presentation.isEnabledAndVisible = true
    e.presentation.icon = if (telephonySession.microphoneEnabled.value) AllIcons.CodeWithMe.CwmMicOn else AllIcons.CodeWithMe.CwmMicOff
  }
}