package com.jetbrains.rd.platform.codeWithMe.telephony

import com.intellij.icons.AllIcons
import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.project.DumbAware
import com.jetbrains.rd.platform.codeWithMe.CodeWithMePlatformBundle
import java.util.function.Supplier

class LeaveCallAction: AnAction(Supplier{CodeWithMePlatformBundle.message("action.LeaveCallAction.text")},
                                AllIcons.CodeWithMe.CwmLeaveCall), DumbAware {
  override fun actionPerformed(e: AnActionEvent) {
    val telephonySession = e.project?.getService(TelephonyManager::class.java)?.getSession() ?: return
    telephonySession.joinConference(false)
  }

  override fun update(e: AnActionEvent) {
    val telephonySession = e.project?.getService(TelephonyManager::class.java)?.getSession()
    e.presentation.isEnabledAndVisible = telephonySession != null && telephonySession.conferenceJoined.value
  }
}