package com.jetbrains.rd.platform.codeWithMe.telephony

import com.intellij.icons.AllIcons
import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.wm.ToolWindowManager
import com.intellij.openapi.wm.ex.ToolWindowEx
import com.jetbrains.rd.platform.codeWithMe.CodeWithMePlatformBundle
import com.jetbrains.rd.platform.codeWithMe.toolWindow.CodeWithMeToolWindowFactory
import com.jetbrains.rd.platform.util.application
import java.util.function.Supplier

class SoundSettingsAction: AnAction(Supplier{ CodeWithMePlatformBundle.message("action.SoundSettingsAction.text")}, AllIcons.General.Settings) {
  private val desiredWidthForSettings = 505
  override fun actionPerformed(e: AnActionEvent) {
    val project = e.project ?: return
    ToolWindowManager.getInstance(project).getToolWindow(CodeWithMeToolWindowFactory.codeWithMeToolWindowID)?.apply {
      (this as ToolWindowEx)
      val currentWidth = component.size.width
      if (currentWidth < desiredWidthForSettings) {
        stretchWidth(desiredWidthForSettings - currentWidth)
      }
      application.invokeLater {
        if (!project.isDisposed) {
          show { TelephonyManager.getInstance(project).getSession()?.openSettings() }
        }
      }
    }
  }
}