package com.jetbrains.rd.platform.codeWithMe.toolbar

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.actionSystem.Presentation
import com.intellij.openapi.actionSystem.ex.CustomComponentAction
import com.jetbrains.rd.platform.codeWithMe.control.CWMControl
import com.jetbrains.rd.platform.codeWithMe.users.UserManager
import javax.swing.JComponent

class CodeWithMeUsersAction: AnAction(), CustomComponentAction {

  init {
    templatePresentation.isEnabledAndVisible = false
  }

  override fun createCustomComponent(presentation: Presentation, place: String): JComponent {
    return CWMControl().view
  }

  override fun update(e: AnActionEvent) {
    e.presentation.isEnabledAndVisible = e.project?.let { UserManager.getInstance(it) }?.let {
      it.sessionEnabled.value || !it.users.isEmpty()
    } ?: false
  }

  override fun actionPerformed(e: AnActionEvent) {
  }
}