package com.jetbrains.rd.platform.codeWithMe.toolbar

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.editor.impl.EditorComponentImpl
import com.intellij.openapi.project.DumbAware
import com.intellij.openapi.wm.IdeFocusManager
import com.jetbrains.rd.platform.codeWithMe.users.UserManager

class EscUnfollowUserAction : AnAction(), DumbAware {
  override fun update(e: AnActionEvent) {
    val userManager: UserManager? = getUserManager(e)
    e.presentation.isEnabled = userManager !=null && userManager.lead.value != null &&
                               IdeFocusManager.findInstance().focusOwner is EditorComponentImpl
  }

  override fun actionPerformed(e: AnActionEvent) {
    val userManager: UserManager? = getUserManager(e)
    userManager?.stopFollowingOrSync()
  }

  private fun getUserManager(e: AnActionEvent): UserManager? {
    val project = e.project
    if (project == null) {
      return null;
    }
    return UserManager.getInstance(project)
  }
}