package com.jetbrains.rd.platform.codeWithMe.toolbar

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.project.DumbAware
import com.jetbrains.rd.platform.codeWithMe.users.UserManager

class ForceOthersToFollowAction : AnAction(), DumbAware {

  override fun update(e: AnActionEvent) {
    val project = e.project
    e.presentation.isEnabledAndVisible = project != null && UserManager.getInstance(project).users.any()
  }

  override fun actionPerformed(e: AnActionEvent) {
    val project = e.project ?: return
    val userManager = UserManager.getInstance(project)
    for (user in userManager.users) {
      userManager.requestFollowing(user, true)
    }
  }
}