package com.jetbrains.rd.platform.codeWithMe.toolbar

import com.intellij.icons.AllIcons
import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.project.DumbAware
import com.jetbrains.rd.platform.codeWithMe.CodeWithMePlatformBundle
import com.jetbrains.rd.platform.codeWithMe.users.UserManager
import java.util.function.Supplier

class InviteOthersToFollowAction : AnAction(Supplier { CodeWithMePlatformBundle.message("action.InviteOthersToFollowAction.text") },
                                            AllIcons.CodeWithMe.CwmFollowMe), DumbAware {

  override fun update(e: AnActionEvent) {
    val project = e.project
    e.presentation.isEnabledAndVisible = project != null && UserManager.getInstance(project).users.any()
  }

  override fun actionPerformed(e: AnActionEvent) {
    val project = e.project ?: return
    val userManager = UserManager.getInstance(project)
    for (user in userManager.users) {
      userManager.requestFollowing(user, false)
    }
  }
}