package com.jetbrains.rd.platform.codeWithMe.toolbar

import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.actionSystem.DefaultActionGroup
import com.jetbrains.rd.platform.codeWithMe.CodeWithMePlatformBundle
import com.jetbrains.rd.platform.codeWithMe.control.icons.CircleFactories
import com.jetbrains.rd.platform.codeWithMe.users.UserManager
import com.jetbrains.codeWithMe.model.RdUserModel
import javax.swing.Icon

class RdUserActionGroup(val userManager: UserManager, val user: RdUserModel, val icon: Icon = CircleFactories.createUsersIcon(user)) : DefaultActionGroup() {
  val text: String = CodeWithMeUsersGroup.getName(user)

  init {
    isPopup = true
    addAll(userManager.createUserActions(user))
  }

  override fun update(e: AnActionEvent) {
    super.update(e)
    e.presentation.icon = icon
    e.presentation.text = text
  }

  public val state: String
    get() {
     val vl = when {
        userManager.isFullSyncWith(user) -> CodeWithMePlatformBundle.message("circle.control.user.state.full.sync")
        userManager.lead.value == user -> CodeWithMePlatformBundle.message("circle.control.user.state.following")
        userManager.followers.contains(user) -> CodeWithMePlatformBundle.message("circle.control.user.state.follower")
        else -> ""
      }
      return vl
    }
}