package com.jetbrains.rd.platform.codeWithMe.toolbar

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.project.DumbAware
import com.jetbrains.codeWithMe.model.RdUserModel
import com.jetbrains.rd.platform.codeWithMe.users.UserManager
import com.jetbrains.rd.util.reactive.IViewableList


class SingleUserFollowAction : AnAction(), DumbAware {
  override fun update(e: AnActionEvent) {
    val manager: UserManager = getUserManager(e)
    e.presentation.isEnabled = manager.users.size > 0 && manager.lead.value == null
  }

  override fun actionPerformed(e: AnActionEvent) {
    val manager: UserManager = getUserManager(e)
    val users: IViewableList<RdUserModel> = manager.users
    if (users.size > 0) {
      val delegate: AnAction
      val folowee: RdUserModel = getDefaultFollowee(users, manager)
      delegate = manager.createFollowAction(folowee)
      delegate.actionPerformed(e)
    }
  }

  private fun getDefaultFollowee(users: IViewableList<RdUserModel>,
                                 manager: UserManager): RdUserModel {
    var folowee: RdUserModel = users.first()
    if (manager.recentLead.value != null && manager.hasRecentLead(users)) {
      folowee = manager.recentLead.value!!
    }
    return folowee
  }

  fun isDefaultFollowee(user : RdUserModel, manager : UserManager) : Boolean {
    return user == getDefaultFollowee(manager.users, manager)
  }

  private fun getUserManager(e: AnActionEvent) = UserManager.getInstance(e.project!!)
}
