package com.jetbrains.rd.platform.codeWithMe.users

import com.intellij.ide.util.PropertiesComponent
import com.intellij.openapi.diagnostic.Logger

object LocalUserSettings {
  private const val userNameKey = "code.with.me.user.name"

  var userName: String
    get() {
      val value = PropertiesComponent.getInstance().getValue(userNameKey)
      if (value != null && value.isNotBlank()) return value
      return getDefaultSystemUserName()
    }
    set(value) {
      PropertiesComponent.getInstance().setValue(userNameKey, value)
    }

  fun getDefaultSystemUserName(): String {
    try {
      return System.getProperty("user.name")
    }
    catch (ex: Throwable) {
      Logger.getInstance("ThinClientWelcomeFrame").error(ex)
    }

    return "User"
  }
}