package com.jetbrains.rd.platform.codeWithMe.util

import com.intellij.codeWithMe.ClientId
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.util.lifetime.onTermination
import com.jetbrains.rd.util.reactive.IViewable
import org.jetbrains.annotations.ApiStatus

// questionable extensions for CWM-25

@ApiStatus.Experimental
inline fun <T : Any> IViewable<T>.view(lifetime: Lifetime, clientId: ClientId, crossinline handler: (Lifetime, T) -> Unit) {
  view(lifetime) { lt, value ->
    ClientId.withClientId(clientId) {
      handler(lt, value)
    }
  }
}

@ApiStatus.Experimental
inline fun Lifetime.onTermination(clientId: ClientId, crossinline action: () -> Unit) {
  this.onTermination {
    ClientId.withClientId(clientId, action)
  }
}