// Copyright 2000-2020 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.platform.codeWithMe.util

import com.intellij.openapi.util.SystemInfo
import com.intellij.util.system.CpuArch
import com.jetbrains.codeWithMe.lobby.CodeWithMePlatform

object CodeWithMePlatformUtil {
  fun currentPlatform(): CodeWithMePlatform =
    when {
      SystemInfo.isMac && CpuArch.isArm64() -> CodeWithMePlatform.MacArm64
      SystemInfo.isMac && CpuArch.isIntel64() -> CodeWithMePlatform.MacIntel64
      SystemInfo.isLinux && CpuArch.isIntel64() -> CodeWithMePlatform.Linux64
      SystemInfo.isWindows && CpuArch.isIntel64() -> CodeWithMePlatform.Windows64
      else -> error("Unsupported OS type: ${SystemInfo.OS_NAME}")
    }
}
