package com.jetbrains.rd.platform.codeWithMe.util

import com.jetbrains.rd.util.reactive.IScheduler
import org.jetbrains.concurrency.AsyncPromise

fun <T> IScheduler.executeSync(ms: Int? = null, action: () -> T): T {
  if (isActive) {
    return action()
  }

  val promise = AsyncPromise<T>()

  queue {
    try {
      promise.setResult(action())
    } catch (e: Throwable) {
      promise.setError(e)
    }
  }

  return when (ms) {
    null -> promise.get()!!
    else -> promise.blockingGet(ms)!!
  }
}