package com.jetbrains.rd.platform.codeWithMe.util

import com.intellij.openapi.ui.Messages
import com.jetbrains.rd.platform.codeWithMe.CodeWithMePlatformBundle
import com.jetbrains.rd.platform.util.application
import java.net.URI

object UrlUtil {
  fun parseOrShowError(url: String): URI? {
    try {
      if (url.contains("://")) {
        return URI.create(url)
      }

      val split = url.split(':')
      if (split.size == 2) {
        return URI.create("tcp://${split[0]}:${split[1]}")
      }
    }
    catch (ex: Throwable) {
      application.invokeLater {
        Messages.showErrorDialog(
          CodeWithMePlatformBundle.message("error.message.invalid.address.format", ex.message ?: ""),
          CodeWithMePlatformBundle.message("product.name"))
      }
      return null
    }

    application.invokeLater {
      Messages.showErrorDialog(
        CodeWithMePlatformBundle.message("error.message.unsupported.address.format"),
        CodeWithMePlatformBundle.message("product.name"))
    }

    return null
  }
}