// Copyright 2000-2020 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.platform.diagnostics

open class LogTraceScenario(vararg _categories: String) : Comparable<LogTraceScenario> {
  val name = this::class.simpleName!!
  private val _categories = _categories.toMutableList()
  val categories: List<String> = this._categories

  init {
    LogTraceScenariosRegistry.allValues.add(this)
  }

  override fun compareTo(other: LogTraceScenario): Int {
    return name.compareTo(other.name)
  }

  fun extend(vararg categories: String) {
    _categories += categories
    LogTraceScenariosRegistry.getInstance().synchronizeToLogger()
  }
}