package com.jetbrains.rd.platform.diagnostics

import com.intellij.openapi.extensions.ExtensionPointName

interface BackendThreadDumper {
  companion object {
    val EP_NAME = ExtensionPointName.create<BackendThreadDumper>("com.intellij.rdclient.backendThreadDumper")
  }

  fun requestBackendThreadDump()
}

object ThreadDumpUtil {
  private val BACKEND_THREAD_DUMPERS: List<BackendThreadDumper> = BackendThreadDumper.EP_NAME.extensionList.filterNotNull()

  fun requestBackendThreadDumps() = BACKEND_THREAD_DUMPERS.forEach { it.requestBackendThreadDump() }
}
