package com.jetbrains.rd.platform.internal.widgets

import com.intellij.openapi.project.Project
import com.jetbrains.rd.util.lifetime.Lifetime
import java.nio.file.Files
import java.nio.file.Paths

abstract class InternalFileWidget(
  lifetime: Lifetime,
  project: Project,
  val path: String,
  autoRefresh: Boolean = false,
  showOnStart: Boolean = true
) : InternalDumpWidget(lifetime, project, autoRefresh, false) {
  init {
    if (showOnStart)
      show()
  }

  override fun dump() = Files.readAllLines(Paths.get(path)).joinToString("\n")
}