package com.jetbrains.rd.platform.internal.widgets

import com.intellij.openapi.actionSystem.AnAction
import com.jetbrains.rd.util.lifetime.Lifetime
import javax.swing.JComponent

abstract class InternalWidget(val lifetime: Lifetime) {
  private val _content = lazy { build() }
  val content: JComponent
    get() = _content.value

  abstract protected fun build(): JComponent
  open fun toolbarActions(): List<AnAction> = emptyList()
}