package com.jetbrains.rd.platform.protocol

import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.util.reactive.IScheduler

class SwitchingScheduler(var actualScheduler: IRdDispatcher) :
  IRdDispatcher {
  override val isActive: Boolean
    get() = actualScheduler.isActive

  override val backgroundScheduler: IScheduler
    get() = actualScheduler.backgroundScheduler

  override fun flush() = actualScheduler.flush()
  override fun suppressPumping(lifetime: Lifetime) = actualScheduler.suppressPumping(lifetime)
  override fun repost() = actualScheduler.repost()
  override fun assertThread(debugInfo: Any?) = actualScheduler.assertThread(debugInfo)
  override fun invokeOrQueue(action: () -> Unit) = actualScheduler.invokeOrQueue(action)
  override fun pumpProtocolQueue(condition: () -> Boolean) = actualScheduler.pumpProtocolQueue(condition)
  override fun queue(action: () -> Unit) = actualScheduler.queue(action)
  override fun allowBackgroundThreadAndSuppressPumping(lifetime: Lifetime) = actualScheduler.allowBackgroundThreadAndSuppressPumping(
    lifetime)
}