package com.jetbrains.rd.platform.util

import com.intellij.mock.MockApplication
import com.intellij.openapi.application.Application
import com.intellij.openapi.application.ApplicationManager
import com.intellij.openapi.application.ex.ApplicationEx
import com.intellij.openapi.application.ex.ApplicationManagerEx

val application: Application
  get() = ApplicationManager.getApplication()

// seems a bit hacky at first, BUT all callers will need to examine 'null' situation anyway,
// so the usual mock-it-just-not-to-check-it-for-null-everywhere doesn't really apply here
// and actually sometimes it's really better to have 'null' instead of 'MockApplication' (e.g. if core test infrastructure uses invokeLater)
val applicationOrNull: Application?
  get() = ApplicationManager.getApplication().let { if (it is MockApplication) null else it }

val applicationEx: ApplicationEx
  get() = ApplicationManagerEx.getApplicationEx()
