package com.jetbrains.rd.platform.util

import java.nio.ByteBuffer
import java.nio.channels.ByteChannel

fun ByteChannel.readAll(buf: ByteBuffer): Boolean {
  while (buf.hasRemaining()) {
    if (read(buf) < 0) return false
  }
  return true
}

fun ByteChannel.writeAll(buf: ByteBuffer): Boolean {
  while (buf.hasRemaining()) {
    if (write(buf) < 0) return false
  }
  return true
}
