// Copyright 2000-2020 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.platform.util

import com.intellij.openapi.util.text.StringUtil
import java.security.MessageDigest
import java.security.cert.Certificate

val Certificate.sha3Fingerprint: String
  get() {
    val md = MessageDigest.getInstance("SHA3-256")
    val digest = md.digest(encoded)
    return StringUtil.toHexString(digest).toUpperCase()
  }
