package com.jetbrains.rd.platform.util

import com.intellij.openapi.rd.createNestedDisposable
import com.intellij.util.messages.MessageBus
import com.intellij.util.messages.Topic
import com.jetbrains.rd.util.lifetime.Lifetime

fun <T> MessageBus.subscribe(lifetime: Lifetime, topic: Topic<T>, handler: T) {
  val disposable = lifetime.createNestedDisposable("MessageBus.subscribe with lifetime")
  connect(disposable).subscribe(topic, handler)
}