package com.jetbrains.rd.platform.util.idea

import com.intellij.openapi.editor.EditorKind
import com.jetbrains.rd.ide.model.TextControlLocation


fun EditorKind.toLocation() = when (this) {
  EditorKind.UNTYPED -> TextControlLocation.Unknown
  EditorKind.MAIN_EDITOR -> TextControlLocation.EditorTab
  EditorKind.CONSOLE -> TextControlLocation.Console
  EditorKind.PREVIEW -> TextControlLocation.Preview
  EditorKind.DIFF -> TextControlLocation.Diff
}

fun TextControlLocation.toEditorKind() = when (this) {
  TextControlLocation.Unknown -> EditorKind.UNTYPED
  TextControlLocation.EditorTab -> EditorKind.MAIN_EDITOR
  TextControlLocation.ToolWindow -> EditorKind.PREVIEW
  TextControlLocation.StandaloneWindow -> EditorKind.UNTYPED
  TextControlLocation.Console -> EditorKind.CONSOLE
  TextControlLocation.Preview -> EditorKind.PREVIEW
  TextControlLocation.Diff -> EditorKind.DIFF
  TextControlLocation.Custom -> EditorKind.UNTYPED
}