package com.jetbrains.rd.platform.util.idea

import com.intellij.openapi.util.Key
import com.intellij.openapi.util.UserDataHolder

inline fun <T> UserDataHolder.getOrCreateUserData(key: Key<T>, producer: () -> T): T {
  val existing = getUserData(key)
  if (existing != null) return existing

  val value = producer()
  putUserData(key, value)
  return value
}
