// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui

import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.actionSystem.Presentation
import com.intellij.openapi.actionSystem.ex.CustomComponentAction
import com.intellij.openapi.project.DumbAwareAction
import javax.swing.JComponent

open class ComponentActionWrapper(private val myComponentCreator: () -> JComponent) : DumbAwareAction(),
                                                                                      CustomComponentAction {
  override fun createCustomComponent(presentation: Presentation) = myComponentCreator()
  override fun actionPerformed(e: AnActionEvent) {}
}