// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui

import com.jetbrains.rd.util.lifetime.Lifetime
import java.awt.event.MouseMotionListener
import javax.swing.JComponent
import javax.swing.JTree
import javax.swing.event.TreeModelListener
import javax.swing.event.TreeSelectionListener
import javax.swing.tree.TreeModel

fun JComponent.addMouseMotionListener(lifetime: Lifetime, l: MouseMotionListener?) {
    lifetime.bracket({ addMouseMotionListener(l) }, { removeMouseMotionListener(l) })
}

fun JTree.addTreeSelectionListener(lifetime: Lifetime, l: TreeSelectionListener) {
    lifetime.bracket({ addTreeSelectionListener(l) }, { removeTreeSelectionListener(l) })
}

fun TreeModel.addTreeModelListener(lifetime: Lifetime, l: TreeModelListener) {
    lifetime.bracket({ addTreeModelListener(l) }, { removeTreeModelListener(l) })
}