package com.jetbrains.rd.ui.bedsl.dsl

import com.jetbrains.ide.model.uiautomation.*
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.ui.bedsl.dsl.util.BeControlSizes


class TabBuilder(private val control: BeTabbedControl, private val lifetime: Lifetime) {
  fun tab(name: String, content: () -> BeControl) {
    val grid = verticalGrid {}
    val tab = BeTab(label(name), grid).apply {
      beInit()
    }
    val lt = lifetime.createNested()
    val index = control.tabs.count()
    var loaded = false
    control.selectedIndex.advise(lt)
    {
      if (it != index || loaded) return@advise
      grid.setElement(content())
      loaded = true
    }
    control.tabs.add(tab)
    //todo:advise remove?
  }
}

fun tabbedControl(lifetime: Lifetime, init: TabBuilder.() -> Unit): BeTabbedControl {
  return BeTabbedControl().apply {
    beInit()
    val tabBuilder = TabBuilder(this, lifetime)
    tabBuilder.init()
    selectedIndex.set(0)
  }
}

/*public fun tab(content: ()-> BeControl
){

}
public fun splitControl() : BeSplitControl{
    val control = BeSplitControl()
    control.beInit()
    return control
}*/

fun scrollablePanel(
  size: BeControlSize? = null,
  scrollbarPolicy: BeScrollbarPolicy = BeScrollbarPolicy.NONE,
  content: () -> BeControl
): BeScrollablePanel = BeScrollablePanel(scrollbarPolicy, size ?: BeControlSizes.getDefaultSize(), content()).apply {
  beInit()
}

fun border(
  showBorders: BeShowBorders = BeShowBorders.All,
  content: () -> BeControl
): BeBorder = BeBorder(showBorders, content()).apply {
  beInit()
}