package com.jetbrains.rd.ui.bedsl.demo

import com.intellij.openapi.project.Project
import com.jetbrains.ide.model.uiautomation.BeControl
import com.jetbrains.ide.model.uiautomation.BeSizingType
import com.jetbrains.rd.ui.bedsl.button
import com.jetbrains.rd.ui.bedsl.buttonWithDialog
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.ui.bedsl.dsl.*
import com.jetbrains.rd.ui.bedsl.link
import java.awt.Color

class DemoButtonsTab(private val model: DemoUITestModel, private val project: Project) {
  fun content(lifetime: Lifetime): BeControl {
    return verticalGrid {
      row { button("Button _with text", lifetime) {} }
      row { spacer() } //todo: button with icon only
      row { spacer() } //todo: button with text+icon
      row { link("Link!", lifetime) {} } //todo: may be change to separate control

      row {
        buttonWithDialog("Button with dialog", lifetime, project) {
          dialog("Dialog from button", "DemoDsl.Dialog") {

              verticalGrid {
                row {
                  horizontalGrid {
                    column(BeSizingType.Fill) { header("Libraries and assemlies") }
                    //column{ }
                  }
                }
                row(BeSizingType.Fill) {
                list(model.MultiSelectionTableElements, lifetime) { lt, e, p ->

                  horizontalGrid {
                    column(BeSizingType.Fill) {
                      verticalGrid {
                        row { label(e.name) }
                        row { label(e.path) }
                      }
                    }
                    if (model.MultiSelectionTableElements.indexOf(e) == 1)
                      column { arrow(Color.LIGHT_GRAY, Color.LIGHT_GRAY, "20", "") }
                  }
                }
              }
            }
          }
            .withCustomButton("Custom", lifetime)
            .withOKButton(lifetime)
            .withCancelButton(lifetime)
            .withCustomFooter(horizontalGrid {
              column(BeSizingType.Fill) { spacer() }
              column { label("Toolbox changes:  Add 1     Remove 4")}})
        }
      }

    }
  }

}
