package com.jetbrains.rd.ui.bedsl.demo

import com.jetbrains.ide.model.uiautomation.BeControl
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.util.reactive.Property
import com.jetbrains.rd.ui.bedsl.dsl.*
import com.jetbrains.rd.ui.bedsl.extensions.bind


class DemoEditableControlsTab(private val model: DemoUITestModel) {
  fun content(lifetime: Lifetime): BeControl {
    val selectionProperty = Property(true)
    val readOnlyProperty = Property(false)
    return verticalGrid {
      row { radioGroup("Make all controls below ", "Enabled", "Disabled", selectionProperty, lifetime) }
      row {
        verticalGrid("auto,*") {
          newRowChild {

            description("Try to type 'name':", lifetime) {
              textBox(model.StringProperty, lifetime).apply {
                selectionProperty.bind(lifetime, this.enabled)
                readOnlyProperty.bind(lifetime, this.settings.readonly)
              }/*.withValidationRule(
                lifetime,
                { it: String -> it.isEmpty() },
                "Text should not be empty"
              ) *///todo: moar validation, completion
            }
          }
          newRowChild {
            description("This is readonly text box:", lifetime) {
              textBox(model.StringProperty, lifetime, true).apply {
                selectionProperty.bind(lifetime, this.enabled)
              }
            }
          }
          newRowChild {
            description("Spinner control:", lifetime) {
              spinner().apply {
                selectionProperty.bind(lifetime, this.enabled)
              }
            }
          }
          newRowChild {
            description("Path selector:", lifetime) {
              pathSelector(model.StringProperty, lifetime).apply {
                selectionProperty.bind(lifetime, this.enabled)
              }
            }
          }
        }
      }
    }
  }
}
