package com.jetbrains.rd.ui.bedsl.demo

import com.jetbrains.ide.model.uiautomation.BeControl
import com.jetbrains.ide.model.uiautomation.BeFontSize
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.util.reactive.Property
import com.jetbrains.rd.ui.bedsl.dsl.*
import com.jetbrains.rd.ui.bedsl.extensions.bind

class DemoLabelsTab(private val model: DemoUITestModel) {

  fun content(lifetime: Lifetime): BeControl {
    return scrollablePanel { //todo:becontrolsizes : FitToContent, Large + Vertical policy
      verticalGrid {
        val selectionProperty = Property(true)
        row { spacer() } //todo: multiline label
        row { header("Below are options of labels (and this is header btw :)") }
        row { radioGroup("Make all controls below ", "Enabled", "Disabled", selectionProperty, lifetime) }
        row { //todo:icon in label
          label("This label has icon but no _shortcut and its text shouldn't be wrapped")
            .apply {
              selectionProperty.bind(lifetime, this.enabled)
            } //labelWithoutWrap
        }
        row {
          labelWithShortcut(
            "This is label with ${model.LongText} text with _shortcut and its text will be wrapped",
            wrapText = true
          ).apply {
            selectionProperty.bind(lifetime, this.enabled)
          } //label with wrap
        }
        row {
          labelWithShortcut("This is label with double underscore __shortcut and text is not wrapped also")
            .apply {
              selectionProperty.bind(lifetime, this.enabled)
            } //label with double underscore
        }
        row {
          labelWithShortcut("This is label with \\n text: \n \r\nMy message \r\n \n \r\n is this.\n \n \r\n")
            .apply {
              selectionProperty.bind(lifetime, this.enabled)
            } //label with line break
        }
        row {
          label("this is label with smaller text")
            .withCustomTextSize(BeFontSize.SMALLER)
            .apply {
              selectionProperty.bind(lifetime, this.enabled)
            } //label with smaller size
        }
        
        row { spacer() } //todo:label with changing text (and radioButton for changing)
        row { spacer() } //todo:rich text with changing text
        row { spacer() } //todo:be rich text
        row { spacer() } //todo:be rich text with smaller text
        row { spacer() } //todo:be rich text with wrap and icon
      }
    }
  }
}