package com.jetbrains.rd.ui.bedsl.demo

import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.util.reactive.Property
import com.jetbrains.rd.util.reactive.ViewableList
import com.jetbrains.rd.ui.bedsl.dsl.util.Description

enum class DemoEnum {
  @Description("One")
  ONE,

  @Description("Two")
  TWO,

  @Description("Three")
  THREE
}

class DemoUITestModel(lifetime: Lifetime) {
  val SingleSelectionTableElement: Property<DemoTestElement?> = Property(null)
  val EnumProperty = Property<DemoEnum>(DemoEnum.ONE)
  val IntProperty = Property<Int>(0)
  val BoolQProperty = Property<Boolean?>(false)
  val BoolProperty = Property<Boolean>(false)
  val StringProperty = Property<String>("")
  val LongText: String = "long long long long long long long long long long long long long" +
                         " long long long long long long long long long long long long " +
                         "long long long long long long long long long long long long"
  val SingleSelectionTableElements: MutableList<DemoTestElement> = mutableListOf(
    DemoTestElement("first", 0),
    DemoTestElement("second", 1),
    DemoTestElement("third", 2))
  val ViewableSingleSelectionTableElements: ViewableList<DemoTestElement> = ViewableList(SingleSelectionTableElements)

  val MultiSelectionTableElements: MutableList<DemoTestElement> = mutableListOf(
    DemoTestElement("first", 0, "Global"),
    DemoTestElement("second", 1, "C:\\work\\dotnet-products4\\Rider\\ultimate\\platform\\rdclient\\src\\com\\jetbrains\rdclient\\ui"),
    DemoTestElement("third", 2, "Somewhere else"))

  val TreeTableElements: MutableList<DemoTestElement> = mutableListOf()
}

open class DemoTestElement(val name: String, val index: Int, val path:String = "", initChildren: Boolean = true) {
  val children: MutableList<DemoAnotherTestElement> = if (initChildren)
    mutableListOf(
      DemoAnotherTestElement("first child", 0),
      DemoAnotherTestElement("second child", 1),
      DemoAnotherTestElement("third child", 2))
  else mutableListOf()
}

class DemoAnotherTestElement(name: String, index: Int) : DemoTestElement(name, index, "", false)
