package com.jetbrains.rd.ui.bedsl.extensions

import com.jetbrains.ide.model.uiautomation.*
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.util.reactive.hasValue

/*
fun BeControl.getBeOkCancelDialog(lifetime : Lifetime, ok : () -> Unit, cancel: ()->Unit, modality: DialogModality, title : String = "") : BeDialog
{
    val okButton =  BeButton("OK".getBeLabel(lifetime))
    okButton.action.click.advise(lifetime, {ok()})
    okButton.enabled.set(true)
    val cancelButton =  BeButton("Cancel".getBeLabel(lifetime))
    cancelButton.click.advise(lifetime, { cancel()})
    cancelButton.enabled.set(true)
    val dialog =  BeDialog(this, modality, title, listOf(cancelButton, okButton), BeDialogSizeFitToContent(), BeScrollbarPolicy(true, true))
    return dialog
}*/


fun String.getBeLabelWithShortCut(lifetime: Lifetime? = null, capitalize: Boolean = true): BeRichText {
  var description = this
  description = description.replaceFirst("_", "")
  if (capitalize)
    description = description.capitalize()
  val label = BeRichText(false)


  var localtextChangeCookie = false
  if (lifetime != null) {
    label.text.change.advise(lifetime
    ) {
      if (localtextChangeCookie) return@advise
      localtextChangeCookie = true

      /* shortcut = getShortcut(s)
          label.shortcut.set(shortcut)*/

      localtextChangeCookie = false
    }
  }

  label.visible.set(ControlVisibility.Visible)
  return label
}


fun BeGrid.addElement(control: BeControl, size: BeSizingType = BeSizingType.Fit): BeGrid {

  val rdUnitSize = BeUnitSize(size, 1)
  val elements = mutableListOf(BeGridElement(control, rdUnitSize))
  val rdGridElements = if (this.items.hasValue)
    this.items.valueOrNull?.toMutableList() ?: mutableListOf()
  else mutableListOf()
  rdGridElements.addAll(elements)

  this.items.set(rdGridElements)
  return this
}

private fun getShortcut(description: String): Char {
  val shortcutIndex = description.indexOf('_')
  var shortcut = ' '

  if (shortcutIndex >= 0 && shortcutIndex < description.length) {
    shortcut = description[shortcutIndex + 1]
  }

  return shortcut
}

fun String.getBeLabel(lifetime: Lifetime? = null): BeRichText {
  return this.getBeLabelWithShortCut(lifetime, false)
}

/*
fun  IOptProperty<String>.getBePathSelector(lifetime : Lifetime, initialValues : List<String>, id: String = "") : BeControl
{
    val grid = BeGrid(GridOrientation.Horizontal)
    val comboBox = this.getBeComboBox(initialValues, lifetime, true, id)
    //todo: change button presentation
    val bePathSelectionButton = BePathSelectionButton(PathChooser.File, "...".getBeLabel(lifetime))
    bePathSelectionButton.selectedPath.advise(lifetime, {v ->   comboBox.selectedValue.set(v)})
    //grid.addElement(comboBox, "*").addElement(bePathSelectionButton)
    return grid
}


public fun  IDeclaredElement.getBeLabelFromDeclaredElement( this IDeclaredElement declaredElement, Lifetime lifetime, bool enabled = true) : BeLabel
{
    var solution = declaredElement.getPsiServices().Solution
    var icon = solution.getComponent<PsiIconManager>().getImage(declaredElement, declaredElement.PresentationLanguage, true)
    var list =  List<BeControl>()

    var overridableMember = declaredElement as IOverridableMember
    if (overridableMember != null)
    {
        var image = MemberPresentationUtil.getImage(overridableMember)
        if (image != null) list.Add(image.getBeIcon())
    }

    var presenter =  DeclaredElementPresenterStyle
        {
            LengthLimit = 60,
            ShowName = NameStyle.SHORT,
            ShowParameterTypes = true,
            ShowType = TypeStyle.AFTER
        }

    var text = DeclaredElementPresenter.Format(declaredElement.PresentationLanguage, presenter, declaredElement)
    var label = text.getBeLabel(lifetime, icon)
    list.Add(label)
    return label
}

public fun BeControl getBeCheckBoxFromTreeNode([NotNull] this ITreeNode treeNode, Lifetime lifetime, IProperty<bool?> isChecked,
IconId iconId = null, bool enabled = true)
{
    var icon = iconId ?? CommonThemedIcons.Clr.Id
    var checkBox =  BeCheckbox(treeNode.getText().getBeLabel(lifetime, icon))
    checkBox.IsThreeState.value = true
    checkBox.Enabled.value = enabled
    isChecked.Bind(lifetime, checkBox.Property)
    return checkBox
}*/
