package com.jetbrains.rd.ui.bedsl.dsl.util

class BeLocalCookie {
  private var CanExecute = false

  init {
    CanExecute = true
  }

  private fun Start(): Boolean {
    if (!CanExecute) return false
    CanExecute = false
    return true
  }

  private fun End() {
    CanExecute = true
  }


  fun Execute(action: () -> Unit) {
    if (!Start()) return
    action()
    End()
  }

  private class Cookie(private val myLocalCookie: BeLocalCookie) {
    fun Dispose() {
      myLocalCookie.End()
    }
  }

  fun <T> Execute(action: () -> T?, defaultValue: T?): T? {
    if (!Start()) return defaultValue
    val cookie = Cookie(this)
    val result = action()
    cookie.Dispose()
    return result
  }
}



