package com.jetbrains.rd.ui.bedsl.dsl.util

import com.jetbrains.ide.model.uiautomation.BeCommonBehavior

annotation class Description(val description: String)
annotation class CommonBehavior(val behavior: BeCommonBehavior)


inline fun <reified T : Annotation, reified E : Enum<E>> Enum<E>.getAnnotation(): T? {
  return E::class.java.getField(this.name).annotations.filterIsInstance<T>().firstOrNull()
}