// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable

import com.intellij.openapi.actionSystem.ActionGroup
import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.KeyboardShortcut
import com.intellij.openapi.components.ServiceManager
import com.intellij.openapi.project.Project

open class BeActionSupport {
  open fun getBackendActionGroup(backendGroupId: String): AnAction? {
    return null
  }

  open fun tryFindBackendAction(backendGroupId: String, backendActionId: String): AnAction? {
    return null
  }

  open fun createBackendActionGroup(resharperMenuGroupId: String): ActionGroup? {
    return null
  }

  open fun getShortcut(action: AnAction): KeyboardShortcut? {
    return null
  }

  companion object {
    fun getInstance(project: Project): BeActionSupport = ServiceManager.getService(project, BeActionSupport::class.java)
  }
}
