// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable

import com.intellij.openapi.actionSystem.DataContext
import com.jetbrains.rd.actions.RdDataConstantProvider
import com.jetbrains.rd.ide.model.RdDataConstant

class BeControlsConstantProvider : RdDataConstantProvider {
  companion object {
    const val dataId = "BECONTROLS_CONSTANTS"
  }

  override fun getDataConstants(dataContext: DataContext): List<RdDataConstant> {
    @Suppress("UNCHECKED_CAST")
    return dataContext.getData(dataId) as? List<RdDataConstant> ?: return emptyList()
  }
}