// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable.views

//import com.intellij.util.ui.AnimatedIcon
import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.project.Project
import com.intellij.util.ui.AsyncProcessIcon
import com.jetbrains.ide.model.uiautomation.BeAnimatedIcon
import com.jetbrains.ide.model.uiautomation.ControlVisibility
import com.jetbrains.ide.model.uiautomation.PredefinedType
import com.jetbrains.rd.ui.bindable.ViewBinder
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.ui.ComponentActionWrapper
import com.jetbrains.rd.ui.RdUiBundle
import com.jetbrains.rd.ui.bindable.views.listControl.IActionOwner
import javax.swing.JComponent
import javax.swing.JLabel

class AnimatedIconViewControl(private val project: Project) : ViewBinder<BeAnimatedIcon>,
                                                              //IRendererOwner<BeAnimatedIcon>,
                                                              IActionOwner<BeAnimatedIcon> {
  override fun getAction(lifetime: Lifetime, viewModel: BeAnimatedIcon): AnAction =
    ComponentActionWrapper { bind(viewModel, lifetime) }

  //override fun getRenderer(viewModel: BeButton): ITreeGridRenderer<BeAnimatedIcon> = BeButtonRenderer(project)

  override fun bind(viewModel: BeAnimatedIcon, lifetime: Lifetime): JComponent {
    when (viewModel.predefinedType) {
      PredefinedType.DEFAULT -> return JLabel(RdUiBundle.message("becontrols.async.icons.only")) //AnimatedIcon.Default.INSTANCE/*AnimatedIcon()*/
      PredefinedType.PROCESS_ICON -> return AsyncProcessIcon(viewModel.text).apply {
        viewModel.visible.advise(lifetime) {
          this.isVisible = it == ControlVisibility.Visible
          //result.repaint()
        }
      }
    }
  }

 /* private fun tryGetRealAction(lifetime: Lifetime, viewModel: BeButton): AnAction? {
    if (viewModel.style == BeButtonStyle.NO_BORDER) return null
    if (viewModel.content.shouldBeWrappedIntoHtml) return null
    if (viewModel.content is BeRichText) return null

    val action = object : DumbAwareAction() {
      override fun actionPerformed(e: AnActionEvent) = viewModel.action.click.fire()

      override fun displayTextInToolbar(): Boolean = viewModel.style != BeButtonStyle.ICON && viewModel.style != BeButtonStyle.HYBRID && viewModel.style != BeButtonStyle.HYBRID_TEXT_ONLY

      override fun update(e: AnActionEvent) = viewModel.updateActionEvent(e, project)
    }
    viewModel.prepareActionWithUpdate(lifetime) { update(action) }
    return action
  }
  }*/
}


