package com.jetbrains.rd.ui.bindable.views

import com.intellij.openapi.actionSystem.*
import com.intellij.openapi.actionSystem.impl.ActionButton
import com.intellij.openapi.project.Project
import com.jetbrains.ide.model.uiautomation.BeBackendIdeAction
import com.jetbrains.rd.actions.ActionProvider
import com.jetbrains.rd.ide.model.ActionModel
import com.jetbrains.rd.ide.model.ActionRegistrationModel
import com.jetbrains.rd.ui.bindable.ViewBinder
import com.jetbrains.rd.ui.bindable.views.listControl.IActionOwner
import com.jetbrains.rd.ui.icons.toIdeaIcon
import com.jetbrains.rd.util.lifetime.Lifetime
import javax.swing.JComponent

class BackendIdeActionViewControl(private val project: Project) : ViewBinder<BeBackendIdeAction>, IActionOwner<BeBackendIdeAction> {
  override fun getAction(lifetime: Lifetime, viewModel: BeBackendIdeAction): AnAction {
    val action = getAction(viewModel)
   return action
  }

  private fun getAction(actionModel:BeBackendIdeAction) = ActionProvider.EP_NAME.extensions.mapNotNull { provider ->
    actionModel.presentation?.let{provider.getAction(it, project)} ?: provider.getAction(actionModel.actionId, null)
  }.firstOrNull() ?: EmptyAction.createEmptyAction("Action Unavailable", null, false)

  override fun bind(viewModel: BeBackendIdeAction, lifetime: Lifetime): JComponent {
    val action = getAction(lifetime, viewModel)
    return ActionButton(action, action.templatePresentation, ActionPlaces.UNKNOWN, ActionToolbar.DEFAULT_MINIMUM_BUTTON_SIZE)
  }
}
