// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable.views

import com.intellij.openapi.project.Project
import com.jetbrains.ide.model.uiautomation.BeGrid
import com.jetbrains.ide.model.uiautomation.BeGroupBox
import com.jetbrains.ide.model.uiautomation.BeSizingType
import com.jetbrains.ide.model.uiautomation.GridOrientation
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.ui.bindable.ViewBinder
import com.jetbrains.rd.ui.bindable.ViewRegistry
import com.jetbrains.rd.ui.bedsl.extensions.addElement
import javax.swing.BorderFactory
import javax.swing.JComponent

class GroupBoxViewControl(private val project: Project) : ViewBinder<BeGroupBox> {
  override fun bind(viewModel: BeGroupBox, lifetime: Lifetime): JComponent {
    return ViewRegistry.getInstance(project).getView(
      BeGrid(GridOrientation.Horizontal).apply { addElement(viewModel.content, BeSizingType.Fill) }, lifetime)
      .apply { border = BorderFactory.createTitledBorder(viewModel.title) }
  }
}