// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable.views

import com.intellij.openapi.project.Project
import com.jetbrains.ide.model.uiautomation.BeTextBox
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.ui.bindable.ViewBinder
import com.jetbrains.rd.ui.bindable.views.customControls.TextBoxControlJb
import com.jetbrains.rd.ui.bindable.views.listControl.IRendererOwner
import com.jetbrains.rd.ui.bindable.views.listControl.ITreeGridRenderer
import com.jetbrains.rd.ui.bindable.views.listControl.renderers.BeTextBoxRenderer
import javax.swing.JComponent

/**
 * @author Nikolay.Kuznetsov
 */
class TextBoxViewControl(private val project: Project) : ViewBinder<BeTextBox>, IRendererOwner<BeTextBox> {

  override fun bind(viewModel: BeTextBox, lifetime: Lifetime): JComponent = TextBoxControlJb(lifetime, viewModel, project)

  override fun getRenderer(viewModel: BeTextBox): ITreeGridRenderer<BeTextBox> = BeTextBoxRenderer(project)
}

