// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable.views.customControls

import com.intellij.ui.components.JBLabel
import com.jetbrains.rd.util.reactive.Property
import java.awt.event.MouseAdapter
import java.awt.event.MouseEvent

class IconToggleButton : JBLabel() {
  val isChecked = Property(false)

  init {
    addMouseListener(object : MouseAdapter() {
      override fun mousePressed(e: MouseEvent?) {
        isChecked.value = !isChecked.value
      }
    })
  }
}