// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable.views.customControls

import com.intellij.ui.Gray
import com.intellij.ui.JBColor
import com.intellij.util.ui.JBUI
import java.awt.GridBagConstraints
import java.awt.GridBagLayout
import java.awt.Insets
import javax.swing.JPanel
import javax.swing.JSeparator
import javax.swing.SwingConstants

class SimpleSeparator : JPanel() {
  private val mySeparator = JSeparator(SwingConstants.HORIZONTAL)

  init {
    mySeparator.foreground = JBColor.namedColor(
      "Group.separatorColor",
      JBColor(
        Gray.xCD,
        Gray.x51
      )
    )
    layout = GridBagLayout()
    add(
      mySeparator,
      GridBagConstraints(
        0,
        0,
        GridBagConstraints.REMAINDER,
        1,
        1.0,
        1.0,
        GridBagConstraints.CENTER,
        GridBagConstraints.HORIZONTAL,
        Insets(2, 0, 0, 0),
        0,
        0
      )
    )
    mySeparator.isOpaque = false
    isOpaque = false
    border = JBUI.Borders.empty(7, 0, 5, 0)
  }
}