// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable.views.listControl

import com.jetbrains.ide.model.uiautomation.BeControl
import com.jetbrains.rd.util.lifetime.Lifetime
import javax.swing.JComponent

interface ITreeGridRenderer<in U> where U : BeControl {
  fun isEditable(): Boolean

  fun containsEditor(model: U): Boolean

  fun reset(
    component: JComponent?,
    value: U,
    settings: RdCellSettings
  ): JComponent?

  fun addUpdate(element: U, lifetime: Lifetime, update: () -> Unit) {}

  fun resetCounter() {}
}

data class RdCellSettings(val isEnabled: Boolean, val isSelected: Boolean, val hasFocus: Boolean,
                          val isEditor: Boolean, val applyHighlighting: Boolean = false)