// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable.views.listControl

import javax.swing.event.TableModelEvent


fun TableModelEvent.toLog(): String {
  val type = when (this.type) {
    TableModelEvent.INSERT -> "INSERT"
    TableModelEvent.DELETE -> "DELETE"
    TableModelEvent.UPDATE -> "UPDATE"
    else -> "unknown"
  }
  return "firstRow: ${row(this.firstRow)} lastRow: ${row(
    this.lastRow
  )} column: ${column(this.column)} type $type"
}

private fun row(row: Int) = if (row == TableModelEvent.HEADER_ROW) "HEADER" else row.toString()
private fun column(column: Int) = if (column == TableModelEvent.ALL_COLUMNS) "ALL_COLUMNS" else column.toString()
