// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable.views.listControl

import com.jetbrains.ide.model.uiautomation.BeTreeGridLine
import com.jetbrains.rd.util.lifetime.LifetimeDefinition
import com.jetbrains.rd.ui.bedsl.extensions.contentToString
import javax.swing.tree.DefaultMutableTreeNode

fun DefaultMutableTreeNode.treeGridUserObject(): TreeGridUserObject {
  return this.userObject as TreeGridUserObject
}

class TreeGridUserObject(val lifetimeDef: LifetimeDefinition, val line: BeTreeGridLine) {
  override fun toString(): String {
    return line.contentToString(" ", "")
  }

  fun toLog(): String {
    return "${toString()} (${line.propsToLog()})"
  }

  override fun equals(other: Any?): Boolean {
    if (this === other) return true
    if (javaClass != other?.javaClass) return false

    other as TreeGridUserObject

    if (line != other.line) return false

    return true
  }

  override fun hashCode(): Int {
    return line.hashCode()
  }

}