// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable.views.listControl.renderers

import com.intellij.openapi.project.Project
import com.jetbrains.ide.model.uiautomation.BeComboBox
import com.jetbrains.rd.ui.bindable.views.listControl.RdCellSettings
import com.jetbrains.rd.ui.bindable.views.listControl.renderers.popupControls.ComboBoxViewControlInRenderer
import javax.swing.JComponent
import javax.swing.JTable


class BeComboRenderer(private val project: Project) : RdMultiRenderer<ComboBoxViewControlInRenderer, BeComboBox>() {
  override fun isEditable(): Boolean = true
  override fun containsEditor(model: BeComboBox) = true

  var clickCount = 0
  override fun getNewInstance(isEditor: Boolean, model: BeComboBox): ComboBoxViewControlInRenderer {
    return ComboBoxViewControlInRenderer(project, model)
  }

  override fun reset(
    component: JComponent?,
    value: BeComboBox,
    settings: RdCellSettings
  ): ComboBoxViewControlInRenderer {
    val combo = getElement(settings.isEditor, value)
    combo.isEnabled = value.enabled.value
    if (settings.isEditor)
      clickCount++
    combo.init(value, component as? JTable, clickCount, settings)
    return combo
  }

  override fun resetCounter() {
    super.resetCounter()
    clickCount = 0
  }
}


