// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable.views.listControl.renderers

import com.intellij.openapi.project.Project
import com.intellij.ui.SimpleColoredComponent
import com.jetbrains.ide.model.uiautomation.BeIcon
import com.jetbrains.rd.ui.icons.RdIconHost
import com.jetbrains.rd.ui.bindable.views.listControl.RdCellSettings
import com.jetbrains.rd.ui.bindable.views.utils.BeComponents
import javax.swing.JComponent

class BeIconRenderer(private val project: Project) : RdMultiRenderer<SimpleColoredComponent, BeIcon>() {
  override fun isEditable(): Boolean = false
  override fun containsEditor(model: BeIcon) = false

  override fun getNewInstance(isEditor: Boolean, model: BeIcon): SimpleColoredComponent = BeComponents.getNewSCCInstance(false)

  override fun reset(
    component: JComponent?,
    value: BeIcon,
    settings: RdCellSettings
  ): SimpleColoredComponent {
    return getElement(settings.isEditor, value).apply {
      BeLabelRenderer.resetLabel(this, null, value.icon.valueOrNull, settings, RdIconHost.getInstance(project), null, value.tooltip.value)
    }
  }
}