package com.jetbrains.rd.ui.bindable.views.utils

import com.intellij.openapi.project.Project
import com.jetbrains.ide.model.uiautomation.BeControl
import com.jetbrains.rd.ui.bindable.getView
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.util.reactive.IPropertyBase
import java.awt.BorderLayout
import javax.swing.JComponent
import javax.swing.JPanel

open class BeControlHost(
  private val project: Project
) : JPanel(BorderLayout()) {

  fun bind(lifetime: Lifetime, property: IPropertyBase<BeControl?>, update: (() -> Unit)? = null) {
    property.view(lifetime) { lt, control ->
      removeAll()
      if (control != null) {
        val view = control.getView(lt, project)
        add(view, BorderLayout.CENTER)
        update?.invoke()
      }
      rootPane?.revalidate()
      repaint()
    }
  }

  fun <T> bind(lifetime: Lifetime, property: IPropertyBase<T>, getControl: (T) -> BeControl, update: (() -> Unit)? = null) {
    property.view(lifetime) { lt, value ->
      removeAll()
      if (value != null) {
        val view = getControl(value).getView(lt, project)
        add(view, BorderLayout.CENTER)
        update?.invoke()
      }
      rootPane?.revalidate()
      repaint()
    }
  }

  fun <T> bind(lifetime: Lifetime, property: IPropertyBase<T>, getView: (T) -> JComponent) {
    property.view(lifetime) { lt, value ->
      removeAll()
      if (value != null) {
        val view = getView(value)
        add(view, BorderLayout.CENTER)
      }
      rootPane?.revalidate()
      repaint()
    }
  }
}