// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.bindable.views.utils

import com.intellij.openapi.wm.IdeFocusManager
import java.awt.event.FocusEvent
import java.awt.event.FocusListener
import javax.swing.JComponent

class PassFocusThroughTo(private val component: JComponent) : FocusListener {
  override fun focusLost(e: FocusEvent?) {}

  override fun focusGained(e: FocusEvent?) {
    IdeFocusManager.getGlobalInstance()
      .doWhenFocusSettlesDown {
        IdeFocusManager.getGlobalInstance().requestFocus(component, true)
      }
  }
}