// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.icons

import com.intellij.util.ui.ColorIcon
import com.intellij.util.ui.JBUI
import com.jetbrains.rd.ide.model.ColorIconModel
import java.awt.Color
import javax.swing.Icon

/**
 * @author Nikolay.Kuznetsov
 */
class ColorIconWrapper(val iconNode: ColorIconModel) : IconWrapper {
  override fun createIcon(): Icon {
    return ColorIcon(JBUI.scale(16), JBUI.scale(13), iconNode.color.run { Color(red, green, blue, alpha) }, false)
  }
}