// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.icons

import com.intellij.util.ui.ColorizeProxyIcon
import com.jetbrains.rd.ide.model.ColorizedIconModel
import java.awt.Color
import javax.swing.Icon

class ColorizedIconWrapper(val model: ColorizedIconModel, iconHost: RdIconHost) : IconWrapper {
  private val myBase = iconHost.createWrapper(model.base).createIcon()

  override fun createIcon(): Icon {
    val color = model.color.run { Color(red, green, blue, alpha) }
    return ColorizeProxyIcon.Simple(myBase, color)
  }
}