// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.icons

import com.intellij.ui.LayeredIcon
import com.jetbrains.rd.ide.model.CompositionIconModel
import javax.swing.Icon

class CompositionIconWrapper(iconNode: CompositionIconModel, iconHost: RdIconHost) : IconWrapper {
  private val myChildren = iconNode.subNodes.map { iconHost.createWrapper(it).createIcon() }

  override fun createIcon(): Icon {
    val layeredIcon = LayeredIcon(myChildren.size)
    for (i in 0..myChildren.size - 1) {
      layeredIcon.setIcon(myChildren[i], i)
    }

    return layeredIcon
  }
}