// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.icons

import com.intellij.icons.AllIcons
import com.intellij.openapi.util.IconLoader
import com.intellij.util.ui.UIUtil
import com.jetbrains.rd.ide.model.ImageIconModel
import javax.swing.Icon

class ImageIconWrapper(private val modelIconNode: ImageIconModel, val iconHost: RdIconHost) : IconWrapper {
  override fun createIcon(): Icon {
    val path = modelIconNode.wrapper.path
    // todo class loaders
    val icon = IconLoader.findIcon(path, AllIcons::class.java, false, false)
    if (icon != null) {
      return icon
    }

    return iconHost.imageIconCache.getOrPut(modelIconNode.wrapper.identity) {
      val sources = modelIconNode.wrapper.sources
      ProtocolCachedImageIcon(path, UIUtil.isUnderDarcula(), sources)
    }
  }
}