// Copyright 2000-2021 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rd.ui.icons

import com.intellij.ui.RowIcon
import com.jetbrains.rd.ide.model.RowIconModel
import javax.swing.Icon

class RowIconWrapper(iconNode: RowIconModel, iconHost: RdIconHost) : IconWrapper {
  private val myChildren = iconNode.subNodes.map { iconHost.createWrapper(it).createIcon() }

  override fun createIcon(): Icon = RowIcon(*myChildren.toTypedArray())
}
