package com.jetbrains.rdserver.unattendedHost

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.ide.CopyPasteManager
import com.intellij.openapi.project.DumbAware
import com.intellij.util.ui.TextTransferable
import com.jetbrains.rd.platform.util.withFragment
import com.jetbrains.rdserver.joinLinks.RdServerJoinLinkManager

class CopyUnattendedJoinLinkInternalAction : AnAction("Copy unattended controller join link"), DumbAware {
  override fun update(e: AnActionEvent) {
    e.presentation.isEnabled = e.project != null && UnattendedHostManager.getInstance().isUnattendedMode
  }

  override fun actionPerformed(e: AnActionEvent) {
    val project = e.project ?: return

    val linkManager = RdServerJoinLinkManager.getInstance(project)
    linkManager.getJoinLink().thenApply {
      val singleUseToken = UnattendedHostProjectService.getInstance(project).createSingleUseConnectionToken()
      val fullLink = it.withFragment(it.fragment + "&jt=$singleUseToken")

      CopyPasteManager.getInstance().setContents(TextTransferable(fullLink.toString() as String?))
    }
  }
}