package com.jetbrains.rdserver.unattendedHost

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.project.DumbAware

class ToggleUnattendedModeInternalAction : AnAction("Toggle unattended host mode"), DumbAware {
  override fun update(e: AnActionEvent) {
    if (UnattendedHostManager.getInstance().isUnattendedMode)
      e.presentation.text = "Disable unattended host mode (internal)"
    else
      e.presentation.text = "Enable unattended host mode (internal)"
  }

  override fun actionPerformed(e: AnActionEvent) {
    val manager = UnattendedHostManager.getInstance()
    if (manager.isUnattendedMode)
      manager.exitUnattendedMode()
    else
      manager.setUnattendedMode()
  }
}