@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [ActionsModel.kt]
 */
class ActionsModel private constructor(
    private val _execute: RdProperty<ActionExecuteRequest?>,
    private val _update: RdCall<ActionUpdateRequest, PresentationModel?>,
    private val _escapeAvailability: RdOptionalProperty<Boolean>,
    private val _copyOrCutHandler: RdSignal<ClipboardHandlerRequest>,
    private val _dotMemoryUnitAvailability: RdOptionalProperty<Boolean>,
    private val _transferredActionGroups: RdMap<String, ActionDescriptionBaseModel>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(TextControlConstant)
            serializers.register(ClipboardTextConstant)
            serializers.register(SelectedItemsConstant)
            serializers.register(RdFileStructureConstant)
            serializers.register(ActionExecuteSyncHandshake)
            serializers.register(ActionExecuteRequest)
            serializers.register(PresentationModel)
            serializers.register(ActionUpdateRequest)
            serializers.register(ActionSeparatorModel)
            serializers.register(ActionDescriptionModel)
            serializers.register(ActionDescriptionActionGroup)
            serializers.register(ClipboardHandlerRequest)
            serializers.register(RdDataConstant_Unknown)
            serializers.register(ActionDescriptionBaseModel_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): ActionsModel  {
            IdeRoot.register(protocol.serializers)
            
            return ActionsModel().apply {
                identify(protocol.identity, RdId.Null.mix("ActionsModel"))
                bind(lifetime, protocol, "ActionsModel")
            }
        }
        
        private val __ActionExecuteRequestNullableSerializer = ActionExecuteRequest.nullable()
        private val __PresentationModelNullableSerializer = PresentationModel.nullable()
        
        const val serializationHash = 3331693950699832695L
        
    }
    override val serializersOwner: ISerializersOwner get() = ActionsModel
    override val serializationHash: Long get() = ActionsModel.serializationHash
    
    //fields
    val execute: IProperty<ActionExecuteRequest?> get() = _execute
    val update: RdCall<ActionUpdateRequest, PresentationModel?> get() = _update
    val escapeAvailability: IOptProperty<Boolean> get() = _escapeAvailability
    val copyOrCutHandler: ISignal<ClipboardHandlerRequest> get() = _copyOrCutHandler
    val dotMemoryUnitAvailability: IOptProperty<Boolean> get() = _dotMemoryUnitAvailability
    val transferredActionGroups: IMutableViewableMap<String, ActionDescriptionBaseModel> get() = _transferredActionGroups
    //methods
    //initializer
    init {
        _escapeAvailability.optimizeNested = true
        _dotMemoryUnitAvailability.optimizeNested = true
        _transferredActionGroups.optimizeNested = true
    }
    
    init {
        _update.async = true
    }
    
    init {
        bindableChildren.add("execute" to _execute)
        bindableChildren.add("update" to _update)
        bindableChildren.add("escapeAvailability" to _escapeAvailability)
        bindableChildren.add("copyOrCutHandler" to _copyOrCutHandler)
        bindableChildren.add("dotMemoryUnitAvailability" to _dotMemoryUnitAvailability)
        bindableChildren.add("transferredActionGroups" to _transferredActionGroups)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdProperty<ActionExecuteRequest?>(null, __ActionExecuteRequestNullableSerializer),
        RdCall<ActionUpdateRequest, PresentationModel?>(ActionUpdateRequest, __PresentationModelNullableSerializer),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdSignal<ClipboardHandlerRequest>(ClipboardHandlerRequest),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdMap<String, ActionDescriptionBaseModel>(FrameworkMarshallers.String, AbstractPolymorphic(ActionDescriptionBaseModel))
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionsModel (")
        printer.indent {
            print("execute = "); _execute.print(printer); println()
            print("update = "); _update.print(printer); println()
            print("escapeAvailability = "); _escapeAvailability.print(printer); println()
            print("copyOrCutHandler = "); _copyOrCutHandler.print(printer); println()
            print("dotMemoryUnitAvailability = "); _dotMemoryUnitAvailability.print(printer); println()
            print("transferredActionGroups = "); _transferredActionGroups.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ActionsModel   {
        return ActionsModel(
            _execute.deepClonePolymorphic(),
            _update.deepClonePolymorphic(),
            _escapeAvailability.deepClonePolymorphic(),
            _copyOrCutHandler.deepClonePolymorphic(),
            _dotMemoryUnitAvailability.deepClonePolymorphic(),
            _transferredActionGroups.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class ActionDescriptionActionGroup (
    val actionId: String,
    val name: String,
    val description: String,
    val icon: IconModel?,
    val subItems: List<ActionDescriptionBaseModel>,
    val isVisible: Boolean = true
) : ActionDescriptionBaseModel (
) {
    //companion
    
    companion object : IMarshaller<ActionDescriptionActionGroup> {
        override val _type: KClass<ActionDescriptionActionGroup> = ActionDescriptionActionGroup::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionDescriptionActionGroup  {
            val actionId = buffer.readString()
            val name = buffer.readString()
            val description = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val subItems = buffer.readList { ctx.serializers.readPolymorphic<ActionDescriptionBaseModel>(ctx, buffer, ActionDescriptionBaseModel) }
            val isVisible = buffer.readBool()
            return ActionDescriptionActionGroup(actionId, name, description, icon, subItems, isVisible)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionDescriptionActionGroup)  {
            buffer.writeString(value.actionId)
            buffer.writeString(value.name)
            buffer.writeString(value.description)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeList(value.subItems) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            buffer.writeBool(value.isVisible)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ActionDescriptionActionGroup
        
        if (actionId != other.actionId) return false
        if (name != other.name) return false
        if (description != other.description) return false
        if (icon != other.icon) return false
        if (subItems != other.subItems) return false
        if (isVisible != other.isVisible) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + name.hashCode()
        __r = __r*31 + description.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + subItems.hashCode()
        __r = __r*31 + isVisible.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionDescriptionActionGroup (")
        printer.indent {
            print("actionId = "); actionId.print(printer); println()
            print("name = "); name.print(printer); println()
            print("description = "); description.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("subItems = "); subItems.print(printer); println()
            print("isVisible = "); isVisible.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
abstract class ActionDescriptionBaseModel (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<ActionDescriptionBaseModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ActionDescriptionBaseModel  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ActionDescriptionBaseModel_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ActionDescriptionBaseModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ActionDescriptionBaseModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ActionDescriptionBaseModel_Unknown> {
        override val _type: KClass<ActionDescriptionBaseModel_Unknown> = ActionDescriptionBaseModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionDescriptionBaseModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionDescriptionBaseModel_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ActionDescriptionBaseModel_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionDescriptionBaseModel_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class ActionDescriptionModel (
    val actionId: String,
    val name: String,
    val description: String,
    val icon: IconModel?,
    val defaultShortcutText: String
) : ActionDescriptionBaseModel (
) {
    //companion
    
    companion object : IMarshaller<ActionDescriptionModel> {
        override val _type: KClass<ActionDescriptionModel> = ActionDescriptionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionDescriptionModel  {
            val actionId = buffer.readString()
            val name = buffer.readString()
            val description = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val defaultShortcutText = buffer.readString()
            return ActionDescriptionModel(actionId, name, description, icon, defaultShortcutText)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionDescriptionModel)  {
            buffer.writeString(value.actionId)
            buffer.writeString(value.name)
            buffer.writeString(value.description)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeString(value.defaultShortcutText)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ActionDescriptionModel
        
        if (actionId != other.actionId) return false
        if (name != other.name) return false
        if (description != other.description) return false
        if (icon != other.icon) return false
        if (defaultShortcutText != other.defaultShortcutText) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + name.hashCode()
        __r = __r*31 + description.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + defaultShortcutText.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionDescriptionModel (")
        printer.indent {
            print("actionId = "); actionId.print(printer); println()
            print("name = "); name.print(printer); println()
            print("description = "); description.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("defaultShortcutText = "); defaultShortcutText.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class ActionExecuteRequest private constructor(
    val dataContext: List<RdDataConstant>,
    val actionId: String,
    private val _available: RdProperty<Boolean?>,
    private val _handshake: RdProperty<ActionExecuteSyncHandshake?>,
    private val _result: RdProperty<Boolean?>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<ActionExecuteRequest> {
        override val _type: KClass<ActionExecuteRequest> = ActionExecuteRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionExecuteRequest  {
            val _id = RdId.read(buffer)
            val dataContext = buffer.readList { ctx.serializers.readPolymorphic<RdDataConstant>(ctx, buffer, RdDataConstant) }
            val actionId = buffer.readString()
            val _available = RdProperty.read(ctx, buffer, __BoolNullableSerializer)
            val _handshake = RdProperty.read(ctx, buffer, __ActionExecuteSyncHandshakeNullableSerializer)
            val _result = RdProperty.read(ctx, buffer, __BoolNullableSerializer)
            return ActionExecuteRequest(dataContext, actionId, _available, _handshake, _result).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionExecuteRequest)  {
            value.rdid.write(buffer)
            buffer.writeList(value.dataContext) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            buffer.writeString(value.actionId)
            RdProperty.write(ctx, buffer, value._available)
            RdProperty.write(ctx, buffer, value._handshake)
            RdProperty.write(ctx, buffer, value._result)
        }
        
        private val __BoolNullableSerializer = FrameworkMarshallers.Bool.nullable()
        private val __ActionExecuteSyncHandshakeNullableSerializer = ActionExecuteSyncHandshake.nullable()
        
    }
    //fields
    val available: IProperty<Boolean?> get() = _available
    val handshake: IProperty<ActionExecuteSyncHandshake?> get() = _handshake
    val result: IProperty<Boolean?> get() = _result
    //methods
    //initializer
    init {
        _available.optimizeNested = true
        _result.optimizeNested = true
    }
    
    init {
        bindableChildren.add("available" to _available)
        bindableChildren.add("handshake" to _handshake)
        bindableChildren.add("result" to _result)
    }
    
    //secondary constructor
    constructor(
        dataContext: List<RdDataConstant>,
        actionId: String
    ) : this(
        dataContext,
        actionId,
        RdProperty<Boolean?>(null, __BoolNullableSerializer),
        RdProperty<ActionExecuteSyncHandshake?>(null, __ActionExecuteSyncHandshakeNullableSerializer),
        RdProperty<Boolean?>(null, __BoolNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionExecuteRequest (")
        printer.indent {
            print("dataContext = "); dataContext.print(printer); println()
            print("actionId = "); actionId.print(printer); println()
            print("available = "); _available.print(printer); println()
            print("handshake = "); _handshake.print(printer); println()
            print("result = "); _result.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ActionExecuteRequest   {
        return ActionExecuteRequest(
            dataContext,
            actionId,
            _available.deepClonePolymorphic(),
            _handshake.deepClonePolymorphic(),
            _result.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class ActionExecuteSyncHandshake private constructor(
    private val _result: RdSignal<Unit>,
    private val _backendResult: RdSignal<Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<ActionExecuteSyncHandshake> {
        override val _type: KClass<ActionExecuteSyncHandshake> = ActionExecuteSyncHandshake::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionExecuteSyncHandshake  {
            val _id = RdId.read(buffer)
            val _result = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _backendResult = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return ActionExecuteSyncHandshake(_result, _backendResult).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionExecuteSyncHandshake)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._result)
            RdSignal.write(ctx, buffer, value._backendResult)
        }
        
        
    }
    //fields
    val result: ISignal<Unit> get() = _result
    val backendResult: ISignal<Unit> get() = _backendResult
    //methods
    //initializer
    init {
        bindableChildren.add("result" to _result)
        bindableChildren.add("backendResult" to _backendResult)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdSignal<Unit>(FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionExecuteSyncHandshake (")
        printer.indent {
            print("result = "); _result.print(printer); println()
            print("backendResult = "); _backendResult.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ActionExecuteSyncHandshake   {
        return ActionExecuteSyncHandshake(
            _result.deepClonePolymorphic(),
            _backendResult.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class ActionSeparatorModel (
) : ActionDescriptionBaseModel (
) {
    //companion
    
    companion object : IMarshaller<ActionSeparatorModel> {
        override val _type: KClass<ActionSeparatorModel> = ActionSeparatorModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionSeparatorModel  {
            return ActionSeparatorModel()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionSeparatorModel)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ActionSeparatorModel
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionSeparatorModel (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
data class ActionUpdateRequest (
    val place: String,
    val dataContext: List<RdDataConstant>,
    val actionId: String,
    val updateImmediately: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ActionUpdateRequest> {
        override val _type: KClass<ActionUpdateRequest> = ActionUpdateRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionUpdateRequest  {
            val place = buffer.readString()
            val dataContext = buffer.readList { ctx.serializers.readPolymorphic<RdDataConstant>(ctx, buffer, RdDataConstant) }
            val actionId = buffer.readString()
            val updateImmediately = buffer.readBool()
            return ActionUpdateRequest(place, dataContext, actionId, updateImmediately)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionUpdateRequest)  {
            buffer.writeString(value.place)
            buffer.writeList(value.dataContext) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            buffer.writeString(value.actionId)
            buffer.writeBool(value.updateImmediately)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ActionUpdateRequest
        
        if (place != other.place) return false
        if (dataContext != other.dataContext) return false
        if (actionId != other.actionId) return false
        if (updateImmediately != other.updateImmediately) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + place.hashCode()
        __r = __r*31 + dataContext.hashCode()
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + updateImmediately.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionUpdateRequest (")
        printer.indent {
            print("place = "); place.print(printer); println()
            print("dataContext = "); dataContext.print(printer); println()
            print("actionId = "); actionId.print(printer); println()
            print("updateImmediately = "); updateImmediately.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
data class ClipboardHandlerRequest (
    val actionId: String,
    val dataContext: List<RdDataConstant>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ClipboardHandlerRequest> {
        override val _type: KClass<ClipboardHandlerRequest> = ClipboardHandlerRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ClipboardHandlerRequest  {
            val actionId = buffer.readString()
            val dataContext = buffer.readList { ctx.serializers.readPolymorphic<RdDataConstant>(ctx, buffer, RdDataConstant) }
            return ClipboardHandlerRequest(actionId, dataContext)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ClipboardHandlerRequest)  {
            buffer.writeString(value.actionId)
            buffer.writeList(value.dataContext) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ClipboardHandlerRequest
        
        if (actionId != other.actionId) return false
        if (dataContext != other.dataContext) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + dataContext.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ClipboardHandlerRequest (")
        printer.indent {
            print("actionId = "); actionId.print(printer); println()
            print("dataContext = "); dataContext.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class ClipboardTextConstant (
    val text: String?
) : RdDataConstant (
) {
    //companion
    
    companion object : IMarshaller<ClipboardTextConstant> {
        override val _type: KClass<ClipboardTextConstant> = ClipboardTextConstant::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ClipboardTextConstant  {
            val text = buffer.readNullable { buffer.readString() }
            return ClipboardTextConstant(text)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ClipboardTextConstant)  {
            buffer.writeNullable(value.text) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ClipboardTextConstant
        
        if (text != other.text) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (text != null) text.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ClipboardTextConstant (")
        printer.indent {
            print("text = "); text.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
data class PresentationModel (
    val isEnabled: Boolean,
    val isVisible: Boolean,
    val text: String?,
    val description: String?,
    val toggleableSelected: Boolean?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<PresentationModel> {
        override val _type: KClass<PresentationModel> = PresentationModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): PresentationModel  {
            val isEnabled = buffer.readBool()
            val isVisible = buffer.readBool()
            val text = buffer.readNullable { buffer.readString() }
            val description = buffer.readNullable { buffer.readString() }
            val toggleableSelected = buffer.readNullable { buffer.readBool() }
            return PresentationModel(isEnabled, isVisible, text, description, toggleableSelected)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: PresentationModel)  {
            buffer.writeBool(value.isEnabled)
            buffer.writeBool(value.isVisible)
            buffer.writeNullable(value.text) { buffer.writeString(it) }
            buffer.writeNullable(value.description) { buffer.writeString(it) }
            buffer.writeNullable(value.toggleableSelected) { buffer.writeBool(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as PresentationModel
        
        if (isEnabled != other.isEnabled) return false
        if (isVisible != other.isVisible) return false
        if (text != other.text) return false
        if (description != other.description) return false
        if (toggleableSelected != other.toggleableSelected) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + isEnabled.hashCode()
        __r = __r*31 + isVisible.hashCode()
        __r = __r*31 + if (text != null) text.hashCode() else 0
        __r = __r*31 + if (description != null) description.hashCode() else 0
        __r = __r*31 + if (toggleableSelected != null) toggleableSelected.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("PresentationModel (")
        printer.indent {
            print("isEnabled = "); isEnabled.print(printer); println()
            print("isVisible = "); isVisible.print(printer); println()
            print("text = "); text.print(printer); println()
            print("description = "); description.print(printer); println()
            print("toggleableSelected = "); toggleableSelected.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
abstract class RdDataConstant (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdDataConstant> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdDataConstant  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdDataConstant_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdDataConstant_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdDataConstant (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdDataConstant_Unknown> {
        override val _type: KClass<RdDataConstant_Unknown> = RdDataConstant_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDataConstant_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDataConstant_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDataConstant_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDataConstant_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class RdFileStructureConstant (
    val selectedIndex: Int
) : RdDataConstant (
) {
    //companion
    
    companion object : IMarshaller<RdFileStructureConstant> {
        override val _type: KClass<RdFileStructureConstant> = RdFileStructureConstant::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFileStructureConstant  {
            val selectedIndex = buffer.readInt()
            return RdFileStructureConstant(selectedIndex)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFileStructureConstant)  {
            buffer.writeInt(value.selectedIndex)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFileStructureConstant
        
        if (selectedIndex != other.selectedIndex) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + selectedIndex.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFileStructureConstant (")
        printer.indent {
            print("selectedIndex = "); selectedIndex.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class SelectedItemsConstant (
    val items: List<Int>
) : RdDataConstant (
) {
    //companion
    
    companion object : IMarshaller<SelectedItemsConstant> {
        override val _type: KClass<SelectedItemsConstant> = SelectedItemsConstant::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SelectedItemsConstant  {
            val items = buffer.readList { buffer.readInt() }
            return SelectedItemsConstant(items)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SelectedItemsConstant)  {
            buffer.writeList(value.items) { v -> buffer.writeInt(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SelectedItemsConstant
        
        if (items != other.items) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + items.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SelectedItemsConstant (")
        printer.indent {
            print("items = "); items.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class TextControlConstant (
    val id: TextControlId?
) : RdDataConstant (
) {
    //companion
    
    companion object : IMarshaller<TextControlConstant> {
        override val _type: KClass<TextControlConstant> = TextControlConstant::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TextControlConstant  {
            val id = buffer.readNullable { TextControlId.read(ctx, buffer) }
            return TextControlConstant(id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TextControlConstant)  {
            buffer.writeNullable(value.id) { TextControlId.write(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TextControlConstant
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (id != null) id.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TextControlConstant (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
