@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [ActionsModel.kt]
 */
class AsyncActionsModel private constructor(
    private val _update: RdCall<AsyncActionUpdateRequest, PresentationModel?>,
    private val _registerActions: RdSignal<List<ActionRegistrationModel>>,
    private val _unregisterActions: RdSignal<List<String>>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(ActionTimestampSetModel)
            serializers.register(MouseEventModel)
            serializers.register(RdCallActionRequest)
            serializers.register(AsyncActionUpdateRequest)
            serializers.register(NavigatablesArrayTimestampModel)
            serializers.register(NavigatablePsiDirectoryTimestampModel)
            serializers.register(ProjectViewTimestampModel)
            serializers.register(EditorTimestampModel)
            serializers.register(DocumentTimestampModel)
            serializers.register(OffsetTimestampModel)
            serializers.register(RangeMarkerTimestampModel)
            serializers.register(CaretTimestampModel)
            serializers.register(DebuggerExecutionLineTimestampModel)
            serializers.register(TransientTimestampModel)
            serializers.register(SeparatorModel)
            serializers.register(ActionModel)
            serializers.register(EditorActionModel)
            serializers.register(ToggleActionModel)
            serializers.register(GroupModel)
            serializers.register(AnchorModel.marshaller)
            serializers.register(ActionConstraintModel)
            serializers.register(AddToGroupRuleModel)
            serializers.register(ActionTimestampModel_Unknown)
            serializers.register(UpgradableActionTimestampModel_Unknown)
            serializers.register(InputEventModel_Unknown)
            serializers.register(ActionRegistrationModel_Unknown)
            serializers.register(NavigatableTimestampModel_Unknown)
            serializers.register(TransientTimestampModel_Unknown)
            serializers.register(ActionModel_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): AsyncActionsModel  {
            IdeRoot.register(protocol.serializers)
            
            return AsyncActionsModel().apply {
                identify(protocol.identity, RdId.Null.mix("AsyncActionsModel"))
                bind(lifetime, protocol, "AsyncActionsModel")
            }
        }
        
        private val __PresentationModelNullableSerializer = PresentationModel.nullable()
        private val __ActionRegistrationModelListSerializer = AbstractPolymorphic(ActionRegistrationModel).list()
        private val __StringListSerializer = FrameworkMarshallers.String.list()
        
        const val serializationHash = -8565035739320734575L
        
    }
    override val serializersOwner: ISerializersOwner get() = AsyncActionsModel
    override val serializationHash: Long get() = AsyncActionsModel.serializationHash
    
    //fields
    val update: RdCall<AsyncActionUpdateRequest, PresentationModel?> get() = _update
    val registerActions: ISignal<List<ActionRegistrationModel>> get() = _registerActions
    val unregisterActions: ISignal<List<String>> get() = _unregisterActions
    //methods
    //initializer
    init {
        _update.async = true
    }
    
    init {
        bindableChildren.add("update" to _update)
        bindableChildren.add("registerActions" to _registerActions)
        bindableChildren.add("unregisterActions" to _unregisterActions)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdCall<AsyncActionUpdateRequest, PresentationModel?>(AsyncActionUpdateRequest, __PresentationModelNullableSerializer),
        RdSignal<List<ActionRegistrationModel>>(__ActionRegistrationModelListSerializer),
        RdSignal<List<String>>(__StringListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("AsyncActionsModel (")
        printer.indent {
            print("update = "); _update.print(printer); println()
            print("registerActions = "); _registerActions.print(printer); println()
            print("unregisterActions = "); _unregisterActions.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): AsyncActionsModel   {
        return AsyncActionsModel(
            _update.deepClonePolymorphic(),
            _registerActions.deepClonePolymorphic(),
            _unregisterActions.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
data class ActionConstraintModel (
    val relativeToActionId: String?,
    val anchor: AnchorModel
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ActionConstraintModel> {
        override val _type: KClass<ActionConstraintModel> = ActionConstraintModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionConstraintModel  {
            val relativeToActionId = buffer.readNullable { buffer.readString() }
            val anchor = buffer.readEnum<AnchorModel>()
            return ActionConstraintModel(relativeToActionId, anchor)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionConstraintModel)  {
            buffer.writeNullable(value.relativeToActionId) { buffer.writeString(it) }
            buffer.writeEnum(value.anchor)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ActionConstraintModel
        
        if (relativeToActionId != other.relativeToActionId) return false
        if (anchor != other.anchor) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (relativeToActionId != null) relativeToActionId.hashCode() else 0
        __r = __r*31 + anchor.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionConstraintModel (")
        printer.indent {
            print("relativeToActionId = "); relativeToActionId.print(printer); println()
            print("anchor = "); anchor.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
open class ActionModel (
    val actionId: String,
    val text: String?,
    val description: String?,
    val icon: IconModel?,
    val addToGroupRules: List<AddToGroupRuleModel>
) : ActionRegistrationModel (
) {
    //companion
    
    companion object : IMarshaller<ActionModel>, IAbstractDeclaration<ActionModel> {
        override val _type: KClass<ActionModel> = ActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionModel  {
            val actionId = buffer.readString()
            val text = buffer.readNullable { buffer.readString() }
            val description = buffer.readNullable { buffer.readString() }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val addToGroupRules = buffer.readList { AddToGroupRuleModel.read(ctx, buffer) }
            return ActionModel(actionId, text, description, icon, addToGroupRules)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionModel)  {
            buffer.writeString(value.actionId)
            buffer.writeNullable(value.text) { buffer.writeString(it) }
            buffer.writeNullable(value.description) { buffer.writeString(it) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeList(value.addToGroupRules) { v -> AddToGroupRuleModel.write(ctx, buffer, v) }
        }
        
        
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ActionModel  {
            val objectStartPosition = buffer.position
            val actionId = buffer.readString()
            val text = buffer.readNullable { buffer.readString() }
            val description = buffer.readNullable { buffer.readString() }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val addToGroupRules = buffer.readList { AddToGroupRuleModel.read(ctx, buffer) }
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ActionModel_Unknown(actionId, text, description, icon, addToGroupRules, unknownId, unknownBytes)
        }
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ActionModel
        
        if (actionId != other.actionId) return false
        if (text != other.text) return false
        if (description != other.description) return false
        if (icon != other.icon) return false
        if (addToGroupRules != other.addToGroupRules) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + if (text != null) text.hashCode() else 0
        __r = __r*31 + if (description != null) description.hashCode() else 0
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + addToGroupRules.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionModel (")
        printer.indent {
            print("actionId = "); actionId.print(printer); println()
            print("text = "); text.print(printer); println()
            print("description = "); description.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("addToGroupRules = "); addToGroupRules.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


class ActionModel_Unknown (
    actionId: String,
    text: String?,
    description: String?,
    icon: IconModel?,
    addToGroupRules: List<AddToGroupRuleModel>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ActionModel (
    actionId,
    text,
    description,
    icon,
    addToGroupRules
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ActionModel_Unknown> {
        override val _type: KClass<ActionModel_Unknown> = ActionModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionModel_Unknown)  {
            buffer.writeString(value.actionId)
            buffer.writeNullable(value.text) { buffer.writeString(it) }
            buffer.writeNullable(value.description) { buffer.writeString(it) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeList(value.addToGroupRules) { v -> AddToGroupRuleModel.write(ctx, buffer, v) }
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ActionModel_Unknown
        
        if (actionId != other.actionId) return false
        if (text != other.text) return false
        if (description != other.description) return false
        if (icon != other.icon) return false
        if (addToGroupRules != other.addToGroupRules) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + if (text != null) text.hashCode() else 0
        __r = __r*31 + if (description != null) description.hashCode() else 0
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + addToGroupRules.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionModel_Unknown (")
        printer.indent {
            print("actionId = "); actionId.print(printer); println()
            print("text = "); text.print(printer); println()
            print("description = "); description.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("addToGroupRules = "); addToGroupRules.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
abstract class ActionRegistrationModel (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<ActionRegistrationModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ActionRegistrationModel  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ActionRegistrationModel_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ActionRegistrationModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ActionRegistrationModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ActionRegistrationModel_Unknown> {
        override val _type: KClass<ActionRegistrationModel_Unknown> = ActionRegistrationModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionRegistrationModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionRegistrationModel_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ActionRegistrationModel_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionRegistrationModel_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
abstract class ActionTimestampModel (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<ActionTimestampModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ActionTimestampModel  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ActionTimestampModel_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ActionTimestampModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ActionTimestampModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ActionTimestampModel_Unknown> {
        override val _type: KClass<ActionTimestampModel_Unknown> = ActionTimestampModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionTimestampModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionTimestampModel_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ActionTimestampModel_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionTimestampModel_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
data class ActionTimestampSetModel (
    val models: List<ActionTimestampModel>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ActionTimestampSetModel> {
        override val _type: KClass<ActionTimestampSetModel> = ActionTimestampSetModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionTimestampSetModel  {
            val models = buffer.readList { ctx.serializers.readPolymorphic<ActionTimestampModel>(ctx, buffer, ActionTimestampModel) }
            return ActionTimestampSetModel(models)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionTimestampSetModel)  {
            buffer.writeList(value.models) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ActionTimestampSetModel
        
        if (models != other.models) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + models.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionTimestampSetModel (")
        printer.indent {
            print("models = "); models.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
data class AddToGroupRuleModel (
    val groupId: String,
    val constraint: ActionConstraintModel?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<AddToGroupRuleModel> {
        override val _type: KClass<AddToGroupRuleModel> = AddToGroupRuleModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): AddToGroupRuleModel  {
            val groupId = buffer.readString()
            val constraint = buffer.readNullable { ActionConstraintModel.read(ctx, buffer) }
            return AddToGroupRuleModel(groupId, constraint)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: AddToGroupRuleModel)  {
            buffer.writeString(value.groupId)
            buffer.writeNullable(value.constraint) { ActionConstraintModel.write(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as AddToGroupRuleModel
        
        if (groupId != other.groupId) return false
        if (constraint != other.constraint) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + groupId.hashCode()
        __r = __r*31 + if (constraint != null) constraint.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("AddToGroupRuleModel (")
        printer.indent {
            print("groupId = "); groupId.print(printer); println()
            print("constraint = "); constraint.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
enum class AnchorModel {
    First, 
    Last, 
    Before, 
    After;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<AnchorModel>()
        
    }
}


/**
 * #### Generated from [ActionsModel.kt]
 */
data class AsyncActionUpdateRequest (
    val place: String,
    val timestampSetModel: ActionTimestampSetModel,
    val actionId: String,
    val updateImmediately: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<AsyncActionUpdateRequest> {
        override val _type: KClass<AsyncActionUpdateRequest> = AsyncActionUpdateRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): AsyncActionUpdateRequest  {
            val place = buffer.readString()
            val timestampSetModel = ActionTimestampSetModel.read(ctx, buffer)
            val actionId = buffer.readString()
            val updateImmediately = buffer.readBool()
            return AsyncActionUpdateRequest(place, timestampSetModel, actionId, updateImmediately)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: AsyncActionUpdateRequest)  {
            buffer.writeString(value.place)
            ActionTimestampSetModel.write(ctx, buffer, value.timestampSetModel)
            buffer.writeString(value.actionId)
            buffer.writeBool(value.updateImmediately)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as AsyncActionUpdateRequest
        
        if (place != other.place) return false
        if (timestampSetModel != other.timestampSetModel) return false
        if (actionId != other.actionId) return false
        if (updateImmediately != other.updateImmediately) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + place.hashCode()
        __r = __r*31 + timestampSetModel.hashCode()
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + updateImmediately.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("AsyncActionUpdateRequest (")
        printer.indent {
            print("place = "); place.print(printer); println()
            print("timestampSetModel = "); timestampSetModel.print(printer); println()
            print("actionId = "); actionId.print(printer); println()
            print("updateImmediately = "); updateImmediately.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class CaretTimestampModel (
    val selection: RangeMarkerTimestampModel,
    val offset: OffsetTimestampModel
) : UpgradableActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<CaretTimestampModel> {
        override val _type: KClass<CaretTimestampModel> = CaretTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CaretTimestampModel  {
            val selection = RangeMarkerTimestampModel.read(ctx, buffer)
            val offset = OffsetTimestampModel.read(ctx, buffer)
            return CaretTimestampModel(selection, offset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CaretTimestampModel)  {
            RangeMarkerTimestampModel.write(ctx, buffer, value.selection)
            OffsetTimestampModel.write(ctx, buffer, value.offset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CaretTimestampModel
        
        if (selection != other.selection) return false
        if (offset != other.offset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + selection.hashCode()
        __r = __r*31 + offset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CaretTimestampModel (")
        printer.indent {
            print("selection = "); selection.print(printer); println()
            print("offset = "); offset.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class DebuggerExecutionLineTimestampModel (
    val offset: OffsetTimestampModel
) : UpgradableActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<DebuggerExecutionLineTimestampModel> {
        override val _type: KClass<DebuggerExecutionLineTimestampModel> = DebuggerExecutionLineTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DebuggerExecutionLineTimestampModel  {
            val offset = OffsetTimestampModel.read(ctx, buffer)
            return DebuggerExecutionLineTimestampModel(offset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DebuggerExecutionLineTimestampModel)  {
            OffsetTimestampModel.write(ctx, buffer, value.offset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DebuggerExecutionLineTimestampModel
        
        if (offset != other.offset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + offset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DebuggerExecutionLineTimestampModel (")
        printer.indent {
            print("offset = "); offset.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class DocumentTimestampModel (
    val documentId: RdDocumentId,
    val version: RdDocumentVersion
) : ActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<DocumentTimestampModel> {
        override val _type: KClass<DocumentTimestampModel> = DocumentTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DocumentTimestampModel  {
            val documentId = ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId)
            val version = RdDocumentVersion.read(ctx, buffer)
            return DocumentTimestampModel(documentId, version)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DocumentTimestampModel)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentId)
            RdDocumentVersion.write(ctx, buffer, value.version)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DocumentTimestampModel
        
        if (documentId != other.documentId) return false
        if (version != other.version) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + documentId.hashCode()
        __r = __r*31 + version.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DocumentTimestampModel (")
        printer.indent {
            print("documentId = "); documentId.print(printer); println()
            print("version = "); version.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class EditorActionModel (
    val withImmediateResult: Boolean,
    actionId: String,
    text: String?,
    description: String?,
    icon: IconModel?,
    addToGroupRules: List<AddToGroupRuleModel>
) : ActionModel (
    actionId,
    text,
    description,
    icon,
    addToGroupRules
) {
    //companion
    
    companion object : IMarshaller<EditorActionModel> {
        override val _type: KClass<EditorActionModel> = EditorActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): EditorActionModel  {
            val actionId = buffer.readString()
            val text = buffer.readNullable { buffer.readString() }
            val description = buffer.readNullable { buffer.readString() }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val addToGroupRules = buffer.readList { AddToGroupRuleModel.read(ctx, buffer) }
            val withImmediateResult = buffer.readBool()
            return EditorActionModel(withImmediateResult, actionId, text, description, icon, addToGroupRules)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: EditorActionModel)  {
            buffer.writeString(value.actionId)
            buffer.writeNullable(value.text) { buffer.writeString(it) }
            buffer.writeNullable(value.description) { buffer.writeString(it) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeList(value.addToGroupRules) { v -> AddToGroupRuleModel.write(ctx, buffer, v) }
            buffer.writeBool(value.withImmediateResult)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as EditorActionModel
        
        if (withImmediateResult != other.withImmediateResult) return false
        if (actionId != other.actionId) return false
        if (text != other.text) return false
        if (description != other.description) return false
        if (icon != other.icon) return false
        if (addToGroupRules != other.addToGroupRules) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + withImmediateResult.hashCode()
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + if (text != null) text.hashCode() else 0
        __r = __r*31 + if (description != null) description.hashCode() else 0
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + addToGroupRules.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("EditorActionModel (")
        printer.indent {
            print("withImmediateResult = "); withImmediateResult.print(printer); println()
            print("actionId = "); actionId.print(printer); println()
            print("text = "); text.print(printer); println()
            print("description = "); description.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("addToGroupRules = "); addToGroupRules.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class EditorTimestampModel (
    val editorId: TextControlId,
    val carets: List<CaretTimestampModel>
) : UpgradableActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<EditorTimestampModel> {
        override val _type: KClass<EditorTimestampModel> = EditorTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): EditorTimestampModel  {
            val editorId = TextControlId.read(ctx, buffer)
            val carets = buffer.readList { CaretTimestampModel.read(ctx, buffer) }
            return EditorTimestampModel(editorId, carets)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: EditorTimestampModel)  {
            TextControlId.write(ctx, buffer, value.editorId)
            buffer.writeList(value.carets) { v -> CaretTimestampModel.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as EditorTimestampModel
        
        if (editorId != other.editorId) return false
        if (carets != other.carets) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + editorId.hashCode()
        __r = __r*31 + carets.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("EditorTimestampModel (")
        printer.indent {
            print("editorId = "); editorId.print(printer); println()
            print("carets = "); carets.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class GroupModel (
    val actionId: String,
    val text: String?,
    val description: String?,
    val icon: IconModel?,
    val popup: Boolean,
    val children: List<ActionRegistrationModel>,
    val addToGroupRules: List<AddToGroupRuleModel>
) : ActionRegistrationModel (
) {
    //companion
    
    companion object : IMarshaller<GroupModel> {
        override val _type: KClass<GroupModel> = GroupModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): GroupModel  {
            val actionId = buffer.readString()
            val text = buffer.readNullable { buffer.readString() }
            val description = buffer.readNullable { buffer.readString() }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val popup = buffer.readBool()
            val children = buffer.readList { ctx.serializers.readPolymorphic<ActionRegistrationModel>(ctx, buffer, ActionRegistrationModel) }
            val addToGroupRules = buffer.readList { AddToGroupRuleModel.read(ctx, buffer) }
            return GroupModel(actionId, text, description, icon, popup, children, addToGroupRules)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: GroupModel)  {
            buffer.writeString(value.actionId)
            buffer.writeNullable(value.text) { buffer.writeString(it) }
            buffer.writeNullable(value.description) { buffer.writeString(it) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeBool(value.popup)
            buffer.writeList(value.children) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            buffer.writeList(value.addToGroupRules) { v -> AddToGroupRuleModel.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as GroupModel
        
        if (actionId != other.actionId) return false
        if (text != other.text) return false
        if (description != other.description) return false
        if (icon != other.icon) return false
        if (popup != other.popup) return false
        if (children != other.children) return false
        if (addToGroupRules != other.addToGroupRules) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + if (text != null) text.hashCode() else 0
        __r = __r*31 + if (description != null) description.hashCode() else 0
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + popup.hashCode()
        __r = __r*31 + children.hashCode()
        __r = __r*31 + addToGroupRules.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("GroupModel (")
        printer.indent {
            print("actionId = "); actionId.print(printer); println()
            print("text = "); text.print(printer); println()
            print("description = "); description.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("popup = "); popup.print(printer); println()
            print("children = "); children.print(printer); println()
            print("addToGroupRules = "); addToGroupRules.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
abstract class InputEventModel (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<InputEventModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): InputEventModel  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return InputEventModel_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class InputEventModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : InputEventModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<InputEventModel_Unknown> {
        override val _type: KClass<InputEventModel_Unknown> = InputEventModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): InputEventModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: InputEventModel_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as InputEventModel_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("InputEventModel_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class MouseEventModel (
    val id: Int,
    val modifiers: Int,
    val x: Int,
    val y: Int,
    val clickCount: Int,
    val button: Int
) : InputEventModel (
) {
    //companion
    
    companion object : IMarshaller<MouseEventModel> {
        override val _type: KClass<MouseEventModel> = MouseEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): MouseEventModel  {
            val id = buffer.readInt()
            val modifiers = buffer.readInt()
            val x = buffer.readInt()
            val y = buffer.readInt()
            val clickCount = buffer.readInt()
            val button = buffer.readInt()
            return MouseEventModel(id, modifiers, x, y, clickCount, button)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: MouseEventModel)  {
            buffer.writeInt(value.id)
            buffer.writeInt(value.modifiers)
            buffer.writeInt(value.x)
            buffer.writeInt(value.y)
            buffer.writeInt(value.clickCount)
            buffer.writeInt(value.button)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as MouseEventModel
        
        if (id != other.id) return false
        if (modifiers != other.modifiers) return false
        if (x != other.x) return false
        if (y != other.y) return false
        if (clickCount != other.clickCount) return false
        if (button != other.button) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + modifiers.hashCode()
        __r = __r*31 + x.hashCode()
        __r = __r*31 + y.hashCode()
        __r = __r*31 + clickCount.hashCode()
        __r = __r*31 + button.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("MouseEventModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("modifiers = "); modifiers.print(printer); println()
            print("x = "); x.print(printer); println()
            print("y = "); y.print(printer); println()
            print("clickCount = "); clickCount.print(printer); println()
            print("button = "); button.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class NavigatablePsiDirectoryTimestampModel (
    val systemIndependentPath: String
) : NavigatableTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<NavigatablePsiDirectoryTimestampModel> {
        override val _type: KClass<NavigatablePsiDirectoryTimestampModel> = NavigatablePsiDirectoryTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NavigatablePsiDirectoryTimestampModel  {
            val systemIndependentPath = buffer.readString()
            return NavigatablePsiDirectoryTimestampModel(systemIndependentPath)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NavigatablePsiDirectoryTimestampModel)  {
            buffer.writeString(value.systemIndependentPath)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as NavigatablePsiDirectoryTimestampModel
        
        if (systemIndependentPath != other.systemIndependentPath) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + systemIndependentPath.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NavigatablePsiDirectoryTimestampModel (")
        printer.indent {
            print("systemIndependentPath = "); systemIndependentPath.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
abstract class NavigatableTimestampModel (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<NavigatableTimestampModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): NavigatableTimestampModel  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return NavigatableTimestampModel_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class NavigatableTimestampModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : NavigatableTimestampModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<NavigatableTimestampModel_Unknown> {
        override val _type: KClass<NavigatableTimestampModel_Unknown> = NavigatableTimestampModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NavigatableTimestampModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NavigatableTimestampModel_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as NavigatableTimestampModel_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NavigatableTimestampModel_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class NavigatablesArrayTimestampModel (
    val navigatables: List<NavigatableTimestampModel>
) : UpgradableActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<NavigatablesArrayTimestampModel> {
        override val _type: KClass<NavigatablesArrayTimestampModel> = NavigatablesArrayTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NavigatablesArrayTimestampModel  {
            val navigatables = buffer.readList { ctx.serializers.readPolymorphic<NavigatableTimestampModel>(ctx, buffer, NavigatableTimestampModel) }
            return NavigatablesArrayTimestampModel(navigatables)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NavigatablesArrayTimestampModel)  {
            buffer.writeList(value.navigatables) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as NavigatablesArrayTimestampModel
        
        if (navigatables != other.navigatables) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + navigatables.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NavigatablesArrayTimestampModel (")
        printer.indent {
            print("navigatables = "); navigatables.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class OffsetTimestampModel (
    val offset: Int,
    val isStickingToRight: Boolean = false,
    val document: DocumentTimestampModel
) : UpgradableActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<OffsetTimestampModel> {
        override val _type: KClass<OffsetTimestampModel> = OffsetTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OffsetTimestampModel  {
            val offset = buffer.readInt()
            val isStickingToRight = buffer.readBool()
            val document = DocumentTimestampModel.read(ctx, buffer)
            return OffsetTimestampModel(offset, isStickingToRight, document)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OffsetTimestampModel)  {
            buffer.writeInt(value.offset)
            buffer.writeBool(value.isStickingToRight)
            DocumentTimestampModel.write(ctx, buffer, value.document)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OffsetTimestampModel
        
        if (offset != other.offset) return false
        if (isStickingToRight != other.isStickingToRight) return false
        if (document != other.document) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + offset.hashCode()
        __r = __r*31 + isStickingToRight.hashCode()
        __r = __r*31 + document.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OffsetTimestampModel (")
        printer.indent {
            print("offset = "); offset.print(printer); println()
            print("isStickingToRight = "); isStickingToRight.print(printer); println()
            print("document = "); document.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class ProjectViewTimestampModel (
    val paneId: String,
    val selectedNodeIds: List<Int>
) : UpgradableActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<ProjectViewTimestampModel> {
        override val _type: KClass<ProjectViewTimestampModel> = ProjectViewTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ProjectViewTimestampModel  {
            val paneId = buffer.readString()
            val selectedNodeIds = buffer.readList { buffer.readInt() }
            return ProjectViewTimestampModel(paneId, selectedNodeIds)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ProjectViewTimestampModel)  {
            buffer.writeString(value.paneId)
            buffer.writeList(value.selectedNodeIds) { v -> buffer.writeInt(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ProjectViewTimestampModel
        
        if (paneId != other.paneId) return false
        if (selectedNodeIds != other.selectedNodeIds) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + paneId.hashCode()
        __r = __r*31 + selectedNodeIds.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ProjectViewTimestampModel (")
        printer.indent {
            print("paneId = "); paneId.print(printer); println()
            print("selectedNodeIds = "); selectedNodeIds.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class RangeMarkerTimestampModel (
    val range: RdTextRange,
    val allowInnerModifications: Boolean,
    val document: DocumentTimestampModel
) : UpgradableActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<RangeMarkerTimestampModel> {
        override val _type: KClass<RangeMarkerTimestampModel> = RangeMarkerTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RangeMarkerTimestampModel  {
            val range = RdTextRange.read(ctx, buffer)
            val allowInnerModifications = buffer.readBool()
            val document = DocumentTimestampModel.read(ctx, buffer)
            return RangeMarkerTimestampModel(range, allowInnerModifications, document)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RangeMarkerTimestampModel)  {
            RdTextRange.write(ctx, buffer, value.range)
            buffer.writeBool(value.allowInnerModifications)
            DocumentTimestampModel.write(ctx, buffer, value.document)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RangeMarkerTimestampModel
        
        if (range != other.range) return false
        if (allowInnerModifications != other.allowInnerModifications) return false
        if (document != other.document) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + range.hashCode()
        __r = __r*31 + allowInnerModifications.hashCode()
        __r = __r*31 + document.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RangeMarkerTimestampModel (")
        printer.indent {
            print("range = "); range.print(printer); println()
            print("allowInnerModifications = "); allowInnerModifications.print(printer); println()
            print("document = "); document.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class RdCallActionRequest (
    val timestampSetModel: ActionTimestampSetModel,
    val actionId: String,
    val actionPlace: String,
    val inputEventModel: InputEventModel?,
    id: Int
) : RdRequest (
    id
) {
    //companion
    
    companion object : IMarshaller<RdCallActionRequest> {
        override val _type: KClass<RdCallActionRequest> = RdCallActionRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCallActionRequest  {
            val id = buffer.readInt()
            val timestampSetModel = ActionTimestampSetModel.read(ctx, buffer)
            val actionId = buffer.readString()
            val actionPlace = buffer.readString()
            val inputEventModel = buffer.readNullable { ctx.serializers.readPolymorphic<InputEventModel>(ctx, buffer, InputEventModel) }
            return RdCallActionRequest(timestampSetModel, actionId, actionPlace, inputEventModel, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCallActionRequest)  {
            buffer.writeInt(value.id)
            ActionTimestampSetModel.write(ctx, buffer, value.timestampSetModel)
            buffer.writeString(value.actionId)
            buffer.writeString(value.actionPlace)
            buffer.writeNullable(value.inputEventModel) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCallActionRequest
        
        if (timestampSetModel != other.timestampSetModel) return false
        if (actionId != other.actionId) return false
        if (actionPlace != other.actionPlace) return false
        if (inputEventModel != other.inputEventModel) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + timestampSetModel.hashCode()
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + actionPlace.hashCode()
        __r = __r*31 + if (inputEventModel != null) inputEventModel.hashCode() else 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCallActionRequest (")
        printer.indent {
            print("timestampSetModel = "); timestampSetModel.print(printer); println()
            print("actionId = "); actionId.print(printer); println()
            print("actionPlace = "); actionPlace.print(printer); println()
            print("inputEventModel = "); inputEventModel.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class SeparatorModel (
    val text: String?
) : ActionRegistrationModel (
) {
    //companion
    
    companion object : IMarshaller<SeparatorModel> {
        override val _type: KClass<SeparatorModel> = SeparatorModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SeparatorModel  {
            val text = buffer.readNullable { buffer.readString() }
            return SeparatorModel(text)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SeparatorModel)  {
            buffer.writeNullable(value.text) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SeparatorModel
        
        if (text != other.text) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (text != null) text.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SeparatorModel (")
        printer.indent {
            print("text = "); text.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
class ToggleActionModel (
    val isSelected: Boolean,
    actionId: String,
    text: String?,
    description: String?,
    icon: IconModel?,
    addToGroupRules: List<AddToGroupRuleModel>
) : ActionModel (
    actionId,
    text,
    description,
    icon,
    addToGroupRules
) {
    //companion
    
    companion object : IMarshaller<ToggleActionModel> {
        override val _type: KClass<ToggleActionModel> = ToggleActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ToggleActionModel  {
            val actionId = buffer.readString()
            val text = buffer.readNullable { buffer.readString() }
            val description = buffer.readNullable { buffer.readString() }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val addToGroupRules = buffer.readList { AddToGroupRuleModel.read(ctx, buffer) }
            val isSelected = buffer.readBool()
            return ToggleActionModel(isSelected, actionId, text, description, icon, addToGroupRules)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ToggleActionModel)  {
            buffer.writeString(value.actionId)
            buffer.writeNullable(value.text) { buffer.writeString(it) }
            buffer.writeNullable(value.description) { buffer.writeString(it) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeList(value.addToGroupRules) { v -> AddToGroupRuleModel.write(ctx, buffer, v) }
            buffer.writeBool(value.isSelected)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ToggleActionModel
        
        if (isSelected != other.isSelected) return false
        if (actionId != other.actionId) return false
        if (text != other.text) return false
        if (description != other.description) return false
        if (icon != other.icon) return false
        if (addToGroupRules != other.addToGroupRules) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + isSelected.hashCode()
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + if (text != null) text.hashCode() else 0
        __r = __r*31 + if (description != null) description.hashCode() else 0
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + addToGroupRules.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ToggleActionModel (")
        printer.indent {
            print("isSelected = "); isSelected.print(printer); println()
            print("actionId = "); actionId.print(printer); println()
            print("text = "); text.print(printer); println()
            print("description = "); description.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("addToGroupRules = "); addToGroupRules.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
open class TransientTimestampModel (
) : ActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<TransientTimestampModel>, IAbstractDeclaration<TransientTimestampModel> {
        override val _type: KClass<TransientTimestampModel> = TransientTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TransientTimestampModel  {
            return TransientTimestampModel()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TransientTimestampModel)  {
        }
        
        
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): TransientTimestampModel  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return TransientTimestampModel_Unknown(unknownId, unknownBytes)
        }
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TransientTimestampModel
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TransientTimestampModel (")
        printer.print(")")
    }
    //deepClone
    //contexts
}


class TransientTimestampModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : TransientTimestampModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<TransientTimestampModel_Unknown> {
        override val _type: KClass<TransientTimestampModel_Unknown> = TransientTimestampModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TransientTimestampModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TransientTimestampModel_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TransientTimestampModel_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TransientTimestampModel_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ActionsModel.kt]
 */
abstract class UpgradableActionTimestampModel (
) : ActionTimestampModel (
) {
    //companion
    
    companion object : IAbstractDeclaration<UpgradableActionTimestampModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): UpgradableActionTimestampModel  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return UpgradableActionTimestampModel_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class UpgradableActionTimestampModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : UpgradableActionTimestampModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<UpgradableActionTimestampModel_Unknown> {
        override val _type: KClass<UpgradableActionTimestampModel_Unknown> = UpgradableActionTimestampModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): UpgradableActionTimestampModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: UpgradableActionTimestampModel_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as UpgradableActionTimestampModel_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("UpgradableActionTimestampModel_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
