@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [BackendRunContentModel.kt]
 */
class BackendRunContentModel private constructor(
    private val _runProcesses: RdMap<Long, BackendRunProcessModel>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(BackendRunProcessModel)
            serializers.register(ExecutionConsoleKind.marshaller)
            serializers.register(ExternalSystemInfo)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): BackendRunContentModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return BackendRunContentModel().apply {
                identify(protocol.identity, RdId.Null.mix("BackendRunContentModel"))
                bind(lifetime, protocol, "BackendRunContentModel")
            }
        }
        
        
        const val serializationHash = 1831872269056053325L
        
    }
    override val serializersOwner: ISerializersOwner get() = BackendRunContentModel
    override val serializationHash: Long get() = BackendRunContentModel.serializationHash
    
    //fields
    val runProcesses: IMutableViewableMap<Long, BackendRunProcessModel> get() = _runProcesses
    //methods
    //initializer
    init {
        _runProcesses.async = true
    }
    
    init {
        bindableChildren.add("runProcesses" to _runProcesses)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdMap<Long, BackendRunProcessModel>(FrameworkMarshallers.Long, BackendRunProcessModel)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BackendRunContentModel (")
        printer.indent {
            print("runProcesses = "); _runProcesses.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BackendRunContentModel   {
        return BackendRunContentModel(
            _runProcesses.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [BackendRunContentModel.kt]
 */
class BackendRunProcessModel private constructor(
    val executionId: Long,
    val displayName: String,
    val configurationTypeId: String,
    val configurationName: String,
    val testFramework: String,
    val idBased: Boolean,
    val executorId: String,
    val runnerId: String,
    val externalSystemInfo: ExternalSystemInfo?,
    val executionConsoleKind: ExecutionConsoleKind,
    private val _exitCode: RdOptionalProperty<Int>,
    private val _consoleOutput: RdSignal<CodeWithMeOutputMessage>,
    private val _terminateFromFrontend: RdSignal<Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BackendRunProcessModel> {
        override val _type: KClass<BackendRunProcessModel> = BackendRunProcessModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BackendRunProcessModel  {
            val _id = RdId.read(buffer)
            val executionId = buffer.readLong()
            val displayName = buffer.readString()
            val configurationTypeId = buffer.readString()
            val configurationName = buffer.readString()
            val testFramework = buffer.readString()
            val idBased = buffer.readBool()
            val executorId = buffer.readString()
            val runnerId = buffer.readString()
            val externalSystemInfo = buffer.readNullable { ExternalSystemInfo.read(ctx, buffer) }
            val executionConsoleKind = buffer.readEnum<ExecutionConsoleKind>()
            val _exitCode = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _consoleOutput = RdSignal.read(ctx, buffer, CodeWithMeOutputMessage)
            val _terminateFromFrontend = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return BackendRunProcessModel(executionId, displayName, configurationTypeId, configurationName, testFramework, idBased, executorId, runnerId, externalSystemInfo, executionConsoleKind, _exitCode, _consoleOutput, _terminateFromFrontend).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BackendRunProcessModel)  {
            value.rdid.write(buffer)
            buffer.writeLong(value.executionId)
            buffer.writeString(value.displayName)
            buffer.writeString(value.configurationTypeId)
            buffer.writeString(value.configurationName)
            buffer.writeString(value.testFramework)
            buffer.writeBool(value.idBased)
            buffer.writeString(value.executorId)
            buffer.writeString(value.runnerId)
            buffer.writeNullable(value.externalSystemInfo) { ExternalSystemInfo.write(ctx, buffer, it) }
            buffer.writeEnum(value.executionConsoleKind)
            RdOptionalProperty.write(ctx, buffer, value._exitCode)
            RdSignal.write(ctx, buffer, value._consoleOutput)
            RdSignal.write(ctx, buffer, value._terminateFromFrontend)
        }
        
        
    }
    //fields
    val exitCode: IOptProperty<Int> get() = _exitCode
    val consoleOutput: IAsyncSignal<CodeWithMeOutputMessage> get() = _consoleOutput
    val terminateFromFrontend: ISignal<Unit> get() = _terminateFromFrontend
    //methods
    //initializer
    init {
        _exitCode.optimizeNested = true
    }
    
    init {
        _consoleOutput.async = true
    }
    
    init {
        bindableChildren.add("exitCode" to _exitCode)
        bindableChildren.add("consoleOutput" to _consoleOutput)
        bindableChildren.add("terminateFromFrontend" to _terminateFromFrontend)
    }
    
    //secondary constructor
    constructor(
        executionId: Long,
        displayName: String,
        configurationTypeId: String,
        configurationName: String,
        testFramework: String,
        idBased: Boolean,
        executorId: String,
        runnerId: String,
        externalSystemInfo: ExternalSystemInfo?,
        executionConsoleKind: ExecutionConsoleKind
    ) : this(
        executionId,
        displayName,
        configurationTypeId,
        configurationName,
        testFramework,
        idBased,
        executorId,
        runnerId,
        externalSystemInfo,
        executionConsoleKind,
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdSignal<CodeWithMeOutputMessage>(CodeWithMeOutputMessage),
        RdSignal<Unit>(FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BackendRunProcessModel (")
        printer.indent {
            print("executionId = "); executionId.print(printer); println()
            print("displayName = "); displayName.print(printer); println()
            print("configurationTypeId = "); configurationTypeId.print(printer); println()
            print("configurationName = "); configurationName.print(printer); println()
            print("testFramework = "); testFramework.print(printer); println()
            print("idBased = "); idBased.print(printer); println()
            print("executorId = "); executorId.print(printer); println()
            print("runnerId = "); runnerId.print(printer); println()
            print("externalSystemInfo = "); externalSystemInfo.print(printer); println()
            print("executionConsoleKind = "); executionConsoleKind.print(printer); println()
            print("exitCode = "); _exitCode.print(printer); println()
            print("consoleOutput = "); _consoleOutput.print(printer); println()
            print("terminateFromFrontend = "); _terminateFromFrontend.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BackendRunProcessModel   {
        return BackendRunProcessModel(
            executionId,
            displayName,
            configurationTypeId,
            configurationName,
            testFramework,
            idBased,
            executorId,
            runnerId,
            externalSystemInfo,
            executionConsoleKind,
            _exitCode.deepClonePolymorphic(),
            _consoleOutput.deepClonePolymorphic(),
            _terminateFromFrontend.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [BackendRunContentModel.kt]
 */
enum class ExecutionConsoleKind {
    TerminalExecutionConsole, 
    Default;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ExecutionConsoleKind>()
        
    }
}


/**
 * #### Generated from [BackendRunContentModel.kt]
 */
data class ExternalSystemInfo (
    val taskId: com.jetbrains.rd.ide.model.ExternalSystemTaskIdModel,
    val executionName: String,
    val taskNames: List<String>,
    val configurationIcon: com.jetbrains.rd.ide.model.IconModel?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ExternalSystemInfo> {
        override val _type: KClass<ExternalSystemInfo> = ExternalSystemInfo::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ExternalSystemInfo  {
            val taskId = com.jetbrains.rd.ide.model.ExternalSystemTaskIdModel.read(ctx, buffer)
            val executionName = buffer.readString()
            val taskNames = buffer.readList { buffer.readString() }
            val configurationIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            return ExternalSystemInfo(taskId, executionName, taskNames, configurationIcon)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ExternalSystemInfo)  {
            com.jetbrains.rd.ide.model.ExternalSystemTaskIdModel.write(ctx, buffer, value.taskId)
            buffer.writeString(value.executionName)
            buffer.writeList(value.taskNames) { v -> buffer.writeString(v) }
            buffer.writeNullable(value.configurationIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ExternalSystemInfo
        
        if (taskId != other.taskId) return false
        if (executionName != other.executionName) return false
        if (taskNames != other.taskNames) return false
        if (configurationIcon != other.configurationIcon) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + taskId.hashCode()
        __r = __r*31 + executionName.hashCode()
        __r = __r*31 + taskNames.hashCode()
        __r = __r*31 + if (configurationIcon != null) configurationIcon.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ExternalSystemInfo (")
        printer.indent {
            print("taskId = "); taskId.print(printer); println()
            print("executionName = "); executionName.print(printer); println()
            print("taskNames = "); taskNames.print(printer); println()
            print("configurationIcon = "); configurationIcon.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
