@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class CWMExternalSystemModel private constructor(
    private val _onStart: RdSignal<OnStartArgs>,
    private val _onTaskOutput: RdSignal<OnTaskOutputArgs>,
    private val _onStatusChange: RdSignal<OnStatusChangeArgs>,
    private val _onStatusChangeBuild: RdSignal<OnStatusChangeArgs2>,
    private val _onSuccess: RdSignal<OnSuccessArgs>,
    private val _onFailure: RdSignal<OnFailureArgs>,
    private val _onCancel: RdSignal<OnCancelArgs>,
    private val _onEnd: RdSignal<OnEndArgs>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(ExternalSystemTaskTypeModel.marshaller)
            serializers.register(ExternalSystemTaskIdModel)
            serializers.register(OperationDescriptorModel)
            serializers.register(ExternalSystemStartEventModel)
            serializers.register(ExternalSystemFinishEventModel)
            serializers.register(ExternalSystemStatusEventModel)
            serializers.register(OnStartArgs)
            serializers.register(OnTaskOutputArgs)
            serializers.register(OnStatusChangeArgs)
            serializers.register(OnStatusChangeArgs2)
            serializers.register(OnSuccessArgs)
            serializers.register(OnFailureArgs)
            serializers.register(OnCancelArgs)
            serializers.register(OnEndArgs)
            serializers.register(OperationResultModel.marshaller)
            serializers.register(ExternalSystemTaskExecutionEventModel_Unknown)
            serializers.register(ExternalSystemIdHolder_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): CWMExternalSystemModel  {
            IdeRoot.register(protocol.serializers)
            
            return CWMExternalSystemModel().apply {
                identify(protocol.identity, RdId.Null.mix("CWMExternalSystemModel"))
                bind(lifetime, protocol, "CWMExternalSystemModel")
            }
        }
        
        
        const val serializationHash = -5068726646684443102L
        
    }
    override val serializersOwner: ISerializersOwner get() = CWMExternalSystemModel
    override val serializationHash: Long get() = CWMExternalSystemModel.serializationHash
    
    //fields
    val onStart: IAsyncSignal<OnStartArgs> get() = _onStart
    val onTaskOutput: IAsyncSignal<OnTaskOutputArgs> get() = _onTaskOutput
    val onStatusChange: IAsyncSignal<OnStatusChangeArgs> get() = _onStatusChange
    val onStatusChangeBuild: IAsyncSignal<OnStatusChangeArgs2> get() = _onStatusChangeBuild
    val onSuccess: IAsyncSignal<OnSuccessArgs> get() = _onSuccess
    val onFailure: IAsyncSignal<OnFailureArgs> get() = _onFailure
    val onCancel: IAsyncSignal<OnCancelArgs> get() = _onCancel
    val onEnd: IAsyncSignal<OnEndArgs> get() = _onEnd
    //methods
    //initializer
    init {
        _onStart.async = true
        _onTaskOutput.async = true
        _onStatusChange.async = true
        _onStatusChangeBuild.async = true
        _onSuccess.async = true
        _onFailure.async = true
        _onCancel.async = true
        _onEnd.async = true
    }
    
    init {
        bindableChildren.add("onStart" to _onStart)
        bindableChildren.add("onTaskOutput" to _onTaskOutput)
        bindableChildren.add("onStatusChange" to _onStatusChange)
        bindableChildren.add("onStatusChangeBuild" to _onStatusChangeBuild)
        bindableChildren.add("onSuccess" to _onSuccess)
        bindableChildren.add("onFailure" to _onFailure)
        bindableChildren.add("onCancel" to _onCancel)
        bindableChildren.add("onEnd" to _onEnd)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdSignal<OnStartArgs>(OnStartArgs),
        RdSignal<OnTaskOutputArgs>(OnTaskOutputArgs),
        RdSignal<OnStatusChangeArgs>(OnStatusChangeArgs),
        RdSignal<OnStatusChangeArgs2>(OnStatusChangeArgs2),
        RdSignal<OnSuccessArgs>(OnSuccessArgs),
        RdSignal<OnFailureArgs>(OnFailureArgs),
        RdSignal<OnCancelArgs>(OnCancelArgs),
        RdSignal<OnEndArgs>(OnEndArgs)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CWMExternalSystemModel (")
        printer.indent {
            print("onStart = "); _onStart.print(printer); println()
            print("onTaskOutput = "); _onTaskOutput.print(printer); println()
            print("onStatusChange = "); _onStatusChange.print(printer); println()
            print("onStatusChangeBuild = "); _onStatusChangeBuild.print(printer); println()
            print("onSuccess = "); _onSuccess.print(printer); println()
            print("onFailure = "); _onFailure.print(printer); println()
            print("onCancel = "); _onCancel.print(printer); println()
            print("onEnd = "); _onEnd.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CWMExternalSystemModel   {
        return CWMExternalSystemModel(
            _onStart.deepClonePolymorphic(),
            _onTaskOutput.deepClonePolymorphic(),
            _onStatusChange.deepClonePolymorphic(),
            _onStatusChangeBuild.deepClonePolymorphic(),
            _onSuccess.deepClonePolymorphic(),
            _onFailure.deepClonePolymorphic(),
            _onCancel.deepClonePolymorphic(),
            _onEnd.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class ExternalSystemFinishEventModel (
    val result: OperationResultModel,
    eventId: String,
    parentEventId: String?,
    description: OperationDescriptorModel
) : ExternalSystemTaskExecutionEventModel (
    eventId,
    parentEventId,
    description
) {
    //companion
    
    companion object : IMarshaller<ExternalSystemFinishEventModel> {
        override val _type: KClass<ExternalSystemFinishEventModel> = ExternalSystemFinishEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ExternalSystemFinishEventModel  {
            val eventId = buffer.readString()
            val parentEventId = buffer.readNullable { buffer.readString() }
            val description = OperationDescriptorModel.read(ctx, buffer)
            val result = buffer.readEnum<OperationResultModel>()
            return ExternalSystemFinishEventModel(result, eventId, parentEventId, description)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ExternalSystemFinishEventModel)  {
            buffer.writeString(value.eventId)
            buffer.writeNullable(value.parentEventId) { buffer.writeString(it) }
            OperationDescriptorModel.write(ctx, buffer, value.description)
            buffer.writeEnum(value.result)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ExternalSystemFinishEventModel
        
        if (result != other.result) return false
        if (eventId != other.eventId) return false
        if (parentEventId != other.parentEventId) return false
        if (description != other.description) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + result.hashCode()
        __r = __r*31 + eventId.hashCode()
        __r = __r*31 + if (parentEventId != null) parentEventId.hashCode() else 0
        __r = __r*31 + description.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ExternalSystemFinishEventModel (")
        printer.indent {
            print("result = "); result.print(printer); println()
            print("eventId = "); eventId.print(printer); println()
            print("parentEventId = "); parentEventId.print(printer); println()
            print("description = "); description.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
abstract class ExternalSystemIdHolder (
    val id: ExternalSystemTaskIdModel
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<ExternalSystemIdHolder> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ExternalSystemIdHolder  {
            val objectStartPosition = buffer.position
            val id = ExternalSystemTaskIdModel.read(ctx, buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ExternalSystemIdHolder_Unknown(id, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ExternalSystemIdHolder_Unknown (
    id: ExternalSystemTaskIdModel,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ExternalSystemIdHolder (
    id
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ExternalSystemIdHolder_Unknown> {
        override val _type: KClass<ExternalSystemIdHolder_Unknown> = ExternalSystemIdHolder_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ExternalSystemIdHolder_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ExternalSystemIdHolder_Unknown)  {
            ExternalSystemTaskIdModel.write(ctx, buffer, value.id)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ExternalSystemIdHolder_Unknown
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ExternalSystemIdHolder_Unknown (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class ExternalSystemStartEventModel (
    eventId: String,
    parentEventId: String?,
    description: OperationDescriptorModel
) : ExternalSystemTaskExecutionEventModel (
    eventId,
    parentEventId,
    description
) {
    //companion
    
    companion object : IMarshaller<ExternalSystemStartEventModel> {
        override val _type: KClass<ExternalSystemStartEventModel> = ExternalSystemStartEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ExternalSystemStartEventModel  {
            val eventId = buffer.readString()
            val parentEventId = buffer.readNullable { buffer.readString() }
            val description = OperationDescriptorModel.read(ctx, buffer)
            return ExternalSystemStartEventModel(eventId, parentEventId, description)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ExternalSystemStartEventModel)  {
            buffer.writeString(value.eventId)
            buffer.writeNullable(value.parentEventId) { buffer.writeString(it) }
            OperationDescriptorModel.write(ctx, buffer, value.description)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ExternalSystemStartEventModel
        
        if (eventId != other.eventId) return false
        if (parentEventId != other.parentEventId) return false
        if (description != other.description) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + eventId.hashCode()
        __r = __r*31 + if (parentEventId != null) parentEventId.hashCode() else 0
        __r = __r*31 + description.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ExternalSystemStartEventModel (")
        printer.indent {
            print("eventId = "); eventId.print(printer); println()
            print("parentEventId = "); parentEventId.print(printer); println()
            print("description = "); description.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class ExternalSystemStatusEventModel (
    eventId: String,
    parentEventId: String?,
    description: OperationDescriptorModel
) : ExternalSystemTaskExecutionEventModel (
    eventId,
    parentEventId,
    description
) {
    //companion
    
    companion object : IMarshaller<ExternalSystemStatusEventModel> {
        override val _type: KClass<ExternalSystemStatusEventModel> = ExternalSystemStatusEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ExternalSystemStatusEventModel  {
            val eventId = buffer.readString()
            val parentEventId = buffer.readNullable { buffer.readString() }
            val description = OperationDescriptorModel.read(ctx, buffer)
            return ExternalSystemStatusEventModel(eventId, parentEventId, description)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ExternalSystemStatusEventModel)  {
            buffer.writeString(value.eventId)
            buffer.writeNullable(value.parentEventId) { buffer.writeString(it) }
            OperationDescriptorModel.write(ctx, buffer, value.description)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ExternalSystemStatusEventModel
        
        if (eventId != other.eventId) return false
        if (parentEventId != other.parentEventId) return false
        if (description != other.description) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + eventId.hashCode()
        __r = __r*31 + if (parentEventId != null) parentEventId.hashCode() else 0
        __r = __r*31 + description.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ExternalSystemStatusEventModel (")
        printer.indent {
            print("eventId = "); eventId.print(printer); println()
            print("parentEventId = "); parentEventId.print(printer); println()
            print("description = "); description.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
abstract class ExternalSystemTaskExecutionEventModel (
    val eventId: String,
    val parentEventId: String?,
    val description: OperationDescriptorModel
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<ExternalSystemTaskExecutionEventModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ExternalSystemTaskExecutionEventModel  {
            val objectStartPosition = buffer.position
            val eventId = buffer.readString()
            val parentEventId = buffer.readNullable { buffer.readString() }
            val description = OperationDescriptorModel.read(ctx, buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ExternalSystemTaskExecutionEventModel_Unknown(eventId, parentEventId, description, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ExternalSystemTaskExecutionEventModel_Unknown (
    eventId: String,
    parentEventId: String?,
    description: OperationDescriptorModel,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ExternalSystemTaskExecutionEventModel (
    eventId,
    parentEventId,
    description
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ExternalSystemTaskExecutionEventModel_Unknown> {
        override val _type: KClass<ExternalSystemTaskExecutionEventModel_Unknown> = ExternalSystemTaskExecutionEventModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ExternalSystemTaskExecutionEventModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ExternalSystemTaskExecutionEventModel_Unknown)  {
            buffer.writeString(value.eventId)
            buffer.writeNullable(value.parentEventId) { buffer.writeString(it) }
            OperationDescriptorModel.write(ctx, buffer, value.description)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ExternalSystemTaskExecutionEventModel_Unknown
        
        if (eventId != other.eventId) return false
        if (parentEventId != other.parentEventId) return false
        if (description != other.description) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + eventId.hashCode()
        __r = __r*31 + if (parentEventId != null) parentEventId.hashCode() else 0
        __r = __r*31 + description.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ExternalSystemTaskExecutionEventModel_Unknown (")
        printer.indent {
            print("eventId = "); eventId.print(printer); println()
            print("parentEventId = "); parentEventId.print(printer); println()
            print("description = "); description.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
data class ExternalSystemTaskIdModel (
    val projectSystemId: String,
    val externalSystemTaskType: ExternalSystemTaskTypeModel,
    val id: Long
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ExternalSystemTaskIdModel> {
        override val _type: KClass<ExternalSystemTaskIdModel> = ExternalSystemTaskIdModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ExternalSystemTaskIdModel  {
            val projectSystemId = buffer.readString()
            val externalSystemTaskType = buffer.readEnum<ExternalSystemTaskTypeModel>()
            val id = buffer.readLong()
            return ExternalSystemTaskIdModel(projectSystemId, externalSystemTaskType, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ExternalSystemTaskIdModel)  {
            buffer.writeString(value.projectSystemId)
            buffer.writeEnum(value.externalSystemTaskType)
            buffer.writeLong(value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ExternalSystemTaskIdModel
        
        if (projectSystemId != other.projectSystemId) return false
        if (externalSystemTaskType != other.externalSystemTaskType) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + projectSystemId.hashCode()
        __r = __r*31 + externalSystemTaskType.hashCode()
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ExternalSystemTaskIdModel (")
        printer.indent {
            print("projectSystemId = "); projectSystemId.print(printer); println()
            print("externalSystemTaskType = "); externalSystemTaskType.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
enum class ExternalSystemTaskTypeModel {
    ResolveProject, 
    RefreshTasksList, 
    ExecuteTask;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ExternalSystemTaskTypeModel>()
        
    }
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class OnCancelArgs (
    id: ExternalSystemTaskIdModel
) : ExternalSystemIdHolder (
    id
) {
    //companion
    
    companion object : IMarshaller<OnCancelArgs> {
        override val _type: KClass<OnCancelArgs> = OnCancelArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OnCancelArgs  {
            val id = ExternalSystemTaskIdModel.read(ctx, buffer)
            return OnCancelArgs(id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OnCancelArgs)  {
            ExternalSystemTaskIdModel.write(ctx, buffer, value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OnCancelArgs
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OnCancelArgs (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class OnEndArgs (
    id: ExternalSystemTaskIdModel
) : ExternalSystemIdHolder (
    id
) {
    //companion
    
    companion object : IMarshaller<OnEndArgs> {
        override val _type: KClass<OnEndArgs> = OnEndArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OnEndArgs  {
            val id = ExternalSystemTaskIdModel.read(ctx, buffer)
            return OnEndArgs(id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OnEndArgs)  {
            ExternalSystemTaskIdModel.write(ctx, buffer, value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OnEndArgs
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OnEndArgs (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class OnFailureArgs (
    val message: String,
    id: ExternalSystemTaskIdModel
) : ExternalSystemIdHolder (
    id
) {
    //companion
    
    companion object : IMarshaller<OnFailureArgs> {
        override val _type: KClass<OnFailureArgs> = OnFailureArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OnFailureArgs  {
            val id = ExternalSystemTaskIdModel.read(ctx, buffer)
            val message = buffer.readString()
            return OnFailureArgs(message, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OnFailureArgs)  {
            ExternalSystemTaskIdModel.write(ctx, buffer, value.id)
            buffer.writeString(value.message)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OnFailureArgs
        
        if (message != other.message) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + message.hashCode()
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OnFailureArgs (")
        printer.indent {
            print("message = "); message.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class OnStartArgs (
    val executionName: String,
    val taskNames: List<String>,
    id: ExternalSystemTaskIdModel
) : ExternalSystemIdHolder (
    id
) {
    //companion
    
    companion object : IMarshaller<OnStartArgs> {
        override val _type: KClass<OnStartArgs> = OnStartArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OnStartArgs  {
            val id = ExternalSystemTaskIdModel.read(ctx, buffer)
            val executionName = buffer.readString()
            val taskNames = buffer.readList { buffer.readString() }
            return OnStartArgs(executionName, taskNames, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OnStartArgs)  {
            ExternalSystemTaskIdModel.write(ctx, buffer, value.id)
            buffer.writeString(value.executionName)
            buffer.writeList(value.taskNames) { v -> buffer.writeString(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OnStartArgs
        
        if (executionName != other.executionName) return false
        if (taskNames != other.taskNames) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + executionName.hashCode()
        __r = __r*31 + taskNames.hashCode()
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OnStartArgs (")
        printer.indent {
            print("executionName = "); executionName.print(printer); println()
            print("taskNames = "); taskNames.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class OnStatusChangeArgs (
    val event: ExternalSystemTaskExecutionEventModel,
    id: ExternalSystemTaskIdModel
) : ExternalSystemIdHolder (
    id
) {
    //companion
    
    companion object : IMarshaller<OnStatusChangeArgs> {
        override val _type: KClass<OnStatusChangeArgs> = OnStatusChangeArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OnStatusChangeArgs  {
            val id = ExternalSystemTaskIdModel.read(ctx, buffer)
            val event = ctx.serializers.readPolymorphic<ExternalSystemTaskExecutionEventModel>(ctx, buffer, ExternalSystemTaskExecutionEventModel)
            return OnStatusChangeArgs(event, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OnStatusChangeArgs)  {
            ExternalSystemTaskIdModel.write(ctx, buffer, value.id)
            ctx.serializers.writePolymorphic(ctx, buffer, value.event)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OnStatusChangeArgs
        
        if (event != other.event) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + event.hashCode()
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OnStatusChangeArgs (")
        printer.indent {
            print("event = "); event.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class OnStatusChangeArgs2 (
    val buildEvent: BuildEventModel,
    id: ExternalSystemTaskIdModel
) : ExternalSystemIdHolder (
    id
) {
    //companion
    
    companion object : IMarshaller<OnStatusChangeArgs2> {
        override val _type: KClass<OnStatusChangeArgs2> = OnStatusChangeArgs2::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OnStatusChangeArgs2  {
            val id = ExternalSystemTaskIdModel.read(ctx, buffer)
            val buildEvent = ctx.serializers.readPolymorphic<BuildEventModel>(ctx, buffer, BuildEventModel)
            return OnStatusChangeArgs2(buildEvent, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OnStatusChangeArgs2)  {
            ExternalSystemTaskIdModel.write(ctx, buffer, value.id)
            ctx.serializers.writePolymorphic(ctx, buffer, value.buildEvent)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OnStatusChangeArgs2
        
        if (buildEvent != other.buildEvent) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + buildEvent.hashCode()
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OnStatusChangeArgs2 (")
        printer.indent {
            print("buildEvent = "); buildEvent.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class OnSuccessArgs (
    id: ExternalSystemTaskIdModel
) : ExternalSystemIdHolder (
    id
) {
    //companion
    
    companion object : IMarshaller<OnSuccessArgs> {
        override val _type: KClass<OnSuccessArgs> = OnSuccessArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OnSuccessArgs  {
            val id = ExternalSystemTaskIdModel.read(ctx, buffer)
            return OnSuccessArgs(id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OnSuccessArgs)  {
            ExternalSystemTaskIdModel.write(ctx, buffer, value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OnSuccessArgs
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OnSuccessArgs (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
class OnTaskOutputArgs (
    val text: String,
    val stdOut: Boolean,
    id: ExternalSystemTaskIdModel
) : ExternalSystemIdHolder (
    id
) {
    //companion
    
    companion object : IMarshaller<OnTaskOutputArgs> {
        override val _type: KClass<OnTaskOutputArgs> = OnTaskOutputArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OnTaskOutputArgs  {
            val id = ExternalSystemTaskIdModel.read(ctx, buffer)
            val text = buffer.readString()
            val stdOut = buffer.readBool()
            return OnTaskOutputArgs(text, stdOut, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OnTaskOutputArgs)  {
            ExternalSystemTaskIdModel.write(ctx, buffer, value.id)
            buffer.writeString(value.text)
            buffer.writeBool(value.stdOut)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OnTaskOutputArgs
        
        if (text != other.text) return false
        if (stdOut != other.stdOut) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + stdOut.hashCode()
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OnTaskOutputArgs (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("stdOut = "); stdOut.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
data class OperationDescriptorModel (
    val displayName: String,
    val eventTime: Long
) : IPrintable {
    //companion
    
    companion object : IMarshaller<OperationDescriptorModel> {
        override val _type: KClass<OperationDescriptorModel> = OperationDescriptorModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OperationDescriptorModel  {
            val displayName = buffer.readString()
            val eventTime = buffer.readLong()
            return OperationDescriptorModel(displayName, eventTime)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OperationDescriptorModel)  {
            buffer.writeString(value.displayName)
            buffer.writeLong(value.eventTime)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OperationDescriptorModel
        
        if (displayName != other.displayName) return false
        if (eventTime != other.eventTime) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + displayName.hashCode()
        __r = __r*31 + eventTime.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OperationDescriptorModel (")
        printer.indent {
            print("displayName = "); displayName.print(printer); println()
            print("eventTime = "); eventTime.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CWMExternalSystemModel.kt]
 */
enum class OperationResultModel {
    Success, 
    Failure, 
    Skipped;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<OperationResultModel>()
        
    }
}
