@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CodeLensModel.kt]
 */
class CodeLensModel internal constructor(
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(TextCodeLensEntry)
            serializers.register(CounterCodeLensEntry)
            serializers.register(RichTextCodeLensEntry)
            serializers.register(CodeLensHighlighterModel)
            serializers.register(CodeLensVcsRangeHighlighterModel)
            serializers.register(CodeLensEntryExtraActionModel)
            serializers.register(CodeLensEntryBase_Unknown)
        }
        
        
        
        
        const val serializationHash = -5912450867035737892L
        
    }
    override val serializersOwner: ISerializersOwner get() = CodeLensModel
    override val serializationHash: Long get() = CodeLensModel.serializationHash
    
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeLensModel (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeLensModel   {
        return CodeLensModel(
        )
    }
    //contexts
}
val RdDocumentModel.codeLensModel get() = getOrCreateExtension("codeLensModel", ::CodeLensModel)



/**
 * @property providerId The provider ID of this entry
 * @property icon Icon to show near this entry in editor
 * @property longPresentation The text in 'More' menu
 * @property tooltip Tooltip text
 * @property extraActions Extra actions for this lens
 * #### Generated from [CodeLensModel.kt]
 */
abstract class CodeLensEntryBase (
    val providerId: String,
    val icon: IconModel?,
    val longPresentation: String,
    val tooltip: String,
    val extraActions: List<CodeLensEntryExtraActionModel>
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<CodeLensEntryBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): CodeLensEntryBase  {
            val objectStartPosition = buffer.position
            val providerId = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val longPresentation = buffer.readString()
            val tooltip = buffer.readString()
            val extraActions = buffer.readList { CodeLensEntryExtraActionModel.read(ctx, buffer) }
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return CodeLensEntryBase_Unknown(providerId, icon, longPresentation, tooltip, extraActions, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class CodeLensEntryBase_Unknown (
    providerId: String,
    icon: IconModel?,
    longPresentation: String,
    tooltip: String,
    extraActions: List<CodeLensEntryExtraActionModel>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : CodeLensEntryBase (
    providerId,
    icon,
    longPresentation,
    tooltip,
    extraActions
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<CodeLensEntryBase_Unknown> {
        override val _type: KClass<CodeLensEntryBase_Unknown> = CodeLensEntryBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeLensEntryBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeLensEntryBase_Unknown)  {
            buffer.writeString(value.providerId)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeString(value.longPresentation)
            buffer.writeString(value.tooltip)
            buffer.writeList(value.extraActions) { v -> CodeLensEntryExtraActionModel.write(ctx, buffer, v) }
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CodeLensEntryBase_Unknown
        
        if (providerId != other.providerId) return false
        if (icon != other.icon) return false
        if (longPresentation != other.longPresentation) return false
        if (tooltip != other.tooltip) return false
        if (extraActions != other.extraActions) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + providerId.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + longPresentation.hashCode()
        __r = __r*31 + tooltip.hashCode()
        __r = __r*31 + extraActions.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeLensEntryBase_Unknown (")
        printer.indent {
            print("providerId = "); providerId.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("longPresentation = "); longPresentation.print(printer); println()
            print("tooltip = "); tooltip.print(printer); println()
            print("extraActions = "); extraActions.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * @property displayText Text that will be displayed in the UI
 * @property actionId Action ID passed to provider when this action is invoked. null for non-clicable line
 * #### Generated from [CodeLensModel.kt]
 */
data class CodeLensEntryExtraActionModel (
    val displayText: String,
    val actionId: String?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CodeLensEntryExtraActionModel> {
        override val _type: KClass<CodeLensEntryExtraActionModel> = CodeLensEntryExtraActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeLensEntryExtraActionModel  {
            val displayText = buffer.readString()
            val actionId = buffer.readNullable { buffer.readString() }
            return CodeLensEntryExtraActionModel(displayText, actionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeLensEntryExtraActionModel)  {
            buffer.writeString(value.displayText)
            buffer.writeNullable(value.actionId) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CodeLensEntryExtraActionModel
        
        if (displayText != other.displayText) return false
        if (actionId != other.actionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + displayText.hashCode()
        __r = __r*31 + if (actionId != null) actionId.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeLensEntryExtraActionModel (")
        printer.indent {
            print("displayText = "); displayText.print(printer); println()
            print("actionId = "); actionId.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeLensModel.kt]
 */
class CodeLensHighlighterModel (
    val codeLensEntry: CodeLensEntryBase,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<CodeLensHighlighterModel> {
        override val _type: KClass<CodeLensHighlighterModel> = CodeLensHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeLensHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val codeLensEntry = ctx.serializers.readPolymorphic<CodeLensEntryBase>(ctx, buffer, CodeLensEntryBase)
            return CodeLensHighlighterModel(codeLensEntry, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeLensHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            ctx.serializers.writePolymorphic(ctx, buffer, value.codeLensEntry)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CodeLensHighlighterModel
        
        if (codeLensEntry != other.codeLensEntry) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + codeLensEntry.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeLensHighlighterModel (")
        printer.indent {
            print("codeLensEntry = "); codeLensEntry.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeLensModel.kt]
 */
class CodeLensVcsRangeHighlighterModel (
    val pairingId: Int,
    val isBody: Boolean,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<CodeLensVcsRangeHighlighterModel> {
        override val _type: KClass<CodeLensVcsRangeHighlighterModel> = CodeLensVcsRangeHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeLensVcsRangeHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val pairingId = buffer.readInt()
            val isBody = buffer.readBool()
            return CodeLensVcsRangeHighlighterModel(pairingId, isBody, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeLensVcsRangeHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeInt(value.pairingId)
            buffer.writeBool(value.isBody)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CodeLensVcsRangeHighlighterModel
        
        if (pairingId != other.pairingId) return false
        if (isBody != other.isBody) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + pairingId.hashCode()
        __r = __r*31 + isBody.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeLensVcsRangeHighlighterModel (")
        printer.indent {
            print("pairingId = "); pairingId.print(printer); println()
            print("isBody = "); isBody.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeLensModel.kt]
 */
class CounterCodeLensEntry (
    val count: Int,
    val text: String,
    providerId: String,
    icon: IconModel?,
    longPresentation: String,
    tooltip: String,
    extraActions: List<CodeLensEntryExtraActionModel>
) : CodeLensEntryBase (
    providerId,
    icon,
    longPresentation,
    tooltip,
    extraActions
) {
    //companion
    
    companion object : IMarshaller<CounterCodeLensEntry> {
        override val _type: KClass<CounterCodeLensEntry> = CounterCodeLensEntry::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CounterCodeLensEntry  {
            val providerId = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val longPresentation = buffer.readString()
            val tooltip = buffer.readString()
            val extraActions = buffer.readList { CodeLensEntryExtraActionModel.read(ctx, buffer) }
            val count = buffer.readInt()
            val text = buffer.readString()
            return CounterCodeLensEntry(count, text, providerId, icon, longPresentation, tooltip, extraActions)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CounterCodeLensEntry)  {
            buffer.writeString(value.providerId)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeString(value.longPresentation)
            buffer.writeString(value.tooltip)
            buffer.writeList(value.extraActions) { v -> CodeLensEntryExtraActionModel.write(ctx, buffer, v) }
            buffer.writeInt(value.count)
            buffer.writeString(value.text)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CounterCodeLensEntry
        
        if (count != other.count) return false
        if (text != other.text) return false
        if (providerId != other.providerId) return false
        if (icon != other.icon) return false
        if (longPresentation != other.longPresentation) return false
        if (tooltip != other.tooltip) return false
        if (extraActions != other.extraActions) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + count.hashCode()
        __r = __r*31 + text.hashCode()
        __r = __r*31 + providerId.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + longPresentation.hashCode()
        __r = __r*31 + tooltip.hashCode()
        __r = __r*31 + extraActions.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CounterCodeLensEntry (")
        printer.indent {
            print("count = "); count.print(printer); println()
            print("text = "); text.print(printer); println()
            print("providerId = "); providerId.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("longPresentation = "); longPresentation.print(printer); println()
            print("tooltip = "); tooltip.print(printer); println()
            print("extraActions = "); extraActions.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeLensModel.kt]
 */
class RichTextCodeLensEntry (
    val text: RichTextModel,
    providerId: String,
    icon: IconModel?,
    longPresentation: String,
    tooltip: String,
    extraActions: List<CodeLensEntryExtraActionModel>
) : CodeLensEntryBase (
    providerId,
    icon,
    longPresentation,
    tooltip,
    extraActions
) {
    //companion
    
    companion object : IMarshaller<RichTextCodeLensEntry> {
        override val _type: KClass<RichTextCodeLensEntry> = RichTextCodeLensEntry::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RichTextCodeLensEntry  {
            val providerId = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val longPresentation = buffer.readString()
            val tooltip = buffer.readString()
            val extraActions = buffer.readList { CodeLensEntryExtraActionModel.read(ctx, buffer) }
            val text = RichTextModel.read(ctx, buffer)
            return RichTextCodeLensEntry(text, providerId, icon, longPresentation, tooltip, extraActions)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RichTextCodeLensEntry)  {
            buffer.writeString(value.providerId)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeString(value.longPresentation)
            buffer.writeString(value.tooltip)
            buffer.writeList(value.extraActions) { v -> CodeLensEntryExtraActionModel.write(ctx, buffer, v) }
            RichTextModel.write(ctx, buffer, value.text)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RichTextCodeLensEntry
        
        if (text != other.text) return false
        if (providerId != other.providerId) return false
        if (icon != other.icon) return false
        if (longPresentation != other.longPresentation) return false
        if (tooltip != other.tooltip) return false
        if (extraActions != other.extraActions) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + providerId.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + longPresentation.hashCode()
        __r = __r*31 + tooltip.hashCode()
        __r = __r*31 + extraActions.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RichTextCodeLensEntry (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("providerId = "); providerId.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("longPresentation = "); longPresentation.print(printer); println()
            print("tooltip = "); tooltip.print(printer); println()
            print("extraActions = "); extraActions.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeLensModel.kt]
 */
class TextCodeLensEntry (
    val text: String,
    providerId: String,
    icon: IconModel?,
    longPresentation: String,
    tooltip: String,
    extraActions: List<CodeLensEntryExtraActionModel>
) : CodeLensEntryBase (
    providerId,
    icon,
    longPresentation,
    tooltip,
    extraActions
) {
    //companion
    
    companion object : IMarshaller<TextCodeLensEntry> {
        override val _type: KClass<TextCodeLensEntry> = TextCodeLensEntry::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TextCodeLensEntry  {
            val providerId = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val longPresentation = buffer.readString()
            val tooltip = buffer.readString()
            val extraActions = buffer.readList { CodeLensEntryExtraActionModel.read(ctx, buffer) }
            val text = buffer.readString()
            return TextCodeLensEntry(text, providerId, icon, longPresentation, tooltip, extraActions)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TextCodeLensEntry)  {
            buffer.writeString(value.providerId)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeString(value.longPresentation)
            buffer.writeString(value.tooltip)
            buffer.writeList(value.extraActions) { v -> CodeLensEntryExtraActionModel.write(ctx, buffer, v) }
            buffer.writeString(value.text)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TextCodeLensEntry
        
        if (text != other.text) return false
        if (providerId != other.providerId) return false
        if (icon != other.icon) return false
        if (longPresentation != other.longPresentation) return false
        if (tooltip != other.tooltip) return false
        if (extraActions != other.extraActions) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + providerId.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + longPresentation.hashCode()
        __r = __r*31 + tooltip.hashCode()
        __r = __r*31 + extraActions.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TextCodeLensEntry (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("providerId = "); providerId.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("longPresentation = "); longPresentation.print(printer); println()
            print("tooltip = "); tooltip.print(printer); println()
            print("extraActions = "); extraActions.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
