@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CodeInsightModels.kt]
 */
class CodeStructureTreeModel private constructor(
    private val _toolWindowVisible: RdOptionalProperty<Boolean>,
    private val _treeNodes: RdOptionalProperty<CodeStructureTreeNodesList>,
    private val _navigateTo: RdSignal<CodeStructureNavigateTo>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(CodeStructureTreeNodesList)
            serializers.register(CodeStructureNavigateTo)
            serializers.register(CodeStructureTreeNode)
        }
        
        
        
        
        const val serializationHash = -4979378072575974101L
        
    }
    override val serializersOwner: ISerializersOwner get() = CodeStructureTreeModel
    override val serializationHash: Long get() = CodeStructureTreeModel.serializationHash
    
    //fields
    val toolWindowVisible: IOptProperty<Boolean> get() = _toolWindowVisible
    val treeNodes: IOptProperty<CodeStructureTreeNodesList> get() = _treeNodes
    
    /**
     * Receives the ID of a node and navigates to it in the editor, transferring focus to it if necessary
     */
    val navigateTo: ISignal<CodeStructureNavigateTo> get() = _navigateTo
    //methods
    //initializer
    init {
        _toolWindowVisible.optimizeNested = true
        _treeNodes.optimizeNested = true
    }
    
    init {
        _treeNodes.async = true
    }
    
    init {
        bindableChildren.add("toolWindowVisible" to _toolWindowVisible)
        bindableChildren.add("treeNodes" to _treeNodes)
        bindableChildren.add("navigateTo" to _navigateTo)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<CodeStructureTreeNodesList>(CodeStructureTreeNodesList),
        RdSignal<CodeStructureNavigateTo>(CodeStructureNavigateTo)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeStructureTreeModel (")
        printer.indent {
            print("toolWindowVisible = "); _toolWindowVisible.print(printer); println()
            print("treeNodes = "); _treeNodes.print(printer); println()
            print("navigateTo = "); _navigateTo.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeStructureTreeModel   {
        return CodeStructureTreeModel(
            _toolWindowVisible.deepClonePolymorphic(),
            _treeNodes.deepClonePolymorphic(),
            _navigateTo.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.codeStructureTreeModel get() = getOrCreateExtension("codeStructureTreeModel", ::CodeStructureTreeModel)



/**
 * @property node The ID (CodeStructureTreeNode.id) of a node
 * @property requestFocus If true, transfer focus to the editor
 * #### Generated from [CodeInsightModels.kt]
 */
data class CodeStructureNavigateTo (
    val node: Int,
    val requestFocus: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CodeStructureNavigateTo> {
        override val _type: KClass<CodeStructureNavigateTo> = CodeStructureNavigateTo::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeStructureNavigateTo  {
            val node = buffer.readInt()
            val requestFocus = buffer.readBool()
            return CodeStructureNavigateTo(node, requestFocus)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeStructureNavigateTo)  {
            buffer.writeInt(value.node)
            buffer.writeBool(value.requestFocus)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CodeStructureNavigateTo
        
        if (node != other.node) return false
        if (requestFocus != other.requestFocus) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + node.hashCode()
        __r = __r*31 + requestFocus.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeStructureNavigateTo (")
        printer.indent {
            print("node = "); node.print(printer); println()
            print("requestFocus = "); requestFocus.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * @property id ID of the element. Used in navigateTo() and in RdFileStructureConstant.
 * @property children List of indices in treeNodes array of the children of this node.
 * @property navigable Whether the Navigate and Navigate to Source actions are enabled for this node.
 * @property offset Start offset of the element represented by this node.
 * @property endOffset End offset of the element represented by this node.
 * @property name Text to show in the structure view tree for this node.
 * @property icon Icon to show in the structure view tree for this node.
 * @property declarationRange Text range that defines declaration part of this node
 * #### Generated from [CodeInsightModels.kt]
 */
data class CodeStructureTreeNode (
    val id: Int,
    val children: List<Int>,
    val navigable: Boolean,
    val offset: Int,
    val endOffset: Int,
    val name: String,
    val icon: IconModel?,
    val declarationRange: RdTextRange?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CodeStructureTreeNode> {
        override val _type: KClass<CodeStructureTreeNode> = CodeStructureTreeNode::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeStructureTreeNode  {
            val id = buffer.readInt()
            val children = buffer.readList { buffer.readInt() }
            val navigable = buffer.readBool()
            val offset = buffer.readInt()
            val endOffset = buffer.readInt()
            val name = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val declarationRange = buffer.readNullable { RdTextRange.read(ctx, buffer) }
            return CodeStructureTreeNode(id, children, navigable, offset, endOffset, name, icon, declarationRange)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeStructureTreeNode)  {
            buffer.writeInt(value.id)
            buffer.writeList(value.children) { v -> buffer.writeInt(v) }
            buffer.writeBool(value.navigable)
            buffer.writeInt(value.offset)
            buffer.writeInt(value.endOffset)
            buffer.writeString(value.name)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.declarationRange) { RdTextRange.write(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CodeStructureTreeNode
        
        if (id != other.id) return false
        if (children != other.children) return false
        if (navigable != other.navigable) return false
        if (offset != other.offset) return false
        if (endOffset != other.endOffset) return false
        if (name != other.name) return false
        if (icon != other.icon) return false
        if (declarationRange != other.declarationRange) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + children.hashCode()
        __r = __r*31 + navigable.hashCode()
        __r = __r*31 + offset.hashCode()
        __r = __r*31 + endOffset.hashCode()
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + if (declarationRange != null) declarationRange.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeStructureTreeNode (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("children = "); children.print(printer); println()
            print("navigable = "); navigable.print(printer); println()
            print("offset = "); offset.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
            print("name = "); name.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("declarationRange = "); declarationRange.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeInsightModels.kt]
 */
data class CodeStructureTreeNodesList (
    val documentId: RdDocumentId?,
    val treeNodes: List<CodeStructureTreeNode>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CodeStructureTreeNodesList> {
        override val _type: KClass<CodeStructureTreeNodesList> = CodeStructureTreeNodesList::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeStructureTreeNodesList  {
            val documentId = buffer.readNullable { ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId) }
            val treeNodes = buffer.readList { CodeStructureTreeNode.read(ctx, buffer) }
            return CodeStructureTreeNodesList(documentId, treeNodes)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeStructureTreeNodesList)  {
            buffer.writeNullable(value.documentId) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeList(value.treeNodes) { v -> CodeStructureTreeNode.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CodeStructureTreeNodesList
        
        if (documentId != other.documentId) return false
        if (treeNodes != other.treeNodes) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (documentId != null) documentId.hashCode() else 0
        __r = __r*31 + treeNodes.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeStructureTreeNodesList (")
        printer.indent {
            print("documentId = "); documentId.print(printer); println()
            print("treeNodes = "); treeNodes.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
