@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CodeWithMeBreakpointsModel.kt]
 */
class CodeWithMeBreakpointsModel private constructor(
    private val _breakpointTypes: RdMap<String, BreakpointTypeModelBase>,
    private val _breakpoints: RdMap<String, CWMBreakpointModelBase>,
    private val _getCanPutAtTypes: RdCall<CanPutAtArgs, List<String>>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(CustomBreakpointTypeModel)
            serializers.register(LineBreakpointTypeModel)
            serializers.register(CWMLineBreakpointModel)
            serializers.register(CanPutAtArgs)
            serializers.register(BreakpointSuspendPolicy.marshaller)
            serializers.register(BreakpointTypeModelBase_Unknown)
            serializers.register(CWMBreakpointModelBase_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): CodeWithMeBreakpointsModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return CodeWithMeBreakpointsModel().apply {
                identify(protocol.identity, RdId.Null.mix("CodeWithMeBreakpointsModel"))
                bind(lifetime, protocol, "CodeWithMeBreakpointsModel")
            }
        }
        
        private val __StringListSerializer = FrameworkMarshallers.String.list()
        
        const val serializationHash = 741806794298619762L
        
    }
    override val serializersOwner: ISerializersOwner get() = CodeWithMeBreakpointsModel
    override val serializationHash: Long get() = CodeWithMeBreakpointsModel.serializationHash
    
    //fields
    val breakpointTypes: IMutableViewableMap<String, BreakpointTypeModelBase> get() = _breakpointTypes
    val breakpoints: IMutableViewableMap<String, CWMBreakpointModelBase> get() = _breakpoints
    val getCanPutAtTypes: RdCall<CanPutAtArgs, List<String>> get() = _getCanPutAtTypes
    //methods
    //initializer
    init {
        bindableChildren.add("breakpointTypes" to _breakpointTypes)
        bindableChildren.add("breakpoints" to _breakpoints)
        bindableChildren.add("getCanPutAtTypes" to _getCanPutAtTypes)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdMap<String, BreakpointTypeModelBase>(FrameworkMarshallers.String, AbstractPolymorphic(BreakpointTypeModelBase)),
        RdMap<String, CWMBreakpointModelBase>(FrameworkMarshallers.String, AbstractPolymorphic(CWMBreakpointModelBase)),
        RdCall<CanPutAtArgs, List<String>>(CanPutAtArgs, __StringListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeBreakpointsModel (")
        printer.indent {
            print("breakpointTypes = "); _breakpointTypes.print(printer); println()
            print("breakpoints = "); _breakpoints.print(printer); println()
            print("getCanPutAtTypes = "); _getCanPutAtTypes.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeBreakpointsModel   {
        return CodeWithMeBreakpointsModel(
            _breakpointTypes.deepClonePolymorphic(),
            _breakpoints.deepClonePolymorphic(),
            _getCanPutAtTypes.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeBreakpointsModel.kt]
 */
enum class BreakpointSuspendPolicy {
    All, 
    Thread, 
    None;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BreakpointSuspendPolicy>()
        
    }
}


/**
 * #### Generated from [CodeWithMeBreakpointsModel.kt]
 */
abstract class BreakpointTypeModelBase (
    val id: String,
    val title: String,
    val enabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    val disabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    val suspendNoneIcon: com.jetbrains.rd.ide.model.IconModel?,
    val mutedEnabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    val mutedDisabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    val pendingIcon: com.jetbrains.rd.ide.model.IconModel?,
    val inactiveDependentIcon: com.jetbrains.rd.ide.model.IconModel?
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<BreakpointTypeModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BreakpointTypeModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val id = buffer.readString()
            val title = buffer.readString()
            val enabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val disabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val suspendNoneIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val mutedEnabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val mutedDisabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val pendingIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val inactiveDependentIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BreakpointTypeModelBase_Unknown(id, title, enabledIcon, disabledIcon, suspendNoneIcon, mutedEnabledIcon, mutedDisabledIcon, pendingIcon, inactiveDependentIcon, unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BreakpointTypeModelBase_Unknown (
    id: String,
    title: String,
    enabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    disabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    suspendNoneIcon: com.jetbrains.rd.ide.model.IconModel?,
    mutedEnabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    mutedDisabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    pendingIcon: com.jetbrains.rd.ide.model.IconModel?,
    inactiveDependentIcon: com.jetbrains.rd.ide.model.IconModel?,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BreakpointTypeModelBase (
    id,
    title,
    enabledIcon,
    disabledIcon,
    suspendNoneIcon,
    mutedEnabledIcon,
    mutedDisabledIcon,
    pendingIcon,
    inactiveDependentIcon
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BreakpointTypeModelBase_Unknown> {
        override val _type: KClass<BreakpointTypeModelBase_Unknown> = BreakpointTypeModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BreakpointTypeModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BreakpointTypeModelBase_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeString(value.id)
            buffer.writeString(value.title)
            buffer.writeNullable(value.enabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.disabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.suspendNoneIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.mutedEnabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.mutedDisabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.pendingIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.inactiveDependentIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BreakpointTypeModelBase_Unknown (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("title = "); title.print(printer); println()
            print("enabledIcon = "); enabledIcon.print(printer); println()
            print("disabledIcon = "); disabledIcon.print(printer); println()
            print("suspendNoneIcon = "); suspendNoneIcon.print(printer); println()
            print("mutedEnabledIcon = "); mutedEnabledIcon.print(printer); println()
            print("mutedDisabledIcon = "); mutedDisabledIcon.print(printer); println()
            print("pendingIcon = "); pendingIcon.print(printer); println()
            print("inactiveDependentIcon = "); inactiveDependentIcon.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BreakpointTypeModelBase_Unknown   {
        return BreakpointTypeModelBase_Unknown(
            id,
            title,
            enabledIcon,
            disabledIcon,
            suspendNoneIcon,
            mutedEnabledIcon,
            mutedDisabledIcon,
            pendingIcon,
            inactiveDependentIcon,
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeBreakpointsModel.kt]
 */
abstract class CWMBreakpointModelBase (
    val id: String,
    val breakpointTypeId: String,
    protected val _isEnabled: RdOptionalProperty<Boolean>,
    protected val _suspendPolicy: RdOptionalProperty<BreakpointSuspendPolicy>
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<CWMBreakpointModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): CWMBreakpointModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val id = buffer.readString()
            val breakpointTypeId = buffer.readString()
            val _isEnabled = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _suspendPolicy = RdOptionalProperty.read(ctx, buffer, BreakpointSuspendPolicy.marshaller)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return CWMBreakpointModelBase_Unknown(id, breakpointTypeId, _isEnabled, _suspendPolicy, unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    val isEnabled: IOptProperty<Boolean> get() = _isEnabled
    val suspendPolicy: IOptProperty<BreakpointSuspendPolicy> get() = _suspendPolicy
    //methods
    //initializer
    init {
        _isEnabled.optimizeNested = true
        _suspendPolicy.optimizeNested = true
    }
    
    init {
        bindableChildren.add("isEnabled" to _isEnabled)
        bindableChildren.add("suspendPolicy" to _suspendPolicy)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class CWMBreakpointModelBase_Unknown (
    id: String,
    breakpointTypeId: String,
    _isEnabled: RdOptionalProperty<Boolean>,
    _suspendPolicy: RdOptionalProperty<BreakpointSuspendPolicy>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : CWMBreakpointModelBase (
    id,
    breakpointTypeId,
    _isEnabled,
    _suspendPolicy
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<CWMBreakpointModelBase_Unknown> {
        override val _type: KClass<CWMBreakpointModelBase_Unknown> = CWMBreakpointModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CWMBreakpointModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CWMBreakpointModelBase_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeString(value.id)
            buffer.writeString(value.breakpointTypeId)
            RdOptionalProperty.write(ctx, buffer, value._isEnabled)
            RdOptionalProperty.write(ctx, buffer, value._suspendPolicy)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        id: String,
        breakpointTypeId: String,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        id,
        breakpointTypeId,
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<BreakpointSuspendPolicy>(BreakpointSuspendPolicy.marshaller),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CWMBreakpointModelBase_Unknown (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("breakpointTypeId = "); breakpointTypeId.print(printer); println()
            print("isEnabled = "); _isEnabled.print(printer); println()
            print("suspendPolicy = "); _suspendPolicy.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CWMBreakpointModelBase_Unknown   {
        return CWMBreakpointModelBase_Unknown(
            id,
            breakpointTypeId,
            _isEnabled.deepClonePolymorphic(),
            _suspendPolicy.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeBreakpointsModel.kt]
 */
class CWMLineBreakpointModel private constructor(
    val fileId: com.jetbrains.rd.ide.model.RdFileId,
    val line: Int,
    id: String,
    breakpointTypeId: String,
    _isEnabled: RdOptionalProperty<Boolean>,
    _suspendPolicy: RdOptionalProperty<BreakpointSuspendPolicy>
) : CWMBreakpointModelBase (
    id,
    breakpointTypeId,
    _isEnabled,
    _suspendPolicy
) {
    //companion
    
    companion object : IMarshaller<CWMLineBreakpointModel> {
        override val _type: KClass<CWMLineBreakpointModel> = CWMLineBreakpointModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CWMLineBreakpointModel  {
            val _id = RdId.read(buffer)
            val id = buffer.readString()
            val breakpointTypeId = buffer.readString()
            val _isEnabled = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _suspendPolicy = RdOptionalProperty.read(ctx, buffer, BreakpointSuspendPolicy.marshaller)
            val fileId = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.RdFileId>(ctx, buffer, com.jetbrains.rd.ide.model.RdFileId)
            val line = buffer.readInt()
            return CWMLineBreakpointModel(fileId, line, id, breakpointTypeId, _isEnabled, _suspendPolicy).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CWMLineBreakpointModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.id)
            buffer.writeString(value.breakpointTypeId)
            RdOptionalProperty.write(ctx, buffer, value._isEnabled)
            RdOptionalProperty.write(ctx, buffer, value._suspendPolicy)
            ctx.serializers.writePolymorphic(ctx, buffer, value.fileId)
            buffer.writeInt(value.line)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        fileId: com.jetbrains.rd.ide.model.RdFileId,
        line: Int,
        id: String,
        breakpointTypeId: String
    ) : this(
        fileId,
        line,
        id,
        breakpointTypeId,
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<BreakpointSuspendPolicy>(BreakpointSuspendPolicy.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CWMLineBreakpointModel (")
        printer.indent {
            print("fileId = "); fileId.print(printer); println()
            print("line = "); line.print(printer); println()
            print("id = "); id.print(printer); println()
            print("breakpointTypeId = "); breakpointTypeId.print(printer); println()
            print("isEnabled = "); _isEnabled.print(printer); println()
            print("suspendPolicy = "); _suspendPolicy.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CWMLineBreakpointModel   {
        return CWMLineBreakpointModel(
            fileId,
            line,
            id,
            breakpointTypeId,
            _isEnabled.deepClonePolymorphic(),
            _suspendPolicy.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeBreakpointsModel.kt]
 */
data class CanPutAtArgs (
    val fileId: com.jetbrains.rd.ide.model.RdFileId,
    val line: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CanPutAtArgs> {
        override val _type: KClass<CanPutAtArgs> = CanPutAtArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CanPutAtArgs  {
            val fileId = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.RdFileId>(ctx, buffer, com.jetbrains.rd.ide.model.RdFileId)
            val line = buffer.readInt()
            return CanPutAtArgs(fileId, line)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CanPutAtArgs)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.fileId)
            buffer.writeInt(value.line)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CanPutAtArgs
        
        if (fileId != other.fileId) return false
        if (line != other.line) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fileId.hashCode()
        __r = __r*31 + line.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CanPutAtArgs (")
        printer.indent {
            print("fileId = "); fileId.print(printer); println()
            print("line = "); line.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeBreakpointsModel.kt]
 */
class CustomBreakpointTypeModel (
    id: String,
    title: String,
    enabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    disabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    suspendNoneIcon: com.jetbrains.rd.ide.model.IconModel?,
    mutedEnabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    mutedDisabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    pendingIcon: com.jetbrains.rd.ide.model.IconModel?,
    inactiveDependentIcon: com.jetbrains.rd.ide.model.IconModel?
) : BreakpointTypeModelBase (
    id,
    title,
    enabledIcon,
    disabledIcon,
    suspendNoneIcon,
    mutedEnabledIcon,
    mutedDisabledIcon,
    pendingIcon,
    inactiveDependentIcon
) {
    //companion
    
    companion object : IMarshaller<CustomBreakpointTypeModel> {
        override val _type: KClass<CustomBreakpointTypeModel> = CustomBreakpointTypeModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CustomBreakpointTypeModel  {
            val _id = RdId.read(buffer)
            val id = buffer.readString()
            val title = buffer.readString()
            val enabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val disabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val suspendNoneIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val mutedEnabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val mutedDisabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val pendingIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val inactiveDependentIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            return CustomBreakpointTypeModel(id, title, enabledIcon, disabledIcon, suspendNoneIcon, mutedEnabledIcon, mutedDisabledIcon, pendingIcon, inactiveDependentIcon).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CustomBreakpointTypeModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.id)
            buffer.writeString(value.title)
            buffer.writeNullable(value.enabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.disabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.suspendNoneIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.mutedEnabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.mutedDisabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.pendingIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.inactiveDependentIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CustomBreakpointTypeModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("title = "); title.print(printer); println()
            print("enabledIcon = "); enabledIcon.print(printer); println()
            print("disabledIcon = "); disabledIcon.print(printer); println()
            print("suspendNoneIcon = "); suspendNoneIcon.print(printer); println()
            print("mutedEnabledIcon = "); mutedEnabledIcon.print(printer); println()
            print("mutedDisabledIcon = "); mutedDisabledIcon.print(printer); println()
            print("pendingIcon = "); pendingIcon.print(printer); println()
            print("inactiveDependentIcon = "); inactiveDependentIcon.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CustomBreakpointTypeModel   {
        return CustomBreakpointTypeModel(
            id,
            title,
            enabledIcon,
            disabledIcon,
            suspendNoneIcon,
            mutedEnabledIcon,
            mutedDisabledIcon,
            pendingIcon,
            inactiveDependentIcon
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeBreakpointsModel.kt]
 */
class LineBreakpointTypeModel (
    val temporaryIcon: com.jetbrains.rd.ide.model.IconModel?,
    id: String,
    title: String,
    enabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    disabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    suspendNoneIcon: com.jetbrains.rd.ide.model.IconModel?,
    mutedEnabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    mutedDisabledIcon: com.jetbrains.rd.ide.model.IconModel?,
    pendingIcon: com.jetbrains.rd.ide.model.IconModel?,
    inactiveDependentIcon: com.jetbrains.rd.ide.model.IconModel?
) : BreakpointTypeModelBase (
    id,
    title,
    enabledIcon,
    disabledIcon,
    suspendNoneIcon,
    mutedEnabledIcon,
    mutedDisabledIcon,
    pendingIcon,
    inactiveDependentIcon
) {
    //companion
    
    companion object : IMarshaller<LineBreakpointTypeModel> {
        override val _type: KClass<LineBreakpointTypeModel> = LineBreakpointTypeModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LineBreakpointTypeModel  {
            val _id = RdId.read(buffer)
            val id = buffer.readString()
            val title = buffer.readString()
            val enabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val disabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val suspendNoneIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val mutedEnabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val mutedDisabledIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val pendingIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val inactiveDependentIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val temporaryIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            return LineBreakpointTypeModel(temporaryIcon, id, title, enabledIcon, disabledIcon, suspendNoneIcon, mutedEnabledIcon, mutedDisabledIcon, pendingIcon, inactiveDependentIcon).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LineBreakpointTypeModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.id)
            buffer.writeString(value.title)
            buffer.writeNullable(value.enabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.disabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.suspendNoneIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.mutedEnabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.mutedDisabledIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.pendingIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.inactiveDependentIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.temporaryIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LineBreakpointTypeModel (")
        printer.indent {
            print("temporaryIcon = "); temporaryIcon.print(printer); println()
            print("id = "); id.print(printer); println()
            print("title = "); title.print(printer); println()
            print("enabledIcon = "); enabledIcon.print(printer); println()
            print("disabledIcon = "); disabledIcon.print(printer); println()
            print("suspendNoneIcon = "); suspendNoneIcon.print(printer); println()
            print("mutedEnabledIcon = "); mutedEnabledIcon.print(printer); println()
            print("mutedDisabledIcon = "); mutedDisabledIcon.print(printer); println()
            print("pendingIcon = "); pendingIcon.print(printer); println()
            print("inactiveDependentIcon = "); inactiveDependentIcon.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): LineBreakpointTypeModel   {
        return LineBreakpointTypeModel(
            temporaryIcon,
            id,
            title,
            enabledIcon,
            disabledIcon,
            suspendNoneIcon,
            mutedEnabledIcon,
            mutedDisabledIcon,
            pendingIcon,
            inactiveDependentIcon
        )
    }
    //contexts
}
