@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CodeWithMeDebuggerModel private constructor(
    private val _sessions: RdList<CodeWithMeDebuggerSessionModel>,
    private val _startCommands: RdSignal<StartCommandArg>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(CodeWithMeSourcePositionModel)
            serializers.register(CodeWithMeSuspendContextModel)
            serializers.register(CodeWithMeExecutionStackModel)
            serializers.register(CodeWithMeEvaluateArg)
            serializers.register(CodeWithMeChildrenListLive)
            serializers.register(CodeWithMeValueModel)
            serializers.register(CodeWithMeValueGroupModel)
            serializers.register(CWMInlineDebuggerDataCallback)
            serializers.register(ConsoleViewContentTypeModel)
            serializers.register(CodeWithMeOutputMessage)
            serializers.register(BreakpointPresentationUpdatedArgs)
            serializers.register(CodeWithMeDebuggerSessionModel)
            serializers.register(CodeWithMeValuePropertiesModel)
            serializers.register(StopActionModel)
            serializers.register(CodeWithMeStackFrameModel)
            serializers.register(DebuggerWatchesInfo)
            serializers.register(InitialSessionData)
            serializers.register(StartCommandArg)
            serializers.register(ImmutableListChildrenWrapper)
            serializers.register(LiveProperties)
            serializers.register(GetExpressionInfoAtOffsetArg)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): CodeWithMeDebuggerModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return CodeWithMeDebuggerModel().apply {
                identify(protocol.identity, RdId.Null.mix("CodeWithMeDebuggerModel"))
                bind(lifetime, protocol, "CodeWithMeDebuggerModel")
            }
        }
        
        
        const val serializationHash = 1414555277068157935L
        
    }
    override val serializersOwner: ISerializersOwner get() = CodeWithMeDebuggerModel
    override val serializationHash: Long get() = CodeWithMeDebuggerModel.serializationHash
    
    //fields
    val sessions: IMutableViewableList<CodeWithMeDebuggerSessionModel> get() = _sessions
    val startCommands: ISignal<StartCommandArg> get() = _startCommands
    //methods
    //initializer
    init {
        bindableChildren.add("sessions" to _sessions)
        bindableChildren.add("startCommands" to _startCommands)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdList<CodeWithMeDebuggerSessionModel>(CodeWithMeDebuggerSessionModel),
        RdSignal<StartCommandArg>(StartCommandArg)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeDebuggerModel (")
        printer.indent {
            print("sessions = "); _sessions.print(printer); println()
            print("startCommands = "); _startCommands.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeDebuggerModel   {
        return CodeWithMeDebuggerModel(
            _sessions.deepClonePolymorphic(),
            _startCommands.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
data class BreakpointPresentationUpdatedArgs (
    val breakpointId: String,
    val icon: com.jetbrains.rd.ide.model.IconModel?,
    val errorMessage: String?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<BreakpointPresentationUpdatedArgs> {
        override val _type: KClass<BreakpointPresentationUpdatedArgs> = BreakpointPresentationUpdatedArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BreakpointPresentationUpdatedArgs  {
            val breakpointId = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val errorMessage = buffer.readNullable { buffer.readString() }
            return BreakpointPresentationUpdatedArgs(breakpointId, icon, errorMessage)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BreakpointPresentationUpdatedArgs)  {
            buffer.writeString(value.breakpointId)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.errorMessage) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BreakpointPresentationUpdatedArgs
        
        if (breakpointId != other.breakpointId) return false
        if (icon != other.icon) return false
        if (errorMessage != other.errorMessage) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + breakpointId.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + if (errorMessage != null) errorMessage.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BreakpointPresentationUpdatedArgs (")
        printer.indent {
            print("breakpointId = "); breakpointId.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("errorMessage = "); errorMessage.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CWMInlineDebuggerDataCallback private constructor(
    private val _computed: RdCall<CodeWithMeSourcePositionModel, Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CWMInlineDebuggerDataCallback> {
        override val _type: KClass<CWMInlineDebuggerDataCallback> = CWMInlineDebuggerDataCallback::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CWMInlineDebuggerDataCallback  {
            val _id = RdId.read(buffer)
            val _computed = RdCall.read(ctx, buffer, CodeWithMeSourcePositionModel, FrameworkMarshallers.Void)
            return CWMInlineDebuggerDataCallback(_computed).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CWMInlineDebuggerDataCallback)  {
            value.rdid.write(buffer)
            RdCall.write(ctx, buffer, value._computed)
        }
        
        
    }
    //fields
    val computed: RdCall<CodeWithMeSourcePositionModel, Unit> get() = _computed
    //methods
    //initializer
    init {
        _computed.async = true
    }
    
    init {
        bindableChildren.add("computed" to _computed)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdCall<CodeWithMeSourcePositionModel, Unit>(CodeWithMeSourcePositionModel, FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CWMInlineDebuggerDataCallback (")
        printer.indent {
            print("computed = "); _computed.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CWMInlineDebuggerDataCallback   {
        return CWMInlineDebuggerDataCallback(
            _computed.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CodeWithMeChildrenListLive private constructor(
    private val _children: RdList<ImmutableListChildrenWrapper>,
    private val _tooManyChildren: RdOptionalProperty<Int>,
    private val _getNextChildren: RdSignal<Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CodeWithMeChildrenListLive> {
        override val _type: KClass<CodeWithMeChildrenListLive> = CodeWithMeChildrenListLive::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeChildrenListLive  {
            val _id = RdId.read(buffer)
            val _children = RdList.read(ctx, buffer, ImmutableListChildrenWrapper)
            val _tooManyChildren = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _getNextChildren = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return CodeWithMeChildrenListLive(_children, _tooManyChildren, _getNextChildren).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeChildrenListLive)  {
            value.rdid.write(buffer)
            RdList.write(ctx, buffer, value._children)
            RdOptionalProperty.write(ctx, buffer, value._tooManyChildren)
            RdSignal.write(ctx, buffer, value._getNextChildren)
        }
        
        
    }
    //fields
    val children: IMutableViewableList<ImmutableListChildrenWrapper> get() = _children
    val tooManyChildren: IOptProperty<Int> get() = _tooManyChildren
    val getNextChildren: IAsyncSignal<Unit> get() = _getNextChildren
    //methods
    //initializer
    init {
        _tooManyChildren.optimizeNested = true
    }
    
    init {
        _tooManyChildren.async = true
        _getNextChildren.async = true
    }
    
    init {
        bindableChildren.add("children" to _children)
        bindableChildren.add("tooManyChildren" to _tooManyChildren)
        bindableChildren.add("getNextChildren" to _getNextChildren)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdList<ImmutableListChildrenWrapper>(ImmutableListChildrenWrapper),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdSignal<Unit>(FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeChildrenListLive (")
        printer.indent {
            print("children = "); _children.print(printer); println()
            print("tooManyChildren = "); _tooManyChildren.print(printer); println()
            print("getNextChildren = "); _getNextChildren.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeChildrenListLive   {
        return CodeWithMeChildrenListLive(
            _children.deepClonePolymorphic(),
            _tooManyChildren.deepClonePolymorphic(),
            _getNextChildren.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CodeWithMeDebuggerSessionModel private constructor(
    val sessionName: String,
    val sessionIcon: com.jetbrains.rd.ide.model.IconModel?,
    val executionId: Long,
    val testFramework: String,
    val idBased: Boolean,
    val uniqueID: String,
    val globalSessionId: Long,
    val startCommandId: Int?,
    val executionConsoleKind: ExecutionConsoleKind,
    private val _targetOutput: RdSignal<CodeWithMeOutputMessage>,
    private val _breakpointPresentationUpdated: RdSignal<BreakpointPresentationUpdatedArgs>,
    private val _areBreakpointsMuted: RdOptionalProperty<Boolean>,
    private val _currentFrame: RdOptionalProperty<Int>,
    private val _changeFrame: RdSignal<Int>,
    _suspendContext: RdProperty<SuspendContextModelBase?>,
    _debuggerAction: RdSignal<DebuggerActionModelBase>
) : DebuggerSessionModelBase (
    _suspendContext,
    _debuggerAction
) {
    //companion
    
    companion object : IMarshaller<CodeWithMeDebuggerSessionModel> {
        override val _type: KClass<CodeWithMeDebuggerSessionModel> = CodeWithMeDebuggerSessionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeDebuggerSessionModel  {
            val _id = RdId.read(buffer)
            val _suspendContext = RdProperty.read(ctx, buffer, __SuspendContextModelBaseNullableSerializer)
            val _debuggerAction = RdSignal.read(ctx, buffer, AbstractPolymorphic(DebuggerActionModelBase))
            val sessionName = buffer.readString()
            val sessionIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val executionId = buffer.readLong()
            val testFramework = buffer.readString()
            val idBased = buffer.readBool()
            val uniqueID = buffer.readString()
            val globalSessionId = buffer.readLong()
            val startCommandId = buffer.readNullable { buffer.readInt() }
            val executionConsoleKind = buffer.readEnum<ExecutionConsoleKind>()
            val _targetOutput = RdSignal.read(ctx, buffer, CodeWithMeOutputMessage)
            val _breakpointPresentationUpdated = RdSignal.read(ctx, buffer, BreakpointPresentationUpdatedArgs)
            val _areBreakpointsMuted = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _currentFrame = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _changeFrame = RdSignal.read(ctx, buffer, FrameworkMarshallers.Int)
            return CodeWithMeDebuggerSessionModel(sessionName, sessionIcon, executionId, testFramework, idBased, uniqueID, globalSessionId, startCommandId, executionConsoleKind, _targetOutput, _breakpointPresentationUpdated, _areBreakpointsMuted, _currentFrame, _changeFrame, _suspendContext, _debuggerAction).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeDebuggerSessionModel)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._suspendContext)
            RdSignal.write(ctx, buffer, value._debuggerAction)
            buffer.writeString(value.sessionName)
            buffer.writeNullable(value.sessionIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeLong(value.executionId)
            buffer.writeString(value.testFramework)
            buffer.writeBool(value.idBased)
            buffer.writeString(value.uniqueID)
            buffer.writeLong(value.globalSessionId)
            buffer.writeNullable(value.startCommandId) { buffer.writeInt(it) }
            buffer.writeEnum(value.executionConsoleKind)
            RdSignal.write(ctx, buffer, value._targetOutput)
            RdSignal.write(ctx, buffer, value._breakpointPresentationUpdated)
            RdOptionalProperty.write(ctx, buffer, value._areBreakpointsMuted)
            RdOptionalProperty.write(ctx, buffer, value._currentFrame)
            RdSignal.write(ctx, buffer, value._changeFrame)
        }
        
        private val __SuspendContextModelBaseNullableSerializer = AbstractPolymorphic(SuspendContextModelBase).nullable()
        
    }
    //fields
    val targetOutput: ISignal<CodeWithMeOutputMessage> get() = _targetOutput
    val breakpointPresentationUpdated: ISignal<BreakpointPresentationUpdatedArgs> get() = _breakpointPresentationUpdated
    val areBreakpointsMuted: IOptProperty<Boolean> get() = _areBreakpointsMuted
    val currentFrame: IOptProperty<Int> get() = _currentFrame
    val changeFrame: IAsyncSignal<Int> get() = _changeFrame
    //methods
    //initializer
    init {
        _areBreakpointsMuted.optimizeNested = true
        _currentFrame.optimizeNested = true
    }
    
    init {
        _areBreakpointsMuted.async = true
        _currentFrame.async = true
        _changeFrame.async = true
    }
    
    init {
        bindableChildren.add("targetOutput" to _targetOutput)
        bindableChildren.add("breakpointPresentationUpdated" to _breakpointPresentationUpdated)
        bindableChildren.add("areBreakpointsMuted" to _areBreakpointsMuted)
        bindableChildren.add("currentFrame" to _currentFrame)
        bindableChildren.add("changeFrame" to _changeFrame)
    }
    
    //secondary constructor
    constructor(
        sessionName: String,
        sessionIcon: com.jetbrains.rd.ide.model.IconModel?,
        executionId: Long,
        testFramework: String,
        idBased: Boolean,
        uniqueID: String,
        globalSessionId: Long,
        startCommandId: Int?,
        executionConsoleKind: ExecutionConsoleKind
    ) : this(
        sessionName,
        sessionIcon,
        executionId,
        testFramework,
        idBased,
        uniqueID,
        globalSessionId,
        startCommandId,
        executionConsoleKind,
        RdSignal<CodeWithMeOutputMessage>(CodeWithMeOutputMessage),
        RdSignal<BreakpointPresentationUpdatedArgs>(BreakpointPresentationUpdatedArgs),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdSignal<Int>(FrameworkMarshallers.Int),
        RdProperty<SuspendContextModelBase?>(null, __SuspendContextModelBaseNullableSerializer),
        RdSignal<DebuggerActionModelBase>(AbstractPolymorphic(DebuggerActionModelBase))
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeDebuggerSessionModel (")
        printer.indent {
            print("sessionName = "); sessionName.print(printer); println()
            print("sessionIcon = "); sessionIcon.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
            print("testFramework = "); testFramework.print(printer); println()
            print("idBased = "); idBased.print(printer); println()
            print("uniqueID = "); uniqueID.print(printer); println()
            print("globalSessionId = "); globalSessionId.print(printer); println()
            print("startCommandId = "); startCommandId.print(printer); println()
            print("executionConsoleKind = "); executionConsoleKind.print(printer); println()
            print("targetOutput = "); _targetOutput.print(printer); println()
            print("breakpointPresentationUpdated = "); _breakpointPresentationUpdated.print(printer); println()
            print("areBreakpointsMuted = "); _areBreakpointsMuted.print(printer); println()
            print("currentFrame = "); _currentFrame.print(printer); println()
            print("changeFrame = "); _changeFrame.print(printer); println()
            print("suspendContext = "); _suspendContext.print(printer); println()
            print("debuggerAction = "); _debuggerAction.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeDebuggerSessionModel   {
        return CodeWithMeDebuggerSessionModel(
            sessionName,
            sessionIcon,
            executionId,
            testFramework,
            idBased,
            uniqueID,
            globalSessionId,
            startCommandId,
            executionConsoleKind,
            _targetOutput.deepClonePolymorphic(),
            _breakpointPresentationUpdated.deepClonePolymorphic(),
            _areBreakpointsMuted.deepClonePolymorphic(),
            _currentFrame.deepClonePolymorphic(),
            _changeFrame.deepClonePolymorphic(),
            _suspendContext.deepClonePolymorphic(),
            _debuggerAction.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CodeWithMeEvaluateArg (
    expression: String
) : EvaluateArgBase (
    expression
) {
    //companion
    
    companion object : IMarshaller<CodeWithMeEvaluateArg> {
        override val _type: KClass<CodeWithMeEvaluateArg> = CodeWithMeEvaluateArg::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeEvaluateArg  {
            val expression = buffer.readString()
            return CodeWithMeEvaluateArg(expression)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeEvaluateArg)  {
            buffer.writeString(value.expression)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CodeWithMeEvaluateArg
        
        if (expression != other.expression) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + expression.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeEvaluateArg (")
        printer.indent {
            print("expression = "); expression.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CodeWithMeExecutionStackModel private constructor(
    displayName: String,
    topFrame: StackFrameModelBase?,
    _computeFrames: RdCall<ComputeFramesArg, List<StackFrameModelBase>>
) : ExecutionStackModelBase (
    displayName,
    topFrame,
    _computeFrames
) {
    //companion
    
    companion object : IMarshaller<CodeWithMeExecutionStackModel> {
        override val _type: KClass<CodeWithMeExecutionStackModel> = CodeWithMeExecutionStackModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeExecutionStackModel  {
            val _id = RdId.read(buffer)
            val displayName = buffer.readString()
            val topFrame = buffer.readNullable { ctx.serializers.readPolymorphic<StackFrameModelBase>(ctx, buffer, StackFrameModelBase) }
            val _computeFrames = RdCall.read(ctx, buffer, ComputeFramesArg, __StackFrameModelBaseListSerializer)
            return CodeWithMeExecutionStackModel(displayName, topFrame, _computeFrames).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeExecutionStackModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.displayName)
            buffer.writeNullable(value.topFrame) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdCall.write(ctx, buffer, value._computeFrames)
        }
        
        private val __StackFrameModelBaseListSerializer = AbstractPolymorphic(StackFrameModelBase).list()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        displayName: String,
        topFrame: StackFrameModelBase?
    ) : this(
        displayName,
        topFrame,
        RdCall<ComputeFramesArg, List<StackFrameModelBase>>(ComputeFramesArg, __StackFrameModelBaseListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeExecutionStackModel (")
        printer.indent {
            print("displayName = "); displayName.print(printer); println()
            print("topFrame = "); topFrame.print(printer); println()
            print("computeFrames = "); _computeFrames.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeExecutionStackModel   {
        return CodeWithMeExecutionStackModel(
            displayName,
            topFrame.deepClonePolymorphic(),
            _computeFrames.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
data class CodeWithMeOutputMessage (
    val text: String,
    val type: ConsoleViewContentTypeModel
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CodeWithMeOutputMessage> {
        override val _type: KClass<CodeWithMeOutputMessage> = CodeWithMeOutputMessage::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeOutputMessage  {
            val text = buffer.readString()
            val type = ConsoleViewContentTypeModel.read(ctx, buffer)
            return CodeWithMeOutputMessage(text, type)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeOutputMessage)  {
            buffer.writeString(value.text)
            ConsoleViewContentTypeModel.write(ctx, buffer, value.type)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CodeWithMeOutputMessage
        
        if (text != other.text) return false
        if (type != other.type) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + type.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeOutputMessage (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("type = "); type.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CodeWithMeSourcePositionModel (
    val fileId: com.jetbrains.rd.ide.model.RdFileId,
    filename: String,
    line: Int,
    offset: Int
) : SourcePositionBase (
    filename,
    line,
    offset
) {
    //companion
    
    companion object : IMarshaller<CodeWithMeSourcePositionModel> {
        override val _type: KClass<CodeWithMeSourcePositionModel> = CodeWithMeSourcePositionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeSourcePositionModel  {
            val filename = buffer.readString()
            val line = buffer.readInt()
            val offset = buffer.readInt()
            val fileId = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.RdFileId>(ctx, buffer, com.jetbrains.rd.ide.model.RdFileId)
            return CodeWithMeSourcePositionModel(fileId, filename, line, offset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeSourcePositionModel)  {
            buffer.writeString(value.filename)
            buffer.writeInt(value.line)
            buffer.writeInt(value.offset)
            ctx.serializers.writePolymorphic(ctx, buffer, value.fileId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CodeWithMeSourcePositionModel
        
        if (fileId != other.fileId) return false
        if (filename != other.filename) return false
        if (line != other.line) return false
        if (offset != other.offset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fileId.hashCode()
        __r = __r*31 + filename.hashCode()
        __r = __r*31 + line.hashCode()
        __r = __r*31 + offset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeSourcePositionModel (")
        printer.indent {
            print("fileId = "); fileId.print(printer); println()
            print("filename = "); filename.print(printer); println()
            print("line = "); line.print(printer); println()
            print("offset = "); offset.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CodeWithMeStackFrameModel private constructor(
    val id: Int,
    val presentation: ColoredTextContainerModel,
    private val _getExpressionInfoAtOffset: RdCall<GetExpressionInfoAtOffsetArg, com.jetbrains.rd.ide.model.RdTextRange?>,
    sourcePosition: SourcePositionBase?,
    _computeLocals: RdCall<Unit, List<ValueEntityModelBase>>,
    _evaluateExpression: RdCall<EvaluateArgBase, ValueModelBase>
) : StackFrameModelBase (
    sourcePosition,
    _computeLocals,
    _evaluateExpression
) {
    //companion
    
    companion object : IMarshaller<CodeWithMeStackFrameModel> {
        override val _type: KClass<CodeWithMeStackFrameModel> = CodeWithMeStackFrameModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeStackFrameModel  {
            val _id = RdId.read(buffer)
            val sourcePosition = buffer.readNullable { ctx.serializers.readPolymorphic<SourcePositionBase>(ctx, buffer, SourcePositionBase) }
            val _computeLocals = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, __ValueEntityModelBaseListSerializer)
            val _evaluateExpression = RdCall.read(ctx, buffer, AbstractPolymorphic(EvaluateArgBase), AbstractPolymorphic(ValueModelBase))
            val id = buffer.readInt()
            val presentation = ColoredTextContainerModel.read(ctx, buffer)
            val _getExpressionInfoAtOffset = RdCall.read(ctx, buffer, GetExpressionInfoAtOffsetArg, __RdTextRangeNullableSerializer)
            return CodeWithMeStackFrameModel(id, presentation, _getExpressionInfoAtOffset, sourcePosition, _computeLocals, _evaluateExpression).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeStackFrameModel)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.sourcePosition) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdCall.write(ctx, buffer, value._computeLocals)
            RdCall.write(ctx, buffer, value._evaluateExpression)
            buffer.writeInt(value.id)
            ColoredTextContainerModel.write(ctx, buffer, value.presentation)
            RdCall.write(ctx, buffer, value._getExpressionInfoAtOffset)
        }
        
        private val __RdTextRangeNullableSerializer = com.jetbrains.rd.ide.model.RdTextRange.nullable()
        private val __ValueEntityModelBaseListSerializer = AbstractPolymorphic(ValueEntityModelBase).list()
        
    }
    //fields
    val getExpressionInfoAtOffset: RdCall<GetExpressionInfoAtOffsetArg, com.jetbrains.rd.ide.model.RdTextRange?> get() = _getExpressionInfoAtOffset
    //methods
    //initializer
    init {
        bindableChildren.add("getExpressionInfoAtOffset" to _getExpressionInfoAtOffset)
    }
    
    //secondary constructor
    constructor(
        id: Int,
        presentation: ColoredTextContainerModel,
        sourcePosition: SourcePositionBase?
    ) : this(
        id,
        presentation,
        RdCall<GetExpressionInfoAtOffsetArg, com.jetbrains.rd.ide.model.RdTextRange?>(GetExpressionInfoAtOffsetArg, __RdTextRangeNullableSerializer),
        sourcePosition,
        RdCall<Unit, List<ValueEntityModelBase>>(FrameworkMarshallers.Void, __ValueEntityModelBaseListSerializer),
        RdCall<EvaluateArgBase, ValueModelBase>(AbstractPolymorphic(EvaluateArgBase), AbstractPolymorphic(ValueModelBase))
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeStackFrameModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("presentation = "); presentation.print(printer); println()
            print("getExpressionInfoAtOffset = "); _getExpressionInfoAtOffset.print(printer); println()
            print("sourcePosition = "); sourcePosition.print(printer); println()
            print("computeLocals = "); _computeLocals.print(printer); println()
            print("evaluateExpression = "); _evaluateExpression.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeStackFrameModel   {
        return CodeWithMeStackFrameModel(
            id,
            presentation,
            _getExpressionInfoAtOffset.deepClonePolymorphic(),
            sourcePosition,
            _computeLocals.deepClonePolymorphic(),
            _evaluateExpression.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CodeWithMeSuspendContextModel private constructor(
    activeStack: ExecutionStackModelBase?,
    _computeStacks: RdCall<Unit, List<ExecutionStackModelBase>>
) : SuspendContextModelBase (
    activeStack,
    _computeStacks
) {
    //companion
    
    companion object : IMarshaller<CodeWithMeSuspendContextModel> {
        override val _type: KClass<CodeWithMeSuspendContextModel> = CodeWithMeSuspendContextModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeSuspendContextModel  {
            val _id = RdId.read(buffer)
            val activeStack = buffer.readNullable { ctx.serializers.readPolymorphic<ExecutionStackModelBase>(ctx, buffer, ExecutionStackModelBase) }
            val _computeStacks = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, __ExecutionStackModelBaseListSerializer)
            return CodeWithMeSuspendContextModel(activeStack, _computeStacks).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeSuspendContextModel)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.activeStack) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdCall.write(ctx, buffer, value._computeStacks)
        }
        
        private val __ExecutionStackModelBaseListSerializer = AbstractPolymorphic(ExecutionStackModelBase).list()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        activeStack: ExecutionStackModelBase?
    ) : this(
        activeStack,
        RdCall<Unit, List<ExecutionStackModelBase>>(FrameworkMarshallers.Void, __ExecutionStackModelBaseListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeSuspendContextModel (")
        printer.indent {
            print("activeStack = "); activeStack.print(printer); println()
            print("computeStacks = "); _computeStacks.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeSuspendContextModel   {
        return CodeWithMeSuspendContextModel(
            activeStack.deepClonePolymorphic(),
            _computeStacks.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CodeWithMeValueGroupModel private constructor(
    val icon: com.jetbrains.rd.ide.model.IconModel?,
    val isAutoExpand: Boolean,
    val isRestoreExpansion: Boolean,
    val separator: String,
    comment: String?,
    name: String,
    _computeChildren: RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>
) : ValueGroupModelBase (
    comment,
    name,
    _computeChildren
) {
    //companion
    
    companion object : IMarshaller<CodeWithMeValueGroupModel> {
        override val _type: KClass<CodeWithMeValueGroupModel> = CodeWithMeValueGroupModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeValueGroupModel  {
            val _id = RdId.read(buffer)
            val comment = buffer.readNullable { buffer.readString() }
            val name = buffer.readString()
            val _computeChildren = RdCall.read(ctx, buffer, AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer)
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val isAutoExpand = buffer.readBool()
            val isRestoreExpansion = buffer.readBool()
            val separator = buffer.readString()
            return CodeWithMeValueGroupModel(icon, isAutoExpand, isRestoreExpansion, separator, comment, name, _computeChildren).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeValueGroupModel)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.comment) { buffer.writeString(it) }
            buffer.writeString(value.name)
            RdCall.write(ctx, buffer, value._computeChildren)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeBool(value.isAutoExpand)
            buffer.writeBool(value.isRestoreExpansion)
            buffer.writeString(value.separator)
        }
        
        private val __ValueEntityModelBaseListSerializer = AbstractPolymorphic(ValueEntityModelBase).list()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        icon: com.jetbrains.rd.ide.model.IconModel?,
        isAutoExpand: Boolean,
        isRestoreExpansion: Boolean,
        separator: String,
        comment: String?,
        name: String
    ) : this(
        icon,
        isAutoExpand,
        isRestoreExpansion,
        separator,
        comment,
        name,
        RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>(AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeValueGroupModel (")
        printer.indent {
            print("icon = "); icon.print(printer); println()
            print("isAutoExpand = "); isAutoExpand.print(printer); println()
            print("isRestoreExpansion = "); isRestoreExpansion.print(printer); println()
            print("separator = "); separator.print(printer); println()
            print("comment = "); comment.print(printer); println()
            print("name = "); name.print(printer); println()
            print("computeChildren = "); _computeChildren.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeValueGroupModel   {
        return CodeWithMeValueGroupModel(
            icon,
            isAutoExpand,
            isRestoreExpansion,
            separator,
            comment,
            name,
            _computeChildren.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CodeWithMeValueModel private constructor(
    val canNavigateToTypeSource: Boolean,
    private val _computeChildrenLive: RdCall<ComputeChildrenArgBase, CodeWithMeChildrenListLive>,
    private val _computeObjectPropertiesLive: RdCall<Unit, LiveProperties>,
    private val _computeSourcePosition: RdCall<Unit, CodeWithMeSourcePositionModel?>,
    private val _computeTypeSourcePosition: RdCall<Unit, CodeWithMeSourcePositionModel?>,
    private val _inlineDebuggerDataCallback: RdOptionalProperty<CWMInlineDebuggerDataCallback>,
    properties: ValuePropertiesModelBase?,
    _computeObjectProperties: RdCall<ComputeObjectPropertiesArgBase, ValuePropertiesModelBase>,
    name: String,
    _computeChildren: RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>
) : ValueModelBase (
    properties,
    _computeObjectProperties,
    name,
    _computeChildren
) {
    //companion
    
    companion object : IMarshaller<CodeWithMeValueModel> {
        override val _type: KClass<CodeWithMeValueModel> = CodeWithMeValueModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeValueModel  {
            val _id = RdId.read(buffer)
            val properties = buffer.readNullable { ctx.serializers.readPolymorphic<ValuePropertiesModelBase>(ctx, buffer, ValuePropertiesModelBase) }
            val _computeObjectProperties = RdCall.read(ctx, buffer, AbstractPolymorphic(ComputeObjectPropertiesArgBase), AbstractPolymorphic(ValuePropertiesModelBase))
            val name = buffer.readString()
            val _computeChildren = RdCall.read(ctx, buffer, AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer)
            val canNavigateToTypeSource = buffer.readBool()
            val _computeChildrenLive = RdCall.read(ctx, buffer, AbstractPolymorphic(ComputeChildrenArgBase), CodeWithMeChildrenListLive)
            val _computeObjectPropertiesLive = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, LiveProperties)
            val _computeSourcePosition = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, __CodeWithMeSourcePositionModelNullableSerializer)
            val _computeTypeSourcePosition = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, __CodeWithMeSourcePositionModelNullableSerializer)
            val _inlineDebuggerDataCallback = RdOptionalProperty.read(ctx, buffer, CWMInlineDebuggerDataCallback)
            return CodeWithMeValueModel(canNavigateToTypeSource, _computeChildrenLive, _computeObjectPropertiesLive, _computeSourcePosition, _computeTypeSourcePosition, _inlineDebuggerDataCallback, properties, _computeObjectProperties, name, _computeChildren).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeValueModel)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.properties) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdCall.write(ctx, buffer, value._computeObjectProperties)
            buffer.writeString(value.name)
            RdCall.write(ctx, buffer, value._computeChildren)
            buffer.writeBool(value.canNavigateToTypeSource)
            RdCall.write(ctx, buffer, value._computeChildrenLive)
            RdCall.write(ctx, buffer, value._computeObjectPropertiesLive)
            RdCall.write(ctx, buffer, value._computeSourcePosition)
            RdCall.write(ctx, buffer, value._computeTypeSourcePosition)
            RdOptionalProperty.write(ctx, buffer, value._inlineDebuggerDataCallback)
        }
        
        private val __CodeWithMeSourcePositionModelNullableSerializer = CodeWithMeSourcePositionModel.nullable()
        private val __ValueEntityModelBaseListSerializer = AbstractPolymorphic(ValueEntityModelBase).list()
        
    }
    //fields
    val computeChildrenLive: RdCall<ComputeChildrenArgBase, CodeWithMeChildrenListLive> get() = _computeChildrenLive
    val computeObjectPropertiesLive: RdCall<Unit, LiveProperties> get() = _computeObjectPropertiesLive
    val computeSourcePosition: RdCall<Unit, CodeWithMeSourcePositionModel?> get() = _computeSourcePosition
    val computeTypeSourcePosition: RdCall<Unit, CodeWithMeSourcePositionModel?> get() = _computeTypeSourcePosition
    val inlineDebuggerDataCallback: IOptProperty<CWMInlineDebuggerDataCallback> get() = _inlineDebuggerDataCallback
    //methods
    //initializer
    init {
        _computeSourcePosition.async = true
        _computeTypeSourcePosition.async = true
    }
    
    init {
        bindableChildren.add("computeChildrenLive" to _computeChildrenLive)
        bindableChildren.add("computeObjectPropertiesLive" to _computeObjectPropertiesLive)
        bindableChildren.add("computeSourcePosition" to _computeSourcePosition)
        bindableChildren.add("computeTypeSourcePosition" to _computeTypeSourcePosition)
        bindableChildren.add("inlineDebuggerDataCallback" to _inlineDebuggerDataCallback)
    }
    
    //secondary constructor
    constructor(
        canNavigateToTypeSource: Boolean,
        properties: ValuePropertiesModelBase?,
        name: String
    ) : this(
        canNavigateToTypeSource,
        RdCall<ComputeChildrenArgBase, CodeWithMeChildrenListLive>(AbstractPolymorphic(ComputeChildrenArgBase), CodeWithMeChildrenListLive),
        RdCall<Unit, LiveProperties>(FrameworkMarshallers.Void, LiveProperties),
        RdCall<Unit, CodeWithMeSourcePositionModel?>(FrameworkMarshallers.Void, __CodeWithMeSourcePositionModelNullableSerializer),
        RdCall<Unit, CodeWithMeSourcePositionModel?>(FrameworkMarshallers.Void, __CodeWithMeSourcePositionModelNullableSerializer),
        RdOptionalProperty<CWMInlineDebuggerDataCallback>(CWMInlineDebuggerDataCallback),
        properties,
        RdCall<ComputeObjectPropertiesArgBase, ValuePropertiesModelBase>(AbstractPolymorphic(ComputeObjectPropertiesArgBase), AbstractPolymorphic(ValuePropertiesModelBase)),
        name,
        RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>(AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeValueModel (")
        printer.indent {
            print("canNavigateToTypeSource = "); canNavigateToTypeSource.print(printer); println()
            print("computeChildrenLive = "); _computeChildrenLive.print(printer); println()
            print("computeObjectPropertiesLive = "); _computeObjectPropertiesLive.print(printer); println()
            print("computeSourcePosition = "); _computeSourcePosition.print(printer); println()
            print("computeTypeSourcePosition = "); _computeTypeSourcePosition.print(printer); println()
            print("inlineDebuggerDataCallback = "); _inlineDebuggerDataCallback.print(printer); println()
            print("properties = "); properties.print(printer); println()
            print("computeObjectProperties = "); _computeObjectProperties.print(printer); println()
            print("name = "); name.print(printer); println()
            print("computeChildren = "); _computeChildren.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeValueModel   {
        return CodeWithMeValueModel(
            canNavigateToTypeSource,
            _computeChildrenLive.deepClonePolymorphic(),
            _computeObjectPropertiesLive.deepClonePolymorphic(),
            _computeSourcePosition.deepClonePolymorphic(),
            _computeTypeSourcePosition.deepClonePolymorphic(),
            _inlineDebuggerDataCallback.deepClonePolymorphic(),
            properties,
            _computeObjectProperties.deepClonePolymorphic(),
            name,
            _computeChildren.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class CodeWithMeValuePropertiesModel (
    val icon: com.jetbrains.rd.ide.model.IconModel?,
    type: String?,
    value: List<ValuePresentationPart>,
    hasChildren: Boolean
) : ValuePropertiesModelBase (
    type,
    value,
    hasChildren
) {
    //companion
    
    companion object : IMarshaller<CodeWithMeValuePropertiesModel> {
        override val _type: KClass<CodeWithMeValuePropertiesModel> = CodeWithMeValuePropertiesModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeValuePropertiesModel  {
            val type = buffer.readNullable { buffer.readString() }
            val value = buffer.readList { ValuePresentationPart.read(ctx, buffer) }
            val hasChildren = buffer.readBool()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            return CodeWithMeValuePropertiesModel(icon, type, value, hasChildren)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeValuePropertiesModel)  {
            buffer.writeNullable(value.type) { buffer.writeString(it) }
            buffer.writeList(value.value) { v -> ValuePresentationPart.write(ctx, buffer, v) }
            buffer.writeBool(value.hasChildren)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CodeWithMeValuePropertiesModel
        
        if (icon != other.icon) return false
        if (type != other.type) return false
        if (value != other.value) return false
        if (hasChildren != other.hasChildren) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + if (type != null) type.hashCode() else 0
        __r = __r*31 + value.hashCode()
        __r = __r*31 + hasChildren.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeValuePropertiesModel (")
        printer.indent {
            print("icon = "); icon.print(printer); println()
            print("type = "); type.print(printer); println()
            print("value = "); value.print(printer); println()
            print("hasChildren = "); hasChildren.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
data class ConsoleViewContentTypeModel (
    val textAttributesKey: String?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ConsoleViewContentTypeModel> {
        override val _type: KClass<ConsoleViewContentTypeModel> = ConsoleViewContentTypeModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ConsoleViewContentTypeModel  {
            val textAttributesKey = buffer.readNullable { buffer.readString() }
            return ConsoleViewContentTypeModel(textAttributesKey)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ConsoleViewContentTypeModel)  {
            buffer.writeNullable(value.textAttributesKey) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ConsoleViewContentTypeModel
        
        if (textAttributesKey != other.textAttributesKey) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (textAttributesKey != null) textAttributesKey.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ConsoleViewContentTypeModel (")
        printer.indent {
            print("textAttributesKey = "); textAttributesKey.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class DebuggerWatchesInfo (
    val initialText: String,
    val sourcePosition: SourcePositionBase?,
    key: String
) : com.jetbrains.rd.ide.model.DocumentExtension (
    key
) {
    //companion
    
    companion object : IMarshaller<DebuggerWatchesInfo> {
        override val _type: KClass<DebuggerWatchesInfo> = DebuggerWatchesInfo::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DebuggerWatchesInfo  {
            val _id = RdId.read(buffer)
            val key = buffer.readString()
            val initialText = buffer.readString()
            val sourcePosition = buffer.readNullable { ctx.serializers.readPolymorphic<SourcePositionBase>(ctx, buffer, SourcePositionBase) }
            return DebuggerWatchesInfo(initialText, sourcePosition, key).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DebuggerWatchesInfo)  {
            value.rdid.write(buffer)
            buffer.writeString(value.key)
            buffer.writeString(value.initialText)
            buffer.writeNullable(value.sourcePosition) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DebuggerWatchesInfo (")
        printer.indent {
            print("initialText = "); initialText.print(printer); println()
            print("sourcePosition = "); sourcePosition.print(printer); println()
            print("key = "); key.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DebuggerWatchesInfo   {
        return DebuggerWatchesInfo(
            initialText,
            sourcePosition,
            key
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
data class GetExpressionInfoAtOffsetArg (
    val documentId: com.jetbrains.rd.ide.model.RdDocumentId,
    val offset: Int,
    val sideEffectsAllowed: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<GetExpressionInfoAtOffsetArg> {
        override val _type: KClass<GetExpressionInfoAtOffsetArg> = GetExpressionInfoAtOffsetArg::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): GetExpressionInfoAtOffsetArg  {
            val documentId = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.RdDocumentId>(ctx, buffer, com.jetbrains.rd.ide.model.RdDocumentId)
            val offset = buffer.readInt()
            val sideEffectsAllowed = buffer.readBool()
            return GetExpressionInfoAtOffsetArg(documentId, offset, sideEffectsAllowed)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: GetExpressionInfoAtOffsetArg)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentId)
            buffer.writeInt(value.offset)
            buffer.writeBool(value.sideEffectsAllowed)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as GetExpressionInfoAtOffsetArg
        
        if (documentId != other.documentId) return false
        if (offset != other.offset) return false
        if (sideEffectsAllowed != other.sideEffectsAllowed) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + documentId.hashCode()
        __r = __r*31 + offset.hashCode()
        __r = __r*31 + sideEffectsAllowed.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("GetExpressionInfoAtOffsetArg (")
        printer.indent {
            print("documentId = "); documentId.print(printer); println()
            print("offset = "); offset.print(printer); println()
            print("sideEffectsAllowed = "); sideEffectsAllowed.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class ImmutableListChildrenWrapper (
    val list: List<ValueEntityModelBase>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<ImmutableListChildrenWrapper> {
        override val _type: KClass<ImmutableListChildrenWrapper> = ImmutableListChildrenWrapper::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ImmutableListChildrenWrapper  {
            val _id = RdId.read(buffer)
            val list = buffer.readList { ctx.serializers.readPolymorphic<ValueEntityModelBase>(ctx, buffer, ValueEntityModelBase) }
            return ImmutableListChildrenWrapper(list).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ImmutableListChildrenWrapper)  {
            value.rdid.write(buffer)
            buffer.writeList(value.list) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("list" to list)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ImmutableListChildrenWrapper (")
        printer.indent {
            print("list = "); list.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ImmutableListChildrenWrapper   {
        return ImmutableListChildrenWrapper(
            list.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
data class InitialSessionData (
    val areBreakpointsMuted: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<InitialSessionData> {
        override val _type: KClass<InitialSessionData> = InitialSessionData::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): InitialSessionData  {
            val areBreakpointsMuted = buffer.readBool()
            return InitialSessionData(areBreakpointsMuted)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: InitialSessionData)  {
            buffer.writeBool(value.areBreakpointsMuted)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as InitialSessionData
        
        if (areBreakpointsMuted != other.areBreakpointsMuted) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + areBreakpointsMuted.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("InitialSessionData (")
        printer.indent {
            print("areBreakpointsMuted = "); areBreakpointsMuted.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class LiveProperties private constructor(
    private val _value: RdOptionalProperty<ValuePropertiesModelBase>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<LiveProperties> {
        override val _type: KClass<LiveProperties> = LiveProperties::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LiveProperties  {
            val _id = RdId.read(buffer)
            val _value = RdOptionalProperty.read(ctx, buffer, AbstractPolymorphic(ValuePropertiesModelBase))
            return LiveProperties(_value).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LiveProperties)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._value)
        }
        
        
    }
    //fields
    val value: IOptProperty<ValuePropertiesModelBase> get() = _value
    //methods
    //initializer
    init {
        _value.optimizeNested = true
    }
    
    init {
        bindableChildren.add("value" to _value)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<ValuePropertiesModelBase>(AbstractPolymorphic(ValuePropertiesModelBase))
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LiveProperties (")
        printer.indent {
            print("value = "); _value.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): LiveProperties   {
        return LiveProperties(
            _value.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
data class StartCommandArg (
    val configurationUniqueId: String,
    val commandId: Int,
    val sessionData: InitialSessionData
) : IPrintable {
    //companion
    
    companion object : IMarshaller<StartCommandArg> {
        override val _type: KClass<StartCommandArg> = StartCommandArg::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): StartCommandArg  {
            val configurationUniqueId = buffer.readString()
            val commandId = buffer.readInt()
            val sessionData = InitialSessionData.read(ctx, buffer)
            return StartCommandArg(configurationUniqueId, commandId, sessionData)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: StartCommandArg)  {
            buffer.writeString(value.configurationUniqueId)
            buffer.writeInt(value.commandId)
            InitialSessionData.write(ctx, buffer, value.sessionData)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as StartCommandArg
        
        if (configurationUniqueId != other.configurationUniqueId) return false
        if (commandId != other.commandId) return false
        if (sessionData != other.sessionData) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + configurationUniqueId.hashCode()
        __r = __r*31 + commandId.hashCode()
        __r = __r*31 + sessionData.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("StartCommandArg (")
        printer.indent {
            print("configurationUniqueId = "); configurationUniqueId.print(printer); println()
            print("commandId = "); commandId.print(printer); println()
            print("sessionData = "); sessionData.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeDebuggerModel.kt]
 */
class StopActionModel (
) : DebuggerActionModelBase (
) {
    //companion
    
    companion object : IMarshaller<StopActionModel> {
        override val _type: KClass<StopActionModel> = StopActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): StopActionModel  {
            return StopActionModel()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: StopActionModel)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as StopActionModel
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("StopActionModel (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
