@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CodeWithMeDiagnosticsModel.kt]
 */
class CodeWithMeDiagnosticsModel private constructor(
    private val _pingViaUiThread: RdCall<Unit, Unit>,
    private val _pingDirect: RdCall<Unit, Unit>,
    private val _getLog: RdCall<Unit, LogFileData?>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(LogFileData)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): CodeWithMeDiagnosticsModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return CodeWithMeDiagnosticsModel().apply {
                identify(protocol.identity, RdId.Null.mix("CodeWithMeDiagnosticsModel"))
                bind(lifetime, protocol, "CodeWithMeDiagnosticsModel")
            }
        }
        
        private val __LogFileDataNullableSerializer = LogFileData.nullable()
        
        const val serializationHash = -6553305628144820826L
        
    }
    override val serializersOwner: ISerializersOwner get() = CodeWithMeDiagnosticsModel
    override val serializationHash: Long get() = CodeWithMeDiagnosticsModel.serializationHash
    
    //fields
    val pingViaUiThread: RdCall<Unit, Unit> get() = _pingViaUiThread
    val pingDirect: RdCall<Unit, Unit> get() = _pingDirect
    val getLog: RdCall<Unit, LogFileData?> get() = _getLog
    //methods
    //initializer
    init {
        _getLog.async = true
    }
    
    init {
        bindableChildren.add("pingViaUiThread" to _pingViaUiThread)
        bindableChildren.add("pingDirect" to _pingDirect)
        bindableChildren.add("getLog" to _getLog)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdCall<Unit, Unit>(FrameworkMarshallers.Void, FrameworkMarshallers.Void),
        RdCall<Unit, Unit>(FrameworkMarshallers.Void, FrameworkMarshallers.Void),
        RdCall<Unit, LogFileData?>(FrameworkMarshallers.Void, __LogFileDataNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeDiagnosticsModel (")
        printer.indent {
            print("pingViaUiThread = "); _pingViaUiThread.print(printer); println()
            print("pingDirect = "); _pingDirect.print(printer); println()
            print("getLog = "); _getLog.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeDiagnosticsModel   {
        return CodeWithMeDiagnosticsModel(
            _pingViaUiThread.deepClonePolymorphic(),
            _pingDirect.deepClonePolymorphic(),
            _getLog.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeDiagnosticsModel.kt]
 */
data class LogFileData (
    val name: String,
    val uuid: UUID
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LogFileData> {
        override val _type: KClass<LogFileData> = LogFileData::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LogFileData  {
            val name = buffer.readString()
            val uuid = buffer.readGuid()
            return LogFileData(name, uuid)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LogFileData)  {
            buffer.writeString(value.name)
            buffer.writeGuid(value.uuid)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LogFileData
        
        if (name != other.name) return false
        if (uuid != other.uuid) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + uuid.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LogFileData (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("uuid = "); uuid.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
