@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CodeWithMeRunConfigurationsModel.kt]
 */
class CodeWithMeRunConfigurationsModel private constructor(
    private val _configurationTypes: RdMap<String, CodeWithMeConfigurationTypeModel>,
    private val _configurationFactories: RdMap<String, List<CodeWithMeConfigurationFactoryModel>>,
    private val _runConfigurations: RdMap<String, CodeWithMeRunConfigurationModel>,
    private val _selectedConfiguration: RdSignal<String>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(SimpleSettingsEditorModel)
            serializers.register(SettingsEditorGroupModel)
            serializers.register(CodeWithMeRunConfigurationModel)
            serializers.register(CodeWithMeConfigurationFactoryModel)
            serializers.register(CodeWithMeConfigurationTypeModel)
            serializers.register(NamedEditor)
            serializers.register(CwmRunConfigurationExecuteArgs)
            serializers.register(SettingsEditorModelBase_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): CodeWithMeRunConfigurationsModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return CodeWithMeRunConfigurationsModel().apply {
                identify(protocol.identity, RdId.Null.mix("CodeWithMeRunConfigurationsModel"))
                bind(lifetime, protocol, "CodeWithMeRunConfigurationsModel")
            }
        }
        
        private val __CodeWithMeConfigurationFactoryModelListSerializer = CodeWithMeConfigurationFactoryModel.list()
        
        const val serializationHash = 558131271431219280L
        
    }
    override val serializersOwner: ISerializersOwner get() = CodeWithMeRunConfigurationsModel
    override val serializationHash: Long get() = CodeWithMeRunConfigurationsModel.serializationHash
    
    //fields
    val configurationTypes: IMutableViewableMap<String, CodeWithMeConfigurationTypeModel> get() = _configurationTypes
    val configurationFactories: IMutableViewableMap<String, List<CodeWithMeConfigurationFactoryModel>> get() = _configurationFactories
    val runConfigurations: IMutableViewableMap<String, CodeWithMeRunConfigurationModel> get() = _runConfigurations
    val selectedConfiguration: ISignal<String> get() = _selectedConfiguration
    //methods
    //initializer
    init {
        _runConfigurations.async = true
    }
    
    init {
        bindableChildren.add("configurationTypes" to _configurationTypes)
        bindableChildren.add("configurationFactories" to _configurationFactories)
        bindableChildren.add("runConfigurations" to _runConfigurations)
        bindableChildren.add("selectedConfiguration" to _selectedConfiguration)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdMap<String, CodeWithMeConfigurationTypeModel>(FrameworkMarshallers.String, CodeWithMeConfigurationTypeModel),
        RdMap<String, List<CodeWithMeConfigurationFactoryModel>>(FrameworkMarshallers.String, __CodeWithMeConfigurationFactoryModelListSerializer),
        RdMap<String, CodeWithMeRunConfigurationModel>(FrameworkMarshallers.String, CodeWithMeRunConfigurationModel),
        RdSignal<String>(FrameworkMarshallers.String)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeRunConfigurationsModel (")
        printer.indent {
            print("configurationTypes = "); _configurationTypes.print(printer); println()
            print("configurationFactories = "); _configurationFactories.print(printer); println()
            print("runConfigurations = "); _runConfigurations.print(printer); println()
            print("selectedConfiguration = "); _selectedConfiguration.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeRunConfigurationsModel   {
        return CodeWithMeRunConfigurationsModel(
            _configurationTypes.deepClonePolymorphic(),
            _configurationFactories.deepClonePolymorphic(),
            _runConfigurations.deepClonePolymorphic(),
            _selectedConfiguration.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeRunConfigurationsModel.kt]
 */
class CodeWithMeConfigurationFactoryModel private constructor(
    val id: String,
    private val _isApplicable: RdCall<Unit, Boolean>,
    private val _createTemplateConfiguration: RdCall<Unit, String>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CodeWithMeConfigurationFactoryModel> {
        override val _type: KClass<CodeWithMeConfigurationFactoryModel> = CodeWithMeConfigurationFactoryModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeConfigurationFactoryModel  {
            val _id = RdId.read(buffer)
            val id = buffer.readString()
            val _isApplicable = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, FrameworkMarshallers.Bool)
            val _createTemplateConfiguration = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, FrameworkMarshallers.String)
            return CodeWithMeConfigurationFactoryModel(id, _isApplicable, _createTemplateConfiguration).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeConfigurationFactoryModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.id)
            RdCall.write(ctx, buffer, value._isApplicable)
            RdCall.write(ctx, buffer, value._createTemplateConfiguration)
        }
        
        
    }
    //fields
    val isApplicable: RdCall<Unit, Boolean> get() = _isApplicable
    val createTemplateConfiguration: RdCall<Unit, String> get() = _createTemplateConfiguration
    //methods
    //initializer
    init {
        bindableChildren.add("isApplicable" to _isApplicable)
        bindableChildren.add("createTemplateConfiguration" to _createTemplateConfiguration)
    }
    
    //secondary constructor
    constructor(
        id: String
    ) : this(
        id,
        RdCall<Unit, Boolean>(FrameworkMarshallers.Void, FrameworkMarshallers.Bool),
        RdCall<Unit, String>(FrameworkMarshallers.Void, FrameworkMarshallers.String)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeConfigurationFactoryModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("isApplicable = "); _isApplicable.print(printer); println()
            print("createTemplateConfiguration = "); _createTemplateConfiguration.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeConfigurationFactoryModel   {
        return CodeWithMeConfigurationFactoryModel(
            id,
            _isApplicable.deepClonePolymorphic(),
            _createTemplateConfiguration.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeRunConfigurationsModel.kt]
 */
class CodeWithMeConfigurationTypeModel (
    val displayName: String,
    val id: String,
    val icon: com.jetbrains.rd.ide.model.IconModel?,
    val tag: String,
    val configurationTypeDescription: String,
    val configurationFactoryIds: List<String>,
    val helpTopic: String?,
    val isManaged: Boolean
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CodeWithMeConfigurationTypeModel> {
        override val _type: KClass<CodeWithMeConfigurationTypeModel> = CodeWithMeConfigurationTypeModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeConfigurationTypeModel  {
            val _id = RdId.read(buffer)
            val displayName = buffer.readString()
            val id = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val tag = buffer.readString()
            val configurationTypeDescription = buffer.readString()
            val configurationFactoryIds = buffer.readList { buffer.readString() }
            val helpTopic = buffer.readNullable { buffer.readString() }
            val isManaged = buffer.readBool()
            return CodeWithMeConfigurationTypeModel(displayName, id, icon, tag, configurationTypeDescription, configurationFactoryIds, helpTopic, isManaged).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeConfigurationTypeModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.displayName)
            buffer.writeString(value.id)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeString(value.tag)
            buffer.writeString(value.configurationTypeDescription)
            buffer.writeList(value.configurationFactoryIds) { v -> buffer.writeString(v) }
            buffer.writeNullable(value.helpTopic) { buffer.writeString(it) }
            buffer.writeBool(value.isManaged)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeConfigurationTypeModel (")
        printer.indent {
            print("displayName = "); displayName.print(printer); println()
            print("id = "); id.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("tag = "); tag.print(printer); println()
            print("configurationTypeDescription = "); configurationTypeDescription.print(printer); println()
            print("configurationFactoryIds = "); configurationFactoryIds.print(printer); println()
            print("helpTopic = "); helpTopic.print(printer); println()
            print("isManaged = "); isManaged.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeConfigurationTypeModel   {
        return CodeWithMeConfigurationTypeModel(
            displayName,
            id,
            icon,
            tag,
            configurationTypeDescription,
            configurationFactoryIds,
            helpTopic,
            isManaged
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeRunConfigurationsModel.kt]
 */
class CodeWithMeRunConfigurationModel private constructor(
    val name: String,
    val folderName: String?,
    val icon: com.jetbrains.rd.ide.model.IconModel?,
    val typeId: String,
    val factoryId: String,
    val isExternalSystem: Boolean,
    val editor: SettingsEditorModelBase,
    private val _execute: RdCall<CwmRunConfigurationExecuteArgs, Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CodeWithMeRunConfigurationModel> {
        override val _type: KClass<CodeWithMeRunConfigurationModel> = CodeWithMeRunConfigurationModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeRunConfigurationModel  {
            val _id = RdId.read(buffer)
            val name = buffer.readString()
            val folderName = buffer.readNullable { buffer.readString() }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val typeId = buffer.readString()
            val factoryId = buffer.readString()
            val isExternalSystem = buffer.readBool()
            val editor = ctx.serializers.readPolymorphic<SettingsEditorModelBase>(ctx, buffer, SettingsEditorModelBase)
            val _execute = RdCall.read(ctx, buffer, CwmRunConfigurationExecuteArgs, FrameworkMarshallers.Void)
            return CodeWithMeRunConfigurationModel(name, folderName, icon, typeId, factoryId, isExternalSystem, editor, _execute).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeRunConfigurationModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.name)
            buffer.writeNullable(value.folderName) { buffer.writeString(it) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeString(value.typeId)
            buffer.writeString(value.factoryId)
            buffer.writeBool(value.isExternalSystem)
            ctx.serializers.writePolymorphic(ctx, buffer, value.editor)
            RdCall.write(ctx, buffer, value._execute)
        }
        
        
    }
    //fields
    val execute: RdCall<CwmRunConfigurationExecuteArgs, Unit> get() = _execute
    //methods
    //initializer
    init {
        bindableChildren.add("editor" to editor)
        bindableChildren.add("execute" to _execute)
    }
    
    //secondary constructor
    constructor(
        name: String,
        folderName: String?,
        icon: com.jetbrains.rd.ide.model.IconModel?,
        typeId: String,
        factoryId: String,
        isExternalSystem: Boolean,
        editor: SettingsEditorModelBase
    ) : this(
        name,
        folderName,
        icon,
        typeId,
        factoryId,
        isExternalSystem,
        editor,
        RdCall<CwmRunConfigurationExecuteArgs, Unit>(CwmRunConfigurationExecuteArgs, FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeRunConfigurationModel (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("folderName = "); folderName.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("typeId = "); typeId.print(printer); println()
            print("factoryId = "); factoryId.print(printer); println()
            print("isExternalSystem = "); isExternalSystem.print(printer); println()
            print("editor = "); editor.print(printer); println()
            print("execute = "); _execute.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeRunConfigurationModel   {
        return CodeWithMeRunConfigurationModel(
            name,
            folderName,
            icon,
            typeId,
            factoryId,
            isExternalSystem,
            editor.deepClonePolymorphic(),
            _execute.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeRunConfigurationsModel.kt]
 */
data class CwmRunConfigurationExecuteArgs (
    val executorId: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CwmRunConfigurationExecuteArgs> {
        override val _type: KClass<CwmRunConfigurationExecuteArgs> = CwmRunConfigurationExecuteArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CwmRunConfigurationExecuteArgs  {
            val executorId = buffer.readString()
            return CwmRunConfigurationExecuteArgs(executorId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CwmRunConfigurationExecuteArgs)  {
            buffer.writeString(value.executorId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CwmRunConfigurationExecuteArgs
        
        if (executorId != other.executorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + executorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CwmRunConfigurationExecuteArgs (")
        printer.indent {
            print("executorId = "); executorId.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeRunConfigurationsModel.kt]
 */
class NamedEditor (
    val name: String,
    val editor: SimpleSettingsEditorModel
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<NamedEditor> {
        override val _type: KClass<NamedEditor> = NamedEditor::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NamedEditor  {
            val _id = RdId.read(buffer)
            val name = buffer.readString()
            val editor = SimpleSettingsEditorModel.read(ctx, buffer)
            return NamedEditor(name, editor).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NamedEditor)  {
            value.rdid.write(buffer)
            buffer.writeString(value.name)
            SimpleSettingsEditorModel.write(ctx, buffer, value.editor)
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("editor" to editor)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NamedEditor (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("editor = "); editor.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): NamedEditor   {
        return NamedEditor(
            name,
            editor.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeRunConfigurationsModel.kt]
 */
class SettingsEditorGroupModel (
    val editors: List<NamedEditor>
) : SettingsEditorModelBase (
) {
    //companion
    
    companion object : IMarshaller<SettingsEditorGroupModel> {
        override val _type: KClass<SettingsEditorGroupModel> = SettingsEditorGroupModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SettingsEditorGroupModel  {
            val _id = RdId.read(buffer)
            val editors = buffer.readList { NamedEditor.read(ctx, buffer) }
            return SettingsEditorGroupModel(editors).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SettingsEditorGroupModel)  {
            value.rdid.write(buffer)
            buffer.writeList(value.editors) { v -> NamedEditor.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("editors" to editors)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SettingsEditorGroupModel (")
        printer.indent {
            print("editors = "); editors.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): SettingsEditorGroupModel   {
        return SettingsEditorGroupModel(
            editors.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeRunConfigurationsModel.kt]
 */
abstract class SettingsEditorModelBase (
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<SettingsEditorModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): SettingsEditorModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return SettingsEditorModelBase_Unknown(unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class SettingsEditorModelBase_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : SettingsEditorModelBase (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<SettingsEditorModelBase_Unknown> {
        override val _type: KClass<SettingsEditorModelBase_Unknown> = SettingsEditorModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SettingsEditorModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SettingsEditorModelBase_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SettingsEditorModelBase_Unknown (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): SettingsEditorModelBase_Unknown   {
        return SettingsEditorModelBase_Unknown(
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeRunConfigurationsModel.kt]
 */
class SimpleSettingsEditorModel (
    val component: com.jetbrains.ide.model.uiautomation.BeControl
) : SettingsEditorModelBase (
) {
    //companion
    
    companion object : IMarshaller<SimpleSettingsEditorModel> {
        override val _type: KClass<SimpleSettingsEditorModel> = SimpleSettingsEditorModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SimpleSettingsEditorModel  {
            val _id = RdId.read(buffer)
            val component = ctx.serializers.readPolymorphic<com.jetbrains.ide.model.uiautomation.BeControl>(ctx, buffer, com.jetbrains.ide.model.uiautomation.BeControl)
            return SimpleSettingsEditorModel(component).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SimpleSettingsEditorModel)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.component)
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("component" to component)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SimpleSettingsEditorModel (")
        printer.indent {
            print("component = "); component.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): SimpleSettingsEditorModel   {
        return SimpleSettingsEditorModel(
            component.deepClonePolymorphic()
        )
    }
    //contexts
}
