@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CodeWithMeModel.kt]
 */
class CodeWithMeSolutionExtModel private constructor(
    private val _otherUsersFocusLocations: RdMap<String, CodeWithMeUserFocus>,
    private val _hostUnderModality: RdOptionalProperty<HostModality>,
    private val _connection: RdOptionalProperty<ConnectionModel>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(CodeWithMeUserFocus)
            serializers.register(HostModality)
            serializers.register(ConnectionModel)
            serializers.register(GuestTerminationReason.marshaller)
            serializers.register(CWMSessionStatus.marshaller)
            serializers.register(RemoteCaretData)
            serializers.register(RemoteCaretHighlighterModel)
            serializers.register(SyntaxHighlighterModel)
            serializers.register(Terminated)
        }
        
        
        
        
        const val serializationHash = 7864568761425165908L
        
    }
    override val serializersOwner: ISerializersOwner get() = CodeWithMeSolutionExtModel
    override val serializationHash: Long get() = CodeWithMeSolutionExtModel.serializationHash
    
    //fields
    val otherUsersFocusLocations: IMutableViewableMap<String, CodeWithMeUserFocus> get() = _otherUsersFocusLocations
    val hostUnderModality: IOptProperty<HostModality> get() = _hostUnderModality
    val connection: IOptProperty<ConnectionModel> get() = _connection
    //methods
    //initializer
    init {
        _hostUnderModality.optimizeNested = true
    }
    
    init {
        bindableChildren.add("otherUsersFocusLocations" to _otherUsersFocusLocations)
        bindableChildren.add("hostUnderModality" to _hostUnderModality)
        bindableChildren.add("connection" to _connection)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdMap<String, CodeWithMeUserFocus>(FrameworkMarshallers.String, CodeWithMeUserFocus),
        RdOptionalProperty<HostModality>(HostModality),
        RdOptionalProperty<ConnectionModel>(ConnectionModel)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeSolutionExtModel (")
        printer.indent {
            print("otherUsersFocusLocations = "); _otherUsersFocusLocations.print(printer); println()
            print("hostUnderModality = "); _hostUnderModality.print(printer); println()
            print("connection = "); _connection.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeSolutionExtModel   {
        return CodeWithMeSolutionExtModel(
            _otherUsersFocusLocations.deepClonePolymorphic(),
            _hostUnderModality.deepClonePolymorphic(),
            _connection.deepClonePolymorphic()
        )
    }
    //contexts
}
val com.jetbrains.rd.ide.model.Solution.codeWithMeSolutionExtModel get() = getOrCreateExtension("codeWithMeSolutionExtModel", ::CodeWithMeSolutionExtModel)



/**
 * #### Generated from [CodeWithMeModel.kt]
 */
enum class CWMSessionStatus {
    LICENSED_SESSION, 
    FREE_SESSION, 
    EXPIRED, 
    FREE_SESSION_STOPPED;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<CWMSessionStatus>()
        
    }
}


/**
 * #### Generated from [CodeWithMeModel.kt]
 */
class CodeWithMeUserFocus private constructor(
    val name: String,
    private val _documentId: RdProperty<com.jetbrains.rd.ide.model.RdDocumentId?>,
    private val _caretOffset: RdOptionalProperty<Int>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CodeWithMeUserFocus> {
        override val _type: KClass<CodeWithMeUserFocus> = CodeWithMeUserFocus::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CodeWithMeUserFocus  {
            val _id = RdId.read(buffer)
            val name = buffer.readString()
            val _documentId = RdProperty.read(ctx, buffer, __RdDocumentIdNullableSerializer)
            val _caretOffset = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            return CodeWithMeUserFocus(name, _documentId, _caretOffset).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CodeWithMeUserFocus)  {
            value.rdid.write(buffer)
            buffer.writeString(value.name)
            RdProperty.write(ctx, buffer, value._documentId)
            RdOptionalProperty.write(ctx, buffer, value._caretOffset)
        }
        
        private val __RdDocumentIdNullableSerializer = AbstractPolymorphic(com.jetbrains.rd.ide.model.RdDocumentId).nullable()
        
    }
    //fields
    val documentId: IProperty<com.jetbrains.rd.ide.model.RdDocumentId?> get() = _documentId
    val caretOffset: IOptProperty<Int> get() = _caretOffset
    //methods
    //initializer
    init {
        _documentId.optimizeNested = true
        _caretOffset.optimizeNested = true
    }
    
    init {
        bindableChildren.add("documentId" to _documentId)
        bindableChildren.add("caretOffset" to _caretOffset)
    }
    
    //secondary constructor
    constructor(
        name: String
    ) : this(
        name,
        RdProperty<com.jetbrains.rd.ide.model.RdDocumentId?>(null, __RdDocumentIdNullableSerializer),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CodeWithMeUserFocus (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("documentId = "); _documentId.print(printer); println()
            print("caretOffset = "); _caretOffset.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CodeWithMeUserFocus   {
        return CodeWithMeUserFocus(
            name,
            _documentId.deepClonePolymorphic(),
            _caretOffset.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeModel.kt]
 */
class ConnectionModel private constructor(
    private val _terminated: RdSignal<Terminated>,
    private val _sessionStatus: RdProperty<CWMSessionStatus?>,
    private val _freeSessionRemainingTimeMs: RdProperty<Long?>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<ConnectionModel> {
        override val _type: KClass<ConnectionModel> = ConnectionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ConnectionModel  {
            val _id = RdId.read(buffer)
            val _terminated = RdSignal.read(ctx, buffer, Terminated)
            val _sessionStatus = RdProperty.read(ctx, buffer, __CWMSessionStatusNullableSerializer)
            val _freeSessionRemainingTimeMs = RdProperty.read(ctx, buffer, __LongNullableSerializer)
            return ConnectionModel(_terminated, _sessionStatus, _freeSessionRemainingTimeMs).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ConnectionModel)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._terminated)
            RdProperty.write(ctx, buffer, value._sessionStatus)
            RdProperty.write(ctx, buffer, value._freeSessionRemainingTimeMs)
        }
        
        private val __CWMSessionStatusNullableSerializer = CWMSessionStatus.marshaller.nullable()
        private val __LongNullableSerializer = FrameworkMarshallers.Long.nullable()
        
    }
    //fields
    val terminated: ISignal<Terminated> get() = _terminated
    val sessionStatus: IProperty<CWMSessionStatus?> get() = _sessionStatus
    val freeSessionRemainingTimeMs: IProperty<Long?> get() = _freeSessionRemainingTimeMs
    //methods
    //initializer
    init {
        _sessionStatus.optimizeNested = true
        _freeSessionRemainingTimeMs.optimizeNested = true
    }
    
    init {
        bindableChildren.add("terminated" to _terminated)
        bindableChildren.add("sessionStatus" to _sessionStatus)
        bindableChildren.add("freeSessionRemainingTimeMs" to _freeSessionRemainingTimeMs)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdSignal<Terminated>(Terminated),
        RdProperty<CWMSessionStatus?>(null, __CWMSessionStatusNullableSerializer),
        RdProperty<Long?>(null, __LongNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ConnectionModel (")
        printer.indent {
            print("terminated = "); _terminated.print(printer); println()
            print("sessionStatus = "); _sessionStatus.print(printer); println()
            print("freeSessionRemainingTimeMs = "); _freeSessionRemainingTimeMs.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ConnectionModel   {
        return ConnectionModel(
            _terminated.deepClonePolymorphic(),
            _sessionStatus.deepClonePolymorphic(),
            _freeSessionRemainingTimeMs.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CodeWithMeModel.kt]
 */
enum class GuestTerminationReason {
    FREE_SESSION_ENDED, 
    KICKED_BY_HOST, 
    SHUTDOWN, 
    ERROR, 
    UNKNOWN;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<GuestTerminationReason>()
        
    }
}


/**
 * #### Generated from [CodeWithMeModel.kt]
 */
data class HostModality (
    val depth: Int,
    val message: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<HostModality> {
        override val _type: KClass<HostModality> = HostModality::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HostModality  {
            val depth = buffer.readInt()
            val message = buffer.readString()
            return HostModality(depth, message)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HostModality)  {
            buffer.writeInt(value.depth)
            buffer.writeString(value.message)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HostModality
        
        if (depth != other.depth) return false
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + depth.hashCode()
        __r = __r*31 + message.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HostModality (")
        printer.indent {
            print("depth = "); depth.print(printer); println()
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeModel.kt]
 */
data class RemoteCaretData (
    val user: RdUserModel,
    val showCaretAtStart: Boolean,
    val lead: RdUserModel?,
    val isSetManually: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RemoteCaretData> {
        override val _type: KClass<RemoteCaretData> = RemoteCaretData::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RemoteCaretData  {
            val user = RdUserModel.read(ctx, buffer)
            val showCaretAtStart = buffer.readBool()
            val lead = buffer.readNullable { RdUserModel.read(ctx, buffer) }
            val isSetManually = buffer.readBool()
            return RemoteCaretData(user, showCaretAtStart, lead, isSetManually)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RemoteCaretData)  {
            RdUserModel.write(ctx, buffer, value.user)
            buffer.writeBool(value.showCaretAtStart)
            buffer.writeNullable(value.lead) { RdUserModel.write(ctx, buffer, it) }
            buffer.writeBool(value.isSetManually)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RemoteCaretData
        
        if (user != other.user) return false
        if (showCaretAtStart != other.showCaretAtStart) return false
        if (lead != other.lead) return false
        if (isSetManually != other.isSetManually) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + user.hashCode()
        __r = __r*31 + showCaretAtStart.hashCode()
        __r = __r*31 + if (lead != null) lead.hashCode() else 0
        __r = __r*31 + isSetManually.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RemoteCaretData (")
        printer.indent {
            print("user = "); user.print(printer); println()
            print("showCaretAtStart = "); showCaretAtStart.print(printer); println()
            print("lead = "); lead.print(printer); println()
            print("isSetManually = "); isSetManually.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeModel.kt]
 */
class RemoteCaretHighlighterModel (
    val `data`: RemoteCaretData,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: com.jetbrains.rd.ide.model.AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : com.jetbrains.rd.ide.model.HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<RemoteCaretHighlighterModel> {
        override val _type: KClass<RemoteCaretHighlighterModel> = RemoteCaretHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RemoteCaretHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.AbstractDocumentVersion>(ctx, buffer, com.jetbrains.rd.ide.model.AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val `data` = RemoteCaretData.read(ctx, buffer)
            return RemoteCaretHighlighterModel(`data`, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RemoteCaretHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            RemoteCaretData.write(ctx, buffer, value.`data`)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RemoteCaretHighlighterModel
        
        if (`data` != other.`data`) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + `data`.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RemoteCaretHighlighterModel (")
        printer.indent {
            print("data = "); `data`.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeModel.kt]
 */
class SyntaxHighlighterModel (
    val attributeIds: List<String>,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: com.jetbrains.rd.ide.model.AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : com.jetbrains.rd.ide.model.HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<SyntaxHighlighterModel> {
        override val _type: KClass<SyntaxHighlighterModel> = SyntaxHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SyntaxHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.AbstractDocumentVersion>(ctx, buffer, com.jetbrains.rd.ide.model.AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val attributeIds = buffer.readList { ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() } }
            return SyntaxHighlighterModel(attributeIds, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SyntaxHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeList(value.attributeIds) { v -> ctx.writeInterned(buffer, v, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) } }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SyntaxHighlighterModel
        
        if (attributeIds != other.attributeIds) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + attributeIds.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SyntaxHighlighterModel (")
        printer.indent {
            print("attributeIds = "); attributeIds.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeWithMeModel.kt]
 */
data class Terminated (
    val reason: GuestTerminationReason,
    val message: String?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<Terminated> {
        override val _type: KClass<Terminated> = Terminated::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): Terminated  {
            val reason = buffer.readEnum<GuestTerminationReason>()
            val message = buffer.readNullable { buffer.readString() }
            return Terminated(reason, message)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: Terminated)  {
            buffer.writeEnum(value.reason)
            buffer.writeNullable(value.message) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as Terminated
        
        if (reason != other.reason) return false
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + reason.hashCode()
        __r = __r*31 + if (message != null) message.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("Terminated (")
        printer.indent {
            print("reason = "); reason.print(printer); println()
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
