@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [ColorChooserModel.kt]
 */
class ColorChooserModel private constructor(
    private val _colorChooserSessions: RdList<ColorChooserSession>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(ColorChooserParam)
            serializers.register(ColorChooserSession)
        }
        
        
        
        
        const val serializationHash = -6728442115923454418L
        
    }
    override val serializersOwner: ISerializersOwner get() = ColorChooserModel
    override val serializationHash: Long get() = ColorChooserModel.serializationHash
    
    //fields
    val colorChooserSessions: IMutableViewableList<ColorChooserSession> get() = _colorChooserSessions
    //methods
    //initializer
    init {
        bindableChildren.add("colorChooserSessions" to _colorChooserSessions)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdList<ColorChooserSession>(ColorChooserSession)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ColorChooserModel (")
        printer.indent {
            print("colorChooserSessions = "); _colorChooserSessions.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ColorChooserModel   {
        return ColorChooserModel(
            _colorChooserSessions.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.colorChooserModel get() = getOrCreateExtension("colorChooserModel", ::ColorChooserModel)



/**
 * #### Generated from [ColorChooserModel.kt]
 */
data class ColorChooserParam (
    val caption: String?,
    val preselectedColor: RgbaColor?,
    val enableOpacity: Boolean,
    val opacityInPercent: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ColorChooserParam> {
        override val _type: KClass<ColorChooserParam> = ColorChooserParam::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ColorChooserParam  {
            val caption = buffer.readNullable { buffer.readString() }
            val preselectedColor = buffer.readNullable { RgbaColor.read(ctx, buffer) }
            val enableOpacity = buffer.readBool()
            val opacityInPercent = buffer.readBool()
            return ColorChooserParam(caption, preselectedColor, enableOpacity, opacityInPercent)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ColorChooserParam)  {
            buffer.writeNullable(value.caption) { buffer.writeString(it) }
            buffer.writeNullable(value.preselectedColor) { RgbaColor.write(ctx, buffer, it) }
            buffer.writeBool(value.enableOpacity)
            buffer.writeBool(value.opacityInPercent)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ColorChooserParam
        
        if (caption != other.caption) return false
        if (preselectedColor != other.preselectedColor) return false
        if (enableOpacity != other.enableOpacity) return false
        if (opacityInPercent != other.opacityInPercent) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (caption != null) caption.hashCode() else 0
        __r = __r*31 + if (preselectedColor != null) preselectedColor.hashCode() else 0
        __r = __r*31 + enableOpacity.hashCode()
        __r = __r*31 + opacityInPercent.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ColorChooserParam (")
        printer.indent {
            print("caption = "); caption.print(printer); println()
            print("preselectedColor = "); preselectedColor.print(printer); println()
            print("enableOpacity = "); enableOpacity.print(printer); println()
            print("opacityInPercent = "); opacityInPercent.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ColorChooserModel.kt]
 */
class ColorChooserSession private constructor(
    val `param`: ColorChooserParam,
    private val _colorChanged: RdSignal<RgbaColor?>,
    private val _closed: RdSignal<RgbaColor?>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<ColorChooserSession> {
        override val _type: KClass<ColorChooserSession> = ColorChooserSession::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ColorChooserSession  {
            val _id = RdId.read(buffer)
            val `param` = ColorChooserParam.read(ctx, buffer)
            val _colorChanged = RdSignal.read(ctx, buffer, __RgbaColorNullableSerializer)
            val _closed = RdSignal.read(ctx, buffer, __RgbaColorNullableSerializer)
            return ColorChooserSession(`param`, _colorChanged, _closed).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ColorChooserSession)  {
            value.rdid.write(buffer)
            ColorChooserParam.write(ctx, buffer, value.`param`)
            RdSignal.write(ctx, buffer, value._colorChanged)
            RdSignal.write(ctx, buffer, value._closed)
        }
        
        private val __RgbaColorNullableSerializer = RgbaColor.nullable()
        
    }
    //fields
    val colorChanged: ISignal<RgbaColor?> get() = _colorChanged
    val closed: ISignal<RgbaColor?> get() = _closed
    //methods
    //initializer
    init {
        bindableChildren.add("colorChanged" to _colorChanged)
        bindableChildren.add("closed" to _closed)
    }
    
    //secondary constructor
    constructor(
        `param`: ColorChooserParam
    ) : this(
        `param`,
        RdSignal<RgbaColor?>(__RgbaColorNullableSerializer),
        RdSignal<RgbaColor?>(__RgbaColorNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ColorChooserSession (")
        printer.indent {
            print("param = "); `param`.print(printer); println()
            print("colorChanged = "); _colorChanged.print(printer); println()
            print("closed = "); _closed.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ColorChooserSession   {
        return ColorChooserSession(
            `param`,
            _colorChanged.deepClonePolymorphic(),
            _closed.deepClonePolymorphic()
        )
    }
    //contexts
}
