@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [Colors.kt]
 */
class Colors private constructor(
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RgbColor)
            serializers.register(RgbaColor)
            serializers.register(ThemeColorId)
            serializers.register(DualColor)
            serializers.register(ColorId.marshaller)
            serializers.register(AbstractColor_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): Colors  {
            IdeRoot.register(protocol.serializers)
            
            return Colors().apply {
                identify(protocol.identity, RdId.Null.mix("Colors"))
                bind(lifetime, protocol, "Colors")
            }
        }
        
        
        const val serializationHash = -2268722531913322628L
        
    }
    override val serializersOwner: ISerializersOwner get() = Colors
    override val serializationHash: Long get() = Colors.serializationHash
    
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("Colors (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): Colors   {
        return Colors(
        )
    }
    //contexts
}


/**
 * #### Generated from [Colors.kt]
 */
abstract class AbstractColor (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<AbstractColor> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): AbstractColor  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return AbstractColor_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class AbstractColor_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : AbstractColor (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<AbstractColor_Unknown> {
        override val _type: KClass<AbstractColor_Unknown> = AbstractColor_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): AbstractColor_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: AbstractColor_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as AbstractColor_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("AbstractColor_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [Colors.kt]
 */
enum class ColorId {
    DefaultForeground, 
    Gray, 
    LabelForeground, 
    LabelForegroundBrighter, 
    LabelDisabled, 
    ListBackground;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ColorId>()
        
    }
}


/**
 * #### Generated from [Colors.kt]
 */
class DualColor (
    val lightColor: RgbaColor,
    val darkColor: RgbaColor
) : AbstractColor (
) {
    //companion
    
    companion object : IMarshaller<DualColor> {
        override val _type: KClass<DualColor> = DualColor::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DualColor  {
            val lightColor = RgbaColor.read(ctx, buffer)
            val darkColor = RgbaColor.read(ctx, buffer)
            return DualColor(lightColor, darkColor)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DualColor)  {
            RgbaColor.write(ctx, buffer, value.lightColor)
            RgbaColor.write(ctx, buffer, value.darkColor)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DualColor
        
        if (lightColor != other.lightColor) return false
        if (darkColor != other.darkColor) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + lightColor.hashCode()
        __r = __r*31 + darkColor.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DualColor (")
        printer.indent {
            print("lightColor = "); lightColor.print(printer); println()
            print("darkColor = "); darkColor.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [Colors.kt]
 */
class RgbColor (
    val red: Int,
    val green: Int,
    val blue: Int
) : AbstractColor (
) {
    //companion
    
    companion object : IMarshaller<RgbColor> {
        override val _type: KClass<RgbColor> = RgbColor::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RgbColor  {
            val red = buffer.readInt()
            val green = buffer.readInt()
            val blue = buffer.readInt()
            return RgbColor(red, green, blue)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RgbColor)  {
            buffer.writeInt(value.red)
            buffer.writeInt(value.green)
            buffer.writeInt(value.blue)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RgbColor
        
        if (red != other.red) return false
        if (green != other.green) return false
        if (blue != other.blue) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + red.hashCode()
        __r = __r*31 + green.hashCode()
        __r = __r*31 + blue.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RgbColor (")
        printer.indent {
            print("red = "); red.print(printer); println()
            print("green = "); green.print(printer); println()
            print("blue = "); blue.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [Colors.kt]
 */
class RgbaColor (
    val red: Int,
    val green: Int,
    val blue: Int,
    val alpha: Int
) : AbstractColor (
) {
    //companion
    
    companion object : IMarshaller<RgbaColor> {
        override val _type: KClass<RgbaColor> = RgbaColor::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RgbaColor  {
            val red = buffer.readInt()
            val green = buffer.readInt()
            val blue = buffer.readInt()
            val alpha = buffer.readInt()
            return RgbaColor(red, green, blue, alpha)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RgbaColor)  {
            buffer.writeInt(value.red)
            buffer.writeInt(value.green)
            buffer.writeInt(value.blue)
            buffer.writeInt(value.alpha)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RgbaColor
        
        if (red != other.red) return false
        if (green != other.green) return false
        if (blue != other.blue) return false
        if (alpha != other.alpha) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + red.hashCode()
        __r = __r*31 + green.hashCode()
        __r = __r*31 + blue.hashCode()
        __r = __r*31 + alpha.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RgbaColor (")
        printer.indent {
            print("red = "); red.print(printer); println()
            print("green = "); green.print(printer); println()
            print("blue = "); blue.print(printer); println()
            print("alpha = "); alpha.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [Colors.kt]
 */
class ThemeColorId (
    val id: ColorId
) : AbstractColor (
) {
    //companion
    
    companion object : IMarshaller<ThemeColorId> {
        override val _type: KClass<ThemeColorId> = ThemeColorId::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ThemeColorId  {
            val id = buffer.readEnum<ColorId>()
            return ThemeColorId(id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ThemeColorId)  {
            buffer.writeEnum(value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ThemeColorId
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ThemeColorId (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
