@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CompletionModel.kt]
 */
class CompletionModel private constructor(
    private val _autoPopupResult: RdSignal<AutoPopupResult>,
    private val _completionSession: RdProperty<CompletionTuple?>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(CompletionMode.marshaller)
            serializers.register(CompletionParameters)
            serializers.register(CompletionItemType.marshaller)
            serializers.register(CompletionPresentationPart)
            serializers.register(CompletionPresentationModel)
            serializers.register(CompletionItem)
            serializers.register(CompletionList)
            serializers.register(CompleteData)
            serializers.register(ItemsToUpdate)
            serializers.register(ToUpdate)
            serializers.register(SummaryInfoItem)
            serializers.register(LookupSummaryInfo)
            serializers.register(FocusBehaviour.marshaller)
            serializers.register(CompletionSessionModel)
            serializers.register(CompletionTuple)
            serializers.register(AutoPopupResult)
            serializers.register(ScoringHint.marshaller)
            serializers.register(AdvancedPresentation)
            serializers.register(SessionState.marshaller)
        }
        
        
        
        private val __CompletionTupleNullableSerializer = CompletionTuple.nullable()
        
        const val serializationHash = 9902521080447919L
        
    }
    override val serializersOwner: ISerializersOwner get() = CompletionModel
    override val serializationHash: Long get() = CompletionModel.serializationHash
    
    //fields
    val autoPopupResult: ISignal<AutoPopupResult> get() = _autoPopupResult
    val completionSession: IProperty<CompletionTuple?> get() = _completionSession
    //methods
    //initializer
    init {
        _completionSession.async = true
    }
    
    init {
        bindableChildren.add("autoPopupResult" to _autoPopupResult)
        bindableChildren.add("completionSession" to _completionSession)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdSignal<AutoPopupResult>(AutoPopupResult),
        RdProperty<CompletionTuple?>(null, __CompletionTupleNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CompletionModel (")
        printer.indent {
            print("autoPopupResult = "); _autoPopupResult.print(printer); println()
            print("completionSession = "); _completionSession.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CompletionModel   {
        return CompletionModel(
            _autoPopupResult.deepClonePolymorphic(),
            _completionSession.deepClonePolymorphic()
        )
    }
    //contexts
}
val TextControlModel.completionModel get() = getOrCreateExtension("completionModel", ::CompletionModel)



/**
 * #### Generated from [CompletionModel.kt]
 */
data class AdvancedPresentation (
    val id: Int,
    val displayName: CompletionPresentationModel?,
    val returnType: String?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<AdvancedPresentation> {
        override val _type: KClass<AdvancedPresentation> = AdvancedPresentation::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): AdvancedPresentation  {
            val id = buffer.readInt()
            val displayName = buffer.readNullable { CompletionPresentationModel.read(ctx, buffer) }
            val returnType = buffer.readNullable { buffer.readString() }
            return AdvancedPresentation(id, displayName, returnType)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: AdvancedPresentation)  {
            buffer.writeInt(value.id)
            buffer.writeNullable(value.displayName) { CompletionPresentationModel.write(ctx, buffer, it) }
            buffer.writeNullable(value.returnType) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as AdvancedPresentation
        
        if (id != other.id) return false
        if (displayName != other.displayName) return false
        if (returnType != other.returnType) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (displayName != null) displayName.hashCode() else 0
        __r = __r*31 + if (returnType != null) returnType.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("AdvancedPresentation (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("displayName = "); displayName.print(printer); println()
            print("returnType = "); returnType.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
data class AutoPopupResult (
    val shouldBeShown: Boolean,
    val typingTimeStamp: Int?,
    val forceSoft: Boolean?,
    val mode: CompletionMode,
    val documentVersion: AbstractDocumentVersion? = null,
    val editorVersion: RdAbstractEditorVersion? = null
) : IPrintable {
    //companion
    
    companion object : IMarshaller<AutoPopupResult> {
        override val _type: KClass<AutoPopupResult> = AutoPopupResult::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): AutoPopupResult  {
            val shouldBeShown = buffer.readBool()
            val typingTimeStamp = buffer.readNullable { buffer.readInt() }
            val forceSoft = buffer.readNullable { buffer.readBool() }
            val mode = buffer.readEnum<CompletionMode>()
            val documentVersion = buffer.readNullable { ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion) }
            val editorVersion = buffer.readNullable { ctx.serializers.readPolymorphic<RdAbstractEditorVersion>(ctx, buffer, RdAbstractEditorVersion) }
            return AutoPopupResult(shouldBeShown, typingTimeStamp, forceSoft, mode, documentVersion, editorVersion)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: AutoPopupResult)  {
            buffer.writeBool(value.shouldBeShown)
            buffer.writeNullable(value.typingTimeStamp) { buffer.writeInt(it) }
            buffer.writeNullable(value.forceSoft) { buffer.writeBool(it) }
            buffer.writeEnum(value.mode)
            buffer.writeNullable(value.documentVersion) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.editorVersion) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as AutoPopupResult
        
        if (shouldBeShown != other.shouldBeShown) return false
        if (typingTimeStamp != other.typingTimeStamp) return false
        if (forceSoft != other.forceSoft) return false
        if (mode != other.mode) return false
        if (documentVersion != other.documentVersion) return false
        if (editorVersion != other.editorVersion) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + shouldBeShown.hashCode()
        __r = __r*31 + if (typingTimeStamp != null) typingTimeStamp.hashCode() else 0
        __r = __r*31 + if (forceSoft != null) forceSoft.hashCode() else 0
        __r = __r*31 + mode.hashCode()
        __r = __r*31 + if (documentVersion != null) documentVersion.hashCode() else 0
        __r = __r*31 + if (editorVersion != null) editorVersion.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("AutoPopupResult (")
        printer.indent {
            print("shouldBeShown = "); shouldBeShown.print(printer); println()
            print("typingTimeStamp = "); typingTimeStamp.print(printer); println()
            print("forceSoft = "); forceSoft.print(printer); println()
            print("mode = "); mode.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("editorVersion = "); editorVersion.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
data class CompleteData (
    val item: CompletionItem,
    val typedChar: Char,
    val typingSessionTimestamp: Int?,
    val callTypingAssists: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CompleteData> {
        override val _type: KClass<CompleteData> = CompleteData::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CompleteData  {
            val item = CompletionItem.read(ctx, buffer)
            val typedChar = buffer.readChar()
            val typingSessionTimestamp = buffer.readNullable { buffer.readInt() }
            val callTypingAssists = buffer.readBool()
            return CompleteData(item, typedChar, typingSessionTimestamp, callTypingAssists)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CompleteData)  {
            CompletionItem.write(ctx, buffer, value.item)
            buffer.writeChar(value.typedChar)
            buffer.writeNullable(value.typingSessionTimestamp) { buffer.writeInt(it) }
            buffer.writeBool(value.callTypingAssists)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CompleteData
        
        if (item != other.item) return false
        if (typedChar != other.typedChar) return false
        if (typingSessionTimestamp != other.typingSessionTimestamp) return false
        if (callTypingAssists != other.callTypingAssists) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + item.hashCode()
        __r = __r*31 + typedChar.hashCode()
        __r = __r*31 + if (typingSessionTimestamp != null) typingSessionTimestamp.hashCode() else 0
        __r = __r*31 + callTypingAssists.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CompleteData (")
        printer.indent {
            print("item = "); item.print(printer); println()
            print("typedChar = "); typedChar.print(printer); println()
            print("typingSessionTimestamp = "); typingSessionTimestamp.print(printer); println()
            print("callTypingAssists = "); callTypingAssists.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
data class CompletionItem (
    val shortText: String,
    val displayName: CompletionPresentationModel?,
    val typeName: String?,
    val icon: IconModel?,
    val id: Int,
    val priority: Long = 0,
    val itemType: CompletionItemType = CompletionItemType.Default,
    val scoringHints: List<ScoringHint>,
    val prefix: String? = null,
    val statsScore: Int,
    val asyncBehaviorAllowed: Boolean,
    val worthShowingInAutoPopup: Boolean,
    val speculativeInsert: String? = null
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CompletionItem> {
        override val _type: KClass<CompletionItem> = CompletionItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CompletionItem  {
            val shortText = buffer.readString()
            val displayName = buffer.readNullable { CompletionPresentationModel.read(ctx, buffer) }
            val typeName = buffer.readNullable { ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() } }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val id = buffer.readInt()
            val priority = buffer.readLong()
            val itemType = buffer.readEnum<CompletionItemType>()
            val scoringHints = buffer.readList { buffer.readEnum<ScoringHint>() }
            val prefix = buffer.readNullable { buffer.readString() }
            val statsScore = buffer.readInt()
            val asyncBehaviorAllowed = buffer.readBool()
            val worthShowingInAutoPopup = buffer.readBool()
            val speculativeInsert = buffer.readNullable { buffer.readString() }
            return CompletionItem(shortText, displayName, typeName, icon, id, priority, itemType, scoringHints, prefix, statsScore, asyncBehaviorAllowed, worthShowingInAutoPopup, speculativeInsert)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CompletionItem)  {
            buffer.writeString(value.shortText)
            buffer.writeNullable(value.displayName) { CompletionPresentationModel.write(ctx, buffer, it) }
            buffer.writeNullable(value.typeName) { ctx.writeInterned(buffer, it, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) } }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeInt(value.id)
            buffer.writeLong(value.priority)
            buffer.writeEnum(value.itemType)
            buffer.writeList(value.scoringHints) { v -> buffer.writeEnum(v) }
            buffer.writeNullable(value.prefix) { buffer.writeString(it) }
            buffer.writeInt(value.statsScore)
            buffer.writeBool(value.asyncBehaviorAllowed)
            buffer.writeBool(value.worthShowingInAutoPopup)
            buffer.writeNullable(value.speculativeInsert) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CompletionItem
        
        if (shortText != other.shortText) return false
        if (displayName != other.displayName) return false
        if (typeName != other.typeName) return false
        if (icon != other.icon) return false
        if (id != other.id) return false
        if (priority != other.priority) return false
        if (itemType != other.itemType) return false
        if (scoringHints != other.scoringHints) return false
        if (prefix != other.prefix) return false
        if (statsScore != other.statsScore) return false
        if (asyncBehaviorAllowed != other.asyncBehaviorAllowed) return false
        if (worthShowingInAutoPopup != other.worthShowingInAutoPopup) return false
        if (speculativeInsert != other.speculativeInsert) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + shortText.hashCode()
        __r = __r*31 + if (displayName != null) displayName.hashCode() else 0
        __r = __r*31 + if (typeName != null) typeName.hashCode() else 0
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + priority.hashCode()
        __r = __r*31 + itemType.hashCode()
        __r = __r*31 + scoringHints.hashCode()
        __r = __r*31 + if (prefix != null) prefix.hashCode() else 0
        __r = __r*31 + statsScore.hashCode()
        __r = __r*31 + asyncBehaviorAllowed.hashCode()
        __r = __r*31 + worthShowingInAutoPopup.hashCode()
        __r = __r*31 + if (speculativeInsert != null) speculativeInsert.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CompletionItem (")
        printer.indent {
            print("shortText = "); shortText.print(printer); println()
            print("displayName = "); displayName.print(printer); println()
            print("typeName = "); typeName.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("id = "); id.print(printer); println()
            print("priority = "); priority.print(printer); println()
            print("itemType = "); itemType.print(printer); println()
            print("scoringHints = "); scoringHints.print(printer); println()
            print("prefix = "); prefix.print(printer); println()
            print("statsScore = "); statsScore.print(printer); println()
            print("asyncBehaviorAllowed = "); asyncBehaviorAllowed.print(printer); println()
            print("worthShowingInAutoPopup = "); worthShowingInAutoPopup.print(printer); println()
            print("speculativeInsert = "); speculativeInsert.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
enum class CompletionItemType {
    Default, 
    TemplateItem, 
    PostfixTemplate, 
    NamedParameter;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<CompletionItemType>()
        
    }
}


/**
 * #### Generated from [CompletionModel.kt]
 */
data class CompletionList (
    val items: List<CompletionItem>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CompletionList> {
        override val _type: KClass<CompletionList> = CompletionList::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CompletionList  {
            val items = buffer.readList { CompletionItem.read(ctx, buffer) }
            return CompletionList(items)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CompletionList)  {
            buffer.writeList(value.items) { v -> CompletionItem.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CompletionList
        
        if (items != other.items) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + items.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CompletionList (")
        printer.indent {
            print("items = "); items.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
enum class CompletionMode {
    Basic, 
    Smart, 
    Import;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<CompletionMode>()
        
    }
}


/**
 * #### Generated from [CompletionModel.kt]
 */
class CompletionParameters (
    val mode: CompletionMode,
    val isAutoCompletion: Boolean,
    val invocationCount: Int,
    val offset: Int,
    val prefix: String?,
    val customBackendParams: String?,
    val isSelectionDisjoint: Boolean
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CompletionParameters> {
        override val _type: KClass<CompletionParameters> = CompletionParameters::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CompletionParameters  {
            val _id = RdId.read(buffer)
            val mode = buffer.readEnum<CompletionMode>()
            val isAutoCompletion = buffer.readBool()
            val invocationCount = buffer.readInt()
            val offset = buffer.readInt()
            val prefix = buffer.readNullable { buffer.readString() }
            val customBackendParams = buffer.readNullable { buffer.readString() }
            val isSelectionDisjoint = buffer.readBool()
            return CompletionParameters(mode, isAutoCompletion, invocationCount, offset, prefix, customBackendParams, isSelectionDisjoint).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CompletionParameters)  {
            value.rdid.write(buffer)
            buffer.writeEnum(value.mode)
            buffer.writeBool(value.isAutoCompletion)
            buffer.writeInt(value.invocationCount)
            buffer.writeInt(value.offset)
            buffer.writeNullable(value.prefix) { buffer.writeString(it) }
            buffer.writeNullable(value.customBackendParams) { buffer.writeString(it) }
            buffer.writeBool(value.isSelectionDisjoint)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CompletionParameters (")
        printer.indent {
            print("mode = "); mode.print(printer); println()
            print("isAutoCompletion = "); isAutoCompletion.print(printer); println()
            print("invocationCount = "); invocationCount.print(printer); println()
            print("offset = "); offset.print(printer); println()
            print("prefix = "); prefix.print(printer); println()
            print("customBackendParams = "); customBackendParams.print(printer); println()
            print("isSelectionDisjoint = "); isSelectionDisjoint.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CompletionParameters   {
        return CompletionParameters(
            mode,
            isAutoCompletion,
            invocationCount,
            offset,
            prefix,
            customBackendParams,
            isSelectionDisjoint
        )
    }
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
data class CompletionPresentationModel (
    val parts: List<CompletionPresentationPart>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CompletionPresentationModel> {
        override val _type: KClass<CompletionPresentationModel> = CompletionPresentationModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CompletionPresentationModel  {
            val parts = buffer.readList { CompletionPresentationPart.read(ctx, buffer) }
            return CompletionPresentationModel(parts)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CompletionPresentationModel)  {
            buffer.writeList(value.parts) { v -> CompletionPresentationPart.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CompletionPresentationModel
        
        if (parts != other.parts) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + parts.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CompletionPresentationModel (")
        printer.indent {
            print("parts = "); parts.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
data class CompletionPresentationPart (
    val text: String,
    val isGrayed: Boolean,
    val effectStyle: EffectStyle = EffectStyle.None,
    val fontStyle: FontStyle = FontStyle.Regular
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CompletionPresentationPart> {
        override val _type: KClass<CompletionPresentationPart> = CompletionPresentationPart::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CompletionPresentationPart  {
            val text = ctx.readInterned(buffer, "CompletionPresentationPartInternScope") { _, _ -> buffer.readString() }
            val isGrayed = buffer.readBool()
            val effectStyle = buffer.readEnum<EffectStyle>()
            val fontStyle = buffer.readEnum<FontStyle>()
            return CompletionPresentationPart(text, isGrayed, effectStyle, fontStyle)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CompletionPresentationPart)  {
            ctx.writeInterned(buffer, value.text, "CompletionPresentationPartInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeBool(value.isGrayed)
            buffer.writeEnum(value.effectStyle)
            buffer.writeEnum(value.fontStyle)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CompletionPresentationPart
        
        if (text != other.text) return false
        if (isGrayed != other.isGrayed) return false
        if (effectStyle != other.effectStyle) return false
        if (fontStyle != other.fontStyle) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + isGrayed.hashCode()
        __r = __r*31 + effectStyle.hashCode()
        __r = __r*31 + fontStyle.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CompletionPresentationPart (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("isGrayed = "); isGrayed.print(printer); println()
            print("effectStyle = "); effectStyle.print(printer); println()
            print("fontStyle = "); fontStyle.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
class CompletionSessionModel private constructor(
    private val _completionItems: RdSignal<CompletionList>,
    private val _isSoft: RdSignal<FocusBehaviour>,
    private val _readyToReceiveItems: RdOptionalProperty<Boolean>,
    private val _sessionState: RdSignal<SessionState>,
    private val _refreshFrontend: RdSignal<String>,
    private val _complete: RdCall<CompleteData?, Boolean>,
    private val _updatePresentation: RdCall<ItemsToUpdate, ToUpdate>,
    private val _getSummaryInfoById: RdCall<Int, LookupSummaryInfo?>,
    private val _currentSelectedItem: RdOptionalProperty<CompletionItem>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CompletionSessionModel> {
        override val _type: KClass<CompletionSessionModel> = CompletionSessionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CompletionSessionModel  {
            val _id = RdId.read(buffer)
            val _completionItems = RdSignal.read(ctx, buffer, CompletionList)
            val _isSoft = RdSignal.read(ctx, buffer, FocusBehaviour.marshaller)
            val _readyToReceiveItems = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _sessionState = RdSignal.read(ctx, buffer, SessionState.marshaller)
            val _refreshFrontend = RdSignal.read(ctx, buffer, __StringInternedAtProtocolSerializer)
            val _complete = RdCall.read(ctx, buffer, __CompleteDataNullableSerializer, FrameworkMarshallers.Bool)
            val _updatePresentation = RdCall.read(ctx, buffer, ItemsToUpdate, ToUpdate)
            val _getSummaryInfoById = RdCall.read(ctx, buffer, FrameworkMarshallers.Int, __LookupSummaryInfoNullableSerializer)
            val _currentSelectedItem = RdOptionalProperty.read(ctx, buffer, CompletionItem)
            return CompletionSessionModel(_completionItems, _isSoft, _readyToReceiveItems, _sessionState, _refreshFrontend, _complete, _updatePresentation, _getSummaryInfoById, _currentSelectedItem).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CompletionSessionModel)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._completionItems)
            RdSignal.write(ctx, buffer, value._isSoft)
            RdOptionalProperty.write(ctx, buffer, value._readyToReceiveItems)
            RdSignal.write(ctx, buffer, value._sessionState)
            RdSignal.write(ctx, buffer, value._refreshFrontend)
            RdCall.write(ctx, buffer, value._complete)
            RdCall.write(ctx, buffer, value._updatePresentation)
            RdCall.write(ctx, buffer, value._getSummaryInfoById)
            RdOptionalProperty.write(ctx, buffer, value._currentSelectedItem)
        }
        
        private val __StringInternedAtProtocolSerializer = FrameworkMarshallers.String.interned("Protocol")
        private val __CompleteDataNullableSerializer = CompleteData.nullable()
        private val __LookupSummaryInfoNullableSerializer = LookupSummaryInfo.nullable()
        
    }
    //fields
    
    /**
     * Returns the next batch of completion items produced by the backend
     */
    val completionItems: IAsyncSignal<CompletionList> get() = _completionItems
    val isSoft: IAsyncSignal<FocusBehaviour> get() = _isSoft
    val readyToReceiveItems: IOptProperty<Boolean> get() = _readyToReceiveItems
    val sessionState: IAsyncSignal<SessionState> get() = _sessionState
    val refreshFrontend: ISignal<String> get() = _refreshFrontend
    val complete: RdCall<CompleteData?, Boolean> get() = _complete
    val updatePresentation: RdCall<ItemsToUpdate, ToUpdate> get() = _updatePresentation
    val getSummaryInfoById: RdCall<Int, LookupSummaryInfo?> get() = _getSummaryInfoById
    val currentSelectedItem: IOptProperty<CompletionItem> get() = _currentSelectedItem
    //methods
    //initializer
    init {
        _readyToReceiveItems.optimizeNested = true
        _currentSelectedItem.optimizeNested = true
    }
    
    init {
        _completionItems.async = true
        _isSoft.async = true
        _sessionState.async = true
    }
    
    init {
        bindableChildren.add("completionItems" to _completionItems)
        bindableChildren.add("isSoft" to _isSoft)
        bindableChildren.add("readyToReceiveItems" to _readyToReceiveItems)
        bindableChildren.add("sessionState" to _sessionState)
        bindableChildren.add("refreshFrontend" to _refreshFrontend)
        bindableChildren.add("complete" to _complete)
        bindableChildren.add("updatePresentation" to _updatePresentation)
        bindableChildren.add("getSummaryInfoById" to _getSummaryInfoById)
        bindableChildren.add("currentSelectedItem" to _currentSelectedItem)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdSignal<CompletionList>(CompletionList),
        RdSignal<FocusBehaviour>(FocusBehaviour.marshaller),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdSignal<SessionState>(SessionState.marshaller),
        RdSignal<String>(__StringInternedAtProtocolSerializer),
        RdCall<CompleteData?, Boolean>(__CompleteDataNullableSerializer, FrameworkMarshallers.Bool),
        RdCall<ItemsToUpdate, ToUpdate>(ItemsToUpdate, ToUpdate),
        RdCall<Int, LookupSummaryInfo?>(FrameworkMarshallers.Int, __LookupSummaryInfoNullableSerializer),
        RdOptionalProperty<CompletionItem>(CompletionItem)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CompletionSessionModel (")
        printer.indent {
            print("completionItems = "); _completionItems.print(printer); println()
            print("isSoft = "); _isSoft.print(printer); println()
            print("readyToReceiveItems = "); _readyToReceiveItems.print(printer); println()
            print("sessionState = "); _sessionState.print(printer); println()
            print("refreshFrontend = "); _refreshFrontend.print(printer); println()
            print("complete = "); _complete.print(printer); println()
            print("updatePresentation = "); _updatePresentation.print(printer); println()
            print("getSummaryInfoById = "); _getSummaryInfoById.print(printer); println()
            print("currentSelectedItem = "); _currentSelectedItem.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CompletionSessionModel   {
        return CompletionSessionModel(
            _completionItems.deepClonePolymorphic(),
            _isSoft.deepClonePolymorphic(),
            _readyToReceiveItems.deepClonePolymorphic(),
            _sessionState.deepClonePolymorphic(),
            _refreshFrontend.deepClonePolymorphic(),
            _complete.deepClonePolymorphic(),
            _updatePresentation.deepClonePolymorphic(),
            _getSummaryInfoById.deepClonePolymorphic(),
            _currentSelectedItem.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
class CompletionTuple private constructor(
    val parameters: CompletionParameters,
    val session: CompletionSessionModel
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CompletionTuple> {
        override val _type: KClass<CompletionTuple> = CompletionTuple::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CompletionTuple  {
            val _id = RdId.read(buffer)
            val parameters = CompletionParameters.read(ctx, buffer)
            val session = CompletionSessionModel.read(ctx, buffer)
            return CompletionTuple(parameters, session).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CompletionTuple)  {
            value.rdid.write(buffer)
            CompletionParameters.write(ctx, buffer, value.parameters)
            CompletionSessionModel.write(ctx, buffer, value.session)
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("parameters" to parameters)
        bindableChildren.add("session" to session)
    }
    
    //secondary constructor
    constructor(
        parameters: CompletionParameters
    ) : this(
        parameters,
        CompletionSessionModel()
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CompletionTuple (")
        printer.indent {
            print("parameters = "); parameters.print(printer); println()
            print("session = "); session.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CompletionTuple   {
        return CompletionTuple(
            parameters.deepClonePolymorphic(),
            session.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
enum class FocusBehaviour {
    Soft, 
    SoftWhenEmpty, 
    Hard;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<FocusBehaviour>()
        
    }
}


/**
 * #### Generated from [CompletionModel.kt]
 */
data class ItemsToUpdate (
    val itemIds: List<Int>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ItemsToUpdate> {
        override val _type: KClass<ItemsToUpdate> = ItemsToUpdate::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ItemsToUpdate  {
            val itemIds = buffer.readList { buffer.readInt() }
            return ItemsToUpdate(itemIds)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ItemsToUpdate)  {
            buffer.writeList(value.itemIds) { v -> buffer.writeInt(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ItemsToUpdate
        
        if (itemIds != other.itemIds) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + itemIds.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ItemsToUpdate (")
        printer.indent {
            print("itemIds = "); itemIds.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
data class LookupSummaryInfo (
    val items: List<SummaryInfoItem>,
    val isSignature: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LookupSummaryInfo> {
        override val _type: KClass<LookupSummaryInfo> = LookupSummaryInfo::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LookupSummaryInfo  {
            val items = buffer.readList { SummaryInfoItem.read(ctx, buffer) }
            val isSignature = buffer.readBool()
            return LookupSummaryInfo(items, isSignature)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LookupSummaryInfo)  {
            buffer.writeList(value.items) { v -> SummaryInfoItem.write(ctx, buffer, v) }
            buffer.writeBool(value.isSignature)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LookupSummaryInfo
        
        if (items != other.items) return false
        if (isSignature != other.isSignature) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + items.hashCode()
        __r = __r*31 + isSignature.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LookupSummaryInfo (")
        printer.indent {
            print("items = "); items.print(printer); println()
            print("isSignature = "); isSignature.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
enum class ScoringHint {
    FieldsParamsLocals, 
    LightItem, 
    Blessed, 
    Obsolete;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ScoringHint>()
        
    }
}


/**
 * #### Generated from [CompletionModel.kt]
 */
enum class SessionState {
    FullItemsPrepared, 
    ReturnedNull;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<SessionState>()
        
    }
}


/**
 * #### Generated from [CompletionModel.kt]
 */
data class SummaryInfoItem (
    val htmlTextBody: RichTextBlockModel,
    val htmlDocumentationBody: RichTextBlockModel?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<SummaryInfoItem> {
        override val _type: KClass<SummaryInfoItem> = SummaryInfoItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SummaryInfoItem  {
            val htmlTextBody = RichTextBlockModel.read(ctx, buffer)
            val htmlDocumentationBody = buffer.readNullable { RichTextBlockModel.read(ctx, buffer) }
            return SummaryInfoItem(htmlTextBody, htmlDocumentationBody)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SummaryInfoItem)  {
            RichTextBlockModel.write(ctx, buffer, value.htmlTextBody)
            buffer.writeNullable(value.htmlDocumentationBody) { RichTextBlockModel.write(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SummaryInfoItem
        
        if (htmlTextBody != other.htmlTextBody) return false
        if (htmlDocumentationBody != other.htmlDocumentationBody) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + htmlTextBody.hashCode()
        __r = __r*31 + if (htmlDocumentationBody != null) htmlDocumentationBody.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SummaryInfoItem (")
        printer.indent {
            print("htmlTextBody = "); htmlTextBody.print(printer); println()
            print("htmlDocumentationBody = "); htmlDocumentationBody.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CompletionModel.kt]
 */
data class ToUpdate (
    val updatedItems: List<AdvancedPresentation>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ToUpdate> {
        override val _type: KClass<ToUpdate> = ToUpdate::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ToUpdate  {
            val updatedItems = buffer.readList { AdvancedPresentation.read(ctx, buffer) }
            return ToUpdate(updatedItems)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ToUpdate)  {
            buffer.writeList(value.updatedItems) { v -> AdvancedPresentation.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ToUpdate
        
        if (updatedItems != other.updatedItems) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + updatedItems.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ToUpdate (")
        printer.indent {
            print("updatedItems = "); updatedItems.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
