@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [DebuggerModelBase.kt]
 */
class DebuggerModelBase private constructor(
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(SourcePositionBase)
            serializers.register(ResumeActionModel)
            serializers.register(PauseActionModel)
            serializers.register(StepIntoActionModel)
            serializers.register(StepOverActionModel)
            serializers.register(StepOutActionModel)
            serializers.register(RunToPositionActionModel)
            serializers.register(RunToMethodActionModel)
            serializers.register(ColoredTextContainerModel)
            serializers.register(ValuePresentationPartKind.marshaller)
            serializers.register(ValuePresentationPart)
            serializers.register(ComputeChildrenEmptyArg)
            serializers.register(ComputeObjectPropertiesEmptyArg)
            serializers.register(ValueGroupModelBase)
            serializers.register(ComputeFramesArg)
            serializers.register(SourcePositionBase_Unknown)
            serializers.register(DebuggerActionModelBase_Unknown)
            serializers.register(ValuePropertiesModelBase_Unknown)
            serializers.register(EvaluateArgBase_Unknown)
            serializers.register(ComputeChildrenArgBase_Unknown)
            serializers.register(ComputeObjectPropertiesArgBase_Unknown)
            serializers.register(ValueEntityModelBase_Unknown)
            serializers.register(ValueGroupModelBase_Unknown)
            serializers.register(ValueModelBase_Unknown)
            serializers.register(StackFrameModelBase_Unknown)
            serializers.register(ExecutionStackModelBase_Unknown)
            serializers.register(SuspendContextModelBase_Unknown)
            serializers.register(DebuggerSessionModelBase_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): DebuggerModelBase  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return DebuggerModelBase().apply {
                identify(protocol.identity, RdId.Null.mix("DebuggerModelBase"))
                bind(lifetime, protocol, "DebuggerModelBase")
            }
        }
        
        
        const val serializationHash = -2812035553958505208L
        
    }
    override val serializersOwner: ISerializersOwner get() = DebuggerModelBase
    override val serializationHash: Long get() = DebuggerModelBase.serializationHash
    
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DebuggerModelBase (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DebuggerModelBase   {
        return DebuggerModelBase(
        )
    }
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
data class ColoredTextContainerModel (
    val fragments: com.jetbrains.rd.ide.model.RichTextModel,
    val tooltipText: String?,
    val icon: com.jetbrains.rd.ide.model.IconModel?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ColoredTextContainerModel> {
        override val _type: KClass<ColoredTextContainerModel> = ColoredTextContainerModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ColoredTextContainerModel  {
            val fragments = com.jetbrains.rd.ide.model.RichTextModel.read(ctx, buffer)
            val tooltipText = buffer.readNullable { buffer.readString() }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            return ColoredTextContainerModel(fragments, tooltipText, icon)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ColoredTextContainerModel)  {
            com.jetbrains.rd.ide.model.RichTextModel.write(ctx, buffer, value.fragments)
            buffer.writeNullable(value.tooltipText) { buffer.writeString(it) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ColoredTextContainerModel
        
        if (fragments != other.fragments) return false
        if (tooltipText != other.tooltipText) return false
        if (icon != other.icon) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fragments.hashCode()
        __r = __r*31 + if (tooltipText != null) tooltipText.hashCode() else 0
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ColoredTextContainerModel (")
        printer.indent {
            print("fragments = "); fragments.print(printer); println()
            print("tooltipText = "); tooltipText.print(printer); println()
            print("icon = "); icon.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
abstract class ComputeChildrenArgBase (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<ComputeChildrenArgBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ComputeChildrenArgBase  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ComputeChildrenArgBase_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ComputeChildrenArgBase_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ComputeChildrenArgBase (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ComputeChildrenArgBase_Unknown> {
        override val _type: KClass<ComputeChildrenArgBase_Unknown> = ComputeChildrenArgBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ComputeChildrenArgBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ComputeChildrenArgBase_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ComputeChildrenArgBase_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ComputeChildrenArgBase_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
class ComputeChildrenEmptyArg (
) : ComputeChildrenArgBase (
) {
    //companion
    
    companion object : IMarshaller<ComputeChildrenEmptyArg> {
        override val _type: KClass<ComputeChildrenEmptyArg> = ComputeChildrenEmptyArg::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ComputeChildrenEmptyArg  {
            return ComputeChildrenEmptyArg()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ComputeChildrenEmptyArg)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ComputeChildrenEmptyArg
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ComputeChildrenEmptyArg (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
data class ComputeFramesArg (
    val firstFrameIndex: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ComputeFramesArg> {
        override val _type: KClass<ComputeFramesArg> = ComputeFramesArg::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ComputeFramesArg  {
            val firstFrameIndex = buffer.readInt()
            return ComputeFramesArg(firstFrameIndex)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ComputeFramesArg)  {
            buffer.writeInt(value.firstFrameIndex)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ComputeFramesArg
        
        if (firstFrameIndex != other.firstFrameIndex) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + firstFrameIndex.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ComputeFramesArg (")
        printer.indent {
            print("firstFrameIndex = "); firstFrameIndex.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
abstract class ComputeObjectPropertiesArgBase (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<ComputeObjectPropertiesArgBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ComputeObjectPropertiesArgBase  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ComputeObjectPropertiesArgBase_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ComputeObjectPropertiesArgBase_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ComputeObjectPropertiesArgBase (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ComputeObjectPropertiesArgBase_Unknown> {
        override val _type: KClass<ComputeObjectPropertiesArgBase_Unknown> = ComputeObjectPropertiesArgBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ComputeObjectPropertiesArgBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ComputeObjectPropertiesArgBase_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ComputeObjectPropertiesArgBase_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ComputeObjectPropertiesArgBase_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
class ComputeObjectPropertiesEmptyArg (
) : ComputeObjectPropertiesArgBase (
) {
    //companion
    
    companion object : IMarshaller<ComputeObjectPropertiesEmptyArg> {
        override val _type: KClass<ComputeObjectPropertiesEmptyArg> = ComputeObjectPropertiesEmptyArg::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ComputeObjectPropertiesEmptyArg  {
            return ComputeObjectPropertiesEmptyArg()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ComputeObjectPropertiesEmptyArg)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ComputeObjectPropertiesEmptyArg
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ComputeObjectPropertiesEmptyArg (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
abstract class DebuggerActionModelBase (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<DebuggerActionModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): DebuggerActionModelBase  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return DebuggerActionModelBase_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class DebuggerActionModelBase_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : DebuggerActionModelBase (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<DebuggerActionModelBase_Unknown> {
        override val _type: KClass<DebuggerActionModelBase_Unknown> = DebuggerActionModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DebuggerActionModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DebuggerActionModelBase_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DebuggerActionModelBase_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DebuggerActionModelBase_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
abstract class DebuggerSessionModelBase (
    protected val _suspendContext: RdProperty<SuspendContextModelBase?>,
    protected val _debuggerAction: RdSignal<DebuggerActionModelBase>
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<DebuggerSessionModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): DebuggerSessionModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val _suspendContext = RdProperty.read(ctx, buffer, __SuspendContextModelBaseNullableSerializer)
            val _debuggerAction = RdSignal.read(ctx, buffer, AbstractPolymorphic(DebuggerActionModelBase))
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return DebuggerSessionModelBase_Unknown(_suspendContext, _debuggerAction, unknownId, unknownBytes).withId(_id)
        }
        
        private val __SuspendContextModelBaseNullableSerializer = AbstractPolymorphic(SuspendContextModelBase).nullable()
        
    }
    //fields
    val suspendContext: IProperty<SuspendContextModelBase?> get() = _suspendContext
    val debuggerAction: IAsyncSignal<DebuggerActionModelBase> get() = _debuggerAction
    //methods
    //initializer
    init {
        _debuggerAction.async = true
    }
    
    init {
        bindableChildren.add("suspendContext" to _suspendContext)
        bindableChildren.add("debuggerAction" to _debuggerAction)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class DebuggerSessionModelBase_Unknown (
    _suspendContext: RdProperty<SuspendContextModelBase?>,
    _debuggerAction: RdSignal<DebuggerActionModelBase>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : DebuggerSessionModelBase (
    _suspendContext,
    _debuggerAction
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<DebuggerSessionModelBase_Unknown> {
        override val _type: KClass<DebuggerSessionModelBase_Unknown> = DebuggerSessionModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DebuggerSessionModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DebuggerSessionModelBase_Unknown)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._suspendContext)
            RdSignal.write(ctx, buffer, value._debuggerAction)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __SuspendContextModelBaseNullableSerializer = AbstractPolymorphic(SuspendContextModelBase).nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        RdProperty<SuspendContextModelBase?>(null, __SuspendContextModelBaseNullableSerializer),
        RdSignal<DebuggerActionModelBase>(AbstractPolymorphic(DebuggerActionModelBase)),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DebuggerSessionModelBase_Unknown (")
        printer.indent {
            print("suspendContext = "); _suspendContext.print(printer); println()
            print("debuggerAction = "); _debuggerAction.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DebuggerSessionModelBase_Unknown   {
        return DebuggerSessionModelBase_Unknown(
            _suspendContext.deepClonePolymorphic(),
            _debuggerAction.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
abstract class EvaluateArgBase (
    val expression: String
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<EvaluateArgBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): EvaluateArgBase  {
            val objectStartPosition = buffer.position
            val expression = buffer.readString()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return EvaluateArgBase_Unknown(expression, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class EvaluateArgBase_Unknown (
    expression: String,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : EvaluateArgBase (
    expression
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<EvaluateArgBase_Unknown> {
        override val _type: KClass<EvaluateArgBase_Unknown> = EvaluateArgBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): EvaluateArgBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: EvaluateArgBase_Unknown)  {
            buffer.writeString(value.expression)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as EvaluateArgBase_Unknown
        
        if (expression != other.expression) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + expression.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("EvaluateArgBase_Unknown (")
        printer.indent {
            print("expression = "); expression.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
abstract class ExecutionStackModelBase (
    val displayName: String,
    val topFrame: StackFrameModelBase?,
    protected val _computeFrames: RdCall<ComputeFramesArg, List<StackFrameModelBase>>
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<ExecutionStackModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ExecutionStackModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val displayName = buffer.readString()
            val topFrame = buffer.readNullable { ctx.serializers.readPolymorphic<StackFrameModelBase>(ctx, buffer, StackFrameModelBase) }
            val _computeFrames = RdCall.read(ctx, buffer, ComputeFramesArg, __StackFrameModelBaseListSerializer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ExecutionStackModelBase_Unknown(displayName, topFrame, _computeFrames, unknownId, unknownBytes).withId(_id)
        }
        
        private val __StackFrameModelBaseListSerializer = AbstractPolymorphic(StackFrameModelBase).list()
        
    }
    //fields
    val computeFrames: RdCall<ComputeFramesArg, List<StackFrameModelBase>> get() = _computeFrames
    //methods
    //initializer
    init {
        bindableChildren.add("topFrame" to topFrame)
        bindableChildren.add("computeFrames" to _computeFrames)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ExecutionStackModelBase_Unknown (
    displayName: String,
    topFrame: StackFrameModelBase?,
    _computeFrames: RdCall<ComputeFramesArg, List<StackFrameModelBase>>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ExecutionStackModelBase (
    displayName,
    topFrame,
    _computeFrames
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ExecutionStackModelBase_Unknown> {
        override val _type: KClass<ExecutionStackModelBase_Unknown> = ExecutionStackModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ExecutionStackModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ExecutionStackModelBase_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeString(value.displayName)
            buffer.writeNullable(value.topFrame) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdCall.write(ctx, buffer, value._computeFrames)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __StackFrameModelBaseListSerializer = AbstractPolymorphic(StackFrameModelBase).list()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        displayName: String,
        topFrame: StackFrameModelBase?,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        displayName,
        topFrame,
        RdCall<ComputeFramesArg, List<StackFrameModelBase>>(ComputeFramesArg, __StackFrameModelBaseListSerializer),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ExecutionStackModelBase_Unknown (")
        printer.indent {
            print("displayName = "); displayName.print(printer); println()
            print("topFrame = "); topFrame.print(printer); println()
            print("computeFrames = "); _computeFrames.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ExecutionStackModelBase_Unknown   {
        return ExecutionStackModelBase_Unknown(
            displayName,
            topFrame.deepClonePolymorphic(),
            _computeFrames.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
class PauseActionModel (
) : DebuggerActionModelBase (
) {
    //companion
    
    companion object : IMarshaller<PauseActionModel> {
        override val _type: KClass<PauseActionModel> = PauseActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): PauseActionModel  {
            return PauseActionModel()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: PauseActionModel)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as PauseActionModel
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("PauseActionModel (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
class ResumeActionModel (
) : DebuggerActionModelBase (
) {
    //companion
    
    companion object : IMarshaller<ResumeActionModel> {
        override val _type: KClass<ResumeActionModel> = ResumeActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ResumeActionModel  {
            return ResumeActionModel()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ResumeActionModel)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ResumeActionModel
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ResumeActionModel (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
class RunToMethodActionModel (
    val typeName: String,
    val methodName: String
) : DebuggerActionModelBase (
) {
    //companion
    
    companion object : IMarshaller<RunToMethodActionModel> {
        override val _type: KClass<RunToMethodActionModel> = RunToMethodActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RunToMethodActionModel  {
            val typeName = buffer.readString()
            val methodName = buffer.readString()
            return RunToMethodActionModel(typeName, methodName)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RunToMethodActionModel)  {
            buffer.writeString(value.typeName)
            buffer.writeString(value.methodName)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RunToMethodActionModel
        
        if (typeName != other.typeName) return false
        if (methodName != other.methodName) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + typeName.hashCode()
        __r = __r*31 + methodName.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RunToMethodActionModel (")
        printer.indent {
            print("typeName = "); typeName.print(printer); println()
            print("methodName = "); methodName.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
class RunToPositionActionModel (
    val sourcePosition: SourcePositionBase
) : DebuggerActionModelBase (
) {
    //companion
    
    companion object : IMarshaller<RunToPositionActionModel> {
        override val _type: KClass<RunToPositionActionModel> = RunToPositionActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RunToPositionActionModel  {
            val sourcePosition = ctx.serializers.readPolymorphic<SourcePositionBase>(ctx, buffer, SourcePositionBase)
            return RunToPositionActionModel(sourcePosition)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RunToPositionActionModel)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.sourcePosition)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RunToPositionActionModel
        
        if (sourcePosition != other.sourcePosition) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + sourcePosition.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RunToPositionActionModel (")
        printer.indent {
            print("sourcePosition = "); sourcePosition.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
open class SourcePositionBase (
    val filename: String,
    val line: Int,
    val offset: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<SourcePositionBase>, IAbstractDeclaration<SourcePositionBase> {
        override val _type: KClass<SourcePositionBase> = SourcePositionBase::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SourcePositionBase  {
            val filename = buffer.readString()
            val line = buffer.readInt()
            val offset = buffer.readInt()
            return SourcePositionBase(filename, line, offset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SourcePositionBase)  {
            buffer.writeString(value.filename)
            buffer.writeInt(value.line)
            buffer.writeInt(value.offset)
        }
        
        
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): SourcePositionBase  {
            val objectStartPosition = buffer.position
            val filename = buffer.readString()
            val line = buffer.readInt()
            val offset = buffer.readInt()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return SourcePositionBase_Unknown(filename, line, offset, unknownId, unknownBytes)
        }
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SourcePositionBase
        
        if (filename != other.filename) return false
        if (line != other.line) return false
        if (offset != other.offset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + filename.hashCode()
        __r = __r*31 + line.hashCode()
        __r = __r*31 + offset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SourcePositionBase (")
        printer.indent {
            print("filename = "); filename.print(printer); println()
            print("line = "); line.print(printer); println()
            print("offset = "); offset.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


class SourcePositionBase_Unknown (
    filename: String,
    line: Int,
    offset: Int,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : SourcePositionBase (
    filename,
    line,
    offset
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<SourcePositionBase_Unknown> {
        override val _type: KClass<SourcePositionBase_Unknown> = SourcePositionBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SourcePositionBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SourcePositionBase_Unknown)  {
            buffer.writeString(value.filename)
            buffer.writeInt(value.line)
            buffer.writeInt(value.offset)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SourcePositionBase_Unknown
        
        if (filename != other.filename) return false
        if (line != other.line) return false
        if (offset != other.offset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + filename.hashCode()
        __r = __r*31 + line.hashCode()
        __r = __r*31 + offset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SourcePositionBase_Unknown (")
        printer.indent {
            print("filename = "); filename.print(printer); println()
            print("line = "); line.print(printer); println()
            print("offset = "); offset.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
abstract class StackFrameModelBase (
    val sourcePosition: SourcePositionBase?,
    protected val _computeLocals: RdCall<Unit, List<ValueEntityModelBase>>,
    protected val _evaluateExpression: RdCall<EvaluateArgBase, ValueModelBase>
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<StackFrameModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): StackFrameModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val sourcePosition = buffer.readNullable { ctx.serializers.readPolymorphic<SourcePositionBase>(ctx, buffer, SourcePositionBase) }
            val _computeLocals = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, __ValueEntityModelBaseListSerializer)
            val _evaluateExpression = RdCall.read(ctx, buffer, AbstractPolymorphic(EvaluateArgBase), AbstractPolymorphic(ValueModelBase))
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return StackFrameModelBase_Unknown(sourcePosition, _computeLocals, _evaluateExpression, unknownId, unknownBytes).withId(_id)
        }
        
        private val __ValueEntityModelBaseListSerializer = AbstractPolymorphic(ValueEntityModelBase).list()
        
    }
    //fields
    val computeLocals: RdCall<Unit, List<ValueEntityModelBase>> get() = _computeLocals
    val evaluateExpression: RdCall<EvaluateArgBase, ValueModelBase> get() = _evaluateExpression
    //methods
    //initializer
    init {
        bindableChildren.add("computeLocals" to _computeLocals)
        bindableChildren.add("evaluateExpression" to _evaluateExpression)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class StackFrameModelBase_Unknown (
    sourcePosition: SourcePositionBase?,
    _computeLocals: RdCall<Unit, List<ValueEntityModelBase>>,
    _evaluateExpression: RdCall<EvaluateArgBase, ValueModelBase>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : StackFrameModelBase (
    sourcePosition,
    _computeLocals,
    _evaluateExpression
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<StackFrameModelBase_Unknown> {
        override val _type: KClass<StackFrameModelBase_Unknown> = StackFrameModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): StackFrameModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: StackFrameModelBase_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.sourcePosition) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdCall.write(ctx, buffer, value._computeLocals)
            RdCall.write(ctx, buffer, value._evaluateExpression)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __ValueEntityModelBaseListSerializer = AbstractPolymorphic(ValueEntityModelBase).list()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        sourcePosition: SourcePositionBase?,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        sourcePosition,
        RdCall<Unit, List<ValueEntityModelBase>>(FrameworkMarshallers.Void, __ValueEntityModelBaseListSerializer),
        RdCall<EvaluateArgBase, ValueModelBase>(AbstractPolymorphic(EvaluateArgBase), AbstractPolymorphic(ValueModelBase)),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("StackFrameModelBase_Unknown (")
        printer.indent {
            print("sourcePosition = "); sourcePosition.print(printer); println()
            print("computeLocals = "); _computeLocals.print(printer); println()
            print("evaluateExpression = "); _evaluateExpression.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): StackFrameModelBase_Unknown   {
        return StackFrameModelBase_Unknown(
            sourcePosition,
            _computeLocals.deepClonePolymorphic(),
            _evaluateExpression.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
class StepIntoActionModel (
) : DebuggerActionModelBase (
) {
    //companion
    
    companion object : IMarshaller<StepIntoActionModel> {
        override val _type: KClass<StepIntoActionModel> = StepIntoActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): StepIntoActionModel  {
            return StepIntoActionModel()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: StepIntoActionModel)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as StepIntoActionModel
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("StepIntoActionModel (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
class StepOutActionModel (
) : DebuggerActionModelBase (
) {
    //companion
    
    companion object : IMarshaller<StepOutActionModel> {
        override val _type: KClass<StepOutActionModel> = StepOutActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): StepOutActionModel  {
            return StepOutActionModel()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: StepOutActionModel)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as StepOutActionModel
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("StepOutActionModel (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
class StepOverActionModel (
) : DebuggerActionModelBase (
) {
    //companion
    
    companion object : IMarshaller<StepOverActionModel> {
        override val _type: KClass<StepOverActionModel> = StepOverActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): StepOverActionModel  {
            return StepOverActionModel()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: StepOverActionModel)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as StepOverActionModel
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("StepOverActionModel (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
abstract class SuspendContextModelBase (
    val activeStack: ExecutionStackModelBase?,
    protected val _computeStacks: RdCall<Unit, List<ExecutionStackModelBase>>
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<SuspendContextModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): SuspendContextModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val activeStack = buffer.readNullable { ctx.serializers.readPolymorphic<ExecutionStackModelBase>(ctx, buffer, ExecutionStackModelBase) }
            val _computeStacks = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, __ExecutionStackModelBaseListSerializer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return SuspendContextModelBase_Unknown(activeStack, _computeStacks, unknownId, unknownBytes).withId(_id)
        }
        
        private val __ExecutionStackModelBaseListSerializer = AbstractPolymorphic(ExecutionStackModelBase).list()
        
    }
    //fields
    val computeStacks: RdCall<Unit, List<ExecutionStackModelBase>> get() = _computeStacks
    //methods
    //initializer
    init {
        bindableChildren.add("activeStack" to activeStack)
        bindableChildren.add("computeStacks" to _computeStacks)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class SuspendContextModelBase_Unknown (
    activeStack: ExecutionStackModelBase?,
    _computeStacks: RdCall<Unit, List<ExecutionStackModelBase>>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : SuspendContextModelBase (
    activeStack,
    _computeStacks
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<SuspendContextModelBase_Unknown> {
        override val _type: KClass<SuspendContextModelBase_Unknown> = SuspendContextModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SuspendContextModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SuspendContextModelBase_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.activeStack) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdCall.write(ctx, buffer, value._computeStacks)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __ExecutionStackModelBaseListSerializer = AbstractPolymorphic(ExecutionStackModelBase).list()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        activeStack: ExecutionStackModelBase?,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        activeStack,
        RdCall<Unit, List<ExecutionStackModelBase>>(FrameworkMarshallers.Void, __ExecutionStackModelBaseListSerializer),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SuspendContextModelBase_Unknown (")
        printer.indent {
            print("activeStack = "); activeStack.print(printer); println()
            print("computeStacks = "); _computeStacks.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): SuspendContextModelBase_Unknown   {
        return SuspendContextModelBase_Unknown(
            activeStack.deepClonePolymorphic(),
            _computeStacks.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
abstract class ValueEntityModelBase (
    val name: String,
    protected val _computeChildren: RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<ValueEntityModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ValueEntityModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val name = buffer.readString()
            val _computeChildren = RdCall.read(ctx, buffer, AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ValueEntityModelBase_Unknown(name, _computeChildren, unknownId, unknownBytes).withId(_id)
        }
        
        private val __ValueEntityModelBaseListSerializer = AbstractPolymorphic(ValueEntityModelBase).list()
        
    }
    //fields
    val computeChildren: RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>> get() = _computeChildren
    //methods
    //initializer
    init {
        bindableChildren.add("computeChildren" to _computeChildren)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ValueEntityModelBase_Unknown (
    name: String,
    _computeChildren: RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ValueEntityModelBase (
    name,
    _computeChildren
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ValueEntityModelBase_Unknown> {
        override val _type: KClass<ValueEntityModelBase_Unknown> = ValueEntityModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ValueEntityModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ValueEntityModelBase_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeString(value.name)
            RdCall.write(ctx, buffer, value._computeChildren)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __ValueEntityModelBaseListSerializer = AbstractPolymorphic(ValueEntityModelBase).list()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        name: String,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        name,
        RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>(AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ValueEntityModelBase_Unknown (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("computeChildren = "); _computeChildren.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ValueEntityModelBase_Unknown   {
        return ValueEntityModelBase_Unknown(
            name,
            _computeChildren.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
open class ValueGroupModelBase protected constructor(
    val comment: String?,
    name: String,
    _computeChildren: RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>
) : ValueEntityModelBase (
    name,
    _computeChildren
) {
    //companion
    
    companion object : IMarshaller<ValueGroupModelBase>, IAbstractDeclaration<ValueGroupModelBase> {
        override val _type: KClass<ValueGroupModelBase> = ValueGroupModelBase::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ValueGroupModelBase  {
            val _id = RdId.read(buffer)
            val name = buffer.readString()
            val _computeChildren = RdCall.read(ctx, buffer, AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer)
            val comment = buffer.readNullable { buffer.readString() }
            return ValueGroupModelBase(comment, name, _computeChildren).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ValueGroupModelBase)  {
            value.rdid.write(buffer)
            buffer.writeString(value.name)
            RdCall.write(ctx, buffer, value._computeChildren)
            buffer.writeNullable(value.comment) { buffer.writeString(it) }
        }
        
        private val __ValueEntityModelBaseListSerializer = AbstractPolymorphic(ValueEntityModelBase).list()
        
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ValueGroupModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val comment = buffer.readNullable { buffer.readString() }
            val name = buffer.readString()
            val _computeChildren = RdCall.read(ctx, buffer, AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ValueGroupModelBase_Unknown(comment, name, _computeChildren, unknownId, unknownBytes).withId(_id)
        }
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        comment: String?,
        name: String
    ) : this(
        comment,
        name,
        RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>(AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ValueGroupModelBase (")
        printer.indent {
            print("comment = "); comment.print(printer); println()
            print("name = "); name.print(printer); println()
            print("computeChildren = "); _computeChildren.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ValueGroupModelBase   {
        return ValueGroupModelBase(
            comment,
            name,
            _computeChildren.deepClonePolymorphic()
        )
    }
    //contexts
}


class ValueGroupModelBase_Unknown (
    comment: String?,
    name: String,
    _computeChildren: RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ValueGroupModelBase (
    comment,
    name,
    _computeChildren
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ValueGroupModelBase_Unknown> {
        override val _type: KClass<ValueGroupModelBase_Unknown> = ValueGroupModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ValueGroupModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ValueGroupModelBase_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.comment) { buffer.writeString(it) }
            buffer.writeString(value.name)
            RdCall.write(ctx, buffer, value._computeChildren)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __ValueEntityModelBaseListSerializer = AbstractPolymorphic(ValueEntityModelBase).list()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        comment: String?,
        name: String,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        comment,
        name,
        RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>(AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ValueGroupModelBase_Unknown (")
        printer.indent {
            print("comment = "); comment.print(printer); println()
            print("name = "); name.print(printer); println()
            print("computeChildren = "); _computeChildren.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ValueGroupModelBase_Unknown   {
        return ValueGroupModelBase_Unknown(
            comment,
            name,
            _computeChildren.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
abstract class ValueModelBase (
    val properties: ValuePropertiesModelBase?,
    protected val _computeObjectProperties: RdCall<ComputeObjectPropertiesArgBase, ValuePropertiesModelBase>,
    name: String,
    _computeChildren: RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>
) : ValueEntityModelBase (
    name,
    _computeChildren
) {
    //companion
    
    companion object : IAbstractDeclaration<ValueModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ValueModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val properties = buffer.readNullable { ctx.serializers.readPolymorphic<ValuePropertiesModelBase>(ctx, buffer, ValuePropertiesModelBase) }
            val _computeObjectProperties = RdCall.read(ctx, buffer, AbstractPolymorphic(ComputeObjectPropertiesArgBase), AbstractPolymorphic(ValuePropertiesModelBase))
            val name = buffer.readString()
            val _computeChildren = RdCall.read(ctx, buffer, AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ValueModelBase_Unknown(properties, _computeObjectProperties, name, _computeChildren, unknownId, unknownBytes).withId(_id)
        }
        
        private val __ValueEntityModelBaseListSerializer = AbstractPolymorphic(ValueEntityModelBase).list()
        
    }
    //fields
    val computeObjectProperties: RdCall<ComputeObjectPropertiesArgBase, ValuePropertiesModelBase> get() = _computeObjectProperties
    //methods
    //initializer
    init {
        bindableChildren.add("computeObjectProperties" to _computeObjectProperties)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ValueModelBase_Unknown (
    properties: ValuePropertiesModelBase?,
    _computeObjectProperties: RdCall<ComputeObjectPropertiesArgBase, ValuePropertiesModelBase>,
    name: String,
    _computeChildren: RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ValueModelBase (
    properties,
    _computeObjectProperties,
    name,
    _computeChildren
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ValueModelBase_Unknown> {
        override val _type: KClass<ValueModelBase_Unknown> = ValueModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ValueModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ValueModelBase_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.properties) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdCall.write(ctx, buffer, value._computeObjectProperties)
            buffer.writeString(value.name)
            RdCall.write(ctx, buffer, value._computeChildren)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __ValueEntityModelBaseListSerializer = AbstractPolymorphic(ValueEntityModelBase).list()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        properties: ValuePropertiesModelBase?,
        name: String,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        properties,
        RdCall<ComputeObjectPropertiesArgBase, ValuePropertiesModelBase>(AbstractPolymorphic(ComputeObjectPropertiesArgBase), AbstractPolymorphic(ValuePropertiesModelBase)),
        name,
        RdCall<ComputeChildrenArgBase, List<ValueEntityModelBase>>(AbstractPolymorphic(ComputeChildrenArgBase), __ValueEntityModelBaseListSerializer),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ValueModelBase_Unknown (")
        printer.indent {
            print("properties = "); properties.print(printer); println()
            print("computeObjectProperties = "); _computeObjectProperties.print(printer); println()
            print("name = "); name.print(printer); println()
            print("computeChildren = "); _computeChildren.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ValueModelBase_Unknown   {
        return ValueModelBase_Unknown(
            properties,
            _computeObjectProperties.deepClonePolymorphic(),
            name,
            _computeChildren.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
data class ValuePresentationPart (
    val value: String,
    val kind: ValuePresentationPartKind
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ValuePresentationPart> {
        override val _type: KClass<ValuePresentationPart> = ValuePresentationPart::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ValuePresentationPart  {
            val value = buffer.readString()
            val kind = buffer.readEnum<ValuePresentationPartKind>()
            return ValuePresentationPart(value, kind)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ValuePresentationPart)  {
            buffer.writeString(value.value)
            buffer.writeEnum(value.kind)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ValuePresentationPart
        
        if (value != other.value) return false
        if (kind != other.kind) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + value.hashCode()
        __r = __r*31 + kind.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ValuePresentationPart (")
        printer.indent {
            print("value = "); value.print(printer); println()
            print("kind = "); kind.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
enum class ValuePresentationPartKind {
    Default, 
    SpecialSymbol, 
    Comment, 
    String, 
    Error, 
    Numerical, 
    Keyword;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ValuePresentationPartKind>()
        
    }
}


/**
 * #### Generated from [DebuggerModelBase.kt]
 */
abstract class ValuePropertiesModelBase (
    val type: String?,
    val value: List<ValuePresentationPart>,
    val hasChildren: Boolean
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<ValuePropertiesModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ValuePropertiesModelBase  {
            val objectStartPosition = buffer.position
            val type = buffer.readNullable { buffer.readString() }
            val value = buffer.readList { ValuePresentationPart.read(ctx, buffer) }
            val hasChildren = buffer.readBool()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ValuePropertiesModelBase_Unknown(type, value, hasChildren, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ValuePropertiesModelBase_Unknown (
    type: String?,
    value: List<ValuePresentationPart>,
    hasChildren: Boolean,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ValuePropertiesModelBase (
    type,
    value,
    hasChildren
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ValuePropertiesModelBase_Unknown> {
        override val _type: KClass<ValuePropertiesModelBase_Unknown> = ValuePropertiesModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ValuePropertiesModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ValuePropertiesModelBase_Unknown)  {
            buffer.writeNullable(value.type) { buffer.writeString(it) }
            buffer.writeList(value.value) { v -> ValuePresentationPart.write(ctx, buffer, v) }
            buffer.writeBool(value.hasChildren)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ValuePropertiesModelBase_Unknown
        
        if (type != other.type) return false
        if (value != other.value) return false
        if (hasChildren != other.hasChildren) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (type != null) type.hashCode() else 0
        __r = __r*31 + value.hashCode()
        __r = __r*31 + hasChildren.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ValuePropertiesModelBase_Unknown (")
        printer.indent {
            print("type = "); type.print(printer); println()
            print("value = "); value.print(printer); println()
            print("hasChildren = "); hasChildren.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
