@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [DiagramModels.kt]
 */
class DiagramsModel private constructor(
    private val _showProjectDiagram: RdSignal<String>,
    private val _showTypeDiagram: RdSignal<String>,
    private val _architectureDiagramDiff: RdSignal<RdDiagramModelDiff>,
    private val _edgeChange: RdSignal<RdEdgeChangesForProject>,
    private val _scopeChanged: RdSignal<RdScopeInfo>,
    private val _findEdgeUsages: RdSignal<RdFindEdgeUsages>,
    private val _calculateCoupling: RdSignal<RdCalculateCoupling>,
    private val _saveProjectDiagram: RdCall<RdSaveDiagramInfo, Unit>,
    private val _openProjectDiagram: RdSignal<String>,
    private val _includeTransitive: RdSignal<RdIncludeTransitive>,
    private val _calcCoupling: RdProperty<Boolean>,
    private val _diagramsMap: RdMap<String, RdDiagramModel>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RdDiagramElement)
            serializers.register(RdDiagramNamedNode)
            serializers.register(RdDiagramNode)
            serializers.register(RdDiffKind.marshaller)
            serializers.register(RdDiagramDiffNode)
            serializers.register(RdDiagramDiffEdge)
            serializers.register(RdDiagramEdge)
            serializers.register(RdDiagramGroupNode)
            serializers.register(RdTypeDiagramModel)
            serializers.register(RdProjectDiagramModel)
            serializers.register(RdDiagramModelDiff)
            serializers.register(RdEdgeChangesForProject)
            serializers.register(RdScopeInfo)
            serializers.register(RdIncludeTransitive)
            serializers.register(RdCalculateCoupling)
            serializers.register(RdFindEdgeUsages)
            serializers.register(RdSaveDiagramInfo)
            serializers.register(RdDiagramNodeBase_Unknown)
            serializers.register(RdDiagramEdgeBase_Unknown)
            serializers.register(RdDiagramModel_Unknown)
        }
        
        
        
        
        const val serializationHash = 8399309736486661675L
        
    }
    override val serializersOwner: ISerializersOwner get() = DiagramsModel
    override val serializationHash: Long get() = DiagramsModel.serializationHash
    
    //fields
    val showProjectDiagram: ISignal<String> get() = _showProjectDiagram
    val showTypeDiagram: ISignal<String> get() = _showTypeDiagram
    val architectureDiagramDiff: ISignal<RdDiagramModelDiff> get() = _architectureDiagramDiff
    val edgeChange: ISignal<RdEdgeChangesForProject> get() = _edgeChange
    val scopeChanged: ISignal<RdScopeInfo> get() = _scopeChanged
    val findEdgeUsages: ISignal<RdFindEdgeUsages> get() = _findEdgeUsages
    val calculateCoupling: ISignal<RdCalculateCoupling> get() = _calculateCoupling
    val saveProjectDiagram: RdCall<RdSaveDiagramInfo, Unit> get() = _saveProjectDiagram
    val openProjectDiagram: ISignal<String> get() = _openProjectDiagram
    val includeTransitive: ISignal<RdIncludeTransitive> get() = _includeTransitive
    val calcCoupling: IProperty<Boolean> get() = _calcCoupling
    val diagramsMap: IMutableViewableMap<String, RdDiagramModel> get() = _diagramsMap
    //methods
    //initializer
    init {
        _calcCoupling.optimizeNested = true
        _diagramsMap.optimizeNested = true
    }
    
    init {
        bindableChildren.add("showProjectDiagram" to _showProjectDiagram)
        bindableChildren.add("showTypeDiagram" to _showTypeDiagram)
        bindableChildren.add("architectureDiagramDiff" to _architectureDiagramDiff)
        bindableChildren.add("edgeChange" to _edgeChange)
        bindableChildren.add("scopeChanged" to _scopeChanged)
        bindableChildren.add("findEdgeUsages" to _findEdgeUsages)
        bindableChildren.add("calculateCoupling" to _calculateCoupling)
        bindableChildren.add("saveProjectDiagram" to _saveProjectDiagram)
        bindableChildren.add("openProjectDiagram" to _openProjectDiagram)
        bindableChildren.add("includeTransitive" to _includeTransitive)
        bindableChildren.add("calcCoupling" to _calcCoupling)
        bindableChildren.add("diagramsMap" to _diagramsMap)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdSignal<String>(FrameworkMarshallers.String),
        RdSignal<String>(FrameworkMarshallers.String),
        RdSignal<RdDiagramModelDiff>(RdDiagramModelDiff),
        RdSignal<RdEdgeChangesForProject>(RdEdgeChangesForProject),
        RdSignal<RdScopeInfo>(RdScopeInfo),
        RdSignal<RdFindEdgeUsages>(RdFindEdgeUsages),
        RdSignal<RdCalculateCoupling>(RdCalculateCoupling),
        RdCall<RdSaveDiagramInfo, Unit>(RdSaveDiagramInfo, FrameworkMarshallers.Void),
        RdSignal<String>(FrameworkMarshallers.String),
        RdSignal<RdIncludeTransitive>(RdIncludeTransitive),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdMap<String, RdDiagramModel>(FrameworkMarshallers.String, AbstractPolymorphic(RdDiagramModel))
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DiagramsModel (")
        printer.indent {
            print("showProjectDiagram = "); _showProjectDiagram.print(printer); println()
            print("showTypeDiagram = "); _showTypeDiagram.print(printer); println()
            print("architectureDiagramDiff = "); _architectureDiagramDiff.print(printer); println()
            print("edgeChange = "); _edgeChange.print(printer); println()
            print("scopeChanged = "); _scopeChanged.print(printer); println()
            print("findEdgeUsages = "); _findEdgeUsages.print(printer); println()
            print("calculateCoupling = "); _calculateCoupling.print(printer); println()
            print("saveProjectDiagram = "); _saveProjectDiagram.print(printer); println()
            print("openProjectDiagram = "); _openProjectDiagram.print(printer); println()
            print("includeTransitive = "); _includeTransitive.print(printer); println()
            print("calcCoupling = "); _calcCoupling.print(printer); println()
            print("diagramsMap = "); _diagramsMap.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DiagramsModel   {
        return DiagramsModel(
            _showProjectDiagram.deepClonePolymorphic(),
            _showTypeDiagram.deepClonePolymorphic(),
            _architectureDiagramDiff.deepClonePolymorphic(),
            _edgeChange.deepClonePolymorphic(),
            _scopeChanged.deepClonePolymorphic(),
            _findEdgeUsages.deepClonePolymorphic(),
            _calculateCoupling.deepClonePolymorphic(),
            _saveProjectDiagram.deepClonePolymorphic(),
            _openProjectDiagram.deepClonePolymorphic(),
            _includeTransitive.deepClonePolymorphic(),
            _calcCoupling.deepClonePolymorphic(),
            _diagramsMap.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.diagramsModel get() = getOrCreateExtension("diagramsModel", ::DiagramsModel)



/**
 * #### Generated from [DiagramModels.kt]
 */
data class RdCalculateCoupling (
    val enabled: Boolean,
    val fqn: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdCalculateCoupling> {
        override val _type: KClass<RdCalculateCoupling> = RdCalculateCoupling::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCalculateCoupling  {
            val enabled = buffer.readBool()
            val fqn = buffer.readString()
            return RdCalculateCoupling(enabled, fqn)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCalculateCoupling)  {
            buffer.writeBool(value.enabled)
            buffer.writeString(value.fqn)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCalculateCoupling
        
        if (enabled != other.enabled) return false
        if (fqn != other.fqn) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + enabled.hashCode()
        __r = __r*31 + fqn.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCalculateCoupling (")
        printer.indent {
            print("enabled = "); enabled.print(printer); println()
            print("fqn = "); fqn.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
class RdDiagramDiffEdge (
    val kind: RdDiffKind,
    source: RdDiagramNodeBase,
    target: RdDiagramNodeBase
) : RdDiagramEdgeBase (
    source,
    target
) {
    //companion
    
    companion object : IMarshaller<RdDiagramDiffEdge> {
        override val _type: KClass<RdDiagramDiffEdge> = RdDiagramDiffEdge::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDiagramDiffEdge  {
            val source = ctx.serializers.readPolymorphic<RdDiagramNodeBase>(ctx, buffer, RdDiagramNodeBase)
            val target = ctx.serializers.readPolymorphic<RdDiagramNodeBase>(ctx, buffer, RdDiagramNodeBase)
            val kind = buffer.readEnum<RdDiffKind>()
            return RdDiagramDiffEdge(kind, source, target)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDiagramDiffEdge)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.source)
            ctx.serializers.writePolymorphic(ctx, buffer, value.target)
            buffer.writeEnum(value.kind)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDiagramDiffEdge
        
        if (kind != other.kind) return false
        if (source != other.source) return false
        if (target != other.target) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + kind.hashCode()
        __r = __r*31 + source.hashCode()
        __r = __r*31 + target.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDiagramDiffEdge (")
        printer.indent {
            print("kind = "); kind.print(printer); println()
            print("source = "); source.print(printer); println()
            print("target = "); target.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
class RdDiagramDiffNode (
    val name: String,
    val kind: RdDiffKind
) : RdDiagramNodeBase (
) {
    //companion
    
    companion object : IMarshaller<RdDiagramDiffNode> {
        override val _type: KClass<RdDiagramDiffNode> = RdDiagramDiffNode::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDiagramDiffNode  {
            val name = buffer.readString()
            val kind = buffer.readEnum<RdDiffKind>()
            return RdDiagramDiffNode(name, kind)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDiagramDiffNode)  {
            buffer.writeString(value.name)
            buffer.writeEnum(value.kind)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDiagramDiffNode
        
        if (name != other.name) return false
        if (kind != other.kind) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + kind.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDiagramDiffNode (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("kind = "); kind.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
class RdDiagramEdge (
    val weight: Int,
    source: RdDiagramNodeBase,
    target: RdDiagramNodeBase
) : RdDiagramEdgeBase (
    source,
    target
) {
    //companion
    
    companion object : IMarshaller<RdDiagramEdge> {
        override val _type: KClass<RdDiagramEdge> = RdDiagramEdge::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDiagramEdge  {
            val source = ctx.serializers.readPolymorphic<RdDiagramNodeBase>(ctx, buffer, RdDiagramNodeBase)
            val target = ctx.serializers.readPolymorphic<RdDiagramNodeBase>(ctx, buffer, RdDiagramNodeBase)
            val weight = buffer.readInt()
            return RdDiagramEdge(weight, source, target)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDiagramEdge)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.source)
            ctx.serializers.writePolymorphic(ctx, buffer, value.target)
            buffer.writeInt(value.weight)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDiagramEdge
        
        if (weight != other.weight) return false
        if (source != other.source) return false
        if (target != other.target) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + weight.hashCode()
        __r = __r*31 + source.hashCode()
        __r = __r*31 + target.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDiagramEdge (")
        printer.indent {
            print("weight = "); weight.print(printer); println()
            print("source = "); source.print(printer); println()
            print("target = "); target.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
abstract class RdDiagramEdgeBase (
    val source: RdDiagramNodeBase,
    val target: RdDiagramNodeBase
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdDiagramEdgeBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdDiagramEdgeBase  {
            val objectStartPosition = buffer.position
            val source = ctx.serializers.readPolymorphic<RdDiagramNodeBase>(ctx, buffer, RdDiagramNodeBase)
            val target = ctx.serializers.readPolymorphic<RdDiagramNodeBase>(ctx, buffer, RdDiagramNodeBase)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdDiagramEdgeBase_Unknown(source, target, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdDiagramEdgeBase_Unknown (
    source: RdDiagramNodeBase,
    target: RdDiagramNodeBase,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdDiagramEdgeBase (
    source,
    target
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdDiagramEdgeBase_Unknown> {
        override val _type: KClass<RdDiagramEdgeBase_Unknown> = RdDiagramEdgeBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDiagramEdgeBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDiagramEdgeBase_Unknown)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.source)
            ctx.serializers.writePolymorphic(ctx, buffer, value.target)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDiagramEdgeBase_Unknown
        
        if (source != other.source) return false
        if (target != other.target) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + source.hashCode()
        __r = __r*31 + target.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDiagramEdgeBase_Unknown (")
        printer.indent {
            print("source = "); source.print(printer); println()
            print("target = "); target.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
data class RdDiagramElement (
    val id: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdDiagramElement> {
        override val _type: KClass<RdDiagramElement> = RdDiagramElement::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDiagramElement  {
            val id = buffer.readInt()
            return RdDiagramElement(id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDiagramElement)  {
            buffer.writeInt(value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDiagramElement
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDiagramElement (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
data class RdDiagramGroupNode (
    val id: Int,
    val subNodes: List<RdDiagramNodeBase>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdDiagramGroupNode> {
        override val _type: KClass<RdDiagramGroupNode> = RdDiagramGroupNode::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDiagramGroupNode  {
            val id = buffer.readInt()
            val subNodes = buffer.readList { ctx.serializers.readPolymorphic<RdDiagramNodeBase>(ctx, buffer, RdDiagramNodeBase) }
            return RdDiagramGroupNode(id, subNodes)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDiagramGroupNode)  {
            buffer.writeInt(value.id)
            buffer.writeList(value.subNodes) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDiagramGroupNode
        
        if (id != other.id) return false
        if (subNodes != other.subNodes) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + subNodes.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDiagramGroupNode (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("subNodes = "); subNodes.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
abstract class RdDiagramModel (
    val fqn: String,
    val nodes: List<RdDiagramNodeBase>,
    val edges: List<RdDiagramEdge>,
    val groupingNodes: List<RdDiagramGroupNode>
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdDiagramModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdDiagramModel  {
            val objectStartPosition = buffer.position
            val fqn = buffer.readString()
            val nodes = buffer.readList { ctx.serializers.readPolymorphic<RdDiagramNodeBase>(ctx, buffer, RdDiagramNodeBase) }
            val edges = buffer.readList { RdDiagramEdge.read(ctx, buffer) }
            val groupingNodes = buffer.readList { RdDiagramGroupNode.read(ctx, buffer) }
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdDiagramModel_Unknown(fqn, nodes, edges, groupingNodes, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
data class RdDiagramModelDiff (
    val fqn: String,
    val nodesToAdd: List<RdDiagramNode>,
    val nodesToDelete: List<RdDiagramNode>,
    val edgesToAdd: List<RdDiagramEdge>,
    val edgesToDelete: List<RdDiagramEdge>,
    val groupsToAdd: List<RdDiagramGroupNode>,
    val groupsToDelete: List<RdDiagramGroupNode>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdDiagramModelDiff> {
        override val _type: KClass<RdDiagramModelDiff> = RdDiagramModelDiff::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDiagramModelDiff  {
            val fqn = buffer.readString()
            val nodesToAdd = buffer.readList { RdDiagramNode.read(ctx, buffer) }
            val nodesToDelete = buffer.readList { RdDiagramNode.read(ctx, buffer) }
            val edgesToAdd = buffer.readList { RdDiagramEdge.read(ctx, buffer) }
            val edgesToDelete = buffer.readList { RdDiagramEdge.read(ctx, buffer) }
            val groupsToAdd = buffer.readList { RdDiagramGroupNode.read(ctx, buffer) }
            val groupsToDelete = buffer.readList { RdDiagramGroupNode.read(ctx, buffer) }
            return RdDiagramModelDiff(fqn, nodesToAdd, nodesToDelete, edgesToAdd, edgesToDelete, groupsToAdd, groupsToDelete)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDiagramModelDiff)  {
            buffer.writeString(value.fqn)
            buffer.writeList(value.nodesToAdd) { v -> RdDiagramNode.write(ctx, buffer, v) }
            buffer.writeList(value.nodesToDelete) { v -> RdDiagramNode.write(ctx, buffer, v) }
            buffer.writeList(value.edgesToAdd) { v -> RdDiagramEdge.write(ctx, buffer, v) }
            buffer.writeList(value.edgesToDelete) { v -> RdDiagramEdge.write(ctx, buffer, v) }
            buffer.writeList(value.groupsToAdd) { v -> RdDiagramGroupNode.write(ctx, buffer, v) }
            buffer.writeList(value.groupsToDelete) { v -> RdDiagramGroupNode.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDiagramModelDiff
        
        if (fqn != other.fqn) return false
        if (nodesToAdd != other.nodesToAdd) return false
        if (nodesToDelete != other.nodesToDelete) return false
        if (edgesToAdd != other.edgesToAdd) return false
        if (edgesToDelete != other.edgesToDelete) return false
        if (groupsToAdd != other.groupsToAdd) return false
        if (groupsToDelete != other.groupsToDelete) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fqn.hashCode()
        __r = __r*31 + nodesToAdd.hashCode()
        __r = __r*31 + nodesToDelete.hashCode()
        __r = __r*31 + edgesToAdd.hashCode()
        __r = __r*31 + edgesToDelete.hashCode()
        __r = __r*31 + groupsToAdd.hashCode()
        __r = __r*31 + groupsToDelete.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDiagramModelDiff (")
        printer.indent {
            print("fqn = "); fqn.print(printer); println()
            print("nodesToAdd = "); nodesToAdd.print(printer); println()
            print("nodesToDelete = "); nodesToDelete.print(printer); println()
            print("edgesToAdd = "); edgesToAdd.print(printer); println()
            print("edgesToDelete = "); edgesToDelete.print(printer); println()
            print("groupsToAdd = "); groupsToAdd.print(printer); println()
            print("groupsToDelete = "); groupsToDelete.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


class RdDiagramModel_Unknown (
    fqn: String,
    nodes: List<RdDiagramNodeBase>,
    edges: List<RdDiagramEdge>,
    groupingNodes: List<RdDiagramGroupNode>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdDiagramModel (
    fqn,
    nodes,
    edges,
    groupingNodes
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdDiagramModel_Unknown> {
        override val _type: KClass<RdDiagramModel_Unknown> = RdDiagramModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDiagramModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDiagramModel_Unknown)  {
            buffer.writeString(value.fqn)
            buffer.writeList(value.nodes) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            buffer.writeList(value.edges) { v -> RdDiagramEdge.write(ctx, buffer, v) }
            buffer.writeList(value.groupingNodes) { v -> RdDiagramGroupNode.write(ctx, buffer, v) }
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDiagramModel_Unknown
        
        if (fqn != other.fqn) return false
        if (nodes != other.nodes) return false
        if (edges != other.edges) return false
        if (groupingNodes != other.groupingNodes) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fqn.hashCode()
        __r = __r*31 + nodes.hashCode()
        __r = __r*31 + edges.hashCode()
        __r = __r*31 + groupingNodes.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDiagramModel_Unknown (")
        printer.indent {
            print("fqn = "); fqn.print(printer); println()
            print("nodes = "); nodes.print(printer); println()
            print("edges = "); edges.print(printer); println()
            print("groupingNodes = "); groupingNodes.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
class RdDiagramNamedNode (
    val name: String
) : RdDiagramNodeBase (
) {
    //companion
    
    companion object : IMarshaller<RdDiagramNamedNode> {
        override val _type: KClass<RdDiagramNamedNode> = RdDiagramNamedNode::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDiagramNamedNode  {
            val name = buffer.readString()
            return RdDiagramNamedNode(name)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDiagramNamedNode)  {
            buffer.writeString(value.name)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDiagramNamedNode
        
        if (name != other.name) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDiagramNamedNode (")
        printer.indent {
            print("name = "); name.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
class RdDiagramNode (
    val id: Int
) : RdDiagramNodeBase (
) {
    //companion
    
    companion object : IMarshaller<RdDiagramNode> {
        override val _type: KClass<RdDiagramNode> = RdDiagramNode::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDiagramNode  {
            val id = buffer.readInt()
            return RdDiagramNode(id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDiagramNode)  {
            buffer.writeInt(value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDiagramNode
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDiagramNode (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
abstract class RdDiagramNodeBase (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdDiagramNodeBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdDiagramNodeBase  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdDiagramNodeBase_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdDiagramNodeBase_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdDiagramNodeBase (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdDiagramNodeBase_Unknown> {
        override val _type: KClass<RdDiagramNodeBase_Unknown> = RdDiagramNodeBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDiagramNodeBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDiagramNodeBase_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDiagramNodeBase_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDiagramNodeBase_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
enum class RdDiffKind {
    New, 
    Removed, 
    Normal;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<RdDiffKind>()
        
    }
}


/**
 * #### Generated from [DiagramModels.kt]
 */
data class RdEdgeChangesForProject (
    val fqn: String,
    val edges: List<RdDiagramEdge>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdEdgeChangesForProject> {
        override val _type: KClass<RdEdgeChangesForProject> = RdEdgeChangesForProject::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdEdgeChangesForProject  {
            val fqn = buffer.readString()
            val edges = buffer.readList { RdDiagramEdge.read(ctx, buffer) }
            return RdEdgeChangesForProject(fqn, edges)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdEdgeChangesForProject)  {
            buffer.writeString(value.fqn)
            buffer.writeList(value.edges) { v -> RdDiagramEdge.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdEdgeChangesForProject
        
        if (fqn != other.fqn) return false
        if (edges != other.edges) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fqn.hashCode()
        __r = __r*31 + edges.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdEdgeChangesForProject (")
        printer.indent {
            print("fqn = "); fqn.print(printer); println()
            print("edges = "); edges.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
data class RdFindEdgeUsages (
    val fqn: String,
    val edge: RdDiagramEdge
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdFindEdgeUsages> {
        override val _type: KClass<RdFindEdgeUsages> = RdFindEdgeUsages::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFindEdgeUsages  {
            val fqn = buffer.readString()
            val edge = RdDiagramEdge.read(ctx, buffer)
            return RdFindEdgeUsages(fqn, edge)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFindEdgeUsages)  {
            buffer.writeString(value.fqn)
            RdDiagramEdge.write(ctx, buffer, value.edge)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFindEdgeUsages
        
        if (fqn != other.fqn) return false
        if (edge != other.edge) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fqn.hashCode()
        __r = __r*31 + edge.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFindEdgeUsages (")
        printer.indent {
            print("fqn = "); fqn.print(printer); println()
            print("edge = "); edge.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
data class RdIncludeTransitive (
    val enabled: Boolean,
    val scopeInfo: RdScopeInfo
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdIncludeTransitive> {
        override val _type: KClass<RdIncludeTransitive> = RdIncludeTransitive::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdIncludeTransitive  {
            val enabled = buffer.readBool()
            val scopeInfo = RdScopeInfo.read(ctx, buffer)
            return RdIncludeTransitive(enabled, scopeInfo)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdIncludeTransitive)  {
            buffer.writeBool(value.enabled)
            RdScopeInfo.write(ctx, buffer, value.scopeInfo)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdIncludeTransitive
        
        if (enabled != other.enabled) return false
        if (scopeInfo != other.scopeInfo) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + enabled.hashCode()
        __r = __r*31 + scopeInfo.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdIncludeTransitive (")
        printer.indent {
            print("enabled = "); enabled.print(printer); println()
            print("scopeInfo = "); scopeInfo.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
class RdProjectDiagramModel (
    val diffWithSolutionNodes: List<RdDiagramDiffNode>,
    val diffWithSolutionEdges: List<RdDiagramDiffEdge>,
    fqn: String,
    nodes: List<RdDiagramNodeBase>,
    edges: List<RdDiagramEdge>,
    groupingNodes: List<RdDiagramGroupNode>
) : RdDiagramModel (
    fqn,
    nodes,
    edges,
    groupingNodes
) {
    //companion
    
    companion object : IMarshaller<RdProjectDiagramModel> {
        override val _type: KClass<RdProjectDiagramModel> = RdProjectDiagramModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdProjectDiagramModel  {
            val fqn = buffer.readString()
            val nodes = buffer.readList { ctx.serializers.readPolymorphic<RdDiagramNodeBase>(ctx, buffer, RdDiagramNodeBase) }
            val edges = buffer.readList { RdDiagramEdge.read(ctx, buffer) }
            val groupingNodes = buffer.readList { RdDiagramGroupNode.read(ctx, buffer) }
            val diffWithSolutionNodes = buffer.readList { RdDiagramDiffNode.read(ctx, buffer) }
            val diffWithSolutionEdges = buffer.readList { RdDiagramDiffEdge.read(ctx, buffer) }
            return RdProjectDiagramModel(diffWithSolutionNodes, diffWithSolutionEdges, fqn, nodes, edges, groupingNodes)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdProjectDiagramModel)  {
            buffer.writeString(value.fqn)
            buffer.writeList(value.nodes) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            buffer.writeList(value.edges) { v -> RdDiagramEdge.write(ctx, buffer, v) }
            buffer.writeList(value.groupingNodes) { v -> RdDiagramGroupNode.write(ctx, buffer, v) }
            buffer.writeList(value.diffWithSolutionNodes) { v -> RdDiagramDiffNode.write(ctx, buffer, v) }
            buffer.writeList(value.diffWithSolutionEdges) { v -> RdDiagramDiffEdge.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdProjectDiagramModel
        
        if (diffWithSolutionNodes != other.diffWithSolutionNodes) return false
        if (diffWithSolutionEdges != other.diffWithSolutionEdges) return false
        if (fqn != other.fqn) return false
        if (nodes != other.nodes) return false
        if (edges != other.edges) return false
        if (groupingNodes != other.groupingNodes) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + diffWithSolutionNodes.hashCode()
        __r = __r*31 + diffWithSolutionEdges.hashCode()
        __r = __r*31 + fqn.hashCode()
        __r = __r*31 + nodes.hashCode()
        __r = __r*31 + edges.hashCode()
        __r = __r*31 + groupingNodes.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdProjectDiagramModel (")
        printer.indent {
            print("diffWithSolutionNodes = "); diffWithSolutionNodes.print(printer); println()
            print("diffWithSolutionEdges = "); diffWithSolutionEdges.print(printer); println()
            print("fqn = "); fqn.print(printer); println()
            print("nodes = "); nodes.print(printer); println()
            print("edges = "); edges.print(printer); println()
            print("groupingNodes = "); groupingNodes.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
data class RdSaveDiagramInfo (
    val fqn: String,
    val path: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdSaveDiagramInfo> {
        override val _type: KClass<RdSaveDiagramInfo> = RdSaveDiagramInfo::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdSaveDiagramInfo  {
            val fqn = buffer.readString()
            val path = buffer.readString()
            return RdSaveDiagramInfo(fqn, path)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdSaveDiagramInfo)  {
            buffer.writeString(value.fqn)
            buffer.writeString(value.path)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdSaveDiagramInfo
        
        if (fqn != other.fqn) return false
        if (path != other.path) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fqn.hashCode()
        __r = __r*31 + path.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdSaveDiagramInfo (")
        printer.indent {
            print("fqn = "); fqn.print(printer); println()
            print("path = "); path.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
data class RdScopeInfo (
    val fqn: String,
    val scope: List<Int>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdScopeInfo> {
        override val _type: KClass<RdScopeInfo> = RdScopeInfo::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdScopeInfo  {
            val fqn = buffer.readString()
            val scope = buffer.readList { buffer.readInt() }
            return RdScopeInfo(fqn, scope)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdScopeInfo)  {
            buffer.writeString(value.fqn)
            buffer.writeList(value.scope) { v -> buffer.writeInt(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdScopeInfo
        
        if (fqn != other.fqn) return false
        if (scope != other.scope) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fqn.hashCode()
        __r = __r*31 + scope.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdScopeInfo (")
        printer.indent {
            print("fqn = "); fqn.print(printer); println()
            print("scope = "); scope.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiagramModels.kt]
 */
class RdTypeDiagramModel (
    fqn: String,
    nodes: List<RdDiagramNodeBase>,
    edges: List<RdDiagramEdge>,
    groupingNodes: List<RdDiagramGroupNode>
) : RdDiagramModel (
    fqn,
    nodes,
    edges,
    groupingNodes
) {
    //companion
    
    companion object : IMarshaller<RdTypeDiagramModel> {
        override val _type: KClass<RdTypeDiagramModel> = RdTypeDiagramModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTypeDiagramModel  {
            val fqn = buffer.readString()
            val nodes = buffer.readList { ctx.serializers.readPolymorphic<RdDiagramNodeBase>(ctx, buffer, RdDiagramNodeBase) }
            val edges = buffer.readList { RdDiagramEdge.read(ctx, buffer) }
            val groupingNodes = buffer.readList { RdDiagramGroupNode.read(ctx, buffer) }
            return RdTypeDiagramModel(fqn, nodes, edges, groupingNodes)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTypeDiagramModel)  {
            buffer.writeString(value.fqn)
            buffer.writeList(value.nodes) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            buffer.writeList(value.edges) { v -> RdDiagramEdge.write(ctx, buffer, v) }
            buffer.writeList(value.groupingNodes) { v -> RdDiagramGroupNode.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdTypeDiagramModel
        
        if (fqn != other.fqn) return false
        if (nodes != other.nodes) return false
        if (edges != other.edges) return false
        if (groupingNodes != other.groupingNodes) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fqn.hashCode()
        __r = __r*31 + nodes.hashCode()
        __r = __r*31 + edges.hashCode()
        __r = __r*31 + groupingNodes.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTypeDiagramModel (")
        printer.indent {
            print("fqn = "); fqn.print(printer); println()
            print("nodes = "); nodes.print(printer); println()
            print("edges = "); edges.print(printer); println()
            print("groupingNodes = "); groupingNodes.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
