@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [DiffViewersModel.kt]
 */
class DiffViewersModel private constructor(
    private val _chains: RdList<DiffRequestChainModel>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(DiffMarkerType.marshaller)
            serializers.register(DiffBlockMarkHighlighterModel)
            serializers.register(DiffInnerMarkHighlighterModel)
            serializers.register(DiffHighlightPolicy.marshaller)
            serializers.register(DiffIgnorePolicy.marshaller)
            serializers.register(TextDiffSettings)
            serializers.register(DiffFoldingDescriptionRequest)
            serializers.register(DiffFoldingDescriptionReply)
            serializers.register(DiffViewerContentModel)
            serializers.register(TwoSideDiffViewerModel)
            serializers.register(OneSideDiffViewerModel)
            serializers.register(ErrorDiffViewerModel)
            serializers.register(DiffRequestChainModel)
            serializers.register(TwoSideState)
            serializers.register(OneSideState)
            serializers.register(DiffMarkHighlighterModel_Unknown)
            serializers.register(DiffViewerModel_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): DiffViewersModel  {
            IdeRoot.register(protocol.serializers)
            
            return DiffViewersModel().apply {
                identify(protocol.identity, RdId.Null.mix("DiffViewersModel"))
                bind(lifetime, protocol, "DiffViewersModel")
            }
        }
        
        
        const val serializationHash = 6959486785519031828L
        
    }
    override val serializersOwner: ISerializersOwner get() = DiffViewersModel
    override val serializationHash: Long get() = DiffViewersModel.serializationHash
    
    //fields
    val chains: IMutableViewableList<DiffRequestChainModel> get() = _chains
    //methods
    //initializer
    init {
        bindableChildren.add("chains" to _chains)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdList<DiffRequestChainModel>(DiffRequestChainModel)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DiffViewersModel (")
        printer.indent {
            print("chains = "); _chains.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DiffViewersModel   {
        return DiffViewersModel(
            _chains.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
class DiffBlockMarkHighlighterModel (
    val changeId: Long,
    val isIgnored: Boolean,
    val isEmptyRange: Boolean,
    val isEOF: Boolean,
    type: DiffMarkerType,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : DiffMarkHighlighterModel (
    type,
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<DiffBlockMarkHighlighterModel> {
        override val _type: KClass<DiffBlockMarkHighlighterModel> = DiffBlockMarkHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DiffBlockMarkHighlighterModel  {
            val type = buffer.readEnum<DiffMarkerType>()
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val changeId = buffer.readLong()
            val isIgnored = buffer.readBool()
            val isEmptyRange = buffer.readBool()
            val isEOF = buffer.readBool()
            return DiffBlockMarkHighlighterModel(changeId, isIgnored, isEmptyRange, isEOF, type, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DiffBlockMarkHighlighterModel)  {
            buffer.writeEnum(value.type)
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeLong(value.changeId)
            buffer.writeBool(value.isIgnored)
            buffer.writeBool(value.isEmptyRange)
            buffer.writeBool(value.isEOF)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DiffBlockMarkHighlighterModel
        
        if (changeId != other.changeId) return false
        if (isIgnored != other.isIgnored) return false
        if (isEmptyRange != other.isEmptyRange) return false
        if (isEOF != other.isEOF) return false
        if (type != other.type) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + changeId.hashCode()
        __r = __r*31 + isIgnored.hashCode()
        __r = __r*31 + isEmptyRange.hashCode()
        __r = __r*31 + isEOF.hashCode()
        __r = __r*31 + type.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DiffBlockMarkHighlighterModel (")
        printer.indent {
            print("changeId = "); changeId.print(printer); println()
            print("isIgnored = "); isIgnored.print(printer); println()
            print("isEmptyRange = "); isEmptyRange.print(printer); println()
            print("isEOF = "); isEOF.print(printer); println()
            print("type = "); type.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
data class DiffFoldingDescriptionReply (
    val description: String,
    val anchorLine: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<DiffFoldingDescriptionReply> {
        override val _type: KClass<DiffFoldingDescriptionReply> = DiffFoldingDescriptionReply::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DiffFoldingDescriptionReply  {
            val description = buffer.readString()
            val anchorLine = buffer.readInt()
            return DiffFoldingDescriptionReply(description, anchorLine)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DiffFoldingDescriptionReply)  {
            buffer.writeString(value.description)
            buffer.writeInt(value.anchorLine)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DiffFoldingDescriptionReply
        
        if (description != other.description) return false
        if (anchorLine != other.anchorLine) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + description.hashCode()
        __r = __r*31 + anchorLine.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DiffFoldingDescriptionReply (")
        printer.indent {
            print("description = "); description.print(printer); println()
            print("anchorLine = "); anchorLine.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
data class DiffFoldingDescriptionRequest (
    val editorIndex: Int,
    val lineNumber: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<DiffFoldingDescriptionRequest> {
        override val _type: KClass<DiffFoldingDescriptionRequest> = DiffFoldingDescriptionRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DiffFoldingDescriptionRequest  {
            val editorIndex = buffer.readInt()
            val lineNumber = buffer.readInt()
            return DiffFoldingDescriptionRequest(editorIndex, lineNumber)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DiffFoldingDescriptionRequest)  {
            buffer.writeInt(value.editorIndex)
            buffer.writeInt(value.lineNumber)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DiffFoldingDescriptionRequest
        
        if (editorIndex != other.editorIndex) return false
        if (lineNumber != other.lineNumber) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + editorIndex.hashCode()
        __r = __r*31 + lineNumber.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DiffFoldingDescriptionRequest (")
        printer.indent {
            print("editorIndex = "); editorIndex.print(printer); println()
            print("lineNumber = "); lineNumber.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
enum class DiffHighlightPolicy {
    BY_LINE, 
    BY_WORD, 
    BY_WORD_SPLIT, 
    BY_CHAR, 
    DO_NOT_HIGHLIGHT;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<DiffHighlightPolicy>()
        
    }
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
enum class DiffIgnorePolicy {
    DEFAULT, 
    TRIM_WHITESPACES, 
    IGNORE_WHITESPACES;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<DiffIgnorePolicy>()
        
    }
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
class DiffInnerMarkHighlighterModel (
    type: DiffMarkerType,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : DiffMarkHighlighterModel (
    type,
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<DiffInnerMarkHighlighterModel> {
        override val _type: KClass<DiffInnerMarkHighlighterModel> = DiffInnerMarkHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DiffInnerMarkHighlighterModel  {
            val type = buffer.readEnum<DiffMarkerType>()
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            return DiffInnerMarkHighlighterModel(type, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DiffInnerMarkHighlighterModel)  {
            buffer.writeEnum(value.type)
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DiffInnerMarkHighlighterModel
        
        if (type != other.type) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + type.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DiffInnerMarkHighlighterModel (")
        printer.indent {
            print("type = "); type.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
abstract class DiffMarkHighlighterModel (
    val type: DiffMarkerType,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IAbstractDeclaration<DiffMarkHighlighterModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): DiffMarkHighlighterModel  {
            val objectStartPosition = buffer.position
            val type = buffer.readEnum<DiffMarkerType>()
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return DiffMarkHighlighterModel_Unknown(type, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class DiffMarkHighlighterModel_Unknown (
    type: DiffMarkerType,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : DiffMarkHighlighterModel (
    type,
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<DiffMarkHighlighterModel_Unknown> {
        override val _type: KClass<DiffMarkHighlighterModel_Unknown> = DiffMarkHighlighterModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DiffMarkHighlighterModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DiffMarkHighlighterModel_Unknown)  {
            buffer.writeEnum(value.type)
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DiffMarkHighlighterModel_Unknown
        
        if (type != other.type) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + type.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DiffMarkHighlighterModel_Unknown (")
        printer.indent {
            print("type = "); type.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
enum class DiffMarkerType {
    INSERTED, 
    DELETED, 
    MODIFIED;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<DiffMarkerType>()
        
    }
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
class DiffRequestChainModel private constructor(
    private val _viewer: RdOptionalProperty<DiffViewerModel>,
    private val _hasPrev: RdOptionalProperty<Boolean>,
    private val _hasNext: RdOptionalProperty<Boolean>,
    private val _goPrev: RdCall<Unit, Unit>,
    private val _goNext: RdCall<Unit, Unit>,
    private val _requestFocus: RdCall<Unit, Unit>,
    private val _index: RdOptionalProperty<Int>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<DiffRequestChainModel> {
        override val _type: KClass<DiffRequestChainModel> = DiffRequestChainModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DiffRequestChainModel  {
            val _id = RdId.read(buffer)
            val _viewer = RdOptionalProperty.read(ctx, buffer, AbstractPolymorphic(DiffViewerModel))
            val _hasPrev = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _hasNext = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _goPrev = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, FrameworkMarshallers.Void)
            val _goNext = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, FrameworkMarshallers.Void)
            val _requestFocus = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, FrameworkMarshallers.Void)
            val _index = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            return DiffRequestChainModel(_viewer, _hasPrev, _hasNext, _goPrev, _goNext, _requestFocus, _index).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DiffRequestChainModel)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._viewer)
            RdOptionalProperty.write(ctx, buffer, value._hasPrev)
            RdOptionalProperty.write(ctx, buffer, value._hasNext)
            RdCall.write(ctx, buffer, value._goPrev)
            RdCall.write(ctx, buffer, value._goNext)
            RdCall.write(ctx, buffer, value._requestFocus)
            RdOptionalProperty.write(ctx, buffer, value._index)
        }
        
        
    }
    //fields
    val viewer: IOptProperty<DiffViewerModel> get() = _viewer
    val hasPrev: IOptProperty<Boolean> get() = _hasPrev
    val hasNext: IOptProperty<Boolean> get() = _hasNext
    val goPrev: RdCall<Unit, Unit> get() = _goPrev
    val goNext: RdCall<Unit, Unit> get() = _goNext
    val requestFocus: RdCall<Unit, Unit> get() = _requestFocus
    val index: IOptProperty<Int> get() = _index
    //methods
    //initializer
    init {
        _hasPrev.optimizeNested = true
        _hasNext.optimizeNested = true
        _index.optimizeNested = true
    }
    
    init {
        bindableChildren.add("viewer" to _viewer)
        bindableChildren.add("hasPrev" to _hasPrev)
        bindableChildren.add("hasNext" to _hasNext)
        bindableChildren.add("goPrev" to _goPrev)
        bindableChildren.add("goNext" to _goNext)
        bindableChildren.add("requestFocus" to _requestFocus)
        bindableChildren.add("index" to _index)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<DiffViewerModel>(AbstractPolymorphic(DiffViewerModel)),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdCall<Unit, Unit>(FrameworkMarshallers.Void, FrameworkMarshallers.Void),
        RdCall<Unit, Unit>(FrameworkMarshallers.Void, FrameworkMarshallers.Void),
        RdCall<Unit, Unit>(FrameworkMarshallers.Void, FrameworkMarshallers.Void),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DiffRequestChainModel (")
        printer.indent {
            print("viewer = "); _viewer.print(printer); println()
            print("hasPrev = "); _hasPrev.print(printer); println()
            print("hasNext = "); _hasNext.print(printer); println()
            print("goPrev = "); _goPrev.print(printer); println()
            print("goNext = "); _goNext.print(printer); println()
            print("requestFocus = "); _requestFocus.print(printer); println()
            print("index = "); _index.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DiffRequestChainModel   {
        return DiffRequestChainModel(
            _viewer.deepClonePolymorphic(),
            _hasPrev.deepClonePolymorphic(),
            _hasNext.deepClonePolymorphic(),
            _goPrev.deepClonePolymorphic(),
            _goNext.deepClonePolymorphic(),
            _requestFocus.deepClonePolymorphic(),
            _index.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
class DiffViewerContentModel (
    val editorId: TextControlId,
    val title: String?
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<DiffViewerContentModel> {
        override val _type: KClass<DiffViewerContentModel> = DiffViewerContentModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DiffViewerContentModel  {
            val _id = RdId.read(buffer)
            val editorId = TextControlId.read(ctx, buffer)
            val title = buffer.readNullable { buffer.readString() }
            return DiffViewerContentModel(editorId, title).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DiffViewerContentModel)  {
            value.rdid.write(buffer)
            TextControlId.write(ctx, buffer, value.editorId)
            buffer.writeNullable(value.title) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DiffViewerContentModel (")
        printer.indent {
            print("editorId = "); editorId.print(printer); println()
            print("title = "); title.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DiffViewerContentModel   {
        return DiffViewerContentModel(
            editorId,
            title
        )
    }
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
abstract class DiffViewerModel (
    val title: String?
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<DiffViewerModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): DiffViewerModel  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val title = buffer.readNullable { buffer.readString() }
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return DiffViewerModel_Unknown(title, unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class DiffViewerModel_Unknown (
    title: String?,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : DiffViewerModel (
    title
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<DiffViewerModel_Unknown> {
        override val _type: KClass<DiffViewerModel_Unknown> = DiffViewerModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DiffViewerModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DiffViewerModel_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.title) { buffer.writeString(it) }
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DiffViewerModel_Unknown (")
        printer.indent {
            print("title = "); title.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DiffViewerModel_Unknown   {
        return DiffViewerModel_Unknown(
            title,
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
class ErrorDiffViewerModel (
    val message: String,
    title: String?
) : DiffViewerModel (
    title
) {
    //companion
    
    companion object : IMarshaller<ErrorDiffViewerModel> {
        override val _type: KClass<ErrorDiffViewerModel> = ErrorDiffViewerModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ErrorDiffViewerModel  {
            val _id = RdId.read(buffer)
            val title = buffer.readNullable { buffer.readString() }
            val message = buffer.readString()
            return ErrorDiffViewerModel(message, title).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ErrorDiffViewerModel)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.title) { buffer.writeString(it) }
            buffer.writeString(value.message)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ErrorDiffViewerModel (")
        printer.indent {
            print("message = "); message.print(printer); println()
            print("title = "); title.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ErrorDiffViewerModel   {
        return ErrorDiffViewerModel(
            message,
            title
        )
    }
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
class OneSideDiffViewerModel private constructor(
    val content: DiffViewerContentModel,
    val isDeleted: Boolean,
    private val _state: RdOptionalProperty<OneSideState>,
    title: String?
) : DiffViewerModel (
    title
) {
    //companion
    
    companion object : IMarshaller<OneSideDiffViewerModel> {
        override val _type: KClass<OneSideDiffViewerModel> = OneSideDiffViewerModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OneSideDiffViewerModel  {
            val _id = RdId.read(buffer)
            val title = buffer.readNullable { buffer.readString() }
            val content = DiffViewerContentModel.read(ctx, buffer)
            val isDeleted = buffer.readBool()
            val _state = RdOptionalProperty.read(ctx, buffer, OneSideState)
            return OneSideDiffViewerModel(content, isDeleted, _state, title).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OneSideDiffViewerModel)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.title) { buffer.writeString(it) }
            DiffViewerContentModel.write(ctx, buffer, value.content)
            buffer.writeBool(value.isDeleted)
            RdOptionalProperty.write(ctx, buffer, value._state)
        }
        
        
    }
    //fields
    val state: IOptProperty<OneSideState> get() = _state
    //methods
    //initializer
    init {
        _state.optimizeNested = true
    }
    
    init {
        bindableChildren.add("content" to content)
        bindableChildren.add("state" to _state)
    }
    
    //secondary constructor
    constructor(
        content: DiffViewerContentModel,
        isDeleted: Boolean,
        title: String?
    ) : this(
        content,
        isDeleted,
        RdOptionalProperty<OneSideState>(OneSideState),
        title
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OneSideDiffViewerModel (")
        printer.indent {
            print("content = "); content.print(printer); println()
            print("isDeleted = "); isDeleted.print(printer); println()
            print("state = "); _state.print(printer); println()
            print("title = "); title.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): OneSideDiffViewerModel   {
        return OneSideDiffViewerModel(
            content.deepClonePolymorphic(),
            isDeleted,
            _state.deepClonePolymorphic(),
            title
        )
    }
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
data class OneSideState (
    val caretOffset: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<OneSideState> {
        override val _type: KClass<OneSideState> = OneSideState::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OneSideState  {
            val caretOffset = buffer.readInt()
            return OneSideState(caretOffset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OneSideState)  {
            buffer.writeInt(value.caretOffset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OneSideState
        
        if (caretOffset != other.caretOffset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + caretOffset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OneSideState (")
        printer.indent {
            print("caretOffset = "); caretOffset.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
data class TextDiffSettings (
    val highlightPolicy: DiffHighlightPolicy,
    val ignorePolicy: DiffIgnorePolicy,
    val foldingContextRange: Int,
    val foldingExpandByDefault: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<TextDiffSettings> {
        override val _type: KClass<TextDiffSettings> = TextDiffSettings::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TextDiffSettings  {
            val highlightPolicy = buffer.readEnum<DiffHighlightPolicy>()
            val ignorePolicy = buffer.readEnum<DiffIgnorePolicy>()
            val foldingContextRange = buffer.readInt()
            val foldingExpandByDefault = buffer.readBool()
            return TextDiffSettings(highlightPolicy, ignorePolicy, foldingContextRange, foldingExpandByDefault)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TextDiffSettings)  {
            buffer.writeEnum(value.highlightPolicy)
            buffer.writeEnum(value.ignorePolicy)
            buffer.writeInt(value.foldingContextRange)
            buffer.writeBool(value.foldingExpandByDefault)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TextDiffSettings
        
        if (highlightPolicy != other.highlightPolicy) return false
        if (ignorePolicy != other.ignorePolicy) return false
        if (foldingContextRange != other.foldingContextRange) return false
        if (foldingExpandByDefault != other.foldingExpandByDefault) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + highlightPolicy.hashCode()
        __r = __r*31 + ignorePolicy.hashCode()
        __r = __r*31 + foldingContextRange.hashCode()
        __r = __r*31 + foldingExpandByDefault.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TextDiffSettings (")
        printer.indent {
            print("highlightPolicy = "); highlightPolicy.print(printer); println()
            print("ignorePolicy = "); ignorePolicy.print(printer); println()
            print("foldingContextRange = "); foldingContextRange.print(printer); println()
            print("foldingExpandByDefault = "); foldingExpandByDefault.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
class TwoSideDiffViewerModel private constructor(
    val content1: DiffViewerContentModel,
    val content2: DiffViewerContentModel,
    private val _settings: RdOptionalProperty<TextDiffSettings>,
    private val _getFoldingDescription: RdCall<DiffFoldingDescriptionRequest, DiffFoldingDescriptionReply?>,
    private val _state: RdOptionalProperty<TwoSideState>,
    title: String?
) : DiffViewerModel (
    title
) {
    //companion
    
    companion object : IMarshaller<TwoSideDiffViewerModel> {
        override val _type: KClass<TwoSideDiffViewerModel> = TwoSideDiffViewerModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TwoSideDiffViewerModel  {
            val _id = RdId.read(buffer)
            val title = buffer.readNullable { buffer.readString() }
            val content1 = DiffViewerContentModel.read(ctx, buffer)
            val content2 = DiffViewerContentModel.read(ctx, buffer)
            val _settings = RdOptionalProperty.read(ctx, buffer, TextDiffSettings)
            val _getFoldingDescription = RdCall.read(ctx, buffer, DiffFoldingDescriptionRequest, __DiffFoldingDescriptionReplyNullableSerializer)
            val _state = RdOptionalProperty.read(ctx, buffer, TwoSideState)
            return TwoSideDiffViewerModel(content1, content2, _settings, _getFoldingDescription, _state, title).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TwoSideDiffViewerModel)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.title) { buffer.writeString(it) }
            DiffViewerContentModel.write(ctx, buffer, value.content1)
            DiffViewerContentModel.write(ctx, buffer, value.content2)
            RdOptionalProperty.write(ctx, buffer, value._settings)
            RdCall.write(ctx, buffer, value._getFoldingDescription)
            RdOptionalProperty.write(ctx, buffer, value._state)
        }
        
        private val __DiffFoldingDescriptionReplyNullableSerializer = DiffFoldingDescriptionReply.nullable()
        
    }
    //fields
    val settings: IOptProperty<TextDiffSettings> get() = _settings
    val getFoldingDescription: RdCall<DiffFoldingDescriptionRequest, DiffFoldingDescriptionReply?> get() = _getFoldingDescription
    val state: IOptProperty<TwoSideState> get() = _state
    //methods
    //initializer
    init {
        _settings.optimizeNested = true
        _state.optimizeNested = true
    }
    
    init {
        _getFoldingDescription.async = true
    }
    
    init {
        bindableChildren.add("content1" to content1)
        bindableChildren.add("content2" to content2)
        bindableChildren.add("settings" to _settings)
        bindableChildren.add("getFoldingDescription" to _getFoldingDescription)
        bindableChildren.add("state" to _state)
    }
    
    //secondary constructor
    constructor(
        content1: DiffViewerContentModel,
        content2: DiffViewerContentModel,
        title: String?
    ) : this(
        content1,
        content2,
        RdOptionalProperty<TextDiffSettings>(TextDiffSettings),
        RdCall<DiffFoldingDescriptionRequest, DiffFoldingDescriptionReply?>(DiffFoldingDescriptionRequest, __DiffFoldingDescriptionReplyNullableSerializer),
        RdOptionalProperty<TwoSideState>(TwoSideState),
        title
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TwoSideDiffViewerModel (")
        printer.indent {
            print("content1 = "); content1.print(printer); println()
            print("content2 = "); content2.print(printer); println()
            print("settings = "); _settings.print(printer); println()
            print("getFoldingDescription = "); _getFoldingDescription.print(printer); println()
            print("state = "); _state.print(printer); println()
            print("title = "); title.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): TwoSideDiffViewerModel   {
        return TwoSideDiffViewerModel(
            content1.deepClonePolymorphic(),
            content2.deepClonePolymorphic(),
            _settings.deepClonePolymorphic(),
            _getFoldingDescription.deepClonePolymorphic(),
            _state.deepClonePolymorphic(),
            title
        )
    }
    //contexts
}


/**
 * #### Generated from [DiffViewersModel.kt]
 */
data class TwoSideState (
    val side: Int,
    val caretOffset: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<TwoSideState> {
        override val _type: KClass<TwoSideState> = TwoSideState::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TwoSideState  {
            val side = buffer.readInt()
            val caretOffset = buffer.readInt()
            return TwoSideState(side, caretOffset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TwoSideState)  {
            buffer.writeInt(value.side)
            buffer.writeInt(value.caretOffset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TwoSideState
        
        if (side != other.side) return false
        if (caretOffset != other.caretOffset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + side.hashCode()
        __r = __r*31 + caretOffset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TwoSideState (")
        printer.indent {
            print("side = "); side.print(printer); println()
            print("caretOffset = "); caretOffset.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
