@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [FileTransmissionModel.kt]
 */
class FileTransmissionModel private constructor(
    private val _sessions: RdMap<FileTransmissionRequest, FileTransmissionSession>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(FileTransmissionRequest)
            serializers.register(FileTransmissionChunk)
            serializers.register(FileTransmissionSession)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): FileTransmissionModel  {
            IdeRoot.register(protocol.serializers)
            
            return FileTransmissionModel().apply {
                identify(protocol.identity, RdId.Null.mix("FileTransmissionModel"))
                bind(lifetime, protocol, "FileTransmissionModel")
            }
        }
        
        
        const val serializationHash = -1152854993999697512L
        
    }
    override val serializersOwner: ISerializersOwner get() = FileTransmissionModel
    override val serializationHash: Long get() = FileTransmissionModel.serializationHash
    
    //fields
    val sessions: IMutableViewableMap<FileTransmissionRequest, FileTransmissionSession> get() = _sessions
    //methods
    //initializer
    init {
        bindableChildren.add("sessions" to _sessions)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdMap<FileTransmissionRequest, FileTransmissionSession>(FileTransmissionRequest, FileTransmissionSession)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FileTransmissionModel (")
        printer.indent {
            print("sessions = "); _sessions.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): FileTransmissionModel   {
        return FileTransmissionModel(
            _sessions.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [FileTransmissionModel.kt]
 */
data class FileTransmissionChunk (
    val bytes: ByteArray,
    val eof: Boolean,
    val error: String?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<FileTransmissionChunk> {
        override val _type: KClass<FileTransmissionChunk> = FileTransmissionChunk::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FileTransmissionChunk  {
            val bytes = buffer.readByteArray()
            val eof = buffer.readBool()
            val error = buffer.readNullable { buffer.readString() }
            return FileTransmissionChunk(bytes, eof, error)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FileTransmissionChunk)  {
            buffer.writeByteArray(value.bytes)
            buffer.writeBool(value.eof)
            buffer.writeNullable(value.error) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FileTransmissionChunk
        
        if (!(bytes contentEquals other.bytes)) return false
        if (eof != other.eof) return false
        if (error != other.error) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + bytes.contentHashCode()
        __r = __r*31 + eof.hashCode()
        __r = __r*31 + if (error != null) error.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FileTransmissionChunk (")
        printer.indent {
            print("bytes = "); bytes.print(printer); println()
            print("eof = "); eof.print(printer); println()
            print("error = "); error.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FileTransmissionModel.kt]
 */
data class FileTransmissionRequest (
    val name: String,
    val uuid: UUID
) : IPrintable {
    //companion
    
    companion object : IMarshaller<FileTransmissionRequest> {
        override val _type: KClass<FileTransmissionRequest> = FileTransmissionRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FileTransmissionRequest  {
            val name = buffer.readString()
            val uuid = buffer.readGuid()
            return FileTransmissionRequest(name, uuid)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FileTransmissionRequest)  {
            buffer.writeString(value.name)
            buffer.writeGuid(value.uuid)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FileTransmissionRequest
        
        if (name != other.name) return false
        if (uuid != other.uuid) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + uuid.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FileTransmissionRequest (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("uuid = "); uuid.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FileTransmissionModel.kt]
 */
class FileTransmissionSession private constructor(
    private val _chunk: RdSignal<FileTransmissionChunk>,
    private val _ack: RdSignal<Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<FileTransmissionSession> {
        override val _type: KClass<FileTransmissionSession> = FileTransmissionSession::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FileTransmissionSession  {
            val _id = RdId.read(buffer)
            val _chunk = RdSignal.read(ctx, buffer, FileTransmissionChunk)
            val _ack = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return FileTransmissionSession(_chunk, _ack).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FileTransmissionSession)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._chunk)
            RdSignal.write(ctx, buffer, value._ack)
        }
        
        
    }
    //fields
    val chunk: IAsyncSignal<FileTransmissionChunk> get() = _chunk
    val ack: IAsyncSignal<Unit> get() = _ack
    //methods
    //initializer
    init {
        _chunk.async = true
        _ack.async = true
    }
    
    init {
        bindableChildren.add("chunk" to _chunk)
        bindableChildren.add("ack" to _ack)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdSignal<FileTransmissionChunk>(FileTransmissionChunk),
        RdSignal<Unit>(FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FileTransmissionSession (")
        printer.indent {
            print("chunk = "); _chunk.print(printer); println()
            print("ack = "); _ack.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): FileTransmissionSession   {
        return FileTransmissionSession(
            _chunk.deepClonePolymorphic(),
            _ack.deepClonePolymorphic()
        )
    }
    //contexts
}
