@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [FilterProviderModel.kt]
 */
class FilterProviderModel private constructor(
    private val _applyFilter: RdCall<ApplyFilterContext, List<FilterHighlighterModelBase>>,
    private val _navigate: RdSignal<FilterNavigationContext>,
    private val _showConsole: RdSignal<SimpleConsole>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(FilterHyperlinkModel)
            serializers.register(FilterFileHyperlinkModel)
            serializers.register(FilterHighlighterModel)
            serializers.register(FilterKind.marshaller)
            serializers.register(FilterNavigationContext)
            serializers.register(ApplyFilterContext)
            serializers.register(SimpleConsole)
            serializers.register(FilterHighlighterModelBase_Unknown)
            serializers.register(FilterHyperlinkModelBase_Unknown)
        }
        
        
        
        private val __FilterHighlighterModelBaseListSerializer = AbstractPolymorphic(FilterHighlighterModelBase).list()
        
        const val serializationHash = -5702877239141481190L
        
    }
    override val serializersOwner: ISerializersOwner get() = FilterProviderModel
    override val serializationHash: Long get() = FilterProviderModel.serializationHash
    
    //fields
    val applyFilter: RdCall<ApplyFilterContext, List<FilterHighlighterModelBase>> get() = _applyFilter
    val navigate: ISignal<FilterNavigationContext> get() = _navigate
    val showConsole: ISignal<SimpleConsole> get() = _showConsole
    //methods
    //initializer
    init {
        _applyFilter.async = true
    }
    
    init {
        bindableChildren.add("applyFilter" to _applyFilter)
        bindableChildren.add("navigate" to _navigate)
        bindableChildren.add("showConsole" to _showConsole)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdCall<ApplyFilterContext, List<FilterHighlighterModelBase>>(ApplyFilterContext, __FilterHighlighterModelBaseListSerializer),
        RdSignal<FilterNavigationContext>(FilterNavigationContext),
        RdSignal<SimpleConsole>(SimpleConsole)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FilterProviderModel (")
        printer.indent {
            print("applyFilter = "); _applyFilter.print(printer); println()
            print("navigate = "); _navigate.print(printer); println()
            print("showConsole = "); _showConsole.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): FilterProviderModel   {
        return FilterProviderModel(
            _applyFilter.deepClonePolymorphic(),
            _navigate.deepClonePolymorphic(),
            _showConsole.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.filterProviderModel get() = getOrCreateExtension("filterProviderModel", ::FilterProviderModel)



/**
 * #### Generated from [FilterProviderModel.kt]
 */
data class ApplyFilterContext (
    val text: String,
    val filterKind: FilterKind
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ApplyFilterContext> {
        override val _type: KClass<ApplyFilterContext> = ApplyFilterContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ApplyFilterContext  {
            val text = buffer.readString()
            val filterKind = buffer.readEnum<FilterKind>()
            return ApplyFilterContext(text, filterKind)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ApplyFilterContext)  {
            buffer.writeString(value.text)
            buffer.writeEnum(value.filterKind)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ApplyFilterContext
        
        if (text != other.text) return false
        if (filterKind != other.filterKind) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + filterKind.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ApplyFilterContext (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("filterKind = "); filterKind.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FilterProviderModel.kt]
 */
class FilterFileHyperlinkModel (
    val filePath: String,
    val line: Int,
    val column: Int,
    includeInOccurenceNavigation: Boolean,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : FilterHyperlinkModelBase (
    includeInOccurenceNavigation,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<FilterFileHyperlinkModel> {
        override val _type: KClass<FilterFileHyperlinkModel> = FilterFileHyperlinkModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FilterFileHyperlinkModel  {
            val includeInOccurenceNavigation = buffer.readBool()
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val filePath = buffer.readString()
            val line = buffer.readInt()
            val column = buffer.readInt()
            return FilterFileHyperlinkModel(filePath, line, column, includeInOccurenceNavigation, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FilterFileHyperlinkModel)  {
            buffer.writeBool(value.includeInOccurenceNavigation)
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeString(value.filePath)
            buffer.writeInt(value.line)
            buffer.writeInt(value.column)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FilterFileHyperlinkModel
        
        if (filePath != other.filePath) return false
        if (line != other.line) return false
        if (column != other.column) return false
        if (includeInOccurenceNavigation != other.includeInOccurenceNavigation) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + filePath.hashCode()
        __r = __r*31 + line.hashCode()
        __r = __r*31 + column.hashCode()
        __r = __r*31 + includeInOccurenceNavigation.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FilterFileHyperlinkModel (")
        printer.indent {
            print("filePath = "); filePath.print(printer); println()
            print("line = "); line.print(printer); println()
            print("column = "); column.print(printer); println()
            print("includeInOccurenceNavigation = "); includeInOccurenceNavigation.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [FilterProviderModel.kt]
 */
class FilterHighlighterModel (
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : FilterHighlighterModelBase (
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<FilterHighlighterModel> {
        override val _type: KClass<FilterHighlighterModel> = FilterHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FilterHighlighterModel  {
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            return FilterHighlighterModel(id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FilterHighlighterModel)  {
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FilterHighlighterModel
        
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FilterHighlighterModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [FilterProviderModel.kt]
 */
abstract class FilterHighlighterModelBase (
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : LightweightHighlighter (
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IAbstractDeclaration<FilterHighlighterModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): FilterHighlighterModelBase  {
            val objectStartPosition = buffer.position
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return FilterHighlighterModelBase_Unknown(id, attributeId, start, end, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class FilterHighlighterModelBase_Unknown (
    id: Long,
    attributeId: String,
    start: Int,
    end: Int,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : FilterHighlighterModelBase (
    id,
    attributeId,
    start,
    end
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<FilterHighlighterModelBase_Unknown> {
        override val _type: KClass<FilterHighlighterModelBase_Unknown> = FilterHighlighterModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FilterHighlighterModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FilterHighlighterModelBase_Unknown)  {
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FilterHighlighterModelBase_Unknown
        
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FilterHighlighterModelBase_Unknown (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [FilterProviderModel.kt]
 */
class FilterHyperlinkModel (
    includeInOccurenceNavigation: Boolean,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : FilterHyperlinkModelBase (
    includeInOccurenceNavigation,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<FilterHyperlinkModel> {
        override val _type: KClass<FilterHyperlinkModel> = FilterHyperlinkModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FilterHyperlinkModel  {
            val includeInOccurenceNavigation = buffer.readBool()
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            return FilterHyperlinkModel(includeInOccurenceNavigation, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FilterHyperlinkModel)  {
            buffer.writeBool(value.includeInOccurenceNavigation)
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FilterHyperlinkModel
        
        if (includeInOccurenceNavigation != other.includeInOccurenceNavigation) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + includeInOccurenceNavigation.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FilterHyperlinkModel (")
        printer.indent {
            print("includeInOccurenceNavigation = "); includeInOccurenceNavigation.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [FilterProviderModel.kt]
 */
abstract class FilterHyperlinkModelBase (
    val includeInOccurenceNavigation: Boolean,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : FilterHighlighterModelBase (
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IAbstractDeclaration<FilterHyperlinkModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): FilterHyperlinkModelBase  {
            val objectStartPosition = buffer.position
            val includeInOccurenceNavigation = buffer.readBool()
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return FilterHyperlinkModelBase_Unknown(includeInOccurenceNavigation, id, attributeId, start, end, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class FilterHyperlinkModelBase_Unknown (
    includeInOccurenceNavigation: Boolean,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : FilterHyperlinkModelBase (
    includeInOccurenceNavigation,
    id,
    attributeId,
    start,
    end
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<FilterHyperlinkModelBase_Unknown> {
        override val _type: KClass<FilterHyperlinkModelBase_Unknown> = FilterHyperlinkModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FilterHyperlinkModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FilterHyperlinkModelBase_Unknown)  {
            buffer.writeBool(value.includeInOccurenceNavigation)
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FilterHyperlinkModelBase_Unknown
        
        if (includeInOccurenceNavigation != other.includeInOccurenceNavigation) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + includeInOccurenceNavigation.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FilterHyperlinkModelBase_Unknown (")
        printer.indent {
            print("includeInOccurenceNavigation = "); includeInOccurenceNavigation.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [FilterProviderModel.kt]
 */
enum class FilterKind {
    StackTrace, 
    Console, 
    All;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<FilterKind>()
        
    }
}


/**
 * #### Generated from [FilterProviderModel.kt]
 */
data class FilterNavigationContext (
    val text: String,
    val filterKind: FilterKind,
    val hyperlink: FilterHyperlinkModel
) : IPrintable {
    //companion
    
    companion object : IMarshaller<FilterNavigationContext> {
        override val _type: KClass<FilterNavigationContext> = FilterNavigationContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FilterNavigationContext  {
            val text = buffer.readString()
            val filterKind = buffer.readEnum<FilterKind>()
            val hyperlink = FilterHyperlinkModel.read(ctx, buffer)
            return FilterNavigationContext(text, filterKind, hyperlink)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FilterNavigationContext)  {
            buffer.writeString(value.text)
            buffer.writeEnum(value.filterKind)
            FilterHyperlinkModel.write(ctx, buffer, value.hyperlink)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FilterNavigationContext
        
        if (text != other.text) return false
        if (filterKind != other.filterKind) return false
        if (hyperlink != other.hyperlink) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + filterKind.hashCode()
        __r = __r*31 + hyperlink.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FilterNavigationContext (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("filterKind = "); filterKind.print(printer); println()
            print("hyperlink = "); hyperlink.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FilterProviderModel.kt]
 */
data class SimpleConsole (
    val title: String,
    val content: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<SimpleConsole> {
        override val _type: KClass<SimpleConsole> = SimpleConsole::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SimpleConsole  {
            val title = buffer.readString()
            val content = buffer.readString()
            return SimpleConsole(title, content)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SimpleConsole)  {
            buffer.writeString(value.title)
            buffer.writeString(value.content)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SimpleConsole
        
        if (title != other.title) return false
        if (content != other.content) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + title.hashCode()
        __r = __r*31 + content.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SimpleConsole (")
        printer.indent {
            print("title = "); title.print(printer); println()
            print("content = "); content.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
