@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [FindInProjectModel.kt]
 */
class FindInProjectModel private constructor(
    private val _fileMasks: RdList<String>,
    private val _session: RdProperty<RdFindInProjectSession?>,
    private val _navigate: RdSignal<RdFindInProjectNavigation>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RdFindInProjectUsage)
            serializers.register(RdFindInProjectModel)
            serializers.register(RdFindInProjectSession)
            serializers.register(RdFindInProjectNavigation)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): FindInProjectModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return FindInProjectModel().apply {
                identify(protocol.identity, RdId.Null.mix("FindInProjectModel"))
                bind(lifetime, protocol, "FindInProjectModel")
            }
        }
        
        private val __RdFindInProjectSessionNullableSerializer = RdFindInProjectSession.nullable()
        
        const val serializationHash = 1129535574007921641L
        
    }
    override val serializersOwner: ISerializersOwner get() = FindInProjectModel
    override val serializationHash: Long get() = FindInProjectModel.serializationHash
    
    //fields
    val fileMasks: IMutableViewableList<String> get() = _fileMasks
    val session: IProperty<RdFindInProjectSession?> get() = _session
    val navigate: ISignal<RdFindInProjectNavigation> get() = _navigate
    //methods
    //initializer
    init {
        _fileMasks.optimizeNested = true
    }
    
    init {
        bindableChildren.add("fileMasks" to _fileMasks)
        bindableChildren.add("session" to _session)
        bindableChildren.add("navigate" to _navigate)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdList<String>(FrameworkMarshallers.String),
        RdProperty<RdFindInProjectSession?>(null, __RdFindInProjectSessionNullableSerializer),
        RdSignal<RdFindInProjectNavigation>(RdFindInProjectNavigation)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FindInProjectModel (")
        printer.indent {
            print("fileMasks = "); _fileMasks.print(printer); println()
            print("session = "); _session.print(printer); println()
            print("navigate = "); _navigate.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): FindInProjectModel   {
        return FindInProjectModel(
            _fileMasks.deepClonePolymorphic(),
            _session.deepClonePolymorphic(),
            _navigate.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [FindInProjectModel.kt]
 */
data class RdFindInProjectModel (
    val stringToFind: String,
    val isWholeWordsOnly: Boolean,
    val isRegularExpressions: Boolean,
    val isCaseSensitive: Boolean,
    val isProjectScope: Boolean,
    val fileFilter: String?,
    val moduleName: String?,
    val searchContext: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdFindInProjectModel> {
        override val _type: KClass<RdFindInProjectModel> = RdFindInProjectModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFindInProjectModel  {
            val stringToFind = buffer.readString()
            val isWholeWordsOnly = buffer.readBool()
            val isRegularExpressions = buffer.readBool()
            val isCaseSensitive = buffer.readBool()
            val isProjectScope = buffer.readBool()
            val fileFilter = buffer.readNullable { buffer.readString() }
            val moduleName = buffer.readNullable { buffer.readString() }
            val searchContext = buffer.readString()
            return RdFindInProjectModel(stringToFind, isWholeWordsOnly, isRegularExpressions, isCaseSensitive, isProjectScope, fileFilter, moduleName, searchContext)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFindInProjectModel)  {
            buffer.writeString(value.stringToFind)
            buffer.writeBool(value.isWholeWordsOnly)
            buffer.writeBool(value.isRegularExpressions)
            buffer.writeBool(value.isCaseSensitive)
            buffer.writeBool(value.isProjectScope)
            buffer.writeNullable(value.fileFilter) { buffer.writeString(it) }
            buffer.writeNullable(value.moduleName) { buffer.writeString(it) }
            buffer.writeString(value.searchContext)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFindInProjectModel
        
        if (stringToFind != other.stringToFind) return false
        if (isWholeWordsOnly != other.isWholeWordsOnly) return false
        if (isRegularExpressions != other.isRegularExpressions) return false
        if (isCaseSensitive != other.isCaseSensitive) return false
        if (isProjectScope != other.isProjectScope) return false
        if (fileFilter != other.fileFilter) return false
        if (moduleName != other.moduleName) return false
        if (searchContext != other.searchContext) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + stringToFind.hashCode()
        __r = __r*31 + isWholeWordsOnly.hashCode()
        __r = __r*31 + isRegularExpressions.hashCode()
        __r = __r*31 + isCaseSensitive.hashCode()
        __r = __r*31 + isProjectScope.hashCode()
        __r = __r*31 + if (fileFilter != null) fileFilter.hashCode() else 0
        __r = __r*31 + if (moduleName != null) moduleName.hashCode() else 0
        __r = __r*31 + searchContext.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFindInProjectModel (")
        printer.indent {
            print("stringToFind = "); stringToFind.print(printer); println()
            print("isWholeWordsOnly = "); isWholeWordsOnly.print(printer); println()
            print("isRegularExpressions = "); isRegularExpressions.print(printer); println()
            print("isCaseSensitive = "); isCaseSensitive.print(printer); println()
            print("isProjectScope = "); isProjectScope.print(printer); println()
            print("fileFilter = "); fileFilter.print(printer); println()
            print("moduleName = "); moduleName.print(printer); println()
            print("searchContext = "); searchContext.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindInProjectModel.kt]
 */
data class RdFindInProjectNavigation (
    val fileId: com.jetbrains.rd.ide.model.RdFileId,
    val offset: Int,
    val requestFocus: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdFindInProjectNavigation> {
        override val _type: KClass<RdFindInProjectNavigation> = RdFindInProjectNavigation::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFindInProjectNavigation  {
            val fileId = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.RdFileId>(ctx, buffer, com.jetbrains.rd.ide.model.RdFileId)
            val offset = buffer.readInt()
            val requestFocus = buffer.readBool()
            return RdFindInProjectNavigation(fileId, offset, requestFocus)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFindInProjectNavigation)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.fileId)
            buffer.writeInt(value.offset)
            buffer.writeBool(value.requestFocus)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFindInProjectNavigation
        
        if (fileId != other.fileId) return false
        if (offset != other.offset) return false
        if (requestFocus != other.requestFocus) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fileId.hashCode()
        __r = __r*31 + offset.hashCode()
        __r = __r*31 + requestFocus.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFindInProjectNavigation (")
        printer.indent {
            print("fileId = "); fileId.print(printer); println()
            print("offset = "); offset.print(printer); println()
            print("requestFocus = "); requestFocus.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindInProjectModel.kt]
 */
class RdFindInProjectSession private constructor(
    val model: RdFindInProjectModel,
    private val _consumer: RdSignal<RdFindInProjectUsage>,
    private val _ready: RdSignal<Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdFindInProjectSession> {
        override val _type: KClass<RdFindInProjectSession> = RdFindInProjectSession::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFindInProjectSession  {
            val _id = RdId.read(buffer)
            val model = RdFindInProjectModel.read(ctx, buffer)
            val _consumer = RdSignal.read(ctx, buffer, RdFindInProjectUsage)
            val _ready = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return RdFindInProjectSession(model, _consumer, _ready).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFindInProjectSession)  {
            value.rdid.write(buffer)
            RdFindInProjectModel.write(ctx, buffer, value.model)
            RdSignal.write(ctx, buffer, value._consumer)
            RdSignal.write(ctx, buffer, value._ready)
        }
        
        
    }
    //fields
    val consumer: IAsyncSignal<RdFindInProjectUsage> get() = _consumer
    val ready: IAsyncSignal<Unit> get() = _ready
    //methods
    //initializer
    init {
        _consumer.async = true
        _ready.async = true
    }
    
    init {
        bindableChildren.add("consumer" to _consumer)
        bindableChildren.add("ready" to _ready)
    }
    
    //secondary constructor
    constructor(
        model: RdFindInProjectModel
    ) : this(
        model,
        RdSignal<RdFindInProjectUsage>(RdFindInProjectUsage),
        RdSignal<Unit>(FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFindInProjectSession (")
        printer.indent {
            print("model = "); model.print(printer); println()
            print("consumer = "); _consumer.print(printer); println()
            print("ready = "); _ready.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdFindInProjectSession   {
        return RdFindInProjectSession(
            model,
            _consumer.deepClonePolymorphic(),
            _ready.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [FindInProjectModel.kt]
 */
data class RdFindInProjectUsage (
    val presentation: List<com.jetbrains.rd.ide.model.RdTextChunk>,
    val line: Int?,
    val offset: Int,
    val length: Int,
    val fileId: com.jetbrains.rd.ide.model.RdFileId,
    val path: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdFindInProjectUsage> {
        override val _type: KClass<RdFindInProjectUsage> = RdFindInProjectUsage::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFindInProjectUsage  {
            val presentation = buffer.readList { com.jetbrains.rd.ide.model.RdTextChunk.read(ctx, buffer) }
            val line = buffer.readNullable { buffer.readInt() }
            val offset = buffer.readInt()
            val length = buffer.readInt()
            val fileId = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.RdFileId>(ctx, buffer, com.jetbrains.rd.ide.model.RdFileId)
            val path = buffer.readString()
            return RdFindInProjectUsage(presentation, line, offset, length, fileId, path)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFindInProjectUsage)  {
            buffer.writeList(value.presentation) { v -> com.jetbrains.rd.ide.model.RdTextChunk.write(ctx, buffer, v) }
            buffer.writeNullable(value.line) { buffer.writeInt(it) }
            buffer.writeInt(value.offset)
            buffer.writeInt(value.length)
            ctx.serializers.writePolymorphic(ctx, buffer, value.fileId)
            buffer.writeString(value.path)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFindInProjectUsage
        
        if (presentation != other.presentation) return false
        if (line != other.line) return false
        if (offset != other.offset) return false
        if (length != other.length) return false
        if (fileId != other.fileId) return false
        if (path != other.path) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + presentation.hashCode()
        __r = __r*31 + if (line != null) line.hashCode() else 0
        __r = __r*31 + offset.hashCode()
        __r = __r*31 + length.hashCode()
        __r = __r*31 + fileId.hashCode()
        __r = __r*31 + path.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFindInProjectUsage (")
        printer.indent {
            print("presentation = "); presentation.print(printer); println()
            print("line = "); line.print(printer); println()
            print("offset = "); offset.print(printer); println()
            print("length = "); length.print(printer); println()
            print("fileId = "); fileId.print(printer); println()
            print("path = "); path.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
