@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [FindUsagesModel.kt]
 */
class FindUsagesModel private constructor(
    private val _highlights: RdSignal<RdHighlights>,
    private val _sessions: RdMap<Int, RdFindUsagesSession>,
    private val _groupingRules: RdOptionalProperty<RdUsageGroupingRuleList>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RdAddPerformOperationActionRequest)
            serializers.register(RdUsagePosition)
            serializers.register(RdUsageGroup)
            serializers.register(RdUsage)
            serializers.register(RdMergeableUsage)
            serializers.register(RdUsageGroupNavigationData)
            serializers.register(RdUsageList)
            serializers.register(RdUsageConstant)
            serializers.register(RdUsageKind.marshaller)
            serializers.register(RdLightUsage)
            serializers.register(RdHighlights)
            serializers.register(RdFindUsagesSession)
            serializers.register(RdUsageGroupingRuleList)
            serializers.register(RdUsageNavigationData)
            serializers.register(RdUsageConstantItem)
            serializers.register(RdUsageTargetList)
            serializers.register(RdUsageTarget)
            serializers.register(RdUsageTargetNavigationData)
            serializers.register(RdUsageGroupingRule)
            serializers.register(RdUsageBase_Unknown)
        }
        
        
        
        
        const val serializationHash = -6288125692311269205L
        
    }
    override val serializersOwner: ISerializersOwner get() = FindUsagesModel
    override val serializationHash: Long get() = FindUsagesModel.serializationHash
    
    //fields
    val highlights: ISignal<RdHighlights> get() = _highlights
    val sessions: IMutableViewableMap<Int, RdFindUsagesSession> get() = _sessions
    val groupingRules: IOptProperty<RdUsageGroupingRuleList> get() = _groupingRules
    //methods
    //initializer
    init {
        bindableChildren.add("highlights" to _highlights)
        bindableChildren.add("sessions" to _sessions)
        bindableChildren.add("groupingRules" to _groupingRules)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdSignal<RdHighlights>(RdHighlights),
        RdMap<Int, RdFindUsagesSession>(FrameworkMarshallers.Int, RdFindUsagesSession),
        RdOptionalProperty<RdUsageGroupingRuleList>(RdUsageGroupingRuleList)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FindUsagesModel (")
        printer.indent {
            print("highlights = "); _highlights.print(printer); println()
            print("sessions = "); _sessions.print(printer); println()
            print("groupingRules = "); _groupingRules.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): FindUsagesModel   {
        return FindUsagesModel(
            _highlights.deepClonePolymorphic(),
            _sessions.deepClonePolymorphic(),
            _groupingRules.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.findUsagesHost get() = getOrCreateExtension("findUsagesModel", ::FindUsagesModel)



/**
 * #### Generated from [FindUsagesModel.kt]
 */
data class RdAddPerformOperationActionRequest (
    val commandName: String?,
    val cannotMakeString: String,
    val shortDescription: String,
    val checkReadOnlyStatus: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdAddPerformOperationActionRequest> {
        override val _type: KClass<RdAddPerformOperationActionRequest> = RdAddPerformOperationActionRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdAddPerformOperationActionRequest  {
            val commandName = buffer.readNullable { buffer.readString() }
            val cannotMakeString = buffer.readString()
            val shortDescription = buffer.readString()
            val checkReadOnlyStatus = buffer.readBool()
            return RdAddPerformOperationActionRequest(commandName, cannotMakeString, shortDescription, checkReadOnlyStatus)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdAddPerformOperationActionRequest)  {
            buffer.writeNullable(value.commandName) { buffer.writeString(it) }
            buffer.writeString(value.cannotMakeString)
            buffer.writeString(value.shortDescription)
            buffer.writeBool(value.checkReadOnlyStatus)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdAddPerformOperationActionRequest
        
        if (commandName != other.commandName) return false
        if (cannotMakeString != other.cannotMakeString) return false
        if (shortDescription != other.shortDescription) return false
        if (checkReadOnlyStatus != other.checkReadOnlyStatus) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (commandName != null) commandName.hashCode() else 0
        __r = __r*31 + cannotMakeString.hashCode()
        __r = __r*31 + shortDescription.hashCode()
        __r = __r*31 + checkReadOnlyStatus.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdAddPerformOperationActionRequest (")
        printer.indent {
            print("commandName = "); commandName.print(printer); println()
            print("cannotMakeString = "); cannotMakeString.print(printer); println()
            print("shortDescription = "); shortDescription.print(printer); println()
            print("checkReadOnlyStatus = "); checkReadOnlyStatus.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * The result of a single Find Usages operation
 * @property title The title of the tab displaying the find usages results
 * @property usages The usages displayed in the tab
 * #### Generated from [FindUsagesModel.kt]
 */
class RdFindUsagesSession private constructor(
    val title: String,
    val usages: RdUsageList,
    val targets: RdUsageTargetList,
    val isShowCancelButton: Boolean,
    val showWithSingleUsage: Boolean,
    val gotoSessionKey: Int?,
    private val _isSearchComplete: RdOptionalProperty<Boolean>,
    private val _canReRun: RdOptionalProperty<Boolean>,
    private val _reRun: RdSignal<Unit>,
    private val _addPerformOperationAction: RdCall<RdAddPerformOperationActionRequest, Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdFindUsagesSession> {
        override val _type: KClass<RdFindUsagesSession> = RdFindUsagesSession::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFindUsagesSession  {
            val _id = RdId.read(buffer)
            val title = buffer.readString()
            val usages = RdUsageList.read(ctx, buffer)
            val targets = RdUsageTargetList.read(ctx, buffer)
            val isShowCancelButton = buffer.readBool()
            val showWithSingleUsage = buffer.readBool()
            val gotoSessionKey = buffer.readNullable { buffer.readInt() }
            val _isSearchComplete = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _canReRun = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _reRun = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _addPerformOperationAction = RdCall.read(ctx, buffer, RdAddPerformOperationActionRequest, FrameworkMarshallers.Void)
            return RdFindUsagesSession(title, usages, targets, isShowCancelButton, showWithSingleUsage, gotoSessionKey, _isSearchComplete, _canReRun, _reRun, _addPerformOperationAction).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFindUsagesSession)  {
            value.rdid.write(buffer)
            buffer.writeString(value.title)
            RdUsageList.write(ctx, buffer, value.usages)
            RdUsageTargetList.write(ctx, buffer, value.targets)
            buffer.writeBool(value.isShowCancelButton)
            buffer.writeBool(value.showWithSingleUsage)
            buffer.writeNullable(value.gotoSessionKey) { buffer.writeInt(it) }
            RdOptionalProperty.write(ctx, buffer, value._isSearchComplete)
            RdOptionalProperty.write(ctx, buffer, value._canReRun)
            RdSignal.write(ctx, buffer, value._reRun)
            RdCall.write(ctx, buffer, value._addPerformOperationAction)
        }
        
        
    }
    //fields
    val isSearchComplete: IOptProperty<Boolean> get() = _isSearchComplete
    val canReRun: IOptProperty<Boolean> get() = _canReRun
    val reRun: ISignal<Unit> get() = _reRun
    val addPerformOperationAction: RdCall<RdAddPerformOperationActionRequest, Unit> get() = _addPerformOperationAction
    //methods
    //initializer
    init {
        _isSearchComplete.optimizeNested = true
        _canReRun.optimizeNested = true
    }
    
    init {
        bindableChildren.add("usages" to usages)
        bindableChildren.add("targets" to targets)
        bindableChildren.add("isSearchComplete" to _isSearchComplete)
        bindableChildren.add("canReRun" to _canReRun)
        bindableChildren.add("reRun" to _reRun)
        bindableChildren.add("addPerformOperationAction" to _addPerformOperationAction)
    }
    
    //secondary constructor
    constructor(
        title: String,
        usages: RdUsageList,
        targets: RdUsageTargetList,
        isShowCancelButton: Boolean,
        showWithSingleUsage: Boolean,
        gotoSessionKey: Int?
    ) : this(
        title,
        usages,
        targets,
        isShowCancelButton,
        showWithSingleUsage,
        gotoSessionKey,
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdCall<RdAddPerformOperationActionRequest, Unit>(RdAddPerformOperationActionRequest, FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFindUsagesSession (")
        printer.indent {
            print("title = "); title.print(printer); println()
            print("usages = "); usages.print(printer); println()
            print("targets = "); targets.print(printer); println()
            print("isShowCancelButton = "); isShowCancelButton.print(printer); println()
            print("showWithSingleUsage = "); showWithSingleUsage.print(printer); println()
            print("gotoSessionKey = "); gotoSessionKey.print(printer); println()
            print("isSearchComplete = "); _isSearchComplete.print(printer); println()
            print("canReRun = "); _canReRun.print(printer); println()
            print("reRun = "); _reRun.print(printer); println()
            print("addPerformOperationAction = "); _addPerformOperationAction.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdFindUsagesSession   {
        return RdFindUsagesSession(
            title,
            usages.deepClonePolymorphic(),
            targets.deepClonePolymorphic(),
            isShowCancelButton,
            showWithSingleUsage,
            gotoSessionKey,
            _isSearchComplete.deepClonePolymorphic(),
            _canReRun.deepClonePolymorphic(),
            _reRun.deepClonePolymorphic(),
            _addPerformOperationAction.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
data class RdHighlights (
    val textControlId: TextControlId,
    val occurrences: List<RdLightUsage>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdHighlights> {
        override val _type: KClass<RdHighlights> = RdHighlights::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdHighlights  {
            val textControlId = TextControlId.read(ctx, buffer)
            val occurrences = buffer.readList { RdLightUsage.read(ctx, buffer) }
            return RdHighlights(textControlId, occurrences)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdHighlights)  {
            TextControlId.write(ctx, buffer, value.textControlId)
            buffer.writeList(value.occurrences) { v -> RdLightUsage.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdHighlights
        
        if (textControlId != other.textControlId) return false
        if (occurrences != other.occurrences) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + textControlId.hashCode()
        __r = __r*31 + occurrences.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdHighlights (")
        printer.indent {
            print("textControlId = "); textControlId.print(printer); println()
            print("occurrences = "); occurrences.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
data class RdLightUsage (
    val start: Int,
    val end: Int,
    val kind: RdUsageKind
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdLightUsage> {
        override val _type: KClass<RdLightUsage> = RdLightUsage::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdLightUsage  {
            val start = buffer.readInt()
            val end = buffer.readInt()
            val kind = buffer.readEnum<RdUsageKind>()
            return RdLightUsage(start, end, kind)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdLightUsage)  {
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeEnum(value.kind)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdLightUsage
        
        if (start != other.start) return false
        if (end != other.end) return false
        if (kind != other.kind) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        __r = __r*31 + kind.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdLightUsage (")
        printer.indent {
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
            print("kind = "); kind.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
class RdMergeableUsage (
    val position: RdUsagePosition,
    index: Int,
    text: String,
    isAccessedForReading: Boolean,
    isAccessedForWriting: Boolean,
    startOffset: Int,
    endOffset: Int,
    fileId: RdDocumentId?,
    icon: IconModel?,
    groups: List<RdUsageGroup>
) : RdUsageBase (
    index,
    text,
    isAccessedForReading,
    isAccessedForWriting,
    startOffset,
    endOffset,
    fileId,
    icon,
    groups
) {
    //companion
    
    companion object : IMarshaller<RdMergeableUsage> {
        override val _type: KClass<RdMergeableUsage> = RdMergeableUsage::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdMergeableUsage  {
            val index = buffer.readInt()
            val text = ctx.readInterned(buffer, "UsagesInternScope") { _, _ -> buffer.readString() }
            val isAccessedForReading = buffer.readBool()
            val isAccessedForWriting = buffer.readBool()
            val startOffset = buffer.readInt()
            val endOffset = buffer.readInt()
            val fileId = buffer.readNullable { ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId) }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val groups = buffer.readList { RdUsageGroup.read(ctx, buffer) }
            val position = RdUsagePosition.read(ctx, buffer)
            return RdMergeableUsage(position, index, text, isAccessedForReading, isAccessedForWriting, startOffset, endOffset, fileId, icon, groups)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdMergeableUsage)  {
            buffer.writeInt(value.index)
            ctx.writeInterned(buffer, value.text, "UsagesInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeBool(value.isAccessedForReading)
            buffer.writeBool(value.isAccessedForWriting)
            buffer.writeInt(value.startOffset)
            buffer.writeInt(value.endOffset)
            buffer.writeNullable(value.fileId) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeList(value.groups) { v -> RdUsageGroup.write(ctx, buffer, v) }
            RdUsagePosition.write(ctx, buffer, value.position)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdMergeableUsage
        
        if (position != other.position) return false
        if (index != other.index) return false
        if (text != other.text) return false
        if (isAccessedForReading != other.isAccessedForReading) return false
        if (isAccessedForWriting != other.isAccessedForWriting) return false
        if (startOffset != other.startOffset) return false
        if (endOffset != other.endOffset) return false
        if (fileId != other.fileId) return false
        if (icon != other.icon) return false
        if (groups != other.groups) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + position.hashCode()
        __r = __r*31 + index.hashCode()
        __r = __r*31 + text.hashCode()
        __r = __r*31 + isAccessedForReading.hashCode()
        __r = __r*31 + isAccessedForWriting.hashCode()
        __r = __r*31 + startOffset.hashCode()
        __r = __r*31 + endOffset.hashCode()
        __r = __r*31 + if (fileId != null) fileId.hashCode() else 0
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + groups.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdMergeableUsage (")
        printer.indent {
            print("position = "); position.print(printer); println()
            print("index = "); index.print(printer); println()
            print("text = "); text.print(printer); println()
            print("isAccessedForReading = "); isAccessedForReading.print(printer); println()
            print("isAccessedForWriting = "); isAccessedForWriting.print(printer); println()
            print("startOffset = "); startOffset.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
            print("fileId = "); fileId.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("groups = "); groups.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
class RdUsage (
    val displayName: RichTextModel,
    index: Int,
    text: String,
    isAccessedForReading: Boolean,
    isAccessedForWriting: Boolean,
    startOffset: Int,
    endOffset: Int,
    fileId: RdDocumentId?,
    icon: IconModel?,
    groups: List<RdUsageGroup>
) : RdUsageBase (
    index,
    text,
    isAccessedForReading,
    isAccessedForWriting,
    startOffset,
    endOffset,
    fileId,
    icon,
    groups
) {
    //companion
    
    companion object : IMarshaller<RdUsage> {
        override val _type: KClass<RdUsage> = RdUsage::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsage  {
            val index = buffer.readInt()
            val text = ctx.readInterned(buffer, "UsagesInternScope") { _, _ -> buffer.readString() }
            val isAccessedForReading = buffer.readBool()
            val isAccessedForWriting = buffer.readBool()
            val startOffset = buffer.readInt()
            val endOffset = buffer.readInt()
            val fileId = buffer.readNullable { ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId) }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val groups = buffer.readList { RdUsageGroup.read(ctx, buffer) }
            val displayName = RichTextModel.read(ctx, buffer)
            return RdUsage(displayName, index, text, isAccessedForReading, isAccessedForWriting, startOffset, endOffset, fileId, icon, groups)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsage)  {
            buffer.writeInt(value.index)
            ctx.writeInterned(buffer, value.text, "UsagesInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeBool(value.isAccessedForReading)
            buffer.writeBool(value.isAccessedForWriting)
            buffer.writeInt(value.startOffset)
            buffer.writeInt(value.endOffset)
            buffer.writeNullable(value.fileId) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeList(value.groups) { v -> RdUsageGroup.write(ctx, buffer, v) }
            RichTextModel.write(ctx, buffer, value.displayName)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUsage
        
        if (displayName != other.displayName) return false
        if (index != other.index) return false
        if (text != other.text) return false
        if (isAccessedForReading != other.isAccessedForReading) return false
        if (isAccessedForWriting != other.isAccessedForWriting) return false
        if (startOffset != other.startOffset) return false
        if (endOffset != other.endOffset) return false
        if (fileId != other.fileId) return false
        if (icon != other.icon) return false
        if (groups != other.groups) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + displayName.hashCode()
        __r = __r*31 + index.hashCode()
        __r = __r*31 + text.hashCode()
        __r = __r*31 + isAccessedForReading.hashCode()
        __r = __r*31 + isAccessedForWriting.hashCode()
        __r = __r*31 + startOffset.hashCode()
        __r = __r*31 + endOffset.hashCode()
        __r = __r*31 + if (fileId != null) fileId.hashCode() else 0
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + groups.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsage (")
        printer.indent {
            print("displayName = "); displayName.print(printer); println()
            print("index = "); index.print(printer); println()
            print("text = "); text.print(printer); println()
            print("isAccessedForReading = "); isAccessedForReading.print(printer); println()
            print("isAccessedForWriting = "); isAccessedForWriting.print(printer); println()
            print("startOffset = "); startOffset.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
            print("fileId = "); fileId.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("groups = "); groups.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
abstract class RdUsageBase (
    val index: Int,
    val text: String,
    val isAccessedForReading: Boolean,
    val isAccessedForWriting: Boolean,
    val startOffset: Int,
    val endOffset: Int,
    val fileId: RdDocumentId?,
    val icon: IconModel?,
    val groups: List<RdUsageGroup>
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdUsageBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdUsageBase  {
            val objectStartPosition = buffer.position
            val index = buffer.readInt()
            val text = ctx.readInterned(buffer, "UsagesInternScope") { _, _ -> buffer.readString() }
            val isAccessedForReading = buffer.readBool()
            val isAccessedForWriting = buffer.readBool()
            val startOffset = buffer.readInt()
            val endOffset = buffer.readInt()
            val fileId = buffer.readNullable { ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId) }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val groups = buffer.readList { RdUsageGroup.read(ctx, buffer) }
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdUsageBase_Unknown(index, text, isAccessedForReading, isAccessedForWriting, startOffset, endOffset, fileId, icon, groups, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdUsageBase_Unknown (
    index: Int,
    text: String,
    isAccessedForReading: Boolean,
    isAccessedForWriting: Boolean,
    startOffset: Int,
    endOffset: Int,
    fileId: RdDocumentId?,
    icon: IconModel?,
    groups: List<RdUsageGroup>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdUsageBase (
    index,
    text,
    isAccessedForReading,
    isAccessedForWriting,
    startOffset,
    endOffset,
    fileId,
    icon,
    groups
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdUsageBase_Unknown> {
        override val _type: KClass<RdUsageBase_Unknown> = RdUsageBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageBase_Unknown)  {
            buffer.writeInt(value.index)
            ctx.writeInterned(buffer, value.text, "UsagesInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeBool(value.isAccessedForReading)
            buffer.writeBool(value.isAccessedForWriting)
            buffer.writeInt(value.startOffset)
            buffer.writeInt(value.endOffset)
            buffer.writeNullable(value.fileId) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeList(value.groups) { v -> RdUsageGroup.write(ctx, buffer, v) }
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUsageBase_Unknown
        
        if (index != other.index) return false
        if (text != other.text) return false
        if (isAccessedForReading != other.isAccessedForReading) return false
        if (isAccessedForWriting != other.isAccessedForWriting) return false
        if (startOffset != other.startOffset) return false
        if (endOffset != other.endOffset) return false
        if (fileId != other.fileId) return false
        if (icon != other.icon) return false
        if (groups != other.groups) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + index.hashCode()
        __r = __r*31 + text.hashCode()
        __r = __r*31 + isAccessedForReading.hashCode()
        __r = __r*31 + isAccessedForWriting.hashCode()
        __r = __r*31 + startOffset.hashCode()
        __r = __r*31 + endOffset.hashCode()
        __r = __r*31 + if (fileId != null) fileId.hashCode() else 0
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + groups.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageBase_Unknown (")
        printer.indent {
            print("index = "); index.print(printer); println()
            print("text = "); text.print(printer); println()
            print("isAccessedForReading = "); isAccessedForReading.print(printer); println()
            print("isAccessedForWriting = "); isAccessedForWriting.print(printer); println()
            print("startOffset = "); startOffset.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
            print("fileId = "); fileId.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("groups = "); groups.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
class RdUsageConstant (
    val selectedItems: List<RdUsageConstantItem>
) : RdDataConstant (
) {
    //companion
    
    companion object : IMarshaller<RdUsageConstant> {
        override val _type: KClass<RdUsageConstant> = RdUsageConstant::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageConstant  {
            val selectedItems = buffer.readList { RdUsageConstantItem.read(ctx, buffer) }
            return RdUsageConstant(selectedItems)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageConstant)  {
            buffer.writeList(value.selectedItems) { v -> RdUsageConstantItem.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUsageConstant
        
        if (selectedItems != other.selectedItems) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + selectedItems.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageConstant (")
        printer.indent {
            print("selectedItems = "); selectedItems.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
data class RdUsageConstantItem (
    val listId: String,
    val itemId: Int,
    val groupName: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdUsageConstantItem> {
        override val _type: KClass<RdUsageConstantItem> = RdUsageConstantItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageConstantItem  {
            val listId = buffer.readString()
            val itemId = buffer.readInt()
            val groupName = buffer.readString()
            return RdUsageConstantItem(listId, itemId, groupName)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageConstantItem)  {
            buffer.writeString(value.listId)
            buffer.writeInt(value.itemId)
            buffer.writeString(value.groupName)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUsageConstantItem
        
        if (listId != other.listId) return false
        if (itemId != other.itemId) return false
        if (groupName != other.groupName) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + listId.hashCode()
        __r = __r*31 + itemId.hashCode()
        __r = __r*31 + groupName.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageConstantItem (")
        printer.indent {
            print("listId = "); listId.print(printer); println()
            print("itemId = "); itemId.print(printer); println()
            print("groupName = "); groupName.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
data class RdUsageGroup (
    val groupingRuleId: String,
    val text: String,
    val icon: IconModel?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdUsageGroup> {
        override val _type: KClass<RdUsageGroup> = RdUsageGroup::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageGroup  {
            val groupingRuleId = ctx.readInterned(buffer, "UsagesInternScope") { _, _ -> buffer.readString() }
            val text = ctx.readInterned(buffer, "UsagesInternScope") { _, _ -> buffer.readString() }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            return RdUsageGroup(groupingRuleId, text, icon)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageGroup)  {
            ctx.writeInterned(buffer, value.groupingRuleId, "UsagesInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
            ctx.writeInterned(buffer, value.text, "UsagesInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUsageGroup
        
        if (groupingRuleId != other.groupingRuleId) return false
        if (text != other.text) return false
        if (icon != other.icon) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + groupingRuleId.hashCode()
        __r = __r*31 + text.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageGroup (")
        printer.indent {
            print("groupingRuleId = "); groupingRuleId.print(printer); println()
            print("text = "); text.print(printer); println()
            print("icon = "); icon.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
data class RdUsageGroupNavigationData (
    val usageIndex: Int,
    val groupingRuleName: String,
    val requestFocus: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdUsageGroupNavigationData> {
        override val _type: KClass<RdUsageGroupNavigationData> = RdUsageGroupNavigationData::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageGroupNavigationData  {
            val usageIndex = buffer.readInt()
            val groupingRuleName = buffer.readString()
            val requestFocus = buffer.readBool()
            return RdUsageGroupNavigationData(usageIndex, groupingRuleName, requestFocus)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageGroupNavigationData)  {
            buffer.writeInt(value.usageIndex)
            buffer.writeString(value.groupingRuleName)
            buffer.writeBool(value.requestFocus)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUsageGroupNavigationData
        
        if (usageIndex != other.usageIndex) return false
        if (groupingRuleName != other.groupingRuleName) return false
        if (requestFocus != other.requestFocus) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + usageIndex.hashCode()
        __r = __r*31 + groupingRuleName.hashCode()
        __r = __r*31 + requestFocus.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageGroupNavigationData (")
        printer.indent {
            print("usageIndex = "); usageIndex.print(printer); println()
            print("groupingRuleName = "); groupingRuleName.print(printer); println()
            print("requestFocus = "); requestFocus.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
class RdUsageGroupingRule private constructor(
    val id: String,
    val groupingRuleName: String,
    val icon: IconModel?,
    val rank: Int,
    val isSeparable: Boolean,
    private val _enabled: RdOptionalProperty<Boolean>,
    val isNavigateable: Boolean,
    val configurable: Boolean,
    val priorityDependsOnUsages: Boolean,
    val groupingActionId: String?,
    val groupingActionInverted: Boolean
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdUsageGroupingRule> {
        override val _type: KClass<RdUsageGroupingRule> = RdUsageGroupingRule::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageGroupingRule  {
            val _id = RdId.read(buffer)
            val id = buffer.readString()
            val groupingRuleName = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val rank = buffer.readInt()
            val isSeparable = buffer.readBool()
            val _enabled = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val isNavigateable = buffer.readBool()
            val configurable = buffer.readBool()
            val priorityDependsOnUsages = buffer.readBool()
            val groupingActionId = buffer.readNullable { buffer.readString() }
            val groupingActionInverted = buffer.readBool()
            return RdUsageGroupingRule(id, groupingRuleName, icon, rank, isSeparable, _enabled, isNavigateable, configurable, priorityDependsOnUsages, groupingActionId, groupingActionInverted).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageGroupingRule)  {
            value.rdid.write(buffer)
            buffer.writeString(value.id)
            buffer.writeString(value.groupingRuleName)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeInt(value.rank)
            buffer.writeBool(value.isSeparable)
            RdOptionalProperty.write(ctx, buffer, value._enabled)
            buffer.writeBool(value.isNavigateable)
            buffer.writeBool(value.configurable)
            buffer.writeBool(value.priorityDependsOnUsages)
            buffer.writeNullable(value.groupingActionId) { buffer.writeString(it) }
            buffer.writeBool(value.groupingActionInverted)
        }
        
        
    }
    //fields
    val enabled: IOptProperty<Boolean> get() = _enabled
    //methods
    //initializer
    init {
        _enabled.optimizeNested = true
    }
    
    init {
        bindableChildren.add("enabled" to _enabled)
    }
    
    //secondary constructor
    constructor(
        id: String,
        groupingRuleName: String,
        icon: IconModel?,
        rank: Int,
        isSeparable: Boolean,
        isNavigateable: Boolean,
        configurable: Boolean,
        priorityDependsOnUsages: Boolean,
        groupingActionId: String?,
        groupingActionInverted: Boolean
    ) : this(
        id,
        groupingRuleName,
        icon,
        rank,
        isSeparable,
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        isNavigateable,
        configurable,
        priorityDependsOnUsages,
        groupingActionId,
        groupingActionInverted
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageGroupingRule (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("groupingRuleName = "); groupingRuleName.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("rank = "); rank.print(printer); println()
            print("isSeparable = "); isSeparable.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("isNavigateable = "); isNavigateable.print(printer); println()
            print("configurable = "); configurable.print(printer); println()
            print("priorityDependsOnUsages = "); priorityDependsOnUsages.print(printer); println()
            print("groupingActionId = "); groupingActionId.print(printer); println()
            print("groupingActionInverted = "); groupingActionInverted.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdUsageGroupingRule   {
        return RdUsageGroupingRule(
            id,
            groupingRuleName,
            icon,
            rank,
            isSeparable,
            _enabled.deepClonePolymorphic(),
            isNavigateable,
            configurable,
            priorityDependsOnUsages,
            groupingActionId,
            groupingActionInverted
        )
    }
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
class RdUsageGroupingRuleList (
    val items: List<RdUsageGroupingRule>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdUsageGroupingRuleList> {
        override val _type: KClass<RdUsageGroupingRuleList> = RdUsageGroupingRuleList::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageGroupingRuleList  {
            val _id = RdId.read(buffer)
            val items = buffer.readList { RdUsageGroupingRule.read(ctx, buffer) }
            return RdUsageGroupingRuleList(items).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageGroupingRuleList)  {
            value.rdid.write(buffer)
            buffer.writeList(value.items) { v -> RdUsageGroupingRule.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("items" to items)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageGroupingRuleList (")
        printer.indent {
            print("items = "); items.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdUsageGroupingRuleList   {
        return RdUsageGroupingRuleList(
            items.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
enum class RdUsageKind {
    Target, 
    ReadUsage, 
    WriteUsage, 
    Navigation, 
    Other;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<RdUsageKind>()
        
    }
}


/**
 * Represents a list of usages shown in a Find Usages view
 * #### Generated from [FindUsagesModel.kt]
 */
class RdUsageList private constructor(
    val listId: String,
    val generatorPlease: Unit,
    private val _items: RdList<List<RdUsageBase>>,
    private val _navigateTo: RdSignal<RdUsageNavigationData>,
    private val _navigateToGroup: RdSignal<RdUsageGroupNavigationData>,
    private val _updateItem: RdCall<Int, Boolean>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdUsageList> {
        override val _type: KClass<RdUsageList> = RdUsageList::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageList  {
            val _id = RdId.read(buffer)
            val listId = buffer.readString()
            val generatorPlease = buffer.readVoid()
            val _items = RdList.read(ctx, buffer, __RdUsageBaseListSerializer)
            val _navigateTo = RdSignal.read(ctx, buffer, RdUsageNavigationData)
            val _navigateToGroup = RdSignal.read(ctx, buffer, RdUsageGroupNavigationData)
            val _updateItem = RdCall.read(ctx, buffer, FrameworkMarshallers.Int, FrameworkMarshallers.Bool)
            return RdUsageList(listId, generatorPlease, _items, _navigateTo, _navigateToGroup, _updateItem).withId(_id).apply { mySerializationContext = ctx.withInternRootsHere(this, "UsagesInternScope") }
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageList)  {
            value.rdid.write(buffer)
            buffer.writeString(value.listId)
            buffer.writeVoid(value.generatorPlease)
            RdList.write(ctx, buffer, value._items)
            RdSignal.write(ctx, buffer, value._navigateTo)
            RdSignal.write(ctx, buffer, value._navigateToGroup)
            RdCall.write(ctx, buffer, value._updateItem)
            value.mySerializationContext = ctx.withInternRootsHere(value, "UsagesInternScope")
        }
        
        private val __RdUsageBaseListSerializer = AbstractPolymorphic(RdUsageBase).list()
        
    }
    //fields
    
    /**
     * List of batches of usages
     */
    val items: IMutableViewableList<List<RdUsageBase>> get() = _items
    
    /**
     * Navigates to the usage with the given index
     */
    val navigateTo: ISignal<RdUsageNavigationData> get() = _navigateTo
    val navigateToGroup: ISignal<RdUsageGroupNavigationData> get() = _navigateToGroup
    
    /**
     * Called to check whether a usage is still valid. Takes index (RdUsageBase.index) of element to check, returns true if valid, false otherwise
     */
    val updateItem: RdCall<Int, Boolean> get() = _updateItem
    private var mySerializationContext: SerializationCtx? = null
    override val serializationContext: SerializationCtx
        get() = mySerializationContext ?: throw IllegalStateException("Attempting to get serialization context too soon for $location")
    //methods
    //initializer
    init {
        _items.optimizeNested = true
    }
    
    init {
        _updateItem.async = true
    }
    
    init {
        bindableChildren.add("items" to _items)
        bindableChildren.add("navigateTo" to _navigateTo)
        bindableChildren.add("navigateToGroup" to _navigateToGroup)
        bindableChildren.add("updateItem" to _updateItem)
    }
    
    //secondary constructor
    constructor(
        listId: String,
        generatorPlease: Unit
    ) : this(
        listId,
        generatorPlease,
        RdList<List<RdUsageBase>>(__RdUsageBaseListSerializer),
        RdSignal<RdUsageNavigationData>(RdUsageNavigationData),
        RdSignal<RdUsageGroupNavigationData>(RdUsageGroupNavigationData),
        RdCall<Int, Boolean>(FrameworkMarshallers.Int, FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageList (")
        printer.indent {
            print("listId = "); listId.print(printer); println()
            print("generatorPlease = "); generatorPlease.print(printer); println()
            print("items = "); _items.print(printer); println()
            print("navigateTo = "); _navigateTo.print(printer); println()
            print("navigateToGroup = "); _navigateToGroup.print(printer); println()
            print("updateItem = "); _updateItem.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdUsageList   {
        return RdUsageList(
            listId,
            generatorPlease,
            _items.deepClonePolymorphic(),
            _navigateTo.deepClonePolymorphic(),
            _navigateToGroup.deepClonePolymorphic(),
            _updateItem.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * @property index Index (RdUsageBase.index) of the element to navigate to
 * @property requestFocus Whether the editor or view in which the element is opened should be focused
 * #### Generated from [FindUsagesModel.kt]
 */
data class RdUsageNavigationData (
    val index: Int,
    val requestFocus: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdUsageNavigationData> {
        override val _type: KClass<RdUsageNavigationData> = RdUsageNavigationData::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageNavigationData  {
            val index = buffer.readInt()
            val requestFocus = buffer.readBool()
            return RdUsageNavigationData(index, requestFocus)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageNavigationData)  {
            buffer.writeInt(value.index)
            buffer.writeBool(value.requestFocus)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUsageNavigationData
        
        if (index != other.index) return false
        if (requestFocus != other.requestFocus) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + index.hashCode()
        __r = __r*31 + requestFocus.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageNavigationData (")
        printer.indent {
            print("index = "); index.print(printer); println()
            print("requestFocus = "); requestFocus.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [FindUsagesModel.kt]
 */
data class RdUsagePosition (
    val line: Int,
    val column: Int,
    val occurrenceRangeStartOffset: Int,
    val occurrenceRangeEndOffset: Int,
    val startOffset: Int,
    val endOffset: Int,
    val documentMoniker: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdUsagePosition> {
        override val _type: KClass<RdUsagePosition> = RdUsagePosition::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsagePosition  {
            val line = buffer.readInt()
            val column = buffer.readInt()
            val occurrenceRangeStartOffset = buffer.readInt()
            val occurrenceRangeEndOffset = buffer.readInt()
            val startOffset = buffer.readInt()
            val endOffset = buffer.readInt()
            val documentMoniker = ctx.readInterned(buffer, "UsagesInternScope") { _, _ -> buffer.readString() }
            return RdUsagePosition(line, column, occurrenceRangeStartOffset, occurrenceRangeEndOffset, startOffset, endOffset, documentMoniker)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsagePosition)  {
            buffer.writeInt(value.line)
            buffer.writeInt(value.column)
            buffer.writeInt(value.occurrenceRangeStartOffset)
            buffer.writeInt(value.occurrenceRangeEndOffset)
            buffer.writeInt(value.startOffset)
            buffer.writeInt(value.endOffset)
            ctx.writeInterned(buffer, value.documentMoniker, "UsagesInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUsagePosition
        
        if (line != other.line) return false
        if (column != other.column) return false
        if (occurrenceRangeStartOffset != other.occurrenceRangeStartOffset) return false
        if (occurrenceRangeEndOffset != other.occurrenceRangeEndOffset) return false
        if (startOffset != other.startOffset) return false
        if (endOffset != other.endOffset) return false
        if (documentMoniker != other.documentMoniker) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + line.hashCode()
        __r = __r*31 + column.hashCode()
        __r = __r*31 + occurrenceRangeStartOffset.hashCode()
        __r = __r*31 + occurrenceRangeEndOffset.hashCode()
        __r = __r*31 + startOffset.hashCode()
        __r = __r*31 + endOffset.hashCode()
        __r = __r*31 + documentMoniker.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsagePosition (")
        printer.indent {
            print("line = "); line.print(printer); println()
            print("column = "); column.print(printer); println()
            print("occurrenceRangeStartOffset = "); occurrenceRangeStartOffset.print(printer); println()
            print("occurrenceRangeEndOffset = "); occurrenceRangeEndOffset.print(printer); println()
            print("startOffset = "); startOffset.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
            print("documentMoniker = "); documentMoniker.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * @property index Index of usage target in list
 * @property name The name to show in the usages view
 * @property icon The icon for the usage target
 * #### Generated from [FindUsagesModel.kt]
 */
class RdUsageTarget private constructor(
    val index: Int,
    val name: String,
    private val _isValid: RdOptionalProperty<Boolean>,
    val icon: IconModel?
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdUsageTarget> {
        override val _type: KClass<RdUsageTarget> = RdUsageTarget::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageTarget  {
            val _id = RdId.read(buffer)
            val index = buffer.readInt()
            val name = buffer.readString()
            val _isValid = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            return RdUsageTarget(index, name, _isValid, icon).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageTarget)  {
            value.rdid.write(buffer)
            buffer.writeInt(value.index)
            buffer.writeString(value.name)
            RdOptionalProperty.write(ctx, buffer, value._isValid)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    
    /**
     * Whether the usage target is valid (the corresponding element is still in the source code
     */
    val isValid: IOptProperty<Boolean> get() = _isValid
    //methods
    //initializer
    init {
        _isValid.optimizeNested = true
    }
    
    init {
        bindableChildren.add("isValid" to _isValid)
    }
    
    //secondary constructor
    constructor(
        index: Int,
        name: String,
        icon: IconModel?
    ) : this(
        index,
        name,
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        icon
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageTarget (")
        printer.indent {
            print("index = "); index.print(printer); println()
            print("name = "); name.print(printer); println()
            print("isValid = "); _isValid.print(printer); println()
            print("icon = "); icon.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdUsageTarget   {
        return RdUsageTarget(
            index,
            name,
            _isValid.deepClonePolymorphic(),
            icon
        )
    }
    //contexts
}


/**
 * @property title Title of the element type being searched
 * #### Generated from [FindUsagesModel.kt]
 */
class RdUsageTargetList private constructor(
    val title: String?,
    val items: List<RdUsageTarget>,
    private val _navigateTo: RdSignal<RdUsageTargetNavigationData>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdUsageTargetList> {
        override val _type: KClass<RdUsageTargetList> = RdUsageTargetList::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageTargetList  {
            val _id = RdId.read(buffer)
            val title = buffer.readNullable { buffer.readString() }
            val items = buffer.readList { RdUsageTarget.read(ctx, buffer) }
            val _navigateTo = RdSignal.read(ctx, buffer, RdUsageTargetNavigationData)
            return RdUsageTargetList(title, items, _navigateTo).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageTargetList)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.title) { buffer.writeString(it) }
            buffer.writeList(value.items) { v -> RdUsageTarget.write(ctx, buffer, v) }
            RdSignal.write(ctx, buffer, value._navigateTo)
        }
        
        
    }
    //fields
    
    /**
     * Navigates to the target with the given index
     */
    val navigateTo: ISignal<RdUsageTargetNavigationData> get() = _navigateTo
    //methods
    //initializer
    init {
        bindableChildren.add("items" to items)
        bindableChildren.add("navigateTo" to _navigateTo)
    }
    
    //secondary constructor
    constructor(
        title: String?,
        items: List<RdUsageTarget>
    ) : this(
        title,
        items,
        RdSignal<RdUsageTargetNavigationData>(RdUsageTargetNavigationData)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageTargetList (")
        printer.indent {
            print("title = "); title.print(printer); println()
            print("items = "); items.print(printer); println()
            print("navigateTo = "); _navigateTo.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdUsageTargetList   {
        return RdUsageTargetList(
            title,
            items.deepClonePolymorphic(),
            _navigateTo.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * @property index Index (RdUsageTarget.index) of the element to navigate to
 * @property requestFocus Whether the editor or view in which the element is opened should be focused
 * #### Generated from [FindUsagesModel.kt]
 */
data class RdUsageTargetNavigationData (
    val index: Int,
    val requestFocus: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdUsageTargetNavigationData> {
        override val _type: KClass<RdUsageTargetNavigationData> = RdUsageTargetNavigationData::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUsageTargetNavigationData  {
            val index = buffer.readInt()
            val requestFocus = buffer.readBool()
            return RdUsageTargetNavigationData(index, requestFocus)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUsageTargetNavigationData)  {
            buffer.writeInt(value.index)
            buffer.writeBool(value.requestFocus)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUsageTargetNavigationData
        
        if (index != other.index) return false
        if (requestFocus != other.requestFocus) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + index.hashCode()
        __r = __r*31 + requestFocus.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUsageTargetNavigationData (")
        printer.indent {
            print("index = "); index.print(printer); println()
            print("requestFocus = "); requestFocus.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
