@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [GotoModel.kt]
 */
class GotoModel private constructor(
    private val _searchPopups: RdMap<GotoKind, SearchPopup>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(SearchItemData)
            serializers.register(GotoResultList)
            serializers.register(GotoKind.marshaller)
            serializers.register(SearchPopup)
            serializers.register(GotoInput)
        }
        
        
        
        
        const val serializationHash = 3301992561388630654L
        
    }
    override val serializersOwner: ISerializersOwner get() = GotoModel
    override val serializationHash: Long get() = GotoModel.serializationHash
    
    //fields
    val searchPopups: IMutableViewableMap<GotoKind, SearchPopup> get() = _searchPopups
    //methods
    //initializer
    init {
        bindableChildren.add("searchPopups" to _searchPopups)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdMap<GotoKind, SearchPopup>(GotoKind.marshaller, SearchPopup)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("GotoModel (")
        printer.indent {
            print("searchPopups = "); _searchPopups.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): GotoModel   {
        return GotoModel(
            _searchPopups.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.gotoModel get() = getOrCreateExtension("gotoModel", ::GotoModel)



/**
 * #### Generated from [GotoModel.kt]
 */
data class GotoInput (
    val text: String,
    val scope: Boolean,
    val requestId: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<GotoInput> {
        override val _type: KClass<GotoInput> = GotoInput::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): GotoInput  {
            val text = buffer.readString()
            val scope = buffer.readBool()
            val requestId = buffer.readInt()
            return GotoInput(text, scope, requestId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: GotoInput)  {
            buffer.writeString(value.text)
            buffer.writeBool(value.scope)
            buffer.writeInt(value.requestId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as GotoInput
        
        if (text != other.text) return false
        if (scope != other.scope) return false
        if (requestId != other.requestId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + scope.hashCode()
        __r = __r*31 + requestId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("GotoInput (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("scope = "); scope.print(printer); println()
            print("requestId = "); requestId.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [GotoModel.kt]
 */
enum class GotoKind {
    Unknown, 
    None, 
    GotoType, 
    GotoSymbol, 
    SearchEverywhere, 
    FileMember, 
    Exception, 
    Snapshot, 
    GotoFile;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<GotoKind>()
        
    }
}


/**
 * #### Generated from [GotoModel.kt]
 */
data class GotoResultList (
    val requestText: String,
    val requestScope: Boolean,
    val items: List<SearchItemData>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<GotoResultList> {
        override val _type: KClass<GotoResultList> = GotoResultList::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): GotoResultList  {
            val requestText = buffer.readString()
            val requestScope = buffer.readBool()
            val items = buffer.readList { SearchItemData.read(ctx, buffer) }
            return GotoResultList(requestText, requestScope, items)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: GotoResultList)  {
            buffer.writeString(value.requestText)
            buffer.writeBool(value.requestScope)
            buffer.writeList(value.items) { v -> SearchItemData.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as GotoResultList
        
        if (requestText != other.requestText) return false
        if (requestScope != other.requestScope) return false
        if (items != other.items) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + requestText.hashCode()
        __r = __r*31 + requestScope.hashCode()
        __r = __r*31 + items.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("GotoResultList (")
        printer.indent {
            print("requestText = "); requestText.print(printer); println()
            print("requestScope = "); requestScope.print(printer); println()
            print("items = "); items.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [GotoModel.kt]
 */
data class SearchItemData (
    val iconId: IconModel,
    val id: Int,
    val shortName: String,
    val fileId: RdDocumentId?,
    val displayText: RichTextModel,
    val glyphText: String?,
    val glyphIconId: IconModel?,
    val matchScore: Int,
    val matchingRanges: List<RdTextRange>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<SearchItemData> {
        override val _type: KClass<SearchItemData> = SearchItemData::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SearchItemData  {
            val iconId = ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel)
            val id = buffer.readInt()
            val shortName = buffer.readString()
            val fileId = buffer.readNullable { ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId) }
            val displayText = RichTextModel.read(ctx, buffer)
            val glyphText = buffer.readNullable { buffer.readString() }
            val glyphIconId = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val matchScore = buffer.readInt()
            val matchingRanges = buffer.readList { RdTextRange.read(ctx, buffer) }
            return SearchItemData(iconId, id, shortName, fileId, displayText, glyphText, glyphIconId, matchScore, matchingRanges)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SearchItemData)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.iconId)
            buffer.writeInt(value.id)
            buffer.writeString(value.shortName)
            buffer.writeNullable(value.fileId) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RichTextModel.write(ctx, buffer, value.displayText)
            buffer.writeNullable(value.glyphText) { buffer.writeString(it) }
            buffer.writeNullable(value.glyphIconId) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeInt(value.matchScore)
            buffer.writeList(value.matchingRanges) { v -> RdTextRange.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SearchItemData
        
        if (iconId != other.iconId) return false
        
        if (shortName != other.shortName) return false
        if (fileId != other.fileId) return false
        
        if (glyphText != other.glyphText) return false
        if (glyphIconId != other.glyphIconId) return false
        
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + iconId.hashCode()
        
        __r = __r*31 + shortName.hashCode()
        __r = __r*31 + if (fileId != null) fileId.hashCode() else 0
        
        __r = __r*31 + if (glyphText != null) glyphText.hashCode() else 0
        __r = __r*31 + if (glyphIconId != null) glyphIconId.hashCode() else 0
        
        
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SearchItemData (")
        printer.indent {
            print("iconId = "); iconId.print(printer); println()
            print("id = "); id.print(printer); println()
            print("shortName = "); shortName.print(printer); println()
            print("fileId = "); fileId.print(printer); println()
            print("displayText = "); displayText.print(printer); println()
            print("glyphText = "); glyphText.print(printer); println()
            print("glyphIconId = "); glyphIconId.print(printer); println()
            print("matchScore = "); matchScore.print(printer); println()
            print("matchingRanges = "); matchingRanges.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [GotoModel.kt]
 */
class SearchPopup private constructor(
    val currentPopupKind: GotoKind,
    private val _itemExecutedSignal: RdSignal<SearchItemData>,
    private val _input: RdOptionalProperty<GotoInput>,
    private val _getItemsTask: RdSignal<GotoResultList>,
    private val _createUsagesSession: RdCall<Unit, Int>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<SearchPopup> {
        override val _type: KClass<SearchPopup> = SearchPopup::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SearchPopup  {
            val _id = RdId.read(buffer)
            val currentPopupKind = buffer.readEnum<GotoKind>()
            val _itemExecutedSignal = RdSignal.read(ctx, buffer, SearchItemData)
            val _input = RdOptionalProperty.read(ctx, buffer, GotoInput)
            val _getItemsTask = RdSignal.read(ctx, buffer, GotoResultList)
            val _createUsagesSession = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, FrameworkMarshallers.Int)
            return SearchPopup(currentPopupKind, _itemExecutedSignal, _input, _getItemsTask, _createUsagesSession).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SearchPopup)  {
            value.rdid.write(buffer)
            buffer.writeEnum(value.currentPopupKind)
            RdSignal.write(ctx, buffer, value._itemExecutedSignal)
            RdOptionalProperty.write(ctx, buffer, value._input)
            RdSignal.write(ctx, buffer, value._getItemsTask)
            RdCall.write(ctx, buffer, value._createUsagesSession)
        }
        
        
    }
    //fields
    val itemExecutedSignal: ISignal<SearchItemData> get() = _itemExecutedSignal
    val input: IOptProperty<GotoInput> get() = _input
    val getItemsTask: IAsyncSignal<GotoResultList> get() = _getItemsTask
    val createUsagesSession: RdCall<Unit, Int> get() = _createUsagesSession
    //methods
    //initializer
    init {
        _input.optimizeNested = true
    }
    
    init {
        _input.async = true
        _getItemsTask.async = true
    }
    
    init {
        bindableChildren.add("itemExecutedSignal" to _itemExecutedSignal)
        bindableChildren.add("input" to _input)
        bindableChildren.add("getItemsTask" to _getItemsTask)
        bindableChildren.add("createUsagesSession" to _createUsagesSession)
    }
    
    //secondary constructor
    constructor(
        currentPopupKind: GotoKind
    ) : this(
        currentPopupKind,
        RdSignal<SearchItemData>(SearchItemData),
        RdOptionalProperty<GotoInput>(GotoInput),
        RdSignal<GotoResultList>(GotoResultList),
        RdCall<Unit, Int>(FrameworkMarshallers.Void, FrameworkMarshallers.Int)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SearchPopup (")
        printer.indent {
            print("currentPopupKind = "); currentPopupKind.print(printer); println()
            print("itemExecutedSignal = "); _itemExecutedSignal.print(printer); println()
            print("input = "); _input.print(printer); println()
            print("getItemsTask = "); _getItemsTask.print(printer); println()
            print("createUsagesSession = "); _createUsagesSession.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): SearchPopup   {
        return SearchPopup(
            currentPopupKind,
            _itemExecutedSignal.deepClonePolymorphic(),
            _input.deepClonePolymorphic(),
            _getItemsTask.deepClonePolymorphic(),
            _createUsagesSession.deepClonePolymorphic()
        )
    }
    //contexts
}
