@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.ide.model.highlighterRegistration

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
class HighlighterRegistrationHostModel private constructor(
    private val _backendReady: RdOptionalProperty<Boolean>,
    private val _registry: RdOptionalProperty<AbstractRegistryModel>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(IdeaEffectType.marshaller)
            serializers.register(SettingsPageDisplayPriority.marshaller)
            serializers.register(IdeaTextAttributes)
            serializers.register(IdeaTextAttributesKey)
            serializers.register(IdeaHighlightInfoType)
            serializers.register(HighlighterKind.marshaller)
            serializers.register(GreedySide.marshaller)
            serializers.register(HighlighterProperties)
            serializers.register(HighlighterRegistrationPack)
            serializers.register(ColorsSchemeEntry)
            serializers.register(ColorsSchemeModel)
            serializers.register(HighlighterData)
            serializers.register(ColorSettingsPageModel)
            serializers.register(HighlightSeverityModel)
            serializers.register(DefaultRegistryModel)
            serializers.register(CachedRegistryModel)
            serializers.register(AbstractRegistryModel_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): HighlighterRegistrationHostModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return HighlighterRegistrationHostModel().apply {
                identify(protocol.identity, RdId.Null.mix("HighlighterRegistrationHostModel"))
                bind(lifetime, protocol, "HighlighterRegistrationHostModel")
            }
        }
        
        
        const val serializationHash = -8806911103745130473L
        
    }
    override val serializersOwner: ISerializersOwner get() = HighlighterRegistrationHostModel
    override val serializationHash: Long get() = HighlighterRegistrationHostModel.serializationHash
    
    //fields
    val backendReady: IOptProperty<Boolean> get() = _backendReady
    val registry: IOptProperty<AbstractRegistryModel> get() = _registry
    //methods
    //initializer
    init {
        _backendReady.optimizeNested = true
    }
    
    init {
        bindableChildren.add("backendReady" to _backendReady)
        bindableChildren.add("registry" to _registry)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<AbstractRegistryModel>(AbstractPolymorphic(AbstractRegistryModel))
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HighlighterRegistrationHostModel (")
        printer.indent {
            print("backendReady = "); _backendReady.print(printer); println()
            print("registry = "); _registry.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): HighlighterRegistrationHostModel   {
        return HighlighterRegistrationHostModel(
            _backendReady.deepClonePolymorphic(),
            _registry.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
abstract class AbstractRegistryModel (
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<AbstractRegistryModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): AbstractRegistryModel  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return AbstractRegistryModel_Unknown(unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class AbstractRegistryModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : AbstractRegistryModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<AbstractRegistryModel_Unknown> {
        override val _type: KClass<AbstractRegistryModel_Unknown> = AbstractRegistryModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): AbstractRegistryModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: AbstractRegistryModel_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("AbstractRegistryModel_Unknown (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): AbstractRegistryModel_Unknown   {
        return AbstractRegistryModel_Unknown(
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
class CachedRegistryModel (
    val cachedAttributesIds: List<String>
) : AbstractRegistryModel (
) {
    //companion
    
    companion object : IMarshaller<CachedRegistryModel> {
        override val _type: KClass<CachedRegistryModel> = CachedRegistryModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CachedRegistryModel  {
            val _id = RdId.read(buffer)
            val cachedAttributesIds = buffer.readList { buffer.readString() }
            return CachedRegistryModel(cachedAttributesIds).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CachedRegistryModel)  {
            value.rdid.write(buffer)
            buffer.writeList(value.cachedAttributesIds) { v -> buffer.writeString(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CachedRegistryModel (")
        printer.indent {
            print("cachedAttributesIds = "); cachedAttributesIds.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CachedRegistryModel   {
        return CachedRegistryModel(
            cachedAttributesIds
        )
    }
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
data class ColorSettingsPageModel (
    val name: String,
    val priority: SettingsPageDisplayPriority,
    val demoText: String,
    val highlighterTags: List<HighlighterData>,
    val inlineElementsTags: List<HighlighterData>,
    val presentableNames: List<HighlighterData>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ColorSettingsPageModel> {
        override val _type: KClass<ColorSettingsPageModel> = ColorSettingsPageModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ColorSettingsPageModel  {
            val name = buffer.readString()
            val priority = buffer.readEnum<SettingsPageDisplayPriority>()
            val demoText = buffer.readString()
            val highlighterTags = buffer.readList { HighlighterData.read(ctx, buffer) }
            val inlineElementsTags = buffer.readList { HighlighterData.read(ctx, buffer) }
            val presentableNames = buffer.readList { HighlighterData.read(ctx, buffer) }
            return ColorSettingsPageModel(name, priority, demoText, highlighterTags, inlineElementsTags, presentableNames)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ColorSettingsPageModel)  {
            buffer.writeString(value.name)
            buffer.writeEnum(value.priority)
            buffer.writeString(value.demoText)
            buffer.writeList(value.highlighterTags) { v -> HighlighterData.write(ctx, buffer, v) }
            buffer.writeList(value.inlineElementsTags) { v -> HighlighterData.write(ctx, buffer, v) }
            buffer.writeList(value.presentableNames) { v -> HighlighterData.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ColorSettingsPageModel
        
        if (name != other.name) return false
        if (priority != other.priority) return false
        if (demoText != other.demoText) return false
        if (highlighterTags != other.highlighterTags) return false
        if (inlineElementsTags != other.inlineElementsTags) return false
        if (presentableNames != other.presentableNames) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + priority.hashCode()
        __r = __r*31 + demoText.hashCode()
        __r = __r*31 + highlighterTags.hashCode()
        __r = __r*31 + inlineElementsTags.hashCode()
        __r = __r*31 + presentableNames.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ColorSettingsPageModel (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("priority = "); priority.print(printer); println()
            print("demoText = "); demoText.print(printer); println()
            print("highlighterTags = "); highlighterTags.print(printer); println()
            print("inlineElementsTags = "); inlineElementsTags.print(printer); println()
            print("presentableNames = "); presentableNames.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
data class ColorsSchemeEntry (
    val attributeId: String,
    val isInherited: Boolean,
    val attributes: IdeaTextAttributes?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ColorsSchemeEntry> {
        override val _type: KClass<ColorsSchemeEntry> = ColorsSchemeEntry::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ColorsSchemeEntry  {
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val isInherited = buffer.readBool()
            val attributes = buffer.readNullable { IdeaTextAttributes.read(ctx, buffer) }
            return ColorsSchemeEntry(attributeId, isInherited, attributes)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ColorsSchemeEntry)  {
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeBool(value.isInherited)
            buffer.writeNullable(value.attributes) { IdeaTextAttributes.write(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ColorsSchemeEntry
        
        if (attributeId != other.attributeId) return false
        if (isInherited != other.isInherited) return false
        if (attributes != other.attributes) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + isInherited.hashCode()
        __r = __r*31 + if (attributes != null) attributes.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ColorsSchemeEntry (")
        printer.indent {
            print("attributeId = "); attributeId.print(printer); println()
            print("isInherited = "); isInherited.print(printer); println()
            print("attributes = "); attributes.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
data class ColorsSchemeModel (
    val name: String,
    val entries: List<ColorsSchemeEntry>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ColorsSchemeModel> {
        override val _type: KClass<ColorsSchemeModel> = ColorsSchemeModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ColorsSchemeModel  {
            val name = buffer.readString()
            val entries = buffer.readList { ColorsSchemeEntry.read(ctx, buffer) }
            return ColorsSchemeModel(name, entries)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ColorsSchemeModel)  {
            buffer.writeString(value.name)
            buffer.writeList(value.entries) { v -> ColorsSchemeEntry.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ColorsSchemeModel
        
        if (name != other.name) return false
        if (entries != other.entries) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + entries.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ColorsSchemeModel (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("entries = "); entries.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
class DefaultRegistryModel private constructor(
    private val _registrationPacks: RdSignal<List<HighlighterRegistrationPack>>,
    private val _colorsScheme: RdSignal<ColorsSchemeModel>,
    private val _colorSettingsPage: RdSignal<ColorSettingsPageModel>,
    private val _severities: RdSignal<List<HighlightSeverityModel>>
) : AbstractRegistryModel (
) {
    //companion
    
    companion object : IMarshaller<DefaultRegistryModel> {
        override val _type: KClass<DefaultRegistryModel> = DefaultRegistryModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DefaultRegistryModel  {
            val _id = RdId.read(buffer)
            val _registrationPacks = RdSignal.read(ctx, buffer, __HighlighterRegistrationPackListSerializer)
            val _colorsScheme = RdSignal.read(ctx, buffer, ColorsSchemeModel)
            val _colorSettingsPage = RdSignal.read(ctx, buffer, ColorSettingsPageModel)
            val _severities = RdSignal.read(ctx, buffer, __HighlightSeverityModelListSerializer)
            return DefaultRegistryModel(_registrationPacks, _colorsScheme, _colorSettingsPage, _severities).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DefaultRegistryModel)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._registrationPacks)
            RdSignal.write(ctx, buffer, value._colorsScheme)
            RdSignal.write(ctx, buffer, value._colorSettingsPage)
            RdSignal.write(ctx, buffer, value._severities)
        }
        
        private val __HighlighterRegistrationPackListSerializer = HighlighterRegistrationPack.list()
        private val __HighlightSeverityModelListSerializer = HighlightSeverityModel.list()
        
    }
    //fields
    val registrationPacks: ISignal<List<HighlighterRegistrationPack>> get() = _registrationPacks
    val colorsScheme: ISignal<ColorsSchemeModel> get() = _colorsScheme
    val colorSettingsPage: ISignal<ColorSettingsPageModel> get() = _colorSettingsPage
    val severities: ISignal<List<HighlightSeverityModel>> get() = _severities
    //methods
    //initializer
    init {
        bindableChildren.add("registrationPacks" to _registrationPacks)
        bindableChildren.add("colorsScheme" to _colorsScheme)
        bindableChildren.add("colorSettingsPage" to _colorSettingsPage)
        bindableChildren.add("severities" to _severities)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdSignal<List<HighlighterRegistrationPack>>(__HighlighterRegistrationPackListSerializer),
        RdSignal<ColorsSchemeModel>(ColorsSchemeModel),
        RdSignal<ColorSettingsPageModel>(ColorSettingsPageModel),
        RdSignal<List<HighlightSeverityModel>>(__HighlightSeverityModelListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DefaultRegistryModel (")
        printer.indent {
            print("registrationPacks = "); _registrationPacks.print(printer); println()
            print("colorsScheme = "); _colorsScheme.print(printer); println()
            print("colorSettingsPage = "); _colorSettingsPage.print(printer); println()
            print("severities = "); _severities.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DefaultRegistryModel   {
        return DefaultRegistryModel(
            _registrationPacks.deepClonePolymorphic(),
            _colorsScheme.deepClonePolymorphic(),
            _colorSettingsPage.deepClonePolymorphic(),
            _severities.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
enum class GreedySide {
    NONE, 
    LEFT, 
    RIGHT, 
    BOTH;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<GreedySide>()
        
    }
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
data class HighlightSeverityModel (
    val id: String,
    val value: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<HighlightSeverityModel> {
        override val _type: KClass<HighlightSeverityModel> = HighlightSeverityModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HighlightSeverityModel  {
            val id = buffer.readString()
            val value = buffer.readInt()
            return HighlightSeverityModel(id, value)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HighlightSeverityModel)  {
            buffer.writeString(value.id)
            buffer.writeInt(value.value)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HighlightSeverityModel
        
        if (id != other.id) return false
        if (value != other.value) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + value.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HighlightSeverityModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("value = "); value.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
data class HighlighterData (
    val `data`: String,
    val attributeId: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<HighlighterData> {
        override val _type: KClass<HighlighterData> = HighlighterData::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HighlighterData  {
            val `data` = buffer.readString()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            return HighlighterData(`data`, attributeId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HighlighterData)  {
            buffer.writeString(value.`data`)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HighlighterData
        
        if (`data` != other.`data`) return false
        if (attributeId != other.attributeId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + `data`.hashCode()
        __r = __r*31 + attributeId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HighlighterData (")
        printer.indent {
            print("data = "); `data`.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
enum class HighlighterKind {
    USUAL, 
    GUTTER_MARK, 
    FOLDING, 
    LINE_MARKER, 
    INLAY;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<HighlighterKind>()
        
    }
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
data class HighlighterProperties (
    val kind: HighlighterKind,
    val isRecyclable: Boolean,
    val greedySide: GreedySide,
    val isVerifiable: Boolean,
    val isBulkUpdatable: Boolean,
    val isVisibleIfFolded: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<HighlighterProperties> {
        override val _type: KClass<HighlighterProperties> = HighlighterProperties::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HighlighterProperties  {
            val kind = buffer.readEnum<HighlighterKind>()
            val isRecyclable = buffer.readBool()
            val greedySide = buffer.readEnum<GreedySide>()
            val isVerifiable = buffer.readBool()
            val isBulkUpdatable = buffer.readBool()
            val isVisibleIfFolded = buffer.readBool()
            return HighlighterProperties(kind, isRecyclable, greedySide, isVerifiable, isBulkUpdatable, isVisibleIfFolded)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HighlighterProperties)  {
            buffer.writeEnum(value.kind)
            buffer.writeBool(value.isRecyclable)
            buffer.writeEnum(value.greedySide)
            buffer.writeBool(value.isVerifiable)
            buffer.writeBool(value.isBulkUpdatable)
            buffer.writeBool(value.isVisibleIfFolded)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HighlighterProperties
        
        if (kind != other.kind) return false
        if (isRecyclable != other.isRecyclable) return false
        if (greedySide != other.greedySide) return false
        if (isVerifiable != other.isVerifiable) return false
        if (isBulkUpdatable != other.isBulkUpdatable) return false
        if (isVisibleIfFolded != other.isVisibleIfFolded) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + kind.hashCode()
        __r = __r*31 + isRecyclable.hashCode()
        __r = __r*31 + greedySide.hashCode()
        __r = __r*31 + isVerifiable.hashCode()
        __r = __r*31 + isBulkUpdatable.hashCode()
        __r = __r*31 + isVisibleIfFolded.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HighlighterProperties (")
        printer.indent {
            print("kind = "); kind.print(printer); println()
            print("isRecyclable = "); isRecyclable.print(printer); println()
            print("greedySide = "); greedySide.print(printer); println()
            print("isVerifiable = "); isVerifiable.print(printer); println()
            print("isBulkUpdatable = "); isBulkUpdatable.print(printer); println()
            print("isVisibleIfFolded = "); isVisibleIfFolded.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
data class HighlighterRegistrationPack (
    val attributeId: String,
    val demoTextTag: String,
    val infoType: IdeaHighlightInfoType?,
    val properties: HighlighterProperties
) : IPrintable {
    //companion
    
    companion object : IMarshaller<HighlighterRegistrationPack> {
        override val _type: KClass<HighlighterRegistrationPack> = HighlighterRegistrationPack::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HighlighterRegistrationPack  {
            val attributeId = buffer.readString()
            val demoTextTag = buffer.readString()
            val infoType = buffer.readNullable { IdeaHighlightInfoType.read(ctx, buffer) }
            val properties = HighlighterProperties.read(ctx, buffer)
            return HighlighterRegistrationPack(attributeId, demoTextTag, infoType, properties)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HighlighterRegistrationPack)  {
            buffer.writeString(value.attributeId)
            buffer.writeString(value.demoTextTag)
            buffer.writeNullable(value.infoType) { IdeaHighlightInfoType.write(ctx, buffer, it) }
            HighlighterProperties.write(ctx, buffer, value.properties)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HighlighterRegistrationPack
        
        if (attributeId != other.attributeId) return false
        if (demoTextTag != other.demoTextTag) return false
        if (infoType != other.infoType) return false
        if (properties != other.properties) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + demoTextTag.hashCode()
        __r = __r*31 + if (infoType != null) infoType.hashCode() else 0
        __r = __r*31 + properties.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HighlighterRegistrationPack (")
        printer.indent {
            print("attributeId = "); attributeId.print(printer); println()
            print("demoTextTag = "); demoTextTag.print(printer); println()
            print("infoType = "); infoType.print(printer); println()
            print("properties = "); properties.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
enum class IdeaEffectType {
    LINE_UNDERSCORE, 
    WAVE_UNDERSCORE, 
    BOXED, 
    STRIKEOUT, 
    BOLD_LINE_UNDERSCORE, 
    BOLD_DOTTED_LINE;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<IdeaEffectType>()
        
    }
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
data class IdeaHighlightInfoType (
    val severityId: String,
    val attributesKey: IdeaTextAttributesKey,
    val needsUpdateOnTyping: Boolean = false
) : IPrintable {
    //companion
    
    companion object : IMarshaller<IdeaHighlightInfoType> {
        override val _type: KClass<IdeaHighlightInfoType> = IdeaHighlightInfoType::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): IdeaHighlightInfoType  {
            val severityId = buffer.readString()
            val attributesKey = IdeaTextAttributesKey.read(ctx, buffer)
            val needsUpdateOnTyping = buffer.readBool()
            return IdeaHighlightInfoType(severityId, attributesKey, needsUpdateOnTyping)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: IdeaHighlightInfoType)  {
            buffer.writeString(value.severityId)
            IdeaTextAttributesKey.write(ctx, buffer, value.attributesKey)
            buffer.writeBool(value.needsUpdateOnTyping)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as IdeaHighlightInfoType
        
        if (severityId != other.severityId) return false
        if (attributesKey != other.attributesKey) return false
        if (needsUpdateOnTyping != other.needsUpdateOnTyping) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + severityId.hashCode()
        __r = __r*31 + attributesKey.hashCode()
        __r = __r*31 + needsUpdateOnTyping.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("IdeaHighlightInfoType (")
        printer.indent {
            print("severityId = "); severityId.print(printer); println()
            print("attributesKey = "); attributesKey.print(printer); println()
            print("needsUpdateOnTyping = "); needsUpdateOnTyping.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
data class IdeaTextAttributes (
    val foregroundColor: com.jetbrains.rd.ide.model.RgbColor?,
    val backgroundColor: com.jetbrains.rd.ide.model.RgbColor?,
    val effectColor: com.jetbrains.rd.ide.model.RgbColor?,
    val errorStripeColor: com.jetbrains.rd.ide.model.RgbColor?,
    val effectType: IdeaEffectType,
    val fontType: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<IdeaTextAttributes> {
        override val _type: KClass<IdeaTextAttributes> = IdeaTextAttributes::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): IdeaTextAttributes  {
            val foregroundColor = buffer.readNullable { com.jetbrains.rd.ide.model.RgbColor.read(ctx, buffer) }
            val backgroundColor = buffer.readNullable { com.jetbrains.rd.ide.model.RgbColor.read(ctx, buffer) }
            val effectColor = buffer.readNullable { com.jetbrains.rd.ide.model.RgbColor.read(ctx, buffer) }
            val errorStripeColor = buffer.readNullable { com.jetbrains.rd.ide.model.RgbColor.read(ctx, buffer) }
            val effectType = buffer.readEnum<IdeaEffectType>()
            val fontType = buffer.readInt()
            return IdeaTextAttributes(foregroundColor, backgroundColor, effectColor, errorStripeColor, effectType, fontType)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: IdeaTextAttributes)  {
            buffer.writeNullable(value.foregroundColor) { com.jetbrains.rd.ide.model.RgbColor.write(ctx, buffer, it) }
            buffer.writeNullable(value.backgroundColor) { com.jetbrains.rd.ide.model.RgbColor.write(ctx, buffer, it) }
            buffer.writeNullable(value.effectColor) { com.jetbrains.rd.ide.model.RgbColor.write(ctx, buffer, it) }
            buffer.writeNullable(value.errorStripeColor) { com.jetbrains.rd.ide.model.RgbColor.write(ctx, buffer, it) }
            buffer.writeEnum(value.effectType)
            buffer.writeInt(value.fontType)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as IdeaTextAttributes
        
        if (foregroundColor != other.foregroundColor) return false
        if (backgroundColor != other.backgroundColor) return false
        if (effectColor != other.effectColor) return false
        if (errorStripeColor != other.errorStripeColor) return false
        if (effectType != other.effectType) return false
        if (fontType != other.fontType) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (foregroundColor != null) foregroundColor.hashCode() else 0
        __r = __r*31 + if (backgroundColor != null) backgroundColor.hashCode() else 0
        __r = __r*31 + if (effectColor != null) effectColor.hashCode() else 0
        __r = __r*31 + if (errorStripeColor != null) errorStripeColor.hashCode() else 0
        __r = __r*31 + effectType.hashCode()
        __r = __r*31 + fontType.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("IdeaTextAttributes (")
        printer.indent {
            print("foregroundColor = "); foregroundColor.print(printer); println()
            print("backgroundColor = "); backgroundColor.print(printer); println()
            print("effectColor = "); effectColor.print(printer); println()
            print("errorStripeColor = "); errorStripeColor.print(printer); println()
            print("effectType = "); effectType.print(printer); println()
            print("fontType = "); fontType.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
data class IdeaTextAttributesKey (
    val externalName: String,
    val fallback: String?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<IdeaTextAttributesKey> {
        override val _type: KClass<IdeaTextAttributesKey> = IdeaTextAttributesKey::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): IdeaTextAttributesKey  {
            val externalName = buffer.readString()
            val fallback = buffer.readNullable { buffer.readString() }
            return IdeaTextAttributesKey(externalName, fallback)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: IdeaTextAttributesKey)  {
            buffer.writeString(value.externalName)
            buffer.writeNullable(value.fallback) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as IdeaTextAttributesKey
        
        if (externalName != other.externalName) return false
        if (fallback != other.fallback) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + externalName.hashCode()
        __r = __r*31 + if (fallback != null) fallback.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("IdeaTextAttributesKey (")
        printer.indent {
            print("externalName = "); externalName.print(printer); println()
            print("fallback = "); fallback.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [HighlighterRegistryModel.kt]
 */
enum class SettingsPageDisplayPriority {
    GENERAL_SETTINGS, 
    FONT_SETTINGS, 
    COMMON_SETTINGS, 
    CODE_SETTINGS, 
    KEY_LANGUAGE_SETTINGS, 
    LANGUAGE_SETTINGS, 
    OTHER_SETTINGS;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<SettingsPageDisplayPriority>()
        
    }
}
