@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CodeInsightModels.kt]
 */
class HyperlinkHighlightingModel private constructor(
    private val _getElementRange: RdCall<HyperlinkHighlightingArgs, HyperlinkHighlightingResultBase?>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(BrowseMode.marshaller)
            serializers.register(HyperlinkHighlightingArgs)
            serializers.register(HyperlinkHighlightingDumpModeResult)
            serializers.register(HyperlinkHighlightingResult)
            serializers.register(HyperlinkHighlightingResultBase_Unknown)
        }
        
        
        
        private val __HyperlinkHighlightingResultBaseNullableSerializer = AbstractPolymorphic(HyperlinkHighlightingResultBase).nullable()
        
        const val serializationHash = 3743574218414949522L
        
    }
    override val serializersOwner: ISerializersOwner get() = HyperlinkHighlightingModel
    override val serializationHash: Long get() = HyperlinkHighlightingModel.serializationHash
    
    //fields
    val getElementRange: RdCall<HyperlinkHighlightingArgs, HyperlinkHighlightingResultBase?> get() = _getElementRange
    //methods
    //initializer
    init {
        bindableChildren.add("getElementRange" to _getElementRange)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdCall<HyperlinkHighlightingArgs, HyperlinkHighlightingResultBase?>(HyperlinkHighlightingArgs, __HyperlinkHighlightingResultBaseNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HyperlinkHighlightingModel (")
        printer.indent {
            print("getElementRange = "); _getElementRange.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): HyperlinkHighlightingModel   {
        return HyperlinkHighlightingModel(
            _getElementRange.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.hyperlinkHighlightingModel get() = getOrCreateExtension("hyperlinkHighlightingModel", ::HyperlinkHighlightingModel)



/**
 * #### Generated from [CodeInsightModels.kt]
 */
enum class BrowseMode {
    None, 
    Declaration, 
    TypeDeclaration, 
    Implementation;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BrowseMode>()
        
    }
}


/**
 * #### Generated from [CodeInsightModels.kt]
 */
data class HyperlinkHighlightingArgs (
    val editorId: TextControlId,
    val offset: Int,
    val mode: BrowseMode
) : IPrintable {
    //companion
    
    companion object : IMarshaller<HyperlinkHighlightingArgs> {
        override val _type: KClass<HyperlinkHighlightingArgs> = HyperlinkHighlightingArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HyperlinkHighlightingArgs  {
            val editorId = TextControlId.read(ctx, buffer)
            val offset = buffer.readInt()
            val mode = buffer.readEnum<BrowseMode>()
            return HyperlinkHighlightingArgs(editorId, offset, mode)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HyperlinkHighlightingArgs)  {
            TextControlId.write(ctx, buffer, value.editorId)
            buffer.writeInt(value.offset)
            buffer.writeEnum(value.mode)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HyperlinkHighlightingArgs
        
        if (editorId != other.editorId) return false
        if (offset != other.offset) return false
        if (mode != other.mode) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + editorId.hashCode()
        __r = __r*31 + offset.hashCode()
        __r = __r*31 + mode.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HyperlinkHighlightingArgs (")
        printer.indent {
            print("editorId = "); editorId.print(printer); println()
            print("offset = "); offset.print(printer); println()
            print("mode = "); mode.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeInsightModels.kt]
 */
class HyperlinkHighlightingDumpModeResult (
    val message: String
) : HyperlinkHighlightingResultBase (
) {
    //companion
    
    companion object : IMarshaller<HyperlinkHighlightingDumpModeResult> {
        override val _type: KClass<HyperlinkHighlightingDumpModeResult> = HyperlinkHighlightingDumpModeResult::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HyperlinkHighlightingDumpModeResult  {
            val message = buffer.readString()
            return HyperlinkHighlightingDumpModeResult(message)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HyperlinkHighlightingDumpModeResult)  {
            buffer.writeString(value.message)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HyperlinkHighlightingDumpModeResult
        
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + message.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HyperlinkHighlightingDumpModeResult (")
        printer.indent {
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeInsightModels.kt]
 */
class HyperlinkHighlightingResult (
    val textRange: RdTextRange,
    val docInfo: String
) : HyperlinkHighlightingResultBase (
) {
    //companion
    
    companion object : IMarshaller<HyperlinkHighlightingResult> {
        override val _type: KClass<HyperlinkHighlightingResult> = HyperlinkHighlightingResult::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HyperlinkHighlightingResult  {
            val textRange = RdTextRange.read(ctx, buffer)
            val docInfo = buffer.readString()
            return HyperlinkHighlightingResult(textRange, docInfo)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HyperlinkHighlightingResult)  {
            RdTextRange.write(ctx, buffer, value.textRange)
            buffer.writeString(value.docInfo)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HyperlinkHighlightingResult
        
        if (textRange != other.textRange) return false
        if (docInfo != other.docInfo) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + textRange.hashCode()
        __r = __r*31 + docInfo.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HyperlinkHighlightingResult (")
        printer.indent {
            print("textRange = "); textRange.print(printer); println()
            print("docInfo = "); docInfo.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeInsightModels.kt]
 */
abstract class HyperlinkHighlightingResultBase (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<HyperlinkHighlightingResultBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): HyperlinkHighlightingResultBase  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return HyperlinkHighlightingResultBase_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class HyperlinkHighlightingResultBase_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : HyperlinkHighlightingResultBase (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<HyperlinkHighlightingResultBase_Unknown> {
        override val _type: KClass<HyperlinkHighlightingResultBase_Unknown> = HyperlinkHighlightingResultBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HyperlinkHighlightingResultBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HyperlinkHighlightingResultBase_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HyperlinkHighlightingResultBase_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HyperlinkHighlightingResultBase_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
