@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [LiveTemplateModel.kt]
 */
class LiveTemplateModel private constructor(
    private val _executeTemplate: RdSignal<LiveTemplateInitialDataModel>,
    private val _requestLookupItems: RdCall<LiveTemplateSnapshotModel, LiveTemplateLookupModel>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(LiveTemplateMacroModel)
            serializers.register(LiveTemplateVariableModel)
            serializers.register(LiveTemplateInitialDataModel)
            serializers.register(LiveTemplateSnapshotModel)
            serializers.register(LiveTemplateLookupModel)
            serializers.register(TemplateHint.marshaller)
            serializers.register(LiveTemplateVariableRangeModel)
            serializers.register(LiveTemplateVariableDependentRangeModel)
            serializers.register(RdLiveTemplateMacroArg)
            serializers.register(LiveTemplateLookupItemModel)
        }
        
        
        
        
        const val serializationHash = -501626618933868998L
        
    }
    override val serializersOwner: ISerializersOwner get() = LiveTemplateModel
    override val serializationHash: Long get() = LiveTemplateModel.serializationHash
    
    //fields
    val executeTemplate: ISignal<LiveTemplateInitialDataModel> get() = _executeTemplate
    val requestLookupItems: RdCall<LiveTemplateSnapshotModel, LiveTemplateLookupModel> get() = _requestLookupItems
    //methods
    //initializer
    init {
        bindableChildren.add("executeTemplate" to _executeTemplate)
        bindableChildren.add("requestLookupItems" to _requestLookupItems)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdSignal<LiveTemplateInitialDataModel>(LiveTemplateInitialDataModel),
        RdCall<LiveTemplateSnapshotModel, LiveTemplateLookupModel>(LiveTemplateSnapshotModel, LiveTemplateLookupModel)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LiveTemplateModel (")
        printer.indent {
            print("executeTemplate = "); _executeTemplate.print(printer); println()
            print("requestLookupItems = "); _requestLookupItems.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): LiveTemplateModel   {
        return LiveTemplateModel(
            _executeTemplate.deepClonePolymorphic(),
            _requestLookupItems.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.liveTemplateHost get() = getOrCreateExtension("liveTemplateModel", ::LiveTemplateModel)



/**
 * #### Generated from [LiveTemplateModel.kt]
 */
data class LiveTemplateInitialDataModel (
    val textControl: TextControlId,
    val documentVersion: com.jetbrains.rd.rdtext.intrinsics.TextBufferVersion,
    val variables: List<LiveTemplateVariableModel>,
    val endOffset: Int,
    val templateHint: TemplateHint
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LiveTemplateInitialDataModel> {
        override val _type: KClass<LiveTemplateInitialDataModel> = LiveTemplateInitialDataModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LiveTemplateInitialDataModel  {
            val textControl = TextControlId.read(ctx, buffer)
            val documentVersion = com.jetbrains.rd.rdtext.intrinsics.TextBufferVersionMarshaller.read(ctx, buffer)
            val variables = buffer.readList { LiveTemplateVariableModel.read(ctx, buffer) }
            val endOffset = buffer.readInt()
            val templateHint = buffer.readEnum<TemplateHint>()
            return LiveTemplateInitialDataModel(textControl, documentVersion, variables, endOffset, templateHint)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LiveTemplateInitialDataModel)  {
            TextControlId.write(ctx, buffer, value.textControl)
            com.jetbrains.rd.rdtext.intrinsics.TextBufferVersionMarshaller.write(ctx,buffer, value.documentVersion)
            buffer.writeList(value.variables) { v -> LiveTemplateVariableModel.write(ctx, buffer, v) }
            buffer.writeInt(value.endOffset)
            buffer.writeEnum(value.templateHint)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LiveTemplateInitialDataModel
        
        if (textControl != other.textControl) return false
        if (documentVersion != other.documentVersion) return false
        if (variables != other.variables) return false
        if (endOffset != other.endOffset) return false
        if (templateHint != other.templateHint) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + textControl.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + variables.hashCode()
        __r = __r*31 + endOffset.hashCode()
        __r = __r*31 + templateHint.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LiveTemplateInitialDataModel (")
        printer.indent {
            print("textControl = "); textControl.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("variables = "); variables.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
            print("templateHint = "); templateHint.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [LiveTemplateModel.kt]
 */
data class LiveTemplateLookupItemModel (
    val displayName: String,
    val icon: IconModel?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LiveTemplateLookupItemModel> {
        override val _type: KClass<LiveTemplateLookupItemModel> = LiveTemplateLookupItemModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LiveTemplateLookupItemModel  {
            val displayName = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            return LiveTemplateLookupItemModel(displayName, icon)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LiveTemplateLookupItemModel)  {
            buffer.writeString(value.displayName)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LiveTemplateLookupItemModel
        
        if (displayName != other.displayName) return false
        if (icon != other.icon) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + displayName.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LiveTemplateLookupItemModel (")
        printer.indent {
            print("displayName = "); displayName.print(printer); println()
            print("icon = "); icon.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [LiveTemplateModel.kt]
 */
data class LiveTemplateLookupModel (
    val items: List<LiveTemplateLookupItemModel>,
    val focusBehaviour: FocusBehaviour
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LiveTemplateLookupModel> {
        override val _type: KClass<LiveTemplateLookupModel> = LiveTemplateLookupModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LiveTemplateLookupModel  {
            val items = buffer.readList { LiveTemplateLookupItemModel.read(ctx, buffer) }
            val focusBehaviour = buffer.readEnum<FocusBehaviour>()
            return LiveTemplateLookupModel(items, focusBehaviour)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LiveTemplateLookupModel)  {
            buffer.writeList(value.items) { v -> LiveTemplateLookupItemModel.write(ctx, buffer, v) }
            buffer.writeEnum(value.focusBehaviour)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LiveTemplateLookupModel
        
        if (items != other.items) return false
        if (focusBehaviour != other.focusBehaviour) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + items.hashCode()
        __r = __r*31 + focusBehaviour.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LiveTemplateLookupModel (")
        printer.indent {
            print("items = "); items.print(printer); println()
            print("focusBehaviour = "); focusBehaviour.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [LiveTemplateModel.kt]
 */
data class LiveTemplateMacroModel (
    val name: String,
    val args: List<RdLiveTemplateMacroArg>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LiveTemplateMacroModel> {
        override val _type: KClass<LiveTemplateMacroModel> = LiveTemplateMacroModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LiveTemplateMacroModel  {
            val name = buffer.readString()
            val args = buffer.readList { RdLiveTemplateMacroArg.read(ctx, buffer) }
            return LiveTemplateMacroModel(name, args)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LiveTemplateMacroModel)  {
            buffer.writeString(value.name)
            buffer.writeList(value.args) { v -> RdLiveTemplateMacroArg.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LiveTemplateMacroModel
        
        if (name != other.name) return false
        if (args != other.args) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + args.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LiveTemplateMacroModel (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("args = "); args.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [LiveTemplateModel.kt]
 */
data class LiveTemplateSnapshotModel (
    val textControl: TextControlId,
    val caretOffset: Int,
    val variables: List<LiveTemplateVariableModel>,
    val currentVariable: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LiveTemplateSnapshotModel> {
        override val _type: KClass<LiveTemplateSnapshotModel> = LiveTemplateSnapshotModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LiveTemplateSnapshotModel  {
            val textControl = TextControlId.read(ctx, buffer)
            val caretOffset = buffer.readInt()
            val variables = buffer.readList { LiveTemplateVariableModel.read(ctx, buffer) }
            val currentVariable = buffer.readInt()
            return LiveTemplateSnapshotModel(textControl, caretOffset, variables, currentVariable)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LiveTemplateSnapshotModel)  {
            TextControlId.write(ctx, buffer, value.textControl)
            buffer.writeInt(value.caretOffset)
            buffer.writeList(value.variables) { v -> LiveTemplateVariableModel.write(ctx, buffer, v) }
            buffer.writeInt(value.currentVariable)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LiveTemplateSnapshotModel
        
        if (textControl != other.textControl) return false
        if (caretOffset != other.caretOffset) return false
        if (variables != other.variables) return false
        if (currentVariable != other.currentVariable) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + textControl.hashCode()
        __r = __r*31 + caretOffset.hashCode()
        __r = __r*31 + variables.hashCode()
        __r = __r*31 + currentVariable.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LiveTemplateSnapshotModel (")
        printer.indent {
            print("textControl = "); textControl.print(printer); println()
            print("caretOffset = "); caretOffset.print(printer); println()
            print("variables = "); variables.print(printer); println()
            print("currentVariable = "); currentVariable.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [LiveTemplateModel.kt]
 */
data class LiveTemplateVariableDependentRangeModel (
    val id: TextControlId,
    val startOffset: Int,
    val endOffset: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LiveTemplateVariableDependentRangeModel> {
        override val _type: KClass<LiveTemplateVariableDependentRangeModel> = LiveTemplateVariableDependentRangeModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LiveTemplateVariableDependentRangeModel  {
            val id = TextControlId.read(ctx, buffer)
            val startOffset = buffer.readInt()
            val endOffset = buffer.readInt()
            return LiveTemplateVariableDependentRangeModel(id, startOffset, endOffset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LiveTemplateVariableDependentRangeModel)  {
            TextControlId.write(ctx, buffer, value.id)
            buffer.writeInt(value.startOffset)
            buffer.writeInt(value.endOffset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LiveTemplateVariableDependentRangeModel
        
        if (id != other.id) return false
        if (startOffset != other.startOffset) return false
        if (endOffset != other.endOffset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + startOffset.hashCode()
        __r = __r*31 + endOffset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LiveTemplateVariableDependentRangeModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("startOffset = "); startOffset.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [LiveTemplateModel.kt]
 */
data class LiveTemplateVariableModel (
    val name: String,
    val currentValue: String,
    val isStopAt: Boolean,
    val isSkipOnStart: Boolean,
    val isDiscardCompletion: Boolean,
    val ranges: List<LiveTemplateVariableRangeModel>,
    val dependentRanges: List<LiveTemplateVariableDependentRangeModel>,
    val macro: LiveTemplateMacroModel,
    val lookupItems: List<String>,
    val focusBehaviour: FocusBehaviour
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LiveTemplateVariableModel> {
        override val _type: KClass<LiveTemplateVariableModel> = LiveTemplateVariableModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LiveTemplateVariableModel  {
            val name = buffer.readString()
            val currentValue = buffer.readString()
            val isStopAt = buffer.readBool()
            val isSkipOnStart = buffer.readBool()
            val isDiscardCompletion = buffer.readBool()
            val ranges = buffer.readList { LiveTemplateVariableRangeModel.read(ctx, buffer) }
            val dependentRanges = buffer.readList { LiveTemplateVariableDependentRangeModel.read(ctx, buffer) }
            val macro = LiveTemplateMacroModel.read(ctx, buffer)
            val lookupItems = buffer.readList { buffer.readString() }
            val focusBehaviour = buffer.readEnum<FocusBehaviour>()
            return LiveTemplateVariableModel(name, currentValue, isStopAt, isSkipOnStart, isDiscardCompletion, ranges, dependentRanges, macro, lookupItems, focusBehaviour)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LiveTemplateVariableModel)  {
            buffer.writeString(value.name)
            buffer.writeString(value.currentValue)
            buffer.writeBool(value.isStopAt)
            buffer.writeBool(value.isSkipOnStart)
            buffer.writeBool(value.isDiscardCompletion)
            buffer.writeList(value.ranges) { v -> LiveTemplateVariableRangeModel.write(ctx, buffer, v) }
            buffer.writeList(value.dependentRanges) { v -> LiveTemplateVariableDependentRangeModel.write(ctx, buffer, v) }
            LiveTemplateMacroModel.write(ctx, buffer, value.macro)
            buffer.writeList(value.lookupItems) { v -> buffer.writeString(v) }
            buffer.writeEnum(value.focusBehaviour)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LiveTemplateVariableModel
        
        if (name != other.name) return false
        if (currentValue != other.currentValue) return false
        if (isStopAt != other.isStopAt) return false
        if (isSkipOnStart != other.isSkipOnStart) return false
        if (isDiscardCompletion != other.isDiscardCompletion) return false
        if (ranges != other.ranges) return false
        if (dependentRanges != other.dependentRanges) return false
        if (macro != other.macro) return false
        if (lookupItems != other.lookupItems) return false
        if (focusBehaviour != other.focusBehaviour) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + currentValue.hashCode()
        __r = __r*31 + isStopAt.hashCode()
        __r = __r*31 + isSkipOnStart.hashCode()
        __r = __r*31 + isDiscardCompletion.hashCode()
        __r = __r*31 + ranges.hashCode()
        __r = __r*31 + dependentRanges.hashCode()
        __r = __r*31 + macro.hashCode()
        __r = __r*31 + lookupItems.hashCode()
        __r = __r*31 + focusBehaviour.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LiveTemplateVariableModel (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("currentValue = "); currentValue.print(printer); println()
            print("isStopAt = "); isStopAt.print(printer); println()
            print("isSkipOnStart = "); isSkipOnStart.print(printer); println()
            print("isDiscardCompletion = "); isDiscardCompletion.print(printer); println()
            print("ranges = "); ranges.print(printer); println()
            print("dependentRanges = "); dependentRanges.print(printer); println()
            print("macro = "); macro.print(printer); println()
            print("lookupItems = "); lookupItems.print(printer); println()
            print("focusBehaviour = "); focusBehaviour.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [LiveTemplateModel.kt]
 */
data class LiveTemplateVariableRangeModel (
    val startOffset: Int,
    val endOffset: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LiveTemplateVariableRangeModel> {
        override val _type: KClass<LiveTemplateVariableRangeModel> = LiveTemplateVariableRangeModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LiveTemplateVariableRangeModel  {
            val startOffset = buffer.readInt()
            val endOffset = buffer.readInt()
            return LiveTemplateVariableRangeModel(startOffset, endOffset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LiveTemplateVariableRangeModel)  {
            buffer.writeInt(value.startOffset)
            buffer.writeInt(value.endOffset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LiveTemplateVariableRangeModel
        
        if (startOffset != other.startOffset) return false
        if (endOffset != other.endOffset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + startOffset.hashCode()
        __r = __r*31 + endOffset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LiveTemplateVariableRangeModel (")
        printer.indent {
            print("startOffset = "); startOffset.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [LiveTemplateModel.kt]
 */
data class RdLiveTemplateMacroArg (
    val type: String,
    val value: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdLiveTemplateMacroArg> {
        override val _type: KClass<RdLiveTemplateMacroArg> = RdLiveTemplateMacroArg::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdLiveTemplateMacroArg  {
            val type = buffer.readString()
            val value = buffer.readString()
            return RdLiveTemplateMacroArg(type, value)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdLiveTemplateMacroArg)  {
            buffer.writeString(value.type)
            buffer.writeString(value.value)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdLiveTemplateMacroArg
        
        if (type != other.type) return false
        if (value != other.value) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + type.hashCode()
        __r = __r*31 + value.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdLiveTemplateMacroArg (")
        printer.indent {
            print("type = "); type.print(printer); println()
            print("value = "); value.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [LiveTemplateModel.kt]
 */
enum class TemplateHint {
    Rename, 
    Other;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<TemplateHint>()
        
    }
}
