@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [LocalChangesModel.kt]
 */
class LocalChangesModel private constructor(
    private val _windows: RdList<LocalChangesWindowModel>,
    private val _isAvailable: RdOptionalProperty<Boolean>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RdLocalChangesItem)
            serializers.register(LocalChangesTreeModel)
            serializers.register(LocalChangesWindowModel)
            serializers.register(LocalChangesTimestampModel)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): LocalChangesModel  {
            IdeRoot.register(protocol.serializers)
            
            return LocalChangesModel().apply {
                identify(protocol.identity, RdId.Null.mix("LocalChangesModel"))
                bind(lifetime, protocol, "LocalChangesModel")
            }
        }
        
        
        const val serializationHash = -1438767822743990928L
        
    }
    override val serializersOwner: ISerializersOwner get() = LocalChangesModel
    override val serializationHash: Long get() = LocalChangesModel.serializationHash
    
    //fields
    val windows: IMutableViewableList<LocalChangesWindowModel> get() = _windows
    val isAvailable: IOptProperty<Boolean> get() = _isAvailable
    //methods
    //initializer
    init {
        _isAvailable.optimizeNested = true
    }
    
    init {
        bindableChildren.add("windows" to _windows)
        bindableChildren.add("isAvailable" to _isAvailable)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdList<LocalChangesWindowModel>(LocalChangesWindowModel),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LocalChangesModel (")
        printer.indent {
            print("windows = "); _windows.print(printer); println()
            print("isAvailable = "); _isAvailable.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): LocalChangesModel   {
        return LocalChangesModel(
            _windows.deepClonePolymorphic(),
            _isAvailable.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [LocalChangesModel.kt]
 */
class LocalChangesTimestampModel (
    val windowId: Int,
    val selectedNodeIds: List<Int>
) : UpgradableActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<LocalChangesTimestampModel> {
        override val _type: KClass<LocalChangesTimestampModel> = LocalChangesTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LocalChangesTimestampModel  {
            val windowId = buffer.readInt()
            val selectedNodeIds = buffer.readList { buffer.readInt() }
            return LocalChangesTimestampModel(windowId, selectedNodeIds)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LocalChangesTimestampModel)  {
            buffer.writeInt(value.windowId)
            buffer.writeList(value.selectedNodeIds) { v -> buffer.writeInt(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LocalChangesTimestampModel
        
        if (windowId != other.windowId) return false
        if (selectedNodeIds != other.selectedNodeIds) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + windowId.hashCode()
        __r = __r*31 + selectedNodeIds.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LocalChangesTimestampModel (")
        printer.indent {
            print("windowId = "); windowId.print(printer); println()
            print("selectedNodeIds = "); selectedNodeIds.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [LocalChangesModel.kt]
 */
class LocalChangesTreeModel private constructor(
    private val _roots: RdOptionalProperty<List<Int>>,
    private val _nodes: RdMap<Int, RdLocalChangesItem>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<LocalChangesTreeModel> {
        override val _type: KClass<LocalChangesTreeModel> = LocalChangesTreeModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LocalChangesTreeModel  {
            val _id = RdId.read(buffer)
            val _roots = RdOptionalProperty.read(ctx, buffer, __IntListSerializer)
            val _nodes = RdMap.read(ctx, buffer, FrameworkMarshallers.Int, RdLocalChangesItem)
            return LocalChangesTreeModel(_roots, _nodes).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LocalChangesTreeModel)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._roots)
            RdMap.write(ctx, buffer, value._nodes)
        }
        
        private val __IntListSerializer = FrameworkMarshallers.Int.list()
        
    }
    //fields
    val roots: IOptProperty<List<Int>> get() = _roots
    val nodes: IMutableViewableMap<Int, RdLocalChangesItem> get() = _nodes
    //methods
    //initializer
    init {
        _roots.optimizeNested = true
        _nodes.optimizeNested = true
    }
    
    init {
        bindableChildren.add("roots" to _roots)
        bindableChildren.add("nodes" to _nodes)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<List<Int>>(__IntListSerializer),
        RdMap<Int, RdLocalChangesItem>(FrameworkMarshallers.Int, RdLocalChangesItem)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LocalChangesTreeModel (")
        printer.indent {
            print("roots = "); _roots.print(printer); println()
            print("nodes = "); _nodes.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): LocalChangesTreeModel   {
        return LocalChangesTreeModel(
            _roots.deepClonePolymorphic(),
            _nodes.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [LocalChangesModel.kt]
 */
class LocalChangesWindowModel private constructor(
    val windowId: Int,
    val tree: LocalChangesTreeModel,
    private val _showDiff: RdCall<Int, Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<LocalChangesWindowModel> {
        override val _type: KClass<LocalChangesWindowModel> = LocalChangesWindowModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LocalChangesWindowModel  {
            val _id = RdId.read(buffer)
            val windowId = buffer.readInt()
            val tree = LocalChangesTreeModel.read(ctx, buffer)
            val _showDiff = RdCall.read(ctx, buffer, FrameworkMarshallers.Int, FrameworkMarshallers.Void)
            return LocalChangesWindowModel(windowId, tree, _showDiff).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LocalChangesWindowModel)  {
            value.rdid.write(buffer)
            buffer.writeInt(value.windowId)
            LocalChangesTreeModel.write(ctx, buffer, value.tree)
            RdCall.write(ctx, buffer, value._showDiff)
        }
        
        
    }
    //fields
    val showDiff: RdCall<Int, Unit> get() = _showDiff
    //methods
    //initializer
    init {
        bindableChildren.add("tree" to tree)
        bindableChildren.add("showDiff" to _showDiff)
    }
    
    //secondary constructor
    constructor(
        windowId: Int
    ) : this(
        windowId,
        LocalChangesTreeModel(),
        RdCall<Int, Unit>(FrameworkMarshallers.Int, FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LocalChangesWindowModel (")
        printer.indent {
            print("windowId = "); windowId.print(printer); println()
            print("tree = "); tree.print(printer); println()
            print("showDiff = "); _showDiff.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): LocalChangesWindowModel   {
        return LocalChangesWindowModel(
            windowId,
            tree.deepClonePolymorphic(),
            _showDiff.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [LocalChangesModel.kt]
 */
data class RdLocalChangesItem (
    val children: List<Int>,
    val text: List<RdTextChunk>,
    val icon: IconModel?,
    val isHelperNode: Boolean,
    val backgroundColor: Int?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdLocalChangesItem> {
        override val _type: KClass<RdLocalChangesItem> = RdLocalChangesItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdLocalChangesItem  {
            val children = buffer.readList { buffer.readInt() }
            val text = buffer.readList { RdTextChunk.read(ctx, buffer) }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val isHelperNode = buffer.readBool()
            val backgroundColor = buffer.readNullable { buffer.readInt() }
            return RdLocalChangesItem(children, text, icon, isHelperNode, backgroundColor)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdLocalChangesItem)  {
            buffer.writeList(value.children) { v -> buffer.writeInt(v) }
            buffer.writeList(value.text) { v -> RdTextChunk.write(ctx, buffer, v) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeBool(value.isHelperNode)
            buffer.writeNullable(value.backgroundColor) { buffer.writeInt(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdLocalChangesItem
        
        if (children != other.children) return false
        if (text != other.text) return false
        if (icon != other.icon) return false
        if (isHelperNode != other.isHelperNode) return false
        if (backgroundColor != other.backgroundColor) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + children.hashCode()
        __r = __r*31 + text.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + isHelperNode.hashCode()
        __r = __r*31 + if (backgroundColor != null) backgroundColor.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdLocalChangesItem (")
        printer.indent {
            print("children = "); children.print(printer); println()
            print("text = "); text.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("isHelperNode = "); isHelperNode.print(printer); println()
            print("backgroundColor = "); backgroundColor.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
