@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.ide.model.loggers

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [LoggerModel.kt]
 */
class LoggerModel private constructor(
    private val _message: RdSignal<LogEntry>,
    private val _testLogDir: RdOptionalProperty<String>,
    private val _traceCategories: RdOptionalProperty<List<String>>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(LogEntry)
            serializers.register(LogEntryType.marshaller)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): LoggerModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return LoggerModel().apply {
                identify(protocol.identity, RdId.Null.mix("LoggerModel"))
                bind(lifetime, protocol, "LoggerModel")
            }
        }
        
        private val __StringListSerializer = FrameworkMarshallers.String.list()
        
        const val serializationHash = 7321528154278941766L
        
    }
    override val serializersOwner: ISerializersOwner get() = LoggerModel
    override val serializationHash: Long get() = LoggerModel.serializationHash
    
    //fields
    val message: IAsyncSignal<LogEntry> get() = _message
    val testLogDir: IOptProperty<String> get() = _testLogDir
    val traceCategories: IOptProperty<List<String>> get() = _traceCategories
    //methods
    //initializer
    init {
        _testLogDir.optimizeNested = true
        _traceCategories.optimizeNested = true
    }
    
    init {
        _message.async = true
    }
    
    init {
        bindableChildren.add("message" to _message)
        bindableChildren.add("testLogDir" to _testLogDir)
        bindableChildren.add("traceCategories" to _traceCategories)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdSignal<LogEntry>(LogEntry),
        RdOptionalProperty<String>(FrameworkMarshallers.String),
        RdOptionalProperty<List<String>>(__StringListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LoggerModel (")
        printer.indent {
            print("message = "); _message.print(printer); println()
            print("testLogDir = "); _testLogDir.print(printer); println()
            print("traceCategories = "); _traceCategories.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): LoggerModel   {
        return LoggerModel(
            _message.deepClonePolymorphic(),
            _testLogDir.deepClonePolymorphic(),
            _traceCategories.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [LoggerModel.kt]
 */
data class LogEntry (
    val logMessage: String,
    val logMessageWithSensitiveData: String,
    val severity: LogEntryType
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LogEntry> {
        override val _type: KClass<LogEntry> = LogEntry::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LogEntry  {
            val logMessage = buffer.readString()
            val logMessageWithSensitiveData = buffer.readString()
            val severity = buffer.readEnum<LogEntryType>()
            return LogEntry(logMessage, logMessageWithSensitiveData, severity)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LogEntry)  {
            buffer.writeString(value.logMessage)
            buffer.writeString(value.logMessageWithSensitiveData)
            buffer.writeEnum(value.severity)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LogEntry
        
        if (logMessage != other.logMessage) return false
        if (logMessageWithSensitiveData != other.logMessageWithSensitiveData) return false
        if (severity != other.severity) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + logMessage.hashCode()
        __r = __r*31 + logMessageWithSensitiveData.hashCode()
        __r = __r*31 + severity.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LogEntry (")
        printer.indent {
            print("logMessage = "); logMessage.print(printer); println()
            print("logMessageWithSensitiveData = "); logMessageWithSensitiveData.print(printer); println()
            print("severity = "); severity.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [LoggerModel.kt]
 */
enum class LogEntryType {
    ERROR, 
    WARN, 
    INFO, 
    VERBOSE, 
    TRACE;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<LogEntryType>()
        
    }
}
