@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [LookupModel.kt]
 */
class LookupModel private constructor(
    private val _customLookup: RdProperty<CustomLookupModel?>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(FocusDegreeModel.marshaller)
            serializers.register(CustomLookupItemsModel)
            serializers.register(CustomLookupModel)
        }
        
        
        
        private val __CustomLookupModelNullableSerializer = CustomLookupModel.nullable()
        
        const val serializationHash = 2389729471986706930L
        
    }
    override val serializersOwner: ISerializersOwner get() = LookupModel
    override val serializationHash: Long get() = LookupModel.serializationHash
    
    //fields
    val customLookup: IProperty<CustomLookupModel?> get() = _customLookup
    //methods
    //initializer
    init {
        bindableChildren.add("customLookup" to _customLookup)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdProperty<CustomLookupModel?>(null, __CustomLookupModelNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LookupModel (")
        printer.indent {
            print("customLookup = "); _customLookup.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): LookupModel   {
        return LookupModel(
            _customLookup.deepClonePolymorphic()
        )
    }
    //contexts
}
val TextControlModel.lookupModel get() = getOrCreateExtension("lookupModel", ::LookupModel)



/**
 * #### Generated from [LookupModel.kt]
 */
data class CustomLookupItemsModel (
    val lookupItems: List<CompletionItem>,
    val lookupItemCount: Int,
    val selectedIndex: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CustomLookupItemsModel> {
        override val _type: KClass<CustomLookupItemsModel> = CustomLookupItemsModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CustomLookupItemsModel  {
            val lookupItems = buffer.readList { CompletionItem.read(ctx, buffer) }
            val lookupItemCount = buffer.readInt()
            val selectedIndex = buffer.readInt()
            return CustomLookupItemsModel(lookupItems, lookupItemCount, selectedIndex)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CustomLookupItemsModel)  {
            buffer.writeList(value.lookupItems) { v -> CompletionItem.write(ctx, buffer, v) }
            buffer.writeInt(value.lookupItemCount)
            buffer.writeInt(value.selectedIndex)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CustomLookupItemsModel
        
        if (lookupItems != other.lookupItems) return false
        if (lookupItemCount != other.lookupItemCount) return false
        if (selectedIndex != other.selectedIndex) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + lookupItems.hashCode()
        __r = __r*31 + lookupItemCount.hashCode()
        __r = __r*31 + selectedIndex.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CustomLookupItemsModel (")
        printer.indent {
            print("lookupItems = "); lookupItems.print(printer); println()
            print("lookupItemCount = "); lookupItemCount.print(printer); println()
            print("selectedIndex = "); selectedIndex.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [LookupModel.kt]
 */
class CustomLookupModel private constructor(
    private val _items: RdProperty<CustomLookupItemsModel?>,
    private val _selectedIndex: RdOptionalProperty<Int>,
    private val _lastVisibleIndex: RdOptionalProperty<Int>,
    private val _calculating: RdOptionalProperty<Boolean>,
    private val _focusDegree: RdOptionalProperty<FocusDegreeModel>,
    private val _itemSelected: RdCall<CompleteData?, Boolean>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CustomLookupModel> {
        override val _type: KClass<CustomLookupModel> = CustomLookupModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CustomLookupModel  {
            val _id = RdId.read(buffer)
            val _items = RdProperty.read(ctx, buffer, __CustomLookupItemsModelNullableSerializer)
            val _selectedIndex = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _lastVisibleIndex = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _calculating = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _focusDegree = RdOptionalProperty.read(ctx, buffer, FocusDegreeModel.marshaller)
            val _itemSelected = RdCall.read(ctx, buffer, __CompleteDataNullableSerializer, FrameworkMarshallers.Bool)
            return CustomLookupModel(_items, _selectedIndex, _lastVisibleIndex, _calculating, _focusDegree, _itemSelected).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CustomLookupModel)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._items)
            RdOptionalProperty.write(ctx, buffer, value._selectedIndex)
            RdOptionalProperty.write(ctx, buffer, value._lastVisibleIndex)
            RdOptionalProperty.write(ctx, buffer, value._calculating)
            RdOptionalProperty.write(ctx, buffer, value._focusDegree)
            RdCall.write(ctx, buffer, value._itemSelected)
        }
        
        private val __CustomLookupItemsModelNullableSerializer = CustomLookupItemsModel.nullable()
        private val __CompleteDataNullableSerializer = CompleteData.nullable()
        
    }
    //fields
    val items: IProperty<CustomLookupItemsModel?> get() = _items
    val selectedIndex: IOptProperty<Int> get() = _selectedIndex
    val lastVisibleIndex: IOptProperty<Int> get() = _lastVisibleIndex
    val calculating: IOptProperty<Boolean> get() = _calculating
    val focusDegree: IOptProperty<FocusDegreeModel> get() = _focusDegree
    val itemSelected: RdCall<CompleteData?, Boolean> get() = _itemSelected
    //methods
    //initializer
    init {
        _items.optimizeNested = true
        _selectedIndex.optimizeNested = true
        _lastVisibleIndex.optimizeNested = true
        _calculating.optimizeNested = true
        _focusDegree.optimizeNested = true
    }
    
    init {
        bindableChildren.add("items" to _items)
        bindableChildren.add("selectedIndex" to _selectedIndex)
        bindableChildren.add("lastVisibleIndex" to _lastVisibleIndex)
        bindableChildren.add("calculating" to _calculating)
        bindableChildren.add("focusDegree" to _focusDegree)
        bindableChildren.add("itemSelected" to _itemSelected)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdProperty<CustomLookupItemsModel?>(null, __CustomLookupItemsModelNullableSerializer),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<FocusDegreeModel>(FocusDegreeModel.marshaller),
        RdCall<CompleteData?, Boolean>(__CompleteDataNullableSerializer, FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CustomLookupModel (")
        printer.indent {
            print("items = "); _items.print(printer); println()
            print("selectedIndex = "); _selectedIndex.print(printer); println()
            print("lastVisibleIndex = "); _lastVisibleIndex.print(printer); println()
            print("calculating = "); _calculating.print(printer); println()
            print("focusDegree = "); _focusDegree.print(printer); println()
            print("itemSelected = "); _itemSelected.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CustomLookupModel   {
        return CustomLookupModel(
            _items.deepClonePolymorphic(),
            _selectedIndex.deepClonePolymorphic(),
            _lastVisibleIndex.deepClonePolymorphic(),
            _calculating.deepClonePolymorphic(),
            _focusDegree.deepClonePolymorphic(),
            _itemSelected.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [LookupModel.kt]
 */
enum class FocusDegreeModel {
    FOCUSED, 
    SEMI_FOCUSED, 
    UNFOCUSED;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<FocusDegreeModel>()
        
    }
}
