@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [NavigationModel.kt]
 */
class NavigationModel private constructor(
    private val _tooltipLinkClicked: RdSignal<TooltipLinkNavigationRequest>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(TooltipLinkNavigationRequest)
        }
        
        
        
        
        const val serializationHash = -5653295559423834393L
        
    }
    override val serializersOwner: ISerializersOwner get() = NavigationModel
    override val serializationHash: Long get() = NavigationModel.serializationHash
    
    //fields
    val tooltipLinkClicked: ISignal<TooltipLinkNavigationRequest> get() = _tooltipLinkClicked
    //methods
    //initializer
    init {
        bindableChildren.add("tooltipLinkClicked" to _tooltipLinkClicked)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdSignal<TooltipLinkNavigationRequest>(TooltipLinkNavigationRequest)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NavigationModel (")
        printer.indent {
            print("tooltipLinkClicked = "); _tooltipLinkClicked.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): NavigationModel   {
        return NavigationModel(
            _tooltipLinkClicked.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.navigationModel get() = getOrCreateExtension("navigationModel", ::NavigationModel)



/**
 * #### Generated from [NavigationModel.kt]
 */
data class TooltipLinkNavigationRequest (
    val refPrefix: String,
    val refSuffix: String,
    val editorId: TextControlId
) : IPrintable {
    //companion
    
    companion object : IMarshaller<TooltipLinkNavigationRequest> {
        override val _type: KClass<TooltipLinkNavigationRequest> = TooltipLinkNavigationRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TooltipLinkNavigationRequest  {
            val refPrefix = buffer.readString()
            val refSuffix = buffer.readString()
            val editorId = TextControlId.read(ctx, buffer)
            return TooltipLinkNavigationRequest(refPrefix, refSuffix, editorId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TooltipLinkNavigationRequest)  {
            buffer.writeString(value.refPrefix)
            buffer.writeString(value.refSuffix)
            TextControlId.write(ctx, buffer, value.editorId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TooltipLinkNavigationRequest
        
        if (refPrefix != other.refPrefix) return false
        if (refSuffix != other.refSuffix) return false
        if (editorId != other.editorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + refPrefix.hashCode()
        __r = __r*31 + refSuffix.hashCode()
        __r = __r*31 + editorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TooltipLinkNavigationRequest (")
        printer.indent {
            print("refPrefix = "); refPrefix.print(printer); println()
            print("refSuffix = "); refSuffix.print(printer); println()
            print("editorId = "); editorId.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
