@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.ide.model.notifications

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [NotificationsModel.kt]
 */
class NotificationsModel private constructor(
    private val _executeHyperlink: RdSignal<String>,
    private val _notification: RdSignal<NotificationModel>,
    private val _messageBox: RdCall<MessageBoxModel, MessageBoxResponse>,
    private val _tasks: RdMap<Int, BackgroundTaskModel>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(NotificationHyperlink)
            serializers.register(NotificationModel)
            serializers.register(MessageBoxResponse.marshaller)
            serializers.register(MessageBoxType.marshaller)
            serializers.register(MessageBoxModel)
            serializers.register(BackgroundTaskModel)
            serializers.register(RdNotificationEntryType.marshaller)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): NotificationsModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return NotificationsModel().apply {
                identify(protocol.identity, RdId.Null.mix("NotificationsModel"))
                bind(lifetime, protocol, "NotificationsModel")
            }
        }
        
        
        const val serializationHash = 6697817614875714010L
        
    }
    override val serializersOwner: ISerializersOwner get() = NotificationsModel
    override val serializationHash: Long get() = NotificationsModel.serializationHash
    
    //fields
    val executeHyperlink: ISignal<String> get() = _executeHyperlink
    
    /**
     * Allows the backend to show a notification on the frontend
     */
    val notification: ISignal<NotificationModel> get() = _notification
    
    /**
     * Allows the backend to show a message box on the frontend
     */
    val messageBox: RdCall<MessageBoxModel, MessageBoxResponse> get() = _messageBox
    
    /**
     * Allows the backend to report a background task to the frontend
     */
    val tasks: IMutableViewableMap<Int, BackgroundTaskModel> get() = _tasks
    //methods
    //initializer
    init {
        _tasks.async = true
    }
    
    init {
        bindableChildren.add("executeHyperlink" to _executeHyperlink)
        bindableChildren.add("notification" to _notification)
        bindableChildren.add("messageBox" to _messageBox)
        bindableChildren.add("tasks" to _tasks)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdSignal<String>(FrameworkMarshallers.String),
        RdSignal<NotificationModel>(NotificationModel),
        RdCall<MessageBoxModel, MessageBoxResponse>(MessageBoxModel, MessageBoxResponse.marshaller),
        RdMap<Int, BackgroundTaskModel>(FrameworkMarshallers.Int, BackgroundTaskModel)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NotificationsModel (")
        printer.indent {
            print("executeHyperlink = "); _executeHyperlink.print(printer); println()
            print("notification = "); _notification.print(printer); println()
            print("messageBox = "); _messageBox.print(printer); println()
            print("tasks = "); _tasks.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): NotificationsModel   {
        return NotificationsModel(
            _executeHyperlink.deepClonePolymorphic(),
            _notification.deepClonePolymorphic(),
            _messageBox.deepClonePolymorphic(),
            _tasks.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [NotificationsModel.kt]
 */
class BackgroundTaskModel private constructor(
    val title: String,
    private val _header: RdProperty<String?>,
    private val _description: RdProperty<String?>,
    private val _progress: RdOptionalProperty<Double>,
    private val _isIndeterminate: RdOptionalProperty<Boolean>,
    val isCancelable: Boolean,
    private val _cancel: RdSignal<Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BackgroundTaskModel> {
        override val _type: KClass<BackgroundTaskModel> = BackgroundTaskModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BackgroundTaskModel  {
            val _id = RdId.read(buffer)
            val title = buffer.readString()
            val _header = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _description = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _progress = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Double)
            val _isIndeterminate = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val isCancelable = buffer.readBool()
            val _cancel = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return BackgroundTaskModel(title, _header, _description, _progress, _isIndeterminate, isCancelable, _cancel).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BackgroundTaskModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.title)
            RdProperty.write(ctx, buffer, value._header)
            RdProperty.write(ctx, buffer, value._description)
            RdOptionalProperty.write(ctx, buffer, value._progress)
            RdOptionalProperty.write(ctx, buffer, value._isIndeterminate)
            buffer.writeBool(value.isCancelable)
            RdSignal.write(ctx, buffer, value._cancel)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val header: IProperty<String?> get() = _header
    val description: IProperty<String?> get() = _description
    val progress: IOptProperty<Double> get() = _progress
    val isIndeterminate: IOptProperty<Boolean> get() = _isIndeterminate
    val cancel: ISignal<Unit> get() = _cancel
    //methods
    //initializer
    init {
        _header.optimizeNested = true
        _description.optimizeNested = true
        _progress.optimizeNested = true
        _isIndeterminate.optimizeNested = true
    }
    
    init {
        _header.async = true
        _description.async = true
        _progress.async = true
        _isIndeterminate.async = true
    }
    
    init {
        bindableChildren.add("header" to _header)
        bindableChildren.add("description" to _description)
        bindableChildren.add("progress" to _progress)
        bindableChildren.add("isIndeterminate" to _isIndeterminate)
        bindableChildren.add("cancel" to _cancel)
    }
    
    //secondary constructor
    constructor(
        title: String,
        isCancelable: Boolean
    ) : this(
        title,
        RdProperty<String?>(null, __StringNullableSerializer),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdOptionalProperty<Double>(FrameworkMarshallers.Double),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        isCancelable,
        RdSignal<Unit>(FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BackgroundTaskModel (")
        printer.indent {
            print("title = "); title.print(printer); println()
            print("header = "); _header.print(printer); println()
            print("description = "); _description.print(printer); println()
            print("progress = "); _progress.print(printer); println()
            print("isIndeterminate = "); _isIndeterminate.print(printer); println()
            print("isCancelable = "); isCancelable.print(printer); println()
            print("cancel = "); _cancel.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BackgroundTaskModel   {
        return BackgroundTaskModel(
            title,
            _header.deepClonePolymorphic(),
            _description.deepClonePolymorphic(),
            _progress.deepClonePolymorphic(),
            _isIndeterminate.deepClonePolymorphic(),
            isCancelable,
            _cancel.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * @property message The text displayed in the message box
 * @property caption The title of the message box
 * @property type The buttons shown in the message box
 * #### Generated from [NotificationsModel.kt]
 */
data class MessageBoxModel (
    val message: String,
    val caption: String,
    val type: MessageBoxType
) : IPrintable {
    //companion
    
    companion object : IMarshaller<MessageBoxModel> {
        override val _type: KClass<MessageBoxModel> = MessageBoxModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): MessageBoxModel  {
            val message = buffer.readString()
            val caption = buffer.readString()
            val type = buffer.readEnum<MessageBoxType>()
            return MessageBoxModel(message, caption, type)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: MessageBoxModel)  {
            buffer.writeString(value.message)
            buffer.writeString(value.caption)
            buffer.writeEnum(value.type)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as MessageBoxModel
        
        if (message != other.message) return false
        if (caption != other.caption) return false
        if (type != other.type) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + message.hashCode()
        __r = __r*31 + caption.hashCode()
        __r = __r*31 + type.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("MessageBoxModel (")
        printer.indent {
            print("message = "); message.print(printer); println()
            print("caption = "); caption.print(printer); println()
            print("type = "); type.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [NotificationsModel.kt]
 */
enum class MessageBoxResponse {
    YES, 
    NO, 
    CANCEL, 
    OK;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<MessageBoxResponse>()
        
    }
}


/**
 * #### Generated from [NotificationsModel.kt]
 */
enum class MessageBoxType {
    OK, 
    YESNO, 
    OKCANCEL, 
    YESNOCANCEL;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<MessageBoxType>()
        
    }
}


/**
 * #### Generated from [NotificationsModel.kt]
 */
data class NotificationHyperlink (
    val text: String,
    val id: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<NotificationHyperlink> {
        override val _type: KClass<NotificationHyperlink> = NotificationHyperlink::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NotificationHyperlink  {
            val text = buffer.readString()
            val id = buffer.readString()
            return NotificationHyperlink(text, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NotificationHyperlink)  {
            buffer.writeString(value.text)
            buffer.writeString(value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as NotificationHyperlink
        
        if (text != other.text) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NotificationHyperlink (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * Represents a notification
 * @property title The title of the notification box
 * @property message The text displayed in the notification box
 * @property showPopup If true, the notification is displayed to the user. If false, it's only written to the log.
 * @property type The severity of the notification
 * #### Generated from [NotificationsModel.kt]
 */
data class NotificationModel (
    val title: String,
    val message: String,
    val showPopup: Boolean,
    val type: RdNotificationEntryType,
    val hyperlinks: List<NotificationHyperlink>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<NotificationModel> {
        override val _type: KClass<NotificationModel> = NotificationModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NotificationModel  {
            val title = buffer.readString()
            val message = buffer.readString()
            val showPopup = buffer.readBool()
            val type = buffer.readEnum<RdNotificationEntryType>()
            val hyperlinks = buffer.readList { NotificationHyperlink.read(ctx, buffer) }
            return NotificationModel(title, message, showPopup, type, hyperlinks)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NotificationModel)  {
            buffer.writeString(value.title)
            buffer.writeString(value.message)
            buffer.writeBool(value.showPopup)
            buffer.writeEnum(value.type)
            buffer.writeList(value.hyperlinks) { v -> NotificationHyperlink.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as NotificationModel
        
        if (title != other.title) return false
        if (message != other.message) return false
        if (showPopup != other.showPopup) return false
        if (type != other.type) return false
        if (hyperlinks != other.hyperlinks) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + title.hashCode()
        __r = __r*31 + message.hashCode()
        __r = __r*31 + showPopup.hashCode()
        __r = __r*31 + type.hashCode()
        __r = __r*31 + hyperlinks.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NotificationModel (")
        printer.indent {
            print("title = "); title.print(printer); println()
            print("message = "); message.print(printer); println()
            print("showPopup = "); showPopup.print(printer); println()
            print("type = "); type.print(printer); println()
            print("hyperlinks = "); hyperlinks.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [NotificationsModel.kt]
 */
enum class RdNotificationEntryType {
    ERROR, 
    WARN, 
    INFO;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<RdNotificationEntryType>()
        
    }
}
