@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [ParameterInfoModel.kt]
 */
class ParameterInfoModel private constructor(
    private val _parameterInfo: RdProperty<ParameterInfoContextsModel?>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(SignatureItem)
            serializers.register(RichTextRawSignatureItem)
            serializers.register(HtmlRawSignatureItem)
            serializers.register(ParameterInfoContext)
            serializers.register(ParameterInfoContextsModel)
            serializers.register(Range)
            serializers.register(SignatureItemModel_Unknown)
        }
        
        
        
        private val __ParameterInfoContextsModelNullableSerializer = ParameterInfoContextsModel.nullable()
        
        const val serializationHash = 4891117014738539863L
        
    }
    override val serializersOwner: ISerializersOwner get() = ParameterInfoModel
    override val serializationHash: Long get() = ParameterInfoModel.serializationHash
    
    //fields
    val parameterInfo: IProperty<ParameterInfoContextsModel?> get() = _parameterInfo
    //methods
    //initializer
    init {
        bindableChildren.add("parameterInfo" to _parameterInfo)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdProperty<ParameterInfoContextsModel?>(null, __ParameterInfoContextsModelNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ParameterInfoModel (")
        printer.indent {
            print("parameterInfo = "); _parameterInfo.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ParameterInfoModel   {
        return ParameterInfoModel(
            _parameterInfo.deepClonePolymorphic()
        )
    }
    //contexts
}
val TextControlModel.parameterInfoModel get() = getOrCreateExtension("parameterInfoModel", ::ParameterInfoModel)



/**
 * #### Generated from [ParameterInfoModel.kt]
 */
class HtmlRawSignatureItem (
    val htmlText: String,
    currentArgumentIdx: Int,
    isDeprecated: Boolean,
    isDisabled: Boolean
) : SignatureItemModel (
    currentArgumentIdx,
    isDeprecated,
    isDisabled
) {
    //companion
    
    companion object : IMarshaller<HtmlRawSignatureItem> {
        override val _type: KClass<HtmlRawSignatureItem> = HtmlRawSignatureItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HtmlRawSignatureItem  {
            val currentArgumentIdx = buffer.readInt()
            val isDeprecated = buffer.readBool()
            val isDisabled = buffer.readBool()
            val htmlText = ctx.readInterned(buffer, "ParameterInfoInternScope") { _, _ -> buffer.readString() }
            return HtmlRawSignatureItem(htmlText, currentArgumentIdx, isDeprecated, isDisabled)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HtmlRawSignatureItem)  {
            buffer.writeInt(value.currentArgumentIdx)
            buffer.writeBool(value.isDeprecated)
            buffer.writeBool(value.isDisabled)
            ctx.writeInterned(buffer, value.htmlText, "ParameterInfoInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HtmlRawSignatureItem
        
        if (htmlText != other.htmlText) return false
        if (currentArgumentIdx != other.currentArgumentIdx) return false
        if (isDeprecated != other.isDeprecated) return false
        if (isDisabled != other.isDisabled) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + htmlText.hashCode()
        __r = __r*31 + currentArgumentIdx.hashCode()
        __r = __r*31 + isDeprecated.hashCode()
        __r = __r*31 + isDisabled.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HtmlRawSignatureItem (")
        printer.indent {
            print("htmlText = "); htmlText.print(printer); println()
            print("currentArgumentIdx = "); currentArgumentIdx.print(printer); println()
            print("isDeprecated = "); isDeprecated.print(printer); println()
            print("isDisabled = "); isDisabled.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ParameterInfoModel.kt]
 */
data class ParameterInfoContext (
    val items: List<SignatureItemModel>,
    val matchedSignature: Int?,
    val range: Range
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ParameterInfoContext> {
        override val _type: KClass<ParameterInfoContext> = ParameterInfoContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ParameterInfoContext  {
            val items = buffer.readList { ctx.serializers.readPolymorphic<SignatureItemModel>(ctx, buffer, SignatureItemModel) }
            val matchedSignature = buffer.readNullable { buffer.readInt() }
            val range = Range.read(ctx, buffer)
            return ParameterInfoContext(items, matchedSignature, range)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ParameterInfoContext)  {
            buffer.writeList(value.items) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            buffer.writeNullable(value.matchedSignature) { buffer.writeInt(it) }
            Range.write(ctx, buffer, value.range)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ParameterInfoContext
        
        if (items != other.items) return false
        if (matchedSignature != other.matchedSignature) return false
        if (range != other.range) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + items.hashCode()
        __r = __r*31 + if (matchedSignature != null) matchedSignature.hashCode() else 0
        __r = __r*31 + range.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ParameterInfoContext (")
        printer.indent {
            print("items = "); items.print(printer); println()
            print("matchedSignature = "); matchedSignature.print(printer); println()
            print("range = "); range.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ParameterInfoModel.kt]
 */
class ParameterInfoContextsModel private constructor(
    val initialContext: ParameterInfoContext,
    private val _context: RdOptionalProperty<ParameterInfoContext>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<ParameterInfoContextsModel> {
        override val _type: KClass<ParameterInfoContextsModel> = ParameterInfoContextsModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ParameterInfoContextsModel  {
            val _id = RdId.read(buffer)
            val initialContext = ParameterInfoContext.read(ctx, buffer)
            val _context = RdOptionalProperty.read(ctx, buffer, ParameterInfoContext)
            return ParameterInfoContextsModel(initialContext, _context).withId(_id).apply { mySerializationContext = ctx.withInternRootsHere(this, "ParameterInfoInternScope") }
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ParameterInfoContextsModel)  {
            value.rdid.write(buffer)
            ParameterInfoContext.write(ctx, buffer, value.initialContext)
            RdOptionalProperty.write(ctx, buffer, value._context)
            value.mySerializationContext = ctx.withInternRootsHere(value, "ParameterInfoInternScope")
        }
        
        
    }
    //fields
    val context: IOptProperty<ParameterInfoContext> get() = _context
    private var mySerializationContext: SerializationCtx? = null
    override val serializationContext: SerializationCtx
        get() = mySerializationContext ?: throw IllegalStateException("Attempting to get serialization context too soon for $location")
    //methods
    //initializer
    init {
        _context.optimizeNested = true
    }
    
    init {
        bindableChildren.add("context" to _context)
    }
    
    //secondary constructor
    constructor(
        initialContext: ParameterInfoContext
    ) : this(
        initialContext,
        RdOptionalProperty<ParameterInfoContext>(ParameterInfoContext)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ParameterInfoContextsModel (")
        printer.indent {
            print("initialContext = "); initialContext.print(printer); println()
            print("context = "); _context.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ParameterInfoContextsModel   {
        return ParameterInfoContextsModel(
            initialContext,
            _context.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [ParameterInfoModel.kt]
 */
data class Range (
    val from: Int,
    val to: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<Range> {
        override val _type: KClass<Range> = Range::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): Range  {
            val from = buffer.readInt()
            val to = buffer.readInt()
            return Range(from, to)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: Range)  {
            buffer.writeInt(value.from)
            buffer.writeInt(value.to)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as Range
        
        if (from != other.from) return false
        if (to != other.to) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + from.hashCode()
        __r = __r*31 + to.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("Range (")
        printer.indent {
            print("from = "); from.print(printer); println()
            print("to = "); to.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ParameterInfoModel.kt]
 */
class RichTextRawSignatureItem (
    val signature: RichTextBlockModel,
    val description: RichTextBlockModel?,
    currentArgumentIdx: Int,
    isDeprecated: Boolean,
    isDisabled: Boolean
) : SignatureItemModel (
    currentArgumentIdx,
    isDeprecated,
    isDisabled
) {
    //companion
    
    companion object : IMarshaller<RichTextRawSignatureItem> {
        override val _type: KClass<RichTextRawSignatureItem> = RichTextRawSignatureItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RichTextRawSignatureItem  {
            val currentArgumentIdx = buffer.readInt()
            val isDeprecated = buffer.readBool()
            val isDisabled = buffer.readBool()
            val signature = RichTextBlockModel.read(ctx, buffer)
            val description = buffer.readNullable { RichTextBlockModel.read(ctx, buffer) }
            return RichTextRawSignatureItem(signature, description, currentArgumentIdx, isDeprecated, isDisabled)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RichTextRawSignatureItem)  {
            buffer.writeInt(value.currentArgumentIdx)
            buffer.writeBool(value.isDeprecated)
            buffer.writeBool(value.isDisabled)
            RichTextBlockModel.write(ctx, buffer, value.signature)
            buffer.writeNullable(value.description) { RichTextBlockModel.write(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RichTextRawSignatureItem
        
        if (signature != other.signature) return false
        if (description != other.description) return false
        if (currentArgumentIdx != other.currentArgumentIdx) return false
        if (isDeprecated != other.isDeprecated) return false
        if (isDisabled != other.isDisabled) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + signature.hashCode()
        __r = __r*31 + if (description != null) description.hashCode() else 0
        __r = __r*31 + currentArgumentIdx.hashCode()
        __r = __r*31 + isDeprecated.hashCode()
        __r = __r*31 + isDisabled.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RichTextRawSignatureItem (")
        printer.indent {
            print("signature = "); signature.print(printer); println()
            print("description = "); description.print(printer); println()
            print("currentArgumentIdx = "); currentArgumentIdx.print(printer); println()
            print("isDeprecated = "); isDeprecated.print(printer); println()
            print("isDisabled = "); isDisabled.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ParameterInfoModel.kt]
 */
class SignatureItem (
    val text: String,
    val startParamOffsets: List<Int>,
    val endParamOffsets: List<Int>,
    currentArgumentIdx: Int,
    isDeprecated: Boolean,
    isDisabled: Boolean
) : SignatureItemModel (
    currentArgumentIdx,
    isDeprecated,
    isDisabled
) {
    //companion
    
    companion object : IMarshaller<SignatureItem> {
        override val _type: KClass<SignatureItem> = SignatureItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SignatureItem  {
            val currentArgumentIdx = buffer.readInt()
            val isDeprecated = buffer.readBool()
            val isDisabled = buffer.readBool()
            val text = ctx.readInterned(buffer, "ParameterInfoInternScope") { _, _ -> buffer.readString() }
            val startParamOffsets = buffer.readList { buffer.readInt() }
            val endParamOffsets = buffer.readList { buffer.readInt() }
            return SignatureItem(text, startParamOffsets, endParamOffsets, currentArgumentIdx, isDeprecated, isDisabled)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SignatureItem)  {
            buffer.writeInt(value.currentArgumentIdx)
            buffer.writeBool(value.isDeprecated)
            buffer.writeBool(value.isDisabled)
            ctx.writeInterned(buffer, value.text, "ParameterInfoInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeList(value.startParamOffsets) { v -> buffer.writeInt(v) }
            buffer.writeList(value.endParamOffsets) { v -> buffer.writeInt(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SignatureItem
        
        if (text != other.text) return false
        if (startParamOffsets != other.startParamOffsets) return false
        if (endParamOffsets != other.endParamOffsets) return false
        if (currentArgumentIdx != other.currentArgumentIdx) return false
        if (isDeprecated != other.isDeprecated) return false
        if (isDisabled != other.isDisabled) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + startParamOffsets.hashCode()
        __r = __r*31 + endParamOffsets.hashCode()
        __r = __r*31 + currentArgumentIdx.hashCode()
        __r = __r*31 + isDeprecated.hashCode()
        __r = __r*31 + isDisabled.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SignatureItem (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("startParamOffsets = "); startParamOffsets.print(printer); println()
            print("endParamOffsets = "); endParamOffsets.print(printer); println()
            print("currentArgumentIdx = "); currentArgumentIdx.print(printer); println()
            print("isDeprecated = "); isDeprecated.print(printer); println()
            print("isDisabled = "); isDisabled.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ParameterInfoModel.kt]
 */
abstract class SignatureItemModel (
    val currentArgumentIdx: Int,
    val isDeprecated: Boolean,
    val isDisabled: Boolean
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<SignatureItemModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): SignatureItemModel  {
            val objectStartPosition = buffer.position
            val currentArgumentIdx = buffer.readInt()
            val isDeprecated = buffer.readBool()
            val isDisabled = buffer.readBool()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return SignatureItemModel_Unknown(currentArgumentIdx, isDeprecated, isDisabled, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class SignatureItemModel_Unknown (
    currentArgumentIdx: Int,
    isDeprecated: Boolean,
    isDisabled: Boolean,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : SignatureItemModel (
    currentArgumentIdx,
    isDeprecated,
    isDisabled
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<SignatureItemModel_Unknown> {
        override val _type: KClass<SignatureItemModel_Unknown> = SignatureItemModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SignatureItemModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SignatureItemModel_Unknown)  {
            buffer.writeInt(value.currentArgumentIdx)
            buffer.writeBool(value.isDeprecated)
            buffer.writeBool(value.isDisabled)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SignatureItemModel_Unknown
        
        if (currentArgumentIdx != other.currentArgumentIdx) return false
        if (isDeprecated != other.isDeprecated) return false
        if (isDisabled != other.isDisabled) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + currentArgumentIdx.hashCode()
        __r = __r*31 + isDeprecated.hashCode()
        __r = __r*31 + isDisabled.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SignatureItemModel_Unknown (")
        printer.indent {
            print("currentArgumentIdx = "); currentArgumentIdx.print(printer); println()
            print("isDeprecated = "); isDeprecated.print(printer); println()
            print("isDisabled = "); isDisabled.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
