@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.ide.model.popups

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class PopupInteractionModel private constructor(
    private val _popups: RdMap<Int, RdPopupMenuModel>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RdPopupMenuItemKind.marshaller)
            serializers.register(RdPopupMenuModelItem)
            serializers.register(RdDefaultPopupWindowContext)
            serializers.register(RdEditorOffsetPopupWindowContext)
            serializers.register(RdMainWindowCenteredPopupWindowContext)
            serializers.register(RdGutterMarkPopupWindowContext)
            serializers.register(RdFrontendComponentWindowContext)
            serializers.register(RdRichTextMultiLineViewModel)
            serializers.register(RdThemedIconViewModel)
            serializers.register(RdPresentableItemViewModel)
            serializers.register(RdRichTextWithProgressViewModel)
            serializers.register(RdButtonViewModel)
            serializers.register(ButtonCollection)
            serializers.register(RdTitleModel)
            serializers.register(RdFilterModel)
            serializers.register(RdPopupSelection)
            serializers.register(CanceledPopupMenuMarker)
            serializers.register(RdEmptyPopupMenuModel)
            serializers.register(RdExpandSubmenuRequest)
            serializers.register(RdPopupSubmenuModel)
            serializers.register(RdPopupMenuModel)
            serializers.register(RdPopupMenuModelItems)
            serializers.register(RdPopupWindowContextBase_Unknown)
            serializers.register(ProtoViewModel_Unknown)
            serializers.register(IRdPopupMenuModel_Unknown)
            serializers.register(RdPopupMenuModelBase_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): PopupInteractionModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return PopupInteractionModel().apply {
                identify(protocol.identity, RdId.Null.mix("PopupInteractionModel"))
                bind(lifetime, protocol, "PopupInteractionModel")
            }
        }
        
        
        const val serializationHash = 408306051733192800L
        
    }
    override val serializersOwner: ISerializersOwner get() = PopupInteractionModel
    override val serializationHash: Long get() = PopupInteractionModel.serializationHash
    
    //fields
    val popups: IMutableViewableMap<Int, RdPopupMenuModel> get() = _popups
    //methods
    //initializer
    init {
        bindableChildren.add("popups" to _popups)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdMap<Int, RdPopupMenuModel>(FrameworkMarshallers.Int, RdPopupMenuModel)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("PopupInteractionModel (")
        printer.indent {
            print("popups = "); _popups.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): PopupInteractionModel   {
        return PopupInteractionModel(
            _popups.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class ButtonCollection (
    val buttons: List<RdButtonViewModel>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<ButtonCollection> {
        override val _type: KClass<ButtonCollection> = ButtonCollection::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ButtonCollection  {
            val _id = RdId.read(buffer)
            val buttons = buffer.readList { RdButtonViewModel.read(ctx, buffer) }
            return ButtonCollection(buttons).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ButtonCollection)  {
            value.rdid.write(buffer)
            buffer.writeList(value.buttons) { v -> RdButtonViewModel.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("buttons" to buttons)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ButtonCollection (")
        printer.indent {
            print("buttons = "); buttons.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ButtonCollection   {
        return ButtonCollection(
            buttons.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class CanceledPopupMenuMarker (
) : IRdPopupMenuModel (
) {
    //companion
    
    companion object : IMarshaller<CanceledPopupMenuMarker> {
        override val _type: KClass<CanceledPopupMenuMarker> = CanceledPopupMenuMarker::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CanceledPopupMenuMarker  {
            val _id = RdId.read(buffer)
            return CanceledPopupMenuMarker().withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CanceledPopupMenuMarker)  {
            value.rdid.write(buffer)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CanceledPopupMenuMarker (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CanceledPopupMenuMarker   {
        return CanceledPopupMenuMarker(
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
abstract class IRdPopupMenuModel (
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<IRdPopupMenuModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): IRdPopupMenuModel  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return IRdPopupMenuModel_Unknown(unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class IRdPopupMenuModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : IRdPopupMenuModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<IRdPopupMenuModel_Unknown> {
        override val _type: KClass<IRdPopupMenuModel_Unknown> = IRdPopupMenuModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): IRdPopupMenuModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: IRdPopupMenuModel_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("IRdPopupMenuModel_Unknown (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): IRdPopupMenuModel_Unknown   {
        return IRdPopupMenuModel_Unknown(
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
abstract class ProtoViewModel (
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<ProtoViewModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): ProtoViewModel  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return ProtoViewModel_Unknown(unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class ProtoViewModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : ProtoViewModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<ProtoViewModel_Unknown> {
        override val _type: KClass<ProtoViewModel_Unknown> = ProtoViewModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ProtoViewModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ProtoViewModel_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ProtoViewModel_Unknown (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ProtoViewModel_Unknown   {
        return ProtoViewModel_Unknown(
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdButtonViewModel private constructor(
    val tooltip: String?,
    val shortcut: String?,
    val icon: com.jetbrains.rd.ide.model.IconModel?,
    private val _execute: RdSignal<Unit>
) : ProtoViewModel (
) {
    //companion
    
    companion object : IMarshaller<RdButtonViewModel> {
        override val _type: KClass<RdButtonViewModel> = RdButtonViewModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdButtonViewModel  {
            val _id = RdId.read(buffer)
            val tooltip = buffer.readNullable { buffer.readString() }
            val shortcut = buffer.readNullable { buffer.readString() }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val _execute = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return RdButtonViewModel(tooltip, shortcut, icon, _execute).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdButtonViewModel)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.tooltip) { buffer.writeString(it) }
            buffer.writeNullable(value.shortcut) { buffer.writeString(it) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdSignal.write(ctx, buffer, value._execute)
        }
        
        
    }
    //fields
    val execute: ISignal<Unit> get() = _execute
    //methods
    //initializer
    init {
        bindableChildren.add("execute" to _execute)
    }
    
    //secondary constructor
    constructor(
        tooltip: String?,
        shortcut: String?,
        icon: com.jetbrains.rd.ide.model.IconModel?
    ) : this(
        tooltip,
        shortcut,
        icon,
        RdSignal<Unit>(FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdButtonViewModel (")
        printer.indent {
            print("tooltip = "); tooltip.print(printer); println()
            print("shortcut = "); shortcut.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("execute = "); _execute.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdButtonViewModel   {
        return RdButtonViewModel(
            tooltip,
            shortcut,
            icon,
            _execute.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdDefaultPopupWindowContext (
) : RdPopupWindowContextBase (
) {
    //companion
    
    companion object : IMarshaller<RdDefaultPopupWindowContext> {
        override val _type: KClass<RdDefaultPopupWindowContext> = RdDefaultPopupWindowContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDefaultPopupWindowContext  {
            return RdDefaultPopupWindowContext()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDefaultPopupWindowContext)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDefaultPopupWindowContext
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDefaultPopupWindowContext (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdEditorOffsetPopupWindowContext (
    val editorOffset: Int
) : RdPopupWindowContextBase (
) {
    //companion
    
    companion object : IMarshaller<RdEditorOffsetPopupWindowContext> {
        override val _type: KClass<RdEditorOffsetPopupWindowContext> = RdEditorOffsetPopupWindowContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdEditorOffsetPopupWindowContext  {
            val editorOffset = buffer.readInt()
            return RdEditorOffsetPopupWindowContext(editorOffset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdEditorOffsetPopupWindowContext)  {
            buffer.writeInt(value.editorOffset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdEditorOffsetPopupWindowContext
        
        if (editorOffset != other.editorOffset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + editorOffset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdEditorOffsetPopupWindowContext (")
        printer.indent {
            print("editorOffset = "); editorOffset.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdEmptyPopupMenuModel (
    val timestamps: List<com.jetbrains.ide.model.uicontext.ContextPair>
) : IRdPopupMenuModel (
) {
    //companion
    
    companion object : IMarshaller<RdEmptyPopupMenuModel> {
        override val _type: KClass<RdEmptyPopupMenuModel> = RdEmptyPopupMenuModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdEmptyPopupMenuModel  {
            val _id = RdId.read(buffer)
            val timestamps = buffer.readList { com.jetbrains.ide.model.uicontext.ContextPair.read(ctx, buffer) }
            return RdEmptyPopupMenuModel(timestamps).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdEmptyPopupMenuModel)  {
            value.rdid.write(buffer)
            buffer.writeList(value.timestamps) { v -> com.jetbrains.ide.model.uicontext.ContextPair.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdEmptyPopupMenuModel (")
        printer.indent {
            print("timestamps = "); timestamps.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdEmptyPopupMenuModel   {
        return RdEmptyPopupMenuModel(
            timestamps
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdExpandSubmenuRequest private constructor(
    val expandedItem: Int,
    private val _submenu: RdOptionalProperty<RdPopupMenuModelBase>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdExpandSubmenuRequest> {
        override val _type: KClass<RdExpandSubmenuRequest> = RdExpandSubmenuRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdExpandSubmenuRequest  {
            val _id = RdId.read(buffer)
            val expandedItem = buffer.readInt()
            val _submenu = RdOptionalProperty.read(ctx, buffer, AbstractPolymorphic(RdPopupMenuModelBase))
            return RdExpandSubmenuRequest(expandedItem, _submenu).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdExpandSubmenuRequest)  {
            value.rdid.write(buffer)
            buffer.writeInt(value.expandedItem)
            RdOptionalProperty.write(ctx, buffer, value._submenu)
        }
        
        
    }
    //fields
    val submenu: IOptProperty<RdPopupMenuModelBase> get() = _submenu
    //methods
    //initializer
    init {
        bindableChildren.add("submenu" to _submenu)
    }
    
    //secondary constructor
    constructor(
        expandedItem: Int
    ) : this(
        expandedItem,
        RdOptionalProperty<RdPopupMenuModelBase>(AbstractPolymorphic(RdPopupMenuModelBase))
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdExpandSubmenuRequest (")
        printer.indent {
            print("expandedItem = "); expandedItem.print(printer); println()
            print("submenu = "); _submenu.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdExpandSubmenuRequest   {
        return RdExpandSubmenuRequest(
            expandedItem,
            _submenu.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdFilterModel private constructor(
    private val _searchString: RdProperty<String?>,
    private val _isValid: RdOptionalProperty<Boolean>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdFilterModel> {
        override val _type: KClass<RdFilterModel> = RdFilterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFilterModel  {
            val _id = RdId.read(buffer)
            val _searchString = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _isValid = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            return RdFilterModel(_searchString, _isValid).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFilterModel)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._searchString)
            RdOptionalProperty.write(ctx, buffer, value._isValid)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val searchString: IProperty<String?> get() = _searchString
    val isValid: IOptProperty<Boolean> get() = _isValid
    //methods
    //initializer
    init {
        _searchString.optimizeNested = true
        _isValid.optimizeNested = true
    }
    
    init {
        bindableChildren.add("searchString" to _searchString)
        bindableChildren.add("isValid" to _isValid)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdProperty<String?>(null, __StringNullableSerializer),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFilterModel (")
        printer.indent {
            print("searchString = "); _searchString.print(printer); println()
            print("isValid = "); _isValid.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdFilterModel   {
        return RdFilterModel(
            _searchString.deepClonePolymorphic(),
            _isValid.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdFrontendComponentWindowContext (
    val id: String
) : RdPopupWindowContextBase (
) {
    //companion
    
    companion object : IMarshaller<RdFrontendComponentWindowContext> {
        override val _type: KClass<RdFrontendComponentWindowContext> = RdFrontendComponentWindowContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFrontendComponentWindowContext  {
            val id = buffer.readString()
            return RdFrontendComponentWindowContext(id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFrontendComponentWindowContext)  {
            buffer.writeString(value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFrontendComponentWindowContext
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFrontendComponentWindowContext (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdGutterMarkPopupWindowContext (
    val docOffset: Int
) : RdPopupWindowContextBase (
) {
    //companion
    
    companion object : IMarshaller<RdGutterMarkPopupWindowContext> {
        override val _type: KClass<RdGutterMarkPopupWindowContext> = RdGutterMarkPopupWindowContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdGutterMarkPopupWindowContext  {
            val docOffset = buffer.readInt()
            return RdGutterMarkPopupWindowContext(docOffset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdGutterMarkPopupWindowContext)  {
            buffer.writeInt(value.docOffset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdGutterMarkPopupWindowContext
        
        if (docOffset != other.docOffset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + docOffset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdGutterMarkPopupWindowContext (")
        printer.indent {
            print("docOffset = "); docOffset.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdMainWindowCenteredPopupWindowContext (
) : RdPopupWindowContextBase (
) {
    //companion
    
    companion object : IMarshaller<RdMainWindowCenteredPopupWindowContext> {
        override val _type: KClass<RdMainWindowCenteredPopupWindowContext> = RdMainWindowCenteredPopupWindowContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdMainWindowCenteredPopupWindowContext  {
            return RdMainWindowCenteredPopupWindowContext()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdMainWindowCenteredPopupWindowContext)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdMainWindowCenteredPopupWindowContext
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdMainWindowCenteredPopupWindowContext (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
enum class RdPopupMenuItemKind {
    ErrorFix, 
    InspectionFix, 
    Intention, 
    Gutter, 
    Notification, 
    Other;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<RdPopupMenuItemKind>()
        
    }
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdPopupMenuModel private constructor(
    private val _expandSubmenu: RdProperty<RdExpandSubmenuRequest?>,
    val timestamps: List<com.jetbrains.ide.model.uicontext.ContextPair>,
    val context: RdPopupWindowContextBase,
    _items: RdOptionalProperty<RdPopupMenuModelItems>,
    _executeItem: RdCall<Int, Boolean>,
    _selectedItem: RdOptionalProperty<RdPopupSelection>,
    toolbar: RdTitleModel,
    filter: RdFilterModel,
    footer: String?,
    modal: Boolean,
    useProtocolSearch: Boolean,
    _isPrepared: RdOptionalProperty<Boolean>
) : RdPopupMenuModelBase (
    _items,
    _executeItem,
    _selectedItem,
    toolbar,
    filter,
    footer,
    modal,
    useProtocolSearch,
    _isPrepared
) {
    //companion
    
    companion object : IMarshaller<RdPopupMenuModel> {
        override val _type: KClass<RdPopupMenuModel> = RdPopupMenuModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPopupMenuModel  {
            val _id = RdId.read(buffer)
            val _items = RdOptionalProperty.read(ctx, buffer, RdPopupMenuModelItems)
            val _executeItem = RdCall.read(ctx, buffer, FrameworkMarshallers.Int, FrameworkMarshallers.Bool)
            val _selectedItem = RdOptionalProperty.read(ctx, buffer, RdPopupSelection)
            val toolbar = RdTitleModel.read(ctx, buffer)
            val filter = RdFilterModel.read(ctx, buffer)
            val footer = buffer.readNullable { buffer.readString() }
            val modal = buffer.readBool()
            val useProtocolSearch = buffer.readBool()
            val _isPrepared = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _expandSubmenu = RdProperty.read(ctx, buffer, __RdExpandSubmenuRequestNullableSerializer)
            val timestamps = buffer.readList { com.jetbrains.ide.model.uicontext.ContextPair.read(ctx, buffer) }
            val context = ctx.serializers.readPolymorphic<RdPopupWindowContextBase>(ctx, buffer, RdPopupWindowContextBase)
            return RdPopupMenuModel(_expandSubmenu, timestamps, context, _items, _executeItem, _selectedItem, toolbar, filter, footer, modal, useProtocolSearch, _isPrepared).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPopupMenuModel)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._items)
            RdCall.write(ctx, buffer, value._executeItem)
            RdOptionalProperty.write(ctx, buffer, value._selectedItem)
            RdTitleModel.write(ctx, buffer, value.toolbar)
            RdFilterModel.write(ctx, buffer, value.filter)
            buffer.writeNullable(value.footer) { buffer.writeString(it) }
            buffer.writeBool(value.modal)
            buffer.writeBool(value.useProtocolSearch)
            RdOptionalProperty.write(ctx, buffer, value._isPrepared)
            RdProperty.write(ctx, buffer, value._expandSubmenu)
            buffer.writeList(value.timestamps) { v -> com.jetbrains.ide.model.uicontext.ContextPair.write(ctx, buffer, v) }
            ctx.serializers.writePolymorphic(ctx, buffer, value.context)
        }
        
        private val __RdExpandSubmenuRequestNullableSerializer = RdExpandSubmenuRequest.nullable()
        
    }
    //fields
    val expandSubmenu: IProperty<RdExpandSubmenuRequest?> get() = _expandSubmenu
    //methods
    //initializer
    init {
        bindableChildren.add("expandSubmenu" to _expandSubmenu)
    }
    
    //secondary constructor
    constructor(
        timestamps: List<com.jetbrains.ide.model.uicontext.ContextPair>,
        context: RdPopupWindowContextBase,
        footer: String?,
        modal: Boolean,
        useProtocolSearch: Boolean
    ) : this(
        RdProperty<RdExpandSubmenuRequest?>(null, __RdExpandSubmenuRequestNullableSerializer),
        timestamps,
        context,
        RdOptionalProperty<RdPopupMenuModelItems>(RdPopupMenuModelItems),
        RdCall<Int, Boolean>(FrameworkMarshallers.Int, FrameworkMarshallers.Bool),
        RdOptionalProperty<RdPopupSelection>(RdPopupSelection),
        RdTitleModel(),
        RdFilterModel(),
        footer,
        modal,
        useProtocolSearch,
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPopupMenuModel (")
        printer.indent {
            print("expandSubmenu = "); _expandSubmenu.print(printer); println()
            print("timestamps = "); timestamps.print(printer); println()
            print("context = "); context.print(printer); println()
            print("items = "); _items.print(printer); println()
            print("executeItem = "); _executeItem.print(printer); println()
            print("selectedItem = "); _selectedItem.print(printer); println()
            print("toolbar = "); toolbar.print(printer); println()
            print("filter = "); filter.print(printer); println()
            print("footer = "); footer.print(printer); println()
            print("modal = "); modal.print(printer); println()
            print("useProtocolSearch = "); useProtocolSearch.print(printer); println()
            print("isPrepared = "); _isPrepared.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdPopupMenuModel   {
        return RdPopupMenuModel(
            _expandSubmenu.deepClonePolymorphic(),
            timestamps,
            context,
            _items.deepClonePolymorphic(),
            _executeItem.deepClonePolymorphic(),
            _selectedItem.deepClonePolymorphic(),
            toolbar.deepClonePolymorphic(),
            filter.deepClonePolymorphic(),
            footer,
            modal,
            useProtocolSearch,
            _isPrepared.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
abstract class RdPopupMenuModelBase (
    protected val _items: RdOptionalProperty<RdPopupMenuModelItems>,
    protected val _executeItem: RdCall<Int, Boolean>,
    protected val _selectedItem: RdOptionalProperty<RdPopupSelection>,
    val toolbar: RdTitleModel,
    val filter: RdFilterModel,
    val footer: String?,
    val modal: Boolean,
    val useProtocolSearch: Boolean,
    protected val _isPrepared: RdOptionalProperty<Boolean>
) : IRdPopupMenuModel (
) {
    //companion
    
    companion object : IAbstractDeclaration<RdPopupMenuModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdPopupMenuModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val _items = RdOptionalProperty.read(ctx, buffer, RdPopupMenuModelItems)
            val _executeItem = RdCall.read(ctx, buffer, FrameworkMarshallers.Int, FrameworkMarshallers.Bool)
            val _selectedItem = RdOptionalProperty.read(ctx, buffer, RdPopupSelection)
            val toolbar = RdTitleModel.read(ctx, buffer)
            val filter = RdFilterModel.read(ctx, buffer)
            val footer = buffer.readNullable { buffer.readString() }
            val modal = buffer.readBool()
            val useProtocolSearch = buffer.readBool()
            val _isPrepared = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdPopupMenuModelBase_Unknown(_items, _executeItem, _selectedItem, toolbar, filter, footer, modal, useProtocolSearch, _isPrepared, unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    val items: IOptProperty<RdPopupMenuModelItems> get() = _items
    val executeItem: RdCall<Int, Boolean> get() = _executeItem
    val selectedItem: IOptProperty<RdPopupSelection> get() = _selectedItem
    val isPrepared: IOptProperty<Boolean> get() = _isPrepared
    //methods
    //initializer
    init {
        _isPrepared.optimizeNested = true
    }
    
    init {
        bindableChildren.add("items" to _items)
        bindableChildren.add("executeItem" to _executeItem)
        bindableChildren.add("selectedItem" to _selectedItem)
        bindableChildren.add("toolbar" to toolbar)
        bindableChildren.add("filter" to filter)
        bindableChildren.add("isPrepared" to _isPrepared)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdPopupMenuModelBase_Unknown (
    _items: RdOptionalProperty<RdPopupMenuModelItems>,
    _executeItem: RdCall<Int, Boolean>,
    _selectedItem: RdOptionalProperty<RdPopupSelection>,
    toolbar: RdTitleModel,
    filter: RdFilterModel,
    footer: String?,
    modal: Boolean,
    useProtocolSearch: Boolean,
    _isPrepared: RdOptionalProperty<Boolean>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdPopupMenuModelBase (
    _items,
    _executeItem,
    _selectedItem,
    toolbar,
    filter,
    footer,
    modal,
    useProtocolSearch,
    _isPrepared
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdPopupMenuModelBase_Unknown> {
        override val _type: KClass<RdPopupMenuModelBase_Unknown> = RdPopupMenuModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPopupMenuModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPopupMenuModelBase_Unknown)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._items)
            RdCall.write(ctx, buffer, value._executeItem)
            RdOptionalProperty.write(ctx, buffer, value._selectedItem)
            RdTitleModel.write(ctx, buffer, value.toolbar)
            RdFilterModel.write(ctx, buffer, value.filter)
            buffer.writeNullable(value.footer) { buffer.writeString(it) }
            buffer.writeBool(value.modal)
            buffer.writeBool(value.useProtocolSearch)
            RdOptionalProperty.write(ctx, buffer, value._isPrepared)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        footer: String?,
        modal: Boolean,
        useProtocolSearch: Boolean,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        RdOptionalProperty<RdPopupMenuModelItems>(RdPopupMenuModelItems),
        RdCall<Int, Boolean>(FrameworkMarshallers.Int, FrameworkMarshallers.Bool),
        RdOptionalProperty<RdPopupSelection>(RdPopupSelection),
        RdTitleModel(),
        RdFilterModel(),
        footer,
        modal,
        useProtocolSearch,
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPopupMenuModelBase_Unknown (")
        printer.indent {
            print("items = "); _items.print(printer); println()
            print("executeItem = "); _executeItem.print(printer); println()
            print("selectedItem = "); _selectedItem.print(printer); println()
            print("toolbar = "); toolbar.print(printer); println()
            print("filter = "); filter.print(printer); println()
            print("footer = "); footer.print(printer); println()
            print("modal = "); modal.print(printer); println()
            print("useProtocolSearch = "); useProtocolSearch.print(printer); println()
            print("isPrepared = "); _isPrepared.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdPopupMenuModelBase_Unknown   {
        return RdPopupMenuModelBase_Unknown(
            _items.deepClonePolymorphic(),
            _executeItem.deepClonePolymorphic(),
            _selectedItem.deepClonePolymorphic(),
            toolbar.deepClonePolymorphic(),
            filter.deepClonePolymorphic(),
            footer,
            modal,
            useProtocolSearch,
            _isPrepared.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
data class RdPopupMenuModelItem (
    val itemId: Int,
    val icon: com.jetbrains.rd.ide.model.IconModel?,
    val optionalIcon: com.jetbrains.rd.ide.model.IconModel?,
    val text: com.jetbrains.rd.ide.model.RichTextModel,
    val optionalText: com.jetbrains.rd.ide.model.RichTextModel?,
    val actionId: String?,
    val tooltip: String?,
    val isSeparator: Boolean,
    val isEnabled: Boolean,
    val canExpand: Boolean,
    val isGroupHeader: Boolean,
    val subItems: List<RdPopupMenuModelItem>?,
    val kind: RdPopupMenuItemKind = RdPopupMenuItemKind.Other
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdPopupMenuModelItem> {
        override val _type: KClass<RdPopupMenuModelItem> = RdPopupMenuModelItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPopupMenuModelItem  {
            val itemId = buffer.readInt()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val optionalIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val text = com.jetbrains.rd.ide.model.RichTextModel.read(ctx, buffer)
            val optionalText = buffer.readNullable { com.jetbrains.rd.ide.model.RichTextModel.read(ctx, buffer) }
            val actionId = buffer.readNullable { buffer.readString() }
            val tooltip = buffer.readNullable { buffer.readString() }
            val isSeparator = buffer.readBool()
            val isEnabled = buffer.readBool()
            val canExpand = buffer.readBool()
            val isGroupHeader = buffer.readBool()
            val subItems = buffer.readNullable { buffer.readList { RdPopupMenuModelItem.read(ctx, buffer) } }
            val kind = buffer.readEnum<RdPopupMenuItemKind>()
            return RdPopupMenuModelItem(itemId, icon, optionalIcon, text, optionalText, actionId, tooltip, isSeparator, isEnabled, canExpand, isGroupHeader, subItems, kind)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPopupMenuModelItem)  {
            buffer.writeInt(value.itemId)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.optionalIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            com.jetbrains.rd.ide.model.RichTextModel.write(ctx, buffer, value.text)
            buffer.writeNullable(value.optionalText) { com.jetbrains.rd.ide.model.RichTextModel.write(ctx, buffer, it) }
            buffer.writeNullable(value.actionId) { buffer.writeString(it) }
            buffer.writeNullable(value.tooltip) { buffer.writeString(it) }
            buffer.writeBool(value.isSeparator)
            buffer.writeBool(value.isEnabled)
            buffer.writeBool(value.canExpand)
            buffer.writeBool(value.isGroupHeader)
            buffer.writeNullable(value.subItems) { buffer.writeList(it) { v -> RdPopupMenuModelItem.write(ctx, buffer, v) } }
            buffer.writeEnum(value.kind)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdPopupMenuModelItem
        
        if (itemId != other.itemId) return false
        if (icon != other.icon) return false
        if (optionalIcon != other.optionalIcon) return false
        if (text != other.text) return false
        if (optionalText != other.optionalText) return false
        if (actionId != other.actionId) return false
        if (tooltip != other.tooltip) return false
        if (isSeparator != other.isSeparator) return false
        if (isEnabled != other.isEnabled) return false
        if (canExpand != other.canExpand) return false
        if (isGroupHeader != other.isGroupHeader) return false
        if (subItems != other.subItems) return false
        if (kind != other.kind) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + itemId.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + if (optionalIcon != null) optionalIcon.hashCode() else 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + if (optionalText != null) optionalText.hashCode() else 0
        __r = __r*31 + if (actionId != null) actionId.hashCode() else 0
        __r = __r*31 + if (tooltip != null) tooltip.hashCode() else 0
        __r = __r*31 + isSeparator.hashCode()
        __r = __r*31 + isEnabled.hashCode()
        __r = __r*31 + canExpand.hashCode()
        __r = __r*31 + isGroupHeader.hashCode()
        __r = __r*31 + if (subItems != null) subItems.hashCode() else 0
        __r = __r*31 + kind.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPopupMenuModelItem (")
        printer.indent {
            print("itemId = "); itemId.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("optionalIcon = "); optionalIcon.print(printer); println()
            print("text = "); text.print(printer); println()
            print("optionalText = "); optionalText.print(printer); println()
            print("actionId = "); actionId.print(printer); println()
            print("tooltip = "); tooltip.print(printer); println()
            print("isSeparator = "); isSeparator.print(printer); println()
            print("isEnabled = "); isEnabled.print(printer); println()
            print("canExpand = "); canExpand.print(printer); println()
            print("isGroupHeader = "); isGroupHeader.print(printer); println()
            print("subItems = "); subItems.print(printer); println()
            print("kind = "); kind.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdPopupMenuModelItems (
    val value: List<RdPopupMenuModelItem>,
    val selectedIndex: Int,
    val version: Int
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdPopupMenuModelItems> {
        override val _type: KClass<RdPopupMenuModelItems> = RdPopupMenuModelItems::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPopupMenuModelItems  {
            val _id = RdId.read(buffer)
            val value = buffer.readList { RdPopupMenuModelItem.read(ctx, buffer) }
            val selectedIndex = buffer.readInt()
            val version = buffer.readInt()
            return RdPopupMenuModelItems(value, selectedIndex, version).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPopupMenuModelItems)  {
            value.rdid.write(buffer)
            buffer.writeList(value.value) { v -> RdPopupMenuModelItem.write(ctx, buffer, v) }
            buffer.writeInt(value.selectedIndex)
            buffer.writeInt(value.version)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPopupMenuModelItems (")
        printer.indent {
            print("value = "); value.print(printer); println()
            print("selectedIndex = "); selectedIndex.print(printer); println()
            print("version = "); version.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdPopupMenuModelItems   {
        return RdPopupMenuModelItems(
            value,
            selectedIndex,
            version
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdPopupSelection (
    val itemId: Int?,
    val version: Int
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdPopupSelection> {
        override val _type: KClass<RdPopupSelection> = RdPopupSelection::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPopupSelection  {
            val _id = RdId.read(buffer)
            val itemId = buffer.readNullable { buffer.readInt() }
            val version = buffer.readInt()
            return RdPopupSelection(itemId, version).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPopupSelection)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.itemId) { buffer.writeInt(it) }
            buffer.writeInt(value.version)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPopupSelection (")
        printer.indent {
            print("itemId = "); itemId.print(printer); println()
            print("version = "); version.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdPopupSelection   {
        return RdPopupSelection(
            itemId,
            version
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdPopupSubmenuModel private constructor(
    private val _expandSubmenu: RdProperty<RdExpandSubmenuRequest?>,
    _items: RdOptionalProperty<RdPopupMenuModelItems>,
    _executeItem: RdCall<Int, Boolean>,
    _selectedItem: RdOptionalProperty<RdPopupSelection>,
    toolbar: RdTitleModel,
    filter: RdFilterModel,
    footer: String?,
    modal: Boolean,
    useProtocolSearch: Boolean,
    _isPrepared: RdOptionalProperty<Boolean>
) : RdPopupMenuModelBase (
    _items,
    _executeItem,
    _selectedItem,
    toolbar,
    filter,
    footer,
    modal,
    useProtocolSearch,
    _isPrepared
) {
    //companion
    
    companion object : IMarshaller<RdPopupSubmenuModel> {
        override val _type: KClass<RdPopupSubmenuModel> = RdPopupSubmenuModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPopupSubmenuModel  {
            val _id = RdId.read(buffer)
            val _items = RdOptionalProperty.read(ctx, buffer, RdPopupMenuModelItems)
            val _executeItem = RdCall.read(ctx, buffer, FrameworkMarshallers.Int, FrameworkMarshallers.Bool)
            val _selectedItem = RdOptionalProperty.read(ctx, buffer, RdPopupSelection)
            val toolbar = RdTitleModel.read(ctx, buffer)
            val filter = RdFilterModel.read(ctx, buffer)
            val footer = buffer.readNullable { buffer.readString() }
            val modal = buffer.readBool()
            val useProtocolSearch = buffer.readBool()
            val _isPrepared = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _expandSubmenu = RdProperty.read(ctx, buffer, __RdExpandSubmenuRequestNullableSerializer)
            return RdPopupSubmenuModel(_expandSubmenu, _items, _executeItem, _selectedItem, toolbar, filter, footer, modal, useProtocolSearch, _isPrepared).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPopupSubmenuModel)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._items)
            RdCall.write(ctx, buffer, value._executeItem)
            RdOptionalProperty.write(ctx, buffer, value._selectedItem)
            RdTitleModel.write(ctx, buffer, value.toolbar)
            RdFilterModel.write(ctx, buffer, value.filter)
            buffer.writeNullable(value.footer) { buffer.writeString(it) }
            buffer.writeBool(value.modal)
            buffer.writeBool(value.useProtocolSearch)
            RdOptionalProperty.write(ctx, buffer, value._isPrepared)
            RdProperty.write(ctx, buffer, value._expandSubmenu)
        }
        
        private val __RdExpandSubmenuRequestNullableSerializer = RdExpandSubmenuRequest.nullable()
        
    }
    //fields
    val expandSubmenu: IProperty<RdExpandSubmenuRequest?> get() = _expandSubmenu
    //methods
    //initializer
    init {
        bindableChildren.add("expandSubmenu" to _expandSubmenu)
    }
    
    //secondary constructor
    constructor(
        footer: String?,
        modal: Boolean,
        useProtocolSearch: Boolean
    ) : this(
        RdProperty<RdExpandSubmenuRequest?>(null, __RdExpandSubmenuRequestNullableSerializer),
        RdOptionalProperty<RdPopupMenuModelItems>(RdPopupMenuModelItems),
        RdCall<Int, Boolean>(FrameworkMarshallers.Int, FrameworkMarshallers.Bool),
        RdOptionalProperty<RdPopupSelection>(RdPopupSelection),
        RdTitleModel(),
        RdFilterModel(),
        footer,
        modal,
        useProtocolSearch,
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPopupSubmenuModel (")
        printer.indent {
            print("expandSubmenu = "); _expandSubmenu.print(printer); println()
            print("items = "); _items.print(printer); println()
            print("executeItem = "); _executeItem.print(printer); println()
            print("selectedItem = "); _selectedItem.print(printer); println()
            print("toolbar = "); toolbar.print(printer); println()
            print("filter = "); filter.print(printer); println()
            print("footer = "); footer.print(printer); println()
            print("modal = "); modal.print(printer); println()
            print("useProtocolSearch = "); useProtocolSearch.print(printer); println()
            print("isPrepared = "); _isPrepared.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdPopupSubmenuModel   {
        return RdPopupSubmenuModel(
            _expandSubmenu.deepClonePolymorphic(),
            _items.deepClonePolymorphic(),
            _executeItem.deepClonePolymorphic(),
            _selectedItem.deepClonePolymorphic(),
            toolbar.deepClonePolymorphic(),
            filter.deepClonePolymorphic(),
            footer,
            modal,
            useProtocolSearch,
            _isPrepared.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
abstract class RdPopupWindowContextBase (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdPopupWindowContextBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdPopupWindowContextBase  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdPopupWindowContextBase_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdPopupWindowContextBase_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdPopupWindowContextBase (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdPopupWindowContextBase_Unknown> {
        override val _type: KClass<RdPopupWindowContextBase_Unknown> = RdPopupWindowContextBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPopupWindowContextBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPopupWindowContextBase_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdPopupWindowContextBase_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPopupWindowContextBase_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdPresentableItemViewModel (
    val icon: com.jetbrains.rd.ide.model.IconModel?,
    val title: com.jetbrains.rd.ide.model.RichTextModel
) : ProtoViewModel (
) {
    //companion
    
    companion object : IMarshaller<RdPresentableItemViewModel> {
        override val _type: KClass<RdPresentableItemViewModel> = RdPresentableItemViewModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPresentableItemViewModel  {
            val _id = RdId.read(buffer)
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val title = com.jetbrains.rd.ide.model.RichTextModel.read(ctx, buffer)
            return RdPresentableItemViewModel(icon, title).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPresentableItemViewModel)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            com.jetbrains.rd.ide.model.RichTextModel.write(ctx, buffer, value.title)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPresentableItemViewModel (")
        printer.indent {
            print("icon = "); icon.print(printer); println()
            print("title = "); title.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdPresentableItemViewModel   {
        return RdPresentableItemViewModel(
            icon,
            title
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdRichTextMultiLineViewModel private constructor(
    private val _htmlTextBlock: RdOptionalProperty<String>
) : ProtoViewModel (
) {
    //companion
    
    companion object : IMarshaller<RdRichTextMultiLineViewModel> {
        override val _type: KClass<RdRichTextMultiLineViewModel> = RdRichTextMultiLineViewModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdRichTextMultiLineViewModel  {
            val _id = RdId.read(buffer)
            val _htmlTextBlock = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.String)
            return RdRichTextMultiLineViewModel(_htmlTextBlock).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdRichTextMultiLineViewModel)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._htmlTextBlock)
        }
        
        
    }
    //fields
    val htmlTextBlock: IOptProperty<String> get() = _htmlTextBlock
    //methods
    //initializer
    init {
        _htmlTextBlock.optimizeNested = true
    }
    
    init {
        bindableChildren.add("htmlTextBlock" to _htmlTextBlock)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<String>(FrameworkMarshallers.String)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdRichTextMultiLineViewModel (")
        printer.indent {
            print("htmlTextBlock = "); _htmlTextBlock.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdRichTextMultiLineViewModel   {
        return RdRichTextMultiLineViewModel(
            _htmlTextBlock.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdRichTextWithProgressViewModel private constructor(
    private val _htmlTextBlock: RdProperty<String?>,
    private val _fraction: RdOptionalProperty<Double>
) : ProtoViewModel (
) {
    //companion
    
    companion object : IMarshaller<RdRichTextWithProgressViewModel> {
        override val _type: KClass<RdRichTextWithProgressViewModel> = RdRichTextWithProgressViewModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdRichTextWithProgressViewModel  {
            val _id = RdId.read(buffer)
            val _htmlTextBlock = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _fraction = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Double)
            return RdRichTextWithProgressViewModel(_htmlTextBlock, _fraction).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdRichTextWithProgressViewModel)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._htmlTextBlock)
            RdOptionalProperty.write(ctx, buffer, value._fraction)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val htmlTextBlock: IProperty<String?> get() = _htmlTextBlock
    val fraction: IOptProperty<Double> get() = _fraction
    //methods
    //initializer
    init {
        _htmlTextBlock.optimizeNested = true
        _fraction.optimizeNested = true
    }
    
    init {
        bindableChildren.add("htmlTextBlock" to _htmlTextBlock)
        bindableChildren.add("fraction" to _fraction)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdProperty<String?>(null, __StringNullableSerializer),
        RdOptionalProperty<Double>(FrameworkMarshallers.Double)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdRichTextWithProgressViewModel (")
        printer.indent {
            print("htmlTextBlock = "); _htmlTextBlock.print(printer); println()
            print("fraction = "); _fraction.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdRichTextWithProgressViewModel   {
        return RdRichTextWithProgressViewModel(
            _htmlTextBlock.deepClonePolymorphic(),
            _fraction.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdThemedIconViewModel (
    val icon: com.jetbrains.rd.ide.model.IconModel
) : ProtoViewModel (
) {
    //companion
    
    companion object : IMarshaller<RdThemedIconViewModel> {
        override val _type: KClass<RdThemedIconViewModel> = RdThemedIconViewModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdThemedIconViewModel  {
            val _id = RdId.read(buffer)
            val icon = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel)
            return RdThemedIconViewModel(icon).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdThemedIconViewModel)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.icon)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdThemedIconViewModel (")
        printer.indent {
            print("icon = "); icon.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdThemedIconViewModel   {
        return RdThemedIconViewModel(
            icon
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupInteractionModel.kt]
 */
class RdTitleModel private constructor(
    private val _caption: RdProperty<ProtoViewModel?>,
    private val _buttons: RdOptionalProperty<ButtonCollection>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdTitleModel> {
        override val _type: KClass<RdTitleModel> = RdTitleModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTitleModel  {
            val _id = RdId.read(buffer)
            val _caption = RdProperty.read(ctx, buffer, __ProtoViewModelNullableSerializer)
            val _buttons = RdOptionalProperty.read(ctx, buffer, ButtonCollection)
            return RdTitleModel(_caption, _buttons).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTitleModel)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._caption)
            RdOptionalProperty.write(ctx, buffer, value._buttons)
        }
        
        private val __ProtoViewModelNullableSerializer = AbstractPolymorphic(ProtoViewModel).nullable()
        
    }
    //fields
    val caption: IProperty<ProtoViewModel?> get() = _caption
    val buttons: IOptProperty<ButtonCollection> get() = _buttons
    //methods
    //initializer
    init {
        bindableChildren.add("caption" to _caption)
        bindableChildren.add("buttons" to _buttons)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdProperty<ProtoViewModel?>(null, __ProtoViewModelNullableSerializer),
        RdOptionalProperty<ButtonCollection>(ButtonCollection)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTitleModel (")
        printer.indent {
            print("caption = "); _caption.print(printer); println()
            print("buttons = "); _buttons.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdTitleModel   {
        return RdTitleModel(
            _caption.deepClonePolymorphic(),
            _buttons.deepClonePolymorphic()
        )
    }
    //contexts
}
