@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [PopupsModel.kt]
 */
class PopupsModel private constructor(
    private val _bePopups: RdMap<Int, com.jetbrains.ide.model.uiautomation.BeAbstractPopup>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(ChooserPopupModel)
            serializers.register(AdText)
            serializers.register(PopupModel_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): PopupsModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return PopupsModel().apply {
                identify(protocol.identity, RdId.Null.mix("PopupsModel"))
                bind(lifetime, protocol, "PopupsModel")
            }
        }
        
        
        const val serializationHash = 652300968247710130L
        
    }
    override val serializersOwner: ISerializersOwner get() = PopupsModel
    override val serializationHash: Long get() = PopupsModel.serializationHash
    
    //fields
    val bePopups: IMutableViewableMap<Int, com.jetbrains.ide.model.uiautomation.BeAbstractPopup> get() = _bePopups
    //methods
    //initializer
    init {
        bindableChildren.add("bePopups" to _bePopups)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdMap<Int, com.jetbrains.ide.model.uiautomation.BeAbstractPopup>(FrameworkMarshallers.Int, com.jetbrains.ide.model.uiautomation.BeAbstractPopup)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("PopupsModel (")
        printer.indent {
            print("bePopups = "); _bePopups.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): PopupsModel   {
        return PopupsModel(
            _bePopups.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupsModel.kt]
 */
data class AdText (
    val text: String?,
    val alignment: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<AdText> {
        override val _type: KClass<AdText> = AdText::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): AdText  {
            val text = buffer.readNullable { buffer.readString() }
            val alignment = buffer.readInt()
            return AdText(text, alignment)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: AdText)  {
            buffer.writeNullable(value.text) { buffer.writeString(it) }
            buffer.writeInt(value.alignment)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as AdText
        
        if (text != other.text) return false
        if (alignment != other.alignment) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (text != null) text.hashCode() else 0
        __r = __r*31 + alignment.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("AdText (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("alignment = "); alignment.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [PopupsModel.kt]
 */
class ChooserPopupModel private constructor(
    private val _title: RdOptionalProperty<String>,
    private val _adText: RdOptionalProperty<AdText>,
    val content: com.jetbrains.ide.model.uiautomation.BeControl,
    private val _contentLoaded: RdSignal<Unit>,
    private val _okHandler: RdSignal<Unit>,
    private val _cancelHandler: RdSignal<Boolean>,
    val movable: Boolean,
    val focusable: Boolean,
    val requestFocus: Boolean,
    val resizable: Boolean,
    val placeWithinScreen: Boolean,
    val cancelOnClickOutside: Boolean,
    val cancelOnWindowDeactivation: Boolean,
    val cancelOnOtherWindowOpen: Boolean
) : PopupModel (
) {
    //companion
    
    companion object : IMarshaller<ChooserPopupModel> {
        override val _type: KClass<ChooserPopupModel> = ChooserPopupModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ChooserPopupModel  {
            val _id = RdId.read(buffer)
            val _title = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _adText = RdOptionalProperty.read(ctx, buffer, AdText)
            val content = ctx.serializers.readPolymorphic<com.jetbrains.ide.model.uiautomation.BeControl>(ctx, buffer, com.jetbrains.ide.model.uiautomation.BeControl)
            val _contentLoaded = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _okHandler = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _cancelHandler = RdSignal.read(ctx, buffer, FrameworkMarshallers.Bool)
            val movable = buffer.readBool()
            val focusable = buffer.readBool()
            val requestFocus = buffer.readBool()
            val resizable = buffer.readBool()
            val placeWithinScreen = buffer.readBool()
            val cancelOnClickOutside = buffer.readBool()
            val cancelOnWindowDeactivation = buffer.readBool()
            val cancelOnOtherWindowOpen = buffer.readBool()
            return ChooserPopupModel(_title, _adText, content, _contentLoaded, _okHandler, _cancelHandler, movable, focusable, requestFocus, resizable, placeWithinScreen, cancelOnClickOutside, cancelOnWindowDeactivation, cancelOnOtherWindowOpen).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ChooserPopupModel)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._title)
            RdOptionalProperty.write(ctx, buffer, value._adText)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            RdSignal.write(ctx, buffer, value._contentLoaded)
            RdSignal.write(ctx, buffer, value._okHandler)
            RdSignal.write(ctx, buffer, value._cancelHandler)
            buffer.writeBool(value.movable)
            buffer.writeBool(value.focusable)
            buffer.writeBool(value.requestFocus)
            buffer.writeBool(value.resizable)
            buffer.writeBool(value.placeWithinScreen)
            buffer.writeBool(value.cancelOnClickOutside)
            buffer.writeBool(value.cancelOnWindowDeactivation)
            buffer.writeBool(value.cancelOnOtherWindowOpen)
        }
        
        
    }
    //fields
    val title: IOptProperty<String> get() = _title
    val adText: IOptProperty<AdText> get() = _adText
    val contentLoaded: ISignal<Unit> get() = _contentLoaded
    val okHandler: ISignal<Unit> get() = _okHandler
    val cancelHandler: ISignal<Boolean> get() = _cancelHandler
    //methods
    //initializer
    init {
        _title.optimizeNested = true
        _adText.optimizeNested = true
    }
    
    init {
        bindableChildren.add("title" to _title)
        bindableChildren.add("adText" to _adText)
        bindableChildren.add("content" to content)
        bindableChildren.add("contentLoaded" to _contentLoaded)
        bindableChildren.add("okHandler" to _okHandler)
        bindableChildren.add("cancelHandler" to _cancelHandler)
    }
    
    //secondary constructor
    constructor(
        content: com.jetbrains.ide.model.uiautomation.BeControl,
        movable: Boolean,
        focusable: Boolean,
        requestFocus: Boolean,
        resizable: Boolean,
        placeWithinScreen: Boolean,
        cancelOnClickOutside: Boolean,
        cancelOnWindowDeactivation: Boolean,
        cancelOnOtherWindowOpen: Boolean
    ) : this(
        RdOptionalProperty<String>(FrameworkMarshallers.String),
        RdOptionalProperty<AdText>(AdText),
        content,
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdSignal<Boolean>(FrameworkMarshallers.Bool),
        movable,
        focusable,
        requestFocus,
        resizable,
        placeWithinScreen,
        cancelOnClickOutside,
        cancelOnWindowDeactivation,
        cancelOnOtherWindowOpen
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ChooserPopupModel (")
        printer.indent {
            print("title = "); _title.print(printer); println()
            print("adText = "); _adText.print(printer); println()
            print("content = "); content.print(printer); println()
            print("contentLoaded = "); _contentLoaded.print(printer); println()
            print("okHandler = "); _okHandler.print(printer); println()
            print("cancelHandler = "); _cancelHandler.print(printer); println()
            print("movable = "); movable.print(printer); println()
            print("focusable = "); focusable.print(printer); println()
            print("requestFocus = "); requestFocus.print(printer); println()
            print("resizable = "); resizable.print(printer); println()
            print("placeWithinScreen = "); placeWithinScreen.print(printer); println()
            print("cancelOnClickOutside = "); cancelOnClickOutside.print(printer); println()
            print("cancelOnWindowDeactivation = "); cancelOnWindowDeactivation.print(printer); println()
            print("cancelOnOtherWindowOpen = "); cancelOnOtherWindowOpen.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ChooserPopupModel   {
        return ChooserPopupModel(
            _title.deepClonePolymorphic(),
            _adText.deepClonePolymorphic(),
            content.deepClonePolymorphic(),
            _contentLoaded.deepClonePolymorphic(),
            _okHandler.deepClonePolymorphic(),
            _cancelHandler.deepClonePolymorphic(),
            movable,
            focusable,
            requestFocus,
            resizable,
            placeWithinScreen,
            cancelOnClickOutside,
            cancelOnWindowDeactivation,
            cancelOnOtherWindowOpen
        )
    }
    //contexts
}


/**
 * #### Generated from [PopupsModel.kt]
 */
abstract class PopupModel (
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<PopupModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): PopupModel  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return PopupModel_Unknown(unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class PopupModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : PopupModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<PopupModel_Unknown> {
        override val _type: KClass<PopupModel_Unknown> = PopupModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): PopupModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: PopupModel_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("PopupModel_Unknown (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): PopupModel_Unknown   {
        return PopupModel_Unknown(
            unknownId,
            unknownBytes
        )
    }
    //contexts
}
