@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [ProjectViewModel.kt]
 */
class ProjectViewModel private constructor(
    val contentModel: RdContentModel,
    private val _panes: RdList<RdProjectViewPane>,
    private val _activate: RdSignal<String?>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(DocumentProjectProperties)
            serializers.register(RdProjectScope)
            serializers.register(RdProjectViewItemDescriptor)
            serializers.register(RdProjectViewItem)
            serializers.register(RdProjectViewNavigation)
            serializers.register(RdContentModel)
            serializers.register(RdProjectViewPane)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): ProjectViewModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return ProjectViewModel().apply {
                identify(protocol.identity, RdId.Null.mix("ProjectViewModel"))
                bind(lifetime, protocol, "ProjectViewModel")
            }
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
        const val serializationHash = -8714833471335932601L
        
    }
    override val serializersOwner: ISerializersOwner get() = ProjectViewModel
    override val serializationHash: Long get() = ProjectViewModel.serializationHash
    
    //fields
    val panes: IMutableViewableList<RdProjectViewPane> get() = _panes
    val activate: ISignal<String?> get() = _activate
    //methods
    //initializer
    init {
        bindableChildren.add("contentModel" to contentModel)
        bindableChildren.add("panes" to _panes)
        bindableChildren.add("activate" to _activate)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdContentModel(),
        RdList<RdProjectViewPane>(RdProjectViewPane),
        RdSignal<String?>(__StringNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ProjectViewModel (")
        printer.indent {
            print("contentModel = "); contentModel.print(printer); println()
            print("panes = "); _panes.print(printer); println()
            print("activate = "); _activate.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ProjectViewModel   {
        return ProjectViewModel(
            contentModel.deepClonePolymorphic(),
            _panes.deepClonePolymorphic(),
            _activate.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [ProjectViewModel.kt]
 */
class DocumentProjectProperties private constructor(
    private val _scope: RdProperty<RdProjectScope?>,
    key: String
) : com.jetbrains.rd.ide.model.DocumentExtension (
    key
) {
    //companion
    
    companion object : IMarshaller<DocumentProjectProperties> {
        override val _type: KClass<DocumentProjectProperties> = DocumentProjectProperties::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DocumentProjectProperties  {
            val _id = RdId.read(buffer)
            val key = buffer.readString()
            val _scope = RdProperty.read(ctx, buffer, __RdProjectScopeNullableSerializer)
            return DocumentProjectProperties(_scope, key).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DocumentProjectProperties)  {
            value.rdid.write(buffer)
            buffer.writeString(value.key)
            RdProperty.write(ctx, buffer, value._scope)
        }
        
        private val __RdProjectScopeNullableSerializer = RdProjectScope.nullable()
        
    }
    //fields
    val scope: IProperty<RdProjectScope?> get() = _scope
    //methods
    //initializer
    init {
        _scope.optimizeNested = true
    }
    
    init {
        bindableChildren.add("scope" to _scope)
    }
    
    //secondary constructor
    constructor(
        key: String
    ) : this(
        RdProperty<RdProjectScope?>(null, __RdProjectScopeNullableSerializer),
        key
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DocumentProjectProperties (")
        printer.indent {
            print("scope = "); _scope.print(printer); println()
            print("key = "); key.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DocumentProjectProperties   {
        return DocumentProjectProperties(
            _scope.deepClonePolymorphic(),
            key
        )
    }
    //contexts
}


/**
 * #### Generated from [ProjectViewModel.kt]
 */
class RdContentModel private constructor(
    private val _projectName: RdOptionalProperty<String>,
    private val _moduleNames: RdList<String>,
    private val _contentRoots: RdList<String>,
    private val _moduleRoots: RdList<String>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdContentModel> {
        override val _type: KClass<RdContentModel> = RdContentModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdContentModel  {
            val _id = RdId.read(buffer)
            val _projectName = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _moduleNames = RdList.read(ctx, buffer, FrameworkMarshallers.String)
            val _contentRoots = RdList.read(ctx, buffer, FrameworkMarshallers.String)
            val _moduleRoots = RdList.read(ctx, buffer, FrameworkMarshallers.String)
            return RdContentModel(_projectName, _moduleNames, _contentRoots, _moduleRoots).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdContentModel)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._projectName)
            RdList.write(ctx, buffer, value._moduleNames)
            RdList.write(ctx, buffer, value._contentRoots)
            RdList.write(ctx, buffer, value._moduleRoots)
        }
        
        
    }
    //fields
    val projectName: IOptProperty<String> get() = _projectName
    val moduleNames: IMutableViewableList<String> get() = _moduleNames
    val contentRoots: IMutableViewableList<String> get() = _contentRoots
    val moduleRoots: IMutableViewableList<String> get() = _moduleRoots
    //methods
    //initializer
    init {
        _projectName.optimizeNested = true
        _moduleNames.optimizeNested = true
        _contentRoots.optimizeNested = true
        _moduleRoots.optimizeNested = true
    }
    
    init {
        bindableChildren.add("projectName" to _projectName)
        bindableChildren.add("moduleNames" to _moduleNames)
        bindableChildren.add("contentRoots" to _contentRoots)
        bindableChildren.add("moduleRoots" to _moduleRoots)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<String>(FrameworkMarshallers.String),
        RdList<String>(FrameworkMarshallers.String),
        RdList<String>(FrameworkMarshallers.String),
        RdList<String>(FrameworkMarshallers.String)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdContentModel (")
        printer.indent {
            print("projectName = "); _projectName.print(printer); println()
            print("moduleNames = "); _moduleNames.print(printer); println()
            print("contentRoots = "); _contentRoots.print(printer); println()
            print("moduleRoots = "); _moduleRoots.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdContentModel   {
        return RdContentModel(
            _projectName.deepClonePolymorphic(),
            _moduleNames.deepClonePolymorphic(),
            _contentRoots.deepClonePolymorphic(),
            _moduleRoots.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * shouldn't be created directly. See toProjectFileDocumentId()
 * #### Generated from [ProjectViewModel.kt]
 */
data class RdProjectScope (
    val name: String,
    val colorName: String?,
    val color: Int?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdProjectScope> {
        override val _type: KClass<RdProjectScope> = RdProjectScope::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdProjectScope  {
            val name = buffer.readString()
            val colorName = buffer.readNullable { buffer.readString() }
            val color = buffer.readNullable { buffer.readInt() }
            return RdProjectScope(name, colorName, color)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdProjectScope)  {
            buffer.writeString(value.name)
            buffer.writeNullable(value.colorName) { buffer.writeString(it) }
            buffer.writeNullable(value.color) { buffer.writeInt(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdProjectScope
        
        if (name != other.name) return false
        if (colorName != other.colorName) return false
        if (color != other.color) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (colorName != null) colorName.hashCode() else 0
        __r = __r*31 + if (color != null) color.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdProjectScope (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("colorName = "); colorName.print(printer); println()
            print("color = "); color.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ProjectViewModel.kt]
 */
data class RdProjectViewItem (
    val parentId: Int?,
    val descriptor: RdProjectViewItemDescriptor
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdProjectViewItem> {
        override val _type: KClass<RdProjectViewItem> = RdProjectViewItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdProjectViewItem  {
            val parentId = buffer.readNullable { buffer.readInt() }
            val descriptor = RdProjectViewItemDescriptor.read(ctx, buffer)
            return RdProjectViewItem(parentId, descriptor)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdProjectViewItem)  {
            buffer.writeNullable(value.parentId) { buffer.writeInt(it) }
            RdProjectViewItemDescriptor.write(ctx, buffer, value.descriptor)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdProjectViewItem
        
        if (parentId != other.parentId) return false
        if (descriptor != other.descriptor) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + descriptor.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdProjectViewItem (")
        printer.indent {
            print("parentId = "); parentId.print(printer); println()
            print("descriptor = "); descriptor.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ProjectViewModel.kt]
 */
class RdProjectViewItemDescriptor (
    val scope: RdProjectScope?,
    val path: String?,
    val sortKey: Int,
    presentation: List<com.jetbrains.rd.ide.model.RdColoredFragment>,
    icon: com.jetbrains.rd.ide.model.IconModel?,
    hasChildren: Boolean,
    canNavigate: Boolean
) : com.jetbrains.rd.ide.model.TreeNodeDescriptor (
    presentation,
    icon,
    hasChildren,
    canNavigate
) {
    //companion
    
    companion object : IMarshaller<RdProjectViewItemDescriptor> {
        override val _type: KClass<RdProjectViewItemDescriptor> = RdProjectViewItemDescriptor::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdProjectViewItemDescriptor  {
            val presentation = buffer.readList { com.jetbrains.rd.ide.model.RdColoredFragment.read(ctx, buffer) }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val hasChildren = buffer.readBool()
            val canNavigate = buffer.readBool()
            val scope = buffer.readNullable { RdProjectScope.read(ctx, buffer) }
            val path = buffer.readNullable { buffer.readString() }
            val sortKey = buffer.readInt()
            return RdProjectViewItemDescriptor(scope, path, sortKey, presentation, icon, hasChildren, canNavigate)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdProjectViewItemDescriptor)  {
            buffer.writeList(value.presentation) { v -> com.jetbrains.rd.ide.model.RdColoredFragment.write(ctx, buffer, v) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeBool(value.hasChildren)
            buffer.writeBool(value.canNavigate)
            buffer.writeNullable(value.scope) { RdProjectScope.write(ctx, buffer, it) }
            buffer.writeNullable(value.path) { buffer.writeString(it) }
            buffer.writeInt(value.sortKey)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdProjectViewItemDescriptor
        
        if (scope != other.scope) return false
        if (path != other.path) return false
        if (sortKey != other.sortKey) return false
        if (presentation != other.presentation) return false
        if (icon != other.icon) return false
        if (hasChildren != other.hasChildren) return false
        if (canNavigate != other.canNavigate) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (scope != null) scope.hashCode() else 0
        __r = __r*31 + if (path != null) path.hashCode() else 0
        __r = __r*31 + sortKey.hashCode()
        __r = __r*31 + presentation.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + hasChildren.hashCode()
        __r = __r*31 + canNavigate.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdProjectViewItemDescriptor (")
        printer.indent {
            print("scope = "); scope.print(printer); println()
            print("path = "); path.print(printer); println()
            print("sortKey = "); sortKey.print(printer); println()
            print("presentation = "); presentation.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("hasChildren = "); hasChildren.print(printer); println()
            print("canNavigate = "); canNavigate.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ProjectViewModel.kt]
 */
data class RdProjectViewNavigation (
    val id: Int,
    val requestFocus: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdProjectViewNavigation> {
        override val _type: KClass<RdProjectViewNavigation> = RdProjectViewNavigation::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdProjectViewNavigation  {
            val id = buffer.readInt()
            val requestFocus = buffer.readBool()
            return RdProjectViewNavigation(id, requestFocus)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdProjectViewNavigation)  {
            buffer.writeInt(value.id)
            buffer.writeBool(value.requestFocus)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdProjectViewNavigation
        
        if (id != other.id) return false
        if (requestFocus != other.requestFocus) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + requestFocus.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdProjectViewNavigation (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("requestFocus = "); requestFocus.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ProjectViewModel.kt]
 */
class RdProjectViewPane private constructor(
    val id: String,
    val name: String,
    val weight: Int,
    val icon: com.jetbrains.rd.ide.model.IconModel?,
    private val _items: RdMap<Int, RdProjectViewItem>,
    private val _selection: RdProperty<Int?>,
    private val _update: RdSignal<Int?>,
    private val _activate: RdSignal<Unit>,
    private val _expand: RdCall<Int, Unit>,
    private val _expandByPath: RdCall<String, Int>,
    private val _navigate: RdCall<RdProjectViewNavigation, Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdProjectViewPane> {
        override val _type: KClass<RdProjectViewPane> = RdProjectViewPane::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdProjectViewPane  {
            val _id = RdId.read(buffer)
            val id = buffer.readString()
            val name = buffer.readString()
            val weight = buffer.readInt()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val _items = RdMap.read(ctx, buffer, FrameworkMarshallers.Int, RdProjectViewItem)
            val _selection = RdProperty.read(ctx, buffer, __IntNullableSerializer)
            val _update = RdSignal.read(ctx, buffer, __IntNullableSerializer)
            val _activate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _expand = RdCall.read(ctx, buffer, FrameworkMarshallers.Int, FrameworkMarshallers.Void)
            val _expandByPath = RdCall.read(ctx, buffer, FrameworkMarshallers.String, FrameworkMarshallers.Int)
            val _navigate = RdCall.read(ctx, buffer, RdProjectViewNavigation, FrameworkMarshallers.Void)
            return RdProjectViewPane(id, name, weight, icon, _items, _selection, _update, _activate, _expand, _expandByPath, _navigate).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdProjectViewPane)  {
            value.rdid.write(buffer)
            buffer.writeString(value.id)
            buffer.writeString(value.name)
            buffer.writeInt(value.weight)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdMap.write(ctx, buffer, value._items)
            RdProperty.write(ctx, buffer, value._selection)
            RdSignal.write(ctx, buffer, value._update)
            RdSignal.write(ctx, buffer, value._activate)
            RdCall.write(ctx, buffer, value._expand)
            RdCall.write(ctx, buffer, value._expandByPath)
            RdCall.write(ctx, buffer, value._navigate)
        }
        
        private val __IntNullableSerializer = FrameworkMarshallers.Int.nullable()
        
    }
    //fields
    val items: IMutableViewableMap<Int, RdProjectViewItem> get() = _items
    val selection: IProperty<Int?> get() = _selection
    val update: ISignal<Int?> get() = _update
    val activate: ISignal<Unit> get() = _activate
    val expand: RdCall<Int, Unit> get() = _expand
    val expandByPath: RdCall<String, Int> get() = _expandByPath
    val navigate: RdCall<RdProjectViewNavigation, Unit> get() = _navigate
    //methods
    //initializer
    init {
        _items.optimizeNested = true
        _selection.optimizeNested = true
    }
    
    init {
        bindableChildren.add("items" to _items)
        bindableChildren.add("selection" to _selection)
        bindableChildren.add("update" to _update)
        bindableChildren.add("activate" to _activate)
        bindableChildren.add("expand" to _expand)
        bindableChildren.add("expandByPath" to _expandByPath)
        bindableChildren.add("navigate" to _navigate)
    }
    
    //secondary constructor
    constructor(
        id: String,
        name: String,
        weight: Int,
        icon: com.jetbrains.rd.ide.model.IconModel?
    ) : this(
        id,
        name,
        weight,
        icon,
        RdMap<Int, RdProjectViewItem>(FrameworkMarshallers.Int, RdProjectViewItem),
        RdProperty<Int?>(null, __IntNullableSerializer),
        RdSignal<Int?>(__IntNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdCall<Int, Unit>(FrameworkMarshallers.Int, FrameworkMarshallers.Void),
        RdCall<String, Int>(FrameworkMarshallers.String, FrameworkMarshallers.Int),
        RdCall<RdProjectViewNavigation, Unit>(RdProjectViewNavigation, FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdProjectViewPane (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("name = "); name.print(printer); println()
            print("weight = "); weight.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("items = "); _items.print(printer); println()
            print("selection = "); _selection.print(printer); println()
            print("update = "); _update.print(printer); println()
            print("activate = "); _activate.print(printer); println()
            print("expand = "); _expand.print(printer); println()
            print("expandByPath = "); _expandByPath.print(printer); println()
            print("navigate = "); _navigate.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdProjectViewPane   {
        return RdProjectViewPane(
            id,
            name,
            weight,
            icon,
            _items.deepClonePolymorphic(),
            _selection.deepClonePolymorphic(),
            _update.deepClonePolymorphic(),
            _activate.deepClonePolymorphic(),
            _expand.deepClonePolymorphic(),
            _expandByPath.deepClonePolymorphic(),
            _navigate.deepClonePolymorphic()
        )
    }
    //contexts
}
