@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [QuickDocHostModel.kt]
 */
class QuickDocHostModel private constructor(
    private val _startHoverDocSession: RdCall<Int, Unit>,
    private val _hoverDocSession: RdProperty<QuickDocSession?>,
    private val _hoverTooltip: RdProperty<HoverTooltip?>,
    private val _quickDocSessions: RdMap<Int, QuickDocSession>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(QuickDocElementInfo)
            serializers.register(QuickDocNavigationArgs)
            serializers.register(QuickDocSession)
            serializers.register(HoverTooltip)
        }
        
        
        
        private val __QuickDocSessionNullableSerializer = QuickDocSession.nullable()
        private val __HoverTooltipNullableSerializer = HoverTooltip.nullable()
        
        const val serializationHash = -5285275994672193892L
        
    }
    override val serializersOwner: ISerializersOwner get() = QuickDocHostModel
    override val serializationHash: Long get() = QuickDocHostModel.serializationHash
    
    //fields
    val startHoverDocSession: RdCall<Int, Unit> get() = _startHoverDocSession
    val hoverDocSession: IProperty<QuickDocSession?> get() = _hoverDocSession
    val hoverTooltip: IProperty<HoverTooltip?> get() = _hoverTooltip
    val quickDocSessions: IMutableViewableMap<Int, QuickDocSession> get() = _quickDocSessions
    //methods
    //initializer
    init {
        _startHoverDocSession.async = true
    }
    
    init {
        bindableChildren.add("startHoverDocSession" to _startHoverDocSession)
        bindableChildren.add("hoverDocSession" to _hoverDocSession)
        bindableChildren.add("hoverTooltip" to _hoverTooltip)
        bindableChildren.add("quickDocSessions" to _quickDocSessions)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdCall<Int, Unit>(FrameworkMarshallers.Int, FrameworkMarshallers.Void),
        RdProperty<QuickDocSession?>(null, __QuickDocSessionNullableSerializer),
        RdProperty<HoverTooltip?>(null, __HoverTooltipNullableSerializer),
        RdMap<Int, QuickDocSession>(FrameworkMarshallers.Int, QuickDocSession)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("QuickDocHostModel (")
        printer.indent {
            print("startHoverDocSession = "); _startHoverDocSession.print(printer); println()
            print("hoverDocSession = "); _hoverDocSession.print(printer); println()
            print("hoverTooltip = "); _hoverTooltip.print(printer); println()
            print("quickDocSessions = "); _quickDocSessions.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): QuickDocHostModel   {
        return QuickDocHostModel(
            _startHoverDocSession.deepClonePolymorphic(),
            _hoverDocSession.deepClonePolymorphic(),
            _hoverTooltip.deepClonePolymorphic(),
            _quickDocSessions.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.quickDocHostModel get() = getOrCreateExtension("quickDocHostModel", ::QuickDocHostModel)



/**
 * #### Generated from [QuickDocHostModel.kt]
 */
class HoverTooltip (
    val actionId: String,
    val text: String
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<HoverTooltip> {
        override val _type: KClass<HoverTooltip> = HoverTooltip::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HoverTooltip  {
            val _id = RdId.read(buffer)
            val actionId = buffer.readString()
            val text = buffer.readString()
            return HoverTooltip(actionId, text).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HoverTooltip)  {
            value.rdid.write(buffer)
            buffer.writeString(value.actionId)
            buffer.writeString(value.text)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HoverTooltip (")
        printer.indent {
            print("actionId = "); actionId.print(printer); println()
            print("text = "); text.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): HoverTooltip   {
        return HoverTooltip(
            actionId,
            text
        )
    }
    //contexts
}


/**
 * @property descriptionHtml This field contains HTML certain parts of which are also marked as symbols that should have syntax highlighting. HTML contains stuff unrelated to syntax highlighting, such as links or tables in the documentation.Markup only contains attributes that can be used to deduce how to highlight those regions of HTML. It has to be done this way, because the backend has no knowledge of which colors are used in the frontend, so text highlighted using pure HTML would look alien when rendered on the frontend. The text inside every RichAttributedStringModel with non-null attribute IDs is assumed to contain no HTML tags.
 * #### Generated from [QuickDocHostModel.kt]
 */
data class QuickDocElementInfo (
    val descriptionHtml: RichAttributedTextModel,
    val presentableName: String?,
    val elementId: String?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<QuickDocElementInfo> {
        override val _type: KClass<QuickDocElementInfo> = QuickDocElementInfo::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): QuickDocElementInfo  {
            val descriptionHtml = RichAttributedTextModel.read(ctx, buffer)
            val presentableName = buffer.readNullable { buffer.readString() }
            val elementId = buffer.readNullable { buffer.readString() }
            return QuickDocElementInfo(descriptionHtml, presentableName, elementId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: QuickDocElementInfo)  {
            RichAttributedTextModel.write(ctx, buffer, value.descriptionHtml)
            buffer.writeNullable(value.presentableName) { buffer.writeString(it) }
            buffer.writeNullable(value.elementId) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as QuickDocElementInfo
        
        if (descriptionHtml != other.descriptionHtml) return false
        if (presentableName != other.presentableName) return false
        if (elementId != other.elementId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + descriptionHtml.hashCode()
        __r = __r*31 + if (presentableName != null) presentableName.hashCode() else 0
        __r = __r*31 + if (elementId != null) elementId.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("QuickDocElementInfo (")
        printer.indent {
            print("descriptionHtml = "); descriptionHtml.print(printer); println()
            print("presentableName = "); presentableName.print(printer); println()
            print("elementId = "); elementId.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [QuickDocHostModel.kt]
 */
data class QuickDocNavigationArgs (
    val url: String?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<QuickDocNavigationArgs> {
        override val _type: KClass<QuickDocNavigationArgs> = QuickDocNavigationArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): QuickDocNavigationArgs  {
            val url = buffer.readNullable { buffer.readString() }
            return QuickDocNavigationArgs(url)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: QuickDocNavigationArgs)  {
            buffer.writeNullable(value.url) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as QuickDocNavigationArgs
        
        if (url != other.url) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (url != null) url.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("QuickDocNavigationArgs (")
        printer.indent {
            print("url = "); url.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [QuickDocHostModel.kt]
 */
class QuickDocSession private constructor(
    val initialInfo: QuickDocElementInfo,
    val textControl: TextControlId,
    private val _fetchInfoByLink: RdCall<String, QuickDocElementInfo>,
    private val _navigate: RdSignal<QuickDocNavigationArgs>,
    private val _fetchQuickDocAgain: RdCall<Unit, QuickDocElementInfo>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<QuickDocSession> {
        override val _type: KClass<QuickDocSession> = QuickDocSession::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): QuickDocSession  {
            val _id = RdId.read(buffer)
            val initialInfo = QuickDocElementInfo.read(ctx, buffer)
            val textControl = TextControlId.read(ctx, buffer)
            val _fetchInfoByLink = RdCall.read(ctx, buffer, FrameworkMarshallers.String, QuickDocElementInfo)
            val _navigate = RdSignal.read(ctx, buffer, QuickDocNavigationArgs)
            val _fetchQuickDocAgain = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, QuickDocElementInfo)
            return QuickDocSession(initialInfo, textControl, _fetchInfoByLink, _navigate, _fetchQuickDocAgain).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: QuickDocSession)  {
            value.rdid.write(buffer)
            QuickDocElementInfo.write(ctx, buffer, value.initialInfo)
            TextControlId.write(ctx, buffer, value.textControl)
            RdCall.write(ctx, buffer, value._fetchInfoByLink)
            RdSignal.write(ctx, buffer, value._navigate)
            RdCall.write(ctx, buffer, value._fetchQuickDocAgain)
        }
        
        
    }
    //fields
    val fetchInfoByLink: RdCall<String, QuickDocElementInfo> get() = _fetchInfoByLink
    val navigate: ISignal<QuickDocNavigationArgs> get() = _navigate
    val fetchQuickDocAgain: RdCall<Unit, QuickDocElementInfo> get() = _fetchQuickDocAgain
    //methods
    //initializer
    init {
        _fetchQuickDocAgain.async = true
    }
    
    init {
        bindableChildren.add("fetchInfoByLink" to _fetchInfoByLink)
        bindableChildren.add("navigate" to _navigate)
        bindableChildren.add("fetchQuickDocAgain" to _fetchQuickDocAgain)
    }
    
    //secondary constructor
    constructor(
        initialInfo: QuickDocElementInfo,
        textControl: TextControlId
    ) : this(
        initialInfo,
        textControl,
        RdCall<String, QuickDocElementInfo>(FrameworkMarshallers.String, QuickDocElementInfo),
        RdSignal<QuickDocNavigationArgs>(QuickDocNavigationArgs),
        RdCall<Unit, QuickDocElementInfo>(FrameworkMarshallers.Void, QuickDocElementInfo)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("QuickDocSession (")
        printer.indent {
            print("initialInfo = "); initialInfo.print(printer); println()
            print("textControl = "); textControl.print(printer); println()
            print("fetchInfoByLink = "); _fetchInfoByLink.print(printer); println()
            print("navigate = "); _navigate.print(printer); println()
            print("fetchQuickDocAgain = "); _fetchQuickDocAgain.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): QuickDocSession   {
        return QuickDocSession(
            initialInfo,
            textControl,
            _fetchInfoByLink.deepClonePolymorphic(),
            _navigate.deepClonePolymorphic(),
            _fetchQuickDocAgain.deepClonePolymorphic()
        )
    }
    //contexts
}
