@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [RunConfigurationModel.kt]
 */
class RunConfigurationModel private constructor(
    private val _runConfigurations: RdOptionalProperty<List<RunConfiguration>>,
    private val _templates: RdOptionalProperty<List<RunConfigurationTemplate>>,
    private val _createAndRun: RdSignal<RunConfigurationTemplate>,
    private val _run: RdSignal<RunConfiguration>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RunConfiguration)
            serializers.register(RunConfigurationExecutorDescriptor)
            serializers.register(RunConfigurationTemplateKey.marshaller)
            serializers.register(RunConfigurationTemplateEntry)
            serializers.register(RunConfigurationTemplate)
        }
        
        
        
        private val __RunConfigurationListSerializer = RunConfiguration.list()
        private val __RunConfigurationTemplateListSerializer = RunConfigurationTemplate.list()
        
        const val serializationHash = -8180805384007385732L
        
    }
    override val serializersOwner: ISerializersOwner get() = RunConfigurationModel
    override val serializationHash: Long get() = RunConfigurationModel.serializationHash
    
    //fields
    val runConfigurations: IOptProperty<List<RunConfiguration>> get() = _runConfigurations
    val templates: IOptProperty<List<RunConfigurationTemplate>> get() = _templates
    val createAndRun: ISignal<RunConfigurationTemplate> get() = _createAndRun
    val run: ISignal<RunConfiguration> get() = _run
    //methods
    //initializer
    init {
        _runConfigurations.optimizeNested = true
        _templates.optimizeNested = true
    }
    
    init {
        bindableChildren.add("runConfigurations" to _runConfigurations)
        bindableChildren.add("templates" to _templates)
        bindableChildren.add("createAndRun" to _createAndRun)
        bindableChildren.add("run" to _run)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdOptionalProperty<List<RunConfiguration>>(__RunConfigurationListSerializer),
        RdOptionalProperty<List<RunConfigurationTemplate>>(__RunConfigurationTemplateListSerializer),
        RdSignal<RunConfigurationTemplate>(RunConfigurationTemplate),
        RdSignal<RunConfiguration>(RunConfiguration)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RunConfigurationModel (")
        printer.indent {
            print("runConfigurations = "); _runConfigurations.print(printer); println()
            print("templates = "); _templates.print(printer); println()
            print("createAndRun = "); _createAndRun.print(printer); println()
            print("run = "); _run.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RunConfigurationModel   {
        return RunConfigurationModel(
            _runConfigurations.deepClonePolymorphic(),
            _templates.deepClonePolymorphic(),
            _createAndRun.deepClonePolymorphic(),
            _run.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.runConfigurationModel get() = getOrCreateExtension("runConfigurationModel", ::RunConfigurationModel)



/**
 * #### Generated from [RunConfigurationModel.kt]
 */
data class RunConfiguration (
    val typeId: String,
    val name: String,
    val projectFilePath: String,
    val executor: RunConfigurationExecutorDescriptor
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RunConfiguration> {
        override val _type: KClass<RunConfiguration> = RunConfiguration::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RunConfiguration  {
            val typeId = buffer.readString()
            val name = buffer.readString()
            val projectFilePath = buffer.readString()
            val executor = RunConfigurationExecutorDescriptor.read(ctx, buffer)
            return RunConfiguration(typeId, name, projectFilePath, executor)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RunConfiguration)  {
            buffer.writeString(value.typeId)
            buffer.writeString(value.name)
            buffer.writeString(value.projectFilePath)
            RunConfigurationExecutorDescriptor.write(ctx, buffer, value.executor)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RunConfiguration
        
        if (typeId != other.typeId) return false
        if (name != other.name) return false
        if (projectFilePath != other.projectFilePath) return false
        if (executor != other.executor) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + typeId.hashCode()
        __r = __r*31 + name.hashCode()
        __r = __r*31 + projectFilePath.hashCode()
        __r = __r*31 + executor.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RunConfiguration (")
        printer.indent {
            print("typeId = "); typeId.print(printer); println()
            print("name = "); name.print(printer); println()
            print("projectFilePath = "); projectFilePath.print(printer); println()
            print("executor = "); executor.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [RunConfigurationModel.kt]
 */
data class RunConfigurationExecutorDescriptor (
    val id: String,
    val displayName: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RunConfigurationExecutorDescriptor> {
        override val _type: KClass<RunConfigurationExecutorDescriptor> = RunConfigurationExecutorDescriptor::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RunConfigurationExecutorDescriptor  {
            val id = buffer.readString()
            val displayName = buffer.readString()
            return RunConfigurationExecutorDescriptor(id, displayName)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RunConfigurationExecutorDescriptor)  {
            buffer.writeString(value.id)
            buffer.writeString(value.displayName)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RunConfigurationExecutorDescriptor
        
        if (id != other.id) return false
        if (displayName != other.displayName) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + displayName.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RunConfigurationExecutorDescriptor (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("displayName = "); displayName.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [RunConfigurationModel.kt]
 */
data class RunConfigurationTemplate (
    val executor: RunConfigurationExecutorDescriptor,
    val typeId: String,
    val compatibleRunnableProjectKinds: List<String>,
    val entries: List<RunConfigurationTemplateEntry>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RunConfigurationTemplate> {
        override val _type: KClass<RunConfigurationTemplate> = RunConfigurationTemplate::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RunConfigurationTemplate  {
            val executor = RunConfigurationExecutorDescriptor.read(ctx, buffer)
            val typeId = buffer.readString()
            val compatibleRunnableProjectKinds = buffer.readList { buffer.readString() }
            val entries = buffer.readList { RunConfigurationTemplateEntry.read(ctx, buffer) }
            return RunConfigurationTemplate(executor, typeId, compatibleRunnableProjectKinds, entries)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RunConfigurationTemplate)  {
            RunConfigurationExecutorDescriptor.write(ctx, buffer, value.executor)
            buffer.writeString(value.typeId)
            buffer.writeList(value.compatibleRunnableProjectKinds) { v -> buffer.writeString(v) }
            buffer.writeList(value.entries) { v -> RunConfigurationTemplateEntry.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RunConfigurationTemplate
        
        if (executor != other.executor) return false
        if (typeId != other.typeId) return false
        if (compatibleRunnableProjectKinds != other.compatibleRunnableProjectKinds) return false
        if (entries != other.entries) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + executor.hashCode()
        __r = __r*31 + typeId.hashCode()
        __r = __r*31 + compatibleRunnableProjectKinds.hashCode()
        __r = __r*31 + entries.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RunConfigurationTemplate (")
        printer.indent {
            print("executor = "); executor.print(printer); println()
            print("typeId = "); typeId.print(printer); println()
            print("compatibleRunnableProjectKinds = "); compatibleRunnableProjectKinds.print(printer); println()
            print("entries = "); entries.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [RunConfigurationModel.kt]
 */
data class RunConfigurationTemplateEntry (
    val key: RunConfigurationTemplateKey,
    val value: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RunConfigurationTemplateEntry> {
        override val _type: KClass<RunConfigurationTemplateEntry> = RunConfigurationTemplateEntry::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RunConfigurationTemplateEntry  {
            val key = buffer.readEnum<RunConfigurationTemplateKey>()
            val value = buffer.readString()
            return RunConfigurationTemplateEntry(key, value)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RunConfigurationTemplateEntry)  {
            buffer.writeEnum(value.key)
            buffer.writeString(value.value)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RunConfigurationTemplateEntry
        
        if (key != other.key) return false
        if (value != other.value) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + key.hashCode()
        __r = __r*31 + value.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RunConfigurationTemplateEntry (")
        printer.indent {
            print("key = "); key.print(printer); println()
            print("value = "); value.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [RunConfigurationModel.kt]
 */
enum class RunConfigurationTemplateKey {
    Name, 
    ProjectFilePath, 
    ProjectKind, 
    TargetFramework, 
    StaticMethodName;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<RunConfigurationTemplateKey>()
        
    }
}
