@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [SettingsModel.kt]
 */
class SettingsModel private constructor(
    private val _protocolStorage: RdMap<KeyPathComponents, PredefinedValue>,
    private val _rightMargin: RdOptionalProperty<Int>,
    private val _virtualSpace: RdOptionalProperty<Boolean>,
    private val _lineSeparator: RdOptionalProperty<LineSeparators>,
    private val _matchCase: RdOptionalProperty<MatchCase>,
    private val _insertPairBracket: RdOptionalProperty<Boolean>,
    private val _insertPairQuote: RdOptionalProperty<Boolean>,
    private val _surroundSelectionOnTyping: RdOptionalProperty<Boolean>,
    private val _reformatBlockOnClosingBrace: RdOptionalProperty<Boolean>,
    private val _useCamelHumps: RdOptionalProperty<Boolean>,
    private val _isMouseClickSelectionHonorsCamelWords: RdOptionalProperty<Boolean>,
    private val _isIndentGuidesShown: RdOptionalProperty<Boolean>,
    private val _customSoftWrapIndent: RdOptionalProperty<Int>,
    private val _insertPairBraceOnEnter: RdOptionalProperty<Boolean>,
    private val _reformatOnPaste: RdOptionalProperty<ReformatOnPasteKind>,
    private val _smartBackspace: RdOptionalProperty<SmartBackspaceKind>,
    private val _smartIndent: RdOptionalProperty<Boolean>,
    private val _noBomForNewFiles: RdOptionalProperty<Boolean>,
    private val _showBuildProgressOnStatusBar: RdOptionalProperty<Boolean>,
    private val _showBuildProgressOnTaskBar: RdOptionalProperty<Boolean>,
    private val _showResultAfterBuild: RdOptionalProperty<WhenShowBuildResultMode>,
    private val _showBuildProgressInToolWindow: RdOptionalProperty<Boolean>,
    private val _winFormsEnabled: RdOptionalProperty<Boolean>,
    private val _showDesignerExceptions: RdOptionalProperty<Boolean>,
    private val _inlayHintsEnabled: RdOptionalProperty<Boolean>,
    private val _paramHintsEnabled: RdOptionalProperty<Boolean>,
    private val _pushToHintEnabled: RdOptionalProperty<Boolean>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(LineSeparators.marshaller)
            serializers.register(RdLanguage)
            serializers.register(ReformatOnPasteKind.marshaller)
            serializers.register(SmartBackspaceKind.marshaller)
            serializers.register(KeyPathComponents)
            serializers.register(IntegerValue)
            serializers.register(BooleanValue)
            serializers.register(DoubleValue)
            serializers.register(StringValue)
            serializers.register(WhenShowBuildResultMode.marshaller)
            serializers.register(MatchCase.marshaller)
            serializers.register(PredefinedValue_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): SettingsModel  {
            IdeRoot.register(protocol.serializers)
            
            return SettingsModel().apply {
                identify(protocol.identity, RdId.Null.mix("SettingsModel"))
                bind(lifetime, protocol, "SettingsModel")
            }
        }
        
        
        const val serializationHash = 2822377652820703899L
        
    }
    override val serializersOwner: ISerializersOwner get() = SettingsModel
    override val serializationHash: Long get() = SettingsModel.serializationHash
    
    //fields
    val protocolStorage: IMutableViewableMap<KeyPathComponents, PredefinedValue> get() = _protocolStorage
    val rightMargin: IOptProperty<Int> get() = _rightMargin
    val virtualSpace: IOptProperty<Boolean> get() = _virtualSpace
    val lineSeparator: IOptProperty<LineSeparators> get() = _lineSeparator
    val matchCase: IOptProperty<MatchCase> get() = _matchCase
    val insertPairBracket: IOptProperty<Boolean> get() = _insertPairBracket
    val insertPairQuote: IOptProperty<Boolean> get() = _insertPairQuote
    val surroundSelectionOnTyping: IOptProperty<Boolean> get() = _surroundSelectionOnTyping
    val reformatBlockOnClosingBrace: IOptProperty<Boolean> get() = _reformatBlockOnClosingBrace
    val useCamelHumps: IOptProperty<Boolean> get() = _useCamelHumps
    val isMouseClickSelectionHonorsCamelWords: IOptProperty<Boolean> get() = _isMouseClickSelectionHonorsCamelWords
    val isIndentGuidesShown: IOptProperty<Boolean> get() = _isIndentGuidesShown
    val customSoftWrapIndent: IOptProperty<Int> get() = _customSoftWrapIndent
    val insertPairBraceOnEnter: IOptProperty<Boolean> get() = _insertPairBraceOnEnter
    val reformatOnPaste: IOptProperty<ReformatOnPasteKind> get() = _reformatOnPaste
    val smartBackspace: IOptProperty<SmartBackspaceKind> get() = _smartBackspace
    val smartIndent: IOptProperty<Boolean> get() = _smartIndent
    val noBomForNewFiles: IOptProperty<Boolean> get() = _noBomForNewFiles
    val showBuildProgressOnStatusBar: IOptProperty<Boolean> get() = _showBuildProgressOnStatusBar
    val showBuildProgressOnTaskBar: IOptProperty<Boolean> get() = _showBuildProgressOnTaskBar
    val showResultAfterBuild: IOptProperty<WhenShowBuildResultMode> get() = _showResultAfterBuild
    val showBuildProgressInToolWindow: IOptProperty<Boolean> get() = _showBuildProgressInToolWindow
    val winFormsEnabled: IOptProperty<Boolean> get() = _winFormsEnabled
    val showDesignerExceptions: IOptProperty<Boolean> get() = _showDesignerExceptions
    val inlayHintsEnabled: IOptProperty<Boolean> get() = _inlayHintsEnabled
    val paramHintsEnabled: IOptProperty<Boolean> get() = _paramHintsEnabled
    val pushToHintEnabled: IOptProperty<Boolean> get() = _pushToHintEnabled
    //methods
    //initializer
    init {
        _protocolStorage.optimizeNested = true
        _rightMargin.optimizeNested = true
        _virtualSpace.optimizeNested = true
        _lineSeparator.optimizeNested = true
        _matchCase.optimizeNested = true
        _insertPairBracket.optimizeNested = true
        _insertPairQuote.optimizeNested = true
        _surroundSelectionOnTyping.optimizeNested = true
        _reformatBlockOnClosingBrace.optimizeNested = true
        _useCamelHumps.optimizeNested = true
        _isMouseClickSelectionHonorsCamelWords.optimizeNested = true
        _isIndentGuidesShown.optimizeNested = true
        _customSoftWrapIndent.optimizeNested = true
        _insertPairBraceOnEnter.optimizeNested = true
        _reformatOnPaste.optimizeNested = true
        _smartBackspace.optimizeNested = true
        _smartIndent.optimizeNested = true
        _noBomForNewFiles.optimizeNested = true
        _showBuildProgressOnStatusBar.optimizeNested = true
        _showBuildProgressOnTaskBar.optimizeNested = true
        _showResultAfterBuild.optimizeNested = true
        _showBuildProgressInToolWindow.optimizeNested = true
        _winFormsEnabled.optimizeNested = true
        _showDesignerExceptions.optimizeNested = true
        _inlayHintsEnabled.optimizeNested = true
        _paramHintsEnabled.optimizeNested = true
        _pushToHintEnabled.optimizeNested = true
    }
    
    init {
        bindableChildren.add("protocolStorage" to _protocolStorage)
        bindableChildren.add("rightMargin" to _rightMargin)
        bindableChildren.add("virtualSpace" to _virtualSpace)
        bindableChildren.add("lineSeparator" to _lineSeparator)
        bindableChildren.add("matchCase" to _matchCase)
        bindableChildren.add("insertPairBracket" to _insertPairBracket)
        bindableChildren.add("insertPairQuote" to _insertPairQuote)
        bindableChildren.add("surroundSelectionOnTyping" to _surroundSelectionOnTyping)
        bindableChildren.add("reformatBlockOnClosingBrace" to _reformatBlockOnClosingBrace)
        bindableChildren.add("useCamelHumps" to _useCamelHumps)
        bindableChildren.add("isMouseClickSelectionHonorsCamelWords" to _isMouseClickSelectionHonorsCamelWords)
        bindableChildren.add("isIndentGuidesShown" to _isIndentGuidesShown)
        bindableChildren.add("customSoftWrapIndent" to _customSoftWrapIndent)
        bindableChildren.add("insertPairBraceOnEnter" to _insertPairBraceOnEnter)
        bindableChildren.add("reformatOnPaste" to _reformatOnPaste)
        bindableChildren.add("smartBackspace" to _smartBackspace)
        bindableChildren.add("smartIndent" to _smartIndent)
        bindableChildren.add("noBomForNewFiles" to _noBomForNewFiles)
        bindableChildren.add("showBuildProgressOnStatusBar" to _showBuildProgressOnStatusBar)
        bindableChildren.add("showBuildProgressOnTaskBar" to _showBuildProgressOnTaskBar)
        bindableChildren.add("showResultAfterBuild" to _showResultAfterBuild)
        bindableChildren.add("showBuildProgressInToolWindow" to _showBuildProgressInToolWindow)
        bindableChildren.add("winFormsEnabled" to _winFormsEnabled)
        bindableChildren.add("showDesignerExceptions" to _showDesignerExceptions)
        bindableChildren.add("inlayHintsEnabled" to _inlayHintsEnabled)
        bindableChildren.add("paramHintsEnabled" to _paramHintsEnabled)
        bindableChildren.add("pushToHintEnabled" to _pushToHintEnabled)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdMap<KeyPathComponents, PredefinedValue>(KeyPathComponents, AbstractPolymorphic(PredefinedValue)),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<LineSeparators>(LineSeparators.marshaller),
        RdOptionalProperty<MatchCase>(MatchCase.marshaller),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<ReformatOnPasteKind>(ReformatOnPasteKind.marshaller),
        RdOptionalProperty<SmartBackspaceKind>(SmartBackspaceKind.marshaller),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<WhenShowBuildResultMode>(WhenShowBuildResultMode.marshaller),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SettingsModel (")
        printer.indent {
            print("protocolStorage = "); _protocolStorage.print(printer); println()
            print("rightMargin = "); _rightMargin.print(printer); println()
            print("virtualSpace = "); _virtualSpace.print(printer); println()
            print("lineSeparator = "); _lineSeparator.print(printer); println()
            print("matchCase = "); _matchCase.print(printer); println()
            print("insertPairBracket = "); _insertPairBracket.print(printer); println()
            print("insertPairQuote = "); _insertPairQuote.print(printer); println()
            print("surroundSelectionOnTyping = "); _surroundSelectionOnTyping.print(printer); println()
            print("reformatBlockOnClosingBrace = "); _reformatBlockOnClosingBrace.print(printer); println()
            print("useCamelHumps = "); _useCamelHumps.print(printer); println()
            print("isMouseClickSelectionHonorsCamelWords = "); _isMouseClickSelectionHonorsCamelWords.print(printer); println()
            print("isIndentGuidesShown = "); _isIndentGuidesShown.print(printer); println()
            print("customSoftWrapIndent = "); _customSoftWrapIndent.print(printer); println()
            print("insertPairBraceOnEnter = "); _insertPairBraceOnEnter.print(printer); println()
            print("reformatOnPaste = "); _reformatOnPaste.print(printer); println()
            print("smartBackspace = "); _smartBackspace.print(printer); println()
            print("smartIndent = "); _smartIndent.print(printer); println()
            print("noBomForNewFiles = "); _noBomForNewFiles.print(printer); println()
            print("showBuildProgressOnStatusBar = "); _showBuildProgressOnStatusBar.print(printer); println()
            print("showBuildProgressOnTaskBar = "); _showBuildProgressOnTaskBar.print(printer); println()
            print("showResultAfterBuild = "); _showResultAfterBuild.print(printer); println()
            print("showBuildProgressInToolWindow = "); _showBuildProgressInToolWindow.print(printer); println()
            print("winFormsEnabled = "); _winFormsEnabled.print(printer); println()
            print("showDesignerExceptions = "); _showDesignerExceptions.print(printer); println()
            print("inlayHintsEnabled = "); _inlayHintsEnabled.print(printer); println()
            print("paramHintsEnabled = "); _paramHintsEnabled.print(printer); println()
            print("pushToHintEnabled = "); _pushToHintEnabled.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): SettingsModel   {
        return SettingsModel(
            _protocolStorage.deepClonePolymorphic(),
            _rightMargin.deepClonePolymorphic(),
            _virtualSpace.deepClonePolymorphic(),
            _lineSeparator.deepClonePolymorphic(),
            _matchCase.deepClonePolymorphic(),
            _insertPairBracket.deepClonePolymorphic(),
            _insertPairQuote.deepClonePolymorphic(),
            _surroundSelectionOnTyping.deepClonePolymorphic(),
            _reformatBlockOnClosingBrace.deepClonePolymorphic(),
            _useCamelHumps.deepClonePolymorphic(),
            _isMouseClickSelectionHonorsCamelWords.deepClonePolymorphic(),
            _isIndentGuidesShown.deepClonePolymorphic(),
            _customSoftWrapIndent.deepClonePolymorphic(),
            _insertPairBraceOnEnter.deepClonePolymorphic(),
            _reformatOnPaste.deepClonePolymorphic(),
            _smartBackspace.deepClonePolymorphic(),
            _smartIndent.deepClonePolymorphic(),
            _noBomForNewFiles.deepClonePolymorphic(),
            _showBuildProgressOnStatusBar.deepClonePolymorphic(),
            _showBuildProgressOnTaskBar.deepClonePolymorphic(),
            _showResultAfterBuild.deepClonePolymorphic(),
            _showBuildProgressInToolWindow.deepClonePolymorphic(),
            _winFormsEnabled.deepClonePolymorphic(),
            _showDesignerExceptions.deepClonePolymorphic(),
            _inlayHintsEnabled.deepClonePolymorphic(),
            _paramHintsEnabled.deepClonePolymorphic(),
            _pushToHintEnabled.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SettingsModel.kt]
 */
class BooleanValue (
    val value: Boolean
) : PredefinedValue (
) {
    //companion
    
    companion object : IMarshaller<BooleanValue> {
        override val _type: KClass<BooleanValue> = BooleanValue::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BooleanValue  {
            val value = buffer.readBool()
            return BooleanValue(value)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BooleanValue)  {
            buffer.writeBool(value.value)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BooleanValue
        
        if (value != other.value) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + value.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BooleanValue (")
        printer.indent {
            print("value = "); value.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SettingsModel.kt]
 */
class DoubleValue (
    val value: Double
) : PredefinedValue (
) {
    //companion
    
    companion object : IMarshaller<DoubleValue> {
        override val _type: KClass<DoubleValue> = DoubleValue::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DoubleValue  {
            val value = buffer.readDouble()
            return DoubleValue(value)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DoubleValue)  {
            buffer.writeDouble(value.value)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DoubleValue
        
        if (value != other.value) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + value.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DoubleValue (")
        printer.indent {
            print("value = "); value.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SettingsModel.kt]
 */
class IntegerValue (
    val value: Int
) : PredefinedValue (
) {
    //companion
    
    companion object : IMarshaller<IntegerValue> {
        override val _type: KClass<IntegerValue> = IntegerValue::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): IntegerValue  {
            val value = buffer.readInt()
            return IntegerValue(value)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: IntegerValue)  {
            buffer.writeInt(value.value)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as IntegerValue
        
        if (value != other.value) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + value.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("IntegerValue (")
        printer.indent {
            print("value = "); value.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SettingsModel.kt]
 */
data class KeyPathComponents (
    val rawKey: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<KeyPathComponents> {
        override val _type: KClass<KeyPathComponents> = KeyPathComponents::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): KeyPathComponents  {
            val rawKey = buffer.readString()
            return KeyPathComponents(rawKey)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: KeyPathComponents)  {
            buffer.writeString(value.rawKey)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as KeyPathComponents
        
        if (rawKey != other.rawKey) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + rawKey.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("KeyPathComponents (")
        printer.indent {
            print("rawKey = "); rawKey.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SettingsModel.kt]
 */
enum class LineSeparators {
    LF, 
    CR, 
    CRLF;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<LineSeparators>()
        
    }
}


/**
 * #### Generated from [SettingsModel.kt]
 */
enum class MatchCase {
    ALL, 
    NONE, 
    FIRST_LETTER;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<MatchCase>()
        
    }
}


/**
 * #### Generated from [SettingsModel.kt]
 */
abstract class PredefinedValue (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<PredefinedValue> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): PredefinedValue  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return PredefinedValue_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class PredefinedValue_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : PredefinedValue (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<PredefinedValue_Unknown> {
        override val _type: KClass<PredefinedValue_Unknown> = PredefinedValue_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): PredefinedValue_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: PredefinedValue_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as PredefinedValue_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("PredefinedValue_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SettingsModel.kt]
 */
data class RdLanguage (
    val name: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdLanguage> {
        override val _type: KClass<RdLanguage> = RdLanguage::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdLanguage  {
            val name = buffer.readString()
            return RdLanguage(name)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdLanguage)  {
            buffer.writeString(value.name)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdLanguage
        
        if (name != other.name) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdLanguage (")
        printer.indent {
            print("name = "); name.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SettingsModel.kt]
 */
enum class ReformatOnPasteKind {
    NONE, 
    INDENT_EACH_LINE, 
    INDENT_BLOCK, 
    REFORMAT_BLOCK;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ReformatOnPasteKind>()
        
    }
}


/**
 * #### Generated from [SettingsModel.kt]
 */
enum class SmartBackspaceKind {
    OFF, 
    AUTOINDENT, 
    INDENT;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<SmartBackspaceKind>()
        
    }
}


/**
 * #### Generated from [SettingsModel.kt]
 */
class StringValue (
    val value: String
) : PredefinedValue (
) {
    //companion
    
    companion object : IMarshaller<StringValue> {
        override val _type: KClass<StringValue> = StringValue::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): StringValue  {
            val value = buffer.readString()
            return StringValue(value)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: StringValue)  {
            buffer.writeString(value.value)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as StringValue
        
        if (value != other.value) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + value.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("StringValue (")
        printer.indent {
            print("value = "); value.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SettingsModel.kt]
 */
enum class WhenShowBuildResultMode {
    Always, 
    ForWarningsOrErrors, 
    ForErrors, 
    Never;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<WhenShowBuildResultMode>()
        
    }
}
