@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [ShellModel.kt]
 */
class ShellModel private constructor(
    private val _lookAndFeelTheme: RdOptionalProperty<LookAndFeelTheme>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(ImageSourceIconModel)
            serializers.register(CompositionIconModel)
            serializers.register(RotatedIconModel)
            serializers.register(ShellIconModel)
            serializers.register(ColorIconModel)
            serializers.register(ColorizedIconModel)
            serializers.register(IdeaIconModel)
            serializers.register(RowIconModel)
            serializers.register(FrontendIconModel)
            serializers.register(ImageIconInternWrapper)
            serializers.register(ImageIconModel)
            serializers.register(EffectStyle.marshaller)
            serializers.register(FontStyle.marshaller)
            serializers.register(RichStringModel)
            serializers.register(RichTextModel)
            serializers.register(RichAttributedStringModel)
            serializers.register(RichAttributedTextModel)
            serializers.register(ContentAlignmentKind.marshaller)
            serializers.register(RichTextBlockModel)
            serializers.register(EnvironmentVariable)
            serializers.register(LookAndFeelTheme.marshaller)
            serializers.register(IconSource)
            serializers.register(IconModel_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): ShellModel  {
            IdeRoot.register(protocol.serializers)
            
            return ShellModel().apply {
                identify(protocol.identity, RdId.Null.mix("ShellModel"))
                bind(lifetime, protocol, "ShellModel")
            }
        }
        
        
        const val serializationHash = -1444674705624874216L
        
    }
    override val serializersOwner: ISerializersOwner get() = ShellModel
    override val serializationHash: Long get() = ShellModel.serializationHash
    
    //fields
    val lookAndFeelTheme: IOptProperty<LookAndFeelTheme> get() = _lookAndFeelTheme
    //methods
    //initializer
    init {
        _lookAndFeelTheme.optimizeNested = true
    }
    
    init {
        bindableChildren.add("lookAndFeelTheme" to _lookAndFeelTheme)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdOptionalProperty<LookAndFeelTheme>(LookAndFeelTheme.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ShellModel (")
        printer.indent {
            print("lookAndFeelTheme = "); _lookAndFeelTheme.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ShellModel   {
        return ShellModel(
            _lookAndFeelTheme.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
class ColorIconModel (
    val color: RgbaColor
) : IconModel (
) {
    //companion
    
    companion object : IMarshaller<ColorIconModel> {
        override val _type: KClass<ColorIconModel> = ColorIconModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ColorIconModel  {
            val color = RgbaColor.read(ctx, buffer)
            return ColorIconModel(color)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ColorIconModel)  {
            RgbaColor.write(ctx, buffer, value.color)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ColorIconModel
        
        if (color != other.color) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + color.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ColorIconModel (")
        printer.indent {
            print("color = "); color.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
class ColorizedIconModel (
    val color: RgbaColor,
    val base: IconModel
) : IconModel (
) {
    //companion
    
    companion object : IMarshaller<ColorizedIconModel> {
        override val _type: KClass<ColorizedIconModel> = ColorizedIconModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ColorizedIconModel  {
            val color = RgbaColor.read(ctx, buffer)
            val base = ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel)
            return ColorizedIconModel(color, base)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ColorizedIconModel)  {
            RgbaColor.write(ctx, buffer, value.color)
            ctx.serializers.writePolymorphic(ctx, buffer, value.base)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ColorizedIconModel
        
        if (color != other.color) return false
        if (base != other.base) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + color.hashCode()
        __r = __r*31 + base.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ColorizedIconModel (")
        printer.indent {
            print("color = "); color.print(printer); println()
            print("base = "); base.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
class CompositionIconModel (
    val subNodes: List<IconModel>
) : IconModel (
) {
    //companion
    
    companion object : IMarshaller<CompositionIconModel> {
        override val _type: KClass<CompositionIconModel> = CompositionIconModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CompositionIconModel  {
            val subNodes = buffer.readList { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            return CompositionIconModel(subNodes)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CompositionIconModel)  {
            buffer.writeList(value.subNodes) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CompositionIconModel
        
        if (subNodes != other.subNodes) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + subNodes.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CompositionIconModel (")
        printer.indent {
            print("subNodes = "); subNodes.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
enum class ContentAlignmentKind {
    None, 
    TopLeft;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ContentAlignmentKind>()
        
    }
}


/**
 * #### Generated from [ShellModel.kt]
 */
enum class EffectStyle {
    None, 
    StraightUnderline, 
    WeavyUnderline, 
    StrikeOut, 
    SearchMatch_IDEA;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<EffectStyle>()
        
    }
}


/**
 * #### Generated from [ShellModel.kt]
 */
data class EnvironmentVariable (
    val key: String,
    val value: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<EnvironmentVariable> {
        override val _type: KClass<EnvironmentVariable> = EnvironmentVariable::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): EnvironmentVariable  {
            val key = buffer.readString()
            val value = buffer.readString()
            return EnvironmentVariable(key, value)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: EnvironmentVariable)  {
            buffer.writeString(value.key)
            buffer.writeString(value.value)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as EnvironmentVariable
        
        if (key != other.key) return false
        if (value != other.value) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + key.hashCode()
        __r = __r*31 + value.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("EnvironmentVariable (")
        printer.indent {
            print("key = "); key.print(printer); println()
            print("value = "); value.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
enum class FontStyle {
    Regular, 
    Bold, 
    Italic, 
    Underline, 
    Strikeout;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<FontStyle>()
        
    }
}


/**
 * #### Generated from [ShellModel.kt]
 */
class FrontendIconModel (
    val path: String
) : IconModel (
) {
    //companion
    
    companion object : IMarshaller<FrontendIconModel> {
        override val _type: KClass<FrontendIconModel> = FrontendIconModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FrontendIconModel  {
            val path = buffer.readString()
            return FrontendIconModel(path)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FrontendIconModel)  {
            buffer.writeString(value.path)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FrontendIconModel
        
        if (path != other.path) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + path.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FrontendIconModel (")
        printer.indent {
            print("path = "); path.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
abstract class IconModel (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<IconModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): IconModel  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return IconModel_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class IconModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : IconModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<IconModel_Unknown> {
        override val _type: KClass<IconModel_Unknown> = IconModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): IconModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: IconModel_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as IconModel_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("IconModel_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
data class IconSource (
    val path: String,
    val body: ByteArray?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<IconSource> {
        override val _type: KClass<IconSource> = IconSource::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): IconSource  {
            val path = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val body = buffer.readNullable { ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readByteArray() } }
            return IconSource(path, body)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: IconSource)  {
            ctx.writeInterned(buffer, value.path, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeNullable(value.body) { ctx.writeInterned(buffer, it, "Protocol") { _, _, internedValue -> buffer.writeByteArray(internedValue) } }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as IconSource
        
        if (path != other.path) return false
        if (body != other.body) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + path.hashCode()
        __r = __r*31 + if (body != null) body.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("IconSource (")
        printer.indent {
            print("path = "); path.print(printer); println()
            print("body = "); body.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
class IdeaIconModel (
    val iconUrl: String
) : IconModel (
) {
    //companion
    
    companion object : IMarshaller<IdeaIconModel> {
        override val _type: KClass<IdeaIconModel> = IdeaIconModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): IdeaIconModel  {
            val iconUrl = buffer.readString()
            return IdeaIconModel(iconUrl)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: IdeaIconModel)  {
            buffer.writeString(value.iconUrl)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as IdeaIconModel
        
        if (iconUrl != other.iconUrl) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + iconUrl.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("IdeaIconModel (")
        printer.indent {
            print("iconUrl = "); iconUrl.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
data class ImageIconInternWrapper (
    val identity: Long,
    val path: String,
    val sources: List<IconSource>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ImageIconInternWrapper> {
        override val _type: KClass<ImageIconInternWrapper> = ImageIconInternWrapper::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ImageIconInternWrapper  {
            val identity = buffer.readLong()
            val path = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val sources = buffer.readList { IconSource.read(ctx, buffer) }
            return ImageIconInternWrapper(identity, path, sources)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ImageIconInternWrapper)  {
            buffer.writeLong(value.identity)
            ctx.writeInterned(buffer, value.path, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeList(value.sources) { v -> IconSource.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ImageIconInternWrapper
        
        if (identity != other.identity) return false
        
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + identity.hashCode()
        
        
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ImageIconInternWrapper (")
        printer.indent {
            print("identity = "); identity.print(printer); println()
            print("path = "); path.print(printer); println()
            print("sources = "); sources.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
class ImageIconModel (
    val wrapper: ImageIconInternWrapper
) : IconModel (
) {
    //companion
    
    companion object : IMarshaller<ImageIconModel> {
        override val _type: KClass<ImageIconModel> = ImageIconModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ImageIconModel  {
            val wrapper = ctx.readInterned(buffer, "Protocol") { _, _ -> ImageIconInternWrapper.read(ctx, buffer) }
            return ImageIconModel(wrapper)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ImageIconModel)  {
            ctx.writeInterned(buffer, value.wrapper, "Protocol") { _, _, internedValue -> ImageIconInternWrapper.write(ctx, buffer, internedValue) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ImageIconModel
        
        if (wrapper != other.wrapper) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + wrapper.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ImageIconModel (")
        printer.indent {
            print("wrapper = "); wrapper.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
class ImageSourceIconModel (
    val iconPackStringId: String,
    val iconNameStringId: String
) : IconModel (
) {
    //companion
    
    companion object : IMarshaller<ImageSourceIconModel> {
        override val _type: KClass<ImageSourceIconModel> = ImageSourceIconModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ImageSourceIconModel  {
            val iconPackStringId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val iconNameStringId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            return ImageSourceIconModel(iconPackStringId, iconNameStringId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ImageSourceIconModel)  {
            ctx.writeInterned(buffer, value.iconPackStringId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            ctx.writeInterned(buffer, value.iconNameStringId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ImageSourceIconModel
        
        if (iconPackStringId != other.iconPackStringId) return false
        if (iconNameStringId != other.iconNameStringId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + iconPackStringId.hashCode()
        __r = __r*31 + iconNameStringId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ImageSourceIconModel (")
        printer.indent {
            print("iconPackStringId = "); iconPackStringId.print(printer); println()
            print("iconNameStringId = "); iconNameStringId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
enum class LookAndFeelTheme {
    Darcula, 
    IntelliJ;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<LookAndFeelTheme>()
        
    }
}


/**
 * #### Generated from [ShellModel.kt]
 */
data class RichAttributedStringModel (
    val text: String,
    val attributeId: String?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RichAttributedStringModel> {
        override val _type: KClass<RichAttributedStringModel> = RichAttributedStringModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RichAttributedStringModel  {
            val text = ctx.readInterned(buffer, "RichStringFragmentInternScope") { _, _ -> buffer.readString() }
            val attributeId = buffer.readNullable { buffer.readString() }
            return RichAttributedStringModel(text, attributeId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RichAttributedStringModel)  {
            ctx.writeInterned(buffer, value.text, "RichStringFragmentInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeNullable(value.attributeId) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RichAttributedStringModel
        
        if (text != other.text) return false
        if (attributeId != other.attributeId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + if (attributeId != null) attributeId.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RichAttributedStringModel (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
data class RichAttributedTextModel (
    val parts: List<RichAttributedStringModel>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RichAttributedTextModel> {
        override val _type: KClass<RichAttributedTextModel> = RichAttributedTextModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RichAttributedTextModel  {
            val parts = buffer.readList { RichAttributedStringModel.read(ctx, buffer) }
            return RichAttributedTextModel(parts)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RichAttributedTextModel)  {
            buffer.writeList(value.parts) { v -> RichAttributedStringModel.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RichAttributedTextModel
        
        if (parts != other.parts) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + parts.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RichAttributedTextModel (")
        printer.indent {
            print("parts = "); parts.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
data class RichStringModel (
    val text: String,
    val foregroundColor: AbstractColor? = null,
    val backgroundColor: AbstractColor? = null,
    val effectColor: AbstractColor? = null,
    val effectStyle: EffectStyle = EffectStyle.None,
    val fontStyle: FontStyle = FontStyle.Regular
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RichStringModel> {
        override val _type: KClass<RichStringModel> = RichStringModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RichStringModel  {
            val text = ctx.readInterned(buffer, "RichStringFragmentInternScope") { _, _ -> buffer.readString() }
            val foregroundColor = buffer.readNullable { ctx.serializers.readPolymorphic<AbstractColor>(ctx, buffer, AbstractColor) }
            val backgroundColor = buffer.readNullable { ctx.serializers.readPolymorphic<AbstractColor>(ctx, buffer, AbstractColor) }
            val effectColor = buffer.readNullable { ctx.serializers.readPolymorphic<AbstractColor>(ctx, buffer, AbstractColor) }
            val effectStyle = buffer.readEnum<EffectStyle>()
            val fontStyle = buffer.readEnum<FontStyle>()
            return RichStringModel(text, foregroundColor, backgroundColor, effectColor, effectStyle, fontStyle)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RichStringModel)  {
            ctx.writeInterned(buffer, value.text, "RichStringFragmentInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeNullable(value.foregroundColor) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.backgroundColor) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.effectColor) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeEnum(value.effectStyle)
            buffer.writeEnum(value.fontStyle)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RichStringModel
        
        if (text != other.text) return false
        if (foregroundColor != other.foregroundColor) return false
        if (backgroundColor != other.backgroundColor) return false
        if (effectColor != other.effectColor) return false
        if (effectStyle != other.effectStyle) return false
        if (fontStyle != other.fontStyle) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + if (foregroundColor != null) foregroundColor.hashCode() else 0
        __r = __r*31 + if (backgroundColor != null) backgroundColor.hashCode() else 0
        __r = __r*31 + if (effectColor != null) effectColor.hashCode() else 0
        __r = __r*31 + effectStyle.hashCode()
        __r = __r*31 + fontStyle.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RichStringModel (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("foregroundColor = "); foregroundColor.print(printer); println()
            print("backgroundColor = "); backgroundColor.print(printer); println()
            print("effectColor = "); effectColor.print(printer); println()
            print("effectStyle = "); effectStyle.print(printer); println()
            print("fontStyle = "); fontStyle.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
data class RichTextBlockModel (
    val lines: List<RichTextModel>,
    val alignment: ContentAlignmentKind,
    val interlineSpacing: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RichTextBlockModel> {
        override val _type: KClass<RichTextBlockModel> = RichTextBlockModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RichTextBlockModel  {
            val lines = buffer.readList { RichTextModel.read(ctx, buffer) }
            val alignment = buffer.readEnum<ContentAlignmentKind>()
            val interlineSpacing = buffer.readInt()
            return RichTextBlockModel(lines, alignment, interlineSpacing)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RichTextBlockModel)  {
            buffer.writeList(value.lines) { v -> RichTextModel.write(ctx, buffer, v) }
            buffer.writeEnum(value.alignment)
            buffer.writeInt(value.interlineSpacing)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RichTextBlockModel
        
        if (lines != other.lines) return false
        if (alignment != other.alignment) return false
        if (interlineSpacing != other.interlineSpacing) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + lines.hashCode()
        __r = __r*31 + alignment.hashCode()
        __r = __r*31 + interlineSpacing.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RichTextBlockModel (")
        printer.indent {
            print("lines = "); lines.print(printer); println()
            print("alignment = "); alignment.print(printer); println()
            print("interlineSpacing = "); interlineSpacing.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
data class RichTextModel (
    val parts: List<RichStringModel>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RichTextModel> {
        override val _type: KClass<RichTextModel> = RichTextModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RichTextModel  {
            val parts = buffer.readList { RichStringModel.read(ctx, buffer) }
            return RichTextModel(parts)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RichTextModel)  {
            buffer.writeList(value.parts) { v -> RichStringModel.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RichTextModel
        
        if (parts != other.parts) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + parts.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RichTextModel (")
        printer.indent {
            print("parts = "); parts.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
class RotatedIconModel (
    val staticNode: IconModel
) : IconModel (
) {
    //companion
    
    companion object : IMarshaller<RotatedIconModel> {
        override val _type: KClass<RotatedIconModel> = RotatedIconModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RotatedIconModel  {
            val staticNode = ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel)
            return RotatedIconModel(staticNode)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RotatedIconModel)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.staticNode)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RotatedIconModel
        
        if (staticNode != other.staticNode) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + staticNode.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RotatedIconModel (")
        printer.indent {
            print("staticNode = "); staticNode.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
class RowIconModel (
    val subNodes: List<IconModel>
) : IconModel (
) {
    //companion
    
    companion object : IMarshaller<RowIconModel> {
        override val _type: KClass<RowIconModel> = RowIconModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RowIconModel  {
            val subNodes = buffer.readList { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            return RowIconModel(subNodes)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RowIconModel)  {
            buffer.writeList(value.subNodes) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RowIconModel
        
        if (subNodes != other.subNodes) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + subNodes.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RowIconModel (")
        printer.indent {
            print("subNodes = "); subNodes.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ShellModel.kt]
 */
class ShellIconModel (
    val extensionWithDotStringId: String
) : IconModel (
) {
    //companion
    
    companion object : IMarshaller<ShellIconModel> {
        override val _type: KClass<ShellIconModel> = ShellIconModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ShellIconModel  {
            val extensionWithDotStringId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            return ShellIconModel(extensionWithDotStringId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ShellIconModel)  {
            ctx.writeInterned(buffer, value.extensionWithDotStringId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ShellIconModel
        
        if (extensionWithDotStringId != other.extensionWithDotStringId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + extensionWithDotStringId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ShellIconModel (")
        printer.indent {
            print("extensionWithDotStringId = "); extensionWithDotStringId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
