@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CodeInsightModels.kt]
 */
class ShowImplementationsModel private constructor(
    private val _session: RdProperty<ImplementationViewSessionModel?>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(ImplementationViewElementModel)
            serializers.register(ImplementationViewSessionModel)
            serializers.register(ImplementationViewNavigateToModel)
        }
        
        
        
        private val __ImplementationViewSessionModelNullableSerializer = ImplementationViewSessionModel.nullable()
        
        const val serializationHash = -6875624344300598262L
        
    }
    override val serializersOwner: ISerializersOwner get() = ShowImplementationsModel
    override val serializationHash: Long get() = ShowImplementationsModel.serializationHash
    
    //fields
    val session: IProperty<ImplementationViewSessionModel?> get() = _session
    //methods
    //initializer
    init {
        bindableChildren.add("session" to _session)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdProperty<ImplementationViewSessionModel?>(null, __ImplementationViewSessionModelNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ShowImplementationsModel (")
        printer.indent {
            print("session = "); _session.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ShowImplementationsModel   {
        return ShowImplementationsModel(
            _session.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.showImplementationsModel get() = getOrCreateExtension("showImplementationsModel", ::ShowImplementationsModel)



/**
 * #### Generated from [CodeInsightModels.kt]
 */
data class ImplementationViewElementModel (
    val id: Int,
    val name: String?,
    val presentableText: String,
    val locationText: String?,
    val locationIcon: IconModel?,
    val containingFile: RdDocumentId?,
    val startOffset: Int,
    val endOffset: Int,
    val navigationOffset: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ImplementationViewElementModel> {
        override val _type: KClass<ImplementationViewElementModel> = ImplementationViewElementModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ImplementationViewElementModel  {
            val id = buffer.readInt()
            val name = buffer.readNullable { buffer.readString() }
            val presentableText = buffer.readString()
            val locationText = buffer.readNullable { buffer.readString() }
            val locationIcon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val containingFile = buffer.readNullable { ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId) }
            val startOffset = buffer.readInt()
            val endOffset = buffer.readInt()
            val navigationOffset = buffer.readInt()
            return ImplementationViewElementModel(id, name, presentableText, locationText, locationIcon, containingFile, startOffset, endOffset, navigationOffset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ImplementationViewElementModel)  {
            buffer.writeInt(value.id)
            buffer.writeNullable(value.name) { buffer.writeString(it) }
            buffer.writeString(value.presentableText)
            buffer.writeNullable(value.locationText) { buffer.writeString(it) }
            buffer.writeNullable(value.locationIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.containingFile) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeInt(value.startOffset)
            buffer.writeInt(value.endOffset)
            buffer.writeInt(value.navigationOffset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ImplementationViewElementModel
        
        if (id != other.id) return false
        if (name != other.name) return false
        if (presentableText != other.presentableText) return false
        if (locationText != other.locationText) return false
        if (locationIcon != other.locationIcon) return false
        if (containingFile != other.containingFile) return false
        if (startOffset != other.startOffset) return false
        if (endOffset != other.endOffset) return false
        if (navigationOffset != other.navigationOffset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (name != null) name.hashCode() else 0
        __r = __r*31 + presentableText.hashCode()
        __r = __r*31 + if (locationText != null) locationText.hashCode() else 0
        __r = __r*31 + if (locationIcon != null) locationIcon.hashCode() else 0
        __r = __r*31 + if (containingFile != null) containingFile.hashCode() else 0
        __r = __r*31 + startOffset.hashCode()
        __r = __r*31 + endOffset.hashCode()
        __r = __r*31 + navigationOffset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ImplementationViewElementModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("name = "); name.print(printer); println()
            print("presentableText = "); presentableText.print(printer); println()
            print("locationText = "); locationText.print(printer); println()
            print("locationIcon = "); locationIcon.print(printer); println()
            print("containingFile = "); containingFile.print(printer); println()
            print("startOffset = "); startOffset.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
            print("navigationOffset = "); navigationOffset.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeInsightModels.kt]
 */
data class ImplementationViewNavigateToModel (
    val id: Int,
    val requestFocus: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ImplementationViewNavigateToModel> {
        override val _type: KClass<ImplementationViewNavigateToModel> = ImplementationViewNavigateToModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ImplementationViewNavigateToModel  {
            val id = buffer.readInt()
            val requestFocus = buffer.readBool()
            return ImplementationViewNavigateToModel(id, requestFocus)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ImplementationViewNavigateToModel)  {
            buffer.writeInt(value.id)
            buffer.writeBool(value.requestFocus)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ImplementationViewNavigateToModel
        
        if (id != other.id) return false
        if (requestFocus != other.requestFocus) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + requestFocus.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ImplementationViewNavigateToModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("requestFocus = "); requestFocus.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [CodeInsightModels.kt]
 */
class ImplementationViewSessionModel private constructor(
    val dataContext: List<RdDataConstant>?,
    private val _text: RdProperty<String?>,
    private val _items: RdList<ImplementationViewElementModel>,
    private val _searchDone: RdOptionalProperty<Unit>,
    private val _navigate: RdSignal<ImplementationViewNavigateToModel>,
    val completionId: Int?,
    val popupId: Int?
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<ImplementationViewSessionModel> {
        override val _type: KClass<ImplementationViewSessionModel> = ImplementationViewSessionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ImplementationViewSessionModel  {
            val _id = RdId.read(buffer)
            val dataContext = buffer.readNullable { buffer.readList { ctx.serializers.readPolymorphic<RdDataConstant>(ctx, buffer, RdDataConstant) } }
            val _text = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _items = RdList.read(ctx, buffer, ImplementationViewElementModel)
            val _searchDone = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Void)
            val _navigate = RdSignal.read(ctx, buffer, ImplementationViewNavigateToModel)
            val completionId = buffer.readNullable { buffer.readInt() }
            val popupId = buffer.readNullable { buffer.readInt() }
            return ImplementationViewSessionModel(dataContext, _text, _items, _searchDone, _navigate, completionId, popupId).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ImplementationViewSessionModel)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.dataContext) { buffer.writeList(it) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) } }
            RdProperty.write(ctx, buffer, value._text)
            RdList.write(ctx, buffer, value._items)
            RdOptionalProperty.write(ctx, buffer, value._searchDone)
            RdSignal.write(ctx, buffer, value._navigate)
            buffer.writeNullable(value.completionId) { buffer.writeInt(it) }
            buffer.writeNullable(value.popupId) { buffer.writeInt(it) }
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    
    /**
     * Shown in the title of the show implementations popup
     */
    val text: IProperty<String?> get() = _text
    val items: IMutableViewableList<ImplementationViewElementModel> get() = _items
    
    /**
     * Signals that items's filling is completed
     */
    val searchDone: IOptProperty<Unit> get() = _searchDone
    val navigate: ISignal<ImplementationViewNavigateToModel> get() = _navigate
    //methods
    //initializer
    init {
        _text.optimizeNested = true
        _items.optimizeNested = true
        _searchDone.optimizeNested = true
    }
    
    init {
        _text.async = true
        _items.async = true
        _searchDone.async = true
    }
    
    init {
        bindableChildren.add("text" to _text)
        bindableChildren.add("items" to _items)
        bindableChildren.add("searchDone" to _searchDone)
        bindableChildren.add("navigate" to _navigate)
    }
    
    //secondary constructor
    constructor(
        dataContext: List<RdDataConstant>?,
        completionId: Int?,
        popupId: Int?
    ) : this(
        dataContext,
        RdProperty<String?>(null, __StringNullableSerializer),
        RdList<ImplementationViewElementModel>(ImplementationViewElementModel),
        RdOptionalProperty<Unit>(FrameworkMarshallers.Void),
        RdSignal<ImplementationViewNavigateToModel>(ImplementationViewNavigateToModel),
        completionId,
        popupId
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ImplementationViewSessionModel (")
        printer.indent {
            print("dataContext = "); dataContext.print(printer); println()
            print("text = "); _text.print(printer); println()
            print("items = "); _items.print(printer); println()
            print("searchDone = "); _searchDone.print(printer); println()
            print("navigate = "); _navigate.print(printer); println()
            print("completionId = "); completionId.print(printer); println()
            print("popupId = "); popupId.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ImplementationViewSessionModel   {
        return ImplementationViewSessionModel(
            dataContext,
            _text.deepClonePolymorphic(),
            _items.deepClonePolymorphic(),
            _searchDone.deepClonePolymorphic(),
            _navigate.deepClonePolymorphic(),
            completionId,
            popupId
        )
    }
    //contexts
}
