@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [TerminalModel.kt]
 */
class TerminalModel private constructor(
    private val _sessions: RdMap<String, RdTerminalSession>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RdTerminalSession)
            serializers.register(RdTerminalSessionOrigin.marshaller)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): TerminalModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return TerminalModel().apply {
                identify(protocol.identity, RdId.Null.mix("TerminalModel"))
                bind(lifetime, protocol, "TerminalModel")
            }
        }
        
        
        const val serializationHash = -6085747854506332605L
        
    }
    override val serializersOwner: ISerializersOwner get() = TerminalModel
    override val serializationHash: Long get() = TerminalModel.serializationHash
    
    //fields
    val sessions: IMutableViewableMap<String, RdTerminalSession> get() = _sessions
    //methods
    //initializer
    init {
        bindableChildren.add("sessions" to _sessions)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdMap<String, RdTerminalSession>(FrameworkMarshallers.String, RdTerminalSession)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TerminalModel (")
        printer.indent {
            print("sessions = "); _sessions.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): TerminalModel   {
        return TerminalModel(
            _sessions.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [TerminalModel.kt]
 */
class RdTerminalSession private constructor(
    val origin: RdTerminalSessionOrigin,
    private val _name: RdOptionalProperty<String>,
    private val _outputConnected: RdOptionalProperty<Boolean>,
    private val _input: RdSignal<List<Byte>>,
    private val _output: RdSignal<List<Byte>>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdTerminalSession> {
        override val _type: KClass<RdTerminalSession> = RdTerminalSession::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTerminalSession  {
            val _id = RdId.read(buffer)
            val origin = buffer.readEnum<RdTerminalSessionOrigin>()
            val _name = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _outputConnected = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _input = RdSignal.read(ctx, buffer, __ByteListSerializer)
            val _output = RdSignal.read(ctx, buffer, __ByteListSerializer)
            return RdTerminalSession(origin, _name, _outputConnected, _input, _output).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTerminalSession)  {
            value.rdid.write(buffer)
            buffer.writeEnum(value.origin)
            RdOptionalProperty.write(ctx, buffer, value._name)
            RdOptionalProperty.write(ctx, buffer, value._outputConnected)
            RdSignal.write(ctx, buffer, value._input)
            RdSignal.write(ctx, buffer, value._output)
        }
        
        private val __ByteListSerializer = FrameworkMarshallers.Byte.list()
        
    }
    //fields
    val name: IOptProperty<String> get() = _name
    val outputConnected: IOptProperty<Boolean> get() = _outputConnected
    val input: IAsyncSignal<List<Byte>> get() = _input
    val output: IAsyncSignal<List<Byte>> get() = _output
    //methods
    //initializer
    init {
        _name.optimizeNested = true
        _outputConnected.optimizeNested = true
    }
    
    init {
        _outputConnected.async = true
        _input.async = true
        _output.async = true
    }
    
    init {
        bindableChildren.add("name" to _name)
        bindableChildren.add("outputConnected" to _outputConnected)
        bindableChildren.add("input" to _input)
        bindableChildren.add("output" to _output)
    }
    
    //secondary constructor
    constructor(
        origin: RdTerminalSessionOrigin
    ) : this(
        origin,
        RdOptionalProperty<String>(FrameworkMarshallers.String),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdSignal<List<Byte>>(__ByteListSerializer),
        RdSignal<List<Byte>>(__ByteListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTerminalSession (")
        printer.indent {
            print("origin = "); origin.print(printer); println()
            print("name = "); _name.print(printer); println()
            print("outputConnected = "); _outputConnected.print(printer); println()
            print("input = "); _input.print(printer); println()
            print("output = "); _output.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdTerminalSession   {
        return RdTerminalSession(
            origin,
            _name.deepClonePolymorphic(),
            _outputConnected.deepClonePolymorphic(),
            _input.deepClonePolymorphic(),
            _output.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [TerminalModel.kt]
 */
enum class RdTerminalSessionOrigin {
    Host, 
    Client;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<RdTerminalSessionOrigin>()
        
    }
}
