@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [TestModel.kt]
 */
class TestModel private constructor(
    private val _syncImpulse: RdCall<Unit, Unit>,
    private val _refreshVFS: RdCall<String, Unit>,
    private val _enabledInspections: RdList<String>,
    private val _testModeFlags: RdList<TestModeFlag>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(DefaultNameDataConstant)
            serializers.register(TestModeBooleanFlag)
            serializers.register(TestModeStringFlag)
            serializers.register(TestModeFlag_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): TestModel  {
            IdeRoot.register(protocol.serializers)
            
            return TestModel().apply {
                identify(protocol.identity, RdId.Null.mix("TestModel"))
                bind(lifetime, protocol, "TestModel")
            }
        }
        
        
        const val serializationHash = 4826835534518136006L
        
    }
    override val serializersOwner: ISerializersOwner get() = TestModel
    override val serializationHash: Long get() = TestModel.serializationHash
    
    //fields
    val syncImpulse: RdCall<Unit, Unit> get() = _syncImpulse
    val refreshVFS: RdCall<String, Unit> get() = _refreshVFS
    val enabledInspections: IMutableViewableList<String> get() = _enabledInspections
    val testModeFlags: IMutableViewableList<TestModeFlag> get() = _testModeFlags
    //methods
    //initializer
    init {
        _enabledInspections.optimizeNested = true
        _testModeFlags.optimizeNested = true
    }
    
    init {
        bindableChildren.add("syncImpulse" to _syncImpulse)
        bindableChildren.add("refreshVFS" to _refreshVFS)
        bindableChildren.add("enabledInspections" to _enabledInspections)
        bindableChildren.add("testModeFlags" to _testModeFlags)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdCall<Unit, Unit>(FrameworkMarshallers.Void, FrameworkMarshallers.Void),
        RdCall<String, Unit>(FrameworkMarshallers.String, FrameworkMarshallers.Void),
        RdList<String>(FrameworkMarshallers.String),
        RdList<TestModeFlag>(AbstractPolymorphic(TestModeFlag))
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestModel (")
        printer.indent {
            print("syncImpulse = "); _syncImpulse.print(printer); println()
            print("refreshVFS = "); _refreshVFS.print(printer); println()
            print("enabledInspections = "); _enabledInspections.print(printer); println()
            print("testModeFlags = "); _testModeFlags.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): TestModel   {
        return TestModel(
            _syncImpulse.deepClonePolymorphic(),
            _refreshVFS.deepClonePolymorphic(),
            _enabledInspections.deepClonePolymorphic(),
            _testModeFlags.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [TestModel.kt]
 */
class DefaultNameDataConstant (
    val name: String
) : RdDataConstant (
) {
    //companion
    
    companion object : IMarshaller<DefaultNameDataConstant> {
        override val _type: KClass<DefaultNameDataConstant> = DefaultNameDataConstant::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DefaultNameDataConstant  {
            val name = buffer.readString()
            return DefaultNameDataConstant(name)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DefaultNameDataConstant)  {
            buffer.writeString(value.name)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DefaultNameDataConstant
        
        if (name != other.name) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DefaultNameDataConstant (")
        printer.indent {
            print("name = "); name.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestModel.kt]
 */
class TestModeBooleanFlag (
    val booleanValue: Boolean,
    name: String
) : TestModeFlag (
    name
) {
    //companion
    
    companion object : IMarshaller<TestModeBooleanFlag> {
        override val _type: KClass<TestModeBooleanFlag> = TestModeBooleanFlag::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TestModeBooleanFlag  {
            val name = buffer.readString()
            val booleanValue = buffer.readBool()
            return TestModeBooleanFlag(booleanValue, name)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TestModeBooleanFlag)  {
            buffer.writeString(value.name)
            buffer.writeBool(value.booleanValue)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TestModeBooleanFlag
        
        if (booleanValue != other.booleanValue) return false
        if (name != other.name) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + booleanValue.hashCode()
        __r = __r*31 + name.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestModeBooleanFlag (")
        printer.indent {
            print("booleanValue = "); booleanValue.print(printer); println()
            print("name = "); name.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestModel.kt]
 */
abstract class TestModeFlag (
    val name: String
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<TestModeFlag> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): TestModeFlag  {
            val objectStartPosition = buffer.position
            val name = buffer.readString()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return TestModeFlag_Unknown(name, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class TestModeFlag_Unknown (
    name: String,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : TestModeFlag (
    name
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<TestModeFlag_Unknown> {
        override val _type: KClass<TestModeFlag_Unknown> = TestModeFlag_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TestModeFlag_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TestModeFlag_Unknown)  {
            buffer.writeString(value.name)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TestModeFlag_Unknown
        
        if (name != other.name) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestModeFlag_Unknown (")
        printer.indent {
            print("name = "); name.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestModel.kt]
 */
class TestModeStringFlag (
    val stringValue: String,
    name: String
) : TestModeFlag (
    name
) {
    //companion
    
    companion object : IMarshaller<TestModeStringFlag> {
        override val _type: KClass<TestModeStringFlag> = TestModeStringFlag::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TestModeStringFlag  {
            val name = buffer.readString()
            val stringValue = buffer.readString()
            return TestModeStringFlag(stringValue, name)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TestModeStringFlag)  {
            buffer.writeString(value.name)
            buffer.writeString(value.stringValue)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TestModeStringFlag
        
        if (stringValue != other.stringValue) return false
        if (name != other.name) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + stringValue.hashCode()
        __r = __r*31 + name.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestModeStringFlag (")
        printer.indent {
            print("stringValue = "); stringValue.print(printer); println()
            print("name = "); name.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
