@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class TestsRunContentModel private constructor(
    private val _testEvent: RdSignal<TestsModel>,
    private val _navigate: RdSignal<TestNavigation>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(SuiteTreeStarted)
            serializers.register(SuiteTreeNodeAdded)
            serializers.register(SuiteTreeEnded)
            serializers.register(BuildTreeEnded)
            serializers.register(ReporterAttached)
            serializers.register(RootPresentation)
            serializers.register(Started)
            serializers.register(SuiteStarted)
            serializers.register(TestStarted)
            serializers.register(TestFinished)
            serializers.register(TestFailure)
            serializers.register(TestIgnore)
            serializers.register(SuiteFinished)
            serializers.register(Finished)
            serializers.register(TestOutput)
            serializers.register(Uncapture)
            serializers.register(TestSelectionModel)
            serializers.register(TestNavigation)
            serializers.register(TestsModel_Unknown)
            serializers.register(NodeEvent_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): TestsRunContentModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return TestsRunContentModel().apply {
                identify(protocol.identity, RdId.Null.mix("TestsRunContentModel"))
                bind(lifetime, protocol, "TestsRunContentModel")
            }
        }
        
        
        const val serializationHash = -1856889554160302156L
        
    }
    override val serializersOwner: ISerializersOwner get() = TestsRunContentModel
    override val serializationHash: Long get() = TestsRunContentModel.serializationHash
    
    //fields
    val testEvent: IAsyncSignal<TestsModel> get() = _testEvent
    val navigate: IAsyncSignal<TestNavigation> get() = _navigate
    //methods
    //initializer
    init {
        _testEvent.async = true
        _navigate.async = true
    }
    
    init {
        bindableChildren.add("testEvent" to _testEvent)
        bindableChildren.add("navigate" to _navigate)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdSignal<TestsModel>(AbstractPolymorphic(TestsModel)),
        RdSignal<TestNavigation>(TestNavigation)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestsRunContentModel (")
        printer.indent {
            print("testEvent = "); _testEvent.print(printer); println()
            print("navigate = "); _navigate.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): TestsRunContentModel   {
        return TestsRunContentModel(
            _testEvent.deepClonePolymorphic(),
            _navigate.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class BuildTreeEnded (
    executionId: Long
) : TestsModel (
    executionId
) {
    //companion
    
    companion object : IMarshaller<BuildTreeEnded> {
        override val _type: KClass<BuildTreeEnded> = BuildTreeEnded::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BuildTreeEnded  {
            val executionId = buffer.readLong()
            return BuildTreeEnded(executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BuildTreeEnded)  {
            buffer.writeLong(value.executionId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BuildTreeEnded
        
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BuildTreeEnded (")
        printer.indent {
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class Finished (
    val rootName: String,
    executionId: Long
) : TestsModel (
    executionId
) {
    //companion
    
    companion object : IMarshaller<Finished> {
        override val _type: KClass<Finished> = Finished::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): Finished  {
            val executionId = buffer.readLong()
            val rootName = buffer.readString()
            return Finished(rootName, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: Finished)  {
            buffer.writeLong(value.executionId)
            buffer.writeString(value.rootName)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as Finished
        
        if (rootName != other.rootName) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + rootName.hashCode()
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("Finished (")
        printer.indent {
            print("rootName = "); rootName.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
abstract class NodeEvent (
    val name: String,
    val id: String?,
    executionId: Long
) : TestsModel (
    executionId
) {
    //companion
    
    companion object : IAbstractDeclaration<NodeEvent> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): NodeEvent  {
            val objectStartPosition = buffer.position
            val name = buffer.readString()
            val id = buffer.readNullable { buffer.readString() }
            val executionId = buffer.readLong()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return NodeEvent_Unknown(name, id, executionId, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class NodeEvent_Unknown (
    name: String,
    id: String?,
    executionId: Long,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : NodeEvent (
    name,
    id,
    executionId
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<NodeEvent_Unknown> {
        override val _type: KClass<NodeEvent_Unknown> = NodeEvent_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NodeEvent_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NodeEvent_Unknown)  {
            buffer.writeString(value.name)
            buffer.writeNullable(value.id) { buffer.writeString(it) }
            buffer.writeLong(value.executionId)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as NodeEvent_Unknown
        
        if (name != other.name) return false
        if (id != other.id) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (id != null) id.hashCode() else 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NodeEvent_Unknown (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("id = "); id.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class ReporterAttached (
    executionId: Long
) : TestsModel (
    executionId
) {
    //companion
    
    companion object : IMarshaller<ReporterAttached> {
        override val _type: KClass<ReporterAttached> = ReporterAttached::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ReporterAttached  {
            val executionId = buffer.readLong()
            return ReporterAttached(executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ReporterAttached)  {
            buffer.writeLong(value.executionId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ReporterAttached
        
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ReporterAttached (")
        printer.indent {
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class RootPresentation (
    val presentation: String?,
    val comment: String?,
    val locationUrl: String?,
    executionId: Long
) : TestsModel (
    executionId
) {
    //companion
    
    companion object : IMarshaller<RootPresentation> {
        override val _type: KClass<RootPresentation> = RootPresentation::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RootPresentation  {
            val executionId = buffer.readLong()
            val presentation = buffer.readNullable { buffer.readString() }
            val comment = buffer.readNullable { buffer.readString() }
            val locationUrl = buffer.readNullable { buffer.readString() }
            return RootPresentation(presentation, comment, locationUrl, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RootPresentation)  {
            buffer.writeLong(value.executionId)
            buffer.writeNullable(value.presentation) { buffer.writeString(it) }
            buffer.writeNullable(value.comment) { buffer.writeString(it) }
            buffer.writeNullable(value.locationUrl) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RootPresentation
        
        if (presentation != other.presentation) return false
        if (comment != other.comment) return false
        if (locationUrl != other.locationUrl) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (presentation != null) presentation.hashCode() else 0
        __r = __r*31 + if (comment != null) comment.hashCode() else 0
        __r = __r*31 + if (locationUrl != null) locationUrl.hashCode() else 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RootPresentation (")
        printer.indent {
            print("presentation = "); presentation.print(printer); println()
            print("comment = "); comment.print(printer); println()
            print("locationUrl = "); locationUrl.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class Started (
    val rootName: String,
    executionId: Long
) : TestsModel (
    executionId
) {
    //companion
    
    companion object : IMarshaller<Started> {
        override val _type: KClass<Started> = Started::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): Started  {
            val executionId = buffer.readLong()
            val rootName = buffer.readString()
            return Started(rootName, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: Started)  {
            buffer.writeLong(value.executionId)
            buffer.writeString(value.rootName)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as Started
        
        if (rootName != other.rootName) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + rootName.hashCode()
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("Started (")
        printer.indent {
            print("rootName = "); rootName.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class SuiteFinished (
    name: String,
    id: String?,
    executionId: Long
) : NodeEvent (
    name,
    id,
    executionId
) {
    //companion
    
    companion object : IMarshaller<SuiteFinished> {
        override val _type: KClass<SuiteFinished> = SuiteFinished::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SuiteFinished  {
            val name = buffer.readString()
            val id = buffer.readNullable { buffer.readString() }
            val executionId = buffer.readLong()
            return SuiteFinished(name, id, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SuiteFinished)  {
            buffer.writeString(value.name)
            buffer.writeNullable(value.id) { buffer.writeString(it) }
            buffer.writeLong(value.executionId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SuiteFinished
        
        if (name != other.name) return false
        if (id != other.id) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (id != null) id.hashCode() else 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SuiteFinished (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("id = "); id.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class SuiteStarted (
    val locationUrl: String?,
    val parentId: String?,
    name: String,
    id: String?,
    executionId: Long
) : NodeEvent (
    name,
    id,
    executionId
) {
    //companion
    
    companion object : IMarshaller<SuiteStarted> {
        override val _type: KClass<SuiteStarted> = SuiteStarted::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SuiteStarted  {
            val name = buffer.readString()
            val id = buffer.readNullable { buffer.readString() }
            val executionId = buffer.readLong()
            val locationUrl = buffer.readNullable { buffer.readString() }
            val parentId = buffer.readNullable { buffer.readString() }
            return SuiteStarted(locationUrl, parentId, name, id, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SuiteStarted)  {
            buffer.writeString(value.name)
            buffer.writeNullable(value.id) { buffer.writeString(it) }
            buffer.writeLong(value.executionId)
            buffer.writeNullable(value.locationUrl) { buffer.writeString(it) }
            buffer.writeNullable(value.parentId) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SuiteStarted
        
        if (locationUrl != other.locationUrl) return false
        if (parentId != other.parentId) return false
        if (name != other.name) return false
        if (id != other.id) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (locationUrl != null) locationUrl.hashCode() else 0
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (id != null) id.hashCode() else 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SuiteStarted (")
        printer.indent {
            print("locationUrl = "); locationUrl.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("name = "); name.print(printer); println()
            print("id = "); id.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class SuiteTreeEnded (
    val name: String,
    executionId: Long
) : TestsModel (
    executionId
) {
    //companion
    
    companion object : IMarshaller<SuiteTreeEnded> {
        override val _type: KClass<SuiteTreeEnded> = SuiteTreeEnded::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SuiteTreeEnded  {
            val executionId = buffer.readLong()
            val name = buffer.readString()
            return SuiteTreeEnded(name, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SuiteTreeEnded)  {
            buffer.writeLong(value.executionId)
            buffer.writeString(value.name)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SuiteTreeEnded
        
        if (name != other.name) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SuiteTreeEnded (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class SuiteTreeNodeAdded (
    val isSuite: Boolean,
    val locationUrl: String?,
    val parentId: String?,
    name: String,
    id: String?,
    executionId: Long
) : NodeEvent (
    name,
    id,
    executionId
) {
    //companion
    
    companion object : IMarshaller<SuiteTreeNodeAdded> {
        override val _type: KClass<SuiteTreeNodeAdded> = SuiteTreeNodeAdded::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SuiteTreeNodeAdded  {
            val name = buffer.readString()
            val id = buffer.readNullable { buffer.readString() }
            val executionId = buffer.readLong()
            val isSuite = buffer.readBool()
            val locationUrl = buffer.readNullable { buffer.readString() }
            val parentId = buffer.readNullable { buffer.readString() }
            return SuiteTreeNodeAdded(isSuite, locationUrl, parentId, name, id, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SuiteTreeNodeAdded)  {
            buffer.writeString(value.name)
            buffer.writeNullable(value.id) { buffer.writeString(it) }
            buffer.writeLong(value.executionId)
            buffer.writeBool(value.isSuite)
            buffer.writeNullable(value.locationUrl) { buffer.writeString(it) }
            buffer.writeNullable(value.parentId) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SuiteTreeNodeAdded
        
        if (isSuite != other.isSuite) return false
        if (locationUrl != other.locationUrl) return false
        if (parentId != other.parentId) return false
        if (name != other.name) return false
        if (id != other.id) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + isSuite.hashCode()
        __r = __r*31 + if (locationUrl != null) locationUrl.hashCode() else 0
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (id != null) id.hashCode() else 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SuiteTreeNodeAdded (")
        printer.indent {
            print("isSuite = "); isSuite.print(printer); println()
            print("locationUrl = "); locationUrl.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("name = "); name.print(printer); println()
            print("id = "); id.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class SuiteTreeStarted (
    val locationUrl: String?,
    val parentId: String?,
    name: String,
    id: String?,
    executionId: Long
) : NodeEvent (
    name,
    id,
    executionId
) {
    //companion
    
    companion object : IMarshaller<SuiteTreeStarted> {
        override val _type: KClass<SuiteTreeStarted> = SuiteTreeStarted::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SuiteTreeStarted  {
            val name = buffer.readString()
            val id = buffer.readNullable { buffer.readString() }
            val executionId = buffer.readLong()
            val locationUrl = buffer.readNullable { buffer.readString() }
            val parentId = buffer.readNullable { buffer.readString() }
            return SuiteTreeStarted(locationUrl, parentId, name, id, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SuiteTreeStarted)  {
            buffer.writeString(value.name)
            buffer.writeNullable(value.id) { buffer.writeString(it) }
            buffer.writeLong(value.executionId)
            buffer.writeNullable(value.locationUrl) { buffer.writeString(it) }
            buffer.writeNullable(value.parentId) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SuiteTreeStarted
        
        if (locationUrl != other.locationUrl) return false
        if (parentId != other.parentId) return false
        if (name != other.name) return false
        if (id != other.id) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (locationUrl != null) locationUrl.hashCode() else 0
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (id != null) id.hashCode() else 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SuiteTreeStarted (")
        printer.indent {
            print("locationUrl = "); locationUrl.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("name = "); name.print(printer); println()
            print("id = "); id.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class TestFailure (
    val message: String,
    val stacktrace: String,
    val error: Boolean,
    val expected: String?,
    val `actual`: String?,
    name: String,
    id: String?,
    executionId: Long
) : NodeEvent (
    name,
    id,
    executionId
) {
    //companion
    
    companion object : IMarshaller<TestFailure> {
        override val _type: KClass<TestFailure> = TestFailure::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TestFailure  {
            val name = buffer.readString()
            val id = buffer.readNullable { buffer.readString() }
            val executionId = buffer.readLong()
            val message = buffer.readString()
            val stacktrace = buffer.readString()
            val error = buffer.readBool()
            val expected = buffer.readNullable { buffer.readString() }
            val `actual` = buffer.readNullable { buffer.readString() }
            return TestFailure(message, stacktrace, error, expected, `actual`, name, id, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TestFailure)  {
            buffer.writeString(value.name)
            buffer.writeNullable(value.id) { buffer.writeString(it) }
            buffer.writeLong(value.executionId)
            buffer.writeString(value.message)
            buffer.writeString(value.stacktrace)
            buffer.writeBool(value.error)
            buffer.writeNullable(value.expected) { buffer.writeString(it) }
            buffer.writeNullable(value.`actual`) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TestFailure
        
        if (message != other.message) return false
        if (stacktrace != other.stacktrace) return false
        if (error != other.error) return false
        if (expected != other.expected) return false
        if (`actual` != other.`actual`) return false
        if (name != other.name) return false
        if (id != other.id) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + message.hashCode()
        __r = __r*31 + stacktrace.hashCode()
        __r = __r*31 + error.hashCode()
        __r = __r*31 + if (expected != null) expected.hashCode() else 0
        __r = __r*31 + if (`actual` != null) `actual`.hashCode() else 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (id != null) id.hashCode() else 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestFailure (")
        printer.indent {
            print("message = "); message.print(printer); println()
            print("stacktrace = "); stacktrace.print(printer); println()
            print("error = "); error.print(printer); println()
            print("expected = "); expected.print(printer); println()
            print("actual = "); `actual`.print(printer); println()
            print("name = "); name.print(printer); println()
            print("id = "); id.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class TestFinished (
    val duration: Long,
    name: String,
    id: String?,
    executionId: Long
) : NodeEvent (
    name,
    id,
    executionId
) {
    //companion
    
    companion object : IMarshaller<TestFinished> {
        override val _type: KClass<TestFinished> = TestFinished::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TestFinished  {
            val name = buffer.readString()
            val id = buffer.readNullable { buffer.readString() }
            val executionId = buffer.readLong()
            val duration = buffer.readLong()
            return TestFinished(duration, name, id, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TestFinished)  {
            buffer.writeString(value.name)
            buffer.writeNullable(value.id) { buffer.writeString(it) }
            buffer.writeLong(value.executionId)
            buffer.writeLong(value.duration)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TestFinished
        
        if (duration != other.duration) return false
        if (name != other.name) return false
        if (id != other.id) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + duration.hashCode()
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (id != null) id.hashCode() else 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestFinished (")
        printer.indent {
            print("duration = "); duration.print(printer); println()
            print("name = "); name.print(printer); println()
            print("id = "); id.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class TestIgnore (
    val comment: String,
    val stacktrace: String,
    name: String,
    id: String?,
    executionId: Long
) : NodeEvent (
    name,
    id,
    executionId
) {
    //companion
    
    companion object : IMarshaller<TestIgnore> {
        override val _type: KClass<TestIgnore> = TestIgnore::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TestIgnore  {
            val name = buffer.readString()
            val id = buffer.readNullable { buffer.readString() }
            val executionId = buffer.readLong()
            val comment = buffer.readString()
            val stacktrace = buffer.readString()
            return TestIgnore(comment, stacktrace, name, id, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TestIgnore)  {
            buffer.writeString(value.name)
            buffer.writeNullable(value.id) { buffer.writeString(it) }
            buffer.writeLong(value.executionId)
            buffer.writeString(value.comment)
            buffer.writeString(value.stacktrace)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TestIgnore
        
        if (comment != other.comment) return false
        if (stacktrace != other.stacktrace) return false
        if (name != other.name) return false
        if (id != other.id) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + comment.hashCode()
        __r = __r*31 + stacktrace.hashCode()
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (id != null) id.hashCode() else 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestIgnore (")
        printer.indent {
            print("comment = "); comment.print(printer); println()
            print("stacktrace = "); stacktrace.print(printer); println()
            print("name = "); name.print(printer); println()
            print("id = "); id.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
data class TestNavigation (
    val executionId: Long,
    val selectedLocation: String?,
    val requestFocus: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<TestNavigation> {
        override val _type: KClass<TestNavigation> = TestNavigation::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TestNavigation  {
            val executionId = buffer.readLong()
            val selectedLocation = buffer.readNullable { buffer.readString() }
            val requestFocus = buffer.readBool()
            return TestNavigation(executionId, selectedLocation, requestFocus)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TestNavigation)  {
            buffer.writeLong(value.executionId)
            buffer.writeNullable(value.selectedLocation) { buffer.writeString(it) }
            buffer.writeBool(value.requestFocus)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TestNavigation
        
        if (executionId != other.executionId) return false
        if (selectedLocation != other.selectedLocation) return false
        if (requestFocus != other.requestFocus) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + executionId.hashCode()
        __r = __r*31 + if (selectedLocation != null) selectedLocation.hashCode() else 0
        __r = __r*31 + requestFocus.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestNavigation (")
        printer.indent {
            print("executionId = "); executionId.print(printer); println()
            print("selectedLocation = "); selectedLocation.print(printer); println()
            print("requestFocus = "); requestFocus.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class TestOutput (
    val text: String,
    val stdOut: Boolean,
    name: String,
    id: String?,
    executionId: Long
) : NodeEvent (
    name,
    id,
    executionId
) {
    //companion
    
    companion object : IMarshaller<TestOutput> {
        override val _type: KClass<TestOutput> = TestOutput::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TestOutput  {
            val name = buffer.readString()
            val id = buffer.readNullable { buffer.readString() }
            val executionId = buffer.readLong()
            val text = buffer.readString()
            val stdOut = buffer.readBool()
            return TestOutput(text, stdOut, name, id, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TestOutput)  {
            buffer.writeString(value.name)
            buffer.writeNullable(value.id) { buffer.writeString(it) }
            buffer.writeLong(value.executionId)
            buffer.writeString(value.text)
            buffer.writeBool(value.stdOut)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TestOutput
        
        if (text != other.text) return false
        if (stdOut != other.stdOut) return false
        if (name != other.name) return false
        if (id != other.id) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + stdOut.hashCode()
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (id != null) id.hashCode() else 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestOutput (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("stdOut = "); stdOut.print(printer); println()
            print("name = "); name.print(printer); println()
            print("id = "); id.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class TestSelectionModel (
    val executionId: Long,
    val selectedLocation: String?
) : com.jetbrains.rd.ide.model.ActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<TestSelectionModel> {
        override val _type: KClass<TestSelectionModel> = TestSelectionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TestSelectionModel  {
            val executionId = buffer.readLong()
            val selectedLocation = buffer.readNullable { buffer.readString() }
            return TestSelectionModel(executionId, selectedLocation)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TestSelectionModel)  {
            buffer.writeLong(value.executionId)
            buffer.writeNullable(value.selectedLocation) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TestSelectionModel
        
        if (executionId != other.executionId) return false
        if (selectedLocation != other.selectedLocation) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + executionId.hashCode()
        __r = __r*31 + if (selectedLocation != null) selectedLocation.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestSelectionModel (")
        printer.indent {
            print("executionId = "); executionId.print(printer); println()
            print("selectedLocation = "); selectedLocation.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class TestStarted (
    val locationUrl: String?,
    val parentId: String?,
    name: String,
    id: String?,
    executionId: Long
) : NodeEvent (
    name,
    id,
    executionId
) {
    //companion
    
    companion object : IMarshaller<TestStarted> {
        override val _type: KClass<TestStarted> = TestStarted::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TestStarted  {
            val name = buffer.readString()
            val id = buffer.readNullable { buffer.readString() }
            val executionId = buffer.readLong()
            val locationUrl = buffer.readNullable { buffer.readString() }
            val parentId = buffer.readNullable { buffer.readString() }
            return TestStarted(locationUrl, parentId, name, id, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TestStarted)  {
            buffer.writeString(value.name)
            buffer.writeNullable(value.id) { buffer.writeString(it) }
            buffer.writeLong(value.executionId)
            buffer.writeNullable(value.locationUrl) { buffer.writeString(it) }
            buffer.writeNullable(value.parentId) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TestStarted
        
        if (locationUrl != other.locationUrl) return false
        if (parentId != other.parentId) return false
        if (name != other.name) return false
        if (id != other.id) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (locationUrl != null) locationUrl.hashCode() else 0
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + if (id != null) id.hashCode() else 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestStarted (")
        printer.indent {
            print("locationUrl = "); locationUrl.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("name = "); name.print(printer); println()
            print("id = "); id.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
abstract class TestsModel (
    val executionId: Long
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<TestsModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): TestsModel  {
            val objectStartPosition = buffer.position
            val executionId = buffer.readLong()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return TestsModel_Unknown(executionId, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class TestsModel_Unknown (
    executionId: Long,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : TestsModel (
    executionId
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<TestsModel_Unknown> {
        override val _type: KClass<TestsModel_Unknown> = TestsModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TestsModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TestsModel_Unknown)  {
            buffer.writeLong(value.executionId)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TestsModel_Unknown
        
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TestsModel_Unknown (")
        printer.indent {
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TestsRunContentModel.kt]
 */
class Uncapture (
    val output: CodeWithMeOutputMessage,
    executionId: Long
) : TestsModel (
    executionId
) {
    //companion
    
    companion object : IMarshaller<Uncapture> {
        override val _type: KClass<Uncapture> = Uncapture::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): Uncapture  {
            val executionId = buffer.readLong()
            val output = CodeWithMeOutputMessage.read(ctx, buffer)
            return Uncapture(output, executionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: Uncapture)  {
            buffer.writeLong(value.executionId)
            CodeWithMeOutputMessage.write(ctx, buffer, value.output)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as Uncapture
        
        if (output != other.output) return false
        if (executionId != other.executionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + output.hashCode()
        __r = __r*31 + executionId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("Uncapture (")
        printer.indent {
            print("output = "); output.print(printer); println()
            print("executionId = "); executionId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
