@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
class ThinClientBuildModel private constructor(
    private val _buildEvent: RdSignal<BuildEventModel>,
    private val _navigate: RdSignal<FileNavigation>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(ProgressBuildEventModel)
            serializers.register(OutputBuildEventModel)
            serializers.register(MessageEventModel)
            serializers.register(FilePositionModel)
            serializers.register(MessageEventKind.marshaller)
            serializers.register(FinishBuildEventModel)
            serializers.register(FinishEventModel)
            serializers.register(BuildResultKindModel.marshaller)
            serializers.register(StartBuildEventModel)
            serializers.register(StartEventModel)
            serializers.register(PlainBuildEventModel)
            serializers.register(BuildDescriptorModel)
            serializers.register(FileNavigation)
            serializers.register(BuildEventModel_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): ThinClientBuildModel  {
            IdeRoot.register(protocol.serializers)
            
            return ThinClientBuildModel().apply {
                identify(protocol.identity, RdId.Null.mix("ThinClientBuildModel"))
                bind(lifetime, protocol, "ThinClientBuildModel")
            }
        }
        
        
        const val serializationHash = 3118281505934030186L
        
    }
    override val serializersOwner: ISerializersOwner get() = ThinClientBuildModel
    override val serializationHash: Long get() = ThinClientBuildModel.serializationHash
    
    //fields
    val buildEvent: IAsyncSignal<BuildEventModel> get() = _buildEvent
    val navigate: IAsyncSignal<FileNavigation> get() = _navigate
    //methods
    //initializer
    init {
        _buildEvent.async = true
        _navigate.async = true
    }
    
    init {
        bindableChildren.add("buildEvent" to _buildEvent)
        bindableChildren.add("navigate" to _navigate)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdSignal<BuildEventModel>(AbstractPolymorphic(BuildEventModel)),
        RdSignal<FileNavigation>(FileNavigation)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ThinClientBuildModel (")
        printer.indent {
            print("buildEvent = "); _buildEvent.print(printer); println()
            print("navigate = "); _navigate.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ThinClientBuildModel   {
        return ThinClientBuildModel(
            _buildEvent.deepClonePolymorphic(),
            _navigate.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
data class BuildDescriptorModel (
    val id: Long,
    val title: String,
    val workingDir: String,
    val startTime: Long,
    val isActivateToolWindowWhenAdded: Boolean?,
    val isActivateToolWindowWhenFailed: Boolean?,
    val isAutoFocusContent: Boolean?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<BuildDescriptorModel> {
        override val _type: KClass<BuildDescriptorModel> = BuildDescriptorModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BuildDescriptorModel  {
            val id = buffer.readLong()
            val title = buffer.readString()
            val workingDir = buffer.readString()
            val startTime = buffer.readLong()
            val isActivateToolWindowWhenAdded = buffer.readNullable { buffer.readBool() }
            val isActivateToolWindowWhenFailed = buffer.readNullable { buffer.readBool() }
            val isAutoFocusContent = buffer.readNullable { buffer.readBool() }
            return BuildDescriptorModel(id, title, workingDir, startTime, isActivateToolWindowWhenAdded, isActivateToolWindowWhenFailed, isAutoFocusContent)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BuildDescriptorModel)  {
            buffer.writeLong(value.id)
            buffer.writeString(value.title)
            buffer.writeString(value.workingDir)
            buffer.writeLong(value.startTime)
            buffer.writeNullable(value.isActivateToolWindowWhenAdded) { buffer.writeBool(it) }
            buffer.writeNullable(value.isActivateToolWindowWhenFailed) { buffer.writeBool(it) }
            buffer.writeNullable(value.isAutoFocusContent) { buffer.writeBool(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BuildDescriptorModel
        
        if (id != other.id) return false
        if (title != other.title) return false
        if (workingDir != other.workingDir) return false
        if (startTime != other.startTime) return false
        if (isActivateToolWindowWhenAdded != other.isActivateToolWindowWhenAdded) return false
        if (isActivateToolWindowWhenFailed != other.isActivateToolWindowWhenFailed) return false
        if (isAutoFocusContent != other.isAutoFocusContent) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + title.hashCode()
        __r = __r*31 + workingDir.hashCode()
        __r = __r*31 + startTime.hashCode()
        __r = __r*31 + if (isActivateToolWindowWhenAdded != null) isActivateToolWindowWhenAdded.hashCode() else 0
        __r = __r*31 + if (isActivateToolWindowWhenFailed != null) isActivateToolWindowWhenFailed.hashCode() else 0
        __r = __r*31 + if (isAutoFocusContent != null) isAutoFocusContent.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BuildDescriptorModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("title = "); title.print(printer); println()
            print("workingDir = "); workingDir.print(printer); println()
            print("startTime = "); startTime.print(printer); println()
            print("isActivateToolWindowWhenAdded = "); isActivateToolWindowWhenAdded.print(printer); println()
            print("isActivateToolWindowWhenFailed = "); isActivateToolWindowWhenFailed.print(printer); println()
            print("isAutoFocusContent = "); isAutoFocusContent.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
abstract class BuildEventModel (
    val buildId: Long,
    val id: Long,
    val parentId: Long?,
    val eventTime: Long,
    val message: String
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<BuildEventModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BuildEventModel  {
            val objectStartPosition = buffer.position
            val buildId = buffer.readLong()
            val id = buffer.readLong()
            val parentId = buffer.readNullable { buffer.readLong() }
            val eventTime = buffer.readLong()
            val message = buffer.readString()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BuildEventModel_Unknown(buildId, id, parentId, eventTime, message, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BuildEventModel_Unknown (
    buildId: Long,
    id: Long,
    parentId: Long?,
    eventTime: Long,
    message: String,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BuildEventModel (
    buildId,
    id,
    parentId,
    eventTime,
    message
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BuildEventModel_Unknown> {
        override val _type: KClass<BuildEventModel_Unknown> = BuildEventModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BuildEventModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BuildEventModel_Unknown)  {
            buffer.writeLong(value.buildId)
            buffer.writeLong(value.id)
            buffer.writeNullable(value.parentId) { buffer.writeLong(it) }
            buffer.writeLong(value.eventTime)
            buffer.writeString(value.message)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BuildEventModel_Unknown
        
        if (buildId != other.buildId) return false
        if (id != other.id) return false
        if (parentId != other.parentId) return false
        if (eventTime != other.eventTime) return false
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + buildId.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + eventTime.hashCode()
        __r = __r*31 + message.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BuildEventModel_Unknown (")
        printer.indent {
            print("buildId = "); buildId.print(printer); println()
            print("id = "); id.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("eventTime = "); eventTime.print(printer); println()
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
enum class BuildResultKindModel {
    Success, 
    Failure, 
    Skipped, 
    Other;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BuildResultKindModel>()
        
    }
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
data class FileNavigation (
    val position: FilePositionModel,
    val requestFocus: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<FileNavigation> {
        override val _type: KClass<FileNavigation> = FileNavigation::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FileNavigation  {
            val position = FilePositionModel.read(ctx, buffer)
            val requestFocus = buffer.readBool()
            return FileNavigation(position, requestFocus)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FileNavigation)  {
            FilePositionModel.write(ctx, buffer, value.position)
            buffer.writeBool(value.requestFocus)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FileNavigation
        
        if (position != other.position) return false
        if (requestFocus != other.requestFocus) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + position.hashCode()
        __r = __r*31 + requestFocus.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FileNavigation (")
        printer.indent {
            print("position = "); position.print(printer); println()
            print("requestFocus = "); requestFocus.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
data class FilePositionModel (
    val filePath: String,
    val line: Int,
    val column: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<FilePositionModel> {
        override val _type: KClass<FilePositionModel> = FilePositionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FilePositionModel  {
            val filePath = buffer.readString()
            val line = buffer.readInt()
            val column = buffer.readInt()
            return FilePositionModel(filePath, line, column)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FilePositionModel)  {
            buffer.writeString(value.filePath)
            buffer.writeInt(value.line)
            buffer.writeInt(value.column)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FilePositionModel
        
        if (filePath != other.filePath) return false
        if (line != other.line) return false
        if (column != other.column) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + filePath.hashCode()
        __r = __r*31 + line.hashCode()
        __r = __r*31 + column.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FilePositionModel (")
        printer.indent {
            print("filePath = "); filePath.print(printer); println()
            print("line = "); line.print(printer); println()
            print("column = "); column.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
class FinishBuildEventModel (
    val buildResult: BuildResultKindModel,
    buildId: Long,
    id: Long,
    parentId: Long?,
    eventTime: Long,
    message: String
) : BuildEventModel (
    buildId,
    id,
    parentId,
    eventTime,
    message
) {
    //companion
    
    companion object : IMarshaller<FinishBuildEventModel> {
        override val _type: KClass<FinishBuildEventModel> = FinishBuildEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FinishBuildEventModel  {
            val buildId = buffer.readLong()
            val id = buffer.readLong()
            val parentId = buffer.readNullable { buffer.readLong() }
            val eventTime = buffer.readLong()
            val message = buffer.readString()
            val buildResult = buffer.readEnum<BuildResultKindModel>()
            return FinishBuildEventModel(buildResult, buildId, id, parentId, eventTime, message)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FinishBuildEventModel)  {
            buffer.writeLong(value.buildId)
            buffer.writeLong(value.id)
            buffer.writeNullable(value.parentId) { buffer.writeLong(it) }
            buffer.writeLong(value.eventTime)
            buffer.writeString(value.message)
            buffer.writeEnum(value.buildResult)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FinishBuildEventModel
        
        if (buildResult != other.buildResult) return false
        if (buildId != other.buildId) return false
        if (id != other.id) return false
        if (parentId != other.parentId) return false
        if (eventTime != other.eventTime) return false
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + buildResult.hashCode()
        __r = __r*31 + buildId.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + eventTime.hashCode()
        __r = __r*31 + message.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FinishBuildEventModel (")
        printer.indent {
            print("buildResult = "); buildResult.print(printer); println()
            print("buildId = "); buildId.print(printer); println()
            print("id = "); id.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("eventTime = "); eventTime.print(printer); println()
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
class FinishEventModel (
    val buildResult: BuildResultKindModel,
    buildId: Long,
    id: Long,
    parentId: Long?,
    eventTime: Long,
    message: String
) : BuildEventModel (
    buildId,
    id,
    parentId,
    eventTime,
    message
) {
    //companion
    
    companion object : IMarshaller<FinishEventModel> {
        override val _type: KClass<FinishEventModel> = FinishEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FinishEventModel  {
            val buildId = buffer.readLong()
            val id = buffer.readLong()
            val parentId = buffer.readNullable { buffer.readLong() }
            val eventTime = buffer.readLong()
            val message = buffer.readString()
            val buildResult = buffer.readEnum<BuildResultKindModel>()
            return FinishEventModel(buildResult, buildId, id, parentId, eventTime, message)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FinishEventModel)  {
            buffer.writeLong(value.buildId)
            buffer.writeLong(value.id)
            buffer.writeNullable(value.parentId) { buffer.writeLong(it) }
            buffer.writeLong(value.eventTime)
            buffer.writeString(value.message)
            buffer.writeEnum(value.buildResult)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FinishEventModel
        
        if (buildResult != other.buildResult) return false
        if (buildId != other.buildId) return false
        if (id != other.id) return false
        if (parentId != other.parentId) return false
        if (eventTime != other.eventTime) return false
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + buildResult.hashCode()
        __r = __r*31 + buildId.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + eventTime.hashCode()
        __r = __r*31 + message.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FinishEventModel (")
        printer.indent {
            print("buildResult = "); buildResult.print(printer); println()
            print("buildId = "); buildId.print(printer); println()
            print("id = "); id.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("eventTime = "); eventTime.print(printer); println()
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
enum class MessageEventKind {
    Error, 
    Warning, 
    Info, 
    Statistics, 
    Simple;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<MessageEventKind>()
        
    }
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
class MessageEventModel (
    val kind: MessageEventKind,
    val group: String,
    val filePosition: FilePositionModel?,
    val detailedMessage: String?,
    buildId: Long,
    id: Long,
    parentId: Long?,
    eventTime: Long,
    message: String
) : BuildEventModel (
    buildId,
    id,
    parentId,
    eventTime,
    message
) {
    //companion
    
    companion object : IMarshaller<MessageEventModel> {
        override val _type: KClass<MessageEventModel> = MessageEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): MessageEventModel  {
            val buildId = buffer.readLong()
            val id = buffer.readLong()
            val parentId = buffer.readNullable { buffer.readLong() }
            val eventTime = buffer.readLong()
            val message = buffer.readString()
            val kind = buffer.readEnum<MessageEventKind>()
            val group = buffer.readString()
            val filePosition = buffer.readNullable { FilePositionModel.read(ctx, buffer) }
            val detailedMessage = buffer.readNullable { buffer.readString() }
            return MessageEventModel(kind, group, filePosition, detailedMessage, buildId, id, parentId, eventTime, message)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: MessageEventModel)  {
            buffer.writeLong(value.buildId)
            buffer.writeLong(value.id)
            buffer.writeNullable(value.parentId) { buffer.writeLong(it) }
            buffer.writeLong(value.eventTime)
            buffer.writeString(value.message)
            buffer.writeEnum(value.kind)
            buffer.writeString(value.group)
            buffer.writeNullable(value.filePosition) { FilePositionModel.write(ctx, buffer, it) }
            buffer.writeNullable(value.detailedMessage) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as MessageEventModel
        
        if (kind != other.kind) return false
        if (group != other.group) return false
        if (filePosition != other.filePosition) return false
        if (detailedMessage != other.detailedMessage) return false
        if (buildId != other.buildId) return false
        if (id != other.id) return false
        if (parentId != other.parentId) return false
        if (eventTime != other.eventTime) return false
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + kind.hashCode()
        __r = __r*31 + group.hashCode()
        __r = __r*31 + if (filePosition != null) filePosition.hashCode() else 0
        __r = __r*31 + if (detailedMessage != null) detailedMessage.hashCode() else 0
        __r = __r*31 + buildId.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + eventTime.hashCode()
        __r = __r*31 + message.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("MessageEventModel (")
        printer.indent {
            print("kind = "); kind.print(printer); println()
            print("group = "); group.print(printer); println()
            print("filePosition = "); filePosition.print(printer); println()
            print("detailedMessage = "); detailedMessage.print(printer); println()
            print("buildId = "); buildId.print(printer); println()
            print("id = "); id.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("eventTime = "); eventTime.print(printer); println()
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
class OutputBuildEventModel (
    val stdOut: Boolean,
    buildId: Long,
    id: Long,
    parentId: Long?,
    eventTime: Long,
    message: String
) : BuildEventModel (
    buildId,
    id,
    parentId,
    eventTime,
    message
) {
    //companion
    
    companion object : IMarshaller<OutputBuildEventModel> {
        override val _type: KClass<OutputBuildEventModel> = OutputBuildEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OutputBuildEventModel  {
            val buildId = buffer.readLong()
            val id = buffer.readLong()
            val parentId = buffer.readNullable { buffer.readLong() }
            val eventTime = buffer.readLong()
            val message = buffer.readString()
            val stdOut = buffer.readBool()
            return OutputBuildEventModel(stdOut, buildId, id, parentId, eventTime, message)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OutputBuildEventModel)  {
            buffer.writeLong(value.buildId)
            buffer.writeLong(value.id)
            buffer.writeNullable(value.parentId) { buffer.writeLong(it) }
            buffer.writeLong(value.eventTime)
            buffer.writeString(value.message)
            buffer.writeBool(value.stdOut)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OutputBuildEventModel
        
        if (stdOut != other.stdOut) return false
        if (buildId != other.buildId) return false
        if (id != other.id) return false
        if (parentId != other.parentId) return false
        if (eventTime != other.eventTime) return false
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + stdOut.hashCode()
        __r = __r*31 + buildId.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + eventTime.hashCode()
        __r = __r*31 + message.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OutputBuildEventModel (")
        printer.indent {
            print("stdOut = "); stdOut.print(printer); println()
            print("buildId = "); buildId.print(printer); println()
            print("id = "); id.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("eventTime = "); eventTime.print(printer); println()
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
class PlainBuildEventModel (
    buildId: Long,
    id: Long,
    parentId: Long?,
    eventTime: Long,
    message: String
) : BuildEventModel (
    buildId,
    id,
    parentId,
    eventTime,
    message
) {
    //companion
    
    companion object : IMarshaller<PlainBuildEventModel> {
        override val _type: KClass<PlainBuildEventModel> = PlainBuildEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): PlainBuildEventModel  {
            val buildId = buffer.readLong()
            val id = buffer.readLong()
            val parentId = buffer.readNullable { buffer.readLong() }
            val eventTime = buffer.readLong()
            val message = buffer.readString()
            return PlainBuildEventModel(buildId, id, parentId, eventTime, message)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: PlainBuildEventModel)  {
            buffer.writeLong(value.buildId)
            buffer.writeLong(value.id)
            buffer.writeNullable(value.parentId) { buffer.writeLong(it) }
            buffer.writeLong(value.eventTime)
            buffer.writeString(value.message)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as PlainBuildEventModel
        
        if (buildId != other.buildId) return false
        if (id != other.id) return false
        if (parentId != other.parentId) return false
        if (eventTime != other.eventTime) return false
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + buildId.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + eventTime.hashCode()
        __r = __r*31 + message.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("PlainBuildEventModel (")
        printer.indent {
            print("buildId = "); buildId.print(printer); println()
            print("id = "); id.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("eventTime = "); eventTime.print(printer); println()
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
class ProgressBuildEventModel (
    val total: Long,
    val progress: Long,
    val unit: String,
    buildId: Long,
    id: Long,
    parentId: Long?,
    eventTime: Long,
    message: String
) : BuildEventModel (
    buildId,
    id,
    parentId,
    eventTime,
    message
) {
    //companion
    
    companion object : IMarshaller<ProgressBuildEventModel> {
        override val _type: KClass<ProgressBuildEventModel> = ProgressBuildEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ProgressBuildEventModel  {
            val buildId = buffer.readLong()
            val id = buffer.readLong()
            val parentId = buffer.readNullable { buffer.readLong() }
            val eventTime = buffer.readLong()
            val message = buffer.readString()
            val total = buffer.readLong()
            val progress = buffer.readLong()
            val unit = buffer.readString()
            return ProgressBuildEventModel(total, progress, unit, buildId, id, parentId, eventTime, message)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ProgressBuildEventModel)  {
            buffer.writeLong(value.buildId)
            buffer.writeLong(value.id)
            buffer.writeNullable(value.parentId) { buffer.writeLong(it) }
            buffer.writeLong(value.eventTime)
            buffer.writeString(value.message)
            buffer.writeLong(value.total)
            buffer.writeLong(value.progress)
            buffer.writeString(value.unit)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ProgressBuildEventModel
        
        if (total != other.total) return false
        if (progress != other.progress) return false
        if (unit != other.unit) return false
        if (buildId != other.buildId) return false
        if (id != other.id) return false
        if (parentId != other.parentId) return false
        if (eventTime != other.eventTime) return false
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + total.hashCode()
        __r = __r*31 + progress.hashCode()
        __r = __r*31 + unit.hashCode()
        __r = __r*31 + buildId.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + eventTime.hashCode()
        __r = __r*31 + message.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ProgressBuildEventModel (")
        printer.indent {
            print("total = "); total.print(printer); println()
            print("progress = "); progress.print(printer); println()
            print("unit = "); unit.print(printer); println()
            print("buildId = "); buildId.print(printer); println()
            print("id = "); id.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("eventTime = "); eventTime.print(printer); println()
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
class StartBuildEventModel (
    val buildDescriptor: BuildDescriptorModel,
    buildId: Long,
    id: Long,
    parentId: Long?,
    eventTime: Long,
    message: String
) : BuildEventModel (
    buildId,
    id,
    parentId,
    eventTime,
    message
) {
    //companion
    
    companion object : IMarshaller<StartBuildEventModel> {
        override val _type: KClass<StartBuildEventModel> = StartBuildEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): StartBuildEventModel  {
            val buildId = buffer.readLong()
            val id = buffer.readLong()
            val parentId = buffer.readNullable { buffer.readLong() }
            val eventTime = buffer.readLong()
            val message = buffer.readString()
            val buildDescriptor = BuildDescriptorModel.read(ctx, buffer)
            return StartBuildEventModel(buildDescriptor, buildId, id, parentId, eventTime, message)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: StartBuildEventModel)  {
            buffer.writeLong(value.buildId)
            buffer.writeLong(value.id)
            buffer.writeNullable(value.parentId) { buffer.writeLong(it) }
            buffer.writeLong(value.eventTime)
            buffer.writeString(value.message)
            BuildDescriptorModel.write(ctx, buffer, value.buildDescriptor)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as StartBuildEventModel
        
        if (buildDescriptor != other.buildDescriptor) return false
        if (buildId != other.buildId) return false
        if (id != other.id) return false
        if (parentId != other.parentId) return false
        if (eventTime != other.eventTime) return false
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + buildDescriptor.hashCode()
        __r = __r*31 + buildId.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + eventTime.hashCode()
        __r = __r*31 + message.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("StartBuildEventModel (")
        printer.indent {
            print("buildDescriptor = "); buildDescriptor.print(printer); println()
            print("buildId = "); buildId.print(printer); println()
            print("id = "); id.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("eventTime = "); eventTime.print(printer); println()
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [ThinClientBuildModel.kt]
 */
class StartEventModel (
    buildId: Long,
    id: Long,
    parentId: Long?,
    eventTime: Long,
    message: String
) : BuildEventModel (
    buildId,
    id,
    parentId,
    eventTime,
    message
) {
    //companion
    
    companion object : IMarshaller<StartEventModel> {
        override val _type: KClass<StartEventModel> = StartEventModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): StartEventModel  {
            val buildId = buffer.readLong()
            val id = buffer.readLong()
            val parentId = buffer.readNullable { buffer.readLong() }
            val eventTime = buffer.readLong()
            val message = buffer.readString()
            return StartEventModel(buildId, id, parentId, eventTime, message)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: StartEventModel)  {
            buffer.writeLong(value.buildId)
            buffer.writeLong(value.id)
            buffer.writeNullable(value.parentId) { buffer.writeLong(it) }
            buffer.writeLong(value.eventTime)
            buffer.writeString(value.message)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as StartEventModel
        
        if (buildId != other.buildId) return false
        if (id != other.id) return false
        if (parentId != other.parentId) return false
        if (eventTime != other.eventTime) return false
        if (message != other.message) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + buildId.hashCode()
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + eventTime.hashCode()
        __r = __r*31 + message.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("StartEventModel (")
        printer.indent {
            print("buildId = "); buildId.print(printer); println()
            print("id = "); id.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("eventTime = "); eventTime.print(printer); println()
            print("message = "); message.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
