@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [ToolWindowModel.kt]
 */
class ToolWindowModel private constructor(
    private val _availableToolWindows: RdMap<String, BeIdeaToolWindow>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RdToolWindowAccessLevel.marshaller)
            serializers.register(BeIdeaToolWindow)
        }
        
        
        
        
        const val serializationHash = 3799728652203839573L
        
    }
    override val serializersOwner: ISerializersOwner get() = ToolWindowModel
    override val serializationHash: Long get() = ToolWindowModel.serializationHash
    
    //fields
    val availableToolWindows: IMutableViewableMap<String, BeIdeaToolWindow> get() = _availableToolWindows
    //methods
    //initializer
    init {
        bindableChildren.add("availableToolWindows" to _availableToolWindows)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdMap<String, BeIdeaToolWindow>(FrameworkMarshallers.String, BeIdeaToolWindow)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ToolWindowModel (")
        printer.indent {
            print("availableToolWindows = "); _availableToolWindows.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ToolWindowModel   {
        return ToolWindowModel(
            _availableToolWindows.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.toolWindowModel get() = getOrCreateExtension("toolWindowModel", ::ToolWindowModel)



/**
 * #### Generated from [ToolWindowModel.kt]
 */
class BeIdeaToolWindow private constructor(
    val toolWindow: com.jetbrains.ide.model.uiautomation.BeToolWindow,
    private val _accessLevel: RdOptionalProperty<RdToolWindowAccessLevel>,
    private val _isSharedAccess: RdOptionalProperty<Boolean>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BeIdeaToolWindow> {
        override val _type: KClass<BeIdeaToolWindow> = BeIdeaToolWindow::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeIdeaToolWindow  {
            val _id = RdId.read(buffer)
            val toolWindow = com.jetbrains.ide.model.uiautomation.BeToolWindow.read(ctx, buffer)
            val _accessLevel = RdOptionalProperty.read(ctx, buffer, RdToolWindowAccessLevel.marshaller)
            val _isSharedAccess = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            return BeIdeaToolWindow(toolWindow, _accessLevel, _isSharedAccess).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeIdeaToolWindow)  {
            value.rdid.write(buffer)
            com.jetbrains.ide.model.uiautomation.BeToolWindow.write(ctx, buffer, value.toolWindow)
            RdOptionalProperty.write(ctx, buffer, value._accessLevel)
            RdOptionalProperty.write(ctx, buffer, value._isSharedAccess)
        }
        
        
    }
    //fields
    val accessLevel: IOptProperty<RdToolWindowAccessLevel> get() = _accessLevel
    
    /**
     * If window is in MIRROR mode and multiple users open it simultaneously
     */
    val isSharedAccess: IOptProperty<Boolean> get() = _isSharedAccess
    //methods
    //initializer
    init {
        _accessLevel.optimizeNested = true
        _isSharedAccess.optimizeNested = true
    }
    
    init {
        bindableChildren.add("toolWindow" to toolWindow)
        bindableChildren.add("accessLevel" to _accessLevel)
        bindableChildren.add("isSharedAccess" to _isSharedAccess)
    }
    
    //secondary constructor
    constructor(
        toolWindow: com.jetbrains.ide.model.uiautomation.BeToolWindow
    ) : this(
        toolWindow,
        RdOptionalProperty<RdToolWindowAccessLevel>(RdToolWindowAccessLevel.marshaller),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeIdeaToolWindow (")
        printer.indent {
            print("toolWindow = "); toolWindow.print(printer); println()
            print("accessLevel = "); _accessLevel.print(printer); println()
            print("isSharedAccess = "); _isSharedAccess.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeIdeaToolWindow   {
        return BeIdeaToolWindow(
            toolWindow.deepClonePolymorphic(),
            _accessLevel.deepClonePolymorphic(),
            _isSharedAccess.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [ToolWindowModel.kt]
 */
enum class RdToolWindowAccessLevel {
    Disabled, 
    Readonly, 
    FullAccess;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<RdToolWindowAccessLevel>()
        
    }
}
