@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.ide.model.tooltips

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [TooltipsModel.kt]
 */
class TooltipsModel private constructor(
    private val _message: RdSignal<TooltipDescriptor>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(TooltipType.marshaller)
            serializers.register(TooltipDescriptor)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): TooltipsModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return TooltipsModel().apply {
                identify(protocol.identity, RdId.Null.mix("TooltipsModel"))
                bind(lifetime, protocol, "TooltipsModel")
            }
        }
        
        
        const val serializationHash = 1996738373844745671L
        
    }
    override val serializersOwner: ISerializersOwner get() = TooltipsModel
    override val serializationHash: Long get() = TooltipsModel.serializationHash
    
    //fields
    val message: ISignal<TooltipDescriptor> get() = _message
    //methods
    //initializer
    init {
        bindableChildren.add("message" to _message)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdSignal<TooltipDescriptor>(TooltipDescriptor)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TooltipsModel (")
        printer.indent {
            print("message = "); _message.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): TooltipsModel   {
        return TooltipsModel(
            _message.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [TooltipsModel.kt]
 */
data class TooltipDescriptor (
    val type: TooltipType,
    val unescapedText: String,
    val timestamps: List<com.jetbrains.ide.model.uicontext.ContextPair>,
    val context: com.jetbrains.ide.model.popups.RdPopupWindowContextBase
) : IPrintable {
    //companion
    
    companion object : IMarshaller<TooltipDescriptor> {
        override val _type: KClass<TooltipDescriptor> = TooltipDescriptor::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TooltipDescriptor  {
            val type = buffer.readEnum<TooltipType>()
            val unescapedText = buffer.readString()
            val timestamps = buffer.readList { com.jetbrains.ide.model.uicontext.ContextPair.read(ctx, buffer) }
            val context = ctx.serializers.readPolymorphic<com.jetbrains.ide.model.popups.RdPopupWindowContextBase>(ctx, buffer, com.jetbrains.ide.model.popups.RdPopupWindowContextBase)
            return TooltipDescriptor(type, unescapedText, timestamps, context)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TooltipDescriptor)  {
            buffer.writeEnum(value.type)
            buffer.writeString(value.unescapedText)
            buffer.writeList(value.timestamps) { v -> com.jetbrains.ide.model.uicontext.ContextPair.write(ctx, buffer, v) }
            ctx.serializers.writePolymorphic(ctx, buffer, value.context)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TooltipDescriptor
        
        if (type != other.type) return false
        if (unescapedText != other.unescapedText) return false
        if (timestamps != other.timestamps) return false
        if (context != other.context) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + type.hashCode()
        __r = __r*31 + unescapedText.hashCode()
        __r = __r*31 + timestamps.hashCode()
        __r = __r*31 + context.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TooltipDescriptor (")
        printer.indent {
            print("type = "); type.print(printer); println()
            print("unescapedText = "); unescapedText.print(printer); println()
            print("timestamps = "); timestamps.print(printer); println()
            print("context = "); context.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [TooltipsModel.kt]
 */
enum class TooltipType {
    ERROR, 
    INFO;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<TooltipType>()
        
    }
}
