@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [TypeHierarchyModel.kt]
 */
class TypeHierarchyModel private constructor(
    private val _sessions: RdMap<Int, RdTypeHierarchyTree>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(TypeHierarchyViewStyle.marshaller)
            serializers.register(RdTypeHierarchyTreeSelectedItemConstant)
            serializers.register(RdTypeHierarchyTreeItem)
            serializers.register(RdTypeHierarchyTreeView)
            serializers.register(RdTypeHierarchyTree)
            serializers.register(RdTypeHierarchyTreeNavigateArgs)
            serializers.register(RdTypeHierarchyTreeBuildViewArgs)
        }
        
        
        
        
        const val serializationHash = 8689536043556982272L
        
    }
    override val serializersOwner: ISerializersOwner get() = TypeHierarchyModel
    override val serializationHash: Long get() = TypeHierarchyModel.serializationHash
    
    //fields
    val sessions: IMutableViewableMap<Int, RdTypeHierarchyTree> get() = _sessions
    //methods
    //initializer
    init {
        bindableChildren.add("sessions" to _sessions)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdMap<Int, RdTypeHierarchyTree>(FrameworkMarshallers.Int, RdTypeHierarchyTree)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TypeHierarchyModel (")
        printer.indent {
            print("sessions = "); _sessions.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): TypeHierarchyModel   {
        return TypeHierarchyModel(
            _sessions.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.typeHierarchyModel get() = getOrCreateExtension("typeHierarchyModel", ::TypeHierarchyModel)



/**
 * #### Generated from [TypeHierarchyModel.kt]
 */
class RdTypeHierarchyTree private constructor(
    val supportedViews: Array<TypeHierarchyViewStyle>,
    private val _baseTypeName: RdProperty<String>,
    private val _baseTypeContainerInfo: RdProperty<String>,
    private val _viewToObserveChanges: RdProperty<TypeHierarchyViewStyle?>,
    private val _isShowingElementsFromThisSolution: RdProperty<Boolean>,
    private val _refresh: RdSignal<Unit>,
    private val _isRefreshing: RdProperty<Boolean>,
    private val _views: RdMap<TypeHierarchyViewStyle, RdTypeHierarchyTreeView>,
    private val _buildView: RdSignal<RdTypeHierarchyTreeBuildViewArgs>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdTypeHierarchyTree> {
        override val _type: KClass<RdTypeHierarchyTree> = RdTypeHierarchyTree::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTypeHierarchyTree  {
            val _id = RdId.read(buffer)
            val supportedViews = buffer.readArray {buffer.readEnum<TypeHierarchyViewStyle>()}
            val _baseTypeName = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _baseTypeContainerInfo = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _viewToObserveChanges = RdProperty.read(ctx, buffer, __TypeHierarchyViewStyleNullableSerializer)
            val _isShowingElementsFromThisSolution = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _refresh = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _isRefreshing = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _views = RdMap.read(ctx, buffer, TypeHierarchyViewStyle.marshaller, RdTypeHierarchyTreeView)
            val _buildView = RdSignal.read(ctx, buffer, RdTypeHierarchyTreeBuildViewArgs)
            return RdTypeHierarchyTree(supportedViews, _baseTypeName, _baseTypeContainerInfo, _viewToObserveChanges, _isShowingElementsFromThisSolution, _refresh, _isRefreshing, _views, _buildView).withId(_id).apply { mySerializationContext = ctx.withInternRootsHere(this, "TypeHierarchyInternScope") }
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTypeHierarchyTree)  {
            value.rdid.write(buffer)
            buffer.writeArray(value.supportedViews) { buffer.writeEnum(it) }
            RdProperty.write(ctx, buffer, value._baseTypeName)
            RdProperty.write(ctx, buffer, value._baseTypeContainerInfo)
            RdProperty.write(ctx, buffer, value._viewToObserveChanges)
            RdProperty.write(ctx, buffer, value._isShowingElementsFromThisSolution)
            RdSignal.write(ctx, buffer, value._refresh)
            RdProperty.write(ctx, buffer, value._isRefreshing)
            RdMap.write(ctx, buffer, value._views)
            RdSignal.write(ctx, buffer, value._buildView)
            value.mySerializationContext = ctx.withInternRootsHere(value, "TypeHierarchyInternScope")
        }
        
        private val __TypeHierarchyViewStyleNullableSerializer = TypeHierarchyViewStyle.marshaller.nullable()
        
    }
    //fields
    val baseTypeName: IProperty<String> get() = _baseTypeName
    val baseTypeContainerInfo: IProperty<String> get() = _baseTypeContainerInfo
    val viewToObserveChanges: IProperty<TypeHierarchyViewStyle?> get() = _viewToObserveChanges
    val isShowingElementsFromThisSolution: IProperty<Boolean> get() = _isShowingElementsFromThisSolution
    val refresh: ISignal<Unit> get() = _refresh
    val isRefreshing: IProperty<Boolean> get() = _isRefreshing
    val views: IMutableViewableMap<TypeHierarchyViewStyle, RdTypeHierarchyTreeView> get() = _views
    val buildView: ISignal<RdTypeHierarchyTreeBuildViewArgs> get() = _buildView
    private var mySerializationContext: SerializationCtx? = null
    override val serializationContext: SerializationCtx
        get() = mySerializationContext ?: throw IllegalStateException("Attempting to get serialization context too soon for $location")
    //methods
    //initializer
    init {
        _baseTypeName.optimizeNested = true
        _baseTypeContainerInfo.optimizeNested = true
        _viewToObserveChanges.optimizeNested = true
        _isShowingElementsFromThisSolution.optimizeNested = true
        _isRefreshing.optimizeNested = true
    }
    
    init {
        bindableChildren.add("baseTypeName" to _baseTypeName)
        bindableChildren.add("baseTypeContainerInfo" to _baseTypeContainerInfo)
        bindableChildren.add("viewToObserveChanges" to _viewToObserveChanges)
        bindableChildren.add("isShowingElementsFromThisSolution" to _isShowingElementsFromThisSolution)
        bindableChildren.add("refresh" to _refresh)
        bindableChildren.add("isRefreshing" to _isRefreshing)
        bindableChildren.add("views" to _views)
        bindableChildren.add("buildView" to _buildView)
    }
    
    //secondary constructor
    constructor(
        supportedViews: Array<TypeHierarchyViewStyle>
    ) : this(
        supportedViews,
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<TypeHierarchyViewStyle?>(null, __TypeHierarchyViewStyleNullableSerializer),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdMap<TypeHierarchyViewStyle, RdTypeHierarchyTreeView>(TypeHierarchyViewStyle.marshaller, RdTypeHierarchyTreeView),
        RdSignal<RdTypeHierarchyTreeBuildViewArgs>(RdTypeHierarchyTreeBuildViewArgs)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTypeHierarchyTree (")
        printer.indent {
            print("supportedViews = "); supportedViews.print(printer); println()
            print("baseTypeName = "); _baseTypeName.print(printer); println()
            print("baseTypeContainerInfo = "); _baseTypeContainerInfo.print(printer); println()
            print("viewToObserveChanges = "); _viewToObserveChanges.print(printer); println()
            print("isShowingElementsFromThisSolution = "); _isShowingElementsFromThisSolution.print(printer); println()
            print("refresh = "); _refresh.print(printer); println()
            print("isRefreshing = "); _isRefreshing.print(printer); println()
            print("views = "); _views.print(printer); println()
            print("buildView = "); _buildView.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdTypeHierarchyTree   {
        return RdTypeHierarchyTree(
            supportedViews,
            _baseTypeName.deepClonePolymorphic(),
            _baseTypeContainerInfo.deepClonePolymorphic(),
            _viewToObserveChanges.deepClonePolymorphic(),
            _isShowingElementsFromThisSolution.deepClonePolymorphic(),
            _refresh.deepClonePolymorphic(),
            _isRefreshing.deepClonePolymorphic(),
            _views.deepClonePolymorphic(),
            _buildView.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [TypeHierarchyModel.kt]
 */
data class RdTypeHierarchyTreeBuildViewArgs (
    val style: TypeHierarchyViewStyle
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdTypeHierarchyTreeBuildViewArgs> {
        override val _type: KClass<RdTypeHierarchyTreeBuildViewArgs> = RdTypeHierarchyTreeBuildViewArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTypeHierarchyTreeBuildViewArgs  {
            val style = buffer.readEnum<TypeHierarchyViewStyle>()
            return RdTypeHierarchyTreeBuildViewArgs(style)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTypeHierarchyTreeBuildViewArgs)  {
            buffer.writeEnum(value.style)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdTypeHierarchyTreeBuildViewArgs
        
        if (style != other.style) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + style.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTypeHierarchyTreeBuildViewArgs (")
        printer.indent {
            print("style = "); style.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [TypeHierarchyModel.kt]
 */
data class RdTypeHierarchyTreeItem (
    val id: Int,
    val parentId: Int?,
    val fileId: Int,
    val moduleName: String?,
    val isModuleDisambigNeeded: Boolean,
    val containerInfo: String,
    val typeName: String,
    val icon: IconModel?,
    val isValid: Boolean,
    val isBase: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdTypeHierarchyTreeItem> {
        override val _type: KClass<RdTypeHierarchyTreeItem> = RdTypeHierarchyTreeItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTypeHierarchyTreeItem  {
            val id = buffer.readInt()
            val parentId = buffer.readNullable { buffer.readInt() }
            val fileId = buffer.readInt()
            val moduleName = buffer.readNullable { ctx.readInterned(buffer, "TypeHierarchyInternScope") { _, _ -> buffer.readString() } }
            val isModuleDisambigNeeded = buffer.readBool()
            val containerInfo = ctx.readInterned(buffer, "TypeHierarchyInternScope") { _, _ -> buffer.readString() }
            val typeName = ctx.readInterned(buffer, "TypeHierarchyInternScope") { _, _ -> buffer.readString() }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val isValid = buffer.readBool()
            val isBase = buffer.readBool()
            return RdTypeHierarchyTreeItem(id, parentId, fileId, moduleName, isModuleDisambigNeeded, containerInfo, typeName, icon, isValid, isBase)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTypeHierarchyTreeItem)  {
            buffer.writeInt(value.id)
            buffer.writeNullable(value.parentId) { buffer.writeInt(it) }
            buffer.writeInt(value.fileId)
            buffer.writeNullable(value.moduleName) { ctx.writeInterned(buffer, it, "TypeHierarchyInternScope") { _, _, internedValue -> buffer.writeString(internedValue) } }
            buffer.writeBool(value.isModuleDisambigNeeded)
            ctx.writeInterned(buffer, value.containerInfo, "TypeHierarchyInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
            ctx.writeInterned(buffer, value.typeName, "TypeHierarchyInternScope") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeBool(value.isValid)
            buffer.writeBool(value.isBase)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdTypeHierarchyTreeItem
        
        if (id != other.id) return false
        if (parentId != other.parentId) return false
        if (fileId != other.fileId) return false
        if (moduleName != other.moduleName) return false
        if (isModuleDisambigNeeded != other.isModuleDisambigNeeded) return false
        if (containerInfo != other.containerInfo) return false
        if (typeName != other.typeName) return false
        if (icon != other.icon) return false
        if (isValid != other.isValid) return false
        if (isBase != other.isBase) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (parentId != null) parentId.hashCode() else 0
        __r = __r*31 + fileId.hashCode()
        __r = __r*31 + if (moduleName != null) moduleName.hashCode() else 0
        __r = __r*31 + isModuleDisambigNeeded.hashCode()
        __r = __r*31 + containerInfo.hashCode()
        __r = __r*31 + typeName.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + isValid.hashCode()
        __r = __r*31 + isBase.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTypeHierarchyTreeItem (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("parentId = "); parentId.print(printer); println()
            print("fileId = "); fileId.print(printer); println()
            print("moduleName = "); moduleName.print(printer); println()
            print("isModuleDisambigNeeded = "); isModuleDisambigNeeded.print(printer); println()
            print("containerInfo = "); containerInfo.print(printer); println()
            print("typeName = "); typeName.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("isValid = "); isValid.print(printer); println()
            print("isBase = "); isBase.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [TypeHierarchyModel.kt]
 */
data class RdTypeHierarchyTreeNavigateArgs (
    val itemId: Int,
    val requestFocus: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdTypeHierarchyTreeNavigateArgs> {
        override val _type: KClass<RdTypeHierarchyTreeNavigateArgs> = RdTypeHierarchyTreeNavigateArgs::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTypeHierarchyTreeNavigateArgs  {
            val itemId = buffer.readInt()
            val requestFocus = buffer.readBool()
            return RdTypeHierarchyTreeNavigateArgs(itemId, requestFocus)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTypeHierarchyTreeNavigateArgs)  {
            buffer.writeInt(value.itemId)
            buffer.writeBool(value.requestFocus)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdTypeHierarchyTreeNavigateArgs
        
        if (itemId != other.itemId) return false
        if (requestFocus != other.requestFocus) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + itemId.hashCode()
        __r = __r*31 + requestFocus.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTypeHierarchyTreeNavigateArgs (")
        printer.indent {
            print("itemId = "); itemId.print(printer); println()
            print("requestFocus = "); requestFocus.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [TypeHierarchyModel.kt]
 */
class RdTypeHierarchyTreeSelectedItemConstant (
    val sessionId: Int,
    val viewStyle: TypeHierarchyViewStyle,
    val itemId: Int
) : RdDataConstant (
) {
    //companion
    
    companion object : IMarshaller<RdTypeHierarchyTreeSelectedItemConstant> {
        override val _type: KClass<RdTypeHierarchyTreeSelectedItemConstant> = RdTypeHierarchyTreeSelectedItemConstant::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTypeHierarchyTreeSelectedItemConstant  {
            val sessionId = buffer.readInt()
            val viewStyle = buffer.readEnum<TypeHierarchyViewStyle>()
            val itemId = buffer.readInt()
            return RdTypeHierarchyTreeSelectedItemConstant(sessionId, viewStyle, itemId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTypeHierarchyTreeSelectedItemConstant)  {
            buffer.writeInt(value.sessionId)
            buffer.writeEnum(value.viewStyle)
            buffer.writeInt(value.itemId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdTypeHierarchyTreeSelectedItemConstant
        
        if (sessionId != other.sessionId) return false
        if (viewStyle != other.viewStyle) return false
        if (itemId != other.itemId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + sessionId.hashCode()
        __r = __r*31 + viewStyle.hashCode()
        __r = __r*31 + itemId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTypeHierarchyTreeSelectedItemConstant (")
        printer.indent {
            print("sessionId = "); sessionId.print(printer); println()
            print("viewStyle = "); viewStyle.print(printer); println()
            print("itemId = "); itemId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [TypeHierarchyModel.kt]
 */
class RdTypeHierarchyTreeView private constructor(
    val style: TypeHierarchyViewStyle,
    private val _items: RdMap<Int, RdTypeHierarchyTreeItem>,
    private val _isReady: RdOptionalProperty<Boolean>,
    private val _navigate: RdSignal<RdTypeHierarchyTreeNavigateArgs>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdTypeHierarchyTreeView> {
        override val _type: KClass<RdTypeHierarchyTreeView> = RdTypeHierarchyTreeView::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTypeHierarchyTreeView  {
            val _id = RdId.read(buffer)
            val style = buffer.readEnum<TypeHierarchyViewStyle>()
            val _items = RdMap.read(ctx, buffer, FrameworkMarshallers.Int, RdTypeHierarchyTreeItem)
            val _isReady = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _navigate = RdSignal.read(ctx, buffer, RdTypeHierarchyTreeNavigateArgs)
            return RdTypeHierarchyTreeView(style, _items, _isReady, _navigate).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTypeHierarchyTreeView)  {
            value.rdid.write(buffer)
            buffer.writeEnum(value.style)
            RdMap.write(ctx, buffer, value._items)
            RdOptionalProperty.write(ctx, buffer, value._isReady)
            RdSignal.write(ctx, buffer, value._navigate)
        }
        
        
    }
    //fields
    val items: IMutableViewableMap<Int, RdTypeHierarchyTreeItem> get() = _items
    val isReady: IOptProperty<Boolean> get() = _isReady
    val navigate: ISignal<RdTypeHierarchyTreeNavigateArgs> get() = _navigate
    //methods
    //initializer
    init {
        _items.optimizeNested = true
        _isReady.optimizeNested = true
    }
    
    init {
        bindableChildren.add("items" to _items)
        bindableChildren.add("isReady" to _isReady)
        bindableChildren.add("navigate" to _navigate)
    }
    
    //secondary constructor
    constructor(
        style: TypeHierarchyViewStyle
    ) : this(
        style,
        RdMap<Int, RdTypeHierarchyTreeItem>(FrameworkMarshallers.Int, RdTypeHierarchyTreeItem),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdSignal<RdTypeHierarchyTreeNavigateArgs>(RdTypeHierarchyTreeNavigateArgs)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTypeHierarchyTreeView (")
        printer.indent {
            print("style = "); style.print(printer); println()
            print("items = "); _items.print(printer); println()
            print("isReady = "); _isReady.print(printer); println()
            print("navigate = "); _navigate.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdTypeHierarchyTreeView   {
        return RdTypeHierarchyTreeView(
            style,
            _items.deepClonePolymorphic(),
            _isReady.deepClonePolymorphic(),
            _navigate.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [TypeHierarchyModel.kt]
 */
enum class TypeHierarchyViewStyle {
    Hierarchy, 
    SubTypes, 
    SuperTypes, 
    Implementation, 
    InterfaceLeaves;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<TypeHierarchyViewStyle>()
        
    }
}
