@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [CodeInsightModels.kt]
 */
class TypingAssistModel private constructor(
    private val _emulateType: RdCall<TypeData, Boolean>,
    private val _readonlyType: RdSignal<TypeData>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(TypeData)
        }
        
        
        
        
        const val serializationHash = 5854140280099368208L
        
    }
    override val serializersOwner: ISerializersOwner get() = TypingAssistModel
    override val serializationHash: Long get() = TypingAssistModel.serializationHash
    
    //fields
    val emulateType: RdCall<TypeData, Boolean> get() = _emulateType
    val readonlyType: ISignal<TypeData> get() = _readonlyType
    //methods
    //initializer
    init {
        bindableChildren.add("emulateType" to _emulateType)
        bindableChildren.add("readonlyType" to _readonlyType)
    }
    
    //secondary constructor
    internal constructor(
    ) : this(
        RdCall<TypeData, Boolean>(TypeData, FrameworkMarshallers.Bool),
        RdSignal<TypeData>(TypeData)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TypingAssistModel (")
        printer.indent {
            print("emulateType = "); _emulateType.print(printer); println()
            print("readonlyType = "); _readonlyType.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): TypingAssistModel   {
        return TypingAssistModel(
            _emulateType.deepClonePolymorphic(),
            _readonlyType.deepClonePolymorphic()
        )
    }
    //contexts
}
val Solution.typingAssistModel get() = getOrCreateExtension("typingAssistModel", ::TypingAssistModel)



/**
 * #### Generated from [CodeInsightModels.kt]
 */
data class TypeData (
    val typedChar: Char,
    val isCompletionTerminator: Boolean,
    val timestamp: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<TypeData> {
        override val _type: KClass<TypeData> = TypeData::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TypeData  {
            val typedChar = buffer.readChar()
            val isCompletionTerminator = buffer.readBool()
            val timestamp = buffer.readInt()
            return TypeData(typedChar, isCompletionTerminator, timestamp)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TypeData)  {
            buffer.writeChar(value.typedChar)
            buffer.writeBool(value.isCompletionTerminator)
            buffer.writeInt(value.timestamp)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TypeData
        
        if (typedChar != other.typedChar) return false
        if (isCompletionTerminator != other.isCompletionTerminator) return false
        if (timestamp != other.timestamp) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + typedChar.hashCode()
        __r = __r*31 + isCompletionTerminator.hashCode()
        __r = __r*31 + timestamp.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TypeData (")
        printer.indent {
            print("typedChar = "); typedChar.print(printer); println()
            print("isCompletionTerminator = "); isCompletionTerminator.print(printer); println()
            print("timestamp = "); timestamp.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
