@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.ide.model.uicontext

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [UiContextModel.kt]
 */
class UiContextModel private constructor(
    private val _caret: RdOptionalProperty<Int>,
    private val _selection: RdOptionalProperty<Int>,
    private val _focus: RdOptionalProperty<Int>,
    private val _textControl: RdOptionalProperty<Int>,
    private val _document: RdOptionalProperty<Int>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(ContextKey.marshaller)
            serializers.register(ContextPair)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): UiContextModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return UiContextModel().apply {
                identify(protocol.identity, RdId.Null.mix("UiContextModel"))
                bind(lifetime, protocol, "UiContextModel")
            }
        }
        
        
        const val serializationHash = -8227276819003039081L
        
    }
    override val serializersOwner: ISerializersOwner get() = UiContextModel
    override val serializationHash: Long get() = UiContextModel.serializationHash
    
    //fields
    val caret: IOptProperty<Int> get() = _caret
    val selection: IOptProperty<Int> get() = _selection
    val focus: IOptProperty<Int> get() = _focus
    val textControl: IOptProperty<Int> get() = _textControl
    val document: IOptProperty<Int> get() = _document
    //methods
    //initializer
    init {
        _caret.optimizeNested = true
        _selection.optimizeNested = true
        _focus.optimizeNested = true
        _textControl.optimizeNested = true
        _document.optimizeNested = true
    }
    
    init {
        bindableChildren.add("caret" to _caret)
        bindableChildren.add("selection" to _selection)
        bindableChildren.add("focus" to _focus)
        bindableChildren.add("textControl" to _textControl)
        bindableChildren.add("document" to _document)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("UiContextModel (")
        printer.indent {
            print("caret = "); _caret.print(printer); println()
            print("selection = "); _selection.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("textControl = "); _textControl.print(printer); println()
            print("document = "); _document.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): UiContextModel   {
        return UiContextModel(
            _caret.deepClonePolymorphic(),
            _selection.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _textControl.deepClonePolymorphic(),
            _document.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UiContextModel.kt]
 */
enum class ContextKey {
    Caret, 
    Selection, 
    Focus, 
    TextControl, 
    Document;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ContextKey>()
        
    }
}


/**
 * #### Generated from [UiContextModel.kt]
 */
data class ContextPair (
    val key: ContextKey,
    val timestamp: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ContextPair> {
        override val _type: KClass<ContextPair> = ContextPair::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ContextPair  {
            val key = buffer.readEnum<ContextKey>()
            val timestamp = buffer.readInt()
            return ContextPair(key, timestamp)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ContextPair)  {
            buffer.writeEnum(value.key)
            buffer.writeInt(value.timestamp)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ContextPair
        
        if (key != other.key) return false
        if (timestamp != other.timestamp) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + key.hashCode()
        __r = __r*31 + timestamp.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ContextPair (")
        printer.indent {
            print("key = "); key.print(printer); println()
            print("timestamp = "); timestamp.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
