@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [UserModel.kt]
 */
class UserModel private constructor(
    private val _users: RdMap<Int, RdUserModel>,
    private val _follow: RdProperty<Int?>,
    private val _followers: RdList<Int>,
    private val _jumpTo: RdSignal<Int>,
    private val _followingRequest: RdSignal<RdUserFollowingRequest>,
    private val _stopFollowingRequest: RdSignal<Int>,
    private val _followingRetarget: RdSignal<RdUserFollowingRetarget>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RdUserModel)
            serializers.register(RdUserFollowingRequest)
            serializers.register(RdUserFollowingRetarget)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): UserModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return UserModel().apply {
                identify(protocol.identity, RdId.Null.mix("UserModel"))
                bind(lifetime, protocol, "UserModel")
            }
        }
        
        private val __IntNullableSerializer = FrameworkMarshallers.Int.nullable()
        
        const val serializationHash = 750991039243450962L
        
    }
    override val serializersOwner: ISerializersOwner get() = UserModel
    override val serializationHash: Long get() = UserModel.serializationHash
    
    //fields
    
    /**
     * All users connected to the same backend at the moment
     */
    val users: IMutableViewableMap<Int, RdUserModel> get() = _users
    
    /**
     * User ID which current client follows
     */
    val follow: IProperty<Int?> get() = _follow
    
    /**
     * User IDs which follows current client
     */
    val followers: IMutableViewableList<Int> get() = _followers
    
    /**
     * Navigates current user to user with specified ID
     */
    val jumpTo: ISignal<Int> get() = _jumpTo
    
    /**
     * Requests user with specified ID to follow current user
     */
    val followingRequest: ISignal<RdUserFollowingRequest> get() = _followingRequest
    
    /**
     * Tells user with specified ID to stop following current user
     */
    val stopFollowingRequest: ISignal<Int> get() = _stopFollowingRequest
    
    /**
     * Tells following request was retargeted to other user
     */
    val followingRetarget: ISignal<RdUserFollowingRetarget> get() = _followingRetarget
    //methods
    //initializer
    init {
        _users.optimizeNested = true
        _follow.optimizeNested = true
        _followers.optimizeNested = true
    }
    
    init {
        bindableChildren.add("users" to _users)
        bindableChildren.add("follow" to _follow)
        bindableChildren.add("followers" to _followers)
        bindableChildren.add("jumpTo" to _jumpTo)
        bindableChildren.add("followingRequest" to _followingRequest)
        bindableChildren.add("stopFollowingRequest" to _stopFollowingRequest)
        bindableChildren.add("followingRetarget" to _followingRetarget)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdMap<Int, RdUserModel>(FrameworkMarshallers.Int, RdUserModel),
        RdProperty<Int?>(null, __IntNullableSerializer),
        RdList<Int>(FrameworkMarshallers.Int),
        RdSignal<Int>(FrameworkMarshallers.Int),
        RdSignal<RdUserFollowingRequest>(RdUserFollowingRequest),
        RdSignal<Int>(FrameworkMarshallers.Int),
        RdSignal<RdUserFollowingRetarget>(RdUserFollowingRetarget)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("UserModel (")
        printer.indent {
            print("users = "); _users.print(printer); println()
            print("follow = "); _follow.print(printer); println()
            print("followers = "); _followers.print(printer); println()
            print("jumpTo = "); _jumpTo.print(printer); println()
            print("followingRequest = "); _followingRequest.print(printer); println()
            print("stopFollowingRequest = "); _stopFollowingRequest.print(printer); println()
            print("followingRetarget = "); _followingRetarget.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): UserModel   {
        return UserModel(
            _users.deepClonePolymorphic(),
            _follow.deepClonePolymorphic(),
            _followers.deepClonePolymorphic(),
            _jumpTo.deepClonePolymorphic(),
            _followingRequest.deepClonePolymorphic(),
            _stopFollowingRequest.deepClonePolymorphic(),
            _followingRetarget.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UserModel.kt]
 */
data class RdUserFollowingRequest (
    val userId: Int,
    val force: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdUserFollowingRequest> {
        override val _type: KClass<RdUserFollowingRequest> = RdUserFollowingRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUserFollowingRequest  {
            val userId = buffer.readInt()
            val force = buffer.readBool()
            return RdUserFollowingRequest(userId, force)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUserFollowingRequest)  {
            buffer.writeInt(value.userId)
            buffer.writeBool(value.force)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUserFollowingRequest
        
        if (userId != other.userId) return false
        if (force != other.force) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + userId.hashCode()
        __r = __r*31 + force.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUserFollowingRequest (")
        printer.indent {
            print("userId = "); userId.print(printer); println()
            print("force = "); force.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [UserModel.kt]
 */
data class RdUserFollowingRetarget (
    val fromUser: String,
    val toUser: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdUserFollowingRetarget> {
        override val _type: KClass<RdUserFollowingRetarget> = RdUserFollowingRetarget::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUserFollowingRetarget  {
            val fromUser = buffer.readString()
            val toUser = buffer.readString()
            return RdUserFollowingRetarget(fromUser, toUser)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUserFollowingRetarget)  {
            buffer.writeString(value.fromUser)
            buffer.writeString(value.toUser)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUserFollowingRetarget
        
        if (fromUser != other.fromUser) return false
        if (toUser != other.toUser) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fromUser.hashCode()
        __r = __r*31 + toUser.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUserFollowingRetarget (")
        printer.indent {
            print("fromUser = "); fromUser.print(printer); println()
            print("toUser = "); toUser.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [UserModel.kt]
 */
data class RdUserModel (
    val id: Int,
    val clientIdValue: String,
    val name: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdUserModel> {
        override val _type: KClass<RdUserModel> = RdUserModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUserModel  {
            val id = buffer.readInt()
            val clientIdValue = buffer.readString()
            val name = buffer.readString()
            return RdUserModel(id, clientIdValue, name)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUserModel)  {
            buffer.writeInt(value.id)
            buffer.writeString(value.clientIdValue)
            buffer.writeString(value.name)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUserModel
        
        if (id != other.id) return false
        if (clientIdValue != other.clientIdValue) return false
        if (name != other.name) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + clientIdValue.hashCode()
        __r = __r*31 + name.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUserModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("clientIdValue = "); clientIdValue.print(printer); println()
            print("name = "); name.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
