@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [VcsModel.kt]
 */
class VcsModel internal constructor(
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(VcsGutterMarkHighlighterModel)
            serializers.register(VcsGutterMarkersModel)
            serializers.register(VcsSelectedLineTimestampModel)
        }
        
        
        
        
        const val serializationHash = 2400490176184490611L
        
    }
    override val serializersOwner: ISerializersOwner get() = VcsModel
    override val serializationHash: Long get() = VcsModel.serializationHash
    
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("VcsModel (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): VcsModel   {
        return VcsModel(
        )
    }
    //contexts
}
val Solution.vcsModel get() = getOrCreateExtension("vcsModel", ::VcsModel)



/**
 * #### Generated from [VcsModel.kt]
 */
class VcsGutterMarkHighlighterModel (
    val type: Byte,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<VcsGutterMarkHighlighterModel> {
        override val _type: KClass<VcsGutterMarkHighlighterModel> = VcsGutterMarkHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): VcsGutterMarkHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val type = buffer.readByte()
            return VcsGutterMarkHighlighterModel(type, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: VcsGutterMarkHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeByte(value.type)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as VcsGutterMarkHighlighterModel
        
        if (type != other.type) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + type.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("VcsGutterMarkHighlighterModel (")
        printer.indent {
            print("type = "); type.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [VcsModel.kt]
 */
class VcsGutterMarkersModel private constructor(
    private val _getOldContent: RdCall<Long, String?>,
    key: String
) : MarkupModelExtension (
    key
) {
    //companion
    
    companion object : IMarshaller<VcsGutterMarkersModel> {
        override val _type: KClass<VcsGutterMarkersModel> = VcsGutterMarkersModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): VcsGutterMarkersModel  {
            val _id = RdId.read(buffer)
            val key = buffer.readString()
            val _getOldContent = RdCall.read(ctx, buffer, FrameworkMarshallers.Long, __StringNullableSerializer)
            return VcsGutterMarkersModel(_getOldContent, key).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: VcsGutterMarkersModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.key)
            RdCall.write(ctx, buffer, value._getOldContent)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val getOldContent: RdCall<Long, String?> get() = _getOldContent
    //methods
    //initializer
    init {
        bindableChildren.add("getOldContent" to _getOldContent)
    }
    
    //secondary constructor
    constructor(
        key: String
    ) : this(
        RdCall<Long, String?>(FrameworkMarshallers.Long, __StringNullableSerializer),
        key
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("VcsGutterMarkersModel (")
        printer.indent {
            print("getOldContent = "); _getOldContent.print(printer); println()
            print("key = "); key.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): VcsGutterMarkersModel   {
        return VcsGutterMarkersModel(
            _getOldContent.deepClonePolymorphic(),
            key
        )
    }
    //contexts
}


/**
 * #### Generated from [VcsModel.kt]
 */
class VcsSelectedLineTimestampModel (
    val offset: OffsetTimestampModel
) : UpgradableActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<VcsSelectedLineTimestampModel> {
        override val _type: KClass<VcsSelectedLineTimestampModel> = VcsSelectedLineTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): VcsSelectedLineTimestampModel  {
            val offset = OffsetTimestampModel.read(ctx, buffer)
            return VcsSelectedLineTimestampModel(offset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: VcsSelectedLineTimestampModel)  {
            OffsetTimestampModel.write(ctx, buffer, value.offset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as VcsSelectedLineTimestampModel
        
        if (offset != other.offset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + offset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("VcsSelectedLineTimestampModel (")
        printer.indent {
            print("offset = "); offset.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}
