@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.codeWithMe.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [VfsModel.kt]
 */
class VfsModel private constructor(
    private val _files: RdMap<com.jetbrains.rd.ide.model.RdFileId, RdFileProperties>,
    private val _updates: RdSignal<RdFileSnapshot>,
    private val _findFile: RdCall<RdFindFileParams, RdFileSnapshot?>,
    private val _findBadFiles: RdCall<List<com.jetbrains.rd.ide.model.RdFileId>, List<com.jetbrains.rd.ide.model.RdFileId>>,
    private val _getFileIcon: RdCall<RdFileIconParams, com.jetbrains.rd.ide.model.IconModel?>,
    private val _getContent: RdCall<com.jetbrains.rd.ide.model.RdFileId, ByteArray>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RdFileProperties)
            serializers.register(RdFileIconParams)
            serializers.register(RdFindFileParams)
            serializers.register(RdFileSnapshot)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): VfsModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return VfsModel().apply {
                identify(protocol.identity, RdId.Null.mix("VfsModel"))
                bind(lifetime, protocol, "VfsModel")
            }
        }
        
        private val __RdFileSnapshotNullableSerializer = RdFileSnapshot.nullable()
        private val __RdFileIdListSerializer = AbstractPolymorphic(com.jetbrains.rd.ide.model.RdFileId).list()
        private val __IconModelNullableSerializer = AbstractPolymorphic(com.jetbrains.rd.ide.model.IconModel).nullable()
        
        const val serializationHash = -3154011026330850659L
        
    }
    override val serializersOwner: ISerializersOwner get() = VfsModel
    override val serializationHash: Long get() = VfsModel.serializationHash
    
    //fields
    val files: IMutableViewableMap<com.jetbrains.rd.ide.model.RdFileId, RdFileProperties> get() = _files
    val updates: IAsyncSignal<RdFileSnapshot> get() = _updates
    val findFile: RdCall<RdFindFileParams, RdFileSnapshot?> get() = _findFile
    val findBadFiles: RdCall<List<com.jetbrains.rd.ide.model.RdFileId>, List<com.jetbrains.rd.ide.model.RdFileId>> get() = _findBadFiles
    val getFileIcon: RdCall<RdFileIconParams, com.jetbrains.rd.ide.model.IconModel?> get() = _getFileIcon
    val getContent: RdCall<com.jetbrains.rd.ide.model.RdFileId, ByteArray> get() = _getContent
    //methods
    //initializer
    init {
        _files.optimizeNested = true
    }
    
    init {
        _files.async = true
        _updates.async = true
        _findFile.async = true
        _findBadFiles.async = true
        _getFileIcon.async = true
        _getContent.async = true
    }
    
    init {
        bindableChildren.add("files" to _files)
        bindableChildren.add("updates" to _updates)
        bindableChildren.add("findFile" to _findFile)
        bindableChildren.add("findBadFiles" to _findBadFiles)
        bindableChildren.add("getFileIcon" to _getFileIcon)
        bindableChildren.add("getContent" to _getContent)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdMap<com.jetbrains.rd.ide.model.RdFileId, RdFileProperties>(AbstractPolymorphic(com.jetbrains.rd.ide.model.RdFileId), RdFileProperties),
        RdSignal<RdFileSnapshot>(RdFileSnapshot),
        RdCall<RdFindFileParams, RdFileSnapshot?>(RdFindFileParams, __RdFileSnapshotNullableSerializer),
        RdCall<List<com.jetbrains.rd.ide.model.RdFileId>, List<com.jetbrains.rd.ide.model.RdFileId>>(__RdFileIdListSerializer, __RdFileIdListSerializer),
        RdCall<RdFileIconParams, com.jetbrains.rd.ide.model.IconModel?>(RdFileIconParams, __IconModelNullableSerializer),
        RdCall<com.jetbrains.rd.ide.model.RdFileId, ByteArray>(AbstractPolymorphic(com.jetbrains.rd.ide.model.RdFileId), FrameworkMarshallers.ByteArray)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("VfsModel (")
        printer.indent {
            print("files = "); _files.print(printer); println()
            print("updates = "); _updates.print(printer); println()
            print("findFile = "); _findFile.print(printer); println()
            print("findBadFiles = "); _findBadFiles.print(printer); println()
            print("getFileIcon = "); _getFileIcon.print(printer); println()
            print("getContent = "); _getContent.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): VfsModel   {
        return VfsModel(
            _files.deepClonePolymorphic(),
            _updates.deepClonePolymorphic(),
            _findFile.deepClonePolymorphic(),
            _findBadFiles.deepClonePolymorphic(),
            _getFileIcon.deepClonePolymorphic(),
            _getContent.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [VfsModel.kt]
 */
data class RdFileIconParams (
    val fileId: com.jetbrains.rd.ide.model.RdFileId,
    val flags: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdFileIconParams> {
        override val _type: KClass<RdFileIconParams> = RdFileIconParams::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFileIconParams  {
            val fileId = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.RdFileId>(ctx, buffer, com.jetbrains.rd.ide.model.RdFileId)
            val flags = buffer.readInt()
            return RdFileIconParams(fileId, flags)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFileIconParams)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.fileId)
            buffer.writeInt(value.flags)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFileIconParams
        
        if (fileId != other.fileId) return false
        if (flags != other.flags) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fileId.hashCode()
        __r = __r*31 + flags.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFileIconParams (")
        printer.indent {
            print("fileId = "); fileId.print(printer); println()
            print("flags = "); flags.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [VfsModel.kt]
 */
data class RdFileProperties (
    val name: String,
    val path: String,
    val timeStamp: Long,
    val modificationStamp: Long,
    val length: Long,
    val content: ByteArray?,
    val isWritable: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdFileProperties> {
        override val _type: KClass<RdFileProperties> = RdFileProperties::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFileProperties  {
            val name = buffer.readString()
            val path = buffer.readString()
            val timeStamp = buffer.readLong()
            val modificationStamp = buffer.readLong()
            val length = buffer.readLong()
            val content = buffer.readNullable { buffer.readByteArray() }
            val isWritable = buffer.readBool()
            return RdFileProperties(name, path, timeStamp, modificationStamp, length, content, isWritable)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFileProperties)  {
            buffer.writeString(value.name)
            buffer.writeString(value.path)
            buffer.writeLong(value.timeStamp)
            buffer.writeLong(value.modificationStamp)
            buffer.writeLong(value.length)
            buffer.writeNullable(value.content) { buffer.writeByteArray(it) }
            buffer.writeBool(value.isWritable)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFileProperties
        
        if (name != other.name) return false
        if (path != other.path) return false
        if (timeStamp != other.timeStamp) return false
        if (modificationStamp != other.modificationStamp) return false
        if (length != other.length) return false
        if (content != other.content) return false
        if (isWritable != other.isWritable) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + path.hashCode()
        __r = __r*31 + timeStamp.hashCode()
        __r = __r*31 + modificationStamp.hashCode()
        __r = __r*31 + length.hashCode()
        __r = __r*31 + if (content != null) content.contentHashCode() else 0
        __r = __r*31 + isWritable.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFileProperties (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("path = "); path.print(printer); println()
            print("timeStamp = "); timeStamp.print(printer); println()
            print("modificationStamp = "); modificationStamp.print(printer); println()
            print("length = "); length.print(printer); println()
            print("content = "); content.print(printer); println()
            print("isWritable = "); isWritable.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [VfsModel.kt]
 */
data class RdFileSnapshot (
    val id: com.jetbrains.rd.ide.model.RdFileId,
    val properties: RdFileProperties?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdFileSnapshot> {
        override val _type: KClass<RdFileSnapshot> = RdFileSnapshot::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFileSnapshot  {
            val id = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.RdFileId>(ctx, buffer, com.jetbrains.rd.ide.model.RdFileId)
            val properties = buffer.readNullable { RdFileProperties.read(ctx, buffer) }
            return RdFileSnapshot(id, properties)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFileSnapshot)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.id)
            buffer.writeNullable(value.properties) { RdFileProperties.write(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFileSnapshot
        
        if (id != other.id) return false
        if (properties != other.properties) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + if (properties != null) properties.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFileSnapshot (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("properties = "); properties.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [VfsModel.kt]
 */
data class RdFindFileParams (
    val id: com.jetbrains.rd.ide.model.RdFileId?,
    val path: String?,
    val sendContent: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdFindFileParams> {
        override val _type: KClass<RdFindFileParams> = RdFindFileParams::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFindFileParams  {
            val id = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.RdFileId>(ctx, buffer, com.jetbrains.rd.ide.model.RdFileId) }
            val path = buffer.readNullable { buffer.readString() }
            val sendContent = buffer.readBool()
            return RdFindFileParams(id, path, sendContent)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFindFileParams)  {
            buffer.writeNullable(value.id) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.path) { buffer.writeString(it) }
            buffer.writeBool(value.sendContent)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFindFileParams
        
        if (id != other.id) return false
        if (path != other.path) return false
        if (sendContent != other.sendContent) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (id != null) id.hashCode() else 0
        __r = __r*31 + if (path != null) path.hashCode() else 0
        __r = __r*31 + sendContent.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFindFileParams (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("path = "); path.print(printer); println()
            print("sendContent = "); sendContent.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
