//package com.jetbrains.rdserver.completion
//
//import com.intellij.codeInsight.completion.CompletionLookupArranger
//import com.intellij.codeInsight.completion.impl.CamelHumpMatcher
//import com.intellij.codeInsight.lookup.*
//import com.intellij.codeInsight.lookup.impl.LookupImpl
//import com.intellij.openapi.Disposable
//import com.intellij.openapi.editor.Editor
//import com.intellij.openapi.project.Project
//import com.intellij.openapi.rd.defineNestedLifetime
//import com.intellij.ui.Gray
//import com.jetbrains.rd.platform.util.getLogger
//import com.jetbrains.rd.util.lifetime.Lifetime
//import com.jetbrains.rd.util.lifetime.onTermination
//import com.jetbrains.rdserver.editors.textControlId
//import com.jetbrains.rdserver.richText
//import com.jetbrains.rdserver.toProtocolModel
//import com.jetbrains.rdserver.toRgbColor
//import com.jetbrains.rd.ide.model.*
//import java.beans.PropertyChangeEvent
//import java.beans.PropertyChangeListener
//import java.util.concurrent.atomic.AtomicInteger
//
///**
// * @author yole
// */
//
//
////unused
//class BackendLookupHost(lifetime: Lifetime, val project: Project, solutionModel: SolutionModel) {
//  companion object {
//    val LOG = getLogger<BackendLookupHost>()
//  }
//
//  init {
//    solutionModel.solutions.view(lifetime) { solLt, _, solution ->
//      LookupManager.getInstance(project).addPropertyChangeListener(PropertyChangeListener {
//        if (it.propertyName == LookupManager.PROP_ACTIVE_LOOKUP) {
//          val lookup = it.newValue as LookupImpl? ?: return@PropertyChangeListener
//          val editor = lookup.editor
//          showCustomLookup(it, solution, editor)
//        }
//      }, project)
//    }
//  }
//
//  private fun showCustomLookup(
//    event: PropertyChangeEvent,
//    solution: Solution,
//    editor: Editor
//  ) {
//    LOG.debug("Active lookup changed to ${event.newValue}")
//    val lookup = event.newValue as? LookupImpl ?: return
//    val textControlId = lookup.editor.textControlId() ?: run {
//      LOG.debug("Skipping lookup display because editor has no associated text control")
//      return
//    }
//    val idCounter = AtomicInteger()
//    val lastFocusedTextControl = solution.editors.lastFocusedTextControlSession.value
//    if (lastFocusedTextControl == null) {
//      LOG.debug("Skipping lookup display because it's not shown in a focused editor")
//      return
//    }
//    if (textControlId != lastFocusedTextControl.id) {
//      LOG.debug("Skipping lookup display because it's not shown in a focused editor")
//      return
//    }
//    val disposable = lookup as Disposable
//    val lifetime = defineNestedLifetime(disposable).lifetime
//
//    val customLookup = convertLookup(lastFocusedTextControl.textControl, lookup, idCounter)
//    customLookup.selectedIndex.view(lifetime) { _, index ->
//      if (lookup.selectedIndex != index) {  // avoid setting selectionTouched flag if not needed
//        lookup.selectedIndex = index
//      }
//    }
//    customLookup.lastVisibleIndex.view(lifetime) { _, index ->
//      if (lookup.lastVisibleIndex != index) {
//        //lookup.lastVisibleIndex = index
//        lookup.refreshUi(true, false)
//      }
//    }
//    customLookup.focusDegree.view(lifetime) { _, newFocusDegree ->
//      lookup.lookupFocusDegree = newFocusDegree.toFocusDegree()
//    }
//    customLookup.itemSelected.set { completeData ->
//      lookup.finishLookup(completeData?.typedChar ?: 0.toChar(), lookup.currentItem)
//      true
//    }
//
//    lifetime.onTermination {
//      lastFocusedTextControl.textControl.customLookup.set(null)
//    }
//  }
//
//  private fun convertLookup(textControl: LastFocusedTextControl, lookup: LookupImpl, idCounter: AtomicInteger): CustomLookupModel {
//    val result = CustomLookupModel()
//    addAllItems(lookup, bdkjsvresult, idCounter)
//    lookup.addLookupListener(object : LookupListener {
//      override fun uiRefreshed() {
//        result.calculating.set(lookup.isCalculating)
//        result.focusDegree.set(lookup.lookupFocusDegree.toProtocol())
//        addAllItems(lookup, result, idCounter)
//      }
//
//      override fun lookupShown(event: LookupEvent) {
//        LOG.info("Lookup shown, reporting to frontend")
//        textControl.customLookup.set(result)
//        val lifetime = defineNestedLifetime(lookup).lifetime
//        textControl.customLookup.view(lifetime) { _, newLookup ->
//          if (newLookup == null) lookup.hideLookup(true)
//        }
//      }
//    })
//
//    return result
//  }
//
//  private fun addAllItems(lookup: LookupImpl,
//                          result: CustomLookupModel,
//                          idCounter: AtomicInteger) {
//    /*
//        val arranger = lookup.arranger as? CompletionLookupArranger
//        if (arranger != null) {
//          result.items.fire(CustomLookupItemsModel(
//            lookup.items.map { it.toProtocolModel(arranger, lookup, idCounter.incrementAndGet(), 0) },
//            lookup.arranger.matchingItems.size,
//            lookup.selectedIndex
//          ))
//        }
//    */
//  }
//}
//
//private fun FocusDegreeModel.toFocusDegree(): LookupFocusDegree = when (this) {
//  FocusDegreeModel.FOCUSED -> LookupFocusDegree.FOCUSED
//  FocusDegreeModel.SEMI_FOCUSED -> LookupFocusDegree.SEMI_FOCUSED
//  FocusDegreeModel.UNFOCUSED -> LookupFocusDegree.UNFOCUSED
//}
//
//private fun LookupFocusDegree.toProtocol(): FocusDegreeModel = when (this) {
//  LookupFocusDegree.FOCUSED -> FocusDegreeModel.FOCUSED
//  LookupFocusDegree.SEMI_FOCUSED -> FocusDegreeModel.SEMI_FOCUSED
//  LookupFocusDegree.UNFOCUSED -> FocusDegreeModel.UNFOCUSED
//}
//
//fun LookupElement.toProtocolModel(arranger: CompletionLookupArranger, id: Int, priority: Long): CompletionItem {
//  val presentation = RealLookupElementPresentation()
//  renderElement(presentation)
//
//  val prefixMatcher = arranger.itemMatcher(this)
//  val prefix = (prefixMatcher as? CamelHumpMatcher)?.toString()
//
//  val isInteractive = getUserData(LookupElementInteractivity.KEY)?.isInsertHandlerInteractive(this) ?: false
//  return CompletionItem(presentation.itemText ?: lookupString,
//                        presentation.toRichText(), presentation.typeText, presentation.icon?.toProtocolModel(), id,
//                        priority, CompletionItemType.Default, listOf(), prefix, 0, !isInteractive
//  )
//}
//
//private fun LookupElementPresentation.toRichText(): RichTextModel {
//  return richText {
//    itemText?.let {
//      append(RichStringModel(
//        it, itemTextForeground.toRgbColor(), null, null,
//        when {
//          isStrikeout -> EffectStyle.StrikeOut
//          isItemTextUnderlined -> EffectStyle.StraightUnderline
//          else -> EffectStyle.None
//        },
//        if (isItemTextBold) FontStyle.Bold else if (isItemTextItalic) FontStyle.Italic else FontStyle.Regular
//      ))
//    }
//    for (tailFragment in tailFragments) {
//      append(RichStringModel(
//        tailFragment.text,
//        if (tailFragment.isGrayed) Gray._127.toRgbColor() else tailFragment.foregroundColor.toRgbColor(),
//        null,
//        null,
//        if (isStrikeout) EffectStyle.StrikeOut else EffectStyle.None,
//        if (tailFragment.isItalic) FontStyle.Italic else FontStyle.Regular
//      ))
//    }
//  }
//}
