package com.jetbrains.rdserver.connection

import com.intellij.openapi.project.Project
import com.jetbrains.codeWithMe.model.CWMSessionStatus
import com.jetbrains.rd.platform.codeWithMe.connection.CwmConnectionStatusService
import com.jetbrains.rd.platform.util.lifetime
import com.jetbrains.rd.util.reactive.map
import com.jetbrains.rdserver.ui.HostNotifications
import java.util.concurrent.TimeUnit

class BackendRemainingTimeListener (val project: Project) {
  init {
    val statusService = CwmConnectionStatusService.getInstance(project)
    statusService.sessionStatus.view(project.lifetime) { lt, status ->
      if (status == CWMSessionStatus.FREE_SESSION) {
        statusService.freeSessionRemainingTimeMs.map {
          it?.let {
            TimeUnit.MILLISECONDS.toMinutes(it) <= statusService.freeSessionMinutesBeforeWarning
          } ?: false
        }.advise(lt) {
          if (it)
          HostNotifications.showNMinutesLeftNotifications(project)
        }
      }
    }
  }
}