package com.jetbrains.rdserver.daemon.folding

import com.intellij.openapi.editor.FoldRegion
import com.intellij.openapi.editor.ex.RangeMarkerEx
import com.jetbrains.rd.ide.model.FoldingHighlighterModel
import com.jetbrains.rd.ide.model.HighlighterModel
import com.jetbrains.rd.ide.model.RdDocumentVersion
import com.jetbrains.rdserver.daemon.BackendHighlighterRegistrationsHost
import com.jetbrains.rdserver.daemon.BackendRangeMarkerModelCreator

class BackendFoldingModelCreator : BackendRangeMarkerModelCreator {
  override fun accept(rangeMarker: RangeMarkerEx): Boolean {
    return rangeMarker is FoldRegion
  }

  override fun createModel(rangeMarker: RangeMarkerEx, documentVersion: RdDocumentVersion): HighlighterModel? {
    val region = rangeMarker as FoldRegion
    return FoldingHighlighterModel(
      region.placeholderText,
      !region.isExpanded,
      region.group?.id,
      0,
      true,
      documentVersion,
      false,
      false,
      false,
      null,
      (region as? RangeMarkerEx)?.id ?: -1,
      BackendHighlighterRegistrationsHost.FOLD_REGION_ID,
      region.startOffset,
      region.endOffset
    )
  }
}