package com.jetbrains.rdserver.daemon.highlighters.breakpoints

import com.intellij.openapi.editor.colors.EditorColorsManager
import com.intellij.openapi.editor.ex.RangeHighlighterEx
import com.intellij.xdebugger.ui.DebuggerColors
import com.intellij.xdebugger.ui.DebuggerColors.BREAKPOINT_HIGHLIGHTER_KEY
import com.jetbrains.rdserver.daemon.BackendHighlighterModelCreator
import com.jetbrains.rd.ide.model.HighlighterModel
import com.jetbrains.rd.ide.model.RdDocumentVersion

class BreakpointProtocolHighlighterModelCreator : BackendHighlighterModelCreator {
  override fun accept(highlighter: RangeHighlighterEx): Boolean {
    val attributesKey = DebuggerColors.BREAKPOINT_ATTRIBUTES
    val breakpointAttributes = EditorColorsManager.getInstance().globalScheme.getAttributes(attributesKey)
    return highlighter.textAttributesKey == attributesKey ||
           highlighter.textAttributes == breakpointAttributes ||
           highlighter.getUserData(BREAKPOINT_HIGHLIGHTER_KEY) == true ||
           highlighter.gutterIconRenderer?.javaClass?.name?.contains("BreakpointGutterIconRenderer") == true
  }

  override fun createModel(highlighter: RangeHighlighterEx, documentVersion: RdDocumentVersion): HighlighterModel? {
    return null
  }
}