package com.jetbrains.rdserver.daemon.highlighters.custom

import com.intellij.codeInsight.daemon.impl.HighlightInfo
import com.intellij.openapi.editor.ex.RangeHighlighterEx
import com.intellij.openapi.editor.markup.HighlighterTargetArea
import com.jetbrains.rd.ide.model.CustomStyleHighlighterModel
import com.jetbrains.rd.ide.model.HighlighterModel
import com.jetbrains.rd.ide.model.RdDocumentVersion
import com.jetbrains.rdserver.daemon.BackendHighlighterModelCreator
import com.jetbrains.rdserver.daemon.BackendHighlighterRegistrationsHost

class CustomStyleProtocolHighlighterModelCreator : BackendHighlighterModelCreator {
  override fun accept(highlighter: RangeHighlighterEx): Boolean {
    return highlighter.let {
      HighlightInfo.fromRangeHighlighter(it) == null &&
      it.textAttributesKey == null &&
      it.getTextAttributes(null) != null
    }
  }

  override fun createModel(highlighter: RangeHighlighterEx, documentVersion: RdDocumentVersion): HighlighterModel? {
    val textAttributes = highlighter.getTextAttributes(null) ?: return null
    val attributes =
      BackendHighlighterRegistrationsHost.convertAttributes(textAttributes)
    return CustomStyleHighlighterModel(
      attributes,
      attributes,
      highlighter.layer,
      highlighter.targetArea == HighlighterTargetArea.EXACT_RANGE,
      documentVersion,
      highlighter.isGreedyToLeft,
      highlighter.isGreedyToRight,
      highlighter.isThinErrorStripeMark,
      null,
      highlighter.id,
      BackendHighlighterRegistrationsHost.CUSTOM_HIGHLIGHTING_ID,
      highlighter.startOffset, highlighter.endOffset
    )
  }
}