package com.jetbrains.rdserver.daemon.highlighters.custom

import com.intellij.codeInsight.daemon.impl.tagTreeHighlighting.XmlTagTreeHighlightingPass
import com.intellij.openapi.editor.ex.RangeHighlighterEx
import com.jetbrains.rdserver.daemon.BackendHighlighterModelCreator
import com.jetbrains.rd.ide.model.HighlighterModel
import com.jetbrains.rd.ide.model.RdDocumentVersion

/**
 * These features operate with hard-coded colors and can't be transferred to guests (which probably use different schemes)
 */
class HardCodedColorsHighlighterModelDisabler : BackendHighlighterModelCreator {
  override fun accept(highlighter: RangeHighlighterEx): Boolean {
    return highlighter.textAttributesKey == XmlTagTreeHighlightingPass.TAG_TREE_HIGHLIGHTING_KEY
  }

  override fun createModel(highlighter: RangeHighlighterEx, documentVersion: RdDocumentVersion): HighlighterModel? {
    return null
  }
}