package com.jetbrains.rdserver.daemon.highlighters.custom

import com.intellij.openapi.editor.ex.RangeHighlighterEx
import com.jetbrains.codeWithMe.model.RemoteCaretHighlighterModel
import com.jetbrains.rd.ide.model.HighlighterModel
import com.jetbrains.rd.ide.model.RdDocumentVersion
import com.jetbrains.rd.platform.codeWithMe.carets.RemoteCaretHighlighterRenderer
import com.jetbrains.rdserver.daemon.BackendHighlighterModelCreator
import com.jetbrains.rdserver.daemon.BackendHighlighterRegistrationsHost

class RemoteCaretProtocolHighlighterModelCreator : BackendHighlighterModelCreator {
  override fun accept(highlighter: RangeHighlighterEx): Boolean {
    return highlighter.customRenderer is RemoteCaretHighlighterRenderer
  }

  override fun createModel(highlighter: RangeHighlighterEx, documentVersion: RdDocumentVersion): HighlighterModel? {
    return highlighter.run {
      RemoteCaretHighlighterModel(
        (customRenderer as RemoteCaretHighlighterRenderer).remoteCaretData,
        layer,
        true,
        documentVersion,
        isGreedyToLeft,
        isGreedyToRight,
        isThinErrorStripeMark,
        null,
        id,
        BackendHighlighterRegistrationsHost.CUSTOM_HIGHLIGHTING_ID,
        startOffset,
        endOffset
      )
    }
  }
}