package com.jetbrains.rdserver.daemon.highlighters.liveTemplates

import com.intellij.codeInsight.template.impl.TemplateState
import com.intellij.openapi.editor.ex.RangeHighlighterEx
import com.intellij.openapi.editor.markup.HighlighterTargetArea
import com.jetbrains.rd.ide.model.HighlighterModel
import com.jetbrains.rd.ide.model.LiveTemplateHighlighterModel
import com.jetbrains.rd.ide.model.RdDocumentVersion
import com.jetbrains.rdserver.daemon.BackendHighlighterModelCreator
import com.jetbrains.rdserver.daemon.BackendHighlighterRegistrationsHost

class LiveTemplateProtocolHighlighterModelCreator : BackendHighlighterModelCreator {
  override fun accept(highlighter: RangeHighlighterEx): Boolean {
    return highlighter.getUserData(TemplateState.TEMPLATE_RANGE_HIGHLIGHTER_KEY) == true
  }

  override fun createModel(highlighter: RangeHighlighterEx, documentVersion: RdDocumentVersion): HighlighterModel? {
    val key = highlighter.textAttributesKey ?: return null
    val attributeId = BackendHighlighterRegistrationsHost.getAttributeId(key) ?: return null
    return with(highlighter) {
      LiveTemplateHighlighterModel(
        layer,
        targetArea == HighlighterTargetArea.EXACT_RANGE,
        documentVersion,
        isGreedyToLeft,
        isGreedyToRight,
        isThinErrorStripeMark,
        null,
        id,
        attributeId,
        startOffset,
        endOffset
      )
    }
  }
}