package com.jetbrains.rdserver.debugger

import com.intellij.openapi.project.Project
import com.intellij.ui.ColoredTextContainer
import com.intellij.ui.SimpleTextAttributes
import com.jetbrains.codeWithMe.model.ColoredTextContainerModel
import com.jetbrains.rdserver.RichTextBuilder
import com.jetbrains.rdserver.toProtocolModel
import javax.swing.Icon

class CodeWithMeColoredTextContainer : ColoredTextContainer {
  private val builder = RichTextBuilder()
  private var tooltipText: String? = null
  private var icon: Icon? = null

  override fun append(fragment: String, attributes: SimpleTextAttributes, tag: Any?) {
    append(fragment, attributes)
  }

  override fun append(fragment: String, attributes: SimpleTextAttributes) {
    builder.append(fragment, attributes)
  }

  override fun setIcon(icon: Icon?) {
    this.icon = icon
  }

  override fun setToolTipText(text: String?) {
    tooltipText = text
  }

  fun createModel(project: Project) = ColoredTextContainerModel(builder.build(), tooltipText, icon?.toProtocolModel())
}