package com.jetbrains.rdserver.debugger

import com.intellij.codeInsight.intention.IntentionAction
import com.jetbrains.rdserver.ui.intentions.BackendIntentionActionFilter
import com.jetbrains.rdserver.ui.intentions.getPersistentStringId

class DebuggerIntentionActionFilter : BackendIntentionActionFilter {
  companion object {
    private val gutterIntentionsToIgnore = setOf(
      "Remove breakpoint",
      "Disable breakpoint",
      "Edit breakpoint"
    )
  }

  override fun acceptGutterAction(it: IntentionAction): Boolean {
    return getPersistentStringId(it) !in gutterIntentionsToIgnore
  }
}