package com.jetbrains.rdserver.debugger

import com.intellij.codeWithMe.ClientId
import com.intellij.openapi.project.Project
import com.intellij.xdebugger.frame.XSuspendContext
import com.jetbrains.codeWithMe.model.CodeWithMeSuspendContextModel
import com.jetbrains.codeWithMe.model.ExecutionStackModelBase
import com.jetbrains.rd.framework.impl.RdTask

fun XSuspendContext.createSuspendContextModel(project: Project, clientId: ClientId) = CodeWithMeSuspendContextModel(
  activeExecutionStack?.createExecutionStackModel(project, clientId)
).apply {
  computeStacks.set { lifetime, _ ->
    RdTask<List<ExecutionStackModelBase>>().apply {
      computeExecutionStacks(
        CodeWithMeStackContainer(clientId, lifetime, project, this)
      )
    }
  }
}