package com.jetbrains.rdserver.diagnostics

import com.intellij.diagnostic.DebugLogManager

class BackendTraceCategoriesCustomizer {
  companion object {
    val traceCategories = listOf(
      DebugLogManager.Category("#com.jetbrains.rdserver.requests", DebugLogManager.DebugLogLevel.TRACE),
      DebugLogManager.Category("#com.jetbrains.rd.ide.document", DebugLogManager.DebugLogLevel.TRACE),
      DebugLogManager.Category("#com.jetbrains.rdserver.document", DebugLogManager.DebugLogLevel.TRACE),
      DebugLogManager.Category("#com.jetbrains.rdserver.editors", DebugLogManager.DebugLogLevel.TRACE),
      DebugLogManager.Category("#com.jetbrains.rdserver.actions", DebugLogManager.DebugLogLevel.TRACE)
    )
  }

  init {
    val debugLogManager = DebugLogManager.getInstance()

    val categories = mutableListOf<DebugLogManager.Category>()
    val savedCategories = debugLogManager.getSavedCategories()
    val traceCategoriesSet = traceCategories.toSet()
    categories.addAll(savedCategories.filter { !traceCategoriesSet.contains(it) })
    categories.addAll(traceCategories)
    debugLogManager.applyCategories(categories)
    debugLogManager.saveCategories(categories)
  }
}