package com.jetbrains.rdserver.distributedTests

import com.intellij.codeWithMe.ClientId.Companion.isLocal
import com.intellij.ide.IdeEventQueue
import com.intellij.openapi.project.Project
import com.jetbrains.rd.platform.codeWithMe.tests.DistributedTestBridge
import com.jetbrains.rdserver.RdServerPerClientComponents
import com.jetbrains.rdserver.followMe.FollowMeManager
import org.jetbrains.annotations.ApiStatus

@ApiStatus.Internal
class BackendDistributedTestBridge(private val project: Project) : DistributedTestBridge {

  override fun syncProtocolEvents() {
    for (clientId in FollowMeManager.getInstance(project).users.keys) {
      if (clientId.isLocal) continue
      val host = RdServerPerClientComponents.getService(project, clientId, BackendDistributedTestHost::class.java)
      host.syncProtocolEvents()
    }
  }

}