package com.jetbrains.rdserver.distributedTests

import com.jetbrains.codeWithMe.model.tests.DistributedTestBridgeModel
import com.jetbrains.rd.framework.IProtocol
import com.jetbrains.rd.framework.impl.RpcTimeouts
import com.jetbrains.rd.platform.codeWithMe.tests.isDistributedTestMode
import com.jetbrains.rd.util.lifetime.Lifetime

@Suppress("NonDefaultConstructor")
class BackendDistributedTestHost(
  lifetime: Lifetime,
  protocol: IProtocol
) {

  private val model by lazy {
    DistributedTestBridgeModel.create(lifetime, protocol)
  }

  init {
    if (isDistributedTestMode) {
      model.syncCall.set { _ -> return@set }
    }
  }

  fun syncProtocolEvents() {
    model.syncCall.sync(Unit, RpcTimeouts.infinite)
  }
}