package com.jetbrains.rdserver.editors

import com.intellij.openapi.editor.Editor
import com.intellij.openapi.editor.EditorActivityManager
import com.intellij.openapi.fileEditor.FileEditor
import com.intellij.openapi.fileEditor.TextEditor

internal class BackendEditorActivityManager : EditorActivityManager() {
  override fun isVisible(editor: Editor): Boolean {
    return super.isVisible(editor) || editor.getUserData(RemoteEditors.REMOTELY_VISIBLE) == true
  }

  override fun isFocused(editor: Editor): Boolean {
    return super.isFocused(editor) || editor.getUserData(RemoteEditors.REMOTELY_VISIBLE) == true
  }

  override fun isVisible(fileEditor: FileEditor): Boolean {
    return super.isVisible(fileEditor) || (fileEditor as? TextEditor)?.editor?.let { isVisible(it) } ?: false
  }

  override fun isFocused(fileEditor: FileEditor): Boolean {
    return super.isFocused(fileEditor) || (fileEditor as? TextEditor)?.editor?.let { isFocused(it) } ?: false
  }
}