package com.jetbrains.rdserver.editors

import com.intellij.openapi.extensions.ExtensionPointName
import com.intellij.openapi.fileEditor.FileEditor
import com.intellij.openapi.fileEditor.FileEditorNavigatable
import com.intellij.openapi.fileEditor.FileEditorProvider
import com.intellij.openapi.project.Project
import com.intellij.openapi.vfs.VirtualFile

interface BackendFileEditorHandler {
  companion object {
    val EP_NAME = ExtensionPointName.create<BackendFileEditorHandler>("com.intellij.cwm.backendFileEditorHandler")
  }

  fun isAvailable(project: Project, file: VirtualFile, provider: FileEditorProvider): Boolean

  fun createEditor(project: Project, file: VirtualFile, provider: FileEditorProvider): FileEditor? {
    return provider.createEditor(project, file)
  }

  fun createFollowNavigatable(project: Project, editor: FileEditor): FileEditorNavigatable? = null
}