package com.jetbrains.rdserver.editors

import com.intellij.codeWithMe.ClientId
import com.intellij.openapi.fileEditor.FileEditorProvider
import com.intellij.openapi.fileEditor.impl.FileEditorProviderSuppressor
import com.intellij.openapi.project.Project
import com.intellij.openapi.vfs.VirtualFile

class BackendFileEditorProviderSuppressor : FileEditorProviderSuppressor {

  override fun isSuppressed(project: Project, file: VirtualFile, provider: FileEditorProvider): Boolean {
    return !ClientId.isCurrentlyUnderLocalId &&
           !BackendFileEditorHandler.EP_NAME.extensionList.any { it.isAvailable(project, file, provider) }
  }

}