package com.jetbrains.rdserver.editors

import com.intellij.codeInsight.editorActions.SelectWordHandler
import com.intellij.codeWithMe.ClientId
import com.intellij.openapi.actionSystem.DataContext
import com.intellij.openapi.editor.Caret
import com.intellij.openapi.editor.Editor
import com.intellij.openapi.editor.EditorSettings
import com.intellij.openapi.editor.actionSystem.EditorActionHandler

//unused. Decided to intentionally ignore isMouseClickSelectionHonorsCamelWords setting in 203
class BackendSelectWordAtCaretHandler(originalHandler: EditorActionHandler) : SelectWordHandler(originalHandler) {
  override fun doExecute(editor: Editor, caret: Caret, dataContext: DataContext?) {
    if (ClientId.isCurrentlyUnderLocalId) {
      super.doExecute(editor, caret, dataContext)
      return
    }

    val settings: EditorSettings = editor.settings
    val camelTemp = settings.isCamelWords
    val needOverrideSetting = camelTemp && !settings.isMouseClickSelectionHonorsCamelWords
    try {
      if (needOverrideSetting) {
        settings.isCamelWords = false
      }

      super.doExecute(editor, caret, dataContext)
    }

    finally {
      if (needOverrideSetting) {
        settings.resetCamelWords()
      }
    }
  }
}