package com.jetbrains.rdserver.editors

import com.intellij.codeInsight.daemon.impl.VisibleHighlightingPassFactory.HEADLESS_VISIBLE_AREA
import com.intellij.openapi.Disposable
import com.intellij.openapi.editor.Editor
import com.intellij.openapi.rd.defineNestedLifetime
import com.intellij.openapi.util.ProperTextRange
import com.jetbrains.rd.platform.util.userData
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rd.util.reactive.OptProperty

var Editor.remoteEditorData: RemoteEditorData? by userData { editor ->
  val data = RemoteEditorData()
  val lifetime = (editor.caretModel as? Disposable)?.defineNestedLifetime() ?: Lifetime.Eternal
  // for IJ daemon
  data.visibleRange.advise(lifetime) {
    editor.putUserData(HEADLESS_VISIBLE_AREA, it)
  }
  data
}

class RemoteEditorData {
  val visibleRange: OptProperty<ProperTextRange> = OptProperty()
}