package com.jetbrains.rdserver.editors

import com.intellij.openapi.actionSystem.CommonDataKeys
import com.intellij.openapi.editor.Caret
import com.intellij.openapi.editor.Editor
import com.intellij.openapi.fileEditor.EditorDataProvider
import com.intellij.openapi.fileEditor.impl.PsiAwareFileEditorManagerImpl

// workaround for the next strange pattern into platform:
//  CommonDataKeys.PROJECT.getData(DataManager.getInstance().getDataContext(editor.getComponent()))
class RemoteEditorDataProvider(private val owner: PsiAwareFileEditorManagerImpl) : EditorDataProvider {
  override fun getData(dataId: String, e: Editor, caret: Caret): Any? {
    if (e.isLocal()) return null

    return when {
      CommonDataKeys.PROJECT.`is`(dataId) -> owner.project
      else -> null
    }
  }
}