package com.jetbrains.rdserver.followMe

import com.intellij.icons.AllIcons
import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.project.DumbAware
import com.intellij.openapi.project.Project
import com.jetbrains.codeWithMe.model.GuestTerminationReason
import com.jetbrains.codeWithMe.model.RdUserModel
import com.jetbrains.rd.platform.codeWithMe.connection.GuestTerminationReasonsData
import com.jetbrains.rd.platform.codeWithMe.users.clientId
import com.jetbrains.rdserver.CodeWithMePluginBundle
import com.jetbrains.rdserver.permissions.ui.PermissionsDialog
import com.jetbrains.rdserver.startup.RdServerConnectionManager
import java.util.function.Supplier

fun createKickAction(project: Project, user: RdUserModel): AnAction {
  return object : AnAction(Supplier { CodeWithMePluginBundle.message("action.user.kick") }, AllIcons.CodeWithMe.CwmKick), DumbAware {
    override fun actionPerformed(e: AnActionEvent) {
      RdServerConnectionManager.getInstance(project)
        .disconnectClient(user.clientId, GuestTerminationReasonsData(GuestTerminationReason.KICKED_BY_HOST, "Kicked by host"))
    }
  }
}

fun createPermissionsAction(project: Project, user: RdUserModel): AnAction {
  return object : AnAction(Supplier { CodeWithMePluginBundle.message("action.user.permissions") }, AllIcons.CodeWithMe.CwmPermissions), DumbAware {
    override fun actionPerformed(e: AnActionEvent) {
      PermissionsDialog(project, user.clientId, false).show()
    }
  }
}