package com.jetbrains.rdserver.internal

import com.intellij.openapi.actionSystem.AnActionEvent
import com.jetbrains.rd.platform.internal.DumpAction
import com.jetbrains.rdserver.diagnostics.RemoteEditorsTroubleInfoCollector

class DumpEditorsAction : DumpAction("DumpRemoteEditors") {
  override fun actionPerformed(e: AnActionEvent) {
    val project = e.project ?: return

    val info = RemoteEditorsTroubleInfoCollector.collect(project)

    dumpToFile(project, "DumpEditors") { outputStreamWriter ->
      outputStreamWriter.write(info)
    }
  }
}