package com.jetbrains.rdserver.joinLinks

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.ide.CopyPasteManager
import com.intellij.openapi.project.DumbAware
import com.intellij.util.ui.TextTransferable
import com.jetbrains.rd.platform.codeWithMe.users.UserNotifications
import com.jetbrains.rdserver.CodeWithMePluginBundle

class CopyJoinLinkAction : AnAction(), DumbAware {

  override fun update(e: AnActionEvent) {
    val project = e.project
    e.presentation.isEnabledAndVisible = project != null &&
                                         RdServerJoinLinkManager.getInstance(project).getExistingJoinLink() != null
  }

  override fun actionPerformed(e: AnActionEvent) {
    val project = e.project ?: return
    val link = RdServerJoinLinkManager.getInstance(project).getExistingJoinLink()
    CopyPasteManager.getInstance().setContents(TextTransferable(link?.toString()))

    UserNotifications.showGreenNotification(
      project,
      CodeWithMePluginBundle.message("notification.join.link.copied"))
  }
}