package com.jetbrains.rdserver.joinLinks

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.project.DumbAware
import com.jetbrains.codeWithMe.model.GuestTerminationReason
import com.jetbrains.rd.platform.codeWithMe.connection.GuestTerminationReasonsData
import com.jetbrains.rd.platform.codeWithMe.users.UserManager
import com.jetbrains.rdserver.CodeWithMePluginBundle
import com.jetbrains.rdserver.startup.RdServerConnectionManager

class ShutdownCodeWithMeAction : AnAction(), DumbAware {

  override fun update(e: AnActionEvent) {
    val project = e.project ?: return
    val userManager = UserManager.getInstance(project)
    e.presentation.isEnabledAndVisible = RdServerJoinLinkManager.getInstance(project).getExistingJoinLink() != null || userManager.users.isNotEmpty()
  }

  override fun actionPerformed(e: AnActionEvent) {
    val project = e.project ?: return
    RdServerConnectionManager.getInstance(project).terminateAllTemporaryListeners(GuestTerminationReasonsData(
      GuestTerminationReason.SHUTDOWN, CodeWithMePluginBundle.message("message.session.ended.title")))
  }
}