package com.jetbrains.rdserver.joinLinks.permanent

import com.intellij.openapi.actionSystem.AnAction
import com.intellij.openapi.actionSystem.AnActionEvent
import com.intellij.openapi.project.DumbAware
import com.jetbrains.rd.platform.util.application

class DisablePermanentLinkAction : AnAction(), DumbAware {
  override fun update(e: AnActionEvent) {
    val project = e.project
    if (project == null || !application.isInternal) {
      e.presentation.isEnabledAndVisible = false
      return
    }

    e.presentation.isEnabledAndVisible = CwmPermanentLinkSettings.getInstance(project).state.enabled
  }

  override fun actionPerformed(e: AnActionEvent) {
    CwmPermanentLinkManager.getInstance(e.project ?: return).disablePermanentLink()
  }
}