@file:Suppress("NonDefaultConstructor")

package com.jetbrains.rdserver.navigation

import com.intellij.codeInsight.hint.TooltipLinkHandlerEP
import com.intellij.openapi.project.Project
import com.jetbrains.rd.ide.model.Solution
import com.jetbrains.rd.ide.model.navigationModel
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rdserver.editors.BackendEditorHost

class BackendTooltipLinkHost(
  project: Project,
  lifetime: Lifetime,
  solution: Solution
) {
  init {
    val navigationModel = solution.navigationModel
    navigationModel.tooltipLinkClicked.advise(lifetime) {
      val editorHost = BackendEditorHost.getInstance(project)
      val editor = editorHost.tryGetOwnRemoteEditor(it.editorId) ?: return@advise
      TooltipLinkHandlerEP.handleLink(it.refPrefix + it.refSuffix, editor)
    }
  }
}