package com.jetbrains.rdserver.permissions.impl

import com.intellij.codeWithMe.ClientId
import com.intellij.openapi.project.Project
import com.intellij.openapi.vfs.VirtualFile
import com.intellij.openapi.vfs.WritingAccessProvider
import com.jetbrains.rdserver.permissions.PermissionManager

class BackendWriteAccessProvider(val project: Project) : WritingAccessProvider() {

  override fun requestWriting(files: Collection<VirtualFile>): Collection<VirtualFile> {
    if (!ClientId.isCurrentlyUnderLocalId && !PermissionManager.getInstance(project).hasFileWriteAccess(ClientId.current)) {
      return files
    }
    return arrayListOf()
  }

  override fun isPotentiallyWritable(file: VirtualFile): Boolean {
    return ClientId.isCurrentlyUnderLocalId
           || PermissionManager.getInstance(project).hasFileWriteAccess(ClientId.current)
           && PermissionManager.getInstance(project).isWritable(ClientId.current, file)
  }
}
