package com.jetbrains.rdserver.permissions.ui

import com.jetbrains.rdserver.CodeWithMePluginBundle
import com.jetbrains.rdserver.permissions.FileAccessLevel
import com.jetbrains.rdserver.permissions.RunAccessLevel
import com.jetbrains.rdserver.permissions.TerminalAccessLevel
import com.jetbrains.rdserver.permissions.ToolWindowAccessLevel
import org.jetbrains.annotations.Nls

@Nls
fun FileAccessLevel.present() : String {
  return when (this) {
    FileAccessLevel.Readonly -> CodeWithMePluginBundle.message("permission.file.access.level.readonly")
    FileAccessLevel.FullAccess -> CodeWithMePluginBundle.message("permission.file.access.level.fullaccess")
  }
}

@Nls
fun TerminalAccessLevel.present() : String {
  return when (this) {
    TerminalAccessLevel.Disabled -> CodeWithMePluginBundle.message("permission.terminal.access.level.disabled")
    TerminalAccessLevel.Readonly -> CodeWithMePluginBundle.message("permission.terminal.access.level.readonly")
    TerminalAccessLevel.Request -> CodeWithMePluginBundle.message("permission.terminal.access.level.request")
    TerminalAccessLevel.FullAccess -> CodeWithMePluginBundle.message("permission.terminal.access.level.fullaccess")
  }
}

@Nls
fun RunAccessLevel.present() : String {
  return when (this) {
    RunAccessLevel.Disabled -> CodeWithMePluginBundle.message("permission.run.access.level.disabled")
    RunAccessLevel.Readonly -> CodeWithMePluginBundle.message("permission.run.access.level.readonly")
    RunAccessLevel.FullAccess -> CodeWithMePluginBundle.message("permission.run.access.level.fullaccess")
  }
}

@Nls
fun ToolWindowAccessLevel.present() : String {
  return when (this) {
    ToolWindowAccessLevel.Disabled -> CodeWithMePluginBundle.message("permission.toolWindow.access.level.disabled")
    ToolWindowAccessLevel.Readonly -> CodeWithMePluginBundle.message("permission.toolWindow.access.level.readonly")
    ToolWindowAccessLevel.FullAccess -> CodeWithMePluginBundle.message("permission.toolWindow.access.level.fullaccess")
  }
}
