package com.jetbrains.rdserver.projectView

import com.intellij.ide.projectView.impl.AbstractProjectViewPane
import com.intellij.ide.util.treeView.AbstractTreeNode
import com.intellij.openapi.extensions.ExtensionPointName
import com.intellij.openapi.vfs.VirtualFile
import com.intellij.ui.tree.AsyncTreeModel
import com.intellij.ui.tree.TreeVisitor
import com.jetbrains.rd.util.lifetime.Lifetime
import org.jetbrains.annotations.ApiStatus

@ApiStatus.Experimental
interface BackendProjectPaneProvider {

  companion object {
    val EP_NAME = ExtensionPointName.create<BackendProjectPaneProvider>("com.intellij.backendProjectPaneProvider")
  }

  fun isAvailable(): Boolean
  fun getProjectViewPane(): AbstractProjectViewPane
  fun createAsyncTreeModel(lifetime: Lifetime): AsyncTreeModel
  fun createSelectVisitor(file: VirtualFile): TreeVisitor?

  fun getVirtualFile(node: AbstractTreeNode<*>): VirtualFile? = null
  fun shouldSyncExternalNode(modelNode: AbstractTreeNode<*>): Boolean = false
}