package com.jetbrains.rdserver.projectView

import com.intellij.openapi.editor.Document
import com.intellij.openapi.fileEditor.FileDocumentManager
import com.intellij.openapi.project.Project
import com.jetbrains.rd.ide.model.DocumentExtension
import com.jetbrains.rd.platform.codeWithMe.editors.DocumentPropertiesExtensions
import com.jetbrains.rdserver.document.BackendDocumentExtensionsProvider

class BackendProjectPropertiesProvider(val project: Project) : BackendDocumentExtensionsProvider {
  override fun getExtensions(document: Document): List<DocumentExtension> {
    val file = FileDocumentManager.getInstance().getFile(document) ?: return emptyList()
    val projectProperties = DocumentPropertiesExtensions.create()
    projectProperties.scope.set(ProjectScopeUtils.getScope(project, file))
    return listOf(projectProperties)
  }
}