package com.jetbrains.rdserver.projectView

import com.intellij.openapi.project.Project
import com.intellij.openapi.vfs.VirtualFile
import com.intellij.psi.search.scope.packageSet.NamedScopesHolder
import com.intellij.psi.search.scope.packageSet.PackageSetBase
import com.intellij.ui.FileColorManager
import com.intellij.ui.tabs.FileColorManagerImpl
import com.jetbrains.codeWithMe.model.RdProjectScope

object ProjectScopeUtils {
  fun getScope(project: Project, file: VirtualFile?): RdProjectScope? {
    file ?: return null
    for (holder in NamedScopesHolder.getAllNamedScopeHolders(project)) {
      for (scope in holder.scopes) {
        val packageSet = scope.value as? PackageSetBase
        if (packageSet != null && packageSet.contains(file, project, holder)) {
          val color = FileColorManager.getInstance(project).getScopeColor(scope.scopeId) ?: continue
          val colorName = FileColorManagerImpl.getColorID(color)
          return RdProjectScope(scope.scopeId, colorName, color.rgb)
        }
      }
    }

    return null
  }
}