// Copyright 2000-2018 JetBrains s.r.o. Use of this source code is governed by the Apache 2.0 license that can be found in the LICENSE file.
package com.jetbrains.rdserver.startup

import com.intellij.ide.CommandLineProcessor
import com.intellij.idea.SocketLock
import com.intellij.openapi.application.ApplicationStarter

class RdAppStarter : ApplicationStarter {
  override fun getCommandName() = "rdserver"
  override fun isHeadless() = false
  override fun getRequiredModality() = ApplicationStarter.NOT_IN_EDT

  override fun main(args: List<String>) {
    val currentDirectory = System.getenv(SocketLock.LAUNCHER_INITIAL_DIRECTORY_ENV_VAR)
    CommandLineProcessor.processExternalCommandLine(args.drop(1), currentDirectory)
  }
}