package com.jetbrains.rdserver.startup

import com.intellij.codeWithMe.ClientId
import com.jetbrains.rd.platform.codeWithMe.protocol.IPasswordAuthHandler
import com.jetbrains.rdserver.unattendedHost.UnattendedHostManager

class RdServerPasswordAuthHandler(val request: UnattendedHostManager.PasswordRequest) : IPasswordAuthHandler {
  private var clientId: ClientId? = null

  override fun getPasswordRequestBytes(): ByteArray {
    return request.baseSalt + request.tokenSalt
  }

  override fun checkPasswordFromClient(password: ByteArray): Boolean {
    return request.checkResponse(password).also {
      if(it && clientId != null)
        UnattendedHostManager.getInstance().setClientJoinedViaPassword(clientId!!)
    }
  }

  fun setClientId(clientId: ClientId) {
    this.clientId = clientId
  }
}