package com.jetbrains.rdserver.telephony

import com.intellij.openapi.project.Project
import com.jetbrains.codeWithMe.model.TelephonyModel
import com.jetbrains.rd.framework.Protocol
import com.jetbrains.rd.util.lifetime.Lifetime

@Suppress("NonDefaultConstructor")
class BackendTelephonyModelHost(
  lifetime: Lifetime,
  project: Project,
  protocol: Protocol
) {
  private val telephonyModel = TelephonyModel.create(lifetime, protocol)

  init {
    val telephonyManager = BackendTelephonyManager.getInstance(project)
    telephonyManager.isTelephonyEnabled.advise(lifetime) {
      telephonyModel.telephonyEnabled.set(it)
    }
  }
}
