package com.jetbrains.rdserver.telephony

import com.intellij.openapi.project.Project
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rdserver.joinLinks.RdServerJoinLinkLifecycleListener
import java.net.URI

class BackendTelephonyRdServerLinkListener(private val project: Project): RdServerJoinLinkLifecycleListener {
  override fun joinLinkCreated(lifetime: Lifetime, joinLink: URI) {
    val backendTelephonyManager = BackendTelephonyManager.getInstance(project)
    backendTelephonyManager.isTelephonyEnabled.view(lifetime) { lt, enabled ->
      if (enabled) {
        backendTelephonyManager.createSession(lt)
      }
    }
  }
}