package com.jetbrains.rdserver.ui.converters

import com.intellij.util.ui.AnimatedIcon
import com.jetbrains.ide.model.uiautomation.*
import com.jetbrains.rd.util.lifetime.Lifetime

/**
 * @author Alex Plate
 */
class AnimatedIconConverter : RdConverter<AnimatedIcon> {
  override fun convert(component: AnimatedIcon, trackOptions: TrackOptions, lifetime: Lifetime): BeControl {
    val beIcon = BeAnimatedIcon(component.toolTipText ?: component.name ?: "", PredefinedType.PROCESS_ICON)
    if (trackOptions.modelChangeTrack) {
    /*  beIcon.visible.advise(lifetime) { value ->
        trackOptions.beforeModelChange?.invoke()
        val componentToChange = trackOptions.modelChangeComponentProvider?.invoke() as? InplaceButton ?: component
        componentToChange.isEnabled = value
        trackOptions.afterModelChange?.invoke()
      }*/
    }
    if (trackOptions.componentChangeTrack) {
      component.addPropertyChangeListener {
        trackOptions.beforeComponentChange?.invoke()
        beIcon.enabled.set(component.isEnabled)
        trackOptions.afterComponentChange?.invoke()
      }
    }

    return beIcon
  }
}