package com.jetbrains.rdserver.ui.converters

import com.jetbrains.ide.model.uiautomation.BeControl
import com.jetbrains.ide.model.uiautomation.BeRichText
import com.jetbrains.rd.platform.util.getLogger
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rdserver.toRichText
import java.awt.Component

/**
 * @author Alex Plate
 *
 * Stub for unknown components
 */
class ComponentConverter : RdConverter<Component> {
  override fun convert(component: Component, trackOptions: TrackOptions, lifetime: Lifetime): BeControl {
    LOG.info("Converting unknown control: $component")
    return BeRichText(false).also {
      val javaClass = component.javaClass
      val className = if (javaClass.isAnonymousClass) javaClass.superclass.simpleName else javaClass.simpleName
      it.text.set("Unknown control: $className".toRichText())
    }
  }

  companion object {
    private val LOG = getLogger<ComponentConverter>()
  }
}
