package com.jetbrains.rdserver.ui.converters

import com.intellij.execution.impl.ConsoleViewImpl
import com.jetbrains.ide.model.uiautomation.BeControl
import com.jetbrains.rd.util.lifetime.Lifetime
import java.awt.BorderLayout
import javax.swing.JComponent

class ConsoleViewImplConverter : RdConverter<ConsoleViewImpl> {
  override fun convert(component: ConsoleViewImpl, trackOptions: TrackOptions, lifetime: Lifetime): BeControl {
    val editorComponent = component.editor.component

    val sides = mutableMapOf<String, JComponent>()

    val layout = component.layout
    if (layout is BorderLayout) {
      for (side in BORDER_LAYOUT_SIDES) {
        sides[side] = layout.getLayoutComponent(side) as? JComponent ?: continue
      }
    }

    sides[BorderLayout.CENTER] = editorComponent // override JBLoadingPanel with custom layout

    return BeJPanel(trackOptions, lifetime).borderLayoutToGrid(sides)
  }
}