package com.jetbrains.rdserver.ui.converters

import com.jetbrains.ide.model.uiautomation.BeControl
import com.jetbrains.ide.model.uiautomation.BeHtmlViewer
import com.jetbrains.rd.util.lifetime.Lifetime
import javax.swing.JEditorPane
import javax.swing.text.html.HTMLEditorKit

/**
 * @author Alex Plate
 */
class EditorPaneConverter : RdConverter<JEditorPane> {
  override fun convert(component: JEditorPane, trackOptions: TrackOptions, lifetime: Lifetime): BeControl {
    return BeHtmlViewer(false).apply {
      text.value = component.text
      val styles = (component.editorKit as? HTMLEditorKit)?.getStyleSheet() ?: return@apply

      val rules = styles.styleNames
      val cssRules = mutableListOf<String>()
      while (rules.hasMoreElements()) {
        val name = rules.nextElement() as String
        val rule = styles.getStyle(name)
        cssRules.add(rule.toString())
      }
      this.cssRules.set(cssRules)
    }
  }
}