package com.jetbrains.rdserver.ui.converters

import com.intellij.ui.MultilineTreeCellRenderer
import com.jetbrains.ide.model.uiautomation.BeControl
import com.jetbrains.ide.model.uiautomation.BeRichText
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rdserver.toProtocolModel
import com.jetbrains.rdserver.toRichText

class MultilineTreeCellRendererConverter : RdConverter<MultilineTreeCellRenderer> {
  override fun convert(component: MultilineTreeCellRenderer, trackOptions: TrackOptions, lifetime: Lifetime): BeControl =
    BeRichText(false).also { control ->
      val text = component.prefix?.let { "$it " }.orEmpty() + component.lines.joinToString("\n")
      control.text.set(text.toRichText())
      control.icon.set(component.icon?.toProtocolModel())
    }
}