package com.jetbrains.rdserver.ui.converters

import com.intellij.ui.SimpleColoredComponent
import com.jetbrains.ide.model.uiautomation.BeControl
import com.jetbrains.ide.model.uiautomation.BeRichText
import com.jetbrains.rd.util.lifetime.Lifetime
import com.jetbrains.rdserver.toProtocolModel
import com.jetbrains.rdserver.toRichText

/**
 * @author Alex Plate
 */
class SimpleColoredComponentConverter : RdConverter<SimpleColoredComponent> {
  override fun convert(component: SimpleColoredComponent, trackOptions: TrackOptions, lifetime: Lifetime): BeControl =
    BeRichText(false).also {
      it.text.set(component.toRichText())
      it.icon.set(component.icon?.toProtocolModel())
    }
}