package com.jetbrains.rdserver.ui.intentions

import com.intellij.codeInsight.intention.EmptyIntentionAction
import com.intellij.codeInsight.intention.IntentionAction

class IntentionActionWithModalDialogFilter : BackendIntentionActionFilter {
  private fun acceptIntentionWithoutModalDialog(it: IntentionAction): Boolean {
    // filter out all intentions that don't start in write lock and might show dialogs
    return it.startInWriteAction() ||
           it is EmptyIntentionAction ||
           IntentionActionFeelLuckyUiMarker.maySkipModalDialog(it)
  }

  override fun acceptIntention(it: IntentionAction): Boolean = acceptIntentionWithoutModalDialog(it)

  override fun acceptErrorFix(it: IntentionAction): Boolean = acceptIntentionWithoutModalDialog(it)

  override fun acceptInspection(it: IntentionAction): Boolean = acceptIntentionWithoutModalDialog(it)
}