package ui.popup;


import com.intellij.openapi.diagnostic.Logger;
import com.intellij.openapi.ui.popup.JBPopup;
import com.intellij.openapi.ui.popup.PopupChooserBuilder;
import org.jetbrains.annotations.NotNull;

import javax.swing.*;

public class BackendPopupChooserBuilder<T> extends PopupChooserBuilder<T> {
  private static final Logger LOG = Logger.getInstance(BackendPopupChooserBuilder.class);
  private static boolean chooserBuilderCreatesPopup;
  public static boolean chooserBuilderCreatesPopup() {
    return chooserBuilderCreatesPopup;
  }

  public BackendPopupChooserBuilder(@NotNull JList list) {
    super(list);
  }

  public BackendPopupChooserBuilder(@NotNull JTable table) {
    super(table);
  }

  @SuppressWarnings("AssignmentToStaticFieldFromInstanceMethod")
  @Override
  public @NotNull JBPopup createPopup() {
    try {
      LOG.assertTrue(!chooserBuilderCreatesPopup);

      chooserBuilderCreatesPopup = true;
      return super.createPopup();
    } finally {
      chooserBuilderCreatesPopup = false;
    }
  }
}
