package com.jetbrains.rdserver.ui.popup

import com.intellij.openapi.diagnostic.logger
import com.intellij.openapi.ui.popup.Balloon
import com.intellij.openapi.ui.popup.JBPopupListener
import com.intellij.ui.awt.RelativePoint
import com.intellij.util.ui.PositionTracker
import com.jetbrains.ide.model.uiautomation.UIAutomationInteractionModel
import com.jetbrains.rd.framework.IProtocol
import com.jetbrains.rd.util.lifetime.LifetimeDefinition
import com.jetbrains.rd.util.lifetime.isNotAlive
import java.awt.Dimension
import java.awt.Rectangle
import javax.swing.JComponent
import javax.swing.JLayeredPane

class RdBalloon(protocol: IProtocol,
                val content: JComponent,
                val title: String?,
                private val uiInteractionModel: UIAutomationInteractionModel) : Balloon {
  companion object {
    private val logger = logger<RdBalloonBuilder>()
  }

  private val lifetimeDefinition = LifetimeDefinition()

  override fun show(tracker: PositionTracker<Balloon>, preferredPosition: Balloon.Position?) {
    // todo rewrite, should send kind of context and lay out on client side
    //val component = tracker.component as? JComponent ?: return
    //val dataContext = DataManagerImpl.MyDataContext(component)
    //
    //val editor = dataContext.getData(LangDataKeys.EDITOR) ?: return
    //val visualPosition = dataContext.getUserData(PopupFactoryImpl.ANCHOR_POPUP_POSITION) ?: run {
    //  val caretModel = editor.caretModel
    //  if (caretModel.isUpToDate) caretModel.visualPosition else editor.offsetToVisualPosition(caretModel.offset)
    //}
    //
    //val logicalPosition = editor.visualToLogicalPosition(visualPosition)
    //val offset = editor.logicalPositionToOffset(logicalPosition)
    //val range = RdTextRange(offset, offset)
    //
    //val textControlId = editor.textControlId() ?: return
    //val balloon = BePopup(content.toBeModel(), range, textControlId)
    //uiInteractionModel.currentPopup.set(balloon)
  }

  override fun show(target: RelativePoint?, preferredPosition: Balloon.Position?) {
    //TODO("not implemented")
  }

  override fun show(pane: JLayeredPane?) {
    //TODO("not implemented")
  }

  override fun showInCenterOf(component: JComponent?) {
    //TODO("not implemented")
  }

  override fun getPreferredSize(): Dimension {
    TODO("not implemented")
  }

  override fun setBounds(bounds: Rectangle?) {
    //TODO("not implemented")
  }

  override fun addListener(listener: JBPopupListener) {
    //TODO("not implemented")
  }

  override fun hide() {
    hide(false)
  }

  override fun hide(ok: Boolean) {
    //TODO("not implemented")
  }

  override fun setAnimationEnabled(enabled: Boolean) {
    //TODO("not implemented")
  }

  override fun wasFadedIn(): Boolean {
    TODO("not implemented")
  }

  override fun wasFadedOut(): Boolean {
    TODO("not implemented")
  }

  override fun isDisposed(): Boolean {
    return lifetimeDefinition.isNotAlive
  }

  override fun setTitle(title: String?) {
    //TODO("not implemented")
  }

  override fun revalidate() {
    //TODO("not implemented")
  }

  override fun revalidate(tracker: PositionTracker<Balloon>) {
    //TODO("not implemented")
  }

  override fun dispose() {
    lifetimeDefinition.terminate()
  }
}