package com.jetbrains.rdserver.ui.popup

import com.intellij.openapi.Disposable
import com.intellij.openapi.diagnostic.logger
import com.intellij.openapi.ui.popup.Balloon
import com.intellij.openapi.ui.popup.BalloonBuilder
import com.jetbrains.ide.model.uiautomation.UIAutomationInteractionModel
import com.jetbrains.rd.framework.IProtocol
import java.awt.Color
import java.awt.Insets
import java.awt.event.ActionListener
import javax.swing.JComponent

class RdBalloonBuilder(val protocol: IProtocol,
                       val content: JComponent,
                       val title: String?,
                       val uiInteractionModel: UIAutomationInteractionModel) : BalloonBuilder {
  companion object {
    private val logger = logger<RdBalloonBuilder>()
  }

  override fun setBorderInsets(insets: Insets?): BalloonBuilder {

    return this
  }

  override fun setFillColor(color: Color): BalloonBuilder {

    return this
  }

  override fun setHideOnClickOutside(hide: Boolean): BalloonBuilder {

    return this
  }

  override fun setHideOnKeyOutside(hide: Boolean): BalloonBuilder {

    return this
  }

  override fun setShowCallout(show: Boolean): BalloonBuilder {

    return this
  }

  override fun setCloseButtonEnabled(enabled: Boolean): BalloonBuilder {

    return this
  }

  override fun setFadeoutTime(fadeoutTime: Long): BalloonBuilder {
    return this
  }

  override fun setAnimationCycle(time: Int): BalloonBuilder {

    return this
  }

  override fun setHideOnFrameResize(hide: Boolean): BalloonBuilder {

    return this
  }

  override fun setHideOnLinkClick(hide: Boolean): BalloonBuilder {

    return this
  }

  override fun setClickHandler(listener: ActionListener?, closeOnClick: Boolean): BalloonBuilder {
    logger.error("todo: it's not implemented")
    return this
  }

  override fun setCalloutShift(length: Int): BalloonBuilder {

    return this
  }

  override fun setPositionChangeXShift(positionChangeXShift: Int): BalloonBuilder {

    return this
  }

  override fun setPositionChangeYShift(positionChangeYShift: Int): BalloonBuilder {

    return this
  }

  override fun setHideOnAction(hideOnAction: Boolean): BalloonBuilder {

    return this
  }

  override fun setDialogMode(dialogMode: Boolean): BalloonBuilder {

    return this
  }

  override fun setTitle(title: String?): BalloonBuilder {

    return this
  }

  override fun setContentInsets(insets: Insets?): BalloonBuilder {

    return this
  }

  override fun setShadow(shadow: Boolean): BalloonBuilder {

    return this
  }

  override fun setSmallVariant(smallVariant: Boolean): BalloonBuilder = this

  override fun setLayer(layer: Balloon.Layer?): BalloonBuilder {

    return this
  }

  override fun setBlockClicksThroughBalloon(block: Boolean): BalloonBuilder {

    return this
  }

  override fun setRequestFocus(requestFocus: Boolean): BalloonBuilder {

    return this
  }

  override fun setHideOnCloseClick(hideOnCloseClick: Boolean): BalloonBuilder {

    return this
  }

  override fun setDisposable(anchor: Disposable): BalloonBuilder {

    return this
  }

  override fun createBalloon(): Balloon = RdBalloon(protocol, content, title, uiInteractionModel)

  override fun setBorderColor(color: Color): BalloonBuilder = this
}