@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.rd.ide.model

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [SolutionModel.kt]
 */
class SolutionModel private constructor(
    private val _solutions: RdMap<Int, Solution>,
    private val _hasBackedSolution: RdOptionalProperty<Boolean>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(RdAbstractDocumentId)
            serializers.register(RdFileDocumentIdImpl)
            serializers.register(RdDocumentIdWithFileId)
            serializers.register(RdFileIdOld)
            serializers.register(RdFileIdNew)
            serializers.register(RdFileIdInMem)
            serializers.register(DocOffsetAndVirtualModel)
            serializers.register(SelectionVersion)
            serializers.register(SelectionRangeWithVersion)
            serializers.register(SelectionRange)
            serializers.register(VisibleRange)
            serializers.register(RdTextChunk)
            serializers.register(RdTextRange)
            serializers.register(RdSimpleTextAttributes)
            serializers.register(RdColoredFragment)
            serializers.register(ScrollKind.marshaller)
            serializers.register(ScrollingInfo)
            serializers.register(OriginKind.marshaller)
            serializers.register(TextControlLocation.marshaller)
            serializers.register(CrumbActionEvent)
            serializers.register(CrumbAction)
            serializers.register(CrumbModel)
            serializers.register(CrumbSession)
            serializers.register(NotificationPanelModel)
            serializers.register(NotificationPanelOpenSettingsHyperlinkModel)
            serializers.register(NotificationPanelCallbackHyperlinkModel)
            serializers.register(TextControlModel)
            serializers.register(TextControlId)
            serializers.register(TextControlSnapshot)
            serializers.register(FrontendTextControl)
            serializers.register(BackendDaemonStateEnum.marshaller)
            serializers.register(BackendHighlightingProgressStateEnum.marshaller)
            serializers.register(HighlightingSettingsState.marshaller)
            serializers.register(HighlightingSettingsModel)
            serializers.register(RdDaemonModel)
            serializers.register(DocumentVersion)
            serializers.register(NotCalculatedTooltipModel)
            serializers.register(StringTooltipModel)
            serializers.register(HtmlStringTooltipModel)
            serializers.register(RichTooltipModel)
            serializers.register(TooltipProviderModel)
            serializers.register(DefaultHighlighterModel)
            serializers.register(OccurrenceHighlighterModel)
            serializers.register(LiveTemplateHighlighterModel)
            serializers.register(HighlightInfoModel)
            serializers.register(HighlightInfoTypeModel)
            serializers.register(RdGutterExecutionRequest)
            serializers.register(GutterMarkActionModel)
            serializers.register(GutterMarkHighlighterModel)
            serializers.register(IndentGuideHighlighterModel)
            serializers.register(InvisibleBraceHintProviderModel)
            serializers.register(InvisibleBraceHintModel)
            serializers.register(TodoHighlighterModel)
            serializers.register(CustomStyleHighlighterModel)
            serializers.register(FoldingHighlighterModel)
            serializers.register(LineMarkerPosition.marshaller)
            serializers.register(MouseButtonKind.marshaller)
            serializers.register(MatchedBraceLineMarkerModel)
            serializers.register(LineMarkerHighlighterModel)
            serializers.register(LineMarkerActionEvent)
            serializers.register(LineMarkerActionModel)
            serializers.register(InjectionMarkHighlighterModel)
            serializers.register(InlayHighlighterModel)
            serializers.register(MethodSeparatorPlacement.marshaller)
            serializers.register(MethodSeparatorHighlighterModel)
            serializers.register(HighlighterList)
            serializers.register(HighlighterIdList)
            serializers.register(MarkupDumpInfo)
            serializers.register(RdEmptyMarkupModel)
            serializers.register(RdMarkupModel)
            serializers.register(MarkupDiagnostics)
            serializers.register(RdDocumentModel)
            serializers.register(RdCommandProcessor)
            serializers.register(TypedKey)
            serializers.register(TypedAction)
            serializers.register(DocumentsOperationModel)
            serializers.register(RdPatch)
            serializers.register(RdAsyncDocumentModel)
            serializers.register(RdDocumentVersion)
            serializers.register(RdEditorVersion)
            serializers.register(RdSuccessResponse)
            serializers.register(RdRetryResponse)
            serializers.register(RdFailureResponse)
            serializers.register(RdPatchResponse)
            serializers.register(RdApplyPathRequest)
            serializers.register(RdTypeKeyRequest)
            serializers.register(RdCallEditorActionRequest)
            serializers.register(RdCompleteItemRequest)
            serializers.register(RdUndoGroup)
            serializers.register(RdTextModificationKind.marshaller)
            serializers.register(RdDocumentChange)
            serializers.register(RdAddHistoryItemToTop)
            serializers.register(RdRemoveHistoryItem)
            serializers.register(RdMoveHistoryItemToTop)
            serializers.register(RdCollectClipboardHistory)
            serializers.register(RdSelection)
            serializers.register(RdCaretId)
            serializers.register(RdCaret)
            serializers.register(RdCaretState)
            serializers.register(RdCaretStateChange)
            serializers.register(RdCaretStateSnapshot)
            serializers.register(RdScrollingRequest)
            serializers.register(RdLookupShowStep)
            serializers.register(RdActionGroupStep)
            serializers.register(RdLiveTemplateExpansion)
            serializers.register(PopupActionModel)
            serializers.register(ActionPopupSession)
            serializers.register(RdFileToOpen)
            serializers.register(RdPostProcessParameters)
            serializers.register(RdExistingSolution)
            serializers.register(RdVirtualSolution)
            serializers.register(RdTemporarySolution)
            serializers.register(RdCodeWithMeProject)
            serializers.register(RdCLionSolution)
            serializers.register(RdOpenSolution)
            serializers.register(RdOpenSolutionAndPostprocess)
            serializers.register(RdOpenSolutionAndCollectProjectModelChanges)
            serializers.register(RdConfigurationAndPlatform)
            serializers.register(RdSolutionProperties)
            serializers.register(NavigationByPath)
            serializers.register(NavigationByFileId)
            serializers.register(SolutionLifecycle)
            serializers.register(RdCustomData)
            serializers.register(WriteLockInfo)
            serializers.register(ReadonlyModeReasons.marshaller)
            serializers.register(Solution)
            serializers.register(CommandDescriptor)
            serializers.register(TypingSessionState)
            serializers.register(LastDocumentVersion)
            serializers.register(LoadResult)
            serializers.register(DaemonModel)
            serializers.register(RdDocumentId_Unknown)
            serializers.register(RdFileDocumentId_Unknown)
            serializers.register(RdFileId_Unknown)
            serializers.register(RdAbstractEditorVersion_Unknown)
            serializers.register(SelectionRangeWithVersionIntermediate_Unknown)
            serializers.register(TreeNodeDescriptor_Unknown)
            serializers.register(NotificationPanelHyperlinkModel_Unknown)
            serializers.register(AbstractDocumentVersion_Unknown)
            serializers.register(LightweightHighlighter_Unknown)
            serializers.register(HighlighterModel_Unknown)
            serializers.register(MarkupModelExtension_Unknown)
            serializers.register(TooltipModel_Unknown)
            serializers.register(RdMarkupModelBase_Unknown)
            serializers.register(AbstractSandboxInfo_Unknown)
            serializers.register(DocumentExtension_Unknown)
            serializers.register(Operation_Unknown)
            serializers.register(RdRequest_Unknown)
            serializers.register(RdResponse_Unknown)
            serializers.register(RdPatchStep_Unknown)
            serializers.register(RdClipboardChange_Unknown)
            serializers.register(RdEditorChange_Unknown)
            serializers.register(RdSelectionChangeBase_Unknown)
            serializers.register(RdTransparentEditorChange_Unknown)
            serializers.register(RdEditorFeatureStep_Unknown)
            serializers.register(RdSolutionDescription_Unknown)
            serializers.register(RdSolutionOpenStrategy_Unknown)
            serializers.register(Navigation_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): SolutionModel  {
            IdeRoot.register(protocol.serializers)
            
            return SolutionModel().apply {
                identify(protocol.identity, RdId.Null.mix("SolutionModel"))
                bind(lifetime, protocol, "SolutionModel")
            }
        }
        
        
        const val serializationHash = 7870205357897606171L
        
    }
    override val serializersOwner: ISerializersOwner get() = SolutionModel
    override val serializationHash: Long get() = SolutionModel.serializationHash
    
    //fields
    val solutions: IMutableViewableMap<Int, Solution> get() = _solutions
    val hasBackedSolution: IOptProperty<Boolean> get() = _hasBackedSolution
    //methods
    //initializer
    init {
        _hasBackedSolution.optimizeNested = true
    }
    
    init {
        bindableChildren.add("solutions" to _solutions)
        bindableChildren.add("hasBackedSolution" to _hasBackedSolution)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdMap<Int, Solution>(FrameworkMarshallers.Int, Solution),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SolutionModel (")
        printer.indent {
            print("solutions = "); _solutions.print(printer); println()
            print("hasBackedSolution = "); _hasBackedSolution.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): SolutionModel   {
        return SolutionModel(
            _solutions.deepClonePolymorphic(),
            _hasBackedSolution.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class AbstractDocumentVersion (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<AbstractDocumentVersion> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): AbstractDocumentVersion  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return AbstractDocumentVersion_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class AbstractDocumentVersion_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : AbstractDocumentVersion (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<AbstractDocumentVersion_Unknown> {
        override val _type: KClass<AbstractDocumentVersion_Unknown> = AbstractDocumentVersion_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): AbstractDocumentVersion_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: AbstractDocumentVersion_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as AbstractDocumentVersion_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("AbstractDocumentVersion_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * For documents which do not correspond to a physical file on disk, specifies context for providing code insight features while editing the document
 * #### Generated from [SolutionModel.kt]
 */
abstract class AbstractSandboxInfo (
    val disableTypingActions: Boolean,
    val disableTypingAssists: List<Char>
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<AbstractSandboxInfo> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): AbstractSandboxInfo  {
            val objectStartPosition = buffer.position
            val disableTypingActions = buffer.readBool()
            val disableTypingAssists = buffer.readList { buffer.readChar() }
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return AbstractSandboxInfo_Unknown(disableTypingActions, disableTypingAssists, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class AbstractSandboxInfo_Unknown (
    disableTypingActions: Boolean,
    disableTypingAssists: List<Char>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : AbstractSandboxInfo (
    disableTypingActions,
    disableTypingAssists
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<AbstractSandboxInfo_Unknown> {
        override val _type: KClass<AbstractSandboxInfo_Unknown> = AbstractSandboxInfo_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): AbstractSandboxInfo_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: AbstractSandboxInfo_Unknown)  {
            buffer.writeBool(value.disableTypingActions)
            buffer.writeList(value.disableTypingAssists) { v -> buffer.writeChar(v) }
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as AbstractSandboxInfo_Unknown
        
        if (disableTypingActions != other.disableTypingActions) return false
        if (disableTypingAssists != other.disableTypingAssists) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + disableTypingActions.hashCode()
        __r = __r*31 + disableTypingAssists.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("AbstractSandboxInfo_Unknown (")
        printer.indent {
            print("disableTypingActions = "); disableTypingActions.print(printer); println()
            print("disableTypingAssists = "); disableTypingAssists.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * The currently displayed question action (e.g. auto-import popup
 * #### Generated from [SolutionModel.kt]
 */
class ActionPopupSession private constructor(
    private val _popupAction: RdProperty<PopupActionModel?>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<ActionPopupSession> {
        override val _type: KClass<ActionPopupSession> = ActionPopupSession::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ActionPopupSession  {
            val _id = RdId.read(buffer)
            val _popupAction = RdProperty.read(ctx, buffer, __PopupActionModelNullableSerializer)
            return ActionPopupSession(_popupAction).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ActionPopupSession)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._popupAction)
        }
        
        private val __PopupActionModelNullableSerializer = PopupActionModel.nullable()
        
    }
    //fields
    val popupAction: IProperty<PopupActionModel?> get() = _popupAction
    //methods
    //initializer
    init {
        bindableChildren.add("popupAction" to _popupAction)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdProperty<PopupActionModel?>(null, __PopupActionModelNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ActionPopupSession (")
        printer.indent {
            print("popupAction = "); _popupAction.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ActionPopupSession   {
        return ActionPopupSession(
            _popupAction.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * @property HIDDEN Means the daemon indicator is hidden and daemon doesn't work for the file; mostly useful for things like decompiled code
 * #### Generated from [SolutionModel.kt]
 */
enum class BackendDaemonStateEnum {
    
    /**
     * Means the daemon indicator is hidden and daemon doesn't work for the file; mostly useful for things like decompiled code
     */
    HIDDEN, 
    UNSUPPORTED, 
    DISABLED, 
    SUSPENDED, 
    INVALIDATED, 
    IN_PROGRESS_LOCAL, 
    IN_PROGRESS_GLOBAL, 
    UP_TO_DATE;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BackendDaemonStateEnum>()
        
    }
}


/**
 * #### Generated from [SolutionModel.kt]
 */
enum class BackendHighlightingProgressStateEnum {
    OFF, 
    LOCAL_STAGES, 
    GLOBAL_STAGES;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BackendHighlightingProgressStateEnum>()
        
    }
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class CommandDescriptor (
    val name: String,
    val isNavigation: Boolean,
    val isTypingPostProcessor: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CommandDescriptor> {
        override val _type: KClass<CommandDescriptor> = CommandDescriptor::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CommandDescriptor  {
            val name = buffer.readString()
            val isNavigation = buffer.readBool()
            val isTypingPostProcessor = buffer.readBool()
            return CommandDescriptor(name, isNavigation, isTypingPostProcessor)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CommandDescriptor)  {
            buffer.writeString(value.name)
            buffer.writeBool(value.isNavigation)
            buffer.writeBool(value.isTypingPostProcessor)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CommandDescriptor
        
        if (name != other.name) return false
        if (isNavigation != other.isNavigation) return false
        if (isTypingPostProcessor != other.isTypingPostProcessor) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + name.hashCode()
        __r = __r*31 + isNavigation.hashCode()
        __r = __r*31 + isTypingPostProcessor.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CommandDescriptor (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("isNavigation = "); isNavigation.print(printer); println()
            print("isTypingPostProcessor = "); isTypingPostProcessor.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class CrumbAction private constructor(
    val name: String,
    val frontendActionId: String?,
    private val _actionExecute: RdCall<CrumbActionEvent, Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CrumbAction> {
        override val _type: KClass<CrumbAction> = CrumbAction::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CrumbAction  {
            val _id = RdId.read(buffer)
            val name = buffer.readString()
            val frontendActionId = buffer.readNullable { buffer.readString() }
            val _actionExecute = RdCall.read(ctx, buffer, CrumbActionEvent, FrameworkMarshallers.Void)
            return CrumbAction(name, frontendActionId, _actionExecute).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CrumbAction)  {
            value.rdid.write(buffer)
            buffer.writeString(value.name)
            buffer.writeNullable(value.frontendActionId) { buffer.writeString(it) }
            RdCall.write(ctx, buffer, value._actionExecute)
        }
        
        
    }
    //fields
    val actionExecute: RdCall<CrumbActionEvent, Unit> get() = _actionExecute
    //methods
    //initializer
    init {
        bindableChildren.add("actionExecute" to _actionExecute)
    }
    
    //secondary constructor
    constructor(
        name: String,
        frontendActionId: String?
    ) : this(
        name,
        frontendActionId,
        RdCall<CrumbActionEvent, Unit>(CrumbActionEvent, FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CrumbAction (")
        printer.indent {
            print("name = "); name.print(printer); println()
            print("frontendActionId = "); frontendActionId.print(printer); println()
            print("actionExecute = "); _actionExecute.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CrumbAction   {
        return CrumbAction(
            name,
            frontendActionId,
            _actionExecute.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class CrumbActionEvent (
    val id: Int,
    val command: String,
    val timestamp: Long,
    val modifiers: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<CrumbActionEvent> {
        override val _type: KClass<CrumbActionEvent> = CrumbActionEvent::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CrumbActionEvent  {
            val id = buffer.readInt()
            val command = buffer.readString()
            val timestamp = buffer.readLong()
            val modifiers = buffer.readInt()
            return CrumbActionEvent(id, command, timestamp, modifiers)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CrumbActionEvent)  {
            buffer.writeInt(value.id)
            buffer.writeString(value.command)
            buffer.writeLong(value.timestamp)
            buffer.writeInt(value.modifiers)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CrumbActionEvent
        
        if (id != other.id) return false
        if (command != other.command) return false
        if (timestamp != other.timestamp) return false
        if (modifiers != other.modifiers) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + command.hashCode()
        __r = __r*31 + timestamp.hashCode()
        __r = __r*31 + modifiers.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CrumbActionEvent (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("command = "); command.print(printer); println()
            print("timestamp = "); timestamp.print(printer); println()
            print("modifiers = "); modifiers.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class CrumbModel private constructor(
    val text: String,
    val tooltip: String,
    val icon: IconModel?,
    val textRange: RdTextRange?,
    private val _navigate: RdCall<Boolean, Unit>,
    val actions: List<CrumbAction>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CrumbModel> {
        override val _type: KClass<CrumbModel> = CrumbModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CrumbModel  {
            val _id = RdId.read(buffer)
            val text = buffer.readString()
            val tooltip = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val textRange = buffer.readNullable { RdTextRange.read(ctx, buffer) }
            val _navigate = RdCall.read(ctx, buffer, FrameworkMarshallers.Bool, FrameworkMarshallers.Void)
            val actions = buffer.readList { CrumbAction.read(ctx, buffer) }
            return CrumbModel(text, tooltip, icon, textRange, _navigate, actions).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CrumbModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.text)
            buffer.writeString(value.tooltip)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeNullable(value.textRange) { RdTextRange.write(ctx, buffer, it) }
            RdCall.write(ctx, buffer, value._navigate)
            buffer.writeList(value.actions) { v -> CrumbAction.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    val navigate: RdCall<Boolean, Unit> get() = _navigate
    //methods
    //initializer
    init {
        bindableChildren.add("navigate" to _navigate)
        bindableChildren.add("actions" to actions)
    }
    
    //secondary constructor
    constructor(
        text: String,
        tooltip: String,
        icon: IconModel?,
        textRange: RdTextRange?,
        actions: List<CrumbAction>
    ) : this(
        text,
        tooltip,
        icon,
        textRange,
        RdCall<Boolean, Unit>(FrameworkMarshallers.Bool, FrameworkMarshallers.Void),
        actions
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CrumbModel (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("tooltip = "); tooltip.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("textRange = "); textRange.print(printer); println()
            print("navigate = "); _navigate.print(printer); println()
            print("actions = "); actions.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CrumbModel   {
        return CrumbModel(
            text,
            tooltip,
            icon,
            textRange,
            _navigate.deepClonePolymorphic(),
            actions.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class CrumbSession private constructor(
    val offset: Int,
    val timestamp: Int,
    private val _crumbs: RdOptionalProperty<List<CrumbModel>>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<CrumbSession> {
        override val _type: KClass<CrumbSession> = CrumbSession::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CrumbSession  {
            val _id = RdId.read(buffer)
            val offset = buffer.readInt()
            val timestamp = buffer.readInt()
            val _crumbs = RdOptionalProperty.read(ctx, buffer, __CrumbModelListSerializer)
            return CrumbSession(offset, timestamp, _crumbs).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CrumbSession)  {
            value.rdid.write(buffer)
            buffer.writeInt(value.offset)
            buffer.writeInt(value.timestamp)
            RdOptionalProperty.write(ctx, buffer, value._crumbs)
        }
        
        private val __CrumbModelListSerializer = CrumbModel.list()
        
    }
    //fields
    val crumbs: IOptProperty<List<CrumbModel>> get() = _crumbs
    //methods
    //initializer
    init {
        bindableChildren.add("crumbs" to _crumbs)
    }
    
    //secondary constructor
    constructor(
        offset: Int,
        timestamp: Int
    ) : this(
        offset,
        timestamp,
        RdOptionalProperty<List<CrumbModel>>(__CrumbModelListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CrumbSession (")
        printer.indent {
            print("offset = "); offset.print(printer); println()
            print("timestamp = "); timestamp.print(printer); println()
            print("crumbs = "); _crumbs.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CrumbSession   {
        return CrumbSession(
            offset,
            timestamp,
            _crumbs.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class CustomStyleHighlighterModel (
    val lightAttributes: com.jetbrains.ide.model.highlighterRegistration.IdeaTextAttributes,
    val darkAttributes: com.jetbrains.ide.model.highlighterRegistration.IdeaTextAttributes,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<CustomStyleHighlighterModel> {
        override val _type: KClass<CustomStyleHighlighterModel> = CustomStyleHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CustomStyleHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val lightAttributes = com.jetbrains.ide.model.highlighterRegistration.IdeaTextAttributes.read(ctx, buffer)
            val darkAttributes = com.jetbrains.ide.model.highlighterRegistration.IdeaTextAttributes.read(ctx, buffer)
            return CustomStyleHighlighterModel(lightAttributes, darkAttributes, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CustomStyleHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            com.jetbrains.ide.model.highlighterRegistration.IdeaTextAttributes.write(ctx, buffer, value.lightAttributes)
            com.jetbrains.ide.model.highlighterRegistration.IdeaTextAttributes.write(ctx, buffer, value.darkAttributes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as CustomStyleHighlighterModel
        
        if (lightAttributes != other.lightAttributes) return false
        if (darkAttributes != other.darkAttributes) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + lightAttributes.hashCode()
        __r = __r*31 + darkAttributes.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CustomStyleHighlighterModel (")
        printer.indent {
            print("lightAttributes = "); lightAttributes.print(printer); println()
            print("darkAttributes = "); darkAttributes.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class DaemonModel private constructor(
    private val _invalidateAll: RdSignal<Unit>,
    private val _isSuspended: RdOptionalProperty<Boolean>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<DaemonModel> {
        override val _type: KClass<DaemonModel> = DaemonModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DaemonModel  {
            val _id = RdId.read(buffer)
            val _invalidateAll = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _isSuspended = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            return DaemonModel(_invalidateAll, _isSuspended).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DaemonModel)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._invalidateAll)
            RdOptionalProperty.write(ctx, buffer, value._isSuspended)
        }
        
        
    }
    //fields
    val invalidateAll: ISignal<Unit> get() = _invalidateAll
    val isSuspended: IOptProperty<Boolean> get() = _isSuspended
    //methods
    //initializer
    init {
        _isSuspended.optimizeNested = true
    }
    
    init {
        bindableChildren.add("invalidateAll" to _invalidateAll)
        bindableChildren.add("isSuspended" to _isSuspended)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DaemonModel (")
        printer.indent {
            print("invalidateAll = "); _invalidateAll.print(printer); println()
            print("isSuspended = "); _isSuspended.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DaemonModel   {
        return DaemonModel(
            _invalidateAll.deepClonePolymorphic(),
            _isSuspended.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class DefaultHighlighterModel (
    val info: HighlightInfoModel?,
    val afterEndOfLine: Boolean,
    val needsUpdateOnTyping: Boolean?,
    val erased: Boolean,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<DefaultHighlighterModel> {
        override val _type: KClass<DefaultHighlighterModel> = DefaultHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DefaultHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val info = buffer.readNullable { HighlightInfoModel.read(ctx, buffer) }
            val afterEndOfLine = buffer.readBool()
            val needsUpdateOnTyping = buffer.readNullable { buffer.readBool() }
            val erased = buffer.readBool()
            return DefaultHighlighterModel(info, afterEndOfLine, needsUpdateOnTyping, erased, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DefaultHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeNullable(value.info) { HighlightInfoModel.write(ctx, buffer, it) }
            buffer.writeBool(value.afterEndOfLine)
            buffer.writeNullable(value.needsUpdateOnTyping) { buffer.writeBool(it) }
            buffer.writeBool(value.erased)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DefaultHighlighterModel
        
        if (info != other.info) return false
        if (afterEndOfLine != other.afterEndOfLine) return false
        if (needsUpdateOnTyping != other.needsUpdateOnTyping) return false
        if (erased != other.erased) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (info != null) info.hashCode() else 0
        __r = __r*31 + afterEndOfLine.hashCode()
        __r = __r*31 + if (needsUpdateOnTyping != null) needsUpdateOnTyping.hashCode() else 0
        __r = __r*31 + erased.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DefaultHighlighterModel (")
        printer.indent {
            print("info = "); info.print(printer); println()
            print("afterEndOfLine = "); afterEndOfLine.print(printer); println()
            print("needsUpdateOnTyping = "); needsUpdateOnTyping.print(printer); println()
            print("erased = "); erased.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class DocOffsetAndVirtualModel (
    val offset: Int,
    val virtualDelta: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<DocOffsetAndVirtualModel> {
        override val _type: KClass<DocOffsetAndVirtualModel> = DocOffsetAndVirtualModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DocOffsetAndVirtualModel  {
            val offset = buffer.readInt()
            val virtualDelta = buffer.readInt()
            return DocOffsetAndVirtualModel(offset, virtualDelta)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DocOffsetAndVirtualModel)  {
            buffer.writeInt(value.offset)
            buffer.writeInt(value.virtualDelta)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DocOffsetAndVirtualModel
        
        if (offset != other.offset) return false
        if (virtualDelta != other.virtualDelta) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + offset.hashCode()
        __r = __r*31 + virtualDelta.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DocOffsetAndVirtualModel (")
        printer.indent {
            print("offset = "); offset.print(printer); println()
            print("virtualDelta = "); virtualDelta.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class DocumentExtension (
    val key: String
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<DocumentExtension> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): DocumentExtension  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val key = buffer.readString()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return DocumentExtension_Unknown(key, unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class DocumentExtension_Unknown (
    key: String,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : DocumentExtension (
    key
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<DocumentExtension_Unknown> {
        override val _type: KClass<DocumentExtension_Unknown> = DocumentExtension_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DocumentExtension_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DocumentExtension_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeString(value.key)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DocumentExtension_Unknown (")
        printer.indent {
            print("key = "); key.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DocumentExtension_Unknown   {
        return DocumentExtension_Unknown(
            key,
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class DocumentVersion (
    val value: com.jetbrains.rd.rdtext.intrinsics.TextBufferVersion
) : AbstractDocumentVersion (
) {
    //companion
    
    companion object : IMarshaller<DocumentVersion> {
        override val _type: KClass<DocumentVersion> = DocumentVersion::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DocumentVersion  {
            val value = com.jetbrains.rd.rdtext.intrinsics.TextBufferVersionMarshaller.read(ctx, buffer)
            return DocumentVersion(value)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DocumentVersion)  {
            com.jetbrains.rd.rdtext.intrinsics.TextBufferVersionMarshaller.write(ctx,buffer, value.value)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as DocumentVersion
        
        if (value != other.value) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + value.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DocumentVersion (")
        printer.indent {
            print("value = "); value.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class DocumentsOperationModel private constructor(
    private val _navigateFromBackend: RdSignal<TextControlId>,
    private val _checkInternalState: RdSignal<FrontendTextControl>,
    private val _dumpBackendTextControls: RdCall<Boolean, String>,
    private val _documents: RdMap<RdDocumentId, RdDocumentModel>,
    private val _needRecover: RdSignal<RdDocumentId>,
    private val _activeClients: RdMap<String, RdDocumentId>,
    private val _committingTransaction: RdProperty<String?>,
    val commandProcessor: RdCommandProcessor,
    private val _saveAllEditorsAfterBackendSync: RdCall<Boolean, Boolean>,
    private val _saveFileAfterBackendSync: RdCall<String, Boolean>,
    private val _saveAll: RdCall<Boolean, Boolean>,
    private val _saveFiles: RdCall<List<String>, Boolean>,
    private val _doNotStripFiles: RdMap<Int, String>,
    private val _afterDocumentInEditorSaved: RdSignal<String>,
    private val _isReady: RdProperty<Boolean>,
    private val _resetCompletionStatistics: RdSignal<Unit>,
    private val _typingSession: RdProperty<TypingSessionState?>,
    val synchronizationModel: RdAsyncDocumentModel
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<DocumentsOperationModel> {
        override val _type: KClass<DocumentsOperationModel> = DocumentsOperationModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DocumentsOperationModel  {
            val _id = RdId.read(buffer)
            val _navigateFromBackend = RdSignal.read(ctx, buffer, TextControlId)
            val _checkInternalState = RdSignal.read(ctx, buffer, FrontendTextControl)
            val _dumpBackendTextControls = RdCall.read(ctx, buffer, FrameworkMarshallers.Bool, FrameworkMarshallers.String)
            val _documents = RdMap.read(ctx, buffer, AbstractPolymorphic(RdDocumentId), RdDocumentModel)
            val _needRecover = RdSignal.read(ctx, buffer, AbstractPolymorphic(RdDocumentId))
            val _activeClients = RdMap.read(ctx, buffer, FrameworkMarshallers.String, AbstractPolymorphic(RdDocumentId))
            val _committingTransaction = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val commandProcessor = RdCommandProcessor.read(ctx, buffer)
            val _saveAllEditorsAfterBackendSync = RdCall.read(ctx, buffer, FrameworkMarshallers.Bool, FrameworkMarshallers.Bool)
            val _saveFileAfterBackendSync = RdCall.read(ctx, buffer, FrameworkMarshallers.String, FrameworkMarshallers.Bool)
            val _saveAll = RdCall.read(ctx, buffer, FrameworkMarshallers.Bool, FrameworkMarshallers.Bool)
            val _saveFiles = RdCall.read(ctx, buffer, __StringListSerializer, FrameworkMarshallers.Bool)
            val _doNotStripFiles = RdMap.read(ctx, buffer, FrameworkMarshallers.Int, FrameworkMarshallers.String)
            val _afterDocumentInEditorSaved = RdSignal.read(ctx, buffer, FrameworkMarshallers.String)
            val _isReady = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _resetCompletionStatistics = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _typingSession = RdProperty.read(ctx, buffer, __TypingSessionStateNullableSerializer)
            val synchronizationModel = RdAsyncDocumentModel.read(ctx, buffer)
            return DocumentsOperationModel(_navigateFromBackend, _checkInternalState, _dumpBackendTextControls, _documents, _needRecover, _activeClients, _committingTransaction, commandProcessor, _saveAllEditorsAfterBackendSync, _saveFileAfterBackendSync, _saveAll, _saveFiles, _doNotStripFiles, _afterDocumentInEditorSaved, _isReady, _resetCompletionStatistics, _typingSession, synchronizationModel).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DocumentsOperationModel)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._navigateFromBackend)
            RdSignal.write(ctx, buffer, value._checkInternalState)
            RdCall.write(ctx, buffer, value._dumpBackendTextControls)
            RdMap.write(ctx, buffer, value._documents)
            RdSignal.write(ctx, buffer, value._needRecover)
            RdMap.write(ctx, buffer, value._activeClients)
            RdProperty.write(ctx, buffer, value._committingTransaction)
            RdCommandProcessor.write(ctx, buffer, value.commandProcessor)
            RdCall.write(ctx, buffer, value._saveAllEditorsAfterBackendSync)
            RdCall.write(ctx, buffer, value._saveFileAfterBackendSync)
            RdCall.write(ctx, buffer, value._saveAll)
            RdCall.write(ctx, buffer, value._saveFiles)
            RdMap.write(ctx, buffer, value._doNotStripFiles)
            RdSignal.write(ctx, buffer, value._afterDocumentInEditorSaved)
            RdProperty.write(ctx, buffer, value._isReady)
            RdSignal.write(ctx, buffer, value._resetCompletionStatistics)
            RdProperty.write(ctx, buffer, value._typingSession)
            RdAsyncDocumentModel.write(ctx, buffer, value.synchronizationModel)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        private val __StringListSerializer = FrameworkMarshallers.String.list()
        private val __TypingSessionStateNullableSerializer = TypingSessionState.nullable()
        
    }
    //fields
    val navigateFromBackend: ISignal<TextControlId> get() = _navigateFromBackend
    val checkInternalState: ISignal<FrontendTextControl> get() = _checkInternalState
    val dumpBackendTextControls: RdCall<Boolean, String> get() = _dumpBackendTextControls
    val documents: IMutableViewableMap<RdDocumentId, RdDocumentModel> get() = _documents
    val needRecover: ISignal<RdDocumentId> get() = _needRecover
    val activeClients: IMutableViewableMap<String, RdDocumentId> get() = _activeClients
    val committingTransaction: IProperty<String?> get() = _committingTransaction
    val saveAllEditorsAfterBackendSync: RdCall<Boolean, Boolean> get() = _saveAllEditorsAfterBackendSync
    val saveFileAfterBackendSync: RdCall<String, Boolean> get() = _saveFileAfterBackendSync
    val saveAll: RdCall<Boolean, Boolean> get() = _saveAll
    val saveFiles: RdCall<List<String>, Boolean> get() = _saveFiles
    val doNotStripFiles: IMutableViewableMap<Int, String> get() = _doNotStripFiles
    val afterDocumentInEditorSaved: ISignal<String> get() = _afterDocumentInEditorSaved
    val isReady: IProperty<Boolean> get() = _isReady
    val resetCompletionStatistics: ISignal<Unit> get() = _resetCompletionStatistics
    val typingSession: IProperty<TypingSessionState?> get() = _typingSession
    //methods
    //initializer
    init {
        _activeClients.optimizeNested = true
        _committingTransaction.optimizeNested = true
        _doNotStripFiles.optimizeNested = true
        _isReady.optimizeNested = true
    }
    
    init {
        bindableChildren.add("navigateFromBackend" to _navigateFromBackend)
        bindableChildren.add("checkInternalState" to _checkInternalState)
        bindableChildren.add("dumpBackendTextControls" to _dumpBackendTextControls)
        bindableChildren.add("documents" to _documents)
        bindableChildren.add("needRecover" to _needRecover)
        bindableChildren.add("activeClients" to _activeClients)
        bindableChildren.add("committingTransaction" to _committingTransaction)
        bindableChildren.add("commandProcessor" to commandProcessor)
        bindableChildren.add("saveAllEditorsAfterBackendSync" to _saveAllEditorsAfterBackendSync)
        bindableChildren.add("saveFileAfterBackendSync" to _saveFileAfterBackendSync)
        bindableChildren.add("saveAll" to _saveAll)
        bindableChildren.add("saveFiles" to _saveFiles)
        bindableChildren.add("doNotStripFiles" to _doNotStripFiles)
        bindableChildren.add("afterDocumentInEditorSaved" to _afterDocumentInEditorSaved)
        bindableChildren.add("isReady" to _isReady)
        bindableChildren.add("resetCompletionStatistics" to _resetCompletionStatistics)
        bindableChildren.add("typingSession" to _typingSession)
        bindableChildren.add("synchronizationModel" to synchronizationModel)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdSignal<TextControlId>(TextControlId),
        RdSignal<FrontendTextControl>(FrontendTextControl),
        RdCall<Boolean, String>(FrameworkMarshallers.Bool, FrameworkMarshallers.String),
        RdMap<RdDocumentId, RdDocumentModel>(AbstractPolymorphic(RdDocumentId), RdDocumentModel),
        RdSignal<RdDocumentId>(AbstractPolymorphic(RdDocumentId)),
        RdMap<String, RdDocumentId>(FrameworkMarshallers.String, AbstractPolymorphic(RdDocumentId)),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdCommandProcessor(),
        RdCall<Boolean, Boolean>(FrameworkMarshallers.Bool, FrameworkMarshallers.Bool),
        RdCall<String, Boolean>(FrameworkMarshallers.String, FrameworkMarshallers.Bool),
        RdCall<Boolean, Boolean>(FrameworkMarshallers.Bool, FrameworkMarshallers.Bool),
        RdCall<List<String>, Boolean>(__StringListSerializer, FrameworkMarshallers.Bool),
        RdMap<Int, String>(FrameworkMarshallers.Int, FrameworkMarshallers.String),
        RdSignal<String>(FrameworkMarshallers.String),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<TypingSessionState?>(null, __TypingSessionStateNullableSerializer),
        RdAsyncDocumentModel()
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DocumentsOperationModel (")
        printer.indent {
            print("navigateFromBackend = "); _navigateFromBackend.print(printer); println()
            print("checkInternalState = "); _checkInternalState.print(printer); println()
            print("dumpBackendTextControls = "); _dumpBackendTextControls.print(printer); println()
            print("documents = "); _documents.print(printer); println()
            print("needRecover = "); _needRecover.print(printer); println()
            print("activeClients = "); _activeClients.print(printer); println()
            print("committingTransaction = "); _committingTransaction.print(printer); println()
            print("commandProcessor = "); commandProcessor.print(printer); println()
            print("saveAllEditorsAfterBackendSync = "); _saveAllEditorsAfterBackendSync.print(printer); println()
            print("saveFileAfterBackendSync = "); _saveFileAfterBackendSync.print(printer); println()
            print("saveAll = "); _saveAll.print(printer); println()
            print("saveFiles = "); _saveFiles.print(printer); println()
            print("doNotStripFiles = "); _doNotStripFiles.print(printer); println()
            print("afterDocumentInEditorSaved = "); _afterDocumentInEditorSaved.print(printer); println()
            print("isReady = "); _isReady.print(printer); println()
            print("resetCompletionStatistics = "); _resetCompletionStatistics.print(printer); println()
            print("typingSession = "); _typingSession.print(printer); println()
            print("synchronizationModel = "); synchronizationModel.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DocumentsOperationModel   {
        return DocumentsOperationModel(
            _navigateFromBackend.deepClonePolymorphic(),
            _checkInternalState.deepClonePolymorphic(),
            _dumpBackendTextControls.deepClonePolymorphic(),
            _documents.deepClonePolymorphic(),
            _needRecover.deepClonePolymorphic(),
            _activeClients.deepClonePolymorphic(),
            _committingTransaction.deepClonePolymorphic(),
            commandProcessor.deepClonePolymorphic(),
            _saveAllEditorsAfterBackendSync.deepClonePolymorphic(),
            _saveFileAfterBackendSync.deepClonePolymorphic(),
            _saveAll.deepClonePolymorphic(),
            _saveFiles.deepClonePolymorphic(),
            _doNotStripFiles.deepClonePolymorphic(),
            _afterDocumentInEditorSaved.deepClonePolymorphic(),
            _isReady.deepClonePolymorphic(),
            _resetCompletionStatistics.deepClonePolymorphic(),
            _typingSession.deepClonePolymorphic(),
            synchronizationModel.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class FoldingHighlighterModel (
    val placeholderText: String,
    val collapsedByDefault: Boolean,
    val groupId: Long?,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<FoldingHighlighterModel> {
        override val _type: KClass<FoldingHighlighterModel> = FoldingHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FoldingHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val placeholderText = buffer.readString()
            val collapsedByDefault = buffer.readBool()
            val groupId = buffer.readNullable { buffer.readLong() }
            return FoldingHighlighterModel(placeholderText, collapsedByDefault, groupId, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FoldingHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeString(value.placeholderText)
            buffer.writeBool(value.collapsedByDefault)
            buffer.writeNullable(value.groupId) { buffer.writeLong(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FoldingHighlighterModel
        
        if (placeholderText != other.placeholderText) return false
        if (collapsedByDefault != other.collapsedByDefault) return false
        if (groupId != other.groupId) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + placeholderText.hashCode()
        __r = __r*31 + collapsedByDefault.hashCode()
        __r = __r*31 + if (groupId != null) groupId.hashCode() else 0
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FoldingHighlighterModel (")
        printer.indent {
            print("placeholderText = "); placeholderText.print(printer); println()
            print("collapsedByDefault = "); collapsedByDefault.print(printer); println()
            print("groupId = "); groupId.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class FrontendTextControl (
    val id: TextControlId,
    val frontendState: TextControlSnapshot
) : IPrintable {
    //companion
    
    companion object : IMarshaller<FrontendTextControl> {
        override val _type: KClass<FrontendTextControl> = FrontendTextControl::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): FrontendTextControl  {
            val id = TextControlId.read(ctx, buffer)
            val frontendState = TextControlSnapshot.read(ctx, buffer)
            return FrontendTextControl(id, frontendState)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: FrontendTextControl)  {
            TextControlId.write(ctx, buffer, value.id)
            TextControlSnapshot.write(ctx, buffer, value.frontendState)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as FrontendTextControl
        
        if (id != other.id) return false
        if (frontendState != other.frontendState) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + frontendState.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("FrontendTextControl (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("frontendState = "); frontendState.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class GutterMarkActionModel private constructor(
    private val _leftClick: RdSignal<RdGutterExecutionRequest>,
    key: String
) : MarkupModelExtension (
    key
) {
    //companion
    
    companion object : IMarshaller<GutterMarkActionModel> {
        override val _type: KClass<GutterMarkActionModel> = GutterMarkActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): GutterMarkActionModel  {
            val _id = RdId.read(buffer)
            val key = buffer.readString()
            val _leftClick = RdSignal.read(ctx, buffer, RdGutterExecutionRequest)
            return GutterMarkActionModel(_leftClick, key).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: GutterMarkActionModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.key)
            RdSignal.write(ctx, buffer, value._leftClick)
        }
        
        
    }
    //fields
    val leftClick: ISignal<RdGutterExecutionRequest> get() = _leftClick
    //methods
    //initializer
    init {
        bindableChildren.add("leftClick" to _leftClick)
    }
    
    //secondary constructor
    constructor(
        key: String
    ) : this(
        RdSignal<RdGutterExecutionRequest>(RdGutterExecutionRequest),
        key
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("GutterMarkActionModel (")
        printer.indent {
            print("leftClick = "); _leftClick.print(printer); println()
            print("key = "); key.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): GutterMarkActionModel   {
        return GutterMarkActionModel(
            _leftClick.deepClonePolymorphic(),
            key
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class GutterMarkHighlighterModel (
    val icon: IconModel,
    val priority: List<Long>,
    val kind: com.jetbrains.ide.model.popups.RdPopupMenuItemKind,
    val tooltip: String?,
    val isNavigatable: Boolean,
    val hasLeftClick: Boolean,
    val hasMiddleClick: Boolean,
    val hasRightClick: Boolean,
    val popupActions: List<String>?,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<GutterMarkHighlighterModel> {
        override val _type: KClass<GutterMarkHighlighterModel> = GutterMarkHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): GutterMarkHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val icon = ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel)
            val priority = buffer.readList { buffer.readLong() }
            val kind = buffer.readEnum<com.jetbrains.ide.model.popups.RdPopupMenuItemKind>()
            val tooltip = buffer.readNullable { buffer.readString() }
            val isNavigatable = buffer.readBool()
            val hasLeftClick = buffer.readBool()
            val hasMiddleClick = buffer.readBool()
            val hasRightClick = buffer.readBool()
            val popupActions = buffer.readNullable { buffer.readList { buffer.readString() } }
            return GutterMarkHighlighterModel(icon, priority, kind, tooltip, isNavigatable, hasLeftClick, hasMiddleClick, hasRightClick, popupActions, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: GutterMarkHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            ctx.serializers.writePolymorphic(ctx, buffer, value.icon)
            buffer.writeList(value.priority) { v -> buffer.writeLong(v) }
            buffer.writeEnum(value.kind)
            buffer.writeNullable(value.tooltip) { buffer.writeString(it) }
            buffer.writeBool(value.isNavigatable)
            buffer.writeBool(value.hasLeftClick)
            buffer.writeBool(value.hasMiddleClick)
            buffer.writeBool(value.hasRightClick)
            buffer.writeNullable(value.popupActions) { buffer.writeList(it) { v -> buffer.writeString(v) } }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as GutterMarkHighlighterModel
        
        if (icon != other.icon) return false
        if (priority != other.priority) return false
        if (kind != other.kind) return false
        if (tooltip != other.tooltip) return false
        if (isNavigatable != other.isNavigatable) return false
        if (hasLeftClick != other.hasLeftClick) return false
        if (hasMiddleClick != other.hasMiddleClick) return false
        if (hasRightClick != other.hasRightClick) return false
        if (popupActions != other.popupActions) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + icon.hashCode()
        __r = __r*31 + priority.hashCode()
        __r = __r*31 + kind.hashCode()
        __r = __r*31 + if (tooltip != null) tooltip.hashCode() else 0
        __r = __r*31 + isNavigatable.hashCode()
        __r = __r*31 + hasLeftClick.hashCode()
        __r = __r*31 + hasMiddleClick.hashCode()
        __r = __r*31 + hasRightClick.hashCode()
        __r = __r*31 + if (popupActions != null) popupActions.hashCode() else 0
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("GutterMarkHighlighterModel (")
        printer.indent {
            print("icon = "); icon.print(printer); println()
            print("priority = "); priority.print(printer); println()
            print("kind = "); kind.print(printer); println()
            print("tooltip = "); tooltip.print(printer); println()
            print("isNavigatable = "); isNavigatable.print(printer); println()
            print("hasLeftClick = "); hasLeftClick.print(printer); println()
            print("hasMiddleClick = "); hasMiddleClick.print(printer); println()
            print("hasRightClick = "); hasRightClick.print(printer); println()
            print("popupActions = "); popupActions.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class HighlightInfoModel (
    val type: com.jetbrains.ide.model.highlighterRegistration.IdeaHighlightInfoType,
    val tooltip: String?,
    val description: String?,
    val useAsyncTooltips: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<HighlightInfoModel> {
        override val _type: KClass<HighlightInfoModel> = HighlightInfoModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HighlightInfoModel  {
            val type = com.jetbrains.ide.model.highlighterRegistration.IdeaHighlightInfoType.read(ctx, buffer)
            val tooltip = buffer.readNullable { buffer.readString() }
            val description = buffer.readNullable { buffer.readString() }
            val useAsyncTooltips = buffer.readBool()
            return HighlightInfoModel(type, tooltip, description, useAsyncTooltips)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HighlightInfoModel)  {
            com.jetbrains.ide.model.highlighterRegistration.IdeaHighlightInfoType.write(ctx, buffer, value.type)
            buffer.writeNullable(value.tooltip) { buffer.writeString(it) }
            buffer.writeNullable(value.description) { buffer.writeString(it) }
            buffer.writeBool(value.useAsyncTooltips)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HighlightInfoModel
        
        if (type != other.type) return false
        if (tooltip != other.tooltip) return false
        if (description != other.description) return false
        if (useAsyncTooltips != other.useAsyncTooltips) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + type.hashCode()
        __r = __r*31 + if (tooltip != null) tooltip.hashCode() else 0
        __r = __r*31 + if (description != null) description.hashCode() else 0
        __r = __r*31 + useAsyncTooltips.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HighlightInfoModel (")
        printer.indent {
            print("type = "); type.print(printer); println()
            print("tooltip = "); tooltip.print(printer); println()
            print("description = "); description.print(printer); println()
            print("useAsyncTooltips = "); useAsyncTooltips.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class HighlightInfoTypeModel (
    val severity: String,
    val attributeKey: String,
    val needsUpdateOnTyping: Boolean
) : IPrintable {
    //companion
    
    companion object : IMarshaller<HighlightInfoTypeModel> {
        override val _type: KClass<HighlightInfoTypeModel> = HighlightInfoTypeModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HighlightInfoTypeModel  {
            val severity = buffer.readString()
            val attributeKey = buffer.readString()
            val needsUpdateOnTyping = buffer.readBool()
            return HighlightInfoTypeModel(severity, attributeKey, needsUpdateOnTyping)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HighlightInfoTypeModel)  {
            buffer.writeString(value.severity)
            buffer.writeString(value.attributeKey)
            buffer.writeBool(value.needsUpdateOnTyping)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HighlightInfoTypeModel
        
        if (severity != other.severity) return false
        if (attributeKey != other.attributeKey) return false
        if (needsUpdateOnTyping != other.needsUpdateOnTyping) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + severity.hashCode()
        __r = __r*31 + attributeKey.hashCode()
        __r = __r*31 + needsUpdateOnTyping.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HighlightInfoTypeModel (")
        printer.indent {
            print("severity = "); severity.print(printer); println()
            print("attributeKey = "); attributeKey.print(printer); println()
            print("needsUpdateOnTyping = "); needsUpdateOnTyping.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class HighlighterIdList (
    val elements: List<Long>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<HighlighterIdList> {
        override val _type: KClass<HighlighterIdList> = HighlighterIdList::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HighlighterIdList  {
            val elements = buffer.readList { buffer.readLong() }
            return HighlighterIdList(elements)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HighlighterIdList)  {
            buffer.writeList(value.elements) { v -> buffer.writeLong(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HighlighterIdList
        
        if (elements != other.elements) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + elements.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HighlighterIdList (")
        printer.indent {
            print("elements = "); elements.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class HighlighterList (
    val elements: List<HighlighterModel>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<HighlighterList> {
        override val _type: KClass<HighlighterList> = HighlighterList::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HighlighterList  {
            val elements = buffer.readList { ctx.serializers.readPolymorphic<HighlighterModel>(ctx, buffer, HighlighterModel) }
            return HighlighterList(elements)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HighlighterList)  {
            buffer.writeList(value.elements) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HighlighterList
        
        if (elements != other.elements) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + elements.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HighlighterList (")
        printer.indent {
            print("elements = "); elements.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class HighlighterModel (
    val layer: Int,
    val isExactRange: Boolean,
    val documentVersion: AbstractDocumentVersion,
    val isGreedyToLeft: Boolean,
    val isGreedyToRight: Boolean,
    val isThinErrorStripeMark: Boolean,
    val textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : LightweightHighlighter (
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IAbstractDeclaration<HighlighterModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): HighlighterModel  {
            val objectStartPosition = buffer.position
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return HighlighterModel_Unknown(layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class HighlighterModel_Unknown (
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<HighlighterModel_Unknown> {
        override val _type: KClass<HighlighterModel_Unknown> = HighlighterModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HighlighterModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HighlighterModel_Unknown)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HighlighterModel_Unknown
        
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HighlighterModel_Unknown (")
        printer.indent {
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class HighlightingSettingsModel (
    val state: HighlightingSettingsState
) : IPrintable {
    //companion
    
    companion object : IMarshaller<HighlightingSettingsModel> {
        override val _type: KClass<HighlightingSettingsModel> = HighlightingSettingsModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HighlightingSettingsModel  {
            val state = buffer.readEnum<HighlightingSettingsState>()
            return HighlightingSettingsModel(state)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HighlightingSettingsModel)  {
            buffer.writeEnum(value.state)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HighlightingSettingsModel
        
        if (state != other.state) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + state.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HighlightingSettingsModel (")
        printer.indent {
            print("state = "); state.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
enum class HighlightingSettingsState {
    NONE, 
    SYNTAX_ONLY, 
    FULL;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<HighlightingSettingsState>()
        
    }
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class HtmlStringTooltipModel (
    val htmlText: String?,
    val description: String?
) : TooltipModel (
) {
    //companion
    
    companion object : IMarshaller<HtmlStringTooltipModel> {
        override val _type: KClass<HtmlStringTooltipModel> = HtmlStringTooltipModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): HtmlStringTooltipModel  {
            val htmlText = buffer.readNullable { buffer.readString() }
            val description = buffer.readNullable { buffer.readString() }
            return HtmlStringTooltipModel(htmlText, description)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: HtmlStringTooltipModel)  {
            buffer.writeNullable(value.htmlText) { buffer.writeString(it) }
            buffer.writeNullable(value.description) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as HtmlStringTooltipModel
        
        if (htmlText != other.htmlText) return false
        if (description != other.description) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (htmlText != null) htmlText.hashCode() else 0
        __r = __r*31 + if (description != null) description.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("HtmlStringTooltipModel (")
        printer.indent {
            print("htmlText = "); htmlText.print(printer); println()
            print("description = "); description.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class IndentGuideHighlighterModel (
    val indentLevel: Int,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<IndentGuideHighlighterModel> {
        override val _type: KClass<IndentGuideHighlighterModel> = IndentGuideHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): IndentGuideHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val indentLevel = buffer.readInt()
            return IndentGuideHighlighterModel(indentLevel, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: IndentGuideHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeInt(value.indentLevel)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as IndentGuideHighlighterModel
        
        if (indentLevel != other.indentLevel) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + indentLevel.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("IndentGuideHighlighterModel (")
        printer.indent {
            print("indentLevel = "); indentLevel.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class InjectionMarkHighlighterModel (
    val language: RdLanguage,
    val isInjected: Boolean,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<InjectionMarkHighlighterModel> {
        override val _type: KClass<InjectionMarkHighlighterModel> = InjectionMarkHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): InjectionMarkHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val language = RdLanguage.read(ctx, buffer)
            val isInjected = buffer.readBool()
            return InjectionMarkHighlighterModel(language, isInjected, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: InjectionMarkHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            RdLanguage.write(ctx, buffer, value.language)
            buffer.writeBool(value.isInjected)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as InjectionMarkHighlighterModel
        
        if (language != other.language) return false
        if (isInjected != other.isInjected) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + language.hashCode()
        __r = __r*31 + isInjected.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("InjectionMarkHighlighterModel (")
        printer.indent {
            print("language = "); language.print(printer); println()
            print("isInjected = "); isInjected.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class InlayHighlighterModel (
    val text: RichTextModel,
    val tooltip: RichTextModel,
    val order: Int,
    val icon: IconModel?,
    val relatesToPrecedingText: Boolean,
    val inPushToHintMode: Boolean,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<InlayHighlighterModel> {
        override val _type: KClass<InlayHighlighterModel> = InlayHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): InlayHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val text = RichTextModel.read(ctx, buffer)
            val tooltip = RichTextModel.read(ctx, buffer)
            val order = buffer.readInt()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val relatesToPrecedingText = buffer.readBool()
            val inPushToHintMode = buffer.readBool()
            return InlayHighlighterModel(text, tooltip, order, icon, relatesToPrecedingText, inPushToHintMode, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: InlayHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            RichTextModel.write(ctx, buffer, value.text)
            RichTextModel.write(ctx, buffer, value.tooltip)
            buffer.writeInt(value.order)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeBool(value.relatesToPrecedingText)
            buffer.writeBool(value.inPushToHintMode)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as InlayHighlighterModel
        
        if (text != other.text) return false
        if (tooltip != other.tooltip) return false
        if (order != other.order) return false
        if (icon != other.icon) return false
        if (relatesToPrecedingText != other.relatesToPrecedingText) return false
        if (inPushToHintMode != other.inPushToHintMode) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + tooltip.hashCode()
        __r = __r*31 + order.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + relatesToPrecedingText.hashCode()
        __r = __r*31 + inPushToHintMode.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("InlayHighlighterModel (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("tooltip = "); tooltip.print(printer); println()
            print("order = "); order.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("relatesToPrecedingText = "); relatesToPrecedingText.print(printer); println()
            print("inPushToHintMode = "); inPushToHintMode.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class InvisibleBraceHintModel (
    val hintRange: RdTextRange
) : IPrintable {
    //companion
    
    companion object : IMarshaller<InvisibleBraceHintModel> {
        override val _type: KClass<InvisibleBraceHintModel> = InvisibleBraceHintModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): InvisibleBraceHintModel  {
            val hintRange = RdTextRange.read(ctx, buffer)
            return InvisibleBraceHintModel(hintRange)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: InvisibleBraceHintModel)  {
            RdTextRange.write(ctx, buffer, value.hintRange)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as InvisibleBraceHintModel
        
        if (hintRange != other.hintRange) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + hintRange.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("InvisibleBraceHintModel (")
        printer.indent {
            print("hintRange = "); hintRange.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class InvisibleBraceHintProviderModel private constructor(
    private val _getInvisibleBraceHint: RdCall<Long, InvisibleBraceHintModel?>,
    key: String
) : MarkupModelExtension (
    key
) {
    //companion
    
    companion object : IMarshaller<InvisibleBraceHintProviderModel> {
        override val _type: KClass<InvisibleBraceHintProviderModel> = InvisibleBraceHintProviderModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): InvisibleBraceHintProviderModel  {
            val _id = RdId.read(buffer)
            val key = buffer.readString()
            val _getInvisibleBraceHint = RdCall.read(ctx, buffer, FrameworkMarshallers.Long, __InvisibleBraceHintModelNullableSerializer)
            return InvisibleBraceHintProviderModel(_getInvisibleBraceHint, key).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: InvisibleBraceHintProviderModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.key)
            RdCall.write(ctx, buffer, value._getInvisibleBraceHint)
        }
        
        private val __InvisibleBraceHintModelNullableSerializer = InvisibleBraceHintModel.nullable()
        
    }
    //fields
    val getInvisibleBraceHint: RdCall<Long, InvisibleBraceHintModel?> get() = _getInvisibleBraceHint
    //methods
    //initializer
    init {
        bindableChildren.add("getInvisibleBraceHint" to _getInvisibleBraceHint)
    }
    
    //secondary constructor
    constructor(
        key: String
    ) : this(
        RdCall<Long, InvisibleBraceHintModel?>(FrameworkMarshallers.Long, __InvisibleBraceHintModelNullableSerializer),
        key
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("InvisibleBraceHintProviderModel (")
        printer.indent {
            print("getInvisibleBraceHint = "); _getInvisibleBraceHint.print(printer); println()
            print("key = "); key.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): InvisibleBraceHintProviderModel   {
        return InvisibleBraceHintProviderModel(
            _getInvisibleBraceHint.deepClonePolymorphic(),
            key
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class LastDocumentVersion (
    val documentId: RdDocumentId,
    val version: RdDocumentVersion
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LastDocumentVersion> {
        override val _type: KClass<LastDocumentVersion> = LastDocumentVersion::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LastDocumentVersion  {
            val documentId = ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId)
            val version = RdDocumentVersion.read(ctx, buffer)
            return LastDocumentVersion(documentId, version)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LastDocumentVersion)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentId)
            RdDocumentVersion.write(ctx, buffer, value.version)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LastDocumentVersion
        
        if (documentId != other.documentId) return false
        if (version != other.version) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + documentId.hashCode()
        __r = __r*31 + version.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LastDocumentVersion (")
        printer.indent {
            print("documentId = "); documentId.print(printer); println()
            print("version = "); version.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class LightweightHighlighter (
    val id: Long,
    val attributeId: String,
    val start: Int,
    val end: Int
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<LightweightHighlighter> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): LightweightHighlighter  {
            val objectStartPosition = buffer.position
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return LightweightHighlighter_Unknown(id, attributeId, start, end, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class LightweightHighlighter_Unknown (
    id: Long,
    attributeId: String,
    start: Int,
    end: Int,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : LightweightHighlighter (
    id,
    attributeId,
    start,
    end
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<LightweightHighlighter_Unknown> {
        override val _type: KClass<LightweightHighlighter_Unknown> = LightweightHighlighter_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LightweightHighlighter_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LightweightHighlighter_Unknown)  {
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LightweightHighlighter_Unknown
        
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LightweightHighlighter_Unknown (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class LineMarkerActionEvent (
    val id: Long,
    val button: MouseButtonKind
) : IPrintable {
    //companion
    
    companion object : IMarshaller<LineMarkerActionEvent> {
        override val _type: KClass<LineMarkerActionEvent> = LineMarkerActionEvent::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LineMarkerActionEvent  {
            val id = buffer.readLong()
            val button = buffer.readEnum<MouseButtonKind>()
            return LineMarkerActionEvent(id, button)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LineMarkerActionEvent)  {
            buffer.writeLong(value.id)
            buffer.writeEnum(value.button)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LineMarkerActionEvent
        
        if (id != other.id) return false
        if (button != other.button) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + button.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LineMarkerActionEvent (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("button = "); button.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class LineMarkerActionModel private constructor(
    private val _click: RdSignal<LineMarkerActionEvent>,
    key: String
) : MarkupModelExtension (
    key
) {
    //companion
    
    companion object : IMarshaller<LineMarkerActionModel> {
        override val _type: KClass<LineMarkerActionModel> = LineMarkerActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LineMarkerActionModel  {
            val _id = RdId.read(buffer)
            val key = buffer.readString()
            val _click = RdSignal.read(ctx, buffer, LineMarkerActionEvent)
            return LineMarkerActionModel(_click, key).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LineMarkerActionModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.key)
            RdSignal.write(ctx, buffer, value._click)
        }
        
        
    }
    //fields
    val click: ISignal<LineMarkerActionEvent> get() = _click
    //methods
    //initializer
    init {
        bindableChildren.add("click" to _click)
    }
    
    //secondary constructor
    constructor(
        key: String
    ) : this(
        RdSignal<LineMarkerActionEvent>(LineMarkerActionEvent),
        key
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LineMarkerActionModel (")
        printer.indent {
            print("click = "); _click.print(printer); println()
            print("key = "); key.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): LineMarkerActionModel   {
        return LineMarkerActionModel(
            _click.deepClonePolymorphic(),
            key
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class LineMarkerHighlighterModel (
    val rendererId: String?,
    val rendererAttributeId: String?,
    val thickness: Int,
    val deepness: Int,
    val position: LineMarkerPosition,
    val isActive: Boolean,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<LineMarkerHighlighterModel> {
        override val _type: KClass<LineMarkerHighlighterModel> = LineMarkerHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LineMarkerHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val rendererId = buffer.readNullable { ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() } }
            val rendererAttributeId = buffer.readNullable { ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() } }
            val thickness = buffer.readInt()
            val deepness = buffer.readInt()
            val position = buffer.readEnum<LineMarkerPosition>()
            val isActive = buffer.readBool()
            return LineMarkerHighlighterModel(rendererId, rendererAttributeId, thickness, deepness, position, isActive, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LineMarkerHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeNullable(value.rendererId) { ctx.writeInterned(buffer, it, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) } }
            buffer.writeNullable(value.rendererAttributeId) { ctx.writeInterned(buffer, it, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) } }
            buffer.writeInt(value.thickness)
            buffer.writeInt(value.deepness)
            buffer.writeEnum(value.position)
            buffer.writeBool(value.isActive)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LineMarkerHighlighterModel
        
        if (rendererId != other.rendererId) return false
        if (rendererAttributeId != other.rendererAttributeId) return false
        if (thickness != other.thickness) return false
        if (deepness != other.deepness) return false
        if (position != other.position) return false
        if (isActive != other.isActive) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (rendererId != null) rendererId.hashCode() else 0
        __r = __r*31 + if (rendererAttributeId != null) rendererAttributeId.hashCode() else 0
        __r = __r*31 + thickness.hashCode()
        __r = __r*31 + deepness.hashCode()
        __r = __r*31 + position.hashCode()
        __r = __r*31 + isActive.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LineMarkerHighlighterModel (")
        printer.indent {
            print("rendererId = "); rendererId.print(printer); println()
            print("rendererAttributeId = "); rendererAttributeId.print(printer); println()
            print("thickness = "); thickness.print(printer); println()
            print("deepness = "); deepness.print(printer); println()
            print("position = "); position.print(printer); println()
            print("isActive = "); isActive.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
enum class LineMarkerPosition {
    LEFT, 
    RIGHT, 
    CUSTOM;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<LineMarkerPosition>()
        
    }
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class LiveTemplateHighlighterModel (
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<LiveTemplateHighlighterModel> {
        override val _type: KClass<LiveTemplateHighlighterModel> = LiveTemplateHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LiveTemplateHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            return LiveTemplateHighlighterModel(layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LiveTemplateHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as LiveTemplateHighlighterModel
        
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LiveTemplateHighlighterModel (")
        printer.indent {
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class LoadResult (
    val loadTime: Long,
    val isCold: Boolean
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<LoadResult> {
        override val _type: KClass<LoadResult> = LoadResult::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): LoadResult  {
            val _id = RdId.read(buffer)
            val loadTime = buffer.readLong()
            val isCold = buffer.readBool()
            return LoadResult(loadTime, isCold).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: LoadResult)  {
            value.rdid.write(buffer)
            buffer.writeLong(value.loadTime)
            buffer.writeBool(value.isCold)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("LoadResult (")
        printer.indent {
            print("loadTime = "); loadTime.print(printer); println()
            print("isCold = "); isCold.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): LoadResult   {
        return LoadResult(
            loadTime,
            isCold
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class MarkupDiagnostics private constructor(
    private val _isDebugMode: RdOptionalProperty<Boolean>,
    private val _dumpAllHighlighters: RdCall<Int, HighlighterList>,
    private val _dumpMarkupInfo: RdCall<Int, MarkupDumpInfo>,
    key: String
) : MarkupModelExtension (
    key
) {
    //companion
    
    companion object : IMarshaller<MarkupDiagnostics> {
        override val _type: KClass<MarkupDiagnostics> = MarkupDiagnostics::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): MarkupDiagnostics  {
            val _id = RdId.read(buffer)
            val key = buffer.readString()
            val _isDebugMode = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _dumpAllHighlighters = RdCall.read(ctx, buffer, FrameworkMarshallers.Int, HighlighterList)
            val _dumpMarkupInfo = RdCall.read(ctx, buffer, FrameworkMarshallers.Int, MarkupDumpInfo)
            return MarkupDiagnostics(_isDebugMode, _dumpAllHighlighters, _dumpMarkupInfo, key).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: MarkupDiagnostics)  {
            value.rdid.write(buffer)
            buffer.writeString(value.key)
            RdOptionalProperty.write(ctx, buffer, value._isDebugMode)
            RdCall.write(ctx, buffer, value._dumpAllHighlighters)
            RdCall.write(ctx, buffer, value._dumpMarkupInfo)
        }
        
        
    }
    //fields
    val isDebugMode: IOptProperty<Boolean> get() = _isDebugMode
    val dumpAllHighlighters: RdCall<Int, HighlighterList> get() = _dumpAllHighlighters
    val dumpMarkupInfo: RdCall<Int, MarkupDumpInfo> get() = _dumpMarkupInfo
    //methods
    //initializer
    init {
        _isDebugMode.optimizeNested = true
    }
    
    init {
        bindableChildren.add("isDebugMode" to _isDebugMode)
        bindableChildren.add("dumpAllHighlighters" to _dumpAllHighlighters)
        bindableChildren.add("dumpMarkupInfo" to _dumpMarkupInfo)
    }
    
    //secondary constructor
    constructor(
        key: String
    ) : this(
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdCall<Int, HighlighterList>(FrameworkMarshallers.Int, HighlighterList),
        RdCall<Int, MarkupDumpInfo>(FrameworkMarshallers.Int, MarkupDumpInfo),
        key
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("MarkupDiagnostics (")
        printer.indent {
            print("isDebugMode = "); _isDebugMode.print(printer); println()
            print("dumpAllHighlighters = "); _dumpAllHighlighters.print(printer); println()
            print("dumpMarkupInfo = "); _dumpMarkupInfo.print(printer); println()
            print("key = "); key.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): MarkupDiagnostics   {
        return MarkupDiagnostics(
            _isDebugMode.deepClonePolymorphic(),
            _dumpAllHighlighters.deepClonePolymorphic(),
            _dumpMarkupInfo.deepClonePolymorphic(),
            key
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class MarkupDumpInfo (
    val allIds: HighlighterIdList,
    val highlighterCounter: Int,
    val documentTimestamp: AbstractDocumentVersion
) : IPrintable {
    //companion
    
    companion object : IMarshaller<MarkupDumpInfo> {
        override val _type: KClass<MarkupDumpInfo> = MarkupDumpInfo::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): MarkupDumpInfo  {
            val allIds = HighlighterIdList.read(ctx, buffer)
            val highlighterCounter = buffer.readInt()
            val documentTimestamp = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            return MarkupDumpInfo(allIds, highlighterCounter, documentTimestamp)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: MarkupDumpInfo)  {
            HighlighterIdList.write(ctx, buffer, value.allIds)
            buffer.writeInt(value.highlighterCounter)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentTimestamp)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as MarkupDumpInfo
        
        if (allIds != other.allIds) return false
        if (highlighterCounter != other.highlighterCounter) return false
        if (documentTimestamp != other.documentTimestamp) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + allIds.hashCode()
        __r = __r*31 + highlighterCounter.hashCode()
        __r = __r*31 + documentTimestamp.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("MarkupDumpInfo (")
        printer.indent {
            print("allIds = "); allIds.print(printer); println()
            print("highlighterCounter = "); highlighterCounter.print(printer); println()
            print("documentTimestamp = "); documentTimestamp.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class MarkupModelExtension (
    val key: String
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<MarkupModelExtension> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): MarkupModelExtension  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val key = buffer.readString()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return MarkupModelExtension_Unknown(key, unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class MarkupModelExtension_Unknown (
    key: String,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : MarkupModelExtension (
    key
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<MarkupModelExtension_Unknown> {
        override val _type: KClass<MarkupModelExtension_Unknown> = MarkupModelExtension_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): MarkupModelExtension_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: MarkupModelExtension_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeString(value.key)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("MarkupModelExtension_Unknown (")
        printer.indent {
            print("key = "); key.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): MarkupModelExtension_Unknown   {
        return MarkupModelExtension_Unknown(
            key,
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class MatchedBraceLineMarkerModel (
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<MatchedBraceLineMarkerModel> {
        override val _type: KClass<MatchedBraceLineMarkerModel> = MatchedBraceLineMarkerModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): MatchedBraceLineMarkerModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            return MatchedBraceLineMarkerModel(layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: MatchedBraceLineMarkerModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as MatchedBraceLineMarkerModel
        
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("MatchedBraceLineMarkerModel (")
        printer.indent {
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class MethodSeparatorHighlighterModel (
    val placement: MethodSeparatorPlacement,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<MethodSeparatorHighlighterModel> {
        override val _type: KClass<MethodSeparatorHighlighterModel> = MethodSeparatorHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): MethodSeparatorHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val placement = buffer.readEnum<MethodSeparatorPlacement>()
            return MethodSeparatorHighlighterModel(placement, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: MethodSeparatorHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeEnum(value.placement)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as MethodSeparatorHighlighterModel
        
        if (placement != other.placement) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + placement.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("MethodSeparatorHighlighterModel (")
        printer.indent {
            print("placement = "); placement.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
enum class MethodSeparatorPlacement {
    TOP, 
    BOTTOM;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<MethodSeparatorPlacement>()
        
    }
}


/**
 * #### Generated from [SolutionModel.kt]
 */
enum class MouseButtonKind {
    BUTTON1, 
    BUTTON2, 
    BUTTON3;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<MouseButtonKind>()
        
    }
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class Navigation (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<Navigation> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): Navigation  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return Navigation_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class NavigationByFileId (
    val fileId: RdFileId,
    val offset: Int
) : Navigation (
) {
    //companion
    
    companion object : IMarshaller<NavigationByFileId> {
        override val _type: KClass<NavigationByFileId> = NavigationByFileId::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NavigationByFileId  {
            val fileId = ctx.serializers.readPolymorphic<RdFileId>(ctx, buffer, RdFileId)
            val offset = buffer.readInt()
            return NavigationByFileId(fileId, offset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NavigationByFileId)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.fileId)
            buffer.writeInt(value.offset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as NavigationByFileId
        
        if (fileId != other.fileId) return false
        if (offset != other.offset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fileId.hashCode()
        __r = __r*31 + offset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NavigationByFileId (")
        printer.indent {
            print("fileId = "); fileId.print(printer); println()
            print("offset = "); offset.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class NavigationByPath (
    val pathToFile: String,
    val offset: Int
) : Navigation (
) {
    //companion
    
    companion object : IMarshaller<NavigationByPath> {
        override val _type: KClass<NavigationByPath> = NavigationByPath::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NavigationByPath  {
            val pathToFile = buffer.readString()
            val offset = buffer.readInt()
            return NavigationByPath(pathToFile, offset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NavigationByPath)  {
            buffer.writeString(value.pathToFile)
            buffer.writeInt(value.offset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as NavigationByPath
        
        if (pathToFile != other.pathToFile) return false
        if (offset != other.offset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + pathToFile.hashCode()
        __r = __r*31 + offset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NavigationByPath (")
        printer.indent {
            print("pathToFile = "); pathToFile.print(printer); println()
            print("offset = "); offset.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


class Navigation_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : Navigation (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<Navigation_Unknown> {
        override val _type: KClass<Navigation_Unknown> = Navigation_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): Navigation_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: Navigation_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as Navigation_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("Navigation_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class NotCalculatedTooltipModel (
) : TooltipModel (
) {
    //companion
    
    companion object : IMarshaller<NotCalculatedTooltipModel> {
        override val _type: KClass<NotCalculatedTooltipModel> = NotCalculatedTooltipModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NotCalculatedTooltipModel  {
            return NotCalculatedTooltipModel()
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NotCalculatedTooltipModel)  {
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as NotCalculatedTooltipModel
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NotCalculatedTooltipModel (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class NotificationPanelCallbackHyperlinkModel private constructor(
    private val _clicked: RdSignal<Unit>,
    text: String,
    closeAfterClick: Boolean
) : NotificationPanelHyperlinkModel (
    text,
    closeAfterClick
) {
    //companion
    
    companion object : IMarshaller<NotificationPanelCallbackHyperlinkModel> {
        override val _type: KClass<NotificationPanelCallbackHyperlinkModel> = NotificationPanelCallbackHyperlinkModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NotificationPanelCallbackHyperlinkModel  {
            val _id = RdId.read(buffer)
            val text = buffer.readString()
            val closeAfterClick = buffer.readBool()
            val _clicked = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return NotificationPanelCallbackHyperlinkModel(_clicked, text, closeAfterClick).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NotificationPanelCallbackHyperlinkModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.text)
            buffer.writeBool(value.closeAfterClick)
            RdSignal.write(ctx, buffer, value._clicked)
        }
        
        
    }
    //fields
    val clicked: ISignal<Unit> get() = _clicked
    //methods
    //initializer
    init {
        bindableChildren.add("clicked" to _clicked)
    }
    
    //secondary constructor
    constructor(
        text: String,
        closeAfterClick: Boolean
    ) : this(
        RdSignal<Unit>(FrameworkMarshallers.Void),
        text,
        closeAfterClick
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NotificationPanelCallbackHyperlinkModel (")
        printer.indent {
            print("clicked = "); _clicked.print(printer); println()
            print("text = "); text.print(printer); println()
            print("closeAfterClick = "); closeAfterClick.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): NotificationPanelCallbackHyperlinkModel   {
        return NotificationPanelCallbackHyperlinkModel(
            _clicked.deepClonePolymorphic(),
            text,
            closeAfterClick
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class NotificationPanelHyperlinkModel (
    val text: String,
    val closeAfterClick: Boolean
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<NotificationPanelHyperlinkModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): NotificationPanelHyperlinkModel  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val text = buffer.readString()
            val closeAfterClick = buffer.readBool()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return NotificationPanelHyperlinkModel_Unknown(text, closeAfterClick, unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class NotificationPanelHyperlinkModel_Unknown (
    text: String,
    closeAfterClick: Boolean,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : NotificationPanelHyperlinkModel (
    text,
    closeAfterClick
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<NotificationPanelHyperlinkModel_Unknown> {
        override val _type: KClass<NotificationPanelHyperlinkModel_Unknown> = NotificationPanelHyperlinkModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NotificationPanelHyperlinkModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NotificationPanelHyperlinkModel_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeString(value.text)
            buffer.writeBool(value.closeAfterClick)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NotificationPanelHyperlinkModel_Unknown (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("closeAfterClick = "); closeAfterClick.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): NotificationPanelHyperlinkModel_Unknown   {
        return NotificationPanelHyperlinkModel_Unknown(
            text,
            closeAfterClick,
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class NotificationPanelModel (
    val id: String,
    val message: String,
    val links: Array<NotificationPanelHyperlinkModel>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<NotificationPanelModel> {
        override val _type: KClass<NotificationPanelModel> = NotificationPanelModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NotificationPanelModel  {
            val _id = RdId.read(buffer)
            val id = buffer.readString()
            val message = buffer.readString()
            val links = buffer.readArray {ctx.serializers.readPolymorphic<NotificationPanelHyperlinkModel>(ctx, buffer, NotificationPanelHyperlinkModel)}
            return NotificationPanelModel(id, message, links).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NotificationPanelModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.id)
            buffer.writeString(value.message)
            buffer.writeArray(value.links) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("links" to links)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NotificationPanelModel (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("message = "); message.print(printer); println()
            print("links = "); links.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): NotificationPanelModel   {
        return NotificationPanelModel(
            id,
            message,
            links.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class NotificationPanelOpenSettingsHyperlinkModel (
    val configurableId: String,
    text: String,
    closeAfterClick: Boolean
) : NotificationPanelHyperlinkModel (
    text,
    closeAfterClick
) {
    //companion
    
    companion object : IMarshaller<NotificationPanelOpenSettingsHyperlinkModel> {
        override val _type: KClass<NotificationPanelOpenSettingsHyperlinkModel> = NotificationPanelOpenSettingsHyperlinkModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): NotificationPanelOpenSettingsHyperlinkModel  {
            val _id = RdId.read(buffer)
            val text = buffer.readString()
            val closeAfterClick = buffer.readBool()
            val configurableId = buffer.readString()
            return NotificationPanelOpenSettingsHyperlinkModel(configurableId, text, closeAfterClick).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: NotificationPanelOpenSettingsHyperlinkModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.text)
            buffer.writeBool(value.closeAfterClick)
            buffer.writeString(value.configurableId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("NotificationPanelOpenSettingsHyperlinkModel (")
        printer.indent {
            print("configurableId = "); configurableId.print(printer); println()
            print("text = "); text.print(printer); println()
            print("closeAfterClick = "); closeAfterClick.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): NotificationPanelOpenSettingsHyperlinkModel   {
        return NotificationPanelOpenSettingsHyperlinkModel(
            configurableId,
            text,
            closeAfterClick
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class OccurrenceHighlighterModel (
    val flags: Int,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<OccurrenceHighlighterModel> {
        override val _type: KClass<OccurrenceHighlighterModel> = OccurrenceHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): OccurrenceHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val flags = buffer.readInt()
            return OccurrenceHighlighterModel(flags, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: OccurrenceHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeInt(value.flags)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as OccurrenceHighlighterModel
        
        if (flags != other.flags) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + flags.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("OccurrenceHighlighterModel (")
        printer.indent {
            print("flags = "); flags.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class Operation (
    val timestamp: Int
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<Operation> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): Operation  {
            val objectStartPosition = buffer.position
            val timestamp = buffer.readInt()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return Operation_Unknown(timestamp, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class Operation_Unknown (
    timestamp: Int,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : Operation (
    timestamp
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<Operation_Unknown> {
        override val _type: KClass<Operation_Unknown> = Operation_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): Operation_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: Operation_Unknown)  {
            buffer.writeInt(value.timestamp)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as Operation_Unknown
        
        if (timestamp != other.timestamp) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + timestamp.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("Operation_Unknown (")
        printer.indent {
            print("timestamp = "); timestamp.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
enum class OriginKind {
    Backend, 
    Frontend;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<OriginKind>()
        
    }
}


/**
 * A question action (e.g. auto-import popup)
 * @property caption HTML displayed to the user
 * #### Generated from [SolutionModel.kt]
 */
class PopupActionModel private constructor(
    val startOffset: Int,
    val endOffset: Int,
    val caption: String,
    val icon: IconModel?,
    val timestamps: List<com.jetbrains.ide.model.uicontext.ContextPair>,
    val textControlId: TextControlId,
    private val _actionExecuted: RdSignal<List<RdDataConstant>>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<PopupActionModel> {
        override val _type: KClass<PopupActionModel> = PopupActionModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): PopupActionModel  {
            val _id = RdId.read(buffer)
            val startOffset = buffer.readInt()
            val endOffset = buffer.readInt()
            val caption = buffer.readString()
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val timestamps = buffer.readList { com.jetbrains.ide.model.uicontext.ContextPair.read(ctx, buffer) }
            val textControlId = TextControlId.read(ctx, buffer)
            val _actionExecuted = RdSignal.read(ctx, buffer, __RdDataConstantListSerializer)
            return PopupActionModel(startOffset, endOffset, caption, icon, timestamps, textControlId, _actionExecuted).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: PopupActionModel)  {
            value.rdid.write(buffer)
            buffer.writeInt(value.startOffset)
            buffer.writeInt(value.endOffset)
            buffer.writeString(value.caption)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeList(value.timestamps) { v -> com.jetbrains.ide.model.uicontext.ContextPair.write(ctx, buffer, v) }
            TextControlId.write(ctx, buffer, value.textControlId)
            RdSignal.write(ctx, buffer, value._actionExecuted)
        }
        
        private val __RdDataConstantListSerializer = AbstractPolymorphic(RdDataConstant).list()
        
    }
    //fields
    val actionExecuted: ISignal<List<RdDataConstant>> get() = _actionExecuted
    //methods
    //initializer
    init {
        bindableChildren.add("actionExecuted" to _actionExecuted)
    }
    
    //secondary constructor
    constructor(
        startOffset: Int,
        endOffset: Int,
        caption: String,
        icon: IconModel?,
        timestamps: List<com.jetbrains.ide.model.uicontext.ContextPair>,
        textControlId: TextControlId
    ) : this(
        startOffset,
        endOffset,
        caption,
        icon,
        timestamps,
        textControlId,
        RdSignal<List<RdDataConstant>>(__RdDataConstantListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("PopupActionModel (")
        printer.indent {
            print("startOffset = "); startOffset.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
            print("caption = "); caption.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("timestamps = "); timestamps.print(printer); println()
            print("textControlId = "); textControlId.print(printer); println()
            print("actionExecuted = "); _actionExecuted.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): PopupActionModel   {
        return PopupActionModel(
            startOffset,
            endOffset,
            caption,
            icon,
            timestamps,
            textControlId,
            _actionExecuted.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * An id of a document which isn't created from a file
 * @property descriptor A unique document identifier. It's can be a UUID, a file path, etc. One shouldn't rely on the inner structure on the descriptor
 * #### Generated from [SolutionModel.kt]
 */
class RdAbstractDocumentId (
    val descriptor: String
) : RdDocumentId (
) {
    //companion
    
    companion object : IMarshaller<RdAbstractDocumentId> {
        override val _type: KClass<RdAbstractDocumentId> = RdAbstractDocumentId::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdAbstractDocumentId  {
            val descriptor = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            return RdAbstractDocumentId(descriptor)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdAbstractDocumentId)  {
            ctx.writeInterned(buffer, value.descriptor, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdAbstractDocumentId
        
        if (descriptor != other.descriptor) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + descriptor.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdAbstractDocumentId (")
        printer.indent {
            print("descriptor = "); descriptor.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdAbstractEditorVersion (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdAbstractEditorVersion> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdAbstractEditorVersion  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdAbstractEditorVersion_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdAbstractEditorVersion_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdAbstractEditorVersion (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdAbstractEditorVersion_Unknown> {
        override val _type: KClass<RdAbstractEditorVersion_Unknown> = RdAbstractEditorVersion_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdAbstractEditorVersion_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdAbstractEditorVersion_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdAbstractEditorVersion_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdAbstractEditorVersion_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdActionGroupStep (
    val actionModel: ActionRegistrationModel,
    editorId: TextControlId
) : RdEditorFeatureStep (
    editorId
) {
    //companion
    
    companion object : IMarshaller<RdActionGroupStep> {
        override val _type: KClass<RdActionGroupStep> = RdActionGroupStep::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdActionGroupStep  {
            val editorId = TextControlId.read(ctx, buffer)
            val actionModel = ctx.serializers.readPolymorphic<ActionRegistrationModel>(ctx, buffer, ActionRegistrationModel)
            return RdActionGroupStep(actionModel, editorId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdActionGroupStep)  {
            TextControlId.write(ctx, buffer, value.editorId)
            ctx.serializers.writePolymorphic(ctx, buffer, value.actionModel)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdActionGroupStep
        
        if (actionModel != other.actionModel) return false
        if (editorId != other.editorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + actionModel.hashCode()
        __r = __r*31 + editorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdActionGroupStep (")
        printer.indent {
            print("actionModel = "); actionModel.print(printer); println()
            print("editorId = "); editorId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdAddHistoryItemToTop (
    val string: String
) : RdClipboardChange (
) {
    //companion
    
    companion object : IMarshaller<RdAddHistoryItemToTop> {
        override val _type: KClass<RdAddHistoryItemToTop> = RdAddHistoryItemToTop::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdAddHistoryItemToTop  {
            val string = buffer.readString()
            return RdAddHistoryItemToTop(string)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdAddHistoryItemToTop)  {
            buffer.writeString(value.string)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdAddHistoryItemToTop
        
        if (string != other.string) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + string.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdAddHistoryItemToTop (")
        printer.indent {
            print("string = "); string.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdApplyPathRequest (
    val patch: RdPatch,
    id: Int
) : RdRequest (
    id
) {
    //companion
    
    companion object : IMarshaller<RdApplyPathRequest> {
        override val _type: KClass<RdApplyPathRequest> = RdApplyPathRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdApplyPathRequest  {
            val id = buffer.readInt()
            val patch = RdPatch.read(ctx, buffer)
            return RdApplyPathRequest(patch, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdApplyPathRequest)  {
            buffer.writeInt(value.id)
            RdPatch.write(ctx, buffer, value.patch)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdApplyPathRequest
        
        if (patch != other.patch) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + patch.hashCode()
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdApplyPathRequest (")
        printer.indent {
            print("patch = "); patch.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdAsyncDocumentModel private constructor(
    private val _requests: RdSignal<List<RdRequest>>,
    private val _responses: RdSignal<List<RdResponse>>,
    private val _backendPatches: RdSignal<RdPatch>,
    private val _lastDocumentVersion: RdSignal<LastDocumentVersion>,
    private val _getEditorStates: RdCall<List<TextControlId>, RdPatch>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdAsyncDocumentModel> {
        override val _type: KClass<RdAsyncDocumentModel> = RdAsyncDocumentModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdAsyncDocumentModel  {
            val _id = RdId.read(buffer)
            val _requests = RdSignal.read(ctx, buffer, __RdRequestListSerializer)
            val _responses = RdSignal.read(ctx, buffer, __RdResponseListSerializer)
            val _backendPatches = RdSignal.read(ctx, buffer, RdPatch)
            val _lastDocumentVersion = RdSignal.read(ctx, buffer, LastDocumentVersion)
            val _getEditorStates = RdCall.read(ctx, buffer, __TextControlIdListSerializer, RdPatch)
            return RdAsyncDocumentModel(_requests, _responses, _backendPatches, _lastDocumentVersion, _getEditorStates).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdAsyncDocumentModel)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._requests)
            RdSignal.write(ctx, buffer, value._responses)
            RdSignal.write(ctx, buffer, value._backendPatches)
            RdSignal.write(ctx, buffer, value._lastDocumentVersion)
            RdCall.write(ctx, buffer, value._getEditorStates)
        }
        
        private val __RdRequestListSerializer = AbstractPolymorphic(RdRequest).list()
        private val __RdResponseListSerializer = AbstractPolymorphic(RdResponse).list()
        private val __TextControlIdListSerializer = TextControlId.list()
        
    }
    //fields
    val requests: ISignal<List<RdRequest>> get() = _requests
    val responses: ISignal<List<RdResponse>> get() = _responses
    val backendPatches: ISignal<RdPatch> get() = _backendPatches
    val lastDocumentVersion: ISignal<LastDocumentVersion> get() = _lastDocumentVersion
    
    /**
     * Gets editors states from server if something goes wrong
     */
    val getEditorStates: RdCall<List<TextControlId>, RdPatch> get() = _getEditorStates
    //methods
    //initializer
    init {
        _getEditorStates.async = true
    }
    
    init {
        bindableChildren.add("requests" to _requests)
        bindableChildren.add("responses" to _responses)
        bindableChildren.add("backendPatches" to _backendPatches)
        bindableChildren.add("lastDocumentVersion" to _lastDocumentVersion)
        bindableChildren.add("getEditorStates" to _getEditorStates)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdSignal<List<RdRequest>>(__RdRequestListSerializer),
        RdSignal<List<RdResponse>>(__RdResponseListSerializer),
        RdSignal<RdPatch>(RdPatch),
        RdSignal<LastDocumentVersion>(LastDocumentVersion),
        RdCall<List<TextControlId>, RdPatch>(__TextControlIdListSerializer, RdPatch)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdAsyncDocumentModel (")
        printer.indent {
            print("requests = "); _requests.print(printer); println()
            print("responses = "); _responses.print(printer); println()
            print("backendPatches = "); _backendPatches.print(printer); println()
            print("lastDocumentVersion = "); _lastDocumentVersion.print(printer); println()
            print("getEditorStates = "); _getEditorStates.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdAsyncDocumentModel   {
        return RdAsyncDocumentModel(
            _requests.deepClonePolymorphic(),
            _responses.deepClonePolymorphic(),
            _backendPatches.deepClonePolymorphic(),
            _lastDocumentVersion.deepClonePolymorphic(),
            _getEditorStates.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdCLionSolution (
    val rootDirectory: String
) : RdSolutionDescription (
) {
    //companion
    
    companion object : IMarshaller<RdCLionSolution> {
        override val _type: KClass<RdCLionSolution> = RdCLionSolution::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCLionSolution  {
            val rootDirectory = buffer.readString()
            return RdCLionSolution(rootDirectory)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCLionSolution)  {
            buffer.writeString(value.rootDirectory)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCLionSolution
        
        if (rootDirectory != other.rootDirectory) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + rootDirectory.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCLionSolution (")
        printer.indent {
            print("rootDirectory = "); rootDirectory.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdCallEditorActionRequest (
    val actionId: String,
    val editorId: TextControlId,
    id: Int
) : RdRequest (
    id
) {
    //companion
    
    companion object : IMarshaller<RdCallEditorActionRequest> {
        override val _type: KClass<RdCallEditorActionRequest> = RdCallEditorActionRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCallEditorActionRequest  {
            val id = buffer.readInt()
            val actionId = buffer.readString()
            val editorId = TextControlId.read(ctx, buffer)
            return RdCallEditorActionRequest(actionId, editorId, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCallEditorActionRequest)  {
            buffer.writeInt(value.id)
            buffer.writeString(value.actionId)
            TextControlId.write(ctx, buffer, value.editorId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCallEditorActionRequest
        
        if (actionId != other.actionId) return false
        if (editorId != other.editorId) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + editorId.hashCode()
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCallEditorActionRequest (")
        printer.indent {
            print("actionId = "); actionId.print(printer); println()
            print("editorId = "); editorId.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdCaret (
    val id: RdCaretId,
    val offset: DocOffsetAndVirtualModel,
    val selection: RdSelection
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdCaret> {
        override val _type: KClass<RdCaret> = RdCaret::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCaret  {
            val id = RdCaretId.read(ctx, buffer)
            val offset = DocOffsetAndVirtualModel.read(ctx, buffer)
            val selection = RdSelection.read(ctx, buffer)
            return RdCaret(id, offset, selection)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCaret)  {
            RdCaretId.write(ctx, buffer, value.id)
            DocOffsetAndVirtualModel.write(ctx, buffer, value.offset)
            RdSelection.write(ctx, buffer, value.selection)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCaret
        
        if (id != other.id) return false
        if (offset != other.offset) return false
        if (selection != other.selection) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + offset.hashCode()
        __r = __r*31 + selection.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCaret (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("offset = "); offset.print(printer); println()
            print("selection = "); selection.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdCaretId (
    val isClient: Boolean,
    val number: Long
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdCaretId> {
        override val _type: KClass<RdCaretId> = RdCaretId::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCaretId  {
            val isClient = buffer.readBool()
            val number = buffer.readLong()
            return RdCaretId(isClient, number)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCaretId)  {
            buffer.writeBool(value.isClient)
            buffer.writeLong(value.number)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCaretId
        
        if (isClient != other.isClient) return false
        if (number != other.number) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + isClient.hashCode()
        __r = __r*31 + number.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCaretId (")
        printer.indent {
            print("isClient = "); isClient.print(printer); println()
            print("number = "); number.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
interface RdCaretModelChange
{
}

/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdCaretState (
    val primaryCaretId: RdCaretId,
    val carets: List<RdCaret>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdCaretState> {
        override val _type: KClass<RdCaretState> = RdCaretState::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCaretState  {
            val primaryCaretId = RdCaretId.read(ctx, buffer)
            val carets = buffer.readList { RdCaret.read(ctx, buffer) }
            return RdCaretState(primaryCaretId, carets)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCaretState)  {
            RdCaretId.write(ctx, buffer, value.primaryCaretId)
            buffer.writeList(value.carets) { v -> RdCaret.write(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCaretState
        
        if (primaryCaretId != other.primaryCaretId) return false
        if (carets != other.carets) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + primaryCaretId.hashCode()
        __r = __r*31 + carets.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCaretState (")
        printer.indent {
            print("primaryCaretId = "); primaryCaretId.print(printer); println()
            print("carets = "); carets.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdCaretStateChange (
    val oldState: RdCaretState,
    val newState: RdCaretState,
    editorId: TextControlId
) : RdSelectionChangeBase (
    editorId
) {
    //companion
    
    companion object : IMarshaller<RdCaretStateChange> {
        override val _type: KClass<RdCaretStateChange> = RdCaretStateChange::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCaretStateChange  {
            val editorId = TextControlId.read(ctx, buffer)
            val oldState = RdCaretState.read(ctx, buffer)
            val newState = RdCaretState.read(ctx, buffer)
            return RdCaretStateChange(oldState, newState, editorId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCaretStateChange)  {
            TextControlId.write(ctx, buffer, value.editorId)
            RdCaretState.write(ctx, buffer, value.oldState)
            RdCaretState.write(ctx, buffer, value.newState)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCaretStateChange
        
        if (oldState != other.oldState) return false
        if (newState != other.newState) return false
        if (editorId != other.editorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + oldState.hashCode()
        __r = __r*31 + newState.hashCode()
        __r = __r*31 + editorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCaretStateChange (")
        printer.indent {
            print("oldState = "); oldState.print(printer); println()
            print("newState = "); newState.print(printer); println()
            print("editorId = "); editorId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdCaretStateSnapshot (
    val state: RdCaretState,
    editorId: TextControlId
) : RdSelectionChangeBase (
    editorId
) {
    //companion
    
    companion object : IMarshaller<RdCaretStateSnapshot> {
        override val _type: KClass<RdCaretStateSnapshot> = RdCaretStateSnapshot::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCaretStateSnapshot  {
            val editorId = TextControlId.read(ctx, buffer)
            val state = RdCaretState.read(ctx, buffer)
            return RdCaretStateSnapshot(state, editorId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCaretStateSnapshot)  {
            TextControlId.write(ctx, buffer, value.editorId)
            RdCaretState.write(ctx, buffer, value.state)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCaretStateSnapshot
        
        if (state != other.state) return false
        if (editorId != other.editorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + state.hashCode()
        __r = __r*31 + editorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCaretStateSnapshot (")
        printer.indent {
            print("state = "); state.print(printer); println()
            print("editorId = "); editorId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdClipboardChange (
) : RdPatchStep (
) {
    //companion
    
    companion object : IAbstractDeclaration<RdClipboardChange> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdClipboardChange  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdClipboardChange_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdClipboardChange_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdClipboardChange (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdClipboardChange_Unknown> {
        override val _type: KClass<RdClipboardChange_Unknown> = RdClipboardChange_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdClipboardChange_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdClipboardChange_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdClipboardChange_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdClipboardChange_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdCodeWithMeProject (
    val projectName: String,
    val hostUserName: String
) : RdSolutionDescription (
) {
    //companion
    
    companion object : IMarshaller<RdCodeWithMeProject> {
        override val _type: KClass<RdCodeWithMeProject> = RdCodeWithMeProject::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCodeWithMeProject  {
            val projectName = buffer.readString()
            val hostUserName = buffer.readString()
            return RdCodeWithMeProject(projectName, hostUserName)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCodeWithMeProject)  {
            buffer.writeString(value.projectName)
            buffer.writeString(value.hostUserName)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCodeWithMeProject
        
        if (projectName != other.projectName) return false
        if (hostUserName != other.hostUserName) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + projectName.hashCode()
        __r = __r*31 + hostUserName.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCodeWithMeProject (")
        printer.indent {
            print("projectName = "); projectName.print(printer); println()
            print("hostUserName = "); hostUserName.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdCollectClipboardHistory (
    val lastKnownId: Int
) : RdClipboardChange (
) {
    //companion
    
    companion object : IMarshaller<RdCollectClipboardHistory> {
        override val _type: KClass<RdCollectClipboardHistory> = RdCollectClipboardHistory::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCollectClipboardHistory  {
            val lastKnownId = buffer.readInt()
            return RdCollectClipboardHistory(lastKnownId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCollectClipboardHistory)  {
            buffer.writeInt(value.lastKnownId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCollectClipboardHistory
        
        if (lastKnownId != other.lastKnownId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + lastKnownId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCollectClipboardHistory (")
        printer.indent {
            print("lastKnownId = "); lastKnownId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdColoredFragment (
    val text: String,
    val tooltip: String?,
    val attributes: RdSimpleTextAttributes
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdColoredFragment> {
        override val _type: KClass<RdColoredFragment> = RdColoredFragment::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdColoredFragment  {
            val text = buffer.readString()
            val tooltip = buffer.readNullable { buffer.readString() }
            val attributes = RdSimpleTextAttributes.read(ctx, buffer)
            return RdColoredFragment(text, tooltip, attributes)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdColoredFragment)  {
            buffer.writeString(value.text)
            buffer.writeNullable(value.tooltip) { buffer.writeString(it) }
            RdSimpleTextAttributes.write(ctx, buffer, value.attributes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdColoredFragment
        
        if (text != other.text) return false
        if (tooltip != other.tooltip) return false
        if (attributes != other.attributes) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + if (tooltip != null) tooltip.hashCode() else 0
        __r = __r*31 + attributes.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdColoredFragment (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("tooltip = "); tooltip.print(printer); println()
            print("attributes = "); attributes.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdCommandProcessor private constructor(
    private val _currentCommand: RdProperty<CommandDescriptor?>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdCommandProcessor> {
        override val _type: KClass<RdCommandProcessor> = RdCommandProcessor::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCommandProcessor  {
            val _id = RdId.read(buffer)
            val _currentCommand = RdProperty.read(ctx, buffer, __CommandDescriptorNullableSerializer)
            return RdCommandProcessor(_currentCommand).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCommandProcessor)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._currentCommand)
        }
        
        private val __CommandDescriptorNullableSerializer = CommandDescriptor.nullable()
        
    }
    //fields
    val currentCommand: IProperty<CommandDescriptor?> get() = _currentCommand
    //methods
    //initializer
    init {
        _currentCommand.optimizeNested = true
    }
    
    init {
        bindableChildren.add("currentCommand" to _currentCommand)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdProperty<CommandDescriptor?>(null, __CommandDescriptorNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCommandProcessor (")
        printer.indent {
            print("currentCommand = "); _currentCommand.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdCommandProcessor   {
        return RdCommandProcessor(
            _currentCommand.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdCompleteItemRequest (
    val char: Char,
    val editorId: TextControlId,
    val item: CompletionItem,
    id: Int
) : RdRequest (
    id
) {
    //companion
    
    companion object : IMarshaller<RdCompleteItemRequest> {
        override val _type: KClass<RdCompleteItemRequest> = RdCompleteItemRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCompleteItemRequest  {
            val id = buffer.readInt()
            val char = buffer.readChar()
            val editorId = TextControlId.read(ctx, buffer)
            val item = CompletionItem.read(ctx, buffer)
            return RdCompleteItemRequest(char, editorId, item, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCompleteItemRequest)  {
            buffer.writeInt(value.id)
            buffer.writeChar(value.char)
            TextControlId.write(ctx, buffer, value.editorId)
            CompletionItem.write(ctx, buffer, value.item)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdCompleteItemRequest
        
        if (char != other.char) return false
        if (editorId != other.editorId) return false
        if (item != other.item) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + char.hashCode()
        __r = __r*31 + editorId.hashCode()
        __r = __r*31 + item.hashCode()
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCompleteItemRequest (")
        printer.indent {
            print("char = "); char.print(printer); println()
            print("editorId = "); editorId.print(printer); println()
            print("item = "); item.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdConfigurationAndPlatform (
    val configuration: String,
    val platform: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdConfigurationAndPlatform> {
        override val _type: KClass<RdConfigurationAndPlatform> = RdConfigurationAndPlatform::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdConfigurationAndPlatform  {
            val configuration = buffer.readString()
            val platform = buffer.readString()
            return RdConfigurationAndPlatform(configuration, platform)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdConfigurationAndPlatform)  {
            buffer.writeString(value.configuration)
            buffer.writeString(value.platform)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdConfigurationAndPlatform
        
        if (configuration != other.configuration) return false
        if (platform != other.platform) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + configuration.hashCode()
        __r = __r*31 + platform.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdConfigurationAndPlatform (")
        printer.indent {
            print("configuration = "); configuration.print(printer); println()
            print("platform = "); platform.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdCustomData private constructor(
    private val _data: RdMap<String, String>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdCustomData> {
        override val _type: KClass<RdCustomData> = RdCustomData::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdCustomData  {
            val _id = RdId.read(buffer)
            val _data = RdMap.read(ctx, buffer, FrameworkMarshallers.String, FrameworkMarshallers.String)
            return RdCustomData(_data).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdCustomData)  {
            value.rdid.write(buffer)
            RdMap.write(ctx, buffer, value._data)
        }
        
        
    }
    //fields
    val `data`: IMutableViewableMap<String, String> get() = _data
    //methods
    //initializer
    init {
        _data.optimizeNested = true
    }
    
    init {
        bindableChildren.add("data" to _data)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdMap<String, String>(FrameworkMarshallers.String, FrameworkMarshallers.String)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdCustomData (")
        printer.indent {
            print("data = "); _data.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdCustomData   {
        return RdCustomData(
            _data.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdDaemonModel private constructor(
    private val _state: RdOptionalProperty<BackendDaemonStateEnum>,
    private val _highlightingProgressState: RdOptionalProperty<BackendHighlightingProgressStateEnum>,
    private val _message: RdProperty<String?>,
    private val _settings: RdOptionalProperty<HighlightingSettingsModel>,
    private val _restart: RdSignal<Unit>,
    private val _invalidateAll: RdSignal<Unit>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdDaemonModel> {
        override val _type: KClass<RdDaemonModel> = RdDaemonModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDaemonModel  {
            val _id = RdId.read(buffer)
            val _state = RdOptionalProperty.read(ctx, buffer, BackendDaemonStateEnum.marshaller)
            val _highlightingProgressState = RdOptionalProperty.read(ctx, buffer, BackendHighlightingProgressStateEnum.marshaller)
            val _message = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _settings = RdOptionalProperty.read(ctx, buffer, HighlightingSettingsModel)
            val _restart = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _invalidateAll = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return RdDaemonModel(_state, _highlightingProgressState, _message, _settings, _restart, _invalidateAll).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDaemonModel)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._state)
            RdOptionalProperty.write(ctx, buffer, value._highlightingProgressState)
            RdProperty.write(ctx, buffer, value._message)
            RdOptionalProperty.write(ctx, buffer, value._settings)
            RdSignal.write(ctx, buffer, value._restart)
            RdSignal.write(ctx, buffer, value._invalidateAll)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val state: IOptProperty<BackendDaemonStateEnum> get() = _state
    val highlightingProgressState: IOptProperty<BackendHighlightingProgressStateEnum> get() = _highlightingProgressState
    val message: IProperty<String?> get() = _message
    val settings: IOptProperty<HighlightingSettingsModel> get() = _settings
    val restart: ISignal<Unit> get() = _restart
    val invalidateAll: ISignal<Unit> get() = _invalidateAll
    //methods
    //initializer
    init {
        _state.optimizeNested = true
        _highlightingProgressState.optimizeNested = true
        _message.optimizeNested = true
        _settings.optimizeNested = true
    }
    
    init {
        bindableChildren.add("state" to _state)
        bindableChildren.add("highlightingProgressState" to _highlightingProgressState)
        bindableChildren.add("message" to _message)
        bindableChildren.add("settings" to _settings)
        bindableChildren.add("restart" to _restart)
        bindableChildren.add("invalidateAll" to _invalidateAll)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<BackendDaemonStateEnum>(BackendDaemonStateEnum.marshaller),
        RdOptionalProperty<BackendHighlightingProgressStateEnum>(BackendHighlightingProgressStateEnum.marshaller),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdOptionalProperty<HighlightingSettingsModel>(HighlightingSettingsModel),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdSignal<Unit>(FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDaemonModel (")
        printer.indent {
            print("state = "); _state.print(printer); println()
            print("highlightingProgressState = "); _highlightingProgressState.print(printer); println()
            print("message = "); _message.print(printer); println()
            print("settings = "); _settings.print(printer); println()
            print("restart = "); _restart.print(printer); println()
            print("invalidateAll = "); _invalidateAll.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdDaemonModel   {
        return RdDaemonModel(
            _state.deepClonePolymorphic(),
            _highlightingProgressState.deepClonePolymorphic(),
            _message.deepClonePolymorphic(),
            _settings.deepClonePolymorphic(),
            _restart.deepClonePolymorphic(),
            _invalidateAll.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * @property text Only for test purpose
 * #### Generated from [SolutionModel.kt]
 */
class RdDocumentChange (
    val documentId: RdDocumentId,
    val offset: Int,
    val moveOffset: Int,
    val newText: String,
    val oldText: String,
    val modificationKind: RdTextModificationKind,
    val oldDocumentLength: Int,
    val text: String?
) : RdPatchStep (
) {
    //companion
    
    companion object : IMarshaller<RdDocumentChange> {
        override val _type: KClass<RdDocumentChange> = RdDocumentChange::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDocumentChange  {
            val documentId = ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId)
            val offset = buffer.readInt()
            val moveOffset = buffer.readInt()
            val newText = buffer.readString()
            val oldText = buffer.readString()
            val modificationKind = buffer.readEnum<RdTextModificationKind>()
            val oldDocumentLength = buffer.readInt()
            val text = buffer.readNullable { buffer.readString() }
            return RdDocumentChange(documentId, offset, moveOffset, newText, oldText, modificationKind, oldDocumentLength, text)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDocumentChange)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentId)
            buffer.writeInt(value.offset)
            buffer.writeInt(value.moveOffset)
            buffer.writeString(value.newText)
            buffer.writeString(value.oldText)
            buffer.writeEnum(value.modificationKind)
            buffer.writeInt(value.oldDocumentLength)
            buffer.writeNullable(value.text) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDocumentChange
        
        if (documentId != other.documentId) return false
        if (offset != other.offset) return false
        if (moveOffset != other.moveOffset) return false
        if (newText != other.newText) return false
        if (oldText != other.oldText) return false
        if (modificationKind != other.modificationKind) return false
        if (oldDocumentLength != other.oldDocumentLength) return false
        if (text != other.text) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + documentId.hashCode()
        __r = __r*31 + offset.hashCode()
        __r = __r*31 + moveOffset.hashCode()
        __r = __r*31 + newText.hashCode()
        __r = __r*31 + oldText.hashCode()
        __r = __r*31 + modificationKind.hashCode()
        __r = __r*31 + oldDocumentLength.hashCode()
        __r = __r*31 + if (text != null) text.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDocumentChange (")
        printer.indent {
            print("documentId = "); documentId.print(printer); println()
            print("offset = "); offset.print(printer); println()
            print("moveOffset = "); moveOffset.print(printer); println()
            print("newText = "); newText.print(printer); println()
            print("oldText = "); oldText.print(printer); println()
            print("modificationKind = "); modificationKind.print(printer); println()
            print("oldDocumentLength = "); oldDocumentLength.print(printer); println()
            print("text = "); text.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * A base class for all possible document ids
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdDocumentId (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdDocumentId> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdDocumentId  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdDocumentId_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdDocumentIdWithFileId (
    val fileId: RdFileId
) : RdDocumentId (
) {
    //companion
    
    companion object : IMarshaller<RdDocumentIdWithFileId> {
        override val _type: KClass<RdDocumentIdWithFileId> = RdDocumentIdWithFileId::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDocumentIdWithFileId  {
            val fileId = ctx.serializers.readPolymorphic<RdFileId>(ctx, buffer, RdFileId)
            return RdDocumentIdWithFileId(fileId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDocumentIdWithFileId)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.fileId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDocumentIdWithFileId
        
        if (fileId != other.fileId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + fileId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDocumentIdWithFileId (")
        printer.indent {
            print("fileId = "); fileId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


class RdDocumentId_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdDocumentId (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdDocumentId_Unknown> {
        override val _type: KClass<RdDocumentId_Unknown> = RdDocumentId_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDocumentId_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDocumentId_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDocumentId_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDocumentId_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdDocumentModel private constructor(
    private val _textControls: RdMap<TextControlId, TextControlModel>,
    private val _text: com.jetbrains.rd.rdtext.impl.RdDeferrableTextBuffer,
    private val _markup: RdOptionalProperty<RdMarkupModelBase>,
    private val _compareAllTextTask: RdCall<Unit, String>,
    val sandboxInfo: AbstractSandboxInfo?,
    private val _crumbsSession: RdProperty<CrumbSession?>,
    val extensions: List<DocumentExtension>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdDocumentModel> {
        override val _type: KClass<RdDocumentModel> = RdDocumentModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDocumentModel  {
            val _id = RdId.read(buffer)
            val _textControls = RdMap.read(ctx, buffer, TextControlId, TextControlModel)
            val _text = com.jetbrains.rd.rdtext.impl.RdDeferrableTextBuffer(com.jetbrains.rd.rdtext.impl.intrinsics.RdTextBufferState.read(ctx, buffer))
            val _markup = RdOptionalProperty.read(ctx, buffer, AbstractPolymorphic(RdMarkupModelBase))
            val _compareAllTextTask = RdCall.read(ctx, buffer, FrameworkMarshallers.Void, FrameworkMarshallers.String)
            val sandboxInfo = buffer.readNullable { ctx.serializers.readPolymorphic<AbstractSandboxInfo>(ctx, buffer, AbstractSandboxInfo) }
            val _crumbsSession = RdProperty.read(ctx, buffer, __CrumbSessionNullableSerializer)
            val extensions = buffer.readList { ctx.serializers.readPolymorphic<DocumentExtension>(ctx, buffer, DocumentExtension) }
            return RdDocumentModel(_textControls, _text, _markup, _compareAllTextTask, sandboxInfo, _crumbsSession, extensions).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDocumentModel)  {
            value.rdid.write(buffer)
            RdMap.write(ctx, buffer, value._textControls)
            com.jetbrains.rd.rdtext.impl.intrinsics.RdTextBufferState.write(ctx, buffer, value._text.delegatedBy)
            RdOptionalProperty.write(ctx, buffer, value._markup)
            RdCall.write(ctx, buffer, value._compareAllTextTask)
            buffer.writeNullable(value.sandboxInfo) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdProperty.write(ctx, buffer, value._crumbsSession)
            buffer.writeList(value.extensions) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        private val __CrumbSessionNullableSerializer = CrumbSession.nullable()
        
    }
    //fields
    val textControls: IMutableViewableMap<TextControlId, TextControlModel> get() = _textControls
    val text: com.jetbrains.rd.rdtext.impl.RdDeferrableTextBuffer get() = _text
    val markup: IOptProperty<RdMarkupModelBase> get() = _markup
    
    /**
     * For diagnostic purposes, returns backend document text.
     */
    val compareAllTextTask: RdCall<Unit, String> get() = _compareAllTextTask
    val crumbsSession: IProperty<CrumbSession?> get() = _crumbsSession
    //methods
    //initializer
    init {
        bindableChildren.add("textControls" to _textControls)
        bindableChildren.add("text" to _text)
        bindableChildren.add("markup" to _markup)
        bindableChildren.add("compareAllTextTask" to _compareAllTextTask)
        bindableChildren.add("crumbsSession" to _crumbsSession)
        bindableChildren.add("extensions" to extensions)
    }
    
    //secondary constructor
    constructor(
        sandboxInfo: AbstractSandboxInfo?,
        extensions: List<DocumentExtension>
    ) : this(
        RdMap<TextControlId, TextControlModel>(TextControlId, TextControlModel),
        com.jetbrains.rd.rdtext.impl.RdDeferrableTextBuffer(com.jetbrains.rd.rdtext.impl.intrinsics.RdTextBufferState()),
        RdOptionalProperty<RdMarkupModelBase>(AbstractPolymorphic(RdMarkupModelBase)),
        RdCall<Unit, String>(FrameworkMarshallers.Void, FrameworkMarshallers.String),
        sandboxInfo,
        RdProperty<CrumbSession?>(null, __CrumbSessionNullableSerializer),
        extensions
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDocumentModel (")
        printer.indent {
            print("textControls = "); _textControls.print(printer); println()
            print("text = "); _text.print(printer); println()
            print("markup = "); _markup.print(printer); println()
            print("compareAllTextTask = "); _compareAllTextTask.print(printer); println()
            print("sandboxInfo = "); sandboxInfo.print(printer); println()
            print("crumbsSession = "); _crumbsSession.print(printer); println()
            print("extensions = "); extensions.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdDocumentModel   {
        return RdDocumentModel(
            _textControls.deepClonePolymorphic(),
            _text.deepClonePolymorphic(),
            _markup.deepClonePolymorphic(),
            _compareAllTextTask.deepClonePolymorphic(),
            sandboxInfo,
            _crumbsSession.deepClonePolymorphic(),
            extensions.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdDocumentVersion (
    val value: Int
) : AbstractDocumentVersion (
) {
    //companion
    
    companion object : IMarshaller<RdDocumentVersion> {
        override val _type: KClass<RdDocumentVersion> = RdDocumentVersion::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdDocumentVersion  {
            val value = buffer.readInt()
            return RdDocumentVersion(value)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdDocumentVersion)  {
            buffer.writeInt(value.value)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdDocumentVersion
        
        if (value != other.value) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + value.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdDocumentVersion (")
        printer.indent {
            print("value = "); value.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdEditorChange (
    val editorId: TextControlId
) : RdPatchStep (
) {
    //companion
    
    companion object : IAbstractDeclaration<RdEditorChange> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdEditorChange  {
            val objectStartPosition = buffer.position
            val editorId = TextControlId.read(ctx, buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdEditorChange_Unknown(editorId, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdEditorChange_Unknown (
    editorId: TextControlId,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdEditorChange (
    editorId
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdEditorChange_Unknown> {
        override val _type: KClass<RdEditorChange_Unknown> = RdEditorChange_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdEditorChange_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdEditorChange_Unknown)  {
            TextControlId.write(ctx, buffer, value.editorId)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdEditorChange_Unknown
        
        if (editorId != other.editorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + editorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdEditorChange_Unknown (")
        printer.indent {
            print("editorId = "); editorId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdEditorFeatureStep (
    editorId: TextControlId
) : RdTransparentEditorChange (
    editorId
) {
    //companion
    
    companion object : IAbstractDeclaration<RdEditorFeatureStep> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdEditorFeatureStep  {
            val objectStartPosition = buffer.position
            val editorId = TextControlId.read(ctx, buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdEditorFeatureStep_Unknown(editorId, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdEditorFeatureStep_Unknown (
    editorId: TextControlId,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdEditorFeatureStep (
    editorId
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdEditorFeatureStep_Unknown> {
        override val _type: KClass<RdEditorFeatureStep_Unknown> = RdEditorFeatureStep_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdEditorFeatureStep_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdEditorFeatureStep_Unknown)  {
            TextControlId.write(ctx, buffer, value.editorId)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdEditorFeatureStep_Unknown
        
        if (editorId != other.editorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + editorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdEditorFeatureStep_Unknown (")
        printer.indent {
            print("editorId = "); editorId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdEditorVersion (
    val caretModelVersion: Int
) : RdAbstractEditorVersion (
) {
    //companion
    
    companion object : IMarshaller<RdEditorVersion> {
        override val _type: KClass<RdEditorVersion> = RdEditorVersion::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdEditorVersion  {
            val caretModelVersion = buffer.readInt()
            return RdEditorVersion(caretModelVersion)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdEditorVersion)  {
            buffer.writeInt(value.caretModelVersion)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdEditorVersion
        
        if (caretModelVersion != other.caretModelVersion) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + caretModelVersion.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdEditorVersion (")
        printer.indent {
            print("caretModelVersion = "); caretModelVersion.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdEmptyMarkupModel (
) : RdMarkupModelBase (
) {
    //companion
    
    companion object : IMarshaller<RdEmptyMarkupModel> {
        override val _type: KClass<RdEmptyMarkupModel> = RdEmptyMarkupModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdEmptyMarkupModel  {
            val _id = RdId.read(buffer)
            return RdEmptyMarkupModel().withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdEmptyMarkupModel)  {
            value.rdid.write(buffer)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdEmptyMarkupModel (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdEmptyMarkupModel   {
        return RdEmptyMarkupModel(
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdExistingSolution (
    val solutionFilePath: String
) : RdSolutionDescription (
) {
    //companion
    
    companion object : IMarshaller<RdExistingSolution> {
        override val _type: KClass<RdExistingSolution> = RdExistingSolution::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdExistingSolution  {
            val solutionFilePath = buffer.readString()
            return RdExistingSolution(solutionFilePath)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdExistingSolution)  {
            buffer.writeString(value.solutionFilePath)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdExistingSolution
        
        if (solutionFilePath != other.solutionFilePath) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + solutionFilePath.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdExistingSolution (")
        printer.indent {
            print("solutionFilePath = "); solutionFilePath.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdFailureResponse (
    val message: String,
    requestId: Int
) : RdResponse (
    requestId
) {
    //companion
    
    companion object : IMarshaller<RdFailureResponse> {
        override val _type: KClass<RdFailureResponse> = RdFailureResponse::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFailureResponse  {
            val requestId = buffer.readInt()
            val message = buffer.readString()
            return RdFailureResponse(message, requestId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFailureResponse)  {
            buffer.writeInt(value.requestId)
            buffer.writeString(value.message)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFailureResponse
        
        if (message != other.message) return false
        if (requestId != other.requestId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + message.hashCode()
        __r = __r*31 + requestId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFailureResponse (")
        printer.indent {
            print("message = "); message.print(printer); println()
            print("requestId = "); requestId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * An id of a document which is backed by a file
 * @property protocol default value is file
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdFileDocumentId (
    val filePath: String,
    val protocol: String
) : RdDocumentId (
) {
    //companion
    
    companion object : IAbstractDeclaration<RdFileDocumentId> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdFileDocumentId  {
            val objectStartPosition = buffer.position
            val filePath = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val protocol = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdFileDocumentId_Unknown(filePath, protocol, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


/**
 * Don't use directly, unless in platform code for instance creation. See [VirtualFile, File].createDocumentId() on the frontend
 * #### Generated from [SolutionModel.kt]
 */
class RdFileDocumentIdImpl (
    filePath: String,
    protocol: String
) : RdFileDocumentId (
    filePath,
    protocol
) {
    //companion
    
    companion object : IMarshaller<RdFileDocumentIdImpl> {
        override val _type: KClass<RdFileDocumentIdImpl> = RdFileDocumentIdImpl::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFileDocumentIdImpl  {
            val filePath = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val protocol = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            return RdFileDocumentIdImpl(filePath, protocol)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFileDocumentIdImpl)  {
            ctx.writeInterned(buffer, value.filePath, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            ctx.writeInterned(buffer, value.protocol, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFileDocumentIdImpl
        
        if (filePath != other.filePath) return false
        if (protocol != other.protocol) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + filePath.hashCode()
        __r = __r*31 + protocol.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFileDocumentIdImpl (")
        printer.indent {
            print("filePath = "); filePath.print(printer); println()
            print("protocol = "); protocol.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


class RdFileDocumentId_Unknown (
    filePath: String,
    protocol: String,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdFileDocumentId (
    filePath,
    protocol
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdFileDocumentId_Unknown> {
        override val _type: KClass<RdFileDocumentId_Unknown> = RdFileDocumentId_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFileDocumentId_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFileDocumentId_Unknown)  {
            ctx.writeInterned(buffer, value.filePath, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            ctx.writeInterned(buffer, value.protocol, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFileDocumentId_Unknown
        
        if (filePath != other.filePath) return false
        if (protocol != other.protocol) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + filePath.hashCode()
        __r = __r*31 + protocol.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFileDocumentId_Unknown (")
        printer.indent {
            print("filePath = "); filePath.print(printer); println()
            print("protocol = "); protocol.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdFileId (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdFileId> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdFileId  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdFileId_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


/**
 * Files that reside in memory (LightVirtualFile)
 * #### Generated from [SolutionModel.kt]
 */
class RdFileIdInMem (
    val descriptor: String
) : RdFileId (
) {
    //companion
    
    companion object : IMarshaller<RdFileIdInMem> {
        override val _type: KClass<RdFileIdInMem> = RdFileIdInMem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFileIdInMem  {
            val descriptor = buffer.readString()
            return RdFileIdInMem(descriptor)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFileIdInMem)  {
            buffer.writeString(value.descriptor)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFileIdInMem
        
        if (descriptor != other.descriptor) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + descriptor.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFileIdInMem (")
        printer.indent {
            print("descriptor = "); descriptor.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * Files with a persistent ID
 * #### Generated from [SolutionModel.kt]
 */
class RdFileIdNew (
    val id: Int
) : RdFileId (
) {
    //companion
    
    companion object : IMarshaller<RdFileIdNew> {
        override val _type: KClass<RdFileIdNew> = RdFileIdNew::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFileIdNew  {
            val id = buffer.readInt()
            return RdFileIdNew(id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFileIdNew)  {
            buffer.writeInt(value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFileIdNew
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFileIdNew (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * Files that have no persistent IDs yet not in-memory LightVirtualFile
 * #### Generated from [SolutionModel.kt]
 */
class RdFileIdOld (
    val protocol: String,
    val path: String
) : RdFileId (
) {
    //companion
    
    companion object : IMarshaller<RdFileIdOld> {
        override val _type: KClass<RdFileIdOld> = RdFileIdOld::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFileIdOld  {
            val protocol = buffer.readString()
            val path = buffer.readString()
            return RdFileIdOld(protocol, path)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFileIdOld)  {
            buffer.writeString(value.protocol)
            buffer.writeString(value.path)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFileIdOld
        
        if (protocol != other.protocol) return false
        if (path != other.path) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + protocol.hashCode()
        __r = __r*31 + path.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFileIdOld (")
        printer.indent {
            print("protocol = "); protocol.print(printer); println()
            print("path = "); path.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


class RdFileId_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdFileId (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdFileId_Unknown> {
        override val _type: KClass<RdFileId_Unknown> = RdFileId_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFileId_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFileId_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFileId_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFileId_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdFileToOpen (
    val path: String,
    val caret: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdFileToOpen> {
        override val _type: KClass<RdFileToOpen> = RdFileToOpen::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdFileToOpen  {
            val path = buffer.readString()
            val caret = buffer.readInt()
            return RdFileToOpen(path, caret)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdFileToOpen)  {
            buffer.writeString(value.path)
            buffer.writeInt(value.caret)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdFileToOpen
        
        if (path != other.path) return false
        if (caret != other.caret) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + path.hashCode()
        __r = __r*31 + caret.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdFileToOpen (")
        printer.indent {
            print("path = "); path.print(printer); println()
            print("caret = "); caret.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdGutterExecutionRequest (
    val gutterId: Long,
    val start: Int,
    val end: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdGutterExecutionRequest> {
        override val _type: KClass<RdGutterExecutionRequest> = RdGutterExecutionRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdGutterExecutionRequest  {
            val gutterId = buffer.readLong()
            val start = buffer.readInt()
            val end = buffer.readInt()
            return RdGutterExecutionRequest(gutterId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdGutterExecutionRequest)  {
            buffer.writeLong(value.gutterId)
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdGutterExecutionRequest
        
        if (gutterId != other.gutterId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + gutterId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdGutterExecutionRequest (")
        printer.indent {
            print("gutterId = "); gutterId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdLiveTemplateExpansion (
    val template: LiveTemplateInitialDataModel,
    editorId: TextControlId
) : RdEditorFeatureStep (
    editorId
) {
    //companion
    
    companion object : IMarshaller<RdLiveTemplateExpansion> {
        override val _type: KClass<RdLiveTemplateExpansion> = RdLiveTemplateExpansion::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdLiveTemplateExpansion  {
            val editorId = TextControlId.read(ctx, buffer)
            val template = LiveTemplateInitialDataModel.read(ctx, buffer)
            return RdLiveTemplateExpansion(template, editorId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdLiveTemplateExpansion)  {
            TextControlId.write(ctx, buffer, value.editorId)
            LiveTemplateInitialDataModel.write(ctx, buffer, value.template)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdLiveTemplateExpansion
        
        if (template != other.template) return false
        if (editorId != other.editorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + template.hashCode()
        __r = __r*31 + editorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdLiveTemplateExpansion (")
        printer.indent {
            print("template = "); template.print(printer); println()
            print("editorId = "); editorId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdLookupShowStep (
    editorId: TextControlId
) : RdEditorFeatureStep (
    editorId
) {
    //companion
    
    companion object : IMarshaller<RdLookupShowStep> {
        override val _type: KClass<RdLookupShowStep> = RdLookupShowStep::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdLookupShowStep  {
            val editorId = TextControlId.read(ctx, buffer)
            return RdLookupShowStep(editorId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdLookupShowStep)  {
            TextControlId.write(ctx, buffer, value.editorId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdLookupShowStep
        
        if (editorId != other.editorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + editorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdLookupShowStep (")
        printer.indent {
            print("editorId = "); editorId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdMarkupModel private constructor(
    private val _highlightersAdded: RdSignal<HighlighterList>,
    private val _highlightersUpdated: RdSignal<HighlighterList>,
    private val _highlightersRemoved: RdSignal<HighlighterIdList>,
    val daemon: RdDaemonModel,
    val extensions: List<MarkupModelExtension>
) : RdMarkupModelBase (
) {
    //companion
    
    companion object : IMarshaller<RdMarkupModel> {
        override val _type: KClass<RdMarkupModel> = RdMarkupModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdMarkupModel  {
            val _id = RdId.read(buffer)
            val _highlightersAdded = RdSignal.read(ctx, buffer, HighlighterList)
            val _highlightersUpdated = RdSignal.read(ctx, buffer, HighlighterList)
            val _highlightersRemoved = RdSignal.read(ctx, buffer, HighlighterIdList)
            val daemon = RdDaemonModel.read(ctx, buffer)
            val extensions = buffer.readList { ctx.serializers.readPolymorphic<MarkupModelExtension>(ctx, buffer, MarkupModelExtension) }
            return RdMarkupModel(_highlightersAdded, _highlightersUpdated, _highlightersRemoved, daemon, extensions).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdMarkupModel)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._highlightersAdded)
            RdSignal.write(ctx, buffer, value._highlightersUpdated)
            RdSignal.write(ctx, buffer, value._highlightersRemoved)
            RdDaemonModel.write(ctx, buffer, value.daemon)
            buffer.writeList(value.extensions) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        
    }
    //fields
    val highlightersAdded: ISignal<HighlighterList> get() = _highlightersAdded
    val highlightersUpdated: ISignal<HighlighterList> get() = _highlightersUpdated
    val highlightersRemoved: ISignal<HighlighterIdList> get() = _highlightersRemoved
    //methods
    //initializer
    init {
        bindableChildren.add("highlightersAdded" to _highlightersAdded)
        bindableChildren.add("highlightersUpdated" to _highlightersUpdated)
        bindableChildren.add("highlightersRemoved" to _highlightersRemoved)
        bindableChildren.add("daemon" to daemon)
        bindableChildren.add("extensions" to extensions)
    }
    
    //secondary constructor
    constructor(
        extensions: List<MarkupModelExtension>
    ) : this(
        RdSignal<HighlighterList>(HighlighterList),
        RdSignal<HighlighterList>(HighlighterList),
        RdSignal<HighlighterIdList>(HighlighterIdList),
        RdDaemonModel(),
        extensions
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdMarkupModel (")
        printer.indent {
            print("highlightersAdded = "); _highlightersAdded.print(printer); println()
            print("highlightersUpdated = "); _highlightersUpdated.print(printer); println()
            print("highlightersRemoved = "); _highlightersRemoved.print(printer); println()
            print("daemon = "); daemon.print(printer); println()
            print("extensions = "); extensions.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdMarkupModel   {
        return RdMarkupModel(
            _highlightersAdded.deepClonePolymorphic(),
            _highlightersUpdated.deepClonePolymorphic(),
            _highlightersRemoved.deepClonePolymorphic(),
            daemon.deepClonePolymorphic(),
            extensions.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdMarkupModelBase (
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<RdMarkupModelBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdMarkupModelBase  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdMarkupModelBase_Unknown(unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdMarkupModelBase_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdMarkupModelBase (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdMarkupModelBase_Unknown> {
        override val _type: KClass<RdMarkupModelBase_Unknown> = RdMarkupModelBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdMarkupModelBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdMarkupModelBase_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdMarkupModelBase_Unknown (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdMarkupModelBase_Unknown   {
        return RdMarkupModelBase_Unknown(
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdMoveHistoryItemToTop (
    val id: Int
) : RdClipboardChange (
) {
    //companion
    
    companion object : IMarshaller<RdMoveHistoryItemToTop> {
        override val _type: KClass<RdMoveHistoryItemToTop> = RdMoveHistoryItemToTop::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdMoveHistoryItemToTop  {
            val id = buffer.readInt()
            return RdMoveHistoryItemToTop(id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdMoveHistoryItemToTop)  {
            buffer.writeInt(value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdMoveHistoryItemToTop
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdMoveHistoryItemToTop (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdOpenSolution (
    description: RdSolutionDescription,
    restorePackages: Boolean
) : RdSolutionOpenStrategy (
    description,
    restorePackages
) {
    //companion
    
    companion object : IMarshaller<RdOpenSolution> {
        override val _type: KClass<RdOpenSolution> = RdOpenSolution::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdOpenSolution  {
            val _id = RdId.read(buffer)
            val description = ctx.serializers.readPolymorphic<RdSolutionDescription>(ctx, buffer, RdSolutionDescription)
            val restorePackages = buffer.readBool()
            return RdOpenSolution(description, restorePackages).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdOpenSolution)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.description)
            buffer.writeBool(value.restorePackages)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdOpenSolution (")
        printer.indent {
            print("description = "); description.print(printer); println()
            print("restorePackages = "); restorePackages.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdOpenSolution   {
        return RdOpenSolution(
            description,
            restorePackages
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdOpenSolutionAndCollectProjectModelChanges private constructor(
    private val _changesLogFile: RdOptionalProperty<String>,
    description: RdSolutionDescription,
    restorePackages: Boolean
) : RdSolutionOpenStrategy (
    description,
    restorePackages
) {
    //companion
    
    companion object : IMarshaller<RdOpenSolutionAndCollectProjectModelChanges> {
        override val _type: KClass<RdOpenSolutionAndCollectProjectModelChanges> = RdOpenSolutionAndCollectProjectModelChanges::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdOpenSolutionAndCollectProjectModelChanges  {
            val _id = RdId.read(buffer)
            val description = ctx.serializers.readPolymorphic<RdSolutionDescription>(ctx, buffer, RdSolutionDescription)
            val restorePackages = buffer.readBool()
            val _changesLogFile = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.String)
            return RdOpenSolutionAndCollectProjectModelChanges(_changesLogFile, description, restorePackages).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdOpenSolutionAndCollectProjectModelChanges)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.description)
            buffer.writeBool(value.restorePackages)
            RdOptionalProperty.write(ctx, buffer, value._changesLogFile)
        }
        
        
    }
    //fields
    val changesLogFile: IOptProperty<String> get() = _changesLogFile
    //methods
    //initializer
    init {
        _changesLogFile.optimizeNested = true
    }
    
    init {
        bindableChildren.add("changesLogFile" to _changesLogFile)
    }
    
    //secondary constructor
    constructor(
        description: RdSolutionDescription,
        restorePackages: Boolean
    ) : this(
        RdOptionalProperty<String>(FrameworkMarshallers.String),
        description,
        restorePackages
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdOpenSolutionAndCollectProjectModelChanges (")
        printer.indent {
            print("changesLogFile = "); _changesLogFile.print(printer); println()
            print("description = "); description.print(printer); println()
            print("restorePackages = "); restorePackages.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdOpenSolutionAndCollectProjectModelChanges   {
        return RdOpenSolutionAndCollectProjectModelChanges(
            _changesLogFile.deepClonePolymorphic(),
            description,
            restorePackages
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdOpenSolutionAndPostprocess (
    val filesToOpen: List<RdFileToOpen>,
    val parameters: RdPostProcessParameters,
    description: RdSolutionDescription,
    restorePackages: Boolean
) : RdSolutionOpenStrategy (
    description,
    restorePackages
) {
    //companion
    
    companion object : IMarshaller<RdOpenSolutionAndPostprocess> {
        override val _type: KClass<RdOpenSolutionAndPostprocess> = RdOpenSolutionAndPostprocess::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdOpenSolutionAndPostprocess  {
            val _id = RdId.read(buffer)
            val description = ctx.serializers.readPolymorphic<RdSolutionDescription>(ctx, buffer, RdSolutionDescription)
            val restorePackages = buffer.readBool()
            val filesToOpen = buffer.readList { RdFileToOpen.read(ctx, buffer) }
            val parameters = RdPostProcessParameters.read(ctx, buffer)
            return RdOpenSolutionAndPostprocess(filesToOpen, parameters, description, restorePackages).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdOpenSolutionAndPostprocess)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.description)
            buffer.writeBool(value.restorePackages)
            buffer.writeList(value.filesToOpen) { v -> RdFileToOpen.write(ctx, buffer, v) }
            RdPostProcessParameters.write(ctx, buffer, value.parameters)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdOpenSolutionAndPostprocess (")
        printer.indent {
            print("filesToOpen = "); filesToOpen.print(printer); println()
            print("parameters = "); parameters.print(printer); println()
            print("description = "); description.print(printer); println()
            print("restorePackages = "); restorePackages.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdOpenSolutionAndPostprocess   {
        return RdOpenSolutionAndPostprocess(
            filesToOpen,
            parameters,
            description,
            restorePackages
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdPatch (
    val changes: List<RdPatchStep>,
    val features: List<RdEditorFeatureStep>?,
    val initialCaretStateHint: RdCaretStateSnapshot?,
    val disableCaretShiftOnWhitespace: Boolean,
    val expectedDocIds: List<RdDocumentId>,
    val updatedDocIds: List<RdDocumentId>,
    val expectedDocVersions: List<RdDocumentVersion>,
    val updatedDocVersions: List<RdDocumentVersion>,
    val expectedEditorIds: List<TextControlId>,
    val updatedEditorIds: List<TextControlId>,
    val expectedEditorVersions: List<RdEditorVersion>,
    val updatedEditorVersions: List<RdEditorVersion>,
    val expectedClipboardVersion: Int?,
    val updatedClipboardVersion: Int?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdPatch> {
        override val _type: KClass<RdPatch> = RdPatch::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPatch  {
            val changes = buffer.readList { ctx.serializers.readPolymorphic<RdPatchStep>(ctx, buffer, RdPatchStep) }
            val features = buffer.readNullable { buffer.readList { ctx.serializers.readPolymorphic<RdEditorFeatureStep>(ctx, buffer, RdEditorFeatureStep) } }
            val initialCaretStateHint = buffer.readNullable { RdCaretStateSnapshot.read(ctx, buffer) }
            val disableCaretShiftOnWhitespace = buffer.readBool()
            val expectedDocIds = buffer.readList { ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId) }
            val updatedDocIds = buffer.readList { ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId) }
            val expectedDocVersions = buffer.readList { RdDocumentVersion.read(ctx, buffer) }
            val updatedDocVersions = buffer.readList { RdDocumentVersion.read(ctx, buffer) }
            val expectedEditorIds = buffer.readList { TextControlId.read(ctx, buffer) }
            val updatedEditorIds = buffer.readList { TextControlId.read(ctx, buffer) }
            val expectedEditorVersions = buffer.readList { RdEditorVersion.read(ctx, buffer) }
            val updatedEditorVersions = buffer.readList { RdEditorVersion.read(ctx, buffer) }
            val expectedClipboardVersion = buffer.readNullable { buffer.readInt() }
            val updatedClipboardVersion = buffer.readNullable { buffer.readInt() }
            return RdPatch(changes, features, initialCaretStateHint, disableCaretShiftOnWhitespace, expectedDocIds, updatedDocIds, expectedDocVersions, updatedDocVersions, expectedEditorIds, updatedEditorIds, expectedEditorVersions, updatedEditorVersions, expectedClipboardVersion, updatedClipboardVersion)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPatch)  {
            buffer.writeList(value.changes) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            buffer.writeNullable(value.features) { buffer.writeList(it) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) } }
            buffer.writeNullable(value.initialCaretStateHint) { RdCaretStateSnapshot.write(ctx, buffer, it) }
            buffer.writeBool(value.disableCaretShiftOnWhitespace)
            buffer.writeList(value.expectedDocIds) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            buffer.writeList(value.updatedDocIds) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            buffer.writeList(value.expectedDocVersions) { v -> RdDocumentVersion.write(ctx, buffer, v) }
            buffer.writeList(value.updatedDocVersions) { v -> RdDocumentVersion.write(ctx, buffer, v) }
            buffer.writeList(value.expectedEditorIds) { v -> TextControlId.write(ctx, buffer, v) }
            buffer.writeList(value.updatedEditorIds) { v -> TextControlId.write(ctx, buffer, v) }
            buffer.writeList(value.expectedEditorVersions) { v -> RdEditorVersion.write(ctx, buffer, v) }
            buffer.writeList(value.updatedEditorVersions) { v -> RdEditorVersion.write(ctx, buffer, v) }
            buffer.writeNullable(value.expectedClipboardVersion) { buffer.writeInt(it) }
            buffer.writeNullable(value.updatedClipboardVersion) { buffer.writeInt(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdPatch
        
        
        if (features != other.features) return false
        
        if (disableCaretShiftOnWhitespace != other.disableCaretShiftOnWhitespace) return false
        if (expectedDocIds != other.expectedDocIds) return false
        if (updatedDocIds != other.updatedDocIds) return false
        if (expectedDocVersions != other.expectedDocVersions) return false
        if (updatedDocVersions != other.updatedDocVersions) return false
        if (expectedEditorIds != other.expectedEditorIds) return false
        if (updatedEditorIds != other.updatedEditorIds) return false
        if (expectedEditorVersions != other.expectedEditorVersions) return false
        if (updatedEditorVersions != other.updatedEditorVersions) return false
        if (expectedClipboardVersion != other.expectedClipboardVersion) return false
        if (updatedClipboardVersion != other.updatedClipboardVersion) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        
        __r = __r*31 + if (features != null) features.hashCode() else 0
        
        __r = __r*31 + disableCaretShiftOnWhitespace.hashCode()
        __r = __r*31 + expectedDocIds.hashCode()
        __r = __r*31 + updatedDocIds.hashCode()
        __r = __r*31 + expectedDocVersions.hashCode()
        __r = __r*31 + updatedDocVersions.hashCode()
        __r = __r*31 + expectedEditorIds.hashCode()
        __r = __r*31 + updatedEditorIds.hashCode()
        __r = __r*31 + expectedEditorVersions.hashCode()
        __r = __r*31 + updatedEditorVersions.hashCode()
        __r = __r*31 + if (expectedClipboardVersion != null) expectedClipboardVersion.hashCode() else 0
        __r = __r*31 + if (updatedClipboardVersion != null) updatedClipboardVersion.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPatch (")
        printer.indent {
            print("changes = "); changes.print(printer); println()
            print("features = "); features.print(printer); println()
            print("initialCaretStateHint = "); initialCaretStateHint.print(printer); println()
            print("disableCaretShiftOnWhitespace = "); disableCaretShiftOnWhitespace.print(printer); println()
            print("expectedDocIds = "); expectedDocIds.print(printer); println()
            print("updatedDocIds = "); updatedDocIds.print(printer); println()
            print("expectedDocVersions = "); expectedDocVersions.print(printer); println()
            print("updatedDocVersions = "); updatedDocVersions.print(printer); println()
            print("expectedEditorIds = "); expectedEditorIds.print(printer); println()
            print("updatedEditorIds = "); updatedEditorIds.print(printer); println()
            print("expectedEditorVersions = "); expectedEditorVersions.print(printer); println()
            print("updatedEditorVersions = "); updatedEditorVersions.print(printer); println()
            print("expectedClipboardVersion = "); expectedClipboardVersion.print(printer); println()
            print("updatedClipboardVersion = "); updatedClipboardVersion.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdPatchResponse (
    val patch: RdPatch?,
    requestId: Int
) : RdResponse (
    requestId
) {
    //companion
    
    companion object : IMarshaller<RdPatchResponse> {
        override val _type: KClass<RdPatchResponse> = RdPatchResponse::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPatchResponse  {
            val requestId = buffer.readInt()
            val patch = buffer.readNullable { RdPatch.read(ctx, buffer) }
            return RdPatchResponse(patch, requestId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPatchResponse)  {
            buffer.writeInt(value.requestId)
            buffer.writeNullable(value.patch) { RdPatch.write(ctx, buffer, it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdPatchResponse
        
        if (patch != other.patch) return false
        if (requestId != other.requestId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (patch != null) patch.hashCode() else 0
        __r = __r*31 + requestId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPatchResponse (")
        printer.indent {
            print("patch = "); patch.print(printer); println()
            print("requestId = "); requestId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdPatchStep (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdPatchStep> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdPatchStep  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdPatchStep_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdPatchStep_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdPatchStep (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdPatchStep_Unknown> {
        override val _type: KClass<RdPatchStep_Unknown> = RdPatchStep_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPatchStep_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPatchStep_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdPatchStep_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPatchStep_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdPostProcessParameters (
    val reformat: Boolean,
    val additionalParameters: List<String>
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdPostProcessParameters> {
        override val _type: KClass<RdPostProcessParameters> = RdPostProcessParameters::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdPostProcessParameters  {
            val reformat = buffer.readBool()
            val additionalParameters = buffer.readList { buffer.readString() }
            return RdPostProcessParameters(reformat, additionalParameters)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdPostProcessParameters)  {
            buffer.writeBool(value.reformat)
            buffer.writeList(value.additionalParameters) { v -> buffer.writeString(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdPostProcessParameters
        
        if (reformat != other.reformat) return false
        if (additionalParameters != other.additionalParameters) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + reformat.hashCode()
        __r = __r*31 + additionalParameters.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdPostProcessParameters (")
        printer.indent {
            print("reformat = "); reformat.print(printer); println()
            print("additionalParameters = "); additionalParameters.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdRemoveHistoryItem (
    val id: Int
) : RdClipboardChange (
) {
    //companion
    
    companion object : IMarshaller<RdRemoveHistoryItem> {
        override val _type: KClass<RdRemoveHistoryItem> = RdRemoveHistoryItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdRemoveHistoryItem  {
            val id = buffer.readInt()
            return RdRemoveHistoryItem(id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdRemoveHistoryItem)  {
            buffer.writeInt(value.id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdRemoveHistoryItem
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdRemoveHistoryItem (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdRequest (
    val id: Int
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdRequest> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdRequest  {
            val objectStartPosition = buffer.position
            val id = buffer.readInt()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdRequest_Unknown(id, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdRequest_Unknown (
    id: Int,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdRequest (
    id
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdRequest_Unknown> {
        override val _type: KClass<RdRequest_Unknown> = RdRequest_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdRequest_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdRequest_Unknown)  {
            buffer.writeInt(value.id)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdRequest_Unknown
        
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdRequest_Unknown (")
        printer.indent {
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdResponse (
    val requestId: Int
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdResponse> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdResponse  {
            val objectStartPosition = buffer.position
            val requestId = buffer.readInt()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdResponse_Unknown(requestId, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdResponse_Unknown (
    requestId: Int,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdResponse (
    requestId
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdResponse_Unknown> {
        override val _type: KClass<RdResponse_Unknown> = RdResponse_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdResponse_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdResponse_Unknown)  {
            buffer.writeInt(value.requestId)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdResponse_Unknown
        
        if (requestId != other.requestId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + requestId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdResponse_Unknown (")
        printer.indent {
            print("requestId = "); requestId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdRetryResponse (
    val message: String,
    requestId: Int
) : RdResponse (
    requestId
) {
    //companion
    
    companion object : IMarshaller<RdRetryResponse> {
        override val _type: KClass<RdRetryResponse> = RdRetryResponse::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdRetryResponse  {
            val requestId = buffer.readInt()
            val message = buffer.readString()
            return RdRetryResponse(message, requestId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdRetryResponse)  {
            buffer.writeInt(value.requestId)
            buffer.writeString(value.message)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdRetryResponse
        
        if (message != other.message) return false
        if (requestId != other.requestId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + message.hashCode()
        __r = __r*31 + requestId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdRetryResponse (")
        printer.indent {
            print("message = "); message.print(printer); println()
            print("requestId = "); requestId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdScrollingRequest (
    val info: ScrollingInfo,
    editorId: TextControlId
) : RdTransparentEditorChange (
    editorId
) {
    //companion
    
    companion object : IMarshaller<RdScrollingRequest> {
        override val _type: KClass<RdScrollingRequest> = RdScrollingRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdScrollingRequest  {
            val editorId = TextControlId.read(ctx, buffer)
            val info = ScrollingInfo.read(ctx, buffer)
            return RdScrollingRequest(info, editorId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdScrollingRequest)  {
            TextControlId.write(ctx, buffer, value.editorId)
            ScrollingInfo.write(ctx, buffer, value.info)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdScrollingRequest
        
        if (info != other.info) return false
        if (editorId != other.editorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + info.hashCode()
        __r = __r*31 + editorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdScrollingRequest (")
        printer.indent {
            print("info = "); info.print(printer); println()
            print("editorId = "); editorId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdSelection (
    val start: DocOffsetAndVirtualModel,
    val end: DocOffsetAndVirtualModel
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdSelection> {
        override val _type: KClass<RdSelection> = RdSelection::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdSelection  {
            val start = DocOffsetAndVirtualModel.read(ctx, buffer)
            val end = DocOffsetAndVirtualModel.read(ctx, buffer)
            return RdSelection(start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdSelection)  {
            DocOffsetAndVirtualModel.write(ctx, buffer, value.start)
            DocOffsetAndVirtualModel.write(ctx, buffer, value.end)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdSelection
        
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdSelection (")
        printer.indent {
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdSelectionChangeBase (
    editorId: TextControlId
) : RdEditorChange (
    editorId
), RdCaretModelChange {
    //companion
    
    companion object : IAbstractDeclaration<RdSelectionChangeBase> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdSelectionChangeBase  {
            val objectStartPosition = buffer.position
            val editorId = TextControlId.read(ctx, buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdSelectionChangeBase_Unknown(editorId, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdSelectionChangeBase_Unknown (
    editorId: TextControlId,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdSelectionChangeBase (
    editorId
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdSelectionChangeBase_Unknown> {
        override val _type: KClass<RdSelectionChangeBase_Unknown> = RdSelectionChangeBase_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdSelectionChangeBase_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdSelectionChangeBase_Unknown)  {
            TextControlId.write(ctx, buffer, value.editorId)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdSelectionChangeBase_Unknown
        
        if (editorId != other.editorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + editorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdSelectionChangeBase_Unknown (")
        printer.indent {
            print("editorId = "); editorId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdSimpleTextAttributes (
    val fgColor: Int? = null,
    val bgColor: Int? = null,
    val waveColor: Int? = null,
    val style: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdSimpleTextAttributes> {
        override val _type: KClass<RdSimpleTextAttributes> = RdSimpleTextAttributes::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdSimpleTextAttributes  {
            val fgColor = buffer.readNullable { buffer.readInt() }
            val bgColor = buffer.readNullable { buffer.readInt() }
            val waveColor = buffer.readNullable { buffer.readInt() }
            val style = buffer.readInt()
            return RdSimpleTextAttributes(fgColor, bgColor, waveColor, style)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdSimpleTextAttributes)  {
            buffer.writeNullable(value.fgColor) { buffer.writeInt(it) }
            buffer.writeNullable(value.bgColor) { buffer.writeInt(it) }
            buffer.writeNullable(value.waveColor) { buffer.writeInt(it) }
            buffer.writeInt(value.style)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdSimpleTextAttributes
        
        if (fgColor != other.fgColor) return false
        if (bgColor != other.bgColor) return false
        if (waveColor != other.waveColor) return false
        if (style != other.style) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (fgColor != null) fgColor.hashCode() else 0
        __r = __r*31 + if (bgColor != null) bgColor.hashCode() else 0
        __r = __r*31 + if (waveColor != null) waveColor.hashCode() else 0
        __r = __r*31 + style.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdSimpleTextAttributes (")
        printer.indent {
            print("fgColor = "); fgColor.print(printer); println()
            print("bgColor = "); bgColor.print(printer); println()
            print("waveColor = "); waveColor.print(printer); println()
            print("style = "); style.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdSolutionDescription (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<RdSolutionDescription> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdSolutionDescription  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdSolutionDescription_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdSolutionDescription_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdSolutionDescription (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdSolutionDescription_Unknown> {
        override val _type: KClass<RdSolutionDescription_Unknown> = RdSolutionDescription_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdSolutionDescription_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdSolutionDescription_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdSolutionDescription_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdSolutionDescription_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdSolutionOpenStrategy (
    val description: RdSolutionDescription,
    val restorePackages: Boolean
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<RdSolutionOpenStrategy> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdSolutionOpenStrategy  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val description = ctx.serializers.readPolymorphic<RdSolutionDescription>(ctx, buffer, RdSolutionDescription)
            val restorePackages = buffer.readBool()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdSolutionOpenStrategy_Unknown(description, restorePackages, unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdSolutionOpenStrategy_Unknown (
    description: RdSolutionDescription,
    restorePackages: Boolean,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdSolutionOpenStrategy (
    description,
    restorePackages
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdSolutionOpenStrategy_Unknown> {
        override val _type: KClass<RdSolutionOpenStrategy_Unknown> = RdSolutionOpenStrategy_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdSolutionOpenStrategy_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdSolutionOpenStrategy_Unknown)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.description)
            buffer.writeBool(value.restorePackages)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdSolutionOpenStrategy_Unknown (")
        printer.indent {
            print("description = "); description.print(printer); println()
            print("restorePackages = "); restorePackages.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdSolutionOpenStrategy_Unknown   {
        return RdSolutionOpenStrategy_Unknown(
            description,
            restorePackages,
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdSolutionProperties private constructor(
    private val _activeConfigurationPlatform: RdProperty<RdConfigurationAndPlatform?>,
    private val _configurationsAndPlatformsCollection: RdOptionalProperty<List<RdConfigurationAndPlatform>>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<RdSolutionProperties> {
        override val _type: KClass<RdSolutionProperties> = RdSolutionProperties::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdSolutionProperties  {
            val _id = RdId.read(buffer)
            val _activeConfigurationPlatform = RdProperty.read(ctx, buffer, __RdConfigurationAndPlatformNullableSerializer)
            val _configurationsAndPlatformsCollection = RdOptionalProperty.read(ctx, buffer, __RdConfigurationAndPlatformListSerializer)
            return RdSolutionProperties(_activeConfigurationPlatform, _configurationsAndPlatformsCollection).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdSolutionProperties)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._activeConfigurationPlatform)
            RdOptionalProperty.write(ctx, buffer, value._configurationsAndPlatformsCollection)
        }
        
        private val __RdConfigurationAndPlatformNullableSerializer = RdConfigurationAndPlatform.nullable()
        private val __RdConfigurationAndPlatformListSerializer = RdConfigurationAndPlatform.list()
        
    }
    //fields
    val activeConfigurationPlatform: IProperty<RdConfigurationAndPlatform?> get() = _activeConfigurationPlatform
    val configurationsAndPlatformsCollection: IOptProperty<List<RdConfigurationAndPlatform>> get() = _configurationsAndPlatformsCollection
    //methods
    //initializer
    init {
        _activeConfigurationPlatform.optimizeNested = true
        _configurationsAndPlatformsCollection.optimizeNested = true
    }
    
    init {
        bindableChildren.add("activeConfigurationPlatform" to _activeConfigurationPlatform)
        bindableChildren.add("configurationsAndPlatformsCollection" to _configurationsAndPlatformsCollection)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdProperty<RdConfigurationAndPlatform?>(null, __RdConfigurationAndPlatformNullableSerializer),
        RdOptionalProperty<List<RdConfigurationAndPlatform>>(__RdConfigurationAndPlatformListSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdSolutionProperties (")
        printer.indent {
            print("activeConfigurationPlatform = "); _activeConfigurationPlatform.print(printer); println()
            print("configurationsAndPlatformsCollection = "); _configurationsAndPlatformsCollection.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): RdSolutionProperties   {
        return RdSolutionProperties(
            _activeConfigurationPlatform.deepClonePolymorphic(),
            _configurationsAndPlatformsCollection.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdSuccessResponse (
    requestId: Int
) : RdResponse (
    requestId
) {
    //companion
    
    companion object : IMarshaller<RdSuccessResponse> {
        override val _type: KClass<RdSuccessResponse> = RdSuccessResponse::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdSuccessResponse  {
            val requestId = buffer.readInt()
            return RdSuccessResponse(requestId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdSuccessResponse)  {
            buffer.writeInt(value.requestId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdSuccessResponse
        
        if (requestId != other.requestId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + requestId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdSuccessResponse (")
        printer.indent {
            print("requestId = "); requestId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdTemporarySolution (
    val solutionName: String,
    val solutionTempDirectory: String,
    val tag: String?
) : RdSolutionDescription (
) {
    //companion
    
    companion object : IMarshaller<RdTemporarySolution> {
        override val _type: KClass<RdTemporarySolution> = RdTemporarySolution::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTemporarySolution  {
            val solutionName = buffer.readString()
            val solutionTempDirectory = buffer.readString()
            val tag = buffer.readNullable { buffer.readString() }
            return RdTemporarySolution(solutionName, solutionTempDirectory, tag)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTemporarySolution)  {
            buffer.writeString(value.solutionName)
            buffer.writeString(value.solutionTempDirectory)
            buffer.writeNullable(value.tag) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdTemporarySolution
        
        if (solutionName != other.solutionName) return false
        if (solutionTempDirectory != other.solutionTempDirectory) return false
        if (tag != other.tag) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + solutionName.hashCode()
        __r = __r*31 + solutionTempDirectory.hashCode()
        __r = __r*31 + if (tag != null) tag.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTemporarySolution (")
        printer.indent {
            print("solutionName = "); solutionName.print(printer); println()
            print("solutionTempDirectory = "); solutionTempDirectory.print(printer); println()
            print("tag = "); tag.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdTextChunk (
    val text: String,
    val attributes: RdSimpleTextAttributes
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdTextChunk> {
        override val _type: KClass<RdTextChunk> = RdTextChunk::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTextChunk  {
            val text = buffer.readString()
            val attributes = RdSimpleTextAttributes.read(ctx, buffer)
            return RdTextChunk(text, attributes)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTextChunk)  {
            buffer.writeString(value.text)
            RdSimpleTextAttributes.write(ctx, buffer, value.attributes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdTextChunk
        
        if (text != other.text) return false
        if (attributes != other.attributes) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + text.hashCode()
        __r = __r*31 + attributes.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTextChunk (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("attributes = "); attributes.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
enum class RdTextModificationKind {
    NotSpecified, 
    LeftSide, 
    RightSide, 
    Reset;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<RdTextModificationKind>()
        
    }
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class RdTextRange (
    val startOffset: Int,
    val endOffset: Int
) : IPrintable {
    //companion
    
    companion object : IMarshaller<RdTextRange> {
        override val _type: KClass<RdTextRange> = RdTextRange::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTextRange  {
            val startOffset = buffer.readInt()
            val endOffset = buffer.readInt()
            return RdTextRange(startOffset, endOffset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTextRange)  {
            buffer.writeInt(value.startOffset)
            buffer.writeInt(value.endOffset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdTextRange
        
        if (startOffset != other.startOffset) return false
        if (endOffset != other.endOffset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + startOffset.hashCode()
        __r = __r*31 + endOffset.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTextRange (")
        printer.indent {
            print("startOffset = "); startOffset.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class RdTransparentEditorChange (
    editorId: TextControlId
) : RdEditorChange (
    editorId
), RdTransparentStep {
    //companion
    
    companion object : IAbstractDeclaration<RdTransparentEditorChange> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): RdTransparentEditorChange  {
            val objectStartPosition = buffer.position
            val editorId = TextControlId.read(ctx, buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return RdTransparentEditorChange_Unknown(editorId, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class RdTransparentEditorChange_Unknown (
    editorId: TextControlId,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : RdTransparentEditorChange (
    editorId
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<RdTransparentEditorChange_Unknown> {
        override val _type: KClass<RdTransparentEditorChange_Unknown> = RdTransparentEditorChange_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTransparentEditorChange_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTransparentEditorChange_Unknown)  {
            TextControlId.write(ctx, buffer, value.editorId)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdTransparentEditorChange_Unknown
        
        if (editorId != other.editorId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + editorId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTransparentEditorChange_Unknown (")
        printer.indent {
            print("editorId = "); editorId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
interface RdTransparentStep
{
}

/**
 * #### Generated from [SolutionModel.kt]
 */
class RdTypeKeyRequest (
    val char: Char,
    val editorId: TextControlId,
    id: Int
) : RdRequest (
    id
) {
    //companion
    
    companion object : IMarshaller<RdTypeKeyRequest> {
        override val _type: KClass<RdTypeKeyRequest> = RdTypeKeyRequest::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdTypeKeyRequest  {
            val id = buffer.readInt()
            val char = buffer.readChar()
            val editorId = TextControlId.read(ctx, buffer)
            return RdTypeKeyRequest(char, editorId, id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdTypeKeyRequest)  {
            buffer.writeInt(value.id)
            buffer.writeChar(value.char)
            TextControlId.write(ctx, buffer, value.editorId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdTypeKeyRequest
        
        if (char != other.char) return false
        if (editorId != other.editorId) return false
        if (id != other.id) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + char.hashCode()
        __r = __r*31 + editorId.hashCode()
        __r = __r*31 + id.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdTypeKeyRequest (")
        printer.indent {
            print("char = "); char.print(printer); println()
            print("editorId = "); editorId.print(printer); println()
            print("id = "); id.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdUndoGroup (
    val id: Int,
    val name: String,
    val steps: List<RdPatchStep>
) : RdPatchStep (
) {
    //companion
    
    companion object : IMarshaller<RdUndoGroup> {
        override val _type: KClass<RdUndoGroup> = RdUndoGroup::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdUndoGroup  {
            val id = buffer.readInt()
            val name = buffer.readString()
            val steps = buffer.readList { ctx.serializers.readPolymorphic<RdPatchStep>(ctx, buffer, RdPatchStep) }
            return RdUndoGroup(id, name, steps)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdUndoGroup)  {
            buffer.writeInt(value.id)
            buffer.writeString(value.name)
            buffer.writeList(value.steps) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdUndoGroup
        
        if (id != other.id) return false
        if (name != other.name) return false
        if (steps != other.steps) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + name.hashCode()
        __r = __r*31 + steps.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdUndoGroup (")
        printer.indent {
            print("id = "); id.print(printer); println()
            print("name = "); name.print(printer); println()
            print("steps = "); steps.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RdVirtualSolution (
    val solutionName: String,
    val solutionDirectory: String,
    val projectFilePaths: List<String>
) : RdSolutionDescription (
) {
    //companion
    
    companion object : IMarshaller<RdVirtualSolution> {
        override val _type: KClass<RdVirtualSolution> = RdVirtualSolution::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RdVirtualSolution  {
            val solutionName = buffer.readString()
            val solutionDirectory = buffer.readString()
            val projectFilePaths = buffer.readList { buffer.readString() }
            return RdVirtualSolution(solutionName, solutionDirectory, projectFilePaths)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RdVirtualSolution)  {
            buffer.writeString(value.solutionName)
            buffer.writeString(value.solutionDirectory)
            buffer.writeList(value.projectFilePaths) { v -> buffer.writeString(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RdVirtualSolution
        
        if (solutionName != other.solutionName) return false
        if (solutionDirectory != other.solutionDirectory) return false
        if (projectFilePaths != other.projectFilePaths) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + solutionName.hashCode()
        __r = __r*31 + solutionDirectory.hashCode()
        __r = __r*31 + projectFilePaths.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RdVirtualSolution (")
        printer.indent {
            print("solutionName = "); solutionName.print(printer); println()
            print("solutionDirectory = "); solutionDirectory.print(printer); println()
            print("projectFilePaths = "); projectFilePaths.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
enum class ReadonlyModeReasons {
    Build, 
    LowOverallPerformance, 
    TooManyUser;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ReadonlyModeReasons>()
        
    }
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class RichTooltipModel (
    val richText: RichAttributedTextModel
) : TooltipModel (
) {
    //companion
    
    companion object : IMarshaller<RichTooltipModel> {
        override val _type: KClass<RichTooltipModel> = RichTooltipModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): RichTooltipModel  {
            val richText = RichAttributedTextModel.read(ctx, buffer)
            return RichTooltipModel(richText)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: RichTooltipModel)  {
            RichAttributedTextModel.write(ctx, buffer, value.richText)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as RichTooltipModel
        
        if (richText != other.richText) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + richText.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("RichTooltipModel (")
        printer.indent {
            print("richText = "); richText.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
enum class ScrollKind {
    Center, 
    UpperHalf, 
    LowerHalf, 
    Smart, 
    Relative;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ScrollKind>()
        
    }
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class ScrollingInfo (
    val kind: ScrollKind,
    val docOffset: Int?
) : IPrintable {
    //companion
    
    companion object : IMarshaller<ScrollingInfo> {
        override val _type: KClass<ScrollingInfo> = ScrollingInfo::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ScrollingInfo  {
            val kind = buffer.readEnum<ScrollKind>()
            val docOffset = buffer.readNullable { buffer.readInt() }
            return ScrollingInfo(kind, docOffset)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ScrollingInfo)  {
            buffer.writeEnum(value.kind)
            buffer.writeNullable(value.docOffset) { buffer.writeInt(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as ScrollingInfo
        
        if (kind != other.kind) return false
        if (docOffset != other.docOffset) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + kind.hashCode()
        __r = __r*31 + if (docOffset != null) docOffset.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ScrollingInfo (")
        printer.indent {
            print("kind = "); kind.print(printer); println()
            print("docOffset = "); docOffset.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class SelectionRange (
    val selectionAnchor: DocOffsetAndVirtualModel,
    val activePosition: DocOffsetAndVirtualModel
) : IPrintable {
    //companion
    
    companion object : IMarshaller<SelectionRange> {
        override val _type: KClass<SelectionRange> = SelectionRange::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SelectionRange  {
            val selectionAnchor = DocOffsetAndVirtualModel.read(ctx, buffer)
            val activePosition = DocOffsetAndVirtualModel.read(ctx, buffer)
            return SelectionRange(selectionAnchor, activePosition)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SelectionRange)  {
            DocOffsetAndVirtualModel.write(ctx, buffer, value.selectionAnchor)
            DocOffsetAndVirtualModel.write(ctx, buffer, value.activePosition)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SelectionRange
        
        if (selectionAnchor != other.selectionAnchor) return false
        if (activePosition != other.activePosition) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + selectionAnchor.hashCode()
        __r = __r*31 + activePosition.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SelectionRange (")
        printer.indent {
            print("selectionAnchor = "); selectionAnchor.print(printer); println()
            print("activePosition = "); activePosition.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class SelectionRangeWithVersion (
    val selection: SelectionRange,
    val version: SelectionVersion
) : SelectionRangeWithVersionIntermediate (
) {
    //companion
    
    companion object : IMarshaller<SelectionRangeWithVersion> {
        override val _type: KClass<SelectionRangeWithVersion> = SelectionRangeWithVersion::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SelectionRangeWithVersion  {
            val selection = SelectionRange.read(ctx, buffer)
            val version = SelectionVersion.read(ctx, buffer)
            return SelectionRangeWithVersion(selection, version)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SelectionRangeWithVersion)  {
            SelectionRange.write(ctx, buffer, value.selection)
            SelectionVersion.write(ctx, buffer, value.version)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SelectionRangeWithVersion
        
        if (selection != other.selection) return false
        if (version != other.version) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + selection.hashCode()
        __r = __r*31 + version.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SelectionRangeWithVersion (")
        printer.indent {
            print("selection = "); selection.print(printer); println()
            print("version = "); version.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class SelectionRangeWithVersionIntermediate (
) : IPrintable, RdCaretModelChange {
    //companion
    
    companion object : IAbstractDeclaration<SelectionRangeWithVersionIntermediate> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): SelectionRangeWithVersionIntermediate  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return SelectionRangeWithVersionIntermediate_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class SelectionRangeWithVersionIntermediate_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : SelectionRangeWithVersionIntermediate (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<SelectionRangeWithVersionIntermediate_Unknown> {
        override val _type: KClass<SelectionRangeWithVersionIntermediate_Unknown> = SelectionRangeWithVersionIntermediate_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SelectionRangeWithVersionIntermediate_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SelectionRangeWithVersionIntermediate_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SelectionRangeWithVersionIntermediate_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SelectionRangeWithVersionIntermediate_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class SelectionVersion (
    val masterVersion: Int,
    val slaveVersion: Int
) : RdAbstractEditorVersion (
) {
    //companion
    
    companion object : IMarshaller<SelectionVersion> {
        override val _type: KClass<SelectionVersion> = SelectionVersion::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SelectionVersion  {
            val masterVersion = buffer.readInt()
            val slaveVersion = buffer.readInt()
            return SelectionVersion(masterVersion, slaveVersion)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SelectionVersion)  {
            buffer.writeInt(value.masterVersion)
            buffer.writeInt(value.slaveVersion)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SelectionVersion
        
        if (masterVersion != other.masterVersion) return false
        if (slaveVersion != other.slaveVersion) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + masterVersion.hashCode()
        __r = __r*31 + slaveVersion.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SelectionVersion (")
        printer.indent {
            print("masterVersion = "); masterVersion.print(printer); println()
            print("slaveVersion = "); slaveVersion.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class Solution private constructor(
    private val _close: RdSignal<Unit>,
    val solutionOpenStrategy: RdSolutionOpenStrategy,
    val solutionProperties: RdSolutionProperties,
    val solutionLifecycle: SolutionLifecycle,
    val documentsOperationModel: DocumentsOperationModel,
    val daemon: DaemonModel,
    val actionPopupSession: ActionPopupSession,
    private val _leadsPopupModel: RdOptionalProperty<com.jetbrains.ide.model.uiautomation.BeAbstractPopup>,
    private val _navigate: RdSignal<Navigation>,
    val customData: RdCustomData,
    private val _isLoaded: RdOptionalProperty<Boolean>,
    private val _isLoading: RdOptionalProperty<Boolean>,
    private val _activeMsBuildPath: RdProperty<String?>,
    private val _readonlyMode: RdProperty<ReadonlyModeReasons?>,
    private val _writeLockAcquired: RdSignal<WriteLockInfo>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<Solution> {
        override val _type: KClass<Solution> = Solution::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): Solution  {
            val _id = RdId.read(buffer)
            val _close = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val solutionOpenStrategy = ctx.serializers.readPolymorphic<RdSolutionOpenStrategy>(ctx, buffer, RdSolutionOpenStrategy)
            val solutionProperties = RdSolutionProperties.read(ctx, buffer)
            val solutionLifecycle = SolutionLifecycle.read(ctx, buffer)
            val documentsOperationModel = DocumentsOperationModel.read(ctx, buffer)
            val daemon = DaemonModel.read(ctx, buffer)
            val actionPopupSession = ActionPopupSession.read(ctx, buffer)
            val _leadsPopupModel = RdOptionalProperty.read(ctx, buffer, com.jetbrains.ide.model.uiautomation.BeAbstractPopup)
            val _navigate = RdSignal.read(ctx, buffer, AbstractPolymorphic(Navigation))
            val customData = RdCustomData.read(ctx, buffer)
            val _isLoaded = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _isLoading = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _activeMsBuildPath = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _readonlyMode = RdProperty.read(ctx, buffer, __ReadonlyModeReasonsNullableSerializer)
            val _writeLockAcquired = RdSignal.read(ctx, buffer, WriteLockInfo)
            return Solution(_close, solutionOpenStrategy, solutionProperties, solutionLifecycle, documentsOperationModel, daemon, actionPopupSession, _leadsPopupModel, _navigate, customData, _isLoaded, _isLoading, _activeMsBuildPath, _readonlyMode, _writeLockAcquired).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: Solution)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._close)
            ctx.serializers.writePolymorphic(ctx, buffer, value.solutionOpenStrategy)
            RdSolutionProperties.write(ctx, buffer, value.solutionProperties)
            SolutionLifecycle.write(ctx, buffer, value.solutionLifecycle)
            DocumentsOperationModel.write(ctx, buffer, value.documentsOperationModel)
            DaemonModel.write(ctx, buffer, value.daemon)
            ActionPopupSession.write(ctx, buffer, value.actionPopupSession)
            RdOptionalProperty.write(ctx, buffer, value._leadsPopupModel)
            RdSignal.write(ctx, buffer, value._navigate)
            RdCustomData.write(ctx, buffer, value.customData)
            RdOptionalProperty.write(ctx, buffer, value._isLoaded)
            RdOptionalProperty.write(ctx, buffer, value._isLoading)
            RdProperty.write(ctx, buffer, value._activeMsBuildPath)
            RdProperty.write(ctx, buffer, value._readonlyMode)
            RdSignal.write(ctx, buffer, value._writeLockAcquired)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        private val __ReadonlyModeReasonsNullableSerializer = ReadonlyModeReasons.marshaller.nullable()
        
    }
    //fields
    val close: IAsyncSignal<Unit> get() = _close
    val leadsPopupModel: IOptProperty<com.jetbrains.ide.model.uiautomation.BeAbstractPopup> get() = _leadsPopupModel
    val navigate: ISignal<Navigation> get() = _navigate
    val isLoaded: IOptProperty<Boolean> get() = _isLoaded
    val isLoading: IOptProperty<Boolean> get() = _isLoading
    val activeMsBuildPath: IProperty<String?> get() = _activeMsBuildPath
    val readonlyMode: IProperty<ReadonlyModeReasons?> get() = _readonlyMode
    
    /**
     * UserName who takes write lock
     */
    val writeLockAcquired: ISignal<WriteLockInfo> get() = _writeLockAcquired
    //methods
    //initializer
    init {
        _isLoaded.optimizeNested = true
        _isLoading.optimizeNested = true
        _activeMsBuildPath.optimizeNested = true
        _readonlyMode.optimizeNested = true
    }
    
    init {
        _close.async = true
        _activeMsBuildPath.async = true
    }
    
    init {
        bindableChildren.add("close" to _close)
        bindableChildren.add("solutionOpenStrategy" to solutionOpenStrategy)
        bindableChildren.add("solutionProperties" to solutionProperties)
        bindableChildren.add("solutionLifecycle" to solutionLifecycle)
        bindableChildren.add("documentsOperationModel" to documentsOperationModel)
        bindableChildren.add("daemon" to daemon)
        bindableChildren.add("actionPopupSession" to actionPopupSession)
        bindableChildren.add("leadsPopupModel" to _leadsPopupModel)
        bindableChildren.add("navigate" to _navigate)
        bindableChildren.add("customData" to customData)
        bindableChildren.add("isLoaded" to _isLoaded)
        bindableChildren.add("isLoading" to _isLoading)
        bindableChildren.add("activeMsBuildPath" to _activeMsBuildPath)
        bindableChildren.add("readonlyMode" to _readonlyMode)
        bindableChildren.add("writeLockAcquired" to _writeLockAcquired)
    }
    
    //secondary constructor
    constructor(
        solutionOpenStrategy: RdSolutionOpenStrategy
    ) : this(
        RdSignal<Unit>(FrameworkMarshallers.Void),
        solutionOpenStrategy,
        RdSolutionProperties(),
        SolutionLifecycle(),
        DocumentsOperationModel(),
        DaemonModel(),
        ActionPopupSession(),
        RdOptionalProperty<com.jetbrains.ide.model.uiautomation.BeAbstractPopup>(com.jetbrains.ide.model.uiautomation.BeAbstractPopup),
        RdSignal<Navigation>(AbstractPolymorphic(Navigation)),
        RdCustomData(),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdProperty<ReadonlyModeReasons?>(null, __ReadonlyModeReasonsNullableSerializer),
        RdSignal<WriteLockInfo>(WriteLockInfo)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("Solution (")
        printer.indent {
            print("close = "); _close.print(printer); println()
            print("solutionOpenStrategy = "); solutionOpenStrategy.print(printer); println()
            print("solutionProperties = "); solutionProperties.print(printer); println()
            print("solutionLifecycle = "); solutionLifecycle.print(printer); println()
            print("documentsOperationModel = "); documentsOperationModel.print(printer); println()
            print("daemon = "); daemon.print(printer); println()
            print("actionPopupSession = "); actionPopupSession.print(printer); println()
            print("leadsPopupModel = "); _leadsPopupModel.print(printer); println()
            print("navigate = "); _navigate.print(printer); println()
            print("customData = "); customData.print(printer); println()
            print("isLoaded = "); _isLoaded.print(printer); println()
            print("isLoading = "); _isLoading.print(printer); println()
            print("activeMsBuildPath = "); _activeMsBuildPath.print(printer); println()
            print("readonlyMode = "); _readonlyMode.print(printer); println()
            print("writeLockAcquired = "); _writeLockAcquired.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): Solution   {
        return Solution(
            _close.deepClonePolymorphic(),
            solutionOpenStrategy.deepClonePolymorphic(),
            solutionProperties.deepClonePolymorphic(),
            solutionLifecycle.deepClonePolymorphic(),
            documentsOperationModel.deepClonePolymorphic(),
            daemon.deepClonePolymorphic(),
            actionPopupSession.deepClonePolymorphic(),
            _leadsPopupModel.deepClonePolymorphic(),
            _navigate.deepClonePolymorphic(),
            customData.deepClonePolymorphic(),
            _isLoaded.deepClonePolymorphic(),
            _isLoading.deepClonePolymorphic(),
            _activeMsBuildPath.deepClonePolymorphic(),
            _readonlyMode.deepClonePolymorphic(),
            _writeLockAcquired.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class SolutionLifecycle private constructor(
    private val _fullStartupFinished: RdOptionalProperty<LoadResult>,
    private val _isReadyForTyping: RdOptionalProperty<Boolean>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<SolutionLifecycle> {
        override val _type: KClass<SolutionLifecycle> = SolutionLifecycle::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SolutionLifecycle  {
            val _id = RdId.read(buffer)
            val _fullStartupFinished = RdOptionalProperty.read(ctx, buffer, LoadResult)
            val _isReadyForTyping = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            return SolutionLifecycle(_fullStartupFinished, _isReadyForTyping).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SolutionLifecycle)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._fullStartupFinished)
            RdOptionalProperty.write(ctx, buffer, value._isReadyForTyping)
        }
        
        
    }
    //fields
    val fullStartupFinished: IOptProperty<LoadResult> get() = _fullStartupFinished
    val isReadyForTyping: IOptProperty<Boolean> get() = _isReadyForTyping
    //methods
    //initializer
    init {
        _isReadyForTyping.optimizeNested = true
    }
    
    init {
        bindableChildren.add("fullStartupFinished" to _fullStartupFinished)
        bindableChildren.add("isReadyForTyping" to _isReadyForTyping)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<LoadResult>(LoadResult),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SolutionLifecycle (")
        printer.indent {
            print("fullStartupFinished = "); _fullStartupFinished.print(printer); println()
            print("isReadyForTyping = "); _isReadyForTyping.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): SolutionLifecycle   {
        return SolutionLifecycle(
            _fullStartupFinished.deepClonePolymorphic(),
            _isReadyForTyping.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class StringTooltipModel (
    val text: String?
) : TooltipModel (
) {
    //companion
    
    companion object : IMarshaller<StringTooltipModel> {
        override val _type: KClass<StringTooltipModel> = StringTooltipModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): StringTooltipModel  {
            val text = buffer.readNullable { buffer.readString() }
            return StringTooltipModel(text)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: StringTooltipModel)  {
            buffer.writeNullable(value.text) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as StringTooltipModel
        
        if (text != other.text) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (text != null) text.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("StringTooltipModel (")
        printer.indent {
            print("text = "); text.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class TextControlId (
    val documentId: RdDocumentId,
    val tabIndex: Int,
    val kind: TextControlLocation,
    val clientId: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<TextControlId> {
        override val _type: KClass<TextControlId> = TextControlId::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TextControlId  {
            val documentId = ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId)
            val tabIndex = buffer.readInt()
            val kind = buffer.readEnum<TextControlLocation>()
            val clientId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            return TextControlId(documentId, tabIndex, kind, clientId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TextControlId)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentId)
            buffer.writeInt(value.tabIndex)
            buffer.writeEnum(value.kind)
            ctx.writeInterned(buffer, value.clientId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TextControlId
        
        if (documentId != other.documentId) return false
        if (tabIndex != other.tabIndex) return false
        if (kind != other.kind) return false
        if (clientId != other.clientId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + documentId.hashCode()
        __r = __r*31 + tabIndex.hashCode()
        __r = __r*31 + kind.hashCode()
        __r = __r*31 + clientId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TextControlId (")
        printer.indent {
            print("documentId = "); documentId.print(printer); println()
            print("tabIndex = "); tabIndex.print(printer); println()
            print("kind = "); kind.print(printer); println()
            print("clientId = "); clientId.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
enum class TextControlLocation {
    Unknown, 
    EditorTab, 
    ToolWindow, 
    StandaloneWindow, 
    Console, 
    Preview, 
    Diff, 
    Custom;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<TextControlLocation>()
        
    }
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class TextControlModel private constructor(
    private val _versionBeforeTypingSession: RdOptionalProperty<SelectionVersion>,
    private val _selection: RdOptionalProperty<SelectionRangeWithVersion>,
    private val _visibleRange: RdOptionalProperty<VisibleRange>,
    val content: RdDocumentId,
    private val _tabSize: RdOptionalProperty<Int>,
    private val _rightMargin: RdOptionalProperty<Int>,
    private val _useTab: RdOptionalProperty<Boolean>,
    private val _indentSize: RdOptionalProperty<Int>,
    private val _spaceWidth: RdOptionalProperty<Int>,
    private val _scrolling: RdSignal<ScrollingInfo>,
    private val _isVisible: RdOptionalProperty<Boolean>,
    private val _isReadonly: RdOptionalProperty<Boolean>,
    val origin: OriginKind,
    val focusOnCreation: Boolean?,
    private val _notificationPanels: RdMap<Int, NotificationPanelModel>,
    private val _markup: RdOptionalProperty<RdMarkupModelBase>,
    private val _crumbs: RdList<CrumbModel>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<TextControlModel> {
        override val _type: KClass<TextControlModel> = TextControlModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TextControlModel  {
            val _id = RdId.read(buffer)
            val _versionBeforeTypingSession = RdOptionalProperty.read(ctx, buffer, SelectionVersion)
            val _selection = RdOptionalProperty.read(ctx, buffer, SelectionRangeWithVersion)
            val _visibleRange = RdOptionalProperty.read(ctx, buffer, VisibleRange)
            val content = ctx.serializers.readPolymorphic<RdDocumentId>(ctx, buffer, RdDocumentId)
            val _tabSize = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _rightMargin = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _useTab = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _indentSize = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _spaceWidth = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _scrolling = RdSignal.read(ctx, buffer, ScrollingInfo)
            val _isVisible = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _isReadonly = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val origin = buffer.readEnum<OriginKind>()
            val focusOnCreation = buffer.readNullable { buffer.readBool() }
            val _notificationPanels = RdMap.read(ctx, buffer, FrameworkMarshallers.Int, NotificationPanelModel)
            val _markup = RdOptionalProperty.read(ctx, buffer, AbstractPolymorphic(RdMarkupModelBase))
            val _crumbs = RdList.read(ctx, buffer, CrumbModel)
            return TextControlModel(_versionBeforeTypingSession, _selection, _visibleRange, content, _tabSize, _rightMargin, _useTab, _indentSize, _spaceWidth, _scrolling, _isVisible, _isReadonly, origin, focusOnCreation, _notificationPanels, _markup, _crumbs).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TextControlModel)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._versionBeforeTypingSession)
            RdOptionalProperty.write(ctx, buffer, value._selection)
            RdOptionalProperty.write(ctx, buffer, value._visibleRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            RdOptionalProperty.write(ctx, buffer, value._tabSize)
            RdOptionalProperty.write(ctx, buffer, value._rightMargin)
            RdOptionalProperty.write(ctx, buffer, value._useTab)
            RdOptionalProperty.write(ctx, buffer, value._indentSize)
            RdOptionalProperty.write(ctx, buffer, value._spaceWidth)
            RdSignal.write(ctx, buffer, value._scrolling)
            RdOptionalProperty.write(ctx, buffer, value._isVisible)
            RdOptionalProperty.write(ctx, buffer, value._isReadonly)
            buffer.writeEnum(value.origin)
            buffer.writeNullable(value.focusOnCreation) { buffer.writeBool(it) }
            RdMap.write(ctx, buffer, value._notificationPanels)
            RdOptionalProperty.write(ctx, buffer, value._markup)
            RdList.write(ctx, buffer, value._crumbs)
        }
        
        
    }
    //fields
    val versionBeforeTypingSession: IOptProperty<SelectionVersion> get() = _versionBeforeTypingSession
    val selection: IOptProperty<SelectionRangeWithVersion> get() = _selection
    val visibleRange: IOptProperty<VisibleRange> get() = _visibleRange
    val tabSize: IOptProperty<Int> get() = _tabSize
    val rightMargin: IOptProperty<Int> get() = _rightMargin
    val useTab: IOptProperty<Boolean> get() = _useTab
    val indentSize: IOptProperty<Int> get() = _indentSize
    val spaceWidth: IOptProperty<Int> get() = _spaceWidth
    val scrolling: ISignal<ScrollingInfo> get() = _scrolling
    val isVisible: IOptProperty<Boolean> get() = _isVisible
    val isReadonly: IOptProperty<Boolean> get() = _isReadonly
    val notificationPanels: IMutableViewableMap<Int, NotificationPanelModel> get() = _notificationPanels
    val markup: IOptProperty<RdMarkupModelBase> get() = _markup
    val crumbs: IMutableViewableList<CrumbModel> get() = _crumbs
    //methods
    //initializer
    init {
        _versionBeforeTypingSession.optimizeNested = true
        _selection.optimizeNested = true
        _tabSize.optimizeNested = true
        _rightMargin.optimizeNested = true
        _useTab.optimizeNested = true
        _indentSize.optimizeNested = true
        _spaceWidth.optimizeNested = true
        _isVisible.optimizeNested = true
        _isReadonly.optimizeNested = true
    }
    
    init {
        bindableChildren.add("versionBeforeTypingSession" to _versionBeforeTypingSession)
        bindableChildren.add("selection" to _selection)
        bindableChildren.add("visibleRange" to _visibleRange)
        bindableChildren.add("tabSize" to _tabSize)
        bindableChildren.add("rightMargin" to _rightMargin)
        bindableChildren.add("useTab" to _useTab)
        bindableChildren.add("indentSize" to _indentSize)
        bindableChildren.add("spaceWidth" to _spaceWidth)
        bindableChildren.add("scrolling" to _scrolling)
        bindableChildren.add("isVisible" to _isVisible)
        bindableChildren.add("isReadonly" to _isReadonly)
        bindableChildren.add("notificationPanels" to _notificationPanels)
        bindableChildren.add("markup" to _markup)
        bindableChildren.add("crumbs" to _crumbs)
    }
    
    //secondary constructor
    constructor(
        content: RdDocumentId,
        origin: OriginKind,
        focusOnCreation: Boolean?
    ) : this(
        RdOptionalProperty<SelectionVersion>(SelectionVersion),
        RdOptionalProperty<SelectionRangeWithVersion>(SelectionRangeWithVersion),
        RdOptionalProperty<VisibleRange>(VisibleRange),
        content,
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdSignal<ScrollingInfo>(ScrollingInfo),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        origin,
        focusOnCreation,
        RdMap<Int, NotificationPanelModel>(FrameworkMarshallers.Int, NotificationPanelModel),
        RdOptionalProperty<RdMarkupModelBase>(AbstractPolymorphic(RdMarkupModelBase)),
        RdList<CrumbModel>(CrumbModel)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TextControlModel (")
        printer.indent {
            print("versionBeforeTypingSession = "); _versionBeforeTypingSession.print(printer); println()
            print("selection = "); _selection.print(printer); println()
            print("visibleRange = "); _visibleRange.print(printer); println()
            print("content = "); content.print(printer); println()
            print("tabSize = "); _tabSize.print(printer); println()
            print("rightMargin = "); _rightMargin.print(printer); println()
            print("useTab = "); _useTab.print(printer); println()
            print("indentSize = "); _indentSize.print(printer); println()
            print("spaceWidth = "); _spaceWidth.print(printer); println()
            print("scrolling = "); _scrolling.print(printer); println()
            print("isVisible = "); _isVisible.print(printer); println()
            print("isReadonly = "); _isReadonly.print(printer); println()
            print("origin = "); origin.print(printer); println()
            print("focusOnCreation = "); focusOnCreation.print(printer); println()
            print("notificationPanels = "); _notificationPanels.print(printer); println()
            print("markup = "); _markup.print(printer); println()
            print("crumbs = "); _crumbs.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): TextControlModel   {
        return TextControlModel(
            _versionBeforeTypingSession.deepClonePolymorphic(),
            _selection.deepClonePolymorphic(),
            _visibleRange.deepClonePolymorphic(),
            content,
            _tabSize.deepClonePolymorphic(),
            _rightMargin.deepClonePolymorphic(),
            _useTab.deepClonePolymorphic(),
            _indentSize.deepClonePolymorphic(),
            _spaceWidth.deepClonePolymorphic(),
            _scrolling.deepClonePolymorphic(),
            _isVisible.deepClonePolymorphic(),
            _isReadonly.deepClonePolymorphic(),
            origin,
            focusOnCreation,
            _notificationPanels.deepClonePolymorphic(),
            _markup.deepClonePolymorphic(),
            _crumbs.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class TextControlSnapshot (
    val selection: SelectionRange
) : IPrintable {
    //companion
    
    companion object : IMarshaller<TextControlSnapshot> {
        override val _type: KClass<TextControlSnapshot> = TextControlSnapshot::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TextControlSnapshot  {
            val selection = SelectionRange.read(ctx, buffer)
            return TextControlSnapshot(selection)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TextControlSnapshot)  {
            SelectionRange.write(ctx, buffer, value.selection)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TextControlSnapshot
        
        if (selection != other.selection) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + selection.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TextControlSnapshot (")
        printer.indent {
            print("selection = "); selection.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class TodoHighlighterModel (
    val patternId: String,
    layer: Int,
    isExactRange: Boolean,
    documentVersion: AbstractDocumentVersion,
    isGreedyToLeft: Boolean,
    isGreedyToRight: Boolean,
    isThinErrorStripeMark: Boolean,
    textToHighlight: String?,
    id: Long,
    attributeId: String,
    start: Int,
    end: Int
) : HighlighterModel (
    layer,
    isExactRange,
    documentVersion,
    isGreedyToLeft,
    isGreedyToRight,
    isThinErrorStripeMark,
    textToHighlight,
    id,
    attributeId,
    start,
    end
) {
    //companion
    
    companion object : IMarshaller<TodoHighlighterModel> {
        override val _type: KClass<TodoHighlighterModel> = TodoHighlighterModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TodoHighlighterModel  {
            val layer = buffer.readInt()
            val isExactRange = buffer.readBool()
            val documentVersion = ctx.serializers.readPolymorphic<AbstractDocumentVersion>(ctx, buffer, AbstractDocumentVersion)
            val isGreedyToLeft = buffer.readBool()
            val isGreedyToRight = buffer.readBool()
            val isThinErrorStripeMark = buffer.readBool()
            val textToHighlight = buffer.readNullable { buffer.readString() }
            val id = buffer.readLong()
            val attributeId = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val start = buffer.readInt()
            val end = buffer.readInt()
            val patternId = buffer.readString()
            return TodoHighlighterModel(patternId, layer, isExactRange, documentVersion, isGreedyToLeft, isGreedyToRight, isThinErrorStripeMark, textToHighlight, id, attributeId, start, end)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TodoHighlighterModel)  {
            buffer.writeInt(value.layer)
            buffer.writeBool(value.isExactRange)
            ctx.serializers.writePolymorphic(ctx, buffer, value.documentVersion)
            buffer.writeBool(value.isGreedyToLeft)
            buffer.writeBool(value.isGreedyToRight)
            buffer.writeBool(value.isThinErrorStripeMark)
            buffer.writeNullable(value.textToHighlight) { buffer.writeString(it) }
            buffer.writeLong(value.id)
            ctx.writeInterned(buffer, value.attributeId, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            buffer.writeInt(value.start)
            buffer.writeInt(value.end)
            buffer.writeString(value.patternId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TodoHighlighterModel
        
        if (patternId != other.patternId) return false
        if (layer != other.layer) return false
        if (isExactRange != other.isExactRange) return false
        if (documentVersion != other.documentVersion) return false
        if (isGreedyToLeft != other.isGreedyToLeft) return false
        if (isGreedyToRight != other.isGreedyToRight) return false
        if (isThinErrorStripeMark != other.isThinErrorStripeMark) return false
        if (textToHighlight != other.textToHighlight) return false
        if (id != other.id) return false
        if (attributeId != other.attributeId) return false
        if (start != other.start) return false
        if (end != other.end) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + patternId.hashCode()
        __r = __r*31 + layer.hashCode()
        __r = __r*31 + isExactRange.hashCode()
        __r = __r*31 + documentVersion.hashCode()
        __r = __r*31 + isGreedyToLeft.hashCode()
        __r = __r*31 + isGreedyToRight.hashCode()
        __r = __r*31 + isThinErrorStripeMark.hashCode()
        __r = __r*31 + if (textToHighlight != null) textToHighlight.hashCode() else 0
        __r = __r*31 + id.hashCode()
        __r = __r*31 + attributeId.hashCode()
        __r = __r*31 + start.hashCode()
        __r = __r*31 + end.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TodoHighlighterModel (")
        printer.indent {
            print("patternId = "); patternId.print(printer); println()
            print("layer = "); layer.print(printer); println()
            print("isExactRange = "); isExactRange.print(printer); println()
            print("documentVersion = "); documentVersion.print(printer); println()
            print("isGreedyToLeft = "); isGreedyToLeft.print(printer); println()
            print("isGreedyToRight = "); isGreedyToRight.print(printer); println()
            print("isThinErrorStripeMark = "); isThinErrorStripeMark.print(printer); println()
            print("textToHighlight = "); textToHighlight.print(printer); println()
            print("id = "); id.print(printer); println()
            print("attributeId = "); attributeId.print(printer); println()
            print("start = "); start.print(printer); println()
            print("end = "); end.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class TooltipModel (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<TooltipModel> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): TooltipModel  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return TooltipModel_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class TooltipModel_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : TooltipModel (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<TooltipModel_Unknown> {
        override val _type: KClass<TooltipModel_Unknown> = TooltipModel_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TooltipModel_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TooltipModel_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TooltipModel_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TooltipModel_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class TooltipProviderModel private constructor(
    private val _getTooltip: RdCall<Long, TooltipModel>,
    key: String
) : MarkupModelExtension (
    key
) {
    //companion
    
    companion object : IMarshaller<TooltipProviderModel> {
        override val _type: KClass<TooltipProviderModel> = TooltipProviderModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TooltipProviderModel  {
            val _id = RdId.read(buffer)
            val key = buffer.readString()
            val _getTooltip = RdCall.read(ctx, buffer, FrameworkMarshallers.Long, AbstractPolymorphic(TooltipModel))
            return TooltipProviderModel(_getTooltip, key).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TooltipProviderModel)  {
            value.rdid.write(buffer)
            buffer.writeString(value.key)
            RdCall.write(ctx, buffer, value._getTooltip)
        }
        
        
    }
    //fields
    val getTooltip: RdCall<Long, TooltipModel> get() = _getTooltip
    //methods
    //initializer
    init {
        _getTooltip.async = true
    }
    
    init {
        bindableChildren.add("getTooltip" to _getTooltip)
    }
    
    //secondary constructor
    constructor(
        key: String
    ) : this(
        RdCall<Long, TooltipModel>(FrameworkMarshallers.Long, AbstractPolymorphic(TooltipModel)),
        key
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TooltipProviderModel (")
        printer.indent {
            print("getTooltip = "); _getTooltip.print(printer); println()
            print("key = "); key.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): TooltipProviderModel   {
        return TooltipProviderModel(
            _getTooltip.deepClonePolymorphic(),
            key
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
abstract class TreeNodeDescriptor (
    val presentation: List<RdColoredFragment>,
    val icon: IconModel?,
    val hasChildren: Boolean,
    val canNavigate: Boolean
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<TreeNodeDescriptor> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): TreeNodeDescriptor  {
            val objectStartPosition = buffer.position
            val presentation = buffer.readList { RdColoredFragment.read(ctx, buffer) }
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<IconModel>(ctx, buffer, IconModel) }
            val hasChildren = buffer.readBool()
            val canNavigate = buffer.readBool()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return TreeNodeDescriptor_Unknown(presentation, icon, hasChildren, canNavigate, unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class TreeNodeDescriptor_Unknown (
    presentation: List<RdColoredFragment>,
    icon: IconModel?,
    hasChildren: Boolean,
    canNavigate: Boolean,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : TreeNodeDescriptor (
    presentation,
    icon,
    hasChildren,
    canNavigate
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<TreeNodeDescriptor_Unknown> {
        override val _type: KClass<TreeNodeDescriptor_Unknown> = TreeNodeDescriptor_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TreeNodeDescriptor_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TreeNodeDescriptor_Unknown)  {
            buffer.writeList(value.presentation) { v -> RdColoredFragment.write(ctx, buffer, v) }
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeBool(value.hasChildren)
            buffer.writeBool(value.canNavigate)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TreeNodeDescriptor_Unknown
        
        if (presentation != other.presentation) return false
        if (icon != other.icon) return false
        if (hasChildren != other.hasChildren) return false
        if (canNavigate != other.canNavigate) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + presentation.hashCode()
        __r = __r*31 + if (icon != null) icon.hashCode() else 0
        __r = __r*31 + hasChildren.hashCode()
        __r = __r*31 + canNavigate.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TreeNodeDescriptor_Unknown (")
        printer.indent {
            print("presentation = "); presentation.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("hasChildren = "); hasChildren.print(printer); println()
            print("canNavigate = "); canNavigate.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class TypedAction (
    val actionId: String,
    val dataContext: List<RdDataConstant>,
    timestamp: Int
) : Operation (
    timestamp
) {
    //companion
    
    companion object : IMarshaller<TypedAction> {
        override val _type: KClass<TypedAction> = TypedAction::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TypedAction  {
            val timestamp = buffer.readInt()
            val actionId = buffer.readString()
            val dataContext = buffer.readList { ctx.serializers.readPolymorphic<RdDataConstant>(ctx, buffer, RdDataConstant) }
            return TypedAction(actionId, dataContext, timestamp)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TypedAction)  {
            buffer.writeInt(value.timestamp)
            buffer.writeString(value.actionId)
            buffer.writeList(value.dataContext) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TypedAction
        
        if (actionId != other.actionId) return false
        if (dataContext != other.dataContext) return false
        if (timestamp != other.timestamp) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + actionId.hashCode()
        __r = __r*31 + dataContext.hashCode()
        __r = __r*31 + timestamp.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TypedAction (")
        printer.indent {
            print("actionId = "); actionId.print(printer); println()
            print("dataContext = "); dataContext.print(printer); println()
            print("timestamp = "); timestamp.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class TypedKey (
    val char: Char,
    val isCompletionTerminator: Boolean,
    timestamp: Int
) : Operation (
    timestamp
) {
    //companion
    
    companion object : IMarshaller<TypedKey> {
        override val _type: KClass<TypedKey> = TypedKey::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TypedKey  {
            val timestamp = buffer.readInt()
            val char = buffer.readChar()
            val isCompletionTerminator = buffer.readBool()
            return TypedKey(char, isCompletionTerminator, timestamp)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TypedKey)  {
            buffer.writeInt(value.timestamp)
            buffer.writeChar(value.char)
            buffer.writeBool(value.isCompletionTerminator)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as TypedKey
        
        if (char != other.char) return false
        if (isCompletionTerminator != other.isCompletionTerminator) return false
        if (timestamp != other.timestamp) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + char.hashCode()
        __r = __r*31 + isCompletionTerminator.hashCode()
        __r = __r*31 + timestamp.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TypedKey (")
        printer.indent {
            print("char = "); char.print(printer); println()
            print("isCompletionTerminator = "); isCompletionTerminator.print(printer); println()
            print("timestamp = "); timestamp.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class TypingSessionState private constructor(
    val textControlId: TextControlId,
    val id: Int,
    private val _ack: RdSignal<Int>,
    private val _close: RdSignal<Unit>,
    private val _rollback: RdSignal<Unit>,
    private val _execute: RdSignal<Operation>,
    private val _executeReadonlyTypeAssist: RdSignal<TypedKey>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<TypingSessionState> {
        override val _type: KClass<TypingSessionState> = TypingSessionState::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TypingSessionState  {
            val _id = RdId.read(buffer)
            val textControlId = TextControlId.read(ctx, buffer)
            val id = buffer.readInt()
            val _ack = RdSignal.read(ctx, buffer, FrameworkMarshallers.Int)
            val _close = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _rollback = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _execute = RdSignal.read(ctx, buffer, AbstractPolymorphic(Operation))
            val _executeReadonlyTypeAssist = RdSignal.read(ctx, buffer, TypedKey)
            return TypingSessionState(textControlId, id, _ack, _close, _rollback, _execute, _executeReadonlyTypeAssist).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TypingSessionState)  {
            value.rdid.write(buffer)
            TextControlId.write(ctx, buffer, value.textControlId)
            buffer.writeInt(value.id)
            RdSignal.write(ctx, buffer, value._ack)
            RdSignal.write(ctx, buffer, value._close)
            RdSignal.write(ctx, buffer, value._rollback)
            RdSignal.write(ctx, buffer, value._execute)
            RdSignal.write(ctx, buffer, value._executeReadonlyTypeAssist)
        }
        
        
    }
    //fields
    val ack: ISignal<Int> get() = _ack
    val close: ISignal<Unit> get() = _close
    val rollback: ISignal<Unit> get() = _rollback
    val execute: ISignal<Operation> get() = _execute
    val executeReadonlyTypeAssist: ISignal<TypedKey> get() = _executeReadonlyTypeAssist
    //methods
    //initializer
    init {
        bindableChildren.add("ack" to _ack)
        bindableChildren.add("close" to _close)
        bindableChildren.add("rollback" to _rollback)
        bindableChildren.add("execute" to _execute)
        bindableChildren.add("executeReadonlyTypeAssist" to _executeReadonlyTypeAssist)
    }
    
    //secondary constructor
    constructor(
        textControlId: TextControlId,
        id: Int
    ) : this(
        textControlId,
        id,
        RdSignal<Int>(FrameworkMarshallers.Int),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdSignal<Operation>(AbstractPolymorphic(Operation)),
        RdSignal<TypedKey>(TypedKey)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TypingSessionState (")
        printer.indent {
            print("textControlId = "); textControlId.print(printer); println()
            print("id = "); id.print(printer); println()
            print("ack = "); _ack.print(printer); println()
            print("close = "); _close.print(printer); println()
            print("rollback = "); _rollback.print(printer); println()
            print("execute = "); _execute.print(printer); println()
            print("executeReadonlyTypeAssist = "); _executeReadonlyTypeAssist.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): TypingSessionState   {
        return TypingSessionState(
            textControlId,
            id,
            _ack.deepClonePolymorphic(),
            _close.deepClonePolymorphic(),
            _rollback.deepClonePolymorphic(),
            _execute.deepClonePolymorphic(),
            _executeReadonlyTypeAssist.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
class VisibleRange (
    val startOffset: Int,
    val endOffset: Int
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<VisibleRange> {
        override val _type: KClass<VisibleRange> = VisibleRange::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): VisibleRange  {
            val _id = RdId.read(buffer)
            val startOffset = buffer.readInt()
            val endOffset = buffer.readInt()
            return VisibleRange(startOffset, endOffset).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: VisibleRange)  {
            value.rdid.write(buffer)
            buffer.writeInt(value.startOffset)
            buffer.writeInt(value.endOffset)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("VisibleRange (")
        printer.indent {
            print("startOffset = "); startOffset.print(printer); println()
            print("endOffset = "); endOffset.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): VisibleRange   {
        return VisibleRange(
            startOffset,
            endOffset
        )
    }
    //contexts
}


/**
 * #### Generated from [SolutionModel.kt]
 */
data class WriteLockInfo (
    val userName: String,
    val actionName: String
) : IPrintable {
    //companion
    
    companion object : IMarshaller<WriteLockInfo> {
        override val _type: KClass<WriteLockInfo> = WriteLockInfo::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): WriteLockInfo  {
            val userName = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            val actionName = ctx.readInterned(buffer, "Protocol") { _, _ -> buffer.readString() }
            return WriteLockInfo(userName, actionName)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: WriteLockInfo)  {
            ctx.writeInterned(buffer, value.userName, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
            ctx.writeInterned(buffer, value.actionName, "Protocol") { _, _, internedValue -> buffer.writeString(internedValue) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as WriteLockInfo
        
        if (userName != other.userName) return false
        if (actionName != other.actionName) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + userName.hashCode()
        __r = __r*31 + actionName.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("WriteLockInfo (")
        printer.indent {
            print("userName = "); userName.print(printer); println()
            print("actionName = "); actionName.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}
