@file:Suppress("EXPERIMENTAL_API_USAGE","EXPERIMENTAL_UNSIGNED_LITERALS","PackageDirectoryMismatch","UnusedImport","unused","LocalVariableName","CanBeVal","PropertyName","EnumEntryName","ClassName","ObjectPropertyName","UnnecessaryVariable","SpellCheckingInspection")
package com.jetbrains.ide.model.uiautomation

import com.jetbrains.rd.framework.*
import com.jetbrains.rd.framework.base.*
import com.jetbrains.rd.framework.impl.*

import com.jetbrains.rd.util.lifetime.*
import com.jetbrains.rd.util.reactive.*
import com.jetbrains.rd.util.string.*
import com.jetbrains.rd.util.*
import kotlin.reflect.KClass



/**
 * #### Generated from [UIAutomationModel.kt]
 */
class UIAutomationInteractionModel private constructor(
    private val _currentPopup: RdProperty<BePopup?>,
    private val _activeToolWindows: RdList<BeToolWindow>,
    private val _activeDialogs: RdList<BeDialog>
) : RdExtBase() {
    //companion
    
    companion object : ISerializersOwner {
        
        override fun registerSerializersCore(serializers: ISerializers)  {
            serializers.register(ValidationStates.marshaller)
            serializers.register(ValidationStyle.marshaller)
            serializers.register(ValidationResult)
            serializers.register(BeControlWithAction)
            serializers.register(BeDynamicControlContainer)
            serializers.register(BeFontSize.marshaller)
            serializers.register(BeFontStyle.marshaller)
            serializers.register(BeTextSettings)
            serializers.register(BeLabel)
            serializers.register(BeRichText)
            serializers.register(BeRichAttributedText)
            serializers.register(BeHeader)
            serializers.register(BeValidationLabel)
            serializers.register(BeCompletionItem)
            serializers.register(BeTextBoxSettings)
            serializers.register(BeTextBox)
            serializers.register(BePasswordTextBox)
            serializers.register(BeTextControl)
            serializers.register(BeEditor)
            serializers.register(BeEditorImpl)
            serializers.register(BeIdeaEditorSettings)
            serializers.register(BeTextControlWithLanguage)
            serializers.register(BeHtmlViewer)
            serializers.register(BeSearchBox)
            serializers.register(BeDock.marshaller)
            serializers.register(BeResharperAction)
            serializers.register(BeBackendIdeAction)
            serializers.register(BeIcon)
            serializers.register(BeAnimatedIcon)
            serializers.register(BeSpacer)
            serializers.register(BeSpinner)
            serializers.register(BeArrowControl)
            serializers.register(BeSeparator)
            serializers.register(BeComboBox)
            serializers.register(BeCommonBehavior.marshaller)
            serializers.register(BeButtonStyle.marshaller)
            serializers.register(BeUserAction)
            serializers.register(BePredefinedAction)
            serializers.register(BeButton)
            serializers.register(BePredefinedBehaviorButton)
            serializers.register(BeLink)
            serializers.register(BeToggleButton)
            serializers.register(BeCheckbox)
            serializers.register(BeRadioButton)
            serializers.register(BeTreeSelection.marshaller)
            serializers.register(BeAlignment.marshaller)
            serializers.register(BeColumnDefinition)
            serializers.register(BeTreeGridLine)
            serializers.register(BeShowBorders.marshaller)
            serializers.register(BeScrollSettings.marshaller)
            serializers.register(BeSpeedSearch.marshaller)
            serializers.register(BeTreeConfiguration)
            serializers.register(OrderBy.marshaller)
            serializers.register(SortKey)
            serializers.register(BeEmptyText)
            serializers.register(BeTreeGrid)
            serializers.register(GridOrientation.marshaller)
            serializers.register(BeSizingType.marshaller)
            serializers.register(BeMarginType.marshaller)
            serializers.register(BeUnitSize)
            serializers.register(BeGridElement)
            serializers.register(BeGrid)
            serializers.register(BeMutableGrid)
            serializers.register(BeSpanColumnElement)
            serializers.register(BeSpanRowElement)
            serializers.register(BeSpanGrid)
            serializers.register(BeMutableSpanGrid)
            serializers.register(BeCollapsiblePanel)
            serializers.register(BeMigLayoutItem)
            serializers.register(BeMigLayout)
            serializers.register(BeTab)
            serializers.register(BeTabbedControl)
            serializers.register(BeSplitControl)
            serializers.register(BePopup)
            serializers.register(BeControlSizeType.marshaller)
            serializers.register(BeSize)
            serializers.register(BeControlSizeCustom)
            serializers.register(BeControlSizeFixed)
            serializers.register(BeControlSizePredefined)
            serializers.register(BeControlSizeProportional)
            serializers.register(BeScrollbarPolicy.marshaller)
            serializers.register(BeScrollablePanel)
            serializers.register(BeGroupBox)
            serializers.register(BePosition.marshaller)
            serializers.register(BeToolWindowState.marshaller)
            serializers.register(BeToolWindow)
            serializers.register(BeBorder)
            serializers.register(BeDialogControlBox.marshaller)
            serializers.register(DialogResult.marshaller)
            serializers.register(DialogModality.marshaller)
            serializers.register(DialogStyle.marshaller)
            serializers.register(DialogLayoutPersistenceMode.marshaller)
            serializers.register(BeDialog)
            serializers.register(BeComponentPopupContext)
            serializers.register(BeFocusCenterPopupContext)
            serializers.register(BeWindowCenterPopupContext)
            serializers.register(BeScreenPointPopupContext)
            serializers.register(BeAbstractPopup)
            serializers.register(BeMenuItem)
            serializers.register(BeMenu)
            serializers.register(BeToolbar)
            serializers.register(BeControlConstant)
            serializers.register(BeBackendContextMenu)
            serializers.register(IndefiniteProgress)
            serializers.register(DefiniteProgress)
            serializers.register(TaskProgress)
            serializers.register(CancelableProgress)
            serializers.register(BeProgress)
            serializers.register(BeBackgroundColorModifier)
            serializers.register(BeOpacityModifier)
            serializers.register(BeBoundsType.marshaller)
            serializers.register(BeBoundsModifier)
            serializers.register(BeSizeModifier)
            serializers.register(BeMarginItem)
            serializers.register(BeMargin)
            serializers.register(BeMarginModifier)
            serializers.register(BeCursor.marshaller)
            serializers.register(BeCursorModifier)
            serializers.register(BeStyleControl)
            serializers.register(BePredefinedShortcutListener)
            serializers.register(BeShortcutListener)
            serializers.register(BeActionIdListener)
            serializers.register(BeMouseAction.marshaller)
            serializers.register(BeMouseListener)
            serializers.register(BeBehaviorControl)
            serializers.register(BeContextIdBehavior)
            serializers.register(BeContextIdTimestampModel)
            serializers.register(ControlVisibility.marshaller)
            serializers.register(HeaderStyle.marshaller)
            serializers.register(UpdateSourceTrigger.marshaller)
            serializers.register(Place.marshaller)
            serializers.register(PredefinedType.marshaller)
            serializers.register(ArrowOrientation.marshaller)
            serializers.register(ChildOffsetSize.marshaller)
            serializers.register(BeControl_Unknown)
            serializers.register(BeControlWithValidation_Unknown)
            serializers.register(BeControlWithValidationOnProperty_Unknown)
            serializers.register(BeControlWithEditableText_Unknown)
            serializers.register(BeControlContainer_Unknown)
            serializers.register(BeAbstractText_Unknown)
            serializers.register(BeEditorSettings_Unknown)
            serializers.register(BeIdeAction_Unknown)
            serializers.register(BeButtonAction_Unknown)
            serializers.register(BeAbstractButton_Unknown)
            serializers.register(BeButton_Unknown)
            serializers.register(BeControlSize_Unknown)
            serializers.register(BePopupContext_Unknown)
            serializers.register(AbstractProgress_Unknown)
            serializers.register(DefiniteProgress_Unknown)
            serializers.register(BeProgress_Unknown)
            serializers.register(BeStyleModifier_Unknown)
            serializers.register(BeActionListener_Unknown)
        }
        
        
        fun create(lifetime: Lifetime, protocol: IProtocol): UIAutomationInteractionModel  {
            com.jetbrains.rd.ide.model.IdeRoot.register(protocol.serializers)
            
            return UIAutomationInteractionModel().apply {
                identify(protocol.identity, RdId.Null.mix("UIAutomationInteractionModel"))
                bind(lifetime, protocol, "UIAutomationInteractionModel")
            }
        }
        
        private val __BePopupNullableSerializer = BePopup.nullable()
        
        const val serializationHash = -4076556420873185335L
        
    }
    override val serializersOwner: ISerializersOwner get() = UIAutomationInteractionModel
    override val serializationHash: Long get() = UIAutomationInteractionModel.serializationHash
    
    //fields
    val currentPopup: IProperty<BePopup?> get() = _currentPopup
    val activeToolWindows: IMutableViewableList<BeToolWindow> get() = _activeToolWindows
    val activeDialogs: IMutableViewableList<BeDialog> get() = _activeDialogs
    //methods
    //initializer
    init {
        bindableChildren.add("currentPopup" to _currentPopup)
        bindableChildren.add("activeToolWindows" to _activeToolWindows)
        bindableChildren.add("activeDialogs" to _activeDialogs)
    }
    
    //secondary constructor
    private constructor(
    ) : this(
        RdProperty<BePopup?>(null, __BePopupNullableSerializer),
        RdList<BeToolWindow>(BeToolWindow),
        RdList<BeDialog>(BeDialog)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("UIAutomationInteractionModel (")
        printer.indent {
            print("currentPopup = "); _currentPopup.print(printer); println()
            print("activeToolWindows = "); _activeToolWindows.print(printer); println()
            print("activeDialogs = "); _activeDialogs.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): UIAutomationInteractionModel   {
        return UIAutomationInteractionModel(
            _currentPopup.deepClonePolymorphic(),
            _activeToolWindows.deepClonePolymorphic(),
            _activeDialogs.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class AbstractProgress (
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<AbstractProgress> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): AbstractProgress  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return AbstractProgress_Unknown(unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class AbstractProgress_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : AbstractProgress (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<AbstractProgress_Unknown> {
        override val _type: KClass<AbstractProgress_Unknown> = AbstractProgress_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): AbstractProgress_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: AbstractProgress_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("AbstractProgress_Unknown (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): AbstractProgress_Unknown   {
        return AbstractProgress_Unknown(
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class ArrowOrientation {
    RIGHT, 
    LEFT, 
    BOTH;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ArrowOrientation>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeAbstractButton (
    val content: BeAbstractText,
    val style: BeButtonStyle = BeButtonStyle.DEFAULT,
    protected val _isMouseOver: RdProperty<Boolean>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IAbstractDeclaration<BeAbstractButton> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeAbstractButton  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText)
            val style = buffer.readEnum<BeButtonStyle>()
            val _isMouseOver = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeAbstractButton_Unknown(content, style, _isMouseOver, _enabled, _controlId, _tooltip, _focus, _visible, unknownId, unknownBytes).withId(_id)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val isMouseOver: IProperty<Boolean> get() = _isMouseOver
    //methods
    //initializer
    init {
        _isMouseOver.optimizeNested = true
    }
    
    init {
        bindableChildren.add("content" to content)
        bindableChildren.add("isMouseOver" to _isMouseOver)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BeAbstractButton_Unknown (
    content: BeAbstractText,
    style: BeButtonStyle = BeButtonStyle.DEFAULT,
    _isMouseOver: RdProperty<Boolean>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeAbstractButton (
    content,
    style,
    _isMouseOver,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeAbstractButton_Unknown> {
        override val _type: KClass<BeAbstractButton_Unknown> = BeAbstractButton_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeAbstractButton_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeAbstractButton_Unknown)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            buffer.writeEnum(value.style)
            RdProperty.write(ctx, buffer, value._isMouseOver)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        content: BeAbstractText,
        style: BeButtonStyle = BeButtonStyle.DEFAULT,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        content,
        style,
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeAbstractButton_Unknown (")
        printer.indent {
            print("content = "); content.print(printer); println()
            print("style = "); style.print(printer); println()
            print("isMouseOver = "); _isMouseOver.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeAbstractButton_Unknown   {
        return BeAbstractButton_Unknown(
            content.deepClonePolymorphic(),
            style,
            _isMouseOver.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeAbstractPopup private constructor(
    val content: BeControl,
    val title: BeLabel?,
    val leftTitleToolbar: BeControl,
    val rightTitleToolbar: BeControl,
    val footer: BeControl,
    val adText: String?,
    private val _context: RdOptionalProperty<BePopupContext>,
    val isFocused: Boolean,
    val focusable: Boolean,
    val isResizable: Boolean,
    val isMovable: Boolean,
    val closeOnEnter: Boolean,
    val cancelKeyEnabled: Boolean,
    val cancelOnWindowDeactivation: Boolean,
    val cancelOnClickOutside: Boolean,
    val cancelOnOtherWindowOpen: Boolean,
    val modality: DialogModality,
    val layoutPersistenceMode: DialogLayoutPersistenceMode,
    private val _result: RdOptionalProperty<DialogResult>,
    private val _accept: RdSignal<Unit>,
    private val _activated: RdSignal<Unit>,
    private val _loaded: RdSignal<Unit>,
    private val _resize: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeAbstractPopup> {
        override val _type: KClass<BeAbstractPopup> = BeAbstractPopup::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeAbstractPopup  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val title = buffer.readNullable { BeLabel.read(ctx, buffer) }
            val leftTitleToolbar = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val rightTitleToolbar = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val footer = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val adText = buffer.readNullable { buffer.readString() }
            val _context = RdOptionalProperty.read(ctx, buffer, AbstractPolymorphic(BePopupContext))
            val isFocused = buffer.readBool()
            val focusable = buffer.readBool()
            val isResizable = buffer.readBool()
            val isMovable = buffer.readBool()
            val closeOnEnter = buffer.readBool()
            val cancelKeyEnabled = buffer.readBool()
            val cancelOnWindowDeactivation = buffer.readBool()
            val cancelOnClickOutside = buffer.readBool()
            val cancelOnOtherWindowOpen = buffer.readBool()
            val modality = buffer.readEnum<DialogModality>()
            val layoutPersistenceMode = buffer.readEnum<DialogLayoutPersistenceMode>()
            val _result = RdOptionalProperty.read(ctx, buffer, DialogResult.marshaller)
            val _accept = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _activated = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _loaded = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _resize = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return BeAbstractPopup(content, title, leftTitleToolbar, rightTitleToolbar, footer, adText, _context, isFocused, focusable, isResizable, isMovable, closeOnEnter, cancelKeyEnabled, cancelOnWindowDeactivation, cancelOnClickOutside, cancelOnOtherWindowOpen, modality, layoutPersistenceMode, _result, _accept, _activated, _loaded, _resize, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeAbstractPopup)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            buffer.writeNullable(value.title) { BeLabel.write(ctx, buffer, it) }
            ctx.serializers.writePolymorphic(ctx, buffer, value.leftTitleToolbar)
            ctx.serializers.writePolymorphic(ctx, buffer, value.rightTitleToolbar)
            ctx.serializers.writePolymorphic(ctx, buffer, value.footer)
            buffer.writeNullable(value.adText) { buffer.writeString(it) }
            RdOptionalProperty.write(ctx, buffer, value._context)
            buffer.writeBool(value.isFocused)
            buffer.writeBool(value.focusable)
            buffer.writeBool(value.isResizable)
            buffer.writeBool(value.isMovable)
            buffer.writeBool(value.closeOnEnter)
            buffer.writeBool(value.cancelKeyEnabled)
            buffer.writeBool(value.cancelOnWindowDeactivation)
            buffer.writeBool(value.cancelOnClickOutside)
            buffer.writeBool(value.cancelOnOtherWindowOpen)
            buffer.writeEnum(value.modality)
            buffer.writeEnum(value.layoutPersistenceMode)
            RdOptionalProperty.write(ctx, buffer, value._result)
            RdSignal.write(ctx, buffer, value._accept)
            RdSignal.write(ctx, buffer, value._activated)
            RdSignal.write(ctx, buffer, value._loaded)
            RdSignal.write(ctx, buffer, value._resize)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val context: IOptProperty<BePopupContext> get() = _context
    val result: IOptProperty<DialogResult> get() = _result
    val accept: ISignal<Unit> get() = _accept
    val activated: ISignal<Unit> get() = _activated
    val loaded: ISignal<Unit> get() = _loaded
    val resize: ISignal<Unit> get() = _resize
    //methods
    //initializer
    init {
        _result.optimizeNested = true
    }
    
    init {
        bindableChildren.add("content" to content)
        bindableChildren.add("title" to title)
        bindableChildren.add("leftTitleToolbar" to leftTitleToolbar)
        bindableChildren.add("rightTitleToolbar" to rightTitleToolbar)
        bindableChildren.add("footer" to footer)
        bindableChildren.add("context" to _context)
        bindableChildren.add("result" to _result)
        bindableChildren.add("accept" to _accept)
        bindableChildren.add("activated" to _activated)
        bindableChildren.add("loaded" to _loaded)
        bindableChildren.add("resize" to _resize)
    }
    
    //secondary constructor
    constructor(
        content: BeControl,
        title: BeLabel?,
        leftTitleToolbar: BeControl,
        rightTitleToolbar: BeControl,
        footer: BeControl,
        adText: String?,
        isFocused: Boolean,
        focusable: Boolean,
        isResizable: Boolean,
        isMovable: Boolean,
        closeOnEnter: Boolean,
        cancelKeyEnabled: Boolean,
        cancelOnWindowDeactivation: Boolean,
        cancelOnClickOutside: Boolean,
        cancelOnOtherWindowOpen: Boolean,
        modality: DialogModality,
        layoutPersistenceMode: DialogLayoutPersistenceMode
    ) : this(
        content,
        title,
        leftTitleToolbar,
        rightTitleToolbar,
        footer,
        adText,
        RdOptionalProperty<BePopupContext>(AbstractPolymorphic(BePopupContext)),
        isFocused,
        focusable,
        isResizable,
        isMovable,
        closeOnEnter,
        cancelKeyEnabled,
        cancelOnWindowDeactivation,
        cancelOnClickOutside,
        cancelOnOtherWindowOpen,
        modality,
        layoutPersistenceMode,
        RdOptionalProperty<DialogResult>(DialogResult.marshaller),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeAbstractPopup (")
        printer.indent {
            print("content = "); content.print(printer); println()
            print("title = "); title.print(printer); println()
            print("leftTitleToolbar = "); leftTitleToolbar.print(printer); println()
            print("rightTitleToolbar = "); rightTitleToolbar.print(printer); println()
            print("footer = "); footer.print(printer); println()
            print("adText = "); adText.print(printer); println()
            print("context = "); _context.print(printer); println()
            print("isFocused = "); isFocused.print(printer); println()
            print("focusable = "); focusable.print(printer); println()
            print("isResizable = "); isResizable.print(printer); println()
            print("isMovable = "); isMovable.print(printer); println()
            print("closeOnEnter = "); closeOnEnter.print(printer); println()
            print("cancelKeyEnabled = "); cancelKeyEnabled.print(printer); println()
            print("cancelOnWindowDeactivation = "); cancelOnWindowDeactivation.print(printer); println()
            print("cancelOnClickOutside = "); cancelOnClickOutside.print(printer); println()
            print("cancelOnOtherWindowOpen = "); cancelOnOtherWindowOpen.print(printer); println()
            print("modality = "); modality.print(printer); println()
            print("layoutPersistenceMode = "); layoutPersistenceMode.print(printer); println()
            print("result = "); _result.print(printer); println()
            print("accept = "); _accept.print(printer); println()
            print("activated = "); _activated.print(printer); println()
            print("loaded = "); _loaded.print(printer); println()
            print("resize = "); _resize.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeAbstractPopup   {
        return BeAbstractPopup(
            content.deepClonePolymorphic(),
            title.deepClonePolymorphic(),
            leftTitleToolbar.deepClonePolymorphic(),
            rightTitleToolbar.deepClonePolymorphic(),
            footer.deepClonePolymorphic(),
            adText,
            _context.deepClonePolymorphic(),
            isFocused,
            focusable,
            isResizable,
            isMovable,
            closeOnEnter,
            cancelKeyEnabled,
            cancelOnWindowDeactivation,
            cancelOnClickOutside,
            cancelOnOtherWindowOpen,
            modality,
            layoutPersistenceMode,
            _result.deepClonePolymorphic(),
            _accept.deepClonePolymorphic(),
            _activated.deepClonePolymorphic(),
            _loaded.deepClonePolymorphic(),
            _resize.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeAbstractText (
    val wrapText: Boolean,
    protected val _icon: RdProperty<com.jetbrains.rd.ide.model.IconModel?>,
    protected val _shortcutIndex: RdProperty<Int>,
    protected val _target: RdProperty<String>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IAbstractDeclaration<BeAbstractText> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeAbstractText  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val wrapText = buffer.readBool()
            val _icon = RdProperty.read(ctx, buffer, __IconModelNullableSerializer)
            val _shortcutIndex = RdProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _target = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeAbstractText_Unknown(wrapText, _icon, _shortcutIndex, _target, _enabled, _controlId, _tooltip, _focus, _visible, unknownId, unknownBytes).withId(_id)
        }
        
        private val __IconModelNullableSerializer = AbstractPolymorphic(com.jetbrains.rd.ide.model.IconModel).nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val icon: IProperty<com.jetbrains.rd.ide.model.IconModel?> get() = _icon
    
    /**
     * For accelerators to work, targetId should be specified
     */
    val shortcutIndex: IProperty<Int> get() = _shortcutIndex
    
    /**
     * ControlId of the control associated with the label with shortcut
     */
    val target: IProperty<String> get() = _target
    //methods
    //initializer
    init {
        _icon.optimizeNested = true
        _shortcutIndex.optimizeNested = true
        _target.optimizeNested = true
    }
    
    init {
        bindableChildren.add("icon" to _icon)
        bindableChildren.add("shortcutIndex" to _shortcutIndex)
        bindableChildren.add("target" to _target)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BeAbstractText_Unknown (
    wrapText: Boolean,
    _icon: RdProperty<com.jetbrains.rd.ide.model.IconModel?>,
    _shortcutIndex: RdProperty<Int>,
    _target: RdProperty<String>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeAbstractText (
    wrapText,
    _icon,
    _shortcutIndex,
    _target,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeAbstractText_Unknown> {
        override val _type: KClass<BeAbstractText_Unknown> = BeAbstractText_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeAbstractText_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeAbstractText_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeBool(value.wrapText)
            RdProperty.write(ctx, buffer, value._icon)
            RdProperty.write(ctx, buffer, value._shortcutIndex)
            RdProperty.write(ctx, buffer, value._target)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __IconModelNullableSerializer = AbstractPolymorphic(com.jetbrains.rd.ide.model.IconModel).nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        wrapText: Boolean,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        wrapText,
        RdProperty<com.jetbrains.rd.ide.model.IconModel?>(null, __IconModelNullableSerializer),
        RdProperty<Int>(-1, FrameworkMarshallers.Int),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeAbstractText_Unknown (")
        printer.indent {
            print("wrapText = "); wrapText.print(printer); println()
            print("icon = "); _icon.print(printer); println()
            print("shortcutIndex = "); _shortcutIndex.print(printer); println()
            print("target = "); _target.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeAbstractText_Unknown   {
        return BeAbstractText_Unknown(
            wrapText,
            _icon.deepClonePolymorphic(),
            _shortcutIndex.deepClonePolymorphic(),
            _target.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeActionIdListener private constructor(
    val actionId: String,
    _reaction: RdSignal<Unit>,
    overrideDefault: Boolean = false
) : BeActionListener (
    _reaction,
    overrideDefault
) {
    //companion
    
    companion object : IMarshaller<BeActionIdListener> {
        override val _type: KClass<BeActionIdListener> = BeActionIdListener::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeActionIdListener  {
            val _id = RdId.read(buffer)
            val _reaction = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val overrideDefault = buffer.readBool()
            val actionId = buffer.readString()
            return BeActionIdListener(actionId, _reaction, overrideDefault).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeActionIdListener)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._reaction)
            buffer.writeBool(value.overrideDefault)
            buffer.writeString(value.actionId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        actionId: String,
        overrideDefault: Boolean = false
    ) : this(
        actionId,
        RdSignal<Unit>(FrameworkMarshallers.Void),
        overrideDefault
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeActionIdListener (")
        printer.indent {
            print("actionId = "); actionId.print(printer); println()
            print("reaction = "); _reaction.print(printer); println()
            print("overrideDefault = "); overrideDefault.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeActionIdListener   {
        return BeActionIdListener(
            actionId,
            _reaction.deepClonePolymorphic(),
            overrideDefault
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeActionListener (
    protected val _reaction: RdSignal<Unit>,
    val overrideDefault: Boolean = false
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<BeActionListener> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeActionListener  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val _reaction = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val overrideDefault = buffer.readBool()
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeActionListener_Unknown(_reaction, overrideDefault, unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    val reaction: ISignal<Unit> get() = _reaction
    //methods
    //initializer
    init {
        bindableChildren.add("reaction" to _reaction)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BeActionListener_Unknown (
    _reaction: RdSignal<Unit>,
    overrideDefault: Boolean = false,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeActionListener (
    _reaction,
    overrideDefault
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeActionListener_Unknown> {
        override val _type: KClass<BeActionListener_Unknown> = BeActionListener_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeActionListener_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeActionListener_Unknown)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._reaction)
            buffer.writeBool(value.overrideDefault)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        overrideDefault: Boolean = false,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        RdSignal<Unit>(FrameworkMarshallers.Void),
        overrideDefault,
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeActionListener_Unknown (")
        printer.indent {
            print("reaction = "); _reaction.print(printer); println()
            print("overrideDefault = "); overrideDefault.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeActionListener_Unknown   {
        return BeActionListener_Unknown(
            _reaction.deepClonePolymorphic(),
            overrideDefault,
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeAlignment {
    Left, 
    Right, 
    Top, 
    Bottom, 
    Center, 
    Stretch, 
    Default, 
    JustifiedDefault;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeAlignment>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeAnimatedIcon private constructor(
    val text: String,
    val predefinedType: PredefinedType,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeAnimatedIcon> {
        override val _type: KClass<BeAnimatedIcon> = BeAnimatedIcon::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeAnimatedIcon  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val text = buffer.readString()
            val predefinedType = buffer.readEnum<PredefinedType>()
            return BeAnimatedIcon(text, predefinedType, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeAnimatedIcon)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeString(value.text)
            buffer.writeEnum(value.predefinedType)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        text: String,
        predefinedType: PredefinedType
    ) : this(
        text,
        predefinedType,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeAnimatedIcon (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("predefinedType = "); predefinedType.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeAnimatedIcon   {
        return BeAnimatedIcon(
            text,
            predefinedType,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeArrowControl private constructor(
    private val _arrowOrientation: RdOptionalProperty<ArrowOrientation>,
    val leftColor: com.jetbrains.rd.ide.model.AbstractColor,
    val rightColor: com.jetbrains.rd.ide.model.AbstractColor,
    val leftContent: String = "",
    val rightContent: String = "",
    private val _click: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeArrowControl> {
        override val _type: KClass<BeArrowControl> = BeArrowControl::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeArrowControl  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _arrowOrientation = RdOptionalProperty.read(ctx, buffer, ArrowOrientation.marshaller)
            val leftColor = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.AbstractColor>(ctx, buffer, com.jetbrains.rd.ide.model.AbstractColor)
            val rightColor = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.AbstractColor>(ctx, buffer, com.jetbrains.rd.ide.model.AbstractColor)
            val leftContent = buffer.readString()
            val rightContent = buffer.readString()
            val _click = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return BeArrowControl(_arrowOrientation, leftColor, rightColor, leftContent, rightContent, _click, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeArrowControl)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdOptionalProperty.write(ctx, buffer, value._arrowOrientation)
            ctx.serializers.writePolymorphic(ctx, buffer, value.leftColor)
            ctx.serializers.writePolymorphic(ctx, buffer, value.rightColor)
            buffer.writeString(value.leftContent)
            buffer.writeString(value.rightContent)
            RdSignal.write(ctx, buffer, value._click)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val arrowOrientation: IOptProperty<ArrowOrientation> get() = _arrowOrientation
    val click: ISignal<Unit> get() = _click
    //methods
    //initializer
    init {
        _arrowOrientation.optimizeNested = true
    }
    
    init {
        bindableChildren.add("arrowOrientation" to _arrowOrientation)
        bindableChildren.add("click" to _click)
    }
    
    //secondary constructor
    constructor(
        leftColor: com.jetbrains.rd.ide.model.AbstractColor,
        rightColor: com.jetbrains.rd.ide.model.AbstractColor,
        leftContent: String = "",
        rightContent: String = ""
    ) : this(
        RdOptionalProperty<ArrowOrientation>(ArrowOrientation.marshaller),
        leftColor,
        rightColor,
        leftContent,
        rightContent,
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeArrowControl (")
        printer.indent {
            print("arrowOrientation = "); _arrowOrientation.print(printer); println()
            print("leftColor = "); leftColor.print(printer); println()
            print("rightColor = "); rightColor.print(printer); println()
            print("leftContent = "); leftContent.print(printer); println()
            print("rightContent = "); rightContent.print(printer); println()
            print("click = "); _click.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeArrowControl   {
        return BeArrowControl(
            _arrowOrientation.deepClonePolymorphic(),
            leftColor,
            rightColor,
            leftContent,
            rightContent,
            _click.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
data class BeBackendContextMenu (
    val backendMenuGroupId: String,
    val doubleClickActionId: String? = null
) : IPrintable {
    //companion
    
    companion object : IMarshaller<BeBackendContextMenu> {
        override val _type: KClass<BeBackendContextMenu> = BeBackendContextMenu::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeBackendContextMenu  {
            val backendMenuGroupId = buffer.readString()
            val doubleClickActionId = buffer.readNullable { buffer.readString() }
            return BeBackendContextMenu(backendMenuGroupId, doubleClickActionId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeBackendContextMenu)  {
            buffer.writeString(value.backendMenuGroupId)
            buffer.writeNullable(value.doubleClickActionId) { buffer.writeString(it) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeBackendContextMenu
        
        if (backendMenuGroupId != other.backendMenuGroupId) return false
        if (doubleClickActionId != other.doubleClickActionId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + backendMenuGroupId.hashCode()
        __r = __r*31 + if (doubleClickActionId != null) doubleClickActionId.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeBackendContextMenu (")
        printer.indent {
            print("backendMenuGroupId = "); backendMenuGroupId.print(printer); println()
            print("doubleClickActionId = "); doubleClickActionId.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeBackendIdeAction private constructor(
    val presentation: com.jetbrains.rd.ide.model.ActionRegistrationModel?,
    actionId: String,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeIdeAction (
    actionId,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeBackendIdeAction> {
        override val _type: KClass<BeBackendIdeAction> = BeBackendIdeAction::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeBackendIdeAction  {
            val _id = RdId.read(buffer)
            val actionId = buffer.readString()
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val presentation = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.ActionRegistrationModel>(ctx, buffer, com.jetbrains.rd.ide.model.ActionRegistrationModel) }
            return BeBackendIdeAction(presentation, actionId, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeBackendIdeAction)  {
            value.rdid.write(buffer)
            buffer.writeString(value.actionId)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeNullable(value.presentation) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        presentation: com.jetbrains.rd.ide.model.ActionRegistrationModel?,
        actionId: String
    ) : this(
        presentation,
        actionId,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeBackendIdeAction (")
        printer.indent {
            print("presentation = "); presentation.print(printer); println()
            print("actionId = "); actionId.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeBackendIdeAction   {
        return BeBackendIdeAction(
            presentation,
            actionId,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeBackgroundColorModifier (
    val color: com.jetbrains.rd.ide.model.AbstractColor
) : BeStyleModifier (
) {
    //companion
    
    companion object : IMarshaller<BeBackgroundColorModifier> {
        override val _type: KClass<BeBackgroundColorModifier> = BeBackgroundColorModifier::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeBackgroundColorModifier  {
            val color = ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.AbstractColor>(ctx, buffer, com.jetbrains.rd.ide.model.AbstractColor)
            return BeBackgroundColorModifier(color)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeBackgroundColorModifier)  {
            ctx.serializers.writePolymorphic(ctx, buffer, value.color)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeBackgroundColorModifier
        
        if (color != other.color) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + color.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeBackgroundColorModifier (")
        printer.indent {
            print("color = "); color.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeBehaviorControl private constructor(
    private val _behavior: RdList<BeActionListener>,
    content: BeControl,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlContainer (
    content,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeBehaviorControl> {
        override val _type: KClass<BeBehaviorControl> = BeBehaviorControl::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeBehaviorControl  {
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _behavior = RdList.read(ctx, buffer, AbstractPolymorphic(BeActionListener))
            return BeBehaviorControl(_behavior, content, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeBehaviorControl)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdList.write(ctx, buffer, value._behavior)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val behavior: IMutableViewableList<BeActionListener> get() = _behavior
    //methods
    //initializer
    init {
        bindableChildren.add("behavior" to _behavior)
    }
    
    //secondary constructor
    constructor(
        content: BeControl
    ) : this(
        RdList<BeActionListener>(AbstractPolymorphic(BeActionListener)),
        content,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeBehaviorControl (")
        printer.indent {
            print("behavior = "); _behavior.print(printer); println()
            print("content = "); content.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeBehaviorControl   {
        return BeBehaviorControl(
            _behavior.deepClonePolymorphic(),
            content.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeBorder private constructor(
    val showBorders: BeShowBorders,
    content: BeControl,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlContainer (
    content,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeBorder> {
        override val _type: KClass<BeBorder> = BeBorder::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeBorder  {
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val showBorders = buffer.readEnum<BeShowBorders>()
            return BeBorder(showBorders, content, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeBorder)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeEnum(value.showBorders)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        showBorders: BeShowBorders,
        content: BeControl
    ) : this(
        showBorders,
        content,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeBorder (")
        printer.indent {
            print("showBorders = "); showBorders.print(printer); println()
            print("content = "); content.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeBorder   {
        return BeBorder(
            showBorders,
            content.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeBoundsModifier (
    val widthType: BeBoundsType,
    val widthSize: BeControlSize,
    val heightType: BeBoundsType,
    val heightSize: BeControlSize
) : BeStyleModifier (
) {
    //companion
    
    companion object : IMarshaller<BeBoundsModifier> {
        override val _type: KClass<BeBoundsModifier> = BeBoundsModifier::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeBoundsModifier  {
            val widthType = buffer.readEnum<BeBoundsType>()
            val widthSize = ctx.serializers.readPolymorphic<BeControlSize>(ctx, buffer, BeControlSize)
            val heightType = buffer.readEnum<BeBoundsType>()
            val heightSize = ctx.serializers.readPolymorphic<BeControlSize>(ctx, buffer, BeControlSize)
            return BeBoundsModifier(widthType, widthSize, heightType, heightSize)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeBoundsModifier)  {
            buffer.writeEnum(value.widthType)
            ctx.serializers.writePolymorphic(ctx, buffer, value.widthSize)
            buffer.writeEnum(value.heightType)
            ctx.serializers.writePolymorphic(ctx, buffer, value.heightSize)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeBoundsModifier
        
        if (widthType != other.widthType) return false
        if (widthSize != other.widthSize) return false
        if (heightType != other.heightType) return false
        if (heightSize != other.heightSize) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + widthType.hashCode()
        __r = __r*31 + widthSize.hashCode()
        __r = __r*31 + heightType.hashCode()
        __r = __r*31 + heightSize.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeBoundsModifier (")
        printer.indent {
            print("widthType = "); widthType.print(printer); println()
            print("widthSize = "); widthSize.print(printer); println()
            print("heightType = "); heightType.print(printer); println()
            print("heightSize = "); heightSize.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeBoundsType {
    MIN_SIZE, 
    FIXED_SIZE, 
    MAX_SIZE;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeBoundsType>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
open class BeButton protected constructor(
    val action: BeUserAction,
    content: BeAbstractText,
    style: BeButtonStyle = BeButtonStyle.DEFAULT,
    _isMouseOver: RdProperty<Boolean>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeAbstractButton (
    content,
    style,
    _isMouseOver,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeButton>, IAbstractDeclaration<BeButton> {
        override val _type: KClass<BeButton> = BeButton::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeButton  {
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText)
            val style = buffer.readEnum<BeButtonStyle>()
            val _isMouseOver = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val action = BeUserAction.read(ctx, buffer)
            return BeButton(action, content, style, _isMouseOver, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeButton)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            buffer.writeEnum(value.style)
            RdProperty.write(ctx, buffer, value._isMouseOver)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            BeUserAction.write(ctx, buffer, value.action)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeButton  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val action = BeUserAction.read(ctx, buffer)
            val content = ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText)
            val style = buffer.readEnum<BeButtonStyle>()
            val _isMouseOver = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeButton_Unknown(action, content, style, _isMouseOver, _enabled, _controlId, _tooltip, _focus, _visible, unknownId, unknownBytes).withId(_id)
        }
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("action" to action)
    }
    
    //secondary constructor
    constructor(
        action: BeUserAction,
        content: BeAbstractText,
        style: BeButtonStyle = BeButtonStyle.DEFAULT
    ) : this(
        action,
        content,
        style,
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeButton (")
        printer.indent {
            print("action = "); action.print(printer); println()
            print("content = "); content.print(printer); println()
            print("style = "); style.print(printer); println()
            print("isMouseOver = "); _isMouseOver.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeButton   {
        return BeButton(
            action.deepClonePolymorphic(),
            content.deepClonePolymorphic(),
            style,
            _isMouseOver.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeButtonAction (
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<BeButtonAction> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeButtonAction  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeButtonAction_Unknown(unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BeButtonAction_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeButtonAction (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeButtonAction_Unknown> {
        override val _type: KClass<BeButtonAction_Unknown> = BeButtonAction_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeButtonAction_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeButtonAction_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeButtonAction_Unknown (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeButtonAction_Unknown   {
        return BeButtonAction_Unknown(
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * @property ICON_TEXT most likely it's same as default
 * @property HYBRID Icon only in IDEA and Icon+Text in VS
 * @property HYBRID_TEXT_ONLY Icon only in IDEA and Text in VS
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeButtonStyle {
    DEFAULT, 
    ICON, 
    
    /**
     * most likely it's same as default
     */
    ICON_TEXT, 
    TEXT, 
    
    /**
     * Icon only in IDEA and Icon+Text in VS
     */
    HYBRID, 
    
    /**
     * Icon only in IDEA and Text in VS
     */
    HYBRID_TEXT_ONLY, 
    NO_BORDER;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeButtonStyle>()
        
    }
}


class BeButton_Unknown (
    action: BeUserAction,
    content: BeAbstractText,
    style: BeButtonStyle = BeButtonStyle.DEFAULT,
    _isMouseOver: RdProperty<Boolean>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeButton (
    action,
    content,
    style,
    _isMouseOver,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeButton_Unknown> {
        override val _type: KClass<BeButton_Unknown> = BeButton_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeButton_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeButton_Unknown)  {
            value.rdid.write(buffer)
            BeUserAction.write(ctx, buffer, value.action)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            buffer.writeEnum(value.style)
            RdProperty.write(ctx, buffer, value._isMouseOver)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        action: BeUserAction,
        content: BeAbstractText,
        style: BeButtonStyle = BeButtonStyle.DEFAULT,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        action,
        content,
        style,
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeButton_Unknown (")
        printer.indent {
            print("action = "); action.print(printer); println()
            print("content = "); content.print(printer); println()
            print("style = "); style.print(printer); println()
            print("isMouseOver = "); _isMouseOver.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeButton_Unknown   {
        return BeButton_Unknown(
            action.deepClonePolymorphic(),
            content.deepClonePolymorphic(),
            style,
            _isMouseOver.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeCheckbox private constructor(
    val description: BeAbstractText,
    private val _property: RdProperty<Boolean?>,
    private val _isThreeState: RdProperty<Boolean>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeCheckbox> {
        override val _type: KClass<BeCheckbox> = BeCheckbox::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeCheckbox  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val description = ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText)
            val _property = RdProperty.read(ctx, buffer, __BoolNullableSerializer)
            val _isThreeState = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            return BeCheckbox(description, _property, _isThreeState, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeCheckbox)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            ctx.serializers.writePolymorphic(ctx, buffer, value.description)
            RdProperty.write(ctx, buffer, value._property)
            RdProperty.write(ctx, buffer, value._isThreeState)
        }
        
        private val __BoolNullableSerializer = FrameworkMarshallers.Bool.nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val `property`: IProperty<Boolean?> get() = _property
    val isThreeState: IProperty<Boolean> get() = _isThreeState
    //methods
    //initializer
    init {
        _property.optimizeNested = true
        _isThreeState.optimizeNested = true
    }
    
    init {
        bindableChildren.add("description" to description)
        bindableChildren.add("property" to _property)
        bindableChildren.add("isThreeState" to _isThreeState)
    }
    
    //secondary constructor
    constructor(
        description: BeAbstractText
    ) : this(
        description,
        RdProperty<Boolean?>(null, __BoolNullableSerializer),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeCheckbox (")
        printer.indent {
            print("description = "); description.print(printer); println()
            print("property = "); _property.print(printer); println()
            print("isThreeState = "); _isThreeState.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeCheckbox   {
        return BeCheckbox(
            description.deepClonePolymorphic(),
            _property.deepClonePolymorphic(),
            _isThreeState.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeCollapsiblePanel private constructor(
    private val _headerText: RdOptionalProperty<String>,
    private val _isExpanded: RdOptionalProperty<Boolean>,
    content: BeControl,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlContainer (
    content,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeCollapsiblePanel> {
        override val _type: KClass<BeCollapsiblePanel> = BeCollapsiblePanel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeCollapsiblePanel  {
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _headerText = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _isExpanded = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            return BeCollapsiblePanel(_headerText, _isExpanded, content, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeCollapsiblePanel)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdOptionalProperty.write(ctx, buffer, value._headerText)
            RdOptionalProperty.write(ctx, buffer, value._isExpanded)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val headerText: IOptProperty<String> get() = _headerText
    val isExpanded: IOptProperty<Boolean> get() = _isExpanded
    //methods
    //initializer
    init {
        _headerText.optimizeNested = true
        _isExpanded.optimizeNested = true
    }
    
    init {
        bindableChildren.add("headerText" to _headerText)
        bindableChildren.add("isExpanded" to _isExpanded)
    }
    
    //secondary constructor
    constructor(
        content: BeControl
    ) : this(
        RdOptionalProperty<String>(FrameworkMarshallers.String),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        content,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeCollapsiblePanel (")
        printer.indent {
            print("headerText = "); _headerText.print(printer); println()
            print("isExpanded = "); _isExpanded.print(printer); println()
            print("content = "); content.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeCollapsiblePanel   {
        return BeCollapsiblePanel(
            _headerText.deepClonePolymorphic(),
            _isExpanded.deepClonePolymorphic(),
            content.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
data class BeColumnDefinition (
    val columnName: String,
    val size: BeUnitSize,
    val alignment: BeAlignment = BeAlignment.Stretch,
    val isSortable: Boolean = false
) : IPrintable {
    //companion
    
    companion object : IMarshaller<BeColumnDefinition> {
        override val _type: KClass<BeColumnDefinition> = BeColumnDefinition::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeColumnDefinition  {
            val columnName = buffer.readString()
            val size = BeUnitSize.read(ctx, buffer)
            val alignment = buffer.readEnum<BeAlignment>()
            val isSortable = buffer.readBool()
            return BeColumnDefinition(columnName, size, alignment, isSortable)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeColumnDefinition)  {
            buffer.writeString(value.columnName)
            BeUnitSize.write(ctx, buffer, value.size)
            buffer.writeEnum(value.alignment)
            buffer.writeBool(value.isSortable)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeColumnDefinition
        
        if (columnName != other.columnName) return false
        if (size != other.size) return false
        if (alignment != other.alignment) return false
        if (isSortable != other.isSortable) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + columnName.hashCode()
        __r = __r*31 + size.hashCode()
        __r = __r*31 + alignment.hashCode()
        __r = __r*31 + isSortable.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeColumnDefinition (")
        printer.indent {
            print("columnName = "); columnName.print(printer); println()
            print("size = "); size.print(printer); println()
            print("alignment = "); alignment.print(printer); println()
            print("isSortable = "); isSortable.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * @property settings todo
 * #### Generated from [UIAutomationModel.kt]
 */
class BeComboBox private constructor(
    private val _values: RdList<BeControl>,
    private val _isEditable: RdProperty<Boolean>,
    private val _selectedIndex: RdProperty<Int>,
    val settings: BeTextBoxSettings,
    _text: RdProperty<String>,
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlWithEditableText (
    _text,
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeComboBox> {
        override val _type: KClass<BeComboBox> = BeComboBox::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeComboBox  {
            val _id = RdId.read(buffer)
            val _text = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _validationResult = RdOptionalProperty.read(ctx, buffer, ValidationResult)
            val _validationStyle = RdOptionalProperty.read(ctx, buffer, ValidationStyle.marshaller)
            val _handledByParent = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _revalidate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _values = RdList.read(ctx, buffer, AbstractPolymorphic(BeControl))
            val _isEditable = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _selectedIndex = RdProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val settings = BeTextBoxSettings.read(ctx, buffer)
            return BeComboBox(_values, _isEditable, _selectedIndex, settings, _text, _validationResult, _validationStyle, _handledByParent, _revalidate, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeComboBox)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._text)
            RdOptionalProperty.write(ctx, buffer, value._validationResult)
            RdOptionalProperty.write(ctx, buffer, value._validationStyle)
            RdProperty.write(ctx, buffer, value._handledByParent)
            RdSignal.write(ctx, buffer, value._revalidate)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdList.write(ctx, buffer, value._values)
            RdProperty.write(ctx, buffer, value._isEditable)
            RdProperty.write(ctx, buffer, value._selectedIndex)
            BeTextBoxSettings.write(ctx, buffer, value.settings)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val values: IMutableViewableList<BeControl> get() = _values
    val isEditable: IProperty<Boolean> get() = _isEditable
    val selectedIndex: IProperty<Int> get() = _selectedIndex
    //methods
    //initializer
    init {
        _isEditable.optimizeNested = true
        _selectedIndex.optimizeNested = true
    }
    
    init {
        bindableChildren.add("values" to _values)
        bindableChildren.add("isEditable" to _isEditable)
        bindableChildren.add("selectedIndex" to _selectedIndex)
        bindableChildren.add("settings" to settings)
    }
    
    //secondary constructor
    constructor(
        settings: BeTextBoxSettings
    ) : this(
        RdList<BeControl>(AbstractPolymorphic(BeControl)),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdProperty<Int>(0, FrameworkMarshallers.Int),
        settings,
        RdProperty<String>("", FrameworkMarshallers.String),
        RdOptionalProperty<ValidationResult>(ValidationResult),
        RdOptionalProperty<ValidationStyle>(ValidationStyle.marshaller),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeComboBox (")
        printer.indent {
            print("values = "); _values.print(printer); println()
            print("isEditable = "); _isEditable.print(printer); println()
            print("selectedIndex = "); _selectedIndex.print(printer); println()
            print("settings = "); settings.print(printer); println()
            print("text = "); _text.print(printer); println()
            print("validationResult = "); _validationResult.print(printer); println()
            print("validationStyle = "); _validationStyle.print(printer); println()
            print("handledByParent = "); _handledByParent.print(printer); println()
            print("revalidate = "); _revalidate.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeComboBox   {
        return BeComboBox(
            _values.deepClonePolymorphic(),
            _isEditable.deepClonePolymorphic(),
            _selectedIndex.deepClonePolymorphic(),
            settings.deepClonePolymorphic(),
            _text.deepClonePolymorphic(),
            _validationResult.deepClonePolymorphic(),
            _validationStyle.deepClonePolymorphic(),
            _handledByParent.deepClonePolymorphic(),
            _revalidate.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeCommonBehavior {
    TABLE_ADD, 
    TABLE_DELETE, 
    TABLE_MOVE_UP, 
    TABLE_MOVE_DOWN, 
    TABLE_EDIT, 
    TABLE_DUPLICATE, 
    TREE_EXPAND_ALL, 
    TREE_COLLAPSE_ALL, 
    SHOW_IN_TOOLWINDOW, 
    DIALOG_ACCEPT_BUTTON, 
    DIALOG_CANCEL_BUTTON, 
    DIALOG_HELP, 
    OPEN_FILE_DIALOG, 
    RESET_VALUE, 
    SEARCH_BUTTON, 
    WARNING, 
    ERROR, 
    FILTER, 
    SEARCH, 
    DOWN, 
    UP, 
    LEFT, 
    RIGHT, 
    INFO, 
    CLOSE, 
    GEAR, 
    NONE;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeCommonBehavior>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeCompletionItem private constructor(
    val leftIcon: com.jetbrains.rd.ide.model.IconModel?,
    val leftText: BeAbstractText,
    private val _rightIcon: RdProperty<com.jetbrains.rd.ide.model.IconModel?>,
    private val _rightText: RdOptionalProperty<BeRichText>,
    val translatedText: String
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BeCompletionItem> {
        override val _type: KClass<BeCompletionItem> = BeCompletionItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeCompletionItem  {
            val _id = RdId.read(buffer)
            val leftIcon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val leftText = ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText)
            val _rightIcon = RdProperty.read(ctx, buffer, __IconModelNullableSerializer)
            val _rightText = RdOptionalProperty.read(ctx, buffer, BeRichText)
            val translatedText = buffer.readString()
            return BeCompletionItem(leftIcon, leftText, _rightIcon, _rightText, translatedText).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeCompletionItem)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.leftIcon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            ctx.serializers.writePolymorphic(ctx, buffer, value.leftText)
            RdProperty.write(ctx, buffer, value._rightIcon)
            RdOptionalProperty.write(ctx, buffer, value._rightText)
            buffer.writeString(value.translatedText)
        }
        
        private val __IconModelNullableSerializer = AbstractPolymorphic(com.jetbrains.rd.ide.model.IconModel).nullable()
        
    }
    //fields
    val rightIcon: IProperty<com.jetbrains.rd.ide.model.IconModel?> get() = _rightIcon
    val rightText: IOptProperty<BeRichText> get() = _rightText
    //methods
    //initializer
    init {
        _rightIcon.optimizeNested = true
    }
    
    init {
        bindableChildren.add("leftText" to leftText)
        bindableChildren.add("rightIcon" to _rightIcon)
        bindableChildren.add("rightText" to _rightText)
    }
    
    //secondary constructor
    constructor(
        leftIcon: com.jetbrains.rd.ide.model.IconModel?,
        leftText: BeAbstractText,
        translatedText: String
    ) : this(
        leftIcon,
        leftText,
        RdProperty<com.jetbrains.rd.ide.model.IconModel?>(null, __IconModelNullableSerializer),
        RdOptionalProperty<BeRichText>(BeRichText),
        translatedText
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeCompletionItem (")
        printer.indent {
            print("leftIcon = "); leftIcon.print(printer); println()
            print("leftText = "); leftText.print(printer); println()
            print("rightIcon = "); _rightIcon.print(printer); println()
            print("rightText = "); _rightText.print(printer); println()
            print("translatedText = "); translatedText.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeCompletionItem   {
        return BeCompletionItem(
            leftIcon,
            leftText.deepClonePolymorphic(),
            _rightIcon.deepClonePolymorphic(),
            _rightText.deepClonePolymorphic(),
            translatedText
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeComponentPopupContext (
) : BePopupContext (
) {
    //companion
    
    companion object : IMarshaller<BeComponentPopupContext> {
        override val _type: KClass<BeComponentPopupContext> = BeComponentPopupContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeComponentPopupContext  {
            val _id = RdId.read(buffer)
            return BeComponentPopupContext().withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeComponentPopupContext)  {
            value.rdid.write(buffer)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeComponentPopupContext (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeComponentPopupContext   {
        return BeComponentPopupContext(
        )
    }
    //contexts
}


/**
 * @property contextId Not implemented in WPF frontend yet
 * #### Generated from [UIAutomationModel.kt]
 */
class BeContextIdBehavior private constructor(
    val contextId: Int,
    content: BeControl,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlContainer (
    content,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeContextIdBehavior> {
        override val _type: KClass<BeContextIdBehavior> = BeContextIdBehavior::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeContextIdBehavior  {
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val contextId = buffer.readInt()
            return BeContextIdBehavior(contextId, content, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeContextIdBehavior)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeInt(value.contextId)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        contextId: Int,
        content: BeControl
    ) : this(
        contextId,
        content,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeContextIdBehavior (")
        printer.indent {
            print("contextId = "); contextId.print(printer); println()
            print("content = "); content.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeContextIdBehavior   {
        return BeContextIdBehavior(
            contextId,
            content.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeContextIdTimestampModel (
    val contextId: Int
) : com.jetbrains.rd.ide.model.UpgradableActionTimestampModel (
) {
    //companion
    
    companion object : IMarshaller<BeContextIdTimestampModel> {
        override val _type: KClass<BeContextIdTimestampModel> = BeContextIdTimestampModel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeContextIdTimestampModel  {
            val contextId = buffer.readInt()
            return BeContextIdTimestampModel(contextId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeContextIdTimestampModel)  {
            buffer.writeInt(value.contextId)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeContextIdTimestampModel
        
        if (contextId != other.contextId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + contextId.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeContextIdTimestampModel (")
        printer.indent {
            print("contextId = "); contextId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeControl (
    protected val _enabled: RdProperty<Boolean>,
    protected val _controlId: RdProperty<String>,
    protected val _tooltip: RdProperty<String?>,
    protected val _focus: RdSignal<Unit>,
    protected val _visible: RdOptionalProperty<ControlVisibility>
) : com.jetbrains.ide.model.popups.ProtoViewModel (
) {
    //companion
    
    companion object : IAbstractDeclaration<BeControl> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeControl  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeControl_Unknown(_enabled, _controlId, _tooltip, _focus, _visible, unknownId, unknownBytes).withId(_id)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val enabled: IProperty<Boolean> get() = _enabled
    
    /**
     * Needed for accelerators to work and for search
     */
    val controlId: IProperty<String> get() = _controlId
    val tooltip: IProperty<String?> get() = _tooltip
    val focus: ISignal<Unit> get() = _focus
    
    /**
     * Warning: currently doesn't work as expected.
     */
    val visible: IOptProperty<ControlVisibility> get() = _visible
    //methods
    //initializer
    init {
        _enabled.optimizeNested = true
        _controlId.optimizeNested = true
        _tooltip.optimizeNested = true
        _visible.optimizeNested = true
    }
    
    init {
        bindableChildren.add("enabled" to _enabled)
        bindableChildren.add("controlId" to _controlId)
        bindableChildren.add("tooltip" to _tooltip)
        bindableChildren.add("focus" to _focus)
        bindableChildren.add("visible" to _visible)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeControlConstant (
    val enclosingControlId: String?,
    val controlId: List<String>?
) : com.jetbrains.rd.ide.model.RdDataConstant (
) {
    //companion
    
    companion object : IMarshaller<BeControlConstant> {
        override val _type: KClass<BeControlConstant> = BeControlConstant::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControlConstant  {
            val enclosingControlId = buffer.readNullable { buffer.readString() }
            val controlId = buffer.readNullable { buffer.readList { buffer.readString() } }
            return BeControlConstant(enclosingControlId, controlId)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControlConstant)  {
            buffer.writeNullable(value.enclosingControlId) { buffer.writeString(it) }
            buffer.writeNullable(value.controlId) { buffer.writeList(it) { v -> buffer.writeString(v) } }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeControlConstant
        
        if (enclosingControlId != other.enclosingControlId) return false
        if (controlId != other.controlId) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + if (enclosingControlId != null) enclosingControlId.hashCode() else 0
        __r = __r*31 + if (controlId != null) controlId.hashCode() else 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControlConstant (")
        printer.indent {
            print("enclosingControlId = "); enclosingControlId.print(printer); println()
            print("controlId = "); controlId.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeControlContainer (
    val content: BeControl,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IAbstractDeclaration<BeControlContainer> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeControlContainer  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeControlContainer_Unknown(content, _enabled, _controlId, _tooltip, _focus, _visible, unknownId, unknownBytes).withId(_id)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("content" to content)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BeControlContainer_Unknown (
    content: BeControl,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeControlContainer (
    content,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeControlContainer_Unknown> {
        override val _type: KClass<BeControlContainer_Unknown> = BeControlContainer_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControlContainer_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControlContainer_Unknown)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        content: BeControl,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        content,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControlContainer_Unknown (")
        printer.indent {
            print("content = "); content.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeControlContainer_Unknown   {
        return BeControlContainer_Unknown(
            content.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeControlSize (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<BeControlSize> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeControlSize  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeControlSize_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeControlSizeCustom (
    val width: Int,
    val height: Int
) : BeControlSize (
) {
    //companion
    
    companion object : IMarshaller<BeControlSizeCustom> {
        override val _type: KClass<BeControlSizeCustom> = BeControlSizeCustom::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControlSizeCustom  {
            val width = buffer.readInt()
            val height = buffer.readInt()
            return BeControlSizeCustom(width, height)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControlSizeCustom)  {
            buffer.writeInt(value.width)
            buffer.writeInt(value.height)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeControlSizeCustom
        
        if (width != other.width) return false
        if (height != other.height) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + width.hashCode()
        __r = __r*31 + height.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControlSizeCustom (")
        printer.indent {
            print("width = "); width.print(printer); println()
            print("height = "); height.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeControlSizeFixed (
    val width: BeControlSizeType,
    val height: BeControlSizeType
) : BeControlSize (
) {
    //companion
    
    companion object : IMarshaller<BeControlSizeFixed> {
        override val _type: KClass<BeControlSizeFixed> = BeControlSizeFixed::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControlSizeFixed  {
            val width = buffer.readEnum<BeControlSizeType>()
            val height = buffer.readEnum<BeControlSizeType>()
            return BeControlSizeFixed(width, height)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControlSizeFixed)  {
            buffer.writeEnum(value.width)
            buffer.writeEnum(value.height)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeControlSizeFixed
        
        if (width != other.width) return false
        if (height != other.height) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + width.hashCode()
        __r = __r*31 + height.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControlSizeFixed (")
        printer.indent {
            print("width = "); width.print(printer); println()
            print("height = "); height.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeControlSizePredefined (
    val width: BeSize,
    val height: BeSize
) : BeControlSize (
) {
    //companion
    
    companion object : IMarshaller<BeControlSizePredefined> {
        override val _type: KClass<BeControlSizePredefined> = BeControlSizePredefined::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControlSizePredefined  {
            val width = BeSize.read(ctx, buffer)
            val height = BeSize.read(ctx, buffer)
            return BeControlSizePredefined(width, height)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControlSizePredefined)  {
            BeSize.write(ctx, buffer, value.width)
            BeSize.write(ctx, buffer, value.height)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeControlSizePredefined
        
        if (width != other.width) return false
        if (height != other.height) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + width.hashCode()
        __r = __r*31 + height.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControlSizePredefined (")
        printer.indent {
            print("width = "); width.print(printer); println()
            print("height = "); height.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeControlSizeProportional (
    val size: BeControlSizeType,
    val proportion: Float
) : BeControlSize (
) {
    //companion
    
    companion object : IMarshaller<BeControlSizeProportional> {
        override val _type: KClass<BeControlSizeProportional> = BeControlSizeProportional::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControlSizeProportional  {
            val size = buffer.readEnum<BeControlSizeType>()
            val proportion = buffer.readFloat()
            return BeControlSizeProportional(size, proportion)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControlSizeProportional)  {
            buffer.writeEnum(value.size)
            buffer.writeFloat(value.proportion)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeControlSizeProportional
        
        if (size != other.size) return false
        if (proportion != other.proportion) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + size.hashCode()
        __r = __r*31 + proportion.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControlSizeProportional (")
        printer.indent {
            print("size = "); size.print(printer); println()
            print("proportion = "); proportion.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeControlSizeType {
    TINY, 
    SMALL, 
    MEDIUM, 
    LARGE, 
    HUGE, 
    EXTRA_HUGE, 
    REFACTORING_WIDTH, 
    FIT_TO_CONTENT;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeControlSizeType>()
        
    }
}


class BeControlSize_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeControlSize (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeControlSize_Unknown> {
        override val _type: KClass<BeControlSize_Unknown> = BeControlSize_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControlSize_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControlSize_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeControlSize_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControlSize_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeControlWithAction private constructor(
    val content: BeControl,
    val actions: List<BeButton>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeControlWithAction> {
        override val _type: KClass<BeControlWithAction> = BeControlWithAction::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControlWithAction  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val actions = buffer.readList { ctx.serializers.readPolymorphic<BeButton>(ctx, buffer, BeButton) }
            return BeControlWithAction(content, actions, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControlWithAction)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            buffer.writeList(value.actions) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("content" to content)
        bindableChildren.add("actions" to actions)
    }
    
    //secondary constructor
    constructor(
        content: BeControl,
        actions: List<BeButton>
    ) : this(
        content,
        actions,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControlWithAction (")
        printer.indent {
            print("content = "); content.print(printer); println()
            print("actions = "); actions.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeControlWithAction   {
        return BeControlWithAction(
            content.deepClonePolymorphic(),
            actions.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeControlWithEditableText (
    protected val _text: RdProperty<String>,
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlWithValidationOnProperty (
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IAbstractDeclaration<BeControlWithEditableText> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeControlWithEditableText  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val _text = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _validationResult = RdOptionalProperty.read(ctx, buffer, ValidationResult)
            val _validationStyle = RdOptionalProperty.read(ctx, buffer, ValidationStyle.marshaller)
            val _handledByParent = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _revalidate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeControlWithEditableText_Unknown(_text, _validationResult, _validationStyle, _handledByParent, _revalidate, _enabled, _controlId, _tooltip, _focus, _visible, unknownId, unknownBytes).withId(_id)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val text: IProperty<String> get() = _text
    //methods
    //initializer
    init {
        _text.optimizeNested = true
    }
    
    init {
        bindableChildren.add("text" to _text)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BeControlWithEditableText_Unknown (
    _text: RdProperty<String>,
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeControlWithEditableText (
    _text,
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeControlWithEditableText_Unknown> {
        override val _type: KClass<BeControlWithEditableText_Unknown> = BeControlWithEditableText_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControlWithEditableText_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControlWithEditableText_Unknown)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._text)
            RdOptionalProperty.write(ctx, buffer, value._validationResult)
            RdOptionalProperty.write(ctx, buffer, value._validationStyle)
            RdProperty.write(ctx, buffer, value._handledByParent)
            RdSignal.write(ctx, buffer, value._revalidate)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        RdProperty<String>("", FrameworkMarshallers.String),
        RdOptionalProperty<ValidationResult>(ValidationResult),
        RdOptionalProperty<ValidationStyle>(ValidationStyle.marshaller),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControlWithEditableText_Unknown (")
        printer.indent {
            print("text = "); _text.print(printer); println()
            print("validationResult = "); _validationResult.print(printer); println()
            print("validationStyle = "); _validationStyle.print(printer); println()
            print("handledByParent = "); _handledByParent.print(printer); println()
            print("revalidate = "); _revalidate.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeControlWithEditableText_Unknown   {
        return BeControlWithEditableText_Unknown(
            _text.deepClonePolymorphic(),
            _validationResult.deepClonePolymorphic(),
            _validationStyle.deepClonePolymorphic(),
            _handledByParent.deepClonePolymorphic(),
            _revalidate.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeControlWithValidation (
    protected val _validationResult: RdOptionalProperty<ValidationResult>,
    protected val _validationStyle: RdOptionalProperty<ValidationStyle>,
    protected val _handledByParent: RdProperty<Boolean>,
    protected val _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IAbstractDeclaration<BeControlWithValidation> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeControlWithValidation  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val _validationResult = RdOptionalProperty.read(ctx, buffer, ValidationResult)
            val _validationStyle = RdOptionalProperty.read(ctx, buffer, ValidationStyle.marshaller)
            val _handledByParent = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _revalidate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeControlWithValidation_Unknown(_validationResult, _validationStyle, _handledByParent, _revalidate, _enabled, _controlId, _tooltip, _focus, _visible, unknownId, unknownBytes).withId(_id)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val validationResult: IOptProperty<ValidationResult> get() = _validationResult
    
    /**
     * Questionable property. Defines how error should look for current control
     */
    val validationStyle: IOptProperty<ValidationStyle> get() = _validationStyle
    
    /**
     * Defines if this control is inside tree (or any control which will handle validation of control by itself)
     */
    val handledByParent: IProperty<Boolean> get() = _handledByParent
    
    /**
     * This property forces control to revalidate all rules for it. Better do not call explicitly
     */
    val revalidate: ISignal<Unit> get() = _revalidate
    //methods
    //initializer
    init {
        _validationStyle.optimizeNested = true
        _handledByParent.optimizeNested = true
    }
    
    init {
        bindableChildren.add("validationResult" to _validationResult)
        bindableChildren.add("validationStyle" to _validationStyle)
        bindableChildren.add("handledByParent" to _handledByParent)
        bindableChildren.add("revalidate" to _revalidate)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeControlWithValidationOnProperty (
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlWithValidation (
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IAbstractDeclaration<BeControlWithValidationOnProperty> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeControlWithValidationOnProperty  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val _validationResult = RdOptionalProperty.read(ctx, buffer, ValidationResult)
            val _validationStyle = RdOptionalProperty.read(ctx, buffer, ValidationStyle.marshaller)
            val _handledByParent = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _revalidate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeControlWithValidationOnProperty_Unknown(_validationResult, _validationStyle, _handledByParent, _revalidate, _enabled, _controlId, _tooltip, _focus, _visible, unknownId, unknownBytes).withId(_id)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BeControlWithValidationOnProperty_Unknown (
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeControlWithValidationOnProperty (
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeControlWithValidationOnProperty_Unknown> {
        override val _type: KClass<BeControlWithValidationOnProperty_Unknown> = BeControlWithValidationOnProperty_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControlWithValidationOnProperty_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControlWithValidationOnProperty_Unknown)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._validationResult)
            RdOptionalProperty.write(ctx, buffer, value._validationStyle)
            RdProperty.write(ctx, buffer, value._handledByParent)
            RdSignal.write(ctx, buffer, value._revalidate)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        RdOptionalProperty<ValidationResult>(ValidationResult),
        RdOptionalProperty<ValidationStyle>(ValidationStyle.marshaller),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControlWithValidationOnProperty_Unknown (")
        printer.indent {
            print("validationResult = "); _validationResult.print(printer); println()
            print("validationStyle = "); _validationStyle.print(printer); println()
            print("handledByParent = "); _handledByParent.print(printer); println()
            print("revalidate = "); _revalidate.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeControlWithValidationOnProperty_Unknown   {
        return BeControlWithValidationOnProperty_Unknown(
            _validationResult.deepClonePolymorphic(),
            _validationStyle.deepClonePolymorphic(),
            _handledByParent.deepClonePolymorphic(),
            _revalidate.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


class BeControlWithValidation_Unknown (
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeControlWithValidation (
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeControlWithValidation_Unknown> {
        override val _type: KClass<BeControlWithValidation_Unknown> = BeControlWithValidation_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControlWithValidation_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControlWithValidation_Unknown)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._validationResult)
            RdOptionalProperty.write(ctx, buffer, value._validationStyle)
            RdProperty.write(ctx, buffer, value._handledByParent)
            RdSignal.write(ctx, buffer, value._revalidate)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        RdOptionalProperty<ValidationResult>(ValidationResult),
        RdOptionalProperty<ValidationStyle>(ValidationStyle.marshaller),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControlWithValidation_Unknown (")
        printer.indent {
            print("validationResult = "); _validationResult.print(printer); println()
            print("validationStyle = "); _validationStyle.print(printer); println()
            print("handledByParent = "); _handledByParent.print(printer); println()
            print("revalidate = "); _revalidate.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeControlWithValidation_Unknown   {
        return BeControlWithValidation_Unknown(
            _validationResult.deepClonePolymorphic(),
            _validationStyle.deepClonePolymorphic(),
            _handledByParent.deepClonePolymorphic(),
            _revalidate.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


class BeControl_Unknown (
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeControl_Unknown> {
        override val _type: KClass<BeControl_Unknown> = BeControl_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeControl_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeControl_Unknown)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeControl_Unknown (")
        printer.indent {
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeControl_Unknown   {
        return BeControl_Unknown(
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeCursor {
    ARROW, 
    HAND;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeCursor>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeCursorModifier (
    val cursor: BeCursor = BeCursor.ARROW
) : BeStyleModifier (
) {
    //companion
    
    companion object : IMarshaller<BeCursorModifier> {
        override val _type: KClass<BeCursorModifier> = BeCursorModifier::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeCursorModifier  {
            val cursor = buffer.readEnum<BeCursor>()
            return BeCursorModifier(cursor)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeCursorModifier)  {
            buffer.writeEnum(value.cursor)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeCursorModifier
        
        if (cursor != other.cursor) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + cursor.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeCursorModifier (")
        printer.indent {
            print("cursor = "); cursor.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * @property layoutPersistenceMode Not implemented in Swing frontend yet
 * @property controlBox Not implemented in Swing frontend yet
 * #### Generated from [UIAutomationModel.kt]
 */
class BeDialog private constructor(
    private val _content: RdOptionalProperty<BeControl>,
    val modality: DialogModality,
    val title: String?,
    val size: BeControlSize,
    private val _minSize: RdProperty<BeControlSize?>,
    private val _maxSize: RdProperty<BeControlSize?>,
    val layoutPersistenceMode: DialogLayoutPersistenceMode = DialogLayoutPersistenceMode.SIZE_AND_POSITION,
    val controlBox: BeDialogControlBox = BeDialogControlBox.MINIMIZE_MAXIMIZE_AND_CLOSE,
    val style: DialogStyle = DialogStyle.SIMPLE,
    private val _result: RdOptionalProperty<DialogResult>,
    private val _acceptButton: RdProperty<BePredefinedBehaviorButton?>,
    private val _cancelButton: RdProperty<BePredefinedBehaviorButton?>,
    private val _helpButton: RdProperty<BePredefinedBehaviorButton?>,
    private val _buttons: RdOptionalProperty<List<BeAbstractButton>>,
    private val _extraFooterContent: RdOptionalProperty<BeControl>,
    private val _activated: RdSignal<Unit>,
    private val _loaded: RdOptionalProperty<Boolean>,
    private val _resize: RdSignal<Unit>,
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlWithValidation (
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeDialog> {
        override val _type: KClass<BeDialog> = BeDialog::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeDialog  {
            val _id = RdId.read(buffer)
            val _validationResult = RdOptionalProperty.read(ctx, buffer, ValidationResult)
            val _validationStyle = RdOptionalProperty.read(ctx, buffer, ValidationStyle.marshaller)
            val _handledByParent = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _revalidate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _content = RdOptionalProperty.read(ctx, buffer, AbstractPolymorphic(BeControl))
            val modality = buffer.readEnum<DialogModality>()
            val title = buffer.readNullable { buffer.readString() }
            val size = ctx.serializers.readPolymorphic<BeControlSize>(ctx, buffer, BeControlSize)
            val _minSize = RdProperty.read(ctx, buffer, __BeControlSizeNullableSerializer)
            val _maxSize = RdProperty.read(ctx, buffer, __BeControlSizeNullableSerializer)
            val layoutPersistenceMode = buffer.readEnum<DialogLayoutPersistenceMode>()
            val controlBox = buffer.readEnum<BeDialogControlBox>()
            val style = buffer.readEnum<DialogStyle>()
            val _result = RdOptionalProperty.read(ctx, buffer, DialogResult.marshaller)
            val _acceptButton = RdProperty.read(ctx, buffer, __BePredefinedBehaviorButtonNullableSerializer)
            val _cancelButton = RdProperty.read(ctx, buffer, __BePredefinedBehaviorButtonNullableSerializer)
            val _helpButton = RdProperty.read(ctx, buffer, __BePredefinedBehaviorButtonNullableSerializer)
            val _buttons = RdOptionalProperty.read(ctx, buffer, __BeAbstractButtonListSerializer)
            val _extraFooterContent = RdOptionalProperty.read(ctx, buffer, AbstractPolymorphic(BeControl))
            val _activated = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _loaded = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _resize = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return BeDialog(_content, modality, title, size, _minSize, _maxSize, layoutPersistenceMode, controlBox, style, _result, _acceptButton, _cancelButton, _helpButton, _buttons, _extraFooterContent, _activated, _loaded, _resize, _validationResult, _validationStyle, _handledByParent, _revalidate, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeDialog)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._validationResult)
            RdOptionalProperty.write(ctx, buffer, value._validationStyle)
            RdProperty.write(ctx, buffer, value._handledByParent)
            RdSignal.write(ctx, buffer, value._revalidate)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdOptionalProperty.write(ctx, buffer, value._content)
            buffer.writeEnum(value.modality)
            buffer.writeNullable(value.title) { buffer.writeString(it) }
            ctx.serializers.writePolymorphic(ctx, buffer, value.size)
            RdProperty.write(ctx, buffer, value._minSize)
            RdProperty.write(ctx, buffer, value._maxSize)
            buffer.writeEnum(value.layoutPersistenceMode)
            buffer.writeEnum(value.controlBox)
            buffer.writeEnum(value.style)
            RdOptionalProperty.write(ctx, buffer, value._result)
            RdProperty.write(ctx, buffer, value._acceptButton)
            RdProperty.write(ctx, buffer, value._cancelButton)
            RdProperty.write(ctx, buffer, value._helpButton)
            RdOptionalProperty.write(ctx, buffer, value._buttons)
            RdOptionalProperty.write(ctx, buffer, value._extraFooterContent)
            RdSignal.write(ctx, buffer, value._activated)
            RdOptionalProperty.write(ctx, buffer, value._loaded)
            RdSignal.write(ctx, buffer, value._resize)
        }
        
        private val __BeControlSizeNullableSerializer = AbstractPolymorphic(BeControlSize).nullable()
        private val __BePredefinedBehaviorButtonNullableSerializer = BePredefinedBehaviorButton.nullable()
        private val __BeAbstractButtonListSerializer = AbstractPolymorphic(BeAbstractButton).list()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val content: IOptProperty<BeControl> get() = _content
    val minSize: IProperty<BeControlSize?> get() = _minSize
    val maxSize: IProperty<BeControlSize?> get() = _maxSize
    val result: IOptProperty<DialogResult> get() = _result
    val acceptButton: IProperty<BePredefinedBehaviorButton?> get() = _acceptButton
    val cancelButton: IProperty<BePredefinedBehaviorButton?> get() = _cancelButton
    val helpButton: IProperty<BePredefinedBehaviorButton?> get() = _helpButton
    val buttons: IOptProperty<List<BeAbstractButton>> get() = _buttons
    val extraFooterContent: IOptProperty<BeControl> get() = _extraFooterContent
    val activated: ISignal<Unit> get() = _activated
    val loaded: IOptProperty<Boolean> get() = _loaded
    val resize: ISignal<Unit> get() = _resize
    //methods
    //initializer
    init {
        _minSize.optimizeNested = true
        _maxSize.optimizeNested = true
        _result.optimizeNested = true
        _loaded.optimizeNested = true
    }
    
    init {
        bindableChildren.add("content" to _content)
        bindableChildren.add("minSize" to _minSize)
        bindableChildren.add("maxSize" to _maxSize)
        bindableChildren.add("result" to _result)
        bindableChildren.add("acceptButton" to _acceptButton)
        bindableChildren.add("cancelButton" to _cancelButton)
        bindableChildren.add("helpButton" to _helpButton)
        bindableChildren.add("buttons" to _buttons)
        bindableChildren.add("extraFooterContent" to _extraFooterContent)
        bindableChildren.add("activated" to _activated)
        bindableChildren.add("loaded" to _loaded)
        bindableChildren.add("resize" to _resize)
    }
    
    //secondary constructor
    constructor(
        modality: DialogModality,
        title: String?,
        size: BeControlSize,
        layoutPersistenceMode: DialogLayoutPersistenceMode = DialogLayoutPersistenceMode.SIZE_AND_POSITION,
        controlBox: BeDialogControlBox = BeDialogControlBox.MINIMIZE_MAXIMIZE_AND_CLOSE,
        style: DialogStyle = DialogStyle.SIMPLE
    ) : this(
        RdOptionalProperty<BeControl>(AbstractPolymorphic(BeControl)),
        modality,
        title,
        size,
        RdProperty<BeControlSize?>(null, __BeControlSizeNullableSerializer),
        RdProperty<BeControlSize?>(null, __BeControlSizeNullableSerializer),
        layoutPersistenceMode,
        controlBox,
        style,
        RdOptionalProperty<DialogResult>(DialogResult.marshaller),
        RdProperty<BePredefinedBehaviorButton?>(null, __BePredefinedBehaviorButtonNullableSerializer),
        RdProperty<BePredefinedBehaviorButton?>(null, __BePredefinedBehaviorButtonNullableSerializer),
        RdProperty<BePredefinedBehaviorButton?>(null, __BePredefinedBehaviorButtonNullableSerializer),
        RdOptionalProperty<List<BeAbstractButton>>(__BeAbstractButtonListSerializer),
        RdOptionalProperty<BeControl>(AbstractPolymorphic(BeControl)),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ValidationResult>(ValidationResult),
        RdOptionalProperty<ValidationStyle>(ValidationStyle.marshaller),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeDialog (")
        printer.indent {
            print("content = "); _content.print(printer); println()
            print("modality = "); modality.print(printer); println()
            print("title = "); title.print(printer); println()
            print("size = "); size.print(printer); println()
            print("minSize = "); _minSize.print(printer); println()
            print("maxSize = "); _maxSize.print(printer); println()
            print("layoutPersistenceMode = "); layoutPersistenceMode.print(printer); println()
            print("controlBox = "); controlBox.print(printer); println()
            print("style = "); style.print(printer); println()
            print("result = "); _result.print(printer); println()
            print("acceptButton = "); _acceptButton.print(printer); println()
            print("cancelButton = "); _cancelButton.print(printer); println()
            print("helpButton = "); _helpButton.print(printer); println()
            print("buttons = "); _buttons.print(printer); println()
            print("extraFooterContent = "); _extraFooterContent.print(printer); println()
            print("activated = "); _activated.print(printer); println()
            print("loaded = "); _loaded.print(printer); println()
            print("resize = "); _resize.print(printer); println()
            print("validationResult = "); _validationResult.print(printer); println()
            print("validationStyle = "); _validationStyle.print(printer); println()
            print("handledByParent = "); _handledByParent.print(printer); println()
            print("revalidate = "); _revalidate.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeDialog   {
        return BeDialog(
            _content.deepClonePolymorphic(),
            modality,
            title,
            size,
            _minSize.deepClonePolymorphic(),
            _maxSize.deepClonePolymorphic(),
            layoutPersistenceMode,
            controlBox,
            style,
            _result.deepClonePolymorphic(),
            _acceptButton.deepClonePolymorphic(),
            _cancelButton.deepClonePolymorphic(),
            _helpButton.deepClonePolymorphic(),
            _buttons.deepClonePolymorphic(),
            _extraFooterContent.deepClonePolymorphic(),
            _activated.deepClonePolymorphic(),
            _loaded.deepClonePolymorphic(),
            _resize.deepClonePolymorphic(),
            _validationResult.deepClonePolymorphic(),
            _validationStyle.deepClonePolymorphic(),
            _handledByParent.deepClonePolymorphic(),
            _revalidate.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeDialogControlBox {
    CLOSE, 
    MINIMIZE_AND_CLOSE, 
    MAXIMIZE_AND_CLOSE, 
    MINIMIZE_MAXIMIZE_AND_CLOSE;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeDialogControlBox>()
        
    }
}


/**
 * @property DEFAULT_IDE_POSITION ide dependent
 * @property PARENT_DEPENDENT toolbar position dependent
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeDock {
    TOP, 
    BOTTOM, 
    LEFT, 
    RIGHT, 
    
    /**
     * ide dependent
     */
    DEFAULT_IDE_POSITION, 
    
    /**
     * toolbar position dependent
     */
    PARENT_DEPENDENT;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeDock>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeDynamicControlContainer private constructor(
    private val _content: RdOptionalProperty<BeControl>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeDynamicControlContainer> {
        override val _type: KClass<BeDynamicControlContainer> = BeDynamicControlContainer::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeDynamicControlContainer  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _content = RdOptionalProperty.read(ctx, buffer, AbstractPolymorphic(BeControl))
            return BeDynamicControlContainer(_content, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeDynamicControlContainer)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdOptionalProperty.write(ctx, buffer, value._content)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    
    /**
     * Not implemented in WPF frontend yet
     */
    val content: IOptProperty<BeControl> get() = _content
    //methods
    //initializer
    init {
        bindableChildren.add("content" to _content)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<BeControl>(AbstractPolymorphic(BeControl)),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeDynamicControlContainer (")
        printer.indent {
            print("content = "); _content.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeDynamicControlContainer   {
        return BeDynamicControlContainer(
            _content.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeEditor private constructor(
    val text: BeRichAttributedText,
    val language: com.jetbrains.rd.ide.model.RdLanguage?,
    private val _settings: RdProperty<BeEditorSettings?>,
    private val _isReadonly: RdProperty<Boolean>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeEditor> {
        override val _type: KClass<BeEditor> = BeEditor::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeEditor  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val text = BeRichAttributedText.read(ctx, buffer)
            val language = buffer.readNullable { com.jetbrains.rd.ide.model.RdLanguage.read(ctx, buffer) }
            val _settings = RdProperty.read(ctx, buffer, __BeEditorSettingsNullableSerializer)
            val _isReadonly = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            return BeEditor(text, language, _settings, _isReadonly, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeEditor)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            BeRichAttributedText.write(ctx, buffer, value.text)
            buffer.writeNullable(value.language) { com.jetbrains.rd.ide.model.RdLanguage.write(ctx, buffer, it) }
            RdProperty.write(ctx, buffer, value._settings)
            RdProperty.write(ctx, buffer, value._isReadonly)
        }
        
        private val __BeEditorSettingsNullableSerializer = AbstractPolymorphic(BeEditorSettings).nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val settings: IProperty<BeEditorSettings?> get() = _settings
    val isReadonly: IProperty<Boolean> get() = _isReadonly
    //methods
    //initializer
    init {
        _isReadonly.optimizeNested = true
    }
    
    init {
        bindableChildren.add("text" to text)
        bindableChildren.add("settings" to _settings)
        bindableChildren.add("isReadonly" to _isReadonly)
    }
    
    //secondary constructor
    constructor(
        text: BeRichAttributedText,
        language: com.jetbrains.rd.ide.model.RdLanguage?
    ) : this(
        text,
        language,
        RdProperty<BeEditorSettings?>(null, __BeEditorSettingsNullableSerializer),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeEditor (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("language = "); language.print(printer); println()
            print("settings = "); _settings.print(printer); println()
            print("isReadonly = "); _isReadonly.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeEditor   {
        return BeEditor(
            text.deepClonePolymorphic(),
            language,
            _settings.deepClonePolymorphic(),
            _isReadonly.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * @property editorId Not implemented in WPF frontend yet
 * #### Generated from [UIAutomationModel.kt]
 */
class BeEditorImpl private constructor(
    val editorId: com.jetbrains.rd.ide.model.TextControlId,
    private val _settings: RdProperty<BeEditorSettings?>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeEditorImpl> {
        override val _type: KClass<BeEditorImpl> = BeEditorImpl::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeEditorImpl  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val editorId = com.jetbrains.rd.ide.model.TextControlId.read(ctx, buffer)
            val _settings = RdProperty.read(ctx, buffer, __BeEditorSettingsNullableSerializer)
            return BeEditorImpl(editorId, _settings, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeEditorImpl)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            com.jetbrains.rd.ide.model.TextControlId.write(ctx, buffer, value.editorId)
            RdProperty.write(ctx, buffer, value._settings)
        }
        
        private val __BeEditorSettingsNullableSerializer = AbstractPolymorphic(BeEditorSettings).nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val settings: IProperty<BeEditorSettings?> get() = _settings
    //methods
    //initializer
    init {
        bindableChildren.add("settings" to _settings)
    }
    
    //secondary constructor
    constructor(
        editorId: com.jetbrains.rd.ide.model.TextControlId
    ) : this(
        editorId,
        RdProperty<BeEditorSettings?>(null, __BeEditorSettingsNullableSerializer),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeEditorImpl (")
        printer.indent {
            print("editorId = "); editorId.print(printer); println()
            print("settings = "); _settings.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeEditorImpl   {
        return BeEditorImpl(
            editorId,
            _settings.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeEditorSettings (
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<BeEditorSettings> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeEditorSettings  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeEditorSettings_Unknown(unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BeEditorSettings_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeEditorSettings (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeEditorSettings_Unknown> {
        override val _type: KClass<BeEditorSettings_Unknown> = BeEditorSettings_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeEditorSettings_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeEditorSettings_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeEditorSettings_Unknown (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeEditorSettings_Unknown   {
        return BeEditorSettings_Unknown(
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * To support partial links inside rich text - for each text part with FontStyle.Underlined property an action from the corresponding list will be retrieved. If there is one part and one action whole part will be treated as a link
 * #### Generated from [UIAutomationModel.kt]
 */
class BeEmptyText (
    val text: com.jetbrains.rd.ide.model.RichTextModel,
    val secondaryText: com.jetbrains.rd.ide.model.RichTextModel? = null,
    val actions: List<BeUserAction>? = null,
    val secondaryActions: List<BeUserAction>? = null
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BeEmptyText> {
        override val _type: KClass<BeEmptyText> = BeEmptyText::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeEmptyText  {
            val _id = RdId.read(buffer)
            val text = com.jetbrains.rd.ide.model.RichTextModel.read(ctx, buffer)
            val secondaryText = buffer.readNullable { com.jetbrains.rd.ide.model.RichTextModel.read(ctx, buffer) }
            val actions = buffer.readNullable { buffer.readList { BeUserAction.read(ctx, buffer) } }
            val secondaryActions = buffer.readNullable { buffer.readList { BeUserAction.read(ctx, buffer) } }
            return BeEmptyText(text, secondaryText, actions, secondaryActions).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeEmptyText)  {
            value.rdid.write(buffer)
            com.jetbrains.rd.ide.model.RichTextModel.write(ctx, buffer, value.text)
            buffer.writeNullable(value.secondaryText) { com.jetbrains.rd.ide.model.RichTextModel.write(ctx, buffer, it) }
            buffer.writeNullable(value.actions) { buffer.writeList(it) { v -> BeUserAction.write(ctx, buffer, v) } }
            buffer.writeNullable(value.secondaryActions) { buffer.writeList(it) { v -> BeUserAction.write(ctx, buffer, v) } }
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("actions" to actions)
        bindableChildren.add("secondaryActions" to secondaryActions)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeEmptyText (")
        printer.indent {
            print("text = "); text.print(printer); println()
            print("secondaryText = "); secondaryText.print(printer); println()
            print("actions = "); actions.print(printer); println()
            print("secondaryActions = "); secondaryActions.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeEmptyText   {
        return BeEmptyText(
            text,
            secondaryText,
            actions.deepClonePolymorphic(),
            secondaryActions.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeFocusCenterPopupContext (
) : BePopupContext (
) {
    //companion
    
    companion object : IMarshaller<BeFocusCenterPopupContext> {
        override val _type: KClass<BeFocusCenterPopupContext> = BeFocusCenterPopupContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeFocusCenterPopupContext  {
            val _id = RdId.read(buffer)
            return BeFocusCenterPopupContext().withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeFocusCenterPopupContext)  {
            value.rdid.write(buffer)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeFocusCenterPopupContext (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeFocusCenterPopupContext   {
        return BeFocusCenterPopupContext(
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeFontSize {
    DEFAULT, 
    BIGGER, 
    SMALLER;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeFontSize>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeFontStyle {
    DEFAULT, 
    MONOSPACE;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeFontStyle>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeGrid private constructor(
    private val _items: RdOptionalProperty<List<BeGridElement>>,
    val orientation: GridOrientation,
    val intercellSpacing: BeMarginType = BeMarginType.DefaultIntercellSpacing,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeGrid> {
        override val _type: KClass<BeGrid> = BeGrid::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeGrid  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _items = RdOptionalProperty.read(ctx, buffer, __BeGridElementListSerializer)
            val orientation = buffer.readEnum<GridOrientation>()
            val intercellSpacing = buffer.readEnum<BeMarginType>()
            return BeGrid(_items, orientation, intercellSpacing, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeGrid)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdOptionalProperty.write(ctx, buffer, value._items)
            buffer.writeEnum(value.orientation)
            buffer.writeEnum(value.intercellSpacing)
        }
        
        private val __BeGridElementListSerializer = BeGridElement.list()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val items: IOptProperty<List<BeGridElement>> get() = _items
    //methods
    //initializer
    init {
        bindableChildren.add("items" to _items)
    }
    
    //secondary constructor
    constructor(
        orientation: GridOrientation,
        intercellSpacing: BeMarginType = BeMarginType.DefaultIntercellSpacing
    ) : this(
        RdOptionalProperty<List<BeGridElement>>(__BeGridElementListSerializer),
        orientation,
        intercellSpacing,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeGrid (")
        printer.indent {
            print("items = "); _items.print(printer); println()
            print("orientation = "); orientation.print(printer); println()
            print("intercellSpacing = "); intercellSpacing.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeGrid   {
        return BeGrid(
            _items.deepClonePolymorphic(),
            orientation,
            intercellSpacing,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeGridElement (
    val content: BeControl,
    val size: BeUnitSize,
    val alignment: BeAlignment = BeAlignment.Stretch
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BeGridElement> {
        override val _type: KClass<BeGridElement> = BeGridElement::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeGridElement  {
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val size = BeUnitSize.read(ctx, buffer)
            val alignment = buffer.readEnum<BeAlignment>()
            return BeGridElement(content, size, alignment).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeGridElement)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            BeUnitSize.write(ctx, buffer, value.size)
            buffer.writeEnum(value.alignment)
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("content" to content)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeGridElement (")
        printer.indent {
            print("content = "); content.print(printer); println()
            print("size = "); size.print(printer); println()
            print("alignment = "); alignment.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeGridElement   {
        return BeGridElement(
            content.deepClonePolymorphic(),
            size,
            alignment
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeGroupBox private constructor(
    val title: String,
    content: BeControl,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlContainer (
    content,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeGroupBox> {
        override val _type: KClass<BeGroupBox> = BeGroupBox::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeGroupBox  {
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val title = buffer.readString()
            return BeGroupBox(title, content, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeGroupBox)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeString(value.title)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        title: String,
        content: BeControl
    ) : this(
        title,
        content,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeGroupBox (")
        printer.indent {
            print("title = "); title.print(printer); println()
            print("content = "); content.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeGroupBox   {
        return BeGroupBox(
            title,
            content.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeHeader private constructor(
    private val _text: RdProperty<String>,
    private val _icon: RdProperty<com.jetbrains.rd.ide.model.IconModel?>,
    val headerStyle: HeaderStyle = HeaderStyle.SEPARATOR,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeHeader> {
        override val _type: KClass<BeHeader> = BeHeader::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeHeader  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _text = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _icon = RdProperty.read(ctx, buffer, __IconModelNullableSerializer)
            val headerStyle = buffer.readEnum<HeaderStyle>()
            return BeHeader(_text, _icon, headerStyle, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeHeader)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdProperty.write(ctx, buffer, value._text)
            RdProperty.write(ctx, buffer, value._icon)
            buffer.writeEnum(value.headerStyle)
        }
        
        private val __IconModelNullableSerializer = AbstractPolymorphic(com.jetbrains.rd.ide.model.IconModel).nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val text: IProperty<String> get() = _text
    val icon: IProperty<com.jetbrains.rd.ide.model.IconModel?> get() = _icon
    //methods
    //initializer
    init {
        _text.optimizeNested = true
        _icon.optimizeNested = true
    }
    
    init {
        bindableChildren.add("text" to _text)
        bindableChildren.add("icon" to _icon)
    }
    
    //secondary constructor
    constructor(
        headerStyle: HeaderStyle = HeaderStyle.SEPARATOR
    ) : this(
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<com.jetbrains.rd.ide.model.IconModel?>(null, __IconModelNullableSerializer),
        headerStyle,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeHeader (")
        printer.indent {
            print("text = "); _text.print(printer); println()
            print("icon = "); _icon.print(printer); println()
            print("headerStyle = "); headerStyle.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeHeader   {
        return BeHeader(
            _text.deepClonePolymorphic(),
            _icon.deepClonePolymorphic(),
            headerStyle,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeHtmlViewer private constructor(
    private val _text: RdProperty<String?>,
    private val _url: RdProperty<String>,
    val asTextBox: Boolean,
    val textOnError: String = "Page cannot be loaded",
    private val _cssRules: RdOptionalProperty<List<String>>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeHtmlViewer> {
        override val _type: KClass<BeHtmlViewer> = BeHtmlViewer::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeHtmlViewer  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _text = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _url = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val asTextBox = buffer.readBool()
            val textOnError = buffer.readString()
            val _cssRules = RdOptionalProperty.read(ctx, buffer, __StringListSerializer)
            return BeHtmlViewer(_text, _url, asTextBox, textOnError, _cssRules, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeHtmlViewer)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdProperty.write(ctx, buffer, value._text)
            RdProperty.write(ctx, buffer, value._url)
            buffer.writeBool(value.asTextBox)
            buffer.writeString(value.textOnError)
            RdOptionalProperty.write(ctx, buffer, value._cssRules)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        private val __StringListSerializer = FrameworkMarshallers.String.list()
        
    }
    //fields
    val text: IProperty<String?> get() = _text
    val url: IProperty<String> get() = _url
    val cssRules: IOptProperty<List<String>> get() = _cssRules
    //methods
    //initializer
    init {
        _text.optimizeNested = true
        _url.optimizeNested = true
        _cssRules.optimizeNested = true
    }
    
    init {
        bindableChildren.add("text" to _text)
        bindableChildren.add("url" to _url)
        bindableChildren.add("cssRules" to _cssRules)
    }
    
    //secondary constructor
    constructor(
        asTextBox: Boolean,
        textOnError: String = "Page cannot be loaded"
    ) : this(
        RdProperty<String?>(null, __StringNullableSerializer),
        RdProperty<String>("", FrameworkMarshallers.String),
        asTextBox,
        textOnError,
        RdOptionalProperty<List<String>>(__StringListSerializer),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeHtmlViewer (")
        printer.indent {
            print("text = "); _text.print(printer); println()
            print("url = "); _url.print(printer); println()
            print("asTextBox = "); asTextBox.print(printer); println()
            print("textOnError = "); textOnError.print(printer); println()
            print("cssRules = "); _cssRules.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeHtmlViewer   {
        return BeHtmlViewer(
            _text.deepClonePolymorphic(),
            _url.deepClonePolymorphic(),
            asTextBox,
            textOnError,
            _cssRules.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeIcon private constructor(
    private val _icon: RdOptionalProperty<com.jetbrains.rd.ide.model.IconModel>,
    private val _iconId: RdOptionalProperty<BeCommonBehavior>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeIcon> {
        override val _type: KClass<BeIcon> = BeIcon::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeIcon  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _icon = RdOptionalProperty.read(ctx, buffer, AbstractPolymorphic(com.jetbrains.rd.ide.model.IconModel))
            val _iconId = RdOptionalProperty.read(ctx, buffer, BeCommonBehavior.marshaller)
            return BeIcon(_icon, _iconId, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeIcon)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdOptionalProperty.write(ctx, buffer, value._icon)
            RdOptionalProperty.write(ctx, buffer, value._iconId)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val icon: IOptProperty<com.jetbrains.rd.ide.model.IconModel> get() = _icon
    val iconId: IOptProperty<BeCommonBehavior> get() = _iconId
    //methods
    //initializer
    init {
        _icon.optimizeNested = true
        _iconId.optimizeNested = true
    }
    
    init {
        bindableChildren.add("icon" to _icon)
        bindableChildren.add("iconId" to _iconId)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<com.jetbrains.rd.ide.model.IconModel>(AbstractPolymorphic(com.jetbrains.rd.ide.model.IconModel)),
        RdOptionalProperty<BeCommonBehavior>(BeCommonBehavior.marshaller),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeIcon (")
        printer.indent {
            print("icon = "); _icon.print(printer); println()
            print("iconId = "); _iconId.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeIcon   {
        return BeIcon(
            _icon.deepClonePolymorphic(),
            _iconId.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeIdeAction (
    val actionId: String,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IAbstractDeclaration<BeIdeAction> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeIdeAction  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val actionId = buffer.readString()
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeIdeAction_Unknown(actionId, _enabled, _controlId, _tooltip, _focus, _visible, unknownId, unknownBytes).withId(_id)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BeIdeAction_Unknown (
    actionId: String,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeIdeAction (
    actionId,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeIdeAction_Unknown> {
        override val _type: KClass<BeIdeAction_Unknown> = BeIdeAction_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeIdeAction_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeIdeAction_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeString(value.actionId)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        actionId: String,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        actionId,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeIdeAction_Unknown (")
        printer.indent {
            print("actionId = "); actionId.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeIdeAction_Unknown   {
        return BeIdeAction_Unknown(
            actionId,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeIdeaEditorSettings (
    val additionalColumnsCount: Int,
    val additionalLinesCount: Int,
    val isCaretRowShown: Boolean,
    val isFoldingOutlineShown: Boolean,
    val isIndentGuidesShown: Boolean,
    val isLineMarkerAreaShown: Boolean,
    val isLineNumbersShown: Boolean,
    val isUseSoftWraps: Boolean,
    val isWhitespacesShown: Boolean,
    val isPaintGutterBackground: Boolean
) : BeEditorSettings (
) {
    //companion
    
    companion object : IMarshaller<BeIdeaEditorSettings> {
        override val _type: KClass<BeIdeaEditorSettings> = BeIdeaEditorSettings::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeIdeaEditorSettings  {
            val _id = RdId.read(buffer)
            val additionalColumnsCount = buffer.readInt()
            val additionalLinesCount = buffer.readInt()
            val isCaretRowShown = buffer.readBool()
            val isFoldingOutlineShown = buffer.readBool()
            val isIndentGuidesShown = buffer.readBool()
            val isLineMarkerAreaShown = buffer.readBool()
            val isLineNumbersShown = buffer.readBool()
            val isUseSoftWraps = buffer.readBool()
            val isWhitespacesShown = buffer.readBool()
            val isPaintGutterBackground = buffer.readBool()
            return BeIdeaEditorSettings(additionalColumnsCount, additionalLinesCount, isCaretRowShown, isFoldingOutlineShown, isIndentGuidesShown, isLineMarkerAreaShown, isLineNumbersShown, isUseSoftWraps, isWhitespacesShown, isPaintGutterBackground).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeIdeaEditorSettings)  {
            value.rdid.write(buffer)
            buffer.writeInt(value.additionalColumnsCount)
            buffer.writeInt(value.additionalLinesCount)
            buffer.writeBool(value.isCaretRowShown)
            buffer.writeBool(value.isFoldingOutlineShown)
            buffer.writeBool(value.isIndentGuidesShown)
            buffer.writeBool(value.isLineMarkerAreaShown)
            buffer.writeBool(value.isLineNumbersShown)
            buffer.writeBool(value.isUseSoftWraps)
            buffer.writeBool(value.isWhitespacesShown)
            buffer.writeBool(value.isPaintGutterBackground)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeIdeaEditorSettings (")
        printer.indent {
            print("additionalColumnsCount = "); additionalColumnsCount.print(printer); println()
            print("additionalLinesCount = "); additionalLinesCount.print(printer); println()
            print("isCaretRowShown = "); isCaretRowShown.print(printer); println()
            print("isFoldingOutlineShown = "); isFoldingOutlineShown.print(printer); println()
            print("isIndentGuidesShown = "); isIndentGuidesShown.print(printer); println()
            print("isLineMarkerAreaShown = "); isLineMarkerAreaShown.print(printer); println()
            print("isLineNumbersShown = "); isLineNumbersShown.print(printer); println()
            print("isUseSoftWraps = "); isUseSoftWraps.print(printer); println()
            print("isWhitespacesShown = "); isWhitespacesShown.print(printer); println()
            print("isPaintGutterBackground = "); isPaintGutterBackground.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeIdeaEditorSettings   {
        return BeIdeaEditorSettings(
            additionalColumnsCount,
            additionalLinesCount,
            isCaretRowShown,
            isFoldingOutlineShown,
            isIndentGuidesShown,
            isLineMarkerAreaShown,
            isLineNumbersShown,
            isUseSoftWraps,
            isWhitespacesShown,
            isPaintGutterBackground
        )
    }
    //contexts
}


/**
 * @property settings specifies common text style (font, size)
 * #### Generated from [UIAutomationModel.kt]
 */
class BeLabel private constructor(
    val settings: BeTextSettings,
    private val _text: RdProperty<String>,
    wrapText: Boolean,
    _icon: RdProperty<com.jetbrains.rd.ide.model.IconModel?>,
    _shortcutIndex: RdProperty<Int>,
    _target: RdProperty<String>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeAbstractText (
    wrapText,
    _icon,
    _shortcutIndex,
    _target,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeLabel> {
        override val _type: KClass<BeLabel> = BeLabel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeLabel  {
            val _id = RdId.read(buffer)
            val wrapText = buffer.readBool()
            val _icon = RdProperty.read(ctx, buffer, __IconModelNullableSerializer)
            val _shortcutIndex = RdProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _target = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val settings = BeTextSettings.read(ctx, buffer)
            val _text = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            return BeLabel(settings, _text, wrapText, _icon, _shortcutIndex, _target, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeLabel)  {
            value.rdid.write(buffer)
            buffer.writeBool(value.wrapText)
            RdProperty.write(ctx, buffer, value._icon)
            RdProperty.write(ctx, buffer, value._shortcutIndex)
            RdProperty.write(ctx, buffer, value._target)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            BeTextSettings.write(ctx, buffer, value.settings)
            RdProperty.write(ctx, buffer, value._text)
        }
        
        private val __IconModelNullableSerializer = AbstractPolymorphic(com.jetbrains.rd.ide.model.IconModel).nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val text: IProperty<String> get() = _text
    //methods
    //initializer
    init {
        _text.optimizeNested = true
    }
    
    init {
        bindableChildren.add("settings" to settings)
        bindableChildren.add("text" to _text)
    }
    
    //secondary constructor
    constructor(
        wrapText: Boolean
    ) : this(
        BeTextSettings(),
        RdProperty<String>("", FrameworkMarshallers.String),
        wrapText,
        RdProperty<com.jetbrains.rd.ide.model.IconModel?>(null, __IconModelNullableSerializer),
        RdProperty<Int>(-1, FrameworkMarshallers.Int),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeLabel (")
        printer.indent {
            print("settings = "); settings.print(printer); println()
            print("text = "); _text.print(printer); println()
            print("wrapText = "); wrapText.print(printer); println()
            print("icon = "); _icon.print(printer); println()
            print("shortcutIndex = "); _shortcutIndex.print(printer); println()
            print("target = "); _target.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeLabel   {
        return BeLabel(
            settings.deepClonePolymorphic(),
            _text.deepClonePolymorphic(),
            wrapText,
            _icon.deepClonePolymorphic(),
            _shortcutIndex.deepClonePolymorphic(),
            _target.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeLink private constructor(
    val prefix: BeAbstractText,
    private val _content: RdOptionalProperty<String>,
    val postfix: BeAbstractText,
    val action: BeUserAction,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeLink> {
        override val _type: KClass<BeLink> = BeLink::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeLink  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val prefix = ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText)
            val _content = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val postfix = ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText)
            val action = BeUserAction.read(ctx, buffer)
            return BeLink(prefix, _content, postfix, action, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeLink)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            ctx.serializers.writePolymorphic(ctx, buffer, value.prefix)
            RdOptionalProperty.write(ctx, buffer, value._content)
            ctx.serializers.writePolymorphic(ctx, buffer, value.postfix)
            BeUserAction.write(ctx, buffer, value.action)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val content: IOptProperty<String> get() = _content
    //methods
    //initializer
    init {
        _content.optimizeNested = true
    }
    
    init {
        bindableChildren.add("prefix" to prefix)
        bindableChildren.add("content" to _content)
        bindableChildren.add("postfix" to postfix)
        bindableChildren.add("action" to action)
    }
    
    //secondary constructor
    constructor(
        prefix: BeAbstractText,
        postfix: BeAbstractText,
        action: BeUserAction
    ) : this(
        prefix,
        RdOptionalProperty<String>(FrameworkMarshallers.String),
        postfix,
        action,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeLink (")
        printer.indent {
            print("prefix = "); prefix.print(printer); println()
            print("content = "); _content.print(printer); println()
            print("postfix = "); postfix.print(printer); println()
            print("action = "); action.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeLink   {
        return BeLink(
            prefix.deepClonePolymorphic(),
            _content.deepClonePolymorphic(),
            postfix.deepClonePolymorphic(),
            action.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
data class BeMargin (
    val left: BeMarginItem,
    val top: BeMarginItem,
    val right: BeMarginItem,
    val bottom: BeMarginItem
) : IPrintable {
    //companion
    
    companion object : IMarshaller<BeMargin> {
        override val _type: KClass<BeMargin> = BeMargin::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeMargin  {
            val left = BeMarginItem.read(ctx, buffer)
            val top = BeMarginItem.read(ctx, buffer)
            val right = BeMarginItem.read(ctx, buffer)
            val bottom = BeMarginItem.read(ctx, buffer)
            return BeMargin(left, top, right, bottom)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeMargin)  {
            BeMarginItem.write(ctx, buffer, value.left)
            BeMarginItem.write(ctx, buffer, value.top)
            BeMarginItem.write(ctx, buffer, value.right)
            BeMarginItem.write(ctx, buffer, value.bottom)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeMargin
        
        if (left != other.left) return false
        if (top != other.top) return false
        if (right != other.right) return false
        if (bottom != other.bottom) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + left.hashCode()
        __r = __r*31 + top.hashCode()
        __r = __r*31 + right.hashCode()
        __r = __r*31 + bottom.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeMargin (")
        printer.indent {
            print("left = "); left.print(printer); println()
            print("top = "); top.print(printer); println()
            print("right = "); right.print(printer); println()
            print("bottom = "); bottom.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
data class BeMarginItem (
    val unit: BeMarginType,
    val multiplier: Int = 1
) : IPrintable {
    //companion
    
    companion object : IMarshaller<BeMarginItem> {
        override val _type: KClass<BeMarginItem> = BeMarginItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeMarginItem  {
            val unit = buffer.readEnum<BeMarginType>()
            val multiplier = buffer.readInt()
            return BeMarginItem(unit, multiplier)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeMarginItem)  {
            buffer.writeEnum(value.unit)
            buffer.writeInt(value.multiplier)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeMarginItem
        
        if (unit != other.unit) return false
        if (multiplier != other.multiplier) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + unit.hashCode()
        __r = __r*31 + multiplier.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeMarginItem (")
        printer.indent {
            print("unit = "); unit.print(printer); println()
            print("multiplier = "); multiplier.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeMarginModifier (
    val margin: BeMargin
) : BeStyleModifier (
) {
    //companion
    
    companion object : IMarshaller<BeMarginModifier> {
        override val _type: KClass<BeMarginModifier> = BeMarginModifier::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeMarginModifier  {
            val margin = BeMargin.read(ctx, buffer)
            return BeMarginModifier(margin)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeMarginModifier)  {
            BeMargin.write(ctx, buffer, value.margin)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeMarginModifier
        
        if (margin != other.margin) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + margin.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeMarginModifier (")
        printer.indent {
            print("margin = "); margin.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeMarginType {
    None, 
    OnePx, 
    Checkbox, 
    RadioButton, 
    ExtractClassTempLineMargin, 
    DefaultIntercellSpacing, 
    ReducedIntercellSpacing, 
    IncreasedIntercellSpacing;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeMarginType>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeMenu private constructor(
    private val _menuItems: RdList<BeControl>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeMenu> {
        override val _type: KClass<BeMenu> = BeMenu::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeMenu  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _menuItems = RdList.read(ctx, buffer, AbstractPolymorphic(BeControl))
            return BeMenu(_menuItems, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeMenu)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdList.write(ctx, buffer, value._menuItems)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val menuItems: IMutableViewableList<BeControl> get() = _menuItems
    //methods
    //initializer
    init {
        bindableChildren.add("menuItems" to _menuItems)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdList<BeControl>(AbstractPolymorphic(BeControl)),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeMenu (")
        printer.indent {
            print("menuItems = "); _menuItems.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeMenu   {
        return BeMenu(
            _menuItems.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeMenuItem private constructor(
    private val _innerMenuItems: RdOptionalProperty<List<BeControl>>,
    private val _header: RdOptionalProperty<BeControl>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeMenuItem> {
        override val _type: KClass<BeMenuItem> = BeMenuItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeMenuItem  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _innerMenuItems = RdOptionalProperty.read(ctx, buffer, __BeControlListSerializer)
            val _header = RdOptionalProperty.read(ctx, buffer, AbstractPolymorphic(BeControl))
            return BeMenuItem(_innerMenuItems, _header, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeMenuItem)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdOptionalProperty.write(ctx, buffer, value._innerMenuItems)
            RdOptionalProperty.write(ctx, buffer, value._header)
        }
        
        private val __BeControlListSerializer = AbstractPolymorphic(BeControl).list()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val innerMenuItems: IOptProperty<List<BeControl>> get() = _innerMenuItems
    val header: IOptProperty<BeControl> get() = _header
    //methods
    //initializer
    init {
        bindableChildren.add("innerMenuItems" to _innerMenuItems)
        bindableChildren.add("header" to _header)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<List<BeControl>>(__BeControlListSerializer),
        RdOptionalProperty<BeControl>(AbstractPolymorphic(BeControl)),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeMenuItem (")
        printer.indent {
            print("innerMenuItems = "); _innerMenuItems.print(printer); println()
            print("header = "); _header.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeMenuItem   {
        return BeMenuItem(
            _innerMenuItems.deepClonePolymorphic(),
            _header.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeMigLayout private constructor(
    private val _items: RdOptionalProperty<List<BeMigLayoutItem>>,
    val layoutConstraints: String,
    val colConstraints: String,
    val rowConstraints: String,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeMigLayout> {
        override val _type: KClass<BeMigLayout> = BeMigLayout::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeMigLayout  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _items = RdOptionalProperty.read(ctx, buffer, __BeMigLayoutItemListSerializer)
            val layoutConstraints = buffer.readString()
            val colConstraints = buffer.readString()
            val rowConstraints = buffer.readString()
            return BeMigLayout(_items, layoutConstraints, colConstraints, rowConstraints, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeMigLayout)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdOptionalProperty.write(ctx, buffer, value._items)
            buffer.writeString(value.layoutConstraints)
            buffer.writeString(value.colConstraints)
            buffer.writeString(value.rowConstraints)
        }
        
        private val __BeMigLayoutItemListSerializer = BeMigLayoutItem.list()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val items: IOptProperty<List<BeMigLayoutItem>> get() = _items
    //methods
    //initializer
    init {
        bindableChildren.add("items" to _items)
    }
    
    //secondary constructor
    constructor(
        layoutConstraints: String,
        colConstraints: String,
        rowConstraints: String
    ) : this(
        RdOptionalProperty<List<BeMigLayoutItem>>(__BeMigLayoutItemListSerializer),
        layoutConstraints,
        colConstraints,
        rowConstraints,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeMigLayout (")
        printer.indent {
            print("items = "); _items.print(printer); println()
            print("layoutConstraints = "); layoutConstraints.print(printer); println()
            print("colConstraints = "); colConstraints.print(printer); println()
            print("rowConstraints = "); rowConstraints.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeMigLayout   {
        return BeMigLayout(
            _items.deepClonePolymorphic(),
            layoutConstraints,
            colConstraints,
            rowConstraints,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeMigLayoutItem (
    val content: BeControl,
    val constraints: String
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BeMigLayoutItem> {
        override val _type: KClass<BeMigLayoutItem> = BeMigLayoutItem::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeMigLayoutItem  {
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val constraints = buffer.readString()
            return BeMigLayoutItem(content, constraints).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeMigLayoutItem)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            buffer.writeString(value.constraints)
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("content" to content)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeMigLayoutItem (")
        printer.indent {
            print("content = "); content.print(printer); println()
            print("constraints = "); constraints.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeMigLayoutItem   {
        return BeMigLayoutItem(
            content.deepClonePolymorphic(),
            constraints
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeMouseAction {
    CLICK, 
    DOUBLE_CLICK, 
    HOVER;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeMouseAction>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeMouseListener private constructor(
    val mouseAction: BeMouseAction,
    _reaction: RdSignal<Unit>,
    overrideDefault: Boolean = false
) : BeActionListener (
    _reaction,
    overrideDefault
) {
    //companion
    
    companion object : IMarshaller<BeMouseListener> {
        override val _type: KClass<BeMouseListener> = BeMouseListener::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeMouseListener  {
            val _id = RdId.read(buffer)
            val _reaction = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val overrideDefault = buffer.readBool()
            val mouseAction = buffer.readEnum<BeMouseAction>()
            return BeMouseListener(mouseAction, _reaction, overrideDefault).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeMouseListener)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._reaction)
            buffer.writeBool(value.overrideDefault)
            buffer.writeEnum(value.mouseAction)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        mouseAction: BeMouseAction,
        overrideDefault: Boolean = false
    ) : this(
        mouseAction,
        RdSignal<Unit>(FrameworkMarshallers.Void),
        overrideDefault
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeMouseListener (")
        printer.indent {
            print("mouseAction = "); mouseAction.print(printer); println()
            print("reaction = "); _reaction.print(printer); println()
            print("overrideDefault = "); overrideDefault.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeMouseListener   {
        return BeMouseListener(
            mouseAction,
            _reaction.deepClonePolymorphic(),
            overrideDefault
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeMutableGrid private constructor(
    private val _items: RdList<BeGridElement>,
    val orientation: GridOrientation,
    val intercellSpacing: BeMarginType = BeMarginType.DefaultIntercellSpacing,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeMutableGrid> {
        override val _type: KClass<BeMutableGrid> = BeMutableGrid::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeMutableGrid  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _items = RdList.read(ctx, buffer, BeGridElement)
            val orientation = buffer.readEnum<GridOrientation>()
            val intercellSpacing = buffer.readEnum<BeMarginType>()
            return BeMutableGrid(_items, orientation, intercellSpacing, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeMutableGrid)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdList.write(ctx, buffer, value._items)
            buffer.writeEnum(value.orientation)
            buffer.writeEnum(value.intercellSpacing)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val items: IMutableViewableList<BeGridElement> get() = _items
    //methods
    //initializer
    init {
        bindableChildren.add("items" to _items)
    }
    
    //secondary constructor
    constructor(
        orientation: GridOrientation,
        intercellSpacing: BeMarginType = BeMarginType.DefaultIntercellSpacing
    ) : this(
        RdList<BeGridElement>(BeGridElement),
        orientation,
        intercellSpacing,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeMutableGrid (")
        printer.indent {
            print("items = "); _items.print(printer); println()
            print("orientation = "); orientation.print(printer); println()
            print("intercellSpacing = "); intercellSpacing.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeMutableGrid   {
        return BeMutableGrid(
            _items.deepClonePolymorphic(),
            orientation,
            intercellSpacing,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeMutableSpanGrid private constructor(
    private val _items: RdList<BeSpanRowElement>,
    val columns: List<BeUnitSize>,
    val intercellSpacing: BeMarginType = BeMarginType.DefaultIntercellSpacing,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeMutableSpanGrid> {
        override val _type: KClass<BeMutableSpanGrid> = BeMutableSpanGrid::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeMutableSpanGrid  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _items = RdList.read(ctx, buffer, BeSpanRowElement)
            val columns = buffer.readList { BeUnitSize.read(ctx, buffer) }
            val intercellSpacing = buffer.readEnum<BeMarginType>()
            return BeMutableSpanGrid(_items, columns, intercellSpacing, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeMutableSpanGrid)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdList.write(ctx, buffer, value._items)
            buffer.writeList(value.columns) { v -> BeUnitSize.write(ctx, buffer, v) }
            buffer.writeEnum(value.intercellSpacing)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val items: IMutableViewableList<BeSpanRowElement> get() = _items
    //methods
    //initializer
    init {
        bindableChildren.add("items" to _items)
    }
    
    //secondary constructor
    constructor(
        columns: List<BeUnitSize>,
        intercellSpacing: BeMarginType = BeMarginType.DefaultIntercellSpacing
    ) : this(
        RdList<BeSpanRowElement>(BeSpanRowElement),
        columns,
        intercellSpacing,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeMutableSpanGrid (")
        printer.indent {
            print("items = "); _items.print(printer); println()
            print("columns = "); columns.print(printer); println()
            print("intercellSpacing = "); intercellSpacing.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeMutableSpanGrid   {
        return BeMutableSpanGrid(
            _items.deepClonePolymorphic(),
            columns,
            intercellSpacing,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeOpacityModifier (
    val opacity: Float
) : BeStyleModifier (
) {
    //companion
    
    companion object : IMarshaller<BeOpacityModifier> {
        override val _type: KClass<BeOpacityModifier> = BeOpacityModifier::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeOpacityModifier  {
            val opacity = buffer.readFloat()
            return BeOpacityModifier(opacity)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeOpacityModifier)  {
            buffer.writeFloat(value.opacity)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeOpacityModifier
        
        if (opacity != other.opacity) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + opacity.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeOpacityModifier (")
        printer.indent {
            print("opacity = "); opacity.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BePasswordTextBox private constructor(
    _text: RdProperty<String>,
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlWithEditableText (
    _text,
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BePasswordTextBox> {
        override val _type: KClass<BePasswordTextBox> = BePasswordTextBox::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BePasswordTextBox  {
            val _id = RdId.read(buffer)
            val _text = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _validationResult = RdOptionalProperty.read(ctx, buffer, ValidationResult)
            val _validationStyle = RdOptionalProperty.read(ctx, buffer, ValidationStyle.marshaller)
            val _handledByParent = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _revalidate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            return BePasswordTextBox(_text, _validationResult, _validationStyle, _handledByParent, _revalidate, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BePasswordTextBox)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._text)
            RdOptionalProperty.write(ctx, buffer, value._validationResult)
            RdOptionalProperty.write(ctx, buffer, value._validationStyle)
            RdProperty.write(ctx, buffer, value._handledByParent)
            RdSignal.write(ctx, buffer, value._revalidate)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
    ) : this(
        RdProperty<String>("", FrameworkMarshallers.String),
        RdOptionalProperty<ValidationResult>(ValidationResult),
        RdOptionalProperty<ValidationStyle>(ValidationStyle.marshaller),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BePasswordTextBox (")
        printer.indent {
            print("text = "); _text.print(printer); println()
            print("validationResult = "); _validationResult.print(printer); println()
            print("validationStyle = "); _validationStyle.print(printer); println()
            print("handledByParent = "); _handledByParent.print(printer); println()
            print("revalidate = "); _revalidate.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BePasswordTextBox   {
        return BePasswordTextBox(
            _text.deepClonePolymorphic(),
            _validationResult.deepClonePolymorphic(),
            _validationStyle.deepClonePolymorphic(),
            _handledByParent.deepClonePolymorphic(),
            _revalidate.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BePopup private constructor(
    val content: BeControl,
    val range: com.jetbrains.rd.ide.model.RdTextRange,
    val textControlId: com.jetbrains.rd.ide.model.TextControlId,
    val hasCloseButton: Boolean = false,
    private val _isClosed: RdOptionalProperty<Boolean>,
    private val _resize: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BePopup> {
        override val _type: KClass<BePopup> = BePopup::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BePopup  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val range = com.jetbrains.rd.ide.model.RdTextRange.read(ctx, buffer)
            val textControlId = com.jetbrains.rd.ide.model.TextControlId.read(ctx, buffer)
            val hasCloseButton = buffer.readBool()
            val _isClosed = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _resize = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return BePopup(content, range, textControlId, hasCloseButton, _isClosed, _resize, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BePopup)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            com.jetbrains.rd.ide.model.RdTextRange.write(ctx, buffer, value.range)
            com.jetbrains.rd.ide.model.TextControlId.write(ctx, buffer, value.textControlId)
            buffer.writeBool(value.hasCloseButton)
            RdOptionalProperty.write(ctx, buffer, value._isClosed)
            RdSignal.write(ctx, buffer, value._resize)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val isClosed: IOptProperty<Boolean> get() = _isClosed
    val resize: ISignal<Unit> get() = _resize
    //methods
    //initializer
    init {
        _isClosed.optimizeNested = true
    }
    
    init {
        bindableChildren.add("content" to content)
        bindableChildren.add("isClosed" to _isClosed)
        bindableChildren.add("resize" to _resize)
    }
    
    //secondary constructor
    constructor(
        content: BeControl,
        range: com.jetbrains.rd.ide.model.RdTextRange,
        textControlId: com.jetbrains.rd.ide.model.TextControlId,
        hasCloseButton: Boolean = false
    ) : this(
        content,
        range,
        textControlId,
        hasCloseButton,
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BePopup (")
        printer.indent {
            print("content = "); content.print(printer); println()
            print("range = "); range.print(printer); println()
            print("textControlId = "); textControlId.print(printer); println()
            print("hasCloseButton = "); hasCloseButton.print(printer); println()
            print("isClosed = "); _isClosed.print(printer); println()
            print("resize = "); _resize.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BePopup   {
        return BePopup(
            content.deepClonePolymorphic(),
            range,
            textControlId,
            hasCloseButton,
            _isClosed.deepClonePolymorphic(),
            _resize.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BePopupContext (
) : RdBindableBase() {
    //companion
    
    companion object : IAbstractDeclaration<BePopupContext> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BePopupContext  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BePopupContext_Unknown(unknownId, unknownBytes).withId(_id)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BePopupContext_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BePopupContext (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BePopupContext_Unknown> {
        override val _type: KClass<BePopupContext_Unknown> = BePopupContext_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BePopupContext_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BePopupContext_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BePopupContext_Unknown (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BePopupContext_Unknown   {
        return BePopupContext_Unknown(
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BePosition {
    LEFT, 
    TOP, 
    RIGHT, 
    BOTTOM;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BePosition>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BePredefinedAction private constructor(
    private val _click: RdSignal<Unit>
) : BeButtonAction (
) {
    //companion
    
    companion object : IMarshaller<BePredefinedAction> {
        override val _type: KClass<BePredefinedAction> = BePredefinedAction::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BePredefinedAction  {
            val _id = RdId.read(buffer)
            val _click = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return BePredefinedAction(_click).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BePredefinedAction)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._click)
        }
        
        
    }
    //fields
    val click: ISignal<Unit> get() = _click
    //methods
    //initializer
    init {
        bindableChildren.add("click" to _click)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdSignal<Unit>(FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BePredefinedAction (")
        printer.indent {
            print("click = "); _click.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BePredefinedAction   {
        return BePredefinedAction(
            _click.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BePredefinedBehaviorButton private constructor(
    val predefinedBehavior: BeCommonBehavior,
    action: BeUserAction,
    content: BeAbstractText,
    style: BeButtonStyle = BeButtonStyle.DEFAULT,
    _isMouseOver: RdProperty<Boolean>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeButton (
    action,
    content,
    style,
    _isMouseOver,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BePredefinedBehaviorButton> {
        override val _type: KClass<BePredefinedBehaviorButton> = BePredefinedBehaviorButton::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BePredefinedBehaviorButton  {
            val _id = RdId.read(buffer)
            val action = BeUserAction.read(ctx, buffer)
            val content = ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText)
            val style = buffer.readEnum<BeButtonStyle>()
            val _isMouseOver = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val predefinedBehavior = buffer.readEnum<BeCommonBehavior>()
            return BePredefinedBehaviorButton(predefinedBehavior, action, content, style, _isMouseOver, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BePredefinedBehaviorButton)  {
            value.rdid.write(buffer)
            BeUserAction.write(ctx, buffer, value.action)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            buffer.writeEnum(value.style)
            RdProperty.write(ctx, buffer, value._isMouseOver)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeEnum(value.predefinedBehavior)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        predefinedBehavior: BeCommonBehavior,
        action: BeUserAction,
        content: BeAbstractText,
        style: BeButtonStyle = BeButtonStyle.DEFAULT
    ) : this(
        predefinedBehavior,
        action,
        content,
        style,
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BePredefinedBehaviorButton (")
        printer.indent {
            print("predefinedBehavior = "); predefinedBehavior.print(printer); println()
            print("action = "); action.print(printer); println()
            print("content = "); content.print(printer); println()
            print("style = "); style.print(printer); println()
            print("isMouseOver = "); _isMouseOver.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BePredefinedBehaviorButton   {
        return BePredefinedBehaviorButton(
            predefinedBehavior,
            action.deepClonePolymorphic(),
            content.deepClonePolymorphic(),
            style,
            _isMouseOver.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BePredefinedShortcutListener private constructor(
    val shortcut: BeCommonBehavior,
    _reaction: RdSignal<Unit>,
    overrideDefault: Boolean = false
) : BeActionListener (
    _reaction,
    overrideDefault
) {
    //companion
    
    companion object : IMarshaller<BePredefinedShortcutListener> {
        override val _type: KClass<BePredefinedShortcutListener> = BePredefinedShortcutListener::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BePredefinedShortcutListener  {
            val _id = RdId.read(buffer)
            val _reaction = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val overrideDefault = buffer.readBool()
            val shortcut = buffer.readEnum<BeCommonBehavior>()
            return BePredefinedShortcutListener(shortcut, _reaction, overrideDefault).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BePredefinedShortcutListener)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._reaction)
            buffer.writeBool(value.overrideDefault)
            buffer.writeEnum(value.shortcut)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        shortcut: BeCommonBehavior,
        overrideDefault: Boolean = false
    ) : this(
        shortcut,
        RdSignal<Unit>(FrameworkMarshallers.Void),
        overrideDefault
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BePredefinedShortcutListener (")
        printer.indent {
            print("shortcut = "); shortcut.print(printer); println()
            print("reaction = "); _reaction.print(printer); println()
            print("overrideDefault = "); overrideDefault.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BePredefinedShortcutListener   {
        return BePredefinedShortcutListener(
            shortcut,
            _reaction.deepClonePolymorphic(),
            overrideDefault
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
open class BeProgress protected constructor(
    protected val _execute: RdProperty<AbstractProgress?>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeProgress>, IAbstractDeclaration<BeProgress> {
        override val _type: KClass<BeProgress> = BeProgress::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeProgress  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _execute = RdProperty.read(ctx, buffer, __AbstractProgressNullableSerializer)
            return BeProgress(_execute, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeProgress)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdProperty.write(ctx, buffer, value._execute)
        }
        
        private val __AbstractProgressNullableSerializer = AbstractPolymorphic(AbstractProgress).nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeProgress  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val _execute = RdProperty.read(ctx, buffer, __AbstractProgressNullableSerializer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeProgress_Unknown(_execute, _enabled, _controlId, _tooltip, _focus, _visible, unknownId, unknownBytes).withId(_id)
        }
        
    }
    //fields
    val execute: IProperty<AbstractProgress?> get() = _execute
    //methods
    //initializer
    init {
        bindableChildren.add("execute" to _execute)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdProperty<AbstractProgress?>(null, __AbstractProgressNullableSerializer),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeProgress (")
        printer.indent {
            print("execute = "); _execute.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeProgress   {
        return BeProgress(
            _execute.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


class BeProgress_Unknown (
    _execute: RdProperty<AbstractProgress?>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeProgress (
    _execute,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeProgress_Unknown> {
        override val _type: KClass<BeProgress_Unknown> = BeProgress_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeProgress_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeProgress_Unknown)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._execute)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        private val __AbstractProgressNullableSerializer = AbstractPolymorphic(AbstractProgress).nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        RdProperty<AbstractProgress?>(null, __AbstractProgressNullableSerializer),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller),
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeProgress_Unknown (")
        printer.indent {
            print("execute = "); _execute.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeProgress_Unknown   {
        return BeProgress_Unknown(
            _execute.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeRadioButton private constructor(
    private val _property: RdProperty<Boolean>,
    val description: BeAbstractText,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeRadioButton> {
        override val _type: KClass<BeRadioButton> = BeRadioButton::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeRadioButton  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _property = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val description = ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText)
            return BeRadioButton(_property, description, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeRadioButton)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdProperty.write(ctx, buffer, value._property)
            ctx.serializers.writePolymorphic(ctx, buffer, value.description)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val `property`: IProperty<Boolean> get() = _property
    //methods
    //initializer
    init {
        _property.optimizeNested = true
    }
    
    init {
        bindableChildren.add("property" to _property)
        bindableChildren.add("description" to description)
    }
    
    //secondary constructor
    constructor(
        description: BeAbstractText
    ) : this(
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        description,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeRadioButton (")
        printer.indent {
            print("property = "); _property.print(printer); println()
            print("description = "); description.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeRadioButton   {
        return BeRadioButton(
            _property.deepClonePolymorphic(),
            description.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * @property resharperActionGroupId Not implemented in WPF frontend yet
 * @property resharperActionId Not implemented in WPF frontend yet
 * #### Generated from [UIAutomationModel.kt]
 */
class BeResharperAction private constructor(
    val resharperActionGroupId: String,
    val resharperActionId: String,
    actionId: String,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeIdeAction (
    actionId,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeResharperAction> {
        override val _type: KClass<BeResharperAction> = BeResharperAction::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeResharperAction  {
            val _id = RdId.read(buffer)
            val actionId = buffer.readString()
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val resharperActionGroupId = buffer.readString()
            val resharperActionId = buffer.readString()
            return BeResharperAction(resharperActionGroupId, resharperActionId, actionId, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeResharperAction)  {
            value.rdid.write(buffer)
            buffer.writeString(value.actionId)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeString(value.resharperActionGroupId)
            buffer.writeString(value.resharperActionId)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        resharperActionGroupId: String,
        resharperActionId: String,
        actionId: String
    ) : this(
        resharperActionGroupId,
        resharperActionId,
        actionId,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeResharperAction (")
        printer.indent {
            print("resharperActionGroupId = "); resharperActionGroupId.print(printer); println()
            print("resharperActionId = "); resharperActionId.print(printer); println()
            print("actionId = "); actionId.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeResharperAction   {
        return BeResharperAction(
            resharperActionGroupId,
            resharperActionId,
            actionId,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeRichAttributedText private constructor(
    private val _text: RdOptionalProperty<com.jetbrains.rd.ide.model.RichAttributedTextModel>,
    wrapText: Boolean,
    _icon: RdProperty<com.jetbrains.rd.ide.model.IconModel?>,
    _shortcutIndex: RdProperty<Int>,
    _target: RdProperty<String>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeAbstractText (
    wrapText,
    _icon,
    _shortcutIndex,
    _target,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeRichAttributedText> {
        override val _type: KClass<BeRichAttributedText> = BeRichAttributedText::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeRichAttributedText  {
            val _id = RdId.read(buffer)
            val wrapText = buffer.readBool()
            val _icon = RdProperty.read(ctx, buffer, __IconModelNullableSerializer)
            val _shortcutIndex = RdProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _target = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _text = RdOptionalProperty.read(ctx, buffer, com.jetbrains.rd.ide.model.RichAttributedTextModel)
            return BeRichAttributedText(_text, wrapText, _icon, _shortcutIndex, _target, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeRichAttributedText)  {
            value.rdid.write(buffer)
            buffer.writeBool(value.wrapText)
            RdProperty.write(ctx, buffer, value._icon)
            RdProperty.write(ctx, buffer, value._shortcutIndex)
            RdProperty.write(ctx, buffer, value._target)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdOptionalProperty.write(ctx, buffer, value._text)
        }
        
        private val __IconModelNullableSerializer = AbstractPolymorphic(com.jetbrains.rd.ide.model.IconModel).nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val text: IOptProperty<com.jetbrains.rd.ide.model.RichAttributedTextModel> get() = _text
    //methods
    //initializer
    init {
        _text.optimizeNested = true
    }
    
    init {
        bindableChildren.add("text" to _text)
    }
    
    //secondary constructor
    constructor(
        wrapText: Boolean
    ) : this(
        RdOptionalProperty<com.jetbrains.rd.ide.model.RichAttributedTextModel>(com.jetbrains.rd.ide.model.RichAttributedTextModel),
        wrapText,
        RdProperty<com.jetbrains.rd.ide.model.IconModel?>(null, __IconModelNullableSerializer),
        RdProperty<Int>(-1, FrameworkMarshallers.Int),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeRichAttributedText (")
        printer.indent {
            print("text = "); _text.print(printer); println()
            print("wrapText = "); wrapText.print(printer); println()
            print("icon = "); _icon.print(printer); println()
            print("shortcutIndex = "); _shortcutIndex.print(printer); println()
            print("target = "); _target.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeRichAttributedText   {
        return BeRichAttributedText(
            _text.deepClonePolymorphic(),
            wrapText,
            _icon.deepClonePolymorphic(),
            _shortcutIndex.deepClonePolymorphic(),
            _target.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * Main non-editable text presentation. Can have icon, text can be wrapped, styles and colors are applicable.
 * @property settings specifies common text style (font, size)
 * #### Generated from [UIAutomationModel.kt]
 */
class BeRichText private constructor(
    val settings: BeTextSettings,
    private val _text: RdOptionalProperty<com.jetbrains.rd.ide.model.RichTextModel>,
    wrapText: Boolean,
    _icon: RdProperty<com.jetbrains.rd.ide.model.IconModel?>,
    _shortcutIndex: RdProperty<Int>,
    _target: RdProperty<String>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeAbstractText (
    wrapText,
    _icon,
    _shortcutIndex,
    _target,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeRichText> {
        override val _type: KClass<BeRichText> = BeRichText::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeRichText  {
            val _id = RdId.read(buffer)
            val wrapText = buffer.readBool()
            val _icon = RdProperty.read(ctx, buffer, __IconModelNullableSerializer)
            val _shortcutIndex = RdProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _target = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val settings = BeTextSettings.read(ctx, buffer)
            val _text = RdOptionalProperty.read(ctx, buffer, com.jetbrains.rd.ide.model.RichTextModel)
            return BeRichText(settings, _text, wrapText, _icon, _shortcutIndex, _target, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeRichText)  {
            value.rdid.write(buffer)
            buffer.writeBool(value.wrapText)
            RdProperty.write(ctx, buffer, value._icon)
            RdProperty.write(ctx, buffer, value._shortcutIndex)
            RdProperty.write(ctx, buffer, value._target)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            BeTextSettings.write(ctx, buffer, value.settings)
            RdOptionalProperty.write(ctx, buffer, value._text)
        }
        
        private val __IconModelNullableSerializer = AbstractPolymorphic(com.jetbrains.rd.ide.model.IconModel).nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val text: IOptProperty<com.jetbrains.rd.ide.model.RichTextModel> get() = _text
    //methods
    //initializer
    init {
        _text.optimizeNested = true
    }
    
    init {
        bindableChildren.add("settings" to settings)
        bindableChildren.add("text" to _text)
    }
    
    //secondary constructor
    constructor(
        wrapText: Boolean
    ) : this(
        BeTextSettings(),
        RdOptionalProperty<com.jetbrains.rd.ide.model.RichTextModel>(com.jetbrains.rd.ide.model.RichTextModel),
        wrapText,
        RdProperty<com.jetbrains.rd.ide.model.IconModel?>(null, __IconModelNullableSerializer),
        RdProperty<Int>(-1, FrameworkMarshallers.Int),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeRichText (")
        printer.indent {
            print("settings = "); settings.print(printer); println()
            print("text = "); _text.print(printer); println()
            print("wrapText = "); wrapText.print(printer); println()
            print("icon = "); _icon.print(printer); println()
            print("shortcutIndex = "); _shortcutIndex.print(printer); println()
            print("target = "); _target.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeRichText   {
        return BeRichText(
            settings.deepClonePolymorphic(),
            _text.deepClonePolymorphic(),
            wrapText,
            _icon.deepClonePolymorphic(),
            _shortcutIndex.deepClonePolymorphic(),
            _target.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeScreenPointPopupContext (
    val x: Int,
    val y: Int
) : BePopupContext (
) {
    //companion
    
    companion object : IMarshaller<BeScreenPointPopupContext> {
        override val _type: KClass<BeScreenPointPopupContext> = BeScreenPointPopupContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeScreenPointPopupContext  {
            val _id = RdId.read(buffer)
            val x = buffer.readInt()
            val y = buffer.readInt()
            return BeScreenPointPopupContext(x, y).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeScreenPointPopupContext)  {
            value.rdid.write(buffer)
            buffer.writeInt(value.x)
            buffer.writeInt(value.y)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeScreenPointPopupContext (")
        printer.indent {
            print("x = "); x.print(printer); println()
            print("y = "); y.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeScreenPointPopupContext   {
        return BeScreenPointPopupContext(
            x,
            y
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeScrollSettings {
    DO_NOT_AUTOSCROLL, 
    AUTOSCROLL_TO_END, 
    AUTOSCROLL_TO_SELECTION;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeScrollSettings>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeScrollablePanel private constructor(
    val scrollbarPolicy: BeScrollbarPolicy,
    val size: BeControlSize,
    content: BeControl,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlContainer (
    content,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeScrollablePanel> {
        override val _type: KClass<BeScrollablePanel> = BeScrollablePanel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeScrollablePanel  {
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val scrollbarPolicy = buffer.readEnum<BeScrollbarPolicy>()
            val size = ctx.serializers.readPolymorphic<BeControlSize>(ctx, buffer, BeControlSize)
            return BeScrollablePanel(scrollbarPolicy, size, content, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeScrollablePanel)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeEnum(value.scrollbarPolicy)
            ctx.serializers.writePolymorphic(ctx, buffer, value.size)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        scrollbarPolicy: BeScrollbarPolicy,
        size: BeControlSize,
        content: BeControl
    ) : this(
        scrollbarPolicy,
        size,
        content,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeScrollablePanel (")
        printer.indent {
            print("scrollbarPolicy = "); scrollbarPolicy.print(printer); println()
            print("size = "); size.print(printer); println()
            print("content = "); content.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeScrollablePanel   {
        return BeScrollablePanel(
            scrollbarPolicy,
            size,
            content.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeScrollbarPolicy {
    HORIZONTAL, 
    VERTICAL, 
    BOTH, 
    NONE;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeScrollbarPolicy>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeSearchBox private constructor(
    val place: Place = Place.Default,
    _text: RdProperty<String>,
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlWithEditableText (
    _text,
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeSearchBox> {
        override val _type: KClass<BeSearchBox> = BeSearchBox::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeSearchBox  {
            val _id = RdId.read(buffer)
            val _text = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _validationResult = RdOptionalProperty.read(ctx, buffer, ValidationResult)
            val _validationStyle = RdOptionalProperty.read(ctx, buffer, ValidationStyle.marshaller)
            val _handledByParent = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _revalidate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val place = buffer.readEnum<Place>()
            return BeSearchBox(place, _text, _validationResult, _validationStyle, _handledByParent, _revalidate, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeSearchBox)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._text)
            RdOptionalProperty.write(ctx, buffer, value._validationResult)
            RdOptionalProperty.write(ctx, buffer, value._validationStyle)
            RdProperty.write(ctx, buffer, value._handledByParent)
            RdSignal.write(ctx, buffer, value._revalidate)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeEnum(value.place)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        place: Place = Place.Default
    ) : this(
        place,
        RdProperty<String>("", FrameworkMarshallers.String),
        RdOptionalProperty<ValidationResult>(ValidationResult),
        RdOptionalProperty<ValidationStyle>(ValidationStyle.marshaller),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeSearchBox (")
        printer.indent {
            print("place = "); place.print(printer); println()
            print("text = "); _text.print(printer); println()
            print("validationResult = "); _validationResult.print(printer); println()
            print("validationStyle = "); _validationStyle.print(printer); println()
            print("handledByParent = "); _handledByParent.print(printer); println()
            print("revalidate = "); _revalidate.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeSearchBox   {
        return BeSearchBox(
            place,
            _text.deepClonePolymorphic(),
            _validationResult.deepClonePolymorphic(),
            _validationStyle.deepClonePolymorphic(),
            _handledByParent.deepClonePolymorphic(),
            _revalidate.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeSeparator private constructor(
    val orientation: GridOrientation,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeSeparator> {
        override val _type: KClass<BeSeparator> = BeSeparator::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeSeparator  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val orientation = buffer.readEnum<GridOrientation>()
            return BeSeparator(orientation, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeSeparator)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            buffer.writeEnum(value.orientation)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        orientation: GridOrientation
    ) : this(
        orientation,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeSeparator (")
        printer.indent {
            print("orientation = "); orientation.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeSeparator   {
        return BeSeparator(
            orientation,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeShortcutListener private constructor(
    val shortcuts: List<String>,
    _reaction: RdSignal<Unit>,
    overrideDefault: Boolean = false
) : BeActionListener (
    _reaction,
    overrideDefault
) {
    //companion
    
    companion object : IMarshaller<BeShortcutListener> {
        override val _type: KClass<BeShortcutListener> = BeShortcutListener::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeShortcutListener  {
            val _id = RdId.read(buffer)
            val _reaction = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val overrideDefault = buffer.readBool()
            val shortcuts = buffer.readList { buffer.readString() }
            return BeShortcutListener(shortcuts, _reaction, overrideDefault).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeShortcutListener)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._reaction)
            buffer.writeBool(value.overrideDefault)
            buffer.writeList(value.shortcuts) { v -> buffer.writeString(v) }
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        shortcuts: List<String>,
        overrideDefault: Boolean = false
    ) : this(
        shortcuts,
        RdSignal<Unit>(FrameworkMarshallers.Void),
        overrideDefault
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeShortcutListener (")
        printer.indent {
            print("shortcuts = "); shortcuts.print(printer); println()
            print("reaction = "); _reaction.print(printer); println()
            print("overrideDefault = "); overrideDefault.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeShortcutListener   {
        return BeShortcutListener(
            shortcuts,
            _reaction.deepClonePolymorphic(),
            overrideDefault
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeShowBorders {
    All, 
    OnlyTop, 
    OnlyBottom, 
    TopAndBottom, 
    None;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeShowBorders>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
data class BeSize (
    val type: BeControlSizeType,
    val multiplier: Int = 1
) : IPrintable {
    //companion
    
    companion object : IMarshaller<BeSize> {
        override val _type: KClass<BeSize> = BeSize::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeSize  {
            val type = buffer.readEnum<BeControlSizeType>()
            val multiplier = buffer.readInt()
            return BeSize(type, multiplier)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeSize)  {
            buffer.writeEnum(value.type)
            buffer.writeInt(value.multiplier)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeSize
        
        if (type != other.type) return false
        if (multiplier != other.multiplier) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + type.hashCode()
        __r = __r*31 + multiplier.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeSize (")
        printer.indent {
            print("type = "); type.print(printer); println()
            print("multiplier = "); multiplier.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeSizeModifier (
    val type: BeBoundsType,
    val size: BeControlSize
) : BeStyleModifier (
) {
    //companion
    
    companion object : IMarshaller<BeSizeModifier> {
        override val _type: KClass<BeSizeModifier> = BeSizeModifier::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeSizeModifier  {
            val type = buffer.readEnum<BeBoundsType>()
            val size = ctx.serializers.readPolymorphic<BeControlSize>(ctx, buffer, BeControlSize)
            return BeSizeModifier(type, size)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeSizeModifier)  {
            buffer.writeEnum(value.type)
            ctx.serializers.writePolymorphic(ctx, buffer, value.size)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeSizeModifier
        
        if (type != other.type) return false
        if (size != other.size) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + type.hashCode()
        __r = __r*31 + size.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeSizeModifier (")
        printer.indent {
            print("type = "); type.print(printer); println()
            print("size = "); size.print(printer); println()
        }
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeSizingType {
    Fill, 
    Fit;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeSizingType>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeSpacer private constructor(
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeSpacer> {
        override val _type: KClass<BeSpacer> = BeSpacer::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeSpacer  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            return BeSpacer(_enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeSpacer)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
    ) : this(
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeSpacer (")
        printer.indent {
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeSpacer   {
        return BeSpacer(
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeSpanColumnElement (
    val content: BeGridElement,
    val columnSpan: Int
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BeSpanColumnElement> {
        override val _type: KClass<BeSpanColumnElement> = BeSpanColumnElement::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeSpanColumnElement  {
            val _id = RdId.read(buffer)
            val content = BeGridElement.read(ctx, buffer)
            val columnSpan = buffer.readInt()
            return BeSpanColumnElement(content, columnSpan).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeSpanColumnElement)  {
            value.rdid.write(buffer)
            BeGridElement.write(ctx, buffer, value.content)
            buffer.writeInt(value.columnSpan)
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("content" to content)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeSpanColumnElement (")
        printer.indent {
            print("content = "); content.print(printer); println()
            print("columnSpan = "); columnSpan.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeSpanColumnElement   {
        return BeSpanColumnElement(
            content.deepClonePolymorphic(),
            columnSpan
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeSpanGrid private constructor(
    private val _items: RdOptionalProperty<List<BeSpanRowElement>>,
    val columns: List<BeUnitSize>,
    val intercellSpacing: BeMarginType = BeMarginType.DefaultIntercellSpacing,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeSpanGrid> {
        override val _type: KClass<BeSpanGrid> = BeSpanGrid::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeSpanGrid  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _items = RdOptionalProperty.read(ctx, buffer, __BeSpanRowElementListSerializer)
            val columns = buffer.readList { BeUnitSize.read(ctx, buffer) }
            val intercellSpacing = buffer.readEnum<BeMarginType>()
            return BeSpanGrid(_items, columns, intercellSpacing, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeSpanGrid)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdOptionalProperty.write(ctx, buffer, value._items)
            buffer.writeList(value.columns) { v -> BeUnitSize.write(ctx, buffer, v) }
            buffer.writeEnum(value.intercellSpacing)
        }
        
        private val __BeSpanRowElementListSerializer = BeSpanRowElement.list()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val items: IOptProperty<List<BeSpanRowElement>> get() = _items
    //methods
    //initializer
    init {
        bindableChildren.add("items" to _items)
    }
    
    //secondary constructor
    constructor(
        columns: List<BeUnitSize>,
        intercellSpacing: BeMarginType = BeMarginType.DefaultIntercellSpacing
    ) : this(
        RdOptionalProperty<List<BeSpanRowElement>>(__BeSpanRowElementListSerializer),
        columns,
        intercellSpacing,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeSpanGrid (")
        printer.indent {
            print("items = "); _items.print(printer); println()
            print("columns = "); columns.print(printer); println()
            print("intercellSpacing = "); intercellSpacing.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeSpanGrid   {
        return BeSpanGrid(
            _items.deepClonePolymorphic(),
            columns,
            intercellSpacing,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeSpanRowElement private constructor(
    private val _content: RdOptionalProperty<List<BeSpanColumnElement>>,
    val size: BeUnitSize
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BeSpanRowElement> {
        override val _type: KClass<BeSpanRowElement> = BeSpanRowElement::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeSpanRowElement  {
            val _id = RdId.read(buffer)
            val _content = RdOptionalProperty.read(ctx, buffer, __BeSpanColumnElementListSerializer)
            val size = BeUnitSize.read(ctx, buffer)
            return BeSpanRowElement(_content, size).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeSpanRowElement)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._content)
            BeUnitSize.write(ctx, buffer, value.size)
        }
        
        private val __BeSpanColumnElementListSerializer = BeSpanColumnElement.list()
        
    }
    //fields
    val content: IOptProperty<List<BeSpanColumnElement>> get() = _content
    //methods
    //initializer
    init {
        bindableChildren.add("content" to _content)
    }
    
    //secondary constructor
    constructor(
        size: BeUnitSize
    ) : this(
        RdOptionalProperty<List<BeSpanColumnElement>>(__BeSpanColumnElementListSerializer),
        size
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeSpanRowElement (")
        printer.indent {
            print("content = "); _content.print(printer); println()
            print("size = "); size.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeSpanRowElement   {
        return BeSpanRowElement(
            _content.deepClonePolymorphic(),
            size
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeSpeedSearch {
    DISABLED, 
    ENABLED_HIGHLIGHT, 
    ENABLED_FILTER_AUTO, 
    ENABLED_FILTER_ALWAYS_VISIBLE;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeSpeedSearch>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeSpinner private constructor(
    private val _value: RdProperty<Int>,
    val minValue: Int,
    val maxValue: Int,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeSpinner> {
        override val _type: KClass<BeSpinner> = BeSpinner::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeSpinner  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _value = RdProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val minValue = buffer.readInt()
            val maxValue = buffer.readInt()
            return BeSpinner(_value, minValue, maxValue, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeSpinner)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdProperty.write(ctx, buffer, value._value)
            buffer.writeInt(value.minValue)
            buffer.writeInt(value.maxValue)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val value: IProperty<Int> get() = _value
    //methods
    //initializer
    init {
        _value.optimizeNested = true
    }
    
    init {
        bindableChildren.add("value" to _value)
    }
    
    //secondary constructor
    constructor(
        minValue: Int,
        maxValue: Int
    ) : this(
        RdProperty<Int>(0, FrameworkMarshallers.Int),
        minValue,
        maxValue,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeSpinner (")
        printer.indent {
            print("value = "); _value.print(printer); println()
            print("minValue = "); minValue.print(printer); println()
            print("maxValue = "); maxValue.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeSpinner   {
        return BeSpinner(
            _value.deepClonePolymorphic(),
            minValue,
            maxValue,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeSplitControl private constructor(
    val firstPanel: BeControl,
    val secondPanel: BeControl,
    val isVertical: Boolean,
    val proportion: Float,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeSplitControl> {
        override val _type: KClass<BeSplitControl> = BeSplitControl::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeSplitControl  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val firstPanel = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val secondPanel = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val isVertical = buffer.readBool()
            val proportion = buffer.readFloat()
            return BeSplitControl(firstPanel, secondPanel, isVertical, proportion, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeSplitControl)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            ctx.serializers.writePolymorphic(ctx, buffer, value.firstPanel)
            ctx.serializers.writePolymorphic(ctx, buffer, value.secondPanel)
            buffer.writeBool(value.isVertical)
            buffer.writeFloat(value.proportion)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("firstPanel" to firstPanel)
        bindableChildren.add("secondPanel" to secondPanel)
    }
    
    //secondary constructor
    constructor(
        firstPanel: BeControl,
        secondPanel: BeControl,
        isVertical: Boolean,
        proportion: Float
    ) : this(
        firstPanel,
        secondPanel,
        isVertical,
        proportion,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeSplitControl (")
        printer.indent {
            print("firstPanel = "); firstPanel.print(printer); println()
            print("secondPanel = "); secondPanel.print(printer); println()
            print("isVertical = "); isVertical.print(printer); println()
            print("proportion = "); proportion.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeSplitControl   {
        return BeSplitControl(
            firstPanel.deepClonePolymorphic(),
            secondPanel.deepClonePolymorphic(),
            isVertical,
            proportion,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeStyleControl private constructor(
    private val _margin: RdProperty<BeMarginModifier?>,
    private val _backgroundColor: RdProperty<BeBackgroundColorModifier?>,
    private val _opacity: RdProperty<BeOpacityModifier?>,
    private val _bounds: RdProperty<BeBoundsModifier?>,
    private val _sizes: RdList<BeSizeModifier>,
    private val _cursor: RdProperty<BeCursorModifier?>,
    content: BeControl,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlContainer (
    content,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeStyleControl> {
        override val _type: KClass<BeStyleControl> = BeStyleControl::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeStyleControl  {
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _margin = RdProperty.read(ctx, buffer, __BeMarginModifierNullableSerializer)
            val _backgroundColor = RdProperty.read(ctx, buffer, __BeBackgroundColorModifierNullableSerializer)
            val _opacity = RdProperty.read(ctx, buffer, __BeOpacityModifierNullableSerializer)
            val _bounds = RdProperty.read(ctx, buffer, __BeBoundsModifierNullableSerializer)
            val _sizes = RdList.read(ctx, buffer, BeSizeModifier)
            val _cursor = RdProperty.read(ctx, buffer, __BeCursorModifierNullableSerializer)
            return BeStyleControl(_margin, _backgroundColor, _opacity, _bounds, _sizes, _cursor, content, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeStyleControl)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdProperty.write(ctx, buffer, value._margin)
            RdProperty.write(ctx, buffer, value._backgroundColor)
            RdProperty.write(ctx, buffer, value._opacity)
            RdProperty.write(ctx, buffer, value._bounds)
            RdList.write(ctx, buffer, value._sizes)
            RdProperty.write(ctx, buffer, value._cursor)
        }
        
        private val __BeMarginModifierNullableSerializer = BeMarginModifier.nullable()
        private val __BeBackgroundColorModifierNullableSerializer = BeBackgroundColorModifier.nullable()
        private val __BeOpacityModifierNullableSerializer = BeOpacityModifier.nullable()
        private val __BeBoundsModifierNullableSerializer = BeBoundsModifier.nullable()
        private val __BeCursorModifierNullableSerializer = BeCursorModifier.nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val margin: IProperty<BeMarginModifier?> get() = _margin
    val backgroundColor: IProperty<BeBackgroundColorModifier?> get() = _backgroundColor
    val opacity: IProperty<BeOpacityModifier?> get() = _opacity
    val bounds: IProperty<BeBoundsModifier?> get() = _bounds
    val sizes: IMutableViewableList<BeSizeModifier> get() = _sizes
    val cursor: IProperty<BeCursorModifier?> get() = _cursor
    //methods
    //initializer
    init {
        _margin.optimizeNested = true
        _backgroundColor.optimizeNested = true
        _opacity.optimizeNested = true
        _bounds.optimizeNested = true
        _sizes.optimizeNested = true
        _cursor.optimizeNested = true
    }
    
    init {
        bindableChildren.add("margin" to _margin)
        bindableChildren.add("backgroundColor" to _backgroundColor)
        bindableChildren.add("opacity" to _opacity)
        bindableChildren.add("bounds" to _bounds)
        bindableChildren.add("sizes" to _sizes)
        bindableChildren.add("cursor" to _cursor)
    }
    
    //secondary constructor
    constructor(
        content: BeControl
    ) : this(
        RdProperty<BeMarginModifier?>(null, __BeMarginModifierNullableSerializer),
        RdProperty<BeBackgroundColorModifier?>(null, __BeBackgroundColorModifierNullableSerializer),
        RdProperty<BeOpacityModifier?>(null, __BeOpacityModifierNullableSerializer),
        RdProperty<BeBoundsModifier?>(null, __BeBoundsModifierNullableSerializer),
        RdList<BeSizeModifier>(BeSizeModifier),
        RdProperty<BeCursorModifier?>(null, __BeCursorModifierNullableSerializer),
        content,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeStyleControl (")
        printer.indent {
            print("margin = "); _margin.print(printer); println()
            print("backgroundColor = "); _backgroundColor.print(printer); println()
            print("opacity = "); _opacity.print(printer); println()
            print("bounds = "); _bounds.print(printer); println()
            print("sizes = "); _sizes.print(printer); println()
            print("cursor = "); _cursor.print(printer); println()
            print("content = "); content.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeStyleControl   {
        return BeStyleControl(
            _margin.deepClonePolymorphic(),
            _backgroundColor.deepClonePolymorphic(),
            _opacity.deepClonePolymorphic(),
            _bounds.deepClonePolymorphic(),
            _sizes.deepClonePolymorphic(),
            _cursor.deepClonePolymorphic(),
            content.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
abstract class BeStyleModifier (
) : IPrintable {
    //companion
    
    companion object : IAbstractDeclaration<BeStyleModifier> {
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): BeStyleModifier  {
            val objectStartPosition = buffer.position
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return BeStyleModifier_Unknown(unknownId, unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    //deepClone
    //contexts
}


class BeStyleModifier_Unknown (
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : BeStyleModifier (
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<BeStyleModifier_Unknown> {
        override val _type: KClass<BeStyleModifier_Unknown> = BeStyleModifier_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeStyleModifier_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeStyleModifier_Unknown)  {
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeStyleModifier_Unknown
        
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeStyleModifier_Unknown (")
        printer.print(")")
    }
    
    override fun toString() = PrettyPrinter().singleLine().also { print(it) }.toString()
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeTab private constructor(
    val tabName: BeLabel,
    val content: BeControl,
    val isCloseable: Boolean = false,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeTab> {
        override val _type: KClass<BeTab> = BeTab::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeTab  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val tabName = BeLabel.read(ctx, buffer)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val isCloseable = buffer.readBool()
            return BeTab(tabName, content, isCloseable, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeTab)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            BeLabel.write(ctx, buffer, value.tabName)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            buffer.writeBool(value.isCloseable)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("tabName" to tabName)
        bindableChildren.add("content" to content)
    }
    
    //secondary constructor
    constructor(
        tabName: BeLabel,
        content: BeControl,
        isCloseable: Boolean = false
    ) : this(
        tabName,
        content,
        isCloseable,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeTab (")
        printer.indent {
            print("tabName = "); tabName.print(printer); println()
            print("content = "); content.print(printer); println()
            print("isCloseable = "); isCloseable.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeTab   {
        return BeTab(
            tabName.deepClonePolymorphic(),
            content.deepClonePolymorphic(),
            isCloseable,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeTabbedControl private constructor(
    private val _tabs: RdList<BeTab>,
    private val _selectedIndex: RdOptionalProperty<Int>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeTabbedControl> {
        override val _type: KClass<BeTabbedControl> = BeTabbedControl::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeTabbedControl  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _tabs = RdList.read(ctx, buffer, BeTab)
            val _selectedIndex = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            return BeTabbedControl(_tabs, _selectedIndex, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeTabbedControl)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdList.write(ctx, buffer, value._tabs)
            RdOptionalProperty.write(ctx, buffer, value._selectedIndex)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val tabs: IMutableViewableList<BeTab> get() = _tabs
    val selectedIndex: IOptProperty<Int> get() = _selectedIndex
    //methods
    //initializer
    init {
        _selectedIndex.optimizeNested = true
    }
    
    init {
        bindableChildren.add("tabs" to _tabs)
        bindableChildren.add("selectedIndex" to _selectedIndex)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdList<BeTab>(BeTab),
        RdOptionalProperty<Int>(FrameworkMarshallers.Int),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeTabbedControl (")
        printer.indent {
            print("tabs = "); _tabs.print(printer); println()
            print("selectedIndex = "); _selectedIndex.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeTabbedControl   {
        return BeTabbedControl(
            _tabs.deepClonePolymorphic(),
            _selectedIndex.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeTextBox private constructor(
    val settings: BeTextBoxSettings,
    private val _completionItems: RdOptionalProperty<List<BeCompletionItem>>,
    _text: RdProperty<String>,
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlWithEditableText (
    _text,
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeTextBox> {
        override val _type: KClass<BeTextBox> = BeTextBox::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeTextBox  {
            val _id = RdId.read(buffer)
            val _text = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _validationResult = RdOptionalProperty.read(ctx, buffer, ValidationResult)
            val _validationStyle = RdOptionalProperty.read(ctx, buffer, ValidationStyle.marshaller)
            val _handledByParent = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _revalidate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val settings = BeTextBoxSettings.read(ctx, buffer)
            val _completionItems = RdOptionalProperty.read(ctx, buffer, __BeCompletionItemListSerializer)
            return BeTextBox(settings, _completionItems, _text, _validationResult, _validationStyle, _handledByParent, _revalidate, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeTextBox)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._text)
            RdOptionalProperty.write(ctx, buffer, value._validationResult)
            RdOptionalProperty.write(ctx, buffer, value._validationStyle)
            RdProperty.write(ctx, buffer, value._handledByParent)
            RdSignal.write(ctx, buffer, value._revalidate)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            BeTextBoxSettings.write(ctx, buffer, value.settings)
            RdOptionalProperty.write(ctx, buffer, value._completionItems)
        }
        
        private val __BeCompletionItemListSerializer = BeCompletionItem.list()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val completionItems: IOptProperty<List<BeCompletionItem>> get() = _completionItems
    //methods
    //initializer
    init {
        bindableChildren.add("settings" to settings)
        bindableChildren.add("completionItems" to _completionItems)
    }
    
    //secondary constructor
    constructor(
        settings: BeTextBoxSettings
    ) : this(
        settings,
        RdOptionalProperty<List<BeCompletionItem>>(__BeCompletionItemListSerializer),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdOptionalProperty<ValidationResult>(ValidationResult),
        RdOptionalProperty<ValidationStyle>(ValidationStyle.marshaller),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeTextBox (")
        printer.indent {
            print("settings = "); settings.print(printer); println()
            print("completionItems = "); _completionItems.print(printer); println()
            print("text = "); _text.print(printer); println()
            print("validationResult = "); _validationResult.print(printer); println()
            print("validationStyle = "); _validationStyle.print(printer); println()
            print("handledByParent = "); _handledByParent.print(printer); println()
            print("revalidate = "); _revalidate.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeTextBox   {
        return BeTextBox(
            settings.deepClonePolymorphic(),
            _completionItems.deepClonePolymorphic(),
            _text.deepClonePolymorphic(),
            _validationResult.deepClonePolymorphic(),
            _validationStyle.deepClonePolymorphic(),
            _handledByParent.deepClonePolymorphic(),
            _revalidate.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * @property updateSourceTrigger Not implemented in Swing frontend yet
 * #### Generated from [UIAutomationModel.kt]
 */
class BeTextBoxSettings private constructor(
    private val _readonly: RdProperty<Boolean>,
    val textSettings: BeTextSettings,
    private val _useCamelHumps: RdProperty<Boolean>,
    private val _selectionLength: RdProperty<Int>,
    private val _caret: RdProperty<Int>,
    val updateSourceTrigger: UpdateSourceTrigger = UpdateSourceTrigger.TextChanged
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BeTextBoxSettings> {
        override val _type: KClass<BeTextBoxSettings> = BeTextBoxSettings::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeTextBoxSettings  {
            val _id = RdId.read(buffer)
            val _readonly = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val textSettings = BeTextSettings.read(ctx, buffer)
            val _useCamelHumps = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _selectionLength = RdProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val _caret = RdProperty.read(ctx, buffer, FrameworkMarshallers.Int)
            val updateSourceTrigger = buffer.readEnum<UpdateSourceTrigger>()
            return BeTextBoxSettings(_readonly, textSettings, _useCamelHumps, _selectionLength, _caret, updateSourceTrigger).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeTextBoxSettings)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._readonly)
            BeTextSettings.write(ctx, buffer, value.textSettings)
            RdProperty.write(ctx, buffer, value._useCamelHumps)
            RdProperty.write(ctx, buffer, value._selectionLength)
            RdProperty.write(ctx, buffer, value._caret)
            buffer.writeEnum(value.updateSourceTrigger)
        }
        
        
    }
    //fields
    val readonly: IProperty<Boolean> get() = _readonly
    val useCamelHumps: IProperty<Boolean> get() = _useCamelHumps
    val selectionLength: IProperty<Int> get() = _selectionLength
    val caret: IProperty<Int> get() = _caret
    //methods
    //initializer
    init {
        _readonly.optimizeNested = true
        _useCamelHumps.optimizeNested = true
        _selectionLength.optimizeNested = true
        _caret.optimizeNested = true
    }
    
    init {
        bindableChildren.add("readonly" to _readonly)
        bindableChildren.add("textSettings" to textSettings)
        bindableChildren.add("useCamelHumps" to _useCamelHumps)
        bindableChildren.add("selectionLength" to _selectionLength)
        bindableChildren.add("caret" to _caret)
    }
    
    //secondary constructor
    constructor(
        updateSourceTrigger: UpdateSourceTrigger = UpdateSourceTrigger.TextChanged
    ) : this(
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        BeTextSettings(),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdProperty<Int>(0, FrameworkMarshallers.Int),
        RdProperty<Int>(0, FrameworkMarshallers.Int),
        updateSourceTrigger
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeTextBoxSettings (")
        printer.indent {
            print("readonly = "); _readonly.print(printer); println()
            print("textSettings = "); textSettings.print(printer); println()
            print("useCamelHumps = "); _useCamelHumps.print(printer); println()
            print("selectionLength = "); _selectionLength.print(printer); println()
            print("caret = "); _caret.print(printer); println()
            print("updateSourceTrigger = "); updateSourceTrigger.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeTextBoxSettings   {
        return BeTextBoxSettings(
            _readonly.deepClonePolymorphic(),
            textSettings.deepClonePolymorphic(),
            _useCamelHumps.deepClonePolymorphic(),
            _selectionLength.deepClonePolymorphic(),
            _caret.deepClonePolymorphic(),
            updateSourceTrigger
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeTextControl private constructor(
    private val _text: RdProperty<String>,
    val settings: BeTextBoxSettings,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeTextControl> {
        override val _type: KClass<BeTextControl> = BeTextControl::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeTextControl  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _text = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val settings = BeTextBoxSettings.read(ctx, buffer)
            return BeTextControl(_text, settings, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeTextControl)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdProperty.write(ctx, buffer, value._text)
            BeTextBoxSettings.write(ctx, buffer, value.settings)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val text: IProperty<String> get() = _text
    //methods
    //initializer
    init {
        _text.optimizeNested = true
    }
    
    init {
        bindableChildren.add("text" to _text)
        bindableChildren.add("settings" to settings)
    }
    
    //secondary constructor
    constructor(
        settings: BeTextBoxSettings
    ) : this(
        RdProperty<String>("", FrameworkMarshallers.String),
        settings,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeTextControl (")
        printer.indent {
            print("text = "); _text.print(printer); println()
            print("settings = "); settings.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeTextControl   {
        return BeTextControl(
            _text.deepClonePolymorphic(),
            settings.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeTextControlWithLanguage private constructor(
    val textControl: BeTextControl,
    val language: com.jetbrains.rd.ide.model.RdLanguage?,
    val customFileName: String?,
    val createPsiFile: Boolean,
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlWithValidation (
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeTextControlWithLanguage> {
        override val _type: KClass<BeTextControlWithLanguage> = BeTextControlWithLanguage::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeTextControlWithLanguage  {
            val _id = RdId.read(buffer)
            val _validationResult = RdOptionalProperty.read(ctx, buffer, ValidationResult)
            val _validationStyle = RdOptionalProperty.read(ctx, buffer, ValidationStyle.marshaller)
            val _handledByParent = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _revalidate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val textControl = BeTextControl.read(ctx, buffer)
            val language = buffer.readNullable { com.jetbrains.rd.ide.model.RdLanguage.read(ctx, buffer) }
            val customFileName = buffer.readNullable { buffer.readString() }
            val createPsiFile = buffer.readBool()
            return BeTextControlWithLanguage(textControl, language, customFileName, createPsiFile, _validationResult, _validationStyle, _handledByParent, _revalidate, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeTextControlWithLanguage)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._validationResult)
            RdOptionalProperty.write(ctx, buffer, value._validationStyle)
            RdProperty.write(ctx, buffer, value._handledByParent)
            RdSignal.write(ctx, buffer, value._revalidate)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            BeTextControl.write(ctx, buffer, value.textControl)
            buffer.writeNullable(value.language) { com.jetbrains.rd.ide.model.RdLanguage.write(ctx, buffer, it) }
            buffer.writeNullable(value.customFileName) { buffer.writeString(it) }
            buffer.writeBool(value.createPsiFile)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("textControl" to textControl)
    }
    
    //secondary constructor
    constructor(
        textControl: BeTextControl,
        language: com.jetbrains.rd.ide.model.RdLanguage?,
        customFileName: String?,
        createPsiFile: Boolean
    ) : this(
        textControl,
        language,
        customFileName,
        createPsiFile,
        RdOptionalProperty<ValidationResult>(ValidationResult),
        RdOptionalProperty<ValidationStyle>(ValidationStyle.marshaller),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeTextControlWithLanguage (")
        printer.indent {
            print("textControl = "); textControl.print(printer); println()
            print("language = "); language.print(printer); println()
            print("customFileName = "); customFileName.print(printer); println()
            print("createPsiFile = "); createPsiFile.print(printer); println()
            print("validationResult = "); _validationResult.print(printer); println()
            print("validationStyle = "); _validationStyle.print(printer); println()
            print("handledByParent = "); _handledByParent.print(printer); println()
            print("revalidate = "); _revalidate.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeTextControlWithLanguage   {
        return BeTextControlWithLanguage(
            textControl.deepClonePolymorphic(),
            language,
            customFileName,
            createPsiFile,
            _validationResult.deepClonePolymorphic(),
            _validationStyle.deepClonePolymorphic(),
            _handledByParent.deepClonePolymorphic(),
            _revalidate.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeTextSettings private constructor(
    private val _fontStyle: RdOptionalProperty<BeFontStyle>,
    private val _fontSize: RdOptionalProperty<BeFontSize>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BeTextSettings> {
        override val _type: KClass<BeTextSettings> = BeTextSettings::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeTextSettings  {
            val _id = RdId.read(buffer)
            val _fontStyle = RdOptionalProperty.read(ctx, buffer, BeFontStyle.marshaller)
            val _fontSize = RdOptionalProperty.read(ctx, buffer, BeFontSize.marshaller)
            return BeTextSettings(_fontStyle, _fontSize).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeTextSettings)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._fontStyle)
            RdOptionalProperty.write(ctx, buffer, value._fontSize)
        }
        
        
    }
    //fields
    val fontStyle: IOptProperty<BeFontStyle> get() = _fontStyle
    val fontSize: IOptProperty<BeFontSize> get() = _fontSize
    //methods
    //initializer
    init {
        _fontStyle.optimizeNested = true
        _fontSize.optimizeNested = true
    }
    
    init {
        bindableChildren.add("fontStyle" to _fontStyle)
        bindableChildren.add("fontSize" to _fontSize)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<BeFontStyle>(BeFontStyle.marshaller),
        RdOptionalProperty<BeFontSize>(BeFontSize.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeTextSettings (")
        printer.indent {
            print("fontStyle = "); _fontStyle.print(printer); println()
            print("fontSize = "); _fontSize.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeTextSettings   {
        return BeTextSettings(
            _fontStyle.deepClonePolymorphic(),
            _fontSize.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeToggleButton private constructor(
    private val _isChecked: RdProperty<Boolean>,
    private val _useLabelRenderer: RdProperty<Boolean>,
    content: BeAbstractText,
    style: BeButtonStyle = BeButtonStyle.DEFAULT,
    _isMouseOver: RdProperty<Boolean>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeAbstractButton (
    content,
    style,
    _isMouseOver,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeToggleButton> {
        override val _type: KClass<BeToggleButton> = BeToggleButton::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeToggleButton  {
            val _id = RdId.read(buffer)
            val content = ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText)
            val style = buffer.readEnum<BeButtonStyle>()
            val _isMouseOver = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _isChecked = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _useLabelRenderer = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            return BeToggleButton(_isChecked, _useLabelRenderer, content, style, _isMouseOver, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeToggleButton)  {
            value.rdid.write(buffer)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            buffer.writeEnum(value.style)
            RdProperty.write(ctx, buffer, value._isMouseOver)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdProperty.write(ctx, buffer, value._isChecked)
            RdProperty.write(ctx, buffer, value._useLabelRenderer)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val isChecked: IProperty<Boolean> get() = _isChecked
    val useLabelRenderer: IProperty<Boolean> get() = _useLabelRenderer
    //methods
    //initializer
    init {
        _isChecked.optimizeNested = true
        _useLabelRenderer.optimizeNested = true
    }
    
    init {
        bindableChildren.add("isChecked" to _isChecked)
        bindableChildren.add("useLabelRenderer" to _useLabelRenderer)
    }
    
    //secondary constructor
    constructor(
        content: BeAbstractText,
        style: BeButtonStyle = BeButtonStyle.DEFAULT
    ) : this(
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        content,
        style,
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeToggleButton (")
        printer.indent {
            print("isChecked = "); _isChecked.print(printer); println()
            print("useLabelRenderer = "); _useLabelRenderer.print(printer); println()
            print("content = "); content.print(printer); println()
            print("style = "); style.print(printer); println()
            print("isMouseOver = "); _isMouseOver.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeToggleButton   {
        return BeToggleButton(
            _isChecked.deepClonePolymorphic(),
            _useLabelRenderer.deepClonePolymorphic(),
            content.deepClonePolymorphic(),
            style,
            _isMouseOver.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeToolWindow private constructor(
    val title: BeLabel,
    val icon: com.jetbrains.rd.ide.model.IconModel?,
    val content: BeTabbedControl,
    val position: BePosition,
    val sideTool: Boolean = false,
    val isSingleInstance: Boolean = true,
    private val _state: RdOptionalProperty<BeToolWindowState>,
    val orientation: GridOrientation = GridOrientation.Horizontal,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeToolWindow> {
        override val _type: KClass<BeToolWindow> = BeToolWindow::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeToolWindow  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val title = BeLabel.read(ctx, buffer)
            val icon = buffer.readNullable { ctx.serializers.readPolymorphic<com.jetbrains.rd.ide.model.IconModel>(ctx, buffer, com.jetbrains.rd.ide.model.IconModel) }
            val content = BeTabbedControl.read(ctx, buffer)
            val position = buffer.readEnum<BePosition>()
            val sideTool = buffer.readBool()
            val isSingleInstance = buffer.readBool()
            val _state = RdOptionalProperty.read(ctx, buffer, BeToolWindowState.marshaller)
            val orientation = buffer.readEnum<GridOrientation>()
            return BeToolWindow(title, icon, content, position, sideTool, isSingleInstance, _state, orientation, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeToolWindow)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            BeLabel.write(ctx, buffer, value.title)
            buffer.writeNullable(value.icon) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            BeTabbedControl.write(ctx, buffer, value.content)
            buffer.writeEnum(value.position)
            buffer.writeBool(value.sideTool)
            buffer.writeBool(value.isSingleInstance)
            RdOptionalProperty.write(ctx, buffer, value._state)
            buffer.writeEnum(value.orientation)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val state: IOptProperty<BeToolWindowState> get() = _state
    //methods
    //initializer
    init {
        _state.optimizeNested = true
    }
    
    init {
        bindableChildren.add("title" to title)
        bindableChildren.add("content" to content)
        bindableChildren.add("state" to _state)
    }
    
    //secondary constructor
    constructor(
        title: BeLabel,
        icon: com.jetbrains.rd.ide.model.IconModel?,
        position: BePosition,
        sideTool: Boolean = false,
        isSingleInstance: Boolean = true,
        orientation: GridOrientation = GridOrientation.Horizontal
    ) : this(
        title,
        icon,
        BeTabbedControl(),
        position,
        sideTool,
        isSingleInstance,
        RdOptionalProperty<BeToolWindowState>(BeToolWindowState.marshaller),
        orientation,
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeToolWindow (")
        printer.indent {
            print("title = "); title.print(printer); println()
            print("icon = "); icon.print(printer); println()
            print("content = "); content.print(printer); println()
            print("position = "); position.print(printer); println()
            print("sideTool = "); sideTool.print(printer); println()
            print("isSingleInstance = "); isSingleInstance.print(printer); println()
            print("state = "); _state.print(printer); println()
            print("orientation = "); orientation.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeToolWindow   {
        return BeToolWindow(
            title.deepClonePolymorphic(),
            icon,
            content.deepClonePolymorphic(),
            position,
            sideTool,
            isSingleInstance,
            _state.deepClonePolymorphic(),
            orientation,
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeToolWindowState {
    ActiveAndFocused, 
    Active, 
    Hidden;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeToolWindowState>()
        
    }
}


/**
 * @property content placed inside because sometimes placement of toolbar depends on OS
 * #### Generated from [UIAutomationModel.kt]
 */
class BeToolbar private constructor(
    val content: BeControl,
    val dock: BeDock,
    private val _leftItems: RdList<BeControl>,
    private val _rightItems: RdList<BeControl>,
    private val _secondaryItems: RdList<BeButton>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeToolbar> {
        override val _type: KClass<BeToolbar> = BeToolbar::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeToolbar  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val content = ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl)
            val dock = buffer.readEnum<BeDock>()
            val _leftItems = RdList.read(ctx, buffer, AbstractPolymorphic(BeControl))
            val _rightItems = RdList.read(ctx, buffer, AbstractPolymorphic(BeControl))
            val _secondaryItems = RdList.read(ctx, buffer, BeButton)
            return BeToolbar(content, dock, _leftItems, _rightItems, _secondaryItems, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeToolbar)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            ctx.serializers.writePolymorphic(ctx, buffer, value.content)
            buffer.writeEnum(value.dock)
            RdList.write(ctx, buffer, value._leftItems)
            RdList.write(ctx, buffer, value._rightItems)
            RdList.write(ctx, buffer, value._secondaryItems)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val leftItems: IMutableViewableList<BeControl> get() = _leftItems
    val rightItems: IMutableViewableList<BeControl> get() = _rightItems
    
    /**
     * items placed inside gear icon.Not implemented in WPF frontend yet
     */
    val secondaryItems: IMutableViewableList<BeButton> get() = _secondaryItems
    //methods
    //initializer
    init {
        bindableChildren.add("content" to content)
        bindableChildren.add("leftItems" to _leftItems)
        bindableChildren.add("rightItems" to _rightItems)
        bindableChildren.add("secondaryItems" to _secondaryItems)
    }
    
    //secondary constructor
    constructor(
        content: BeControl,
        dock: BeDock
    ) : this(
        content,
        dock,
        RdList<BeControl>(AbstractPolymorphic(BeControl)),
        RdList<BeControl>(AbstractPolymorphic(BeControl)),
        RdList<BeButton>(BeButton),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeToolbar (")
        printer.indent {
            print("content = "); content.print(printer); println()
            print("dock = "); dock.print(printer); println()
            print("leftItems = "); _leftItems.print(printer); println()
            print("rightItems = "); _rightItems.print(printer); println()
            print("secondaryItems = "); _secondaryItems.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeToolbar   {
        return BeToolbar(
            content.deepClonePolymorphic(),
            dock,
            _leftItems.deepClonePolymorphic(),
            _rightItems.deepClonePolymorphic(),
            _secondaryItems.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * @property autoScrollToEnd Deprecated. Will be removed from future releases
 * @property speedSearchEnabled Deprecated. Will be removed from future releases
 * #### Generated from [UIAutomationModel.kt]
 */
class BeTreeConfiguration private constructor(
    val columnDefinitions: List<BeColumnDefinition>,
    val selection: BeTreeSelection,
    val hasHeader: Boolean,
    val childOffsetSize: ChildOffsetSize,
    val showAsList: Boolean,
    val autoScrollToEnd: Boolean,
    val showBorders: BeShowBorders = BeShowBorders.All,
    val autoStartEditing: Boolean = true,
    val backendContextMenu: BeBackendContextMenu? = null,
    val speedSearchEnabled: Boolean = true,
    val visibleRowsCount: Int = -1,
    private val _infiniteCycleScroll: RdOptionalProperty<Boolean>,
    private val _autoScroll: RdOptionalProperty<BeScrollSettings>,
    private val _selectOnMouseOver: RdOptionalProperty<Boolean>,
    private val _speedSearch: RdOptionalProperty<BeSpeedSearch>,
    private val _shown: RdOptionalProperty<Boolean>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<BeTreeConfiguration> {
        override val _type: KClass<BeTreeConfiguration> = BeTreeConfiguration::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeTreeConfiguration  {
            val _id = RdId.read(buffer)
            val columnDefinitions = buffer.readList { BeColumnDefinition.read(ctx, buffer) }
            val selection = buffer.readEnum<BeTreeSelection>()
            val hasHeader = buffer.readBool()
            val childOffsetSize = buffer.readEnum<ChildOffsetSize>()
            val showAsList = buffer.readBool()
            val autoScrollToEnd = buffer.readBool()
            val showBorders = buffer.readEnum<BeShowBorders>()
            val autoStartEditing = buffer.readBool()
            val backendContextMenu = buffer.readNullable { BeBackendContextMenu.read(ctx, buffer) }
            val speedSearchEnabled = buffer.readBool()
            val visibleRowsCount = buffer.readInt()
            val _infiniteCycleScroll = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _autoScroll = RdOptionalProperty.read(ctx, buffer, BeScrollSettings.marshaller)
            val _selectOnMouseOver = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _speedSearch = RdOptionalProperty.read(ctx, buffer, BeSpeedSearch.marshaller)
            val _shown = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            return BeTreeConfiguration(columnDefinitions, selection, hasHeader, childOffsetSize, showAsList, autoScrollToEnd, showBorders, autoStartEditing, backendContextMenu, speedSearchEnabled, visibleRowsCount, _infiniteCycleScroll, _autoScroll, _selectOnMouseOver, _speedSearch, _shown).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeTreeConfiguration)  {
            value.rdid.write(buffer)
            buffer.writeList(value.columnDefinitions) { v -> BeColumnDefinition.write(ctx, buffer, v) }
            buffer.writeEnum(value.selection)
            buffer.writeBool(value.hasHeader)
            buffer.writeEnum(value.childOffsetSize)
            buffer.writeBool(value.showAsList)
            buffer.writeBool(value.autoScrollToEnd)
            buffer.writeEnum(value.showBorders)
            buffer.writeBool(value.autoStartEditing)
            buffer.writeNullable(value.backendContextMenu) { BeBackendContextMenu.write(ctx, buffer, it) }
            buffer.writeBool(value.speedSearchEnabled)
            buffer.writeInt(value.visibleRowsCount)
            RdOptionalProperty.write(ctx, buffer, value._infiniteCycleScroll)
            RdOptionalProperty.write(ctx, buffer, value._autoScroll)
            RdOptionalProperty.write(ctx, buffer, value._selectOnMouseOver)
            RdOptionalProperty.write(ctx, buffer, value._speedSearch)
            RdOptionalProperty.write(ctx, buffer, value._shown)
        }
        
        
    }
    //fields
    val infiniteCycleScroll: IOptProperty<Boolean> get() = _infiniteCycleScroll
    val autoScroll: IOptProperty<BeScrollSettings> get() = _autoScroll
    val selectOnMouseOver: IOptProperty<Boolean> get() = _selectOnMouseOver
    val speedSearch: IOptProperty<BeSpeedSearch> get() = _speedSearch
    val shown: IOptProperty<Boolean> get() = _shown
    //methods
    //initializer
    init {
        _infiniteCycleScroll.optimizeNested = true
        _autoScroll.optimizeNested = true
        _selectOnMouseOver.optimizeNested = true
        _speedSearch.optimizeNested = true
        _shown.optimizeNested = true
    }
    
    init {
        bindableChildren.add("infiniteCycleScroll" to _infiniteCycleScroll)
        bindableChildren.add("autoScroll" to _autoScroll)
        bindableChildren.add("selectOnMouseOver" to _selectOnMouseOver)
        bindableChildren.add("speedSearch" to _speedSearch)
        bindableChildren.add("shown" to _shown)
    }
    
    //secondary constructor
    constructor(
        columnDefinitions: List<BeColumnDefinition>,
        selection: BeTreeSelection,
        hasHeader: Boolean,
        childOffsetSize: ChildOffsetSize,
        showAsList: Boolean,
        autoScrollToEnd: Boolean,
        showBorders: BeShowBorders = BeShowBorders.All,
        autoStartEditing: Boolean = true,
        backendContextMenu: BeBackendContextMenu? = null,
        speedSearchEnabled: Boolean = true,
        visibleRowsCount: Int = -1
    ) : this(
        columnDefinitions,
        selection,
        hasHeader,
        childOffsetSize,
        showAsList,
        autoScrollToEnd,
        showBorders,
        autoStartEditing,
        backendContextMenu,
        speedSearchEnabled,
        visibleRowsCount,
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<BeScrollSettings>(BeScrollSettings.marshaller),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool),
        RdOptionalProperty<BeSpeedSearch>(BeSpeedSearch.marshaller),
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeTreeConfiguration (")
        printer.indent {
            print("columnDefinitions = "); columnDefinitions.print(printer); println()
            print("selection = "); selection.print(printer); println()
            print("hasHeader = "); hasHeader.print(printer); println()
            print("childOffsetSize = "); childOffsetSize.print(printer); println()
            print("showAsList = "); showAsList.print(printer); println()
            print("autoScrollToEnd = "); autoScrollToEnd.print(printer); println()
            print("showBorders = "); showBorders.print(printer); println()
            print("autoStartEditing = "); autoStartEditing.print(printer); println()
            print("backendContextMenu = "); backendContextMenu.print(printer); println()
            print("speedSearchEnabled = "); speedSearchEnabled.print(printer); println()
            print("visibleRowsCount = "); visibleRowsCount.print(printer); println()
            print("infiniteCycleScroll = "); _infiniteCycleScroll.print(printer); println()
            print("autoScroll = "); _autoScroll.print(printer); println()
            print("selectOnMouseOver = "); _selectOnMouseOver.print(printer); println()
            print("speedSearch = "); _speedSearch.print(printer); println()
            print("shown = "); _shown.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeTreeConfiguration   {
        return BeTreeConfiguration(
            columnDefinitions,
            selection,
            hasHeader,
            childOffsetSize,
            showAsList,
            autoScrollToEnd,
            showBorders,
            autoStartEditing,
            backendContextMenu,
            speedSearchEnabled,
            visibleRowsCount,
            _infiniteCycleScroll.deepClonePolymorphic(),
            _autoScroll.deepClonePolymorphic(),
            _selectOnMouseOver.deepClonePolymorphic(),
            _speedSearch.deepClonePolymorphic(),
            _shown.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeTreeGrid private constructor(
    val fakeRoot: BeTreeGridLine,
    val configuration: BeTreeConfiguration,
    private val _progress: RdProperty<AbstractProgress?>,
    private val _emptyText: RdProperty<BeEmptyText?>,
    private val _sortKeys: RdProperty<Array<SortKey>?>,
    private val _viewToModelMap: RdOptionalProperty<IntArray>,
    private val _mouseClicked: RdSignal<Unit>,
    private val _enter: RdSignal<Unit>,
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlWithValidation (
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeTreeGrid> {
        override val _type: KClass<BeTreeGrid> = BeTreeGrid::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeTreeGrid  {
            val _id = RdId.read(buffer)
            val _validationResult = RdOptionalProperty.read(ctx, buffer, ValidationResult)
            val _validationStyle = RdOptionalProperty.read(ctx, buffer, ValidationStyle.marshaller)
            val _handledByParent = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _revalidate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val fakeRoot = BeTreeGridLine.read(ctx, buffer)
            val configuration = BeTreeConfiguration.read(ctx, buffer)
            val _progress = RdProperty.read(ctx, buffer, __AbstractProgressNullableSerializer)
            val _emptyText = RdProperty.read(ctx, buffer, __BeEmptyTextNullableSerializer)
            val _sortKeys = RdProperty.read(ctx, buffer, __SortKeyArrayNullableSerializer)
            val _viewToModelMap = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.IntArray)
            val _mouseClicked = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enter = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return BeTreeGrid(fakeRoot, configuration, _progress, _emptyText, _sortKeys, _viewToModelMap, _mouseClicked, _enter, _validationResult, _validationStyle, _handledByParent, _revalidate, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeTreeGrid)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._validationResult)
            RdOptionalProperty.write(ctx, buffer, value._validationStyle)
            RdProperty.write(ctx, buffer, value._handledByParent)
            RdSignal.write(ctx, buffer, value._revalidate)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            BeTreeGridLine.write(ctx, buffer, value.fakeRoot)
            BeTreeConfiguration.write(ctx, buffer, value.configuration)
            RdProperty.write(ctx, buffer, value._progress)
            RdProperty.write(ctx, buffer, value._emptyText)
            RdProperty.write(ctx, buffer, value._sortKeys)
            RdOptionalProperty.write(ctx, buffer, value._viewToModelMap)
            RdSignal.write(ctx, buffer, value._mouseClicked)
            RdSignal.write(ctx, buffer, value._enter)
        }
        
        private val __AbstractProgressNullableSerializer = AbstractPolymorphic(AbstractProgress).nullable()
        private val __BeEmptyTextNullableSerializer = BeEmptyText.nullable()
        private val __SortKeyArrayNullableSerializer = SortKey.array().nullable()
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val progress: IProperty<AbstractProgress?> get() = _progress
    val emptyText: IProperty<BeEmptyText?> get() = _emptyText
    val sortKeys: IProperty<Array<SortKey>?> get() = _sortKeys
    val viewToModelMap: IOptProperty<IntArray> get() = _viewToModelMap
    val mouseClicked: ISignal<Unit> get() = _mouseClicked
    val enter: ISignal<Unit> get() = _enter
    //methods
    //initializer
    init {
        _sortKeys.optimizeNested = true
        _viewToModelMap.optimizeNested = true
    }
    
    init {
        bindableChildren.add("fakeRoot" to fakeRoot)
        bindableChildren.add("configuration" to configuration)
        bindableChildren.add("progress" to _progress)
        bindableChildren.add("emptyText" to _emptyText)
        bindableChildren.add("sortKeys" to _sortKeys)
        bindableChildren.add("viewToModelMap" to _viewToModelMap)
        bindableChildren.add("mouseClicked" to _mouseClicked)
        bindableChildren.add("enter" to _enter)
    }
    
    //secondary constructor
    constructor(
        fakeRoot: BeTreeGridLine,
        configuration: BeTreeConfiguration
    ) : this(
        fakeRoot,
        configuration,
        RdProperty<AbstractProgress?>(null, __AbstractProgressNullableSerializer),
        RdProperty<BeEmptyText?>(null, __BeEmptyTextNullableSerializer),
        RdProperty<Array<SortKey>?>(null, __SortKeyArrayNullableSerializer),
        RdOptionalProperty<IntArray>(FrameworkMarshallers.IntArray),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ValidationResult>(ValidationResult),
        RdOptionalProperty<ValidationStyle>(ValidationStyle.marshaller),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeTreeGrid (")
        printer.indent {
            print("fakeRoot = "); fakeRoot.print(printer); println()
            print("configuration = "); configuration.print(printer); println()
            print("progress = "); _progress.print(printer); println()
            print("emptyText = "); _emptyText.print(printer); println()
            print("sortKeys = "); _sortKeys.print(printer); println()
            print("viewToModelMap = "); _viewToModelMap.print(printer); println()
            print("mouseClicked = "); _mouseClicked.print(printer); println()
            print("enter = "); _enter.print(printer); println()
            print("validationResult = "); _validationResult.print(printer); println()
            print("validationStyle = "); _validationStyle.print(printer); println()
            print("handledByParent = "); _handledByParent.print(printer); println()
            print("revalidate = "); _revalidate.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeTreeGrid   {
        return BeTreeGrid(
            fakeRoot.deepClonePolymorphic(),
            configuration.deepClonePolymorphic(),
            _progress.deepClonePolymorphic(),
            _emptyText.deepClonePolymorphic(),
            _sortKeys.deepClonePolymorphic(),
            _viewToModelMap.deepClonePolymorphic(),
            _mouseClicked.deepClonePolymorphic(),
            _enter.deepClonePolymorphic(),
            _validationResult.deepClonePolymorphic(),
            _validationStyle.deepClonePolymorphic(),
            _handledByParent.deepClonePolymorphic(),
            _revalidate.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeTreeGridLine private constructor(
    private val _isSelected: RdProperty<Boolean>,
    val columnElements: List<BeControl>,
    private val _isExpanded: RdProperty<Boolean>,
    private val _children: RdList<BeControl>,
    private val _signal: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControl (
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeTreeGridLine> {
        override val _type: KClass<BeTreeGridLine> = BeTreeGridLine::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeTreeGridLine  {
            val _id = RdId.read(buffer)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val _isSelected = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val columnElements = buffer.readList { ctx.serializers.readPolymorphic<BeControl>(ctx, buffer, BeControl) }
            val _isExpanded = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _children = RdList.read(ctx, buffer, AbstractPolymorphic(BeControl))
            val _signal = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return BeTreeGridLine(_isSelected, columnElements, _isExpanded, _children, _signal, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeTreeGridLine)  {
            value.rdid.write(buffer)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            RdProperty.write(ctx, buffer, value._isSelected)
            buffer.writeList(value.columnElements) { v -> ctx.serializers.writePolymorphic(ctx, buffer, v) }
            RdProperty.write(ctx, buffer, value._isExpanded)
            RdList.write(ctx, buffer, value._children)
            RdSignal.write(ctx, buffer, value._signal)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val isSelected: IProperty<Boolean> get() = _isSelected
    val isExpanded: IProperty<Boolean> get() = _isExpanded
    val children: IMutableViewableList<BeControl> get() = _children
    val signal: ISignal<Unit> get() = _signal
    //methods
    //initializer
    init {
        _isSelected.optimizeNested = true
        _isExpanded.optimizeNested = true
    }
    
    init {
        bindableChildren.add("isSelected" to _isSelected)
        bindableChildren.add("columnElements" to columnElements)
        bindableChildren.add("isExpanded" to _isExpanded)
        bindableChildren.add("children" to _children)
        bindableChildren.add("signal" to _signal)
    }
    
    //secondary constructor
    constructor(
        columnElements: List<BeControl>
    ) : this(
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        columnElements,
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdList<BeControl>(AbstractPolymorphic(BeControl)),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeTreeGridLine (")
        printer.indent {
            print("isSelected = "); _isSelected.print(printer); println()
            print("columnElements = "); columnElements.print(printer); println()
            print("isExpanded = "); _isExpanded.print(printer); println()
            print("children = "); _children.print(printer); println()
            print("signal = "); _signal.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeTreeGridLine   {
        return BeTreeGridLine(
            _isSelected.deepClonePolymorphic(),
            columnElements.deepClonePolymorphic(),
            _isExpanded.deepClonePolymorphic(),
            _children.deepClonePolymorphic(),
            _signal.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class BeTreeSelection {
    Multi, 
    Single;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<BeTreeSelection>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
data class BeUnitSize (
    val unit: BeSizingType,
    val multiplier: Int = 1
) : IPrintable {
    //companion
    
    companion object : IMarshaller<BeUnitSize> {
        override val _type: KClass<BeUnitSize> = BeUnitSize::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeUnitSize  {
            val unit = buffer.readEnum<BeSizingType>()
            val multiplier = buffer.readInt()
            return BeUnitSize(unit, multiplier)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeUnitSize)  {
            buffer.writeEnum(value.unit)
            buffer.writeInt(value.multiplier)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as BeUnitSize
        
        if (unit != other.unit) return false
        if (multiplier != other.multiplier) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + unit.hashCode()
        __r = __r*31 + multiplier.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeUnitSize (")
        printer.indent {
            print("unit = "); unit.print(printer); println()
            print("multiplier = "); multiplier.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeUserAction private constructor(
    private val _click: RdSignal<Unit>
) : BeButtonAction (
) {
    //companion
    
    companion object : IMarshaller<BeUserAction> {
        override val _type: KClass<BeUserAction> = BeUserAction::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeUserAction  {
            val _id = RdId.read(buffer)
            val _click = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return BeUserAction(_click).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeUserAction)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._click)
        }
        
        
    }
    //fields
    val click: ISignal<Unit> get() = _click
    //methods
    //initializer
    init {
        bindableChildren.add("click" to _click)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdSignal<Unit>(FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeUserAction (")
        printer.indent {
            print("click = "); _click.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeUserAction   {
        return BeUserAction(
            _click.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeValidationLabel private constructor(
    val presentation: BeRichText,
    private val _text: RdProperty<String>,
    _validationResult: RdOptionalProperty<ValidationResult>,
    _validationStyle: RdOptionalProperty<ValidationStyle>,
    _handledByParent: RdProperty<Boolean>,
    _revalidate: RdSignal<Unit>,
    _enabled: RdProperty<Boolean>,
    _controlId: RdProperty<String>,
    _tooltip: RdProperty<String?>,
    _focus: RdSignal<Unit>,
    _visible: RdOptionalProperty<ControlVisibility>
) : BeControlWithValidationOnProperty (
    _validationResult,
    _validationStyle,
    _handledByParent,
    _revalidate,
    _enabled,
    _controlId,
    _tooltip,
    _focus,
    _visible
) {
    //companion
    
    companion object : IMarshaller<BeValidationLabel> {
        override val _type: KClass<BeValidationLabel> = BeValidationLabel::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeValidationLabel  {
            val _id = RdId.read(buffer)
            val _validationResult = RdOptionalProperty.read(ctx, buffer, ValidationResult)
            val _validationStyle = RdOptionalProperty.read(ctx, buffer, ValidationStyle.marshaller)
            val _handledByParent = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _revalidate = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _enabled = RdProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            val _controlId = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            val _tooltip = RdProperty.read(ctx, buffer, __StringNullableSerializer)
            val _focus = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            val _visible = RdOptionalProperty.read(ctx, buffer, ControlVisibility.marshaller)
            val presentation = BeRichText.read(ctx, buffer)
            val _text = RdProperty.read(ctx, buffer, FrameworkMarshallers.String)
            return BeValidationLabel(presentation, _text, _validationResult, _validationStyle, _handledByParent, _revalidate, _enabled, _controlId, _tooltip, _focus, _visible).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeValidationLabel)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._validationResult)
            RdOptionalProperty.write(ctx, buffer, value._validationStyle)
            RdProperty.write(ctx, buffer, value._handledByParent)
            RdSignal.write(ctx, buffer, value._revalidate)
            RdProperty.write(ctx, buffer, value._enabled)
            RdProperty.write(ctx, buffer, value._controlId)
            RdProperty.write(ctx, buffer, value._tooltip)
            RdSignal.write(ctx, buffer, value._focus)
            RdOptionalProperty.write(ctx, buffer, value._visible)
            BeRichText.write(ctx, buffer, value.presentation)
            RdProperty.write(ctx, buffer, value._text)
        }
        
        private val __StringNullableSerializer = FrameworkMarshallers.String.nullable()
        
    }
    //fields
    val text: IProperty<String> get() = _text
    //methods
    //initializer
    init {
        _text.optimizeNested = true
    }
    
    init {
        bindableChildren.add("presentation" to presentation)
        bindableChildren.add("text" to _text)
    }
    
    //secondary constructor
    constructor(
        presentation: BeRichText
    ) : this(
        presentation,
        RdProperty<String>("", FrameworkMarshallers.String),
        RdOptionalProperty<ValidationResult>(ValidationResult),
        RdOptionalProperty<ValidationStyle>(ValidationStyle.marshaller),
        RdProperty<Boolean>(false, FrameworkMarshallers.Bool),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdProperty<Boolean>(true, FrameworkMarshallers.Bool),
        RdProperty<String>("", FrameworkMarshallers.String),
        RdProperty<String?>(null, __StringNullableSerializer),
        RdSignal<Unit>(FrameworkMarshallers.Void),
        RdOptionalProperty<ControlVisibility>(ControlVisibility.marshaller)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeValidationLabel (")
        printer.indent {
            print("presentation = "); presentation.print(printer); println()
            print("text = "); _text.print(printer); println()
            print("validationResult = "); _validationResult.print(printer); println()
            print("validationStyle = "); _validationStyle.print(printer); println()
            print("handledByParent = "); _handledByParent.print(printer); println()
            print("revalidate = "); _revalidate.print(printer); println()
            print("enabled = "); _enabled.print(printer); println()
            print("controlId = "); _controlId.print(printer); println()
            print("tooltip = "); _tooltip.print(printer); println()
            print("focus = "); _focus.print(printer); println()
            print("visible = "); _visible.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeValidationLabel   {
        return BeValidationLabel(
            presentation.deepClonePolymorphic(),
            _text.deepClonePolymorphic(),
            _validationResult.deepClonePolymorphic(),
            _validationStyle.deepClonePolymorphic(),
            _handledByParent.deepClonePolymorphic(),
            _revalidate.deepClonePolymorphic(),
            _enabled.deepClonePolymorphic(),
            _controlId.deepClonePolymorphic(),
            _tooltip.deepClonePolymorphic(),
            _focus.deepClonePolymorphic(),
            _visible.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class BeWindowCenterPopupContext (
) : BePopupContext (
) {
    //companion
    
    companion object : IMarshaller<BeWindowCenterPopupContext> {
        override val _type: KClass<BeWindowCenterPopupContext> = BeWindowCenterPopupContext::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): BeWindowCenterPopupContext  {
            val _id = RdId.read(buffer)
            return BeWindowCenterPopupContext().withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: BeWindowCenterPopupContext)  {
            value.rdid.write(buffer)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("BeWindowCenterPopupContext (")
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): BeWindowCenterPopupContext   {
        return BeWindowCenterPopupContext(
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class CancelableProgress private constructor(
    private val _cancel: RdSignal<Unit>
) : AbstractProgress (
) {
    //companion
    
    companion object : IMarshaller<CancelableProgress> {
        override val _type: KClass<CancelableProgress> = CancelableProgress::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): CancelableProgress  {
            val _id = RdId.read(buffer)
            val _cancel = RdSignal.read(ctx, buffer, FrameworkMarshallers.Void)
            return CancelableProgress(_cancel).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: CancelableProgress)  {
            value.rdid.write(buffer)
            RdSignal.write(ctx, buffer, value._cancel)
        }
        
        
    }
    //fields
    val cancel: IAsyncSignal<Unit> get() = _cancel
    //methods
    //initializer
    init {
        _cancel.async = true
    }
    
    init {
        bindableChildren.add("cancel" to _cancel)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdSignal<Unit>(FrameworkMarshallers.Void)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("CancelableProgress (")
        printer.indent {
            print("cancel = "); _cancel.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): CancelableProgress   {
        return CancelableProgress(
            _cancel.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class ChildOffsetSize {
    DEFAULT, 
    SMALL, 
    NONE;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ChildOffsetSize>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class ControlVisibility {
    Visible, 
    Collapsed, 
    Hidden;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ControlVisibility>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
open class DefiniteProgress protected constructor(
    val taskName: BeAbstractText?,
    protected val _fraction: RdOptionalProperty<Double>,
    val stepName: BeAbstractText?
) : AbstractProgress (
) {
    //companion
    
    companion object : IMarshaller<DefiniteProgress>, IAbstractDeclaration<DefiniteProgress> {
        override val _type: KClass<DefiniteProgress> = DefiniteProgress::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DefiniteProgress  {
            val _id = RdId.read(buffer)
            val taskName = buffer.readNullable { ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText) }
            val _fraction = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Double)
            val stepName = buffer.readNullable { ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText) }
            return DefiniteProgress(taskName, _fraction, stepName).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DefiniteProgress)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.taskName) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdOptionalProperty.write(ctx, buffer, value._fraction)
            buffer.writeNullable(value.stepName) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
        }
        
        
        override fun readUnknownInstance(ctx: SerializationCtx, buffer: AbstractBuffer, unknownId: RdId, size: Int): DefiniteProgress  {
            val objectStartPosition = buffer.position
            val _id = RdId.read(buffer)
            val taskName = buffer.readNullable { ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText) }
            val _fraction = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Double)
            val stepName = buffer.readNullable { ctx.serializers.readPolymorphic<BeAbstractText>(ctx, buffer, BeAbstractText) }
            val unknownBytes = ByteArray(objectStartPosition + size - buffer.position)
            buffer.readByteArrayRaw(unknownBytes)
            return DefiniteProgress_Unknown(taskName, _fraction, stepName, unknownId, unknownBytes).withId(_id)
        }
        
    }
    //fields
    val fraction: IOptProperty<Double> get() = _fraction
    //methods
    //initializer
    init {
        _fraction.optimizeNested = true
    }
    
    init {
        _fraction.async = true
    }
    
    init {
        bindableChildren.add("taskName" to taskName)
        bindableChildren.add("fraction" to _fraction)
        bindableChildren.add("stepName" to stepName)
    }
    
    //secondary constructor
    constructor(
        taskName: BeAbstractText?,
        stepName: BeAbstractText?
    ) : this(
        taskName,
        RdOptionalProperty<Double>(FrameworkMarshallers.Double),
        stepName
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DefiniteProgress (")
        printer.indent {
            print("taskName = "); taskName.print(printer); println()
            print("fraction = "); _fraction.print(printer); println()
            print("stepName = "); stepName.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DefiniteProgress   {
        return DefiniteProgress(
            taskName.deepClonePolymorphic(),
            _fraction.deepClonePolymorphic(),
            stepName.deepClonePolymorphic()
        )
    }
    //contexts
}


class DefiniteProgress_Unknown (
    taskName: BeAbstractText?,
    _fraction: RdOptionalProperty<Double>,
    stepName: BeAbstractText?,
    override val unknownId: RdId,
    val unknownBytes: ByteArray
) : DefiniteProgress (
    taskName,
    _fraction,
    stepName
), IUnknownInstance {
    //companion
    
    companion object : IMarshaller<DefiniteProgress_Unknown> {
        override val _type: KClass<DefiniteProgress_Unknown> = DefiniteProgress_Unknown::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): DefiniteProgress_Unknown  {
            throw NotImplementedError("Unknown instances should not be read via serializer")
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: DefiniteProgress_Unknown)  {
            value.rdid.write(buffer)
            buffer.writeNullable(value.taskName) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            RdOptionalProperty.write(ctx, buffer, value._fraction)
            buffer.writeNullable(value.stepName) { ctx.serializers.writePolymorphic(ctx, buffer, it) }
            buffer.writeByteArrayRaw(value.unknownBytes)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    constructor(
        taskName: BeAbstractText?,
        stepName: BeAbstractText?,
        unknownId: RdId,
        unknownBytes: ByteArray
    ) : this(
        taskName,
        RdOptionalProperty<Double>(FrameworkMarshallers.Double),
        stepName,
        unknownId,
        unknownBytes
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("DefiniteProgress_Unknown (")
        printer.indent {
            print("taskName = "); taskName.print(printer); println()
            print("fraction = "); _fraction.print(printer); println()
            print("stepName = "); stepName.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): DefiniteProgress_Unknown   {
        return DefiniteProgress_Unknown(
            taskName.deepClonePolymorphic(),
            _fraction.deepClonePolymorphic(),
            stepName.deepClonePolymorphic(),
            unknownId,
            unknownBytes
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class DialogLayoutPersistenceMode {
    NONE, 
    POSITION, 
    SIZE, 
    SIZE_AND_POSITION;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<DialogLayoutPersistenceMode>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class DialogModality {
    MODAL, 
    NON_MODAL;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<DialogModality>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class DialogResult {
    OK, 
    CANCEL, 
    CLOSE, 
    NONE;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<DialogResult>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class DialogStyle {
    SIMPLE, 
    MESSAGE_BOX, 
    THEMED;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<DialogStyle>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class GridOrientation {
    Horizontal, 
    Vertical;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<GridOrientation>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class HeaderStyle {
    SEPARATOR, 
    BOLD;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<HeaderStyle>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class IndefiniteProgress private constructor(
    private val _inProgress: RdOptionalProperty<Boolean>
) : AbstractProgress (
) {
    //companion
    
    companion object : IMarshaller<IndefiniteProgress> {
        override val _type: KClass<IndefiniteProgress> = IndefiniteProgress::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): IndefiniteProgress  {
            val _id = RdId.read(buffer)
            val _inProgress = RdOptionalProperty.read(ctx, buffer, FrameworkMarshallers.Bool)
            return IndefiniteProgress(_inProgress).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: IndefiniteProgress)  {
            value.rdid.write(buffer)
            RdOptionalProperty.write(ctx, buffer, value._inProgress)
        }
        
        
    }
    //fields
    val inProgress: IOptProperty<Boolean> get() = _inProgress
    //methods
    //initializer
    init {
        _inProgress.optimizeNested = true
    }
    
    init {
        bindableChildren.add("inProgress" to _inProgress)
    }
    
    //secondary constructor
    constructor(
    ) : this(
        RdOptionalProperty<Boolean>(FrameworkMarshallers.Bool)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("IndefiniteProgress (")
        printer.indent {
            print("inProgress = "); _inProgress.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): IndefiniteProgress   {
        return IndefiniteProgress(
            _inProgress.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class OrderBy {
    ASC, 
    DESC, 
    UNSORTED;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<OrderBy>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class Place {
    Default, 
    ToolbarLeft;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<Place>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class PredefinedType {
    DEFAULT, 
    PROCESS_ICON;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<PredefinedType>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
data class SortKey (
    val columnIndex: Int,
    val orderBy: OrderBy
) : IPrintable {
    //companion
    
    companion object : IMarshaller<SortKey> {
        override val _type: KClass<SortKey> = SortKey::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): SortKey  {
            val columnIndex = buffer.readInt()
            val orderBy = buffer.readEnum<OrderBy>()
            return SortKey(columnIndex, orderBy)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: SortKey)  {
            buffer.writeInt(value.columnIndex)
            buffer.writeEnum(value.orderBy)
        }
        
        
    }
    //fields
    //methods
    //initializer
    //secondary constructor
    //equals trait
    override fun equals(other: Any?): Boolean  {
        if (this === other) return true
        if (other == null || other::class != this::class) return false
        
        other as SortKey
        
        if (columnIndex != other.columnIndex) return false
        if (orderBy != other.orderBy) return false
        
        return true
    }
    //hash code trait
    override fun hashCode(): Int  {
        var __r = 0
        __r = __r*31 + columnIndex.hashCode()
        __r = __r*31 + orderBy.hashCode()
        return __r
    }
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("SortKey (")
        printer.indent {
            print("columnIndex = "); columnIndex.print(printer); println()
            print("orderBy = "); orderBy.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
class TaskProgress (
    val taskModel: com.jetbrains.ide.model.notifications.BackgroundTaskModel
) : AbstractProgress (
) {
    //companion
    
    companion object : IMarshaller<TaskProgress> {
        override val _type: KClass<TaskProgress> = TaskProgress::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): TaskProgress  {
            val _id = RdId.read(buffer)
            val taskModel = com.jetbrains.ide.model.notifications.BackgroundTaskModel.read(ctx, buffer)
            return TaskProgress(taskModel).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: TaskProgress)  {
            value.rdid.write(buffer)
            com.jetbrains.ide.model.notifications.BackgroundTaskModel.write(ctx, buffer, value.taskModel)
        }
        
        
    }
    //fields
    //methods
    //initializer
    init {
        bindableChildren.add("taskModel" to taskModel)
    }
    
    //secondary constructor
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("TaskProgress (")
        printer.indent {
            print("taskModel = "); taskModel.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): TaskProgress   {
        return TaskProgress(
            taskModel.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class UpdateSourceTrigger {
    TextChanged, 
    LostFocus, 
    EnterOrTab;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<UpdateSourceTrigger>()
        
    }
}


/**
 * @property state Defines validation result state
 * @property resultMessage Error text, empty when passed
 * #### Generated from [UIAutomationModel.kt]
 */
class ValidationResult private constructor(
    val state: ValidationStates = ValidationStates.validationPassed,
    val resultMessage: String = "",
    private val _icon: RdProperty<com.jetbrains.rd.ide.model.IconModel?>
) : RdBindableBase() {
    //companion
    
    companion object : IMarshaller<ValidationResult> {
        override val _type: KClass<ValidationResult> = ValidationResult::class
        
        @Suppress("UNCHECKED_CAST")
        override fun read(ctx: SerializationCtx, buffer: AbstractBuffer): ValidationResult  {
            val _id = RdId.read(buffer)
            val state = buffer.readEnum<ValidationStates>()
            val resultMessage = buffer.readString()
            val _icon = RdProperty.read(ctx, buffer, __IconModelNullableSerializer)
            return ValidationResult(state, resultMessage, _icon).withId(_id)
        }
        
        override fun write(ctx: SerializationCtx, buffer: AbstractBuffer, value: ValidationResult)  {
            value.rdid.write(buffer)
            buffer.writeEnum(value.state)
            buffer.writeString(value.resultMessage)
            RdProperty.write(ctx, buffer, value._icon)
        }
        
        private val __IconModelNullableSerializer = AbstractPolymorphic(com.jetbrains.rd.ide.model.IconModel).nullable()
        
    }
    //fields
    
    /**
     * Icon (currently is shown only in WPF control
     */
    val icon: IProperty<com.jetbrains.rd.ide.model.IconModel?> get() = _icon
    //methods
    //initializer
    init {
        _icon.optimizeNested = true
    }
    
    init {
        bindableChildren.add("icon" to _icon)
    }
    
    //secondary constructor
    constructor(
        state: ValidationStates = ValidationStates.validationPassed,
        resultMessage: String = ""
    ) : this(
        state,
        resultMessage,
        RdProperty<com.jetbrains.rd.ide.model.IconModel?>(null, __IconModelNullableSerializer)
    )
    
    //equals trait
    //hash code trait
    //pretty print
    override fun print(printer: PrettyPrinter)  {
        printer.println("ValidationResult (")
        printer.indent {
            print("state = "); state.print(printer); println()
            print("resultMessage = "); resultMessage.print(printer); println()
            print("icon = "); _icon.print(printer); println()
        }
        printer.print(")")
    }
    //deepClone
    override fun deepClone(): ValidationResult   {
        return ValidationResult(
            state,
            resultMessage,
            _icon.deepClonePolymorphic()
        )
    }
    //contexts
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class ValidationStates {
    validationPassed, 
    validationWarning, 
    validationError;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ValidationStates>()
        
    }
}


/**
 * #### Generated from [UIAutomationModel.kt]
 */
enum class ValidationStyle {
    Text, 
    Border, 
    InnerBorder;
    
    companion object {
        val marshaller = FrameworkMarshallers.enum<ValidationStyle>()
        
    }
}
